/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the PPC target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 41;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(PPCInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(PPCInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static PPCInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static PPCInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s64,
  GILLT_v4s32,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_v256s1,
  GILLT_v512s1,
  GILLT_v1024s1,
};
const static size_t NumTypeObjects = 11;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(256), 1),
  LLT::vector(ElementCount::getFixed(512), 1),
  LLT::vector(ElementCount::getFixed(1024), 1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_In32BitModeBit = 1,
  Feature_In64BitModeBit = 9,
  Feature_HasOnlyMSYNCBit = 23,
  Feature_HasSYNCBit = 22,
  Feature_HasSPEBit = 8,
  Feature_HasICBTBit = 21,
  Feature_HasBPERMDBit = 10,
  Feature_HasExtDivBit = 3,
  Feature_IsISA2_06Bit = 11,
  Feature_IsISA2_07Bit = 40,
  Feature_IsISA3_0Bit = 2,
  Feature_HasFPUBit = 0,
  Feature_PCRelativeMemopsBit = 37,
  Feature_IsNotISA3_1Bit = 39,
  Feature_IsAIXBit = 24,
  Feature_NotAIXBit = 25,
  Feature_IsISAFutureBit = 18,
  Feature_IsNotISAFutureBit = 19,
  Feature_HasAltivecBit = 4,
  Feature_HasP8AltivecBit = 5,
  Feature_HasP8CryptoBit = 6,
  Feature_HasP9AltivecBit = 7,
  Feature_HasVSXBit = 12,
  Feature_IsLittleEndianBit = 26,
  Feature_IsBigEndianBit = 27,
  Feature_IsPPC64Bit = 31,
  Feature_HasOnlySwappingMemOpsBit = 29,
  Feature_NoP8VectorBit = 30,
  Feature_HasP8VectorBit = 13,
  Feature_HasDirectMoveBit = 14,
  Feature_NoP9VectorBit = 28,
  Feature_HasP9VectorBit = 15,
  Feature_NoP9AltivecBit = 32,
  Feature_NoP10VectorBit = 33,
  Feature_HasP10VectorBit = 36,
  Feature_HasHTMBit = 34,
  Feature_MMABit = 20,
  Feature_IsPPC32Bit = 38,
  Feature_PrefixInstrsBit = 16,
  Feature_IsISA3_1Bit = 17,
  Feature_PairedVectorMemopsBit = 35,
};

PredicateBitset PPCInstructionSelector::
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!Subtarget->isPPC64())
    Features.set(Feature_In32BitModeBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasOnlyMSYNCBit);
  if (!Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasSYNCBit);
  if (Subtarget->hasSPE())
    Features.set(Feature_HasSPEBit);
  if (Subtarget->hasICBT())
    Features.set(Feature_HasICBTBit);
  if (Subtarget->hasBPERMD())
    Features.set(Feature_HasBPERMDBit);
  if (Subtarget->hasExtDiv())
    Features.set(Feature_HasExtDivBit);
  if (Subtarget->isISA2_06())
    Features.set(Feature_IsISA2_06Bit);
  if (Subtarget->isISA2_07())
    Features.set(Feature_IsISA2_07Bit);
  if (Subtarget->isISA3_0())
    Features.set(Feature_IsISA3_0Bit);
  if (Subtarget->hasFPU())
    Features.set(Feature_HasFPUBit);
  if (Subtarget->hasPCRelativeMemops())
    Features.set(Feature_PCRelativeMemopsBit);
  if (!Subtarget->isISA3_1())
    Features.set(Feature_IsNotISA3_1Bit);
  if (Subtarget->isAIXABI())
    Features.set(Feature_IsAIXBit);
  if (!Subtarget->isAIXABI())
    Features.set(Feature_NotAIXBit);
  if (Subtarget->isISAFuture())
    Features.set(Feature_IsISAFutureBit);
  if (!Subtarget->isISAFuture())
    Features.set(Feature_IsNotISAFutureBit);
  if (Subtarget->hasAltivec())
    Features.set(Feature_HasAltivecBit);
  if (Subtarget->hasP8Altivec())
    Features.set(Feature_HasP8AltivecBit);
  if (Subtarget->hasP8Crypto())
    Features.set(Feature_HasP8CryptoBit);
  if (Subtarget->hasP9Altivec())
    Features.set(Feature_HasP9AltivecBit);
  if (Subtarget->hasVSX())
    Features.set(Feature_HasVSXBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLittleEndianBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBigEndianBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_IsPPC64Bit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_HasOnlySwappingMemOpsBit);
  if (!Subtarget->hasP8Vector())
    Features.set(Feature_NoP8VectorBit);
  if (Subtarget->hasP8Vector())
    Features.set(Feature_HasP8VectorBit);
  if (Subtarget->hasDirectMove())
    Features.set(Feature_HasDirectMoveBit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_NoP9VectorBit);
  if (Subtarget->hasP9Vector())
    Features.set(Feature_HasP9VectorBit);
  if (!Subtarget->hasP9Altivec())
    Features.set(Feature_NoP9AltivecBit);
  if (!Subtarget->hasP10Vector())
    Features.set(Feature_NoP10VectorBit);
  if (Subtarget->hasP10Vector())
    Features.set(Feature_HasP10VectorBit);
  if (Subtarget->hasHTM())
    Features.set(Feature_HasHTMBit);
  if (Subtarget->hasMMA())
    Features.set(Feature_MMABit);
  if (!Subtarget->isPPC64())
    Features.set(Feature_IsPPC32Bit);
  if (Subtarget->hasPrefixInstrs())
    Features.set(Feature_PrefixInstrsBit);
  if (Subtarget->isISA3_1())
    Features.set(Feature_IsISA3_1Bit);
  if (Subtarget->pairedVectorMemops())
    Features.set(Feature_PairedVectorMemopsBit);
  return Features;
}

void PPCInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const PPCSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset PPCInstructionSelector::
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAltivec,
  GIFBS_HasBPERMD,
  GIFBS_HasExtDiv,
  GIFBS_HasFPU,
  GIFBS_HasHTM,
  GIFBS_HasOnlyMSYNC,
  GIFBS_HasP8Altivec,
  GIFBS_HasP8Crypto,
  GIFBS_HasP9Altivec,
  GIFBS_HasSPE,
  GIFBS_HasSYNC,
  GIFBS_HasVSX,
  GIFBS_In32BitMode,
  GIFBS_In64BitMode,
  GIFBS_IsAIX,
  GIFBS_IsISA3_0,
  GIFBS_IsISA3_1,
  GIFBS_IsISAFuture,
  GIFBS_IsNotISA3_1,
  GIFBS_NotAIX,
  GIFBS_PairedVectorMemops,
  GIFBS_HasDirectMove_HasVSX,
  GIFBS_HasFPU_IsISA3_1,
  GIFBS_HasP10Vector_PrefixInstrs,
  GIFBS_HasP8Altivec_HasVSX,
  GIFBS_HasP8Vector_HasVSX,
  GIFBS_HasP9Vector_HasVSX,
  GIFBS_HasVSX_IsISA3_1,
  GIFBS_In64BitMode_IsISA3_0,
  GIFBS_IsISAFuture_MMA,
  GIFBS_IsNotISAFuture_MMA,
  GIFBS_HasP8Altivec_HasVSX_IsBigEndian,
  GIFBS_HasP8Altivec_HasVSX_IsLittleEndian,
  GIFBS_IsISAFuture_MMA_PrefixInstrs,
  GIFBS_IsNotISAFuture_MMA_PrefixInstrs,
  GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian,
  GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector,
  GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAltivecBit, },
  {Feature_HasBPERMDBit, },
  {Feature_HasExtDivBit, },
  {Feature_HasFPUBit, },
  {Feature_HasHTMBit, },
  {Feature_HasOnlyMSYNCBit, },
  {Feature_HasP8AltivecBit, },
  {Feature_HasP8CryptoBit, },
  {Feature_HasP9AltivecBit, },
  {Feature_HasSPEBit, },
  {Feature_HasSYNCBit, },
  {Feature_HasVSXBit, },
  {Feature_In32BitModeBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsAIXBit, },
  {Feature_IsISA3_0Bit, },
  {Feature_IsISA3_1Bit, },
  {Feature_IsISAFutureBit, },
  {Feature_IsNotISA3_1Bit, },
  {Feature_NotAIXBit, },
  {Feature_PairedVectorMemopsBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, },
  {Feature_HasFPUBit, Feature_IsISA3_1Bit, },
  {Feature_HasP10VectorBit, Feature_PrefixInstrsBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, },
  {Feature_HasP8VectorBit, Feature_HasVSXBit, },
  {Feature_HasP9VectorBit, Feature_HasVSXBit, },
  {Feature_HasVSXBit, Feature_IsISA3_1Bit, },
  {Feature_In64BitModeBit, Feature_IsISA3_0Bit, },
  {Feature_IsISAFutureBit, Feature_MMABit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsBigEndianBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, },
  {Feature_IsISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsISA3_0Bit, Feature_IsLittleEndianBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, Feature_NoP9VectorBit, },
  {Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_1Bit, Feature_IsPPC32Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_0Bit, Feature_IsPPC64Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsPPC64Bit, Feature_NoP9VectorBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

PPCInstructionSelector::ComplexMatcherMemFn
PPCInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool PPCInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_Msk2Imm = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_Msk4Imm,
  GICXXPred_I64_Predicate_Msk8Imm,
  GICXXPred_I64_Predicate_i32immNonAllOneNonZero,
  GICXXPred_I64_Predicate_imm32SExt16,
  GICXXPred_I64_Predicate_imm64SExt16,
  GICXXPred_I64_Predicate_imm64ZExt32,
  GICXXPred_I64_Predicate_immNonAllOneAnyExt8,
  GICXXPred_I64_Predicate_immSExt5NonZero,
};
bool PPCInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_Msk2Imm: {
     return isUInt<2>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk4Imm: {
     return isUInt<4>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk8Imm: {
     return isUInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immNonAllOneNonZero: {
     return Imm && (Imm != -1); 
  }
  case GICXXPred_I64_Predicate_imm32SExt16: {
    
      // imm32SExt16 predicate - True if the i32 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int32_t)Imm == (short)Imm;
    
    llvm_unreachable("imm32SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64SExt16: {
    
      // imm64SExt16 predicate - True if the i64 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int64_t)Imm == (short)Imm;
    
    llvm_unreachable("imm64SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64ZExt32: {
    
      // imm64ZExt32 predicate - True if the i64 immediate fits in a 32-bit
      // zero extended field.
      return isUInt<32>(Imm);
    
    llvm_unreachable("imm64ZExt32 should have returned");
  }
  case GICXXPred_I64_Predicate_immNonAllOneAnyExt8: {
    
      return (isInt<8>(Imm) && (Imm != -1)) || (isUInt<8>(Imm) && (Imm != 0xFF));
    
  }
  case GICXXPred_I64_Predicate_immSExt5NonZero: {
     return Imm && isInt<5>(Imm); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool PPCInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("PPCInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
PPCInstructionSelector::CustomRendererFn
PPCInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool PPCInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool PPCInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("PPCInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *PPCInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(287), /*)*//*default:*//*Label 83*/ GIMT_Encode4(211157),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(946),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(1355),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(1796),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(2078),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(2234),
     /*     30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(2390),
     /*     34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(2552), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(2714),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(5275),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(48417), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 10*/ GIMT_Encode4(57524), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 11*/ GIMT_Encode4(58491), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 12*/ GIMT_Encode4(60768),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 13*/ GIMT_Encode4(61043),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 14*/ GIMT_Encode4(61293),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 15*/ GIMT_Encode4(61424), GIMT_Encode4(0),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 16*/ GIMT_Encode4(61555), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 17*/ GIMT_Encode4(61575), GIMT_Encode4(0),
     /*    302 */ /*TargetOpcode::G_BRCOND*//*Label 18*/ GIMT_Encode4(61700), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 19*/ GIMT_Encode4(61763),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 20*/ GIMT_Encode4(90883), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 21*/ GIMT_Encode4(93775),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 22*/ GIMT_Encode4(114531),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 23*/ GIMT_Encode4(114717), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 24*/ GIMT_Encode4(114869),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 25*/ GIMT_Encode4(129901),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 26*/ GIMT_Encode4(130254),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 27*/ GIMT_Encode4(151724),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 28*/ GIMT_Encode4(152080),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 29*/ GIMT_Encode4(152502), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    390 */ /*TargetOpcode::G_ROTL*//*Label 30*/ GIMT_Encode4(152872),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 31*/ GIMT_Encode4(153180),
     /*    398 */ /*TargetOpcode::G_FCMP*//*Label 32*/ GIMT_Encode4(157182), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 33*/ GIMT_Encode4(160633), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 34*/ GIMT_Encode4(161757),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 35*/ GIMT_Encode4(161887),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 36*/ GIMT_Encode4(162017),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 37*/ GIMT_Encode4(162119),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 38*/ GIMT_Encode4(162221),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 39*/ GIMT_Encode4(162323), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 40*/ GIMT_Encode4(162425),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 41*/ GIMT_Encode4(162720),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 42*/ GIMT_Encode4(163015),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 43*/ GIMT_Encode4(163365), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 44*/ GIMT_Encode4(163946), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 45*/ GIMT_Encode4(164216),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 46*/ GIMT_Encode4(166687),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 47*/ GIMT_Encode4(166851),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 48*/ GIMT_Encode4(167008),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 49*/ GIMT_Encode4(167271),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 50*/ GIMT_Encode4(167534),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 51*/ GIMT_Encode4(167781), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 52*/ GIMT_Encode4(168028),
     /*    626 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 53*/ GIMT_Encode4(168320), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 54*/ GIMT_Encode4(168636),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 55*/ GIMT_Encode4(168716),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 56*/ GIMT_Encode4(168796),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 57*/ GIMT_Encode4(169378), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    694 */ /*TargetOpcode::G_SMIN*//*Label 58*/ GIMT_Encode4(169960),
     /*    698 */ /*TargetOpcode::G_SMAX*//*Label 59*/ GIMT_Encode4(170140),
     /*    702 */ /*TargetOpcode::G_UMIN*//*Label 60*/ GIMT_Encode4(170320),
     /*    706 */ /*TargetOpcode::G_UMAX*//*Label 61*/ GIMT_Encode4(170500), GIMT_Encode4(0),
     /*    714 */ /*TargetOpcode::G_LROUND*//*Label 62*/ GIMT_Encode4(170680),
     /*    718 */ /*TargetOpcode::G_LLROUND*//*Label 63*/ GIMT_Encode4(170982),
     /*    722 */ /*TargetOpcode::G_BR*//*Label 64*/ GIMT_Encode4(171147), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    742 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 65*/ GIMT_Encode4(171163), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTTZ*//*Label 66*/ GIMT_Encode4(171281), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTLZ*//*Label 67*/ GIMT_Encode4(171459), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTPOP*//*Label 68*/ GIMT_Encode4(171631),
     /*    786 */ /*TargetOpcode::G_BSWAP*//*Label 69*/ GIMT_Encode4(171803),
     /*    790 */ /*TargetOpcode::G_BITREVERSE*//*Label 70*/ GIMT_Encode4(172067),
     /*    794 */ /*TargetOpcode::G_FCEIL*//*Label 71*/ GIMT_Encode4(208073), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    842 */ /*TargetOpcode::G_FSQRT*//*Label 72*/ GIMT_Encode4(208348),
     /*    846 */ /*TargetOpcode::G_FFLOOR*//*Label 73*/ GIMT_Encode4(208565),
     /*    850 */ /*TargetOpcode::G_FRINT*//*Label 74*/ GIMT_Encode4(208840),
     /*    854 */ /*TargetOpcode::G_FNEARBYINT*//*Label 75*/ GIMT_Encode4(209052), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    882 */ /*TargetOpcode::G_STRICT_FADD*//*Label 76*/ GIMT_Encode4(209289),
     /*    886 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 77*/ GIMT_Encode4(209559),
     /*    890 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 78*/ GIMT_Encode4(209829),
     /*    894 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 79*/ GIMT_Encode4(210099), GIMT_Encode4(0),
     /*    902 */ /*TargetOpcode::G_STRICT_FMA*//*Label 80*/ GIMT_Encode4(210369),
     /*    906 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 81*/ GIMT_Encode4(210927), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    942 */ /*TargetOpcode::G_TRAP*//*Label 82*/ GIMT_Encode4(211144),
     /*    946 */ // Label 0: @946
     /*    946 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 92*/ GIMT_Encode4(1354),
     /*    957 */ /*GILLT_s1*//*Label 84*/ GIMT_Encode4(989),
     /*    961 */ /*GILLT_s32*//*Label 85*/ GIMT_Encode4(1012),
     /*    965 */ /*GILLT_s64*//*Label 86*/ GIMT_Encode4(1072),
     /*    969 */ /*GILLT_s128*//*Label 87*/ GIMT_Encode4(1132),
     /*    973 */ /*GILLT_v2s64*//*Label 88*/ GIMT_Encode4(1158),
     /*    977 */ /*GILLT_v4s32*//*Label 89*/ GIMT_Encode4(1184),
     /*    981 */ /*GILLT_v8s16*//*Label 90*/ GIMT_Encode4(1210),
     /*    985 */ /*GILLT_v16s8*//*Label 91*/ GIMT_Encode4(1328),
     /*    989 */ // Label 84: @989
     /*    989 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1011), // Rule ID 3661 //
     /*    994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*    997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1004 */   // (add:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1009 */   GIR_RootConstrainSelectedInstOperands,
     /*   1010 */   // GIR_Coverage, 3661,
     /*   1010 */   GIR_Done,
     /*   1011 */ // Label 93: @1011
     /*   1011 */ GIM_Reject,
     /*   1012 */ // Label 85: @1012
     /*   1012 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1071),
     /*   1017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1027 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1058), // Rule ID 107 //
     /*   1032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1044 */     // MIs[1] Operand 1
     /*   1044 */     // No operand predicates
     /*   1044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1046 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (ADDI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*   1049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1051 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1056 */     GIR_RootConstrainSelectedInstOperands,
     /*   1057 */     // GIR_Coverage, 107,
     /*   1057 */     GIR_EraseRootFromParent_Done,
     /*   1058 */   // Label 95: @1058
     /*   1058 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1070), // Rule ID 199 //
     /*   1063 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADD4:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD4),
     /*   1068 */     GIR_RootConstrainSelectedInstOperands,
     /*   1069 */     // GIR_Coverage, 199,
     /*   1069 */     GIR_Done,
     /*   1070 */   // Label 96: @1070
     /*   1070 */   GIM_Reject,
     /*   1071 */ // Label 94: @1071
     /*   1071 */ GIM_Reject,
     /*   1072 */ // Label 86: @1072
     /*   1072 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1131),
     /*   1077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1087 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1118), // Rule ID 659 //
     /*   1092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1104 */     // MIs[1] Operand 1
     /*   1104 */     // No operand predicates
     /*   1104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1106 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (ADDI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*   1109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1111 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1116 */     GIR_RootConstrainSelectedInstOperands,
     /*   1117 */     // GIR_Coverage, 659,
     /*   1117 */     GIR_EraseRootFromParent_Done,
     /*   1118 */   // Label 98: @1118
     /*   1118 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1130), // Rule ID 655 //
     /*   1123 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADD8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD8),
     /*   1128 */     GIR_RootConstrainSelectedInstOperands,
     /*   1129 */     // GIR_Coverage, 655,
     /*   1129 */     GIR_Done,
     /*   1130 */   // Label 99: @1130
     /*   1130 */   GIM_Reject,
     /*   1131 */ // Label 97: @1131
     /*   1131 */ GIM_Reject,
     /*   1132 */ // Label 87: @1132
     /*   1132 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1157), // Rule ID 470 //
     /*   1137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1150 */   // (add:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUQM),
     /*   1155 */   GIR_RootConstrainSelectedInstOperands,
     /*   1156 */   // GIR_Coverage, 470,
     /*   1156 */   GIR_Done,
     /*   1157 */ // Label 100: @1157
     /*   1157 */ GIM_Reject,
     /*   1158 */ // Label 88: @1158
     /*   1158 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1183), // Rule ID 469 //
     /*   1163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1176 */   // (add:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VADDUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUDM),
     /*   1181 */   GIR_RootConstrainSelectedInstOperands,
     /*   1182 */   // GIR_Coverage, 469,
     /*   1182 */   GIR_Done,
     /*   1183 */ // Label 101: @1183
     /*   1183 */ GIM_Reject,
     /*   1184 */ // Label 89: @1184
     /*   1184 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1209), // Rule ID 303 //
     /*   1189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1202 */   // (add:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWM),
     /*   1207 */   GIR_RootConstrainSelectedInstOperands,
     /*   1208 */   // GIR_Coverage, 303,
     /*   1208 */   GIR_Done,
     /*   1209 */ // Label 102: @1209
     /*   1209 */ GIM_Reject,
     /*   1210 */ // Label 90: @1210
     /*   1210 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1327),
     /*   1215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1225 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1268), // Rule ID 1290 //
     /*   1230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1251 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB), v8i16:{ *:[v8i16] }:$vC)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1264 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   1266 */     GIR_RootConstrainSelectedInstOperands,
     /*   1267 */     // GIR_Coverage, 1290,
     /*   1267 */     GIR_EraseRootFromParent_Done,
     /*   1268 */   // Label 104: @1268
     /*   1268 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1311), // Rule ID 4936 //
     /*   1273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1294 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vC, (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB))  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1307 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   1309 */     GIR_RootConstrainSelectedInstOperands,
     /*   1310 */     // GIR_Coverage, 4936,
     /*   1310 */     GIR_EraseRootFromParent_Done,
     /*   1311 */   // Label 105: @1311
     /*   1311 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1326), // Rule ID 302 //
     /*   1316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1319 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHM),
     /*   1324 */     GIR_RootConstrainSelectedInstOperands,
     /*   1325 */     // GIR_Coverage, 302,
     /*   1325 */     GIR_Done,
     /*   1326 */   // Label 106: @1326
     /*   1326 */   GIM_Reject,
     /*   1327 */ // Label 103: @1327
     /*   1327 */ GIM_Reject,
     /*   1328 */ // Label 91: @1328
     /*   1328 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1353), // Rule ID 301 //
     /*   1333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1346 */   // (add:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBM),
     /*   1351 */   GIR_RootConstrainSelectedInstOperands,
     /*   1352 */   // GIR_Coverage, 301,
     /*   1352 */   GIR_Done,
     /*   1353 */ // Label 107: @1353
     /*   1353 */ GIM_Reject,
     /*   1354 */ // Label 92: @1354
     /*   1354 */ GIM_Reject,
     /*   1355 */ // Label 1: @1355
     /*   1355 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 116*/ GIMT_Encode4(1795),
     /*   1366 */ /*GILLT_s1*//*Label 108*/ GIMT_Encode4(1398),
     /*   1370 */ /*GILLT_s32*//*Label 109*/ GIMT_Encode4(1421),
     /*   1374 */ /*GILLT_s64*//*Label 110*/ GIMT_Encode4(1506),
     /*   1378 */ /*GILLT_s128*//*Label 111*/ GIMT_Encode4(1591),
     /*   1382 */ /*GILLT_v2s64*//*Label 112*/ GIMT_Encode4(1617),
     /*   1386 */ /*GILLT_v4s32*//*Label 113*/ GIMT_Encode4(1680),
     /*   1390 */ /*GILLT_v8s16*//*Label 114*/ GIMT_Encode4(1743),
     /*   1394 */ /*GILLT_v16s8*//*Label 115*/ GIMT_Encode4(1769),
     /*   1398 */ // Label 108: @1398
     /*   1398 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1420), // Rule ID 3662 //
     /*   1403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1413 */   // (sub:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1418 */   GIR_RootConstrainSelectedInstOperands,
     /*   1419 */   // GIR_Coverage, 3662,
     /*   1419 */   GIR_Done,
     /*   1420 */ // Label 117: @1420
     /*   1420 */ GIM_Reject,
     /*   1421 */ // Label 109: @1421
     /*   1421 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1505),
     /*   1426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1436 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1454), // Rule ID 211 //
     /*   1441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1445 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$RA)  =>  (NEG:{ *:[i32] } i32:{ *:[i32] }:$RA)
     /*   1445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*   1448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1450 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1452 */     GIR_RootConstrainSelectedInstOperands,
     /*   1453 */     // GIR_Coverage, 211,
     /*   1453 */     GIR_EraseRootFromParent_Done,
     /*   1454 */   // Label 119: @1454
     /*   1454 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1488), // Rule ID 1211 //
     /*   1459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1471 */     // MIs[1] Operand 1
     /*   1471 */     // No operand predicates
     /*   1471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1473 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, i32:{ *:[i32] }:$in)  =>  (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)
     /*   1473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*   1476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1478 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1486 */     GIR_RootConstrainSelectedInstOperands,
     /*   1487 */     // GIR_Coverage, 1211,
     /*   1487 */     GIR_EraseRootFromParent_Done,
     /*   1488 */   // Label 120: @1488
     /*   1488 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1504), // Rule ID 209 //
     /*   1493 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$RB, i32:{ *:[i32] }:$RA)  =>  (SUBF:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF),
     /*   1496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1498 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1500 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1502 */     GIR_RootConstrainSelectedInstOperands,
     /*   1503 */     // GIR_Coverage, 209,
     /*   1503 */     GIR_EraseRootFromParent_Done,
     /*   1504 */   // Label 121: @1504
     /*   1504 */   GIM_Reject,
     /*   1505 */ // Label 118: @1505
     /*   1505 */ GIM_Reject,
     /*   1506 */ // Label 110: @1506
     /*   1506 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1590),
     /*   1511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1521 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1539), // Rule ID 665 //
     /*   1526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1530 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, i64:{ *:[i64] }:$RA)  =>  (NEG8:{ *:[i64] } i64:{ *:[i64] }:$RA)
     /*   1530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*   1533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1535 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1537 */     GIR_RootConstrainSelectedInstOperands,
     /*   1538 */     // GIR_Coverage, 665,
     /*   1538 */     GIR_EraseRootFromParent_Done,
     /*   1539 */   // Label 123: @1539
     /*   1539 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1573), // Rule ID 1533 //
     /*   1544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1556 */     // MIs[1] Operand 1
     /*   1556 */     // No operand predicates
     /*   1556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1558 */     // (sub:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, i64:{ *:[i64] }:$in)  =>  (SUBFIC8:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$in, (imm:{ *:[i64] }):$imm)
     /*   1558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC8),
     /*   1561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1563 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1571 */     GIR_RootConstrainSelectedInstOperands,
     /*   1572 */     // GIR_Coverage, 1533,
     /*   1572 */     GIR_EraseRootFromParent_Done,
     /*   1573 */   // Label 124: @1573
     /*   1573 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1589), // Rule ID 664 //
     /*   1578 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$RB, i64:{ *:[i64] }:$RA)  =>  (SUBF8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF8),
     /*   1581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1583 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1585 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1587 */     GIR_RootConstrainSelectedInstOperands,
     /*   1588 */     // GIR_Coverage, 664,
     /*   1588 */     GIR_EraseRootFromParent_Done,
     /*   1589 */   // Label 125: @1589
     /*   1589 */   GIM_Reject,
     /*   1590 */ // Label 122: @1590
     /*   1590 */ GIM_Reject,
     /*   1591 */ // Label 111: @1591
     /*   1591 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1616), // Rule ID 475 //
     /*   1596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1609 */   // (sub:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUQM),
     /*   1614 */   GIR_RootConstrainSelectedInstOperands,
     /*   1615 */   // GIR_Coverage, 475,
     /*   1615 */   GIR_Done,
     /*   1616 */ // Label 126: @1616
     /*   1616 */ GIM_Reject,
     /*   1617 */ // Label 112: @1617
     /*   1617 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1679),
     /*   1622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1632 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1663), // Rule ID 542 //
     /*   1637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1650 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1654 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VNEGD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*   1654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGD),
     /*   1657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1659 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1661 */     GIR_RootConstrainSelectedInstOperands,
     /*   1662 */     // GIR_Coverage, 542,
     /*   1662 */     GIR_EraseRootFromParent_Done,
     /*   1663 */   // Label 128: @1663
     /*   1663 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1678), // Rule ID 474 //
     /*   1668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1671 */     // (sub:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VSUBUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUDM),
     /*   1676 */     GIR_RootConstrainSelectedInstOperands,
     /*   1677 */     // GIR_Coverage, 474,
     /*   1677 */     GIR_Done,
     /*   1678 */   // Label 129: @1678
     /*   1678 */   GIM_Reject,
     /*   1679 */ // Label 127: @1679
     /*   1679 */ GIM_Reject,
     /*   1680 */ // Label 113: @1680
     /*   1680 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1742),
     /*   1685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1695 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1726), // Rule ID 541 //
     /*   1700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1707 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1713 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1717 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VNEGW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*   1717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGW),
     /*   1720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1722 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1724 */     GIR_RootConstrainSelectedInstOperands,
     /*   1725 */     // GIR_Coverage, 541,
     /*   1725 */     GIR_EraseRootFromParent_Done,
     /*   1726 */   // Label 131: @1726
     /*   1726 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1741), // Rule ID 373 //
     /*   1731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1734 */     // (sub:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWM),
     /*   1739 */     GIR_RootConstrainSelectedInstOperands,
     /*   1740 */     // GIR_Coverage, 373,
     /*   1740 */     GIR_Done,
     /*   1741 */   // Label 132: @1741
     /*   1741 */   GIM_Reject,
     /*   1742 */ // Label 130: @1742
     /*   1742 */ GIM_Reject,
     /*   1743 */ // Label 114: @1743
     /*   1743 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1768), // Rule ID 372 //
     /*   1748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1761 */   // (sub:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHM),
     /*   1766 */   GIR_RootConstrainSelectedInstOperands,
     /*   1767 */   // GIR_Coverage, 372,
     /*   1767 */   GIR_Done,
     /*   1768 */ // Label 133: @1768
     /*   1768 */ GIM_Reject,
     /*   1769 */ // Label 115: @1769
     /*   1769 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1794), // Rule ID 371 //
     /*   1774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1787 */   // (sub:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBM),
     /*   1792 */   GIR_RootConstrainSelectedInstOperands,
     /*   1793 */   // GIR_Coverage, 371,
     /*   1793 */   GIR_Done,
     /*   1794 */ // Label 134: @1794
     /*   1794 */ GIM_Reject,
     /*   1795 */ // Label 116: @1795
     /*   1795 */ GIM_Reject,
     /*   1796 */ // Label 2: @1796
     /*   1796 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(7), /*)*//*default:*//*Label 141*/ GIMT_Encode4(2077),
     /*   1807 */ /*GILLT_s1*//*Label 135*/ GIMT_Encode4(1835),
     /*   1811 */ /*GILLT_s32*//*Label 136*/ GIMT_Encode4(1858),
     /*   1815 */ /*GILLT_s64*//*Label 137*/ GIMT_Encode4(1918), GIMT_Encode4(0),
     /*   1823 */ /*GILLT_v2s64*//*Label 138*/ GIMT_Encode4(1978),
     /*   1827 */ /*GILLT_v4s32*//*Label 139*/ GIMT_Encode4(2004),
     /*   1831 */ /*GILLT_v8s16*//*Label 140*/ GIMT_Encode4(2030),
     /*   1835 */ // Label 135: @1835
     /*   1835 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(1857), // Rule ID 3663 //
     /*   1840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1850 */   // (mul:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRAND:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   1855 */   GIR_RootConstrainSelectedInstOperands,
     /*   1856 */   // GIR_Coverage, 3663,
     /*   1856 */   GIR_Done,
     /*   1857 */ // Label 142: @1857
     /*   1857 */ GIM_Reject,
     /*   1858 */ // Label 136: @1858
     /*   1858 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(1917),
     /*   1863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1873 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(1904), // Rule ID 111 //
     /*   1878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1890 */     // MIs[1] Operand 1
     /*   1890 */     // No operand predicates
     /*   1890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1892 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (MULLI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI),
     /*   1895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1897 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1902 */     GIR_RootConstrainSelectedInstOperands,
     /*   1903 */     // GIR_Coverage, 111,
     /*   1903 */     GIR_EraseRootFromParent_Done,
     /*   1904 */   // Label 144: @1904
     /*   1904 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(1916), // Rule ID 208 //
     /*   1909 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULLW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLW),
     /*   1914 */     GIR_RootConstrainSelectedInstOperands,
     /*   1915 */     // GIR_Coverage, 208,
     /*   1915 */     GIR_Done,
     /*   1916 */   // Label 145: @1916
     /*   1916 */   GIM_Reject,
     /*   1917 */ // Label 143: @1917
     /*   1917 */ GIM_Reject,
     /*   1918 */ // Label 137: @1918
     /*   1918 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(1977),
     /*   1923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1933 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(1964), // Rule ID 702 //
     /*   1938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1950 */     // MIs[1] Operand 1
     /*   1950 */     // No operand predicates
     /*   1950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1952 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (MULLI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI8),
     /*   1955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1957 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1962 */     GIR_RootConstrainSelectedInstOperands,
     /*   1963 */     // GIR_Coverage, 702,
     /*   1963 */     GIR_EraseRootFromParent_Done,
     /*   1964 */   // Label 147: @1964
     /*   1964 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1976), // Rule ID 701 //
     /*   1969 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULLD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLD),
     /*   1974 */     GIR_RootConstrainSelectedInstOperands,
     /*   1975 */     // GIR_Coverage, 701,
     /*   1975 */     GIR_Done,
     /*   1976 */   // Label 148: @1976
     /*   1976 */   GIM_Reject,
     /*   1977 */ // Label 146: @1977
     /*   1977 */ GIM_Reject,
     /*   1978 */ // Label 138: @1978
     /*   1978 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2003), // Rule ID 1120 //
     /*   1983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   1986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1996 */   // (mul:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULLD),
     /*   2001 */   GIR_RootConstrainSelectedInstOperands,
     /*   2002 */   // GIR_Coverage, 1120,
     /*   2002 */   GIR_Done,
     /*   2003 */ // Label 149: @2003
     /*   2003 */ GIM_Reject,
     /*   2004 */ // Label 139: @2004
     /*   2004 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2029), // Rule ID 461 //
     /*   2009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   2012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2022 */   // (mul:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULUWM),
     /*   2027 */   GIR_RootConstrainSelectedInstOperands,
     /*   2028 */   // GIR_Coverage, 461,
     /*   2028 */   GIR_Done,
     /*   2029 */ // Label 150: @2029
     /*   2029 */ GIM_Reject,
     /*   2030 */ // Label 140: @2030
     /*   2030 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2076), // Rule ID 1289 //
     /*   2035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   2038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   2041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   2044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2048 */   // (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, (V_SET0H:{ *:[v8i16] }))
     /*   2048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*   2051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::V_SET0H),
     /*   2055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   2060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   2062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   2065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   2067 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   2069 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /*   2071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   2074 */   GIR_RootConstrainSelectedInstOperands,
     /*   2075 */   // GIR_Coverage, 1289,
     /*   2075 */   GIR_EraseRootFromParent_Done,
     /*   2076 */ // Label 151: @2076
     /*   2076 */ GIM_Reject,
     /*   2077 */ // Label 141: @2077
     /*   2077 */ GIM_Reject,
     /*   2078 */ // Label 3: @2078
     /*   2078 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 157*/ GIMT_Encode4(2233),
     /*   2089 */ /*GILLT_s32*//*Label 152*/ GIMT_Encode4(2109),
     /*   2093 */ /*GILLT_s64*//*Label 153*/ GIMT_Encode4(2132),
     /*   2097 */ /*GILLT_s128*//*Label 154*/ GIMT_Encode4(2155),
     /*   2101 */ /*GILLT_v2s64*//*Label 155*/ GIMT_Encode4(2181),
     /*   2105 */ /*GILLT_v4s32*//*Label 156*/ GIMT_Encode4(2207),
     /*   2109 */ // Label 152: @2109
     /*   2109 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2131), // Rule ID 202 //
     /*   2114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2124 */   // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVW),
     /*   2129 */   GIR_RootConstrainSelectedInstOperands,
     /*   2130 */   // GIR_Coverage, 202,
     /*   2130 */   GIR_Done,
     /*   2131 */ // Label 158: @2131
     /*   2131 */ GIM_Reject,
     /*   2132 */ // Label 153: @2132
     /*   2132 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2154), // Rule ID 693 //
     /*   2137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2147 */   // (sdiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVD),
     /*   2152 */   GIR_RootConstrainSelectedInstOperands,
     /*   2153 */   // GIR_Coverage, 693,
     /*   2153 */   GIR_Done,
     /*   2154 */ // Label 159: @2154
     /*   2154 */ GIM_Reject,
     /*   2155 */ // Label 154: @2155
     /*   2155 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2180), // Rule ID 1144 //
     /*   2160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2173 */   // (sdiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSQ),
     /*   2178 */   GIR_RootConstrainSelectedInstOperands,
     /*   2179 */   // GIR_Coverage, 1144,
     /*   2179 */   GIR_Done,
     /*   2180 */ // Label 160: @2180
     /*   2180 */ GIM_Reject,
     /*   2181 */ // Label 155: @2181
     /*   2181 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2206), // Rule ID 1131 //
     /*   2186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2199 */   // (sdiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSD),
     /*   2204 */   GIR_RootConstrainSelectedInstOperands,
     /*   2205 */   // GIR_Coverage, 1131,
     /*   2205 */   GIR_Done,
     /*   2206 */ // Label 161: @2206
     /*   2206 */ GIM_Reject,
     /*   2207 */ // Label 156: @2207
     /*   2207 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2232), // Rule ID 1129 //
     /*   2212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2225 */   // (sdiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSW),
     /*   2230 */   GIR_RootConstrainSelectedInstOperands,
     /*   2231 */   // GIR_Coverage, 1129,
     /*   2231 */   GIR_Done,
     /*   2232 */ // Label 162: @2232
     /*   2232 */ GIM_Reject,
     /*   2233 */ // Label 157: @2233
     /*   2233 */ GIM_Reject,
     /*   2234 */ // Label 4: @2234
     /*   2234 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 168*/ GIMT_Encode4(2389),
     /*   2245 */ /*GILLT_s32*//*Label 163*/ GIMT_Encode4(2265),
     /*   2249 */ /*GILLT_s64*//*Label 164*/ GIMT_Encode4(2288),
     /*   2253 */ /*GILLT_s128*//*Label 165*/ GIMT_Encode4(2311),
     /*   2257 */ /*GILLT_v2s64*//*Label 166*/ GIMT_Encode4(2337),
     /*   2261 */ /*GILLT_v4s32*//*Label 167*/ GIMT_Encode4(2363),
     /*   2265 */ // Label 163: @2265
     /*   2265 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2287), // Rule ID 203 //
     /*   2270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2280 */   // (udiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVWU),
     /*   2285 */   GIR_RootConstrainSelectedInstOperands,
     /*   2286 */   // GIR_Coverage, 203,
     /*   2286 */   GIR_Done,
     /*   2287 */ // Label 169: @2287
     /*   2287 */ GIM_Reject,
     /*   2288 */ // Label 164: @2288
     /*   2288 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2310), // Rule ID 694 //
     /*   2293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2303 */   // (udiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVDU),
     /*   2308 */   GIR_RootConstrainSelectedInstOperands,
     /*   2309 */   // GIR_Coverage, 694,
     /*   2309 */   GIR_Done,
     /*   2310 */ // Label 170: @2310
     /*   2310 */ GIM_Reject,
     /*   2311 */ // Label 165: @2311
     /*   2311 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2336), // Rule ID 1145 //
     /*   2316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2329 */   // (udiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUQ),
     /*   2334 */   GIR_RootConstrainSelectedInstOperands,
     /*   2335 */   // GIR_Coverage, 1145,
     /*   2335 */   GIR_Done,
     /*   2336 */ // Label 171: @2336
     /*   2336 */ GIM_Reject,
     /*   2337 */ // Label 166: @2337
     /*   2337 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2362), // Rule ID 1132 //
     /*   2342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2355 */   // (udiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUD),
     /*   2360 */   GIR_RootConstrainSelectedInstOperands,
     /*   2361 */   // GIR_Coverage, 1132,
     /*   2361 */   GIR_Done,
     /*   2362 */ // Label 172: @2362
     /*   2362 */ GIM_Reject,
     /*   2363 */ // Label 167: @2363
     /*   2363 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2388), // Rule ID 1130 //
     /*   2368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2381 */   // (udiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUW),
     /*   2386 */   GIR_RootConstrainSelectedInstOperands,
     /*   2387 */   // GIR_Coverage, 1130,
     /*   2387 */   GIR_Done,
     /*   2388 */ // Label 173: @2388
     /*   2388 */ GIM_Reject,
     /*   2389 */ // Label 168: @2389
     /*   2389 */ GIM_Reject,
     /*   2390 */ // Label 5: @2390
     /*   2390 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 179*/ GIMT_Encode4(2551),
     /*   2401 */ /*GILLT_s32*//*Label 174*/ GIMT_Encode4(2421),
     /*   2405 */ /*GILLT_s64*//*Label 175*/ GIMT_Encode4(2447),
     /*   2409 */ /*GILLT_s128*//*Label 176*/ GIMT_Encode4(2473),
     /*   2413 */ /*GILLT_v2s64*//*Label 177*/ GIMT_Encode4(2499),
     /*   2417 */ /*GILLT_v4s32*//*Label 178*/ GIMT_Encode4(2525),
     /*   2421 */ // Label 174: @2421
     /*   2421 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2446), // Rule ID 197 //
     /*   2426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2439 */   // (srem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODSW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSW),
     /*   2444 */   GIR_RootConstrainSelectedInstOperands,
     /*   2445 */   // GIR_Coverage, 197,
     /*   2445 */   GIR_Done,
     /*   2446 */ // Label 180: @2446
     /*   2446 */ GIM_Reject,
     /*   2447 */ // Label 175: @2447
     /*   2447 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2472), // Rule ID 698 //
     /*   2452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2465 */   // (srem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODSD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSD),
     /*   2470 */   GIR_RootConstrainSelectedInstOperands,
     /*   2471 */   // GIR_Coverage, 698,
     /*   2471 */   GIR_Done,
     /*   2472 */ // Label 181: @2472
     /*   2472 */ GIM_Reject,
     /*   2473 */ // Label 176: @2473
     /*   2473 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2498), // Rule ID 1154 //
     /*   2478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2491 */   // (srem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSQ),
     /*   2496 */   GIR_RootConstrainSelectedInstOperands,
     /*   2497 */   // GIR_Coverage, 1154,
     /*   2497 */   GIR_Done,
     /*   2498 */ // Label 182: @2498
     /*   2498 */ GIM_Reject,
     /*   2499 */ // Label 177: @2499
     /*   2499 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2524), // Rule ID 1127 //
     /*   2504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2517 */   // (srem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSD),
     /*   2522 */   GIR_RootConstrainSelectedInstOperands,
     /*   2523 */   // GIR_Coverage, 1127,
     /*   2523 */   GIR_Done,
     /*   2524 */ // Label 183: @2524
     /*   2524 */ GIM_Reject,
     /*   2525 */ // Label 178: @2525
     /*   2525 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2550), // Rule ID 1125 //
     /*   2530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2543 */   // (srem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSW),
     /*   2548 */   GIR_RootConstrainSelectedInstOperands,
     /*   2549 */   // GIR_Coverage, 1125,
     /*   2549 */   GIR_Done,
     /*   2550 */ // Label 184: @2550
     /*   2550 */ GIM_Reject,
     /*   2551 */ // Label 179: @2551
     /*   2551 */ GIM_Reject,
     /*   2552 */ // Label 6: @2552
     /*   2552 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 190*/ GIMT_Encode4(2713),
     /*   2563 */ /*GILLT_s32*//*Label 185*/ GIMT_Encode4(2583),
     /*   2567 */ /*GILLT_s64*//*Label 186*/ GIMT_Encode4(2609),
     /*   2571 */ /*GILLT_s128*//*Label 187*/ GIMT_Encode4(2635),
     /*   2575 */ /*GILLT_v2s64*//*Label 188*/ GIMT_Encode4(2661),
     /*   2579 */ /*GILLT_v4s32*//*Label 189*/ GIMT_Encode4(2687),
     /*   2583 */ // Label 185: @2583
     /*   2583 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2608), // Rule ID 198 //
     /*   2588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2601 */   // (urem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODUW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUW),
     /*   2606 */   GIR_RootConstrainSelectedInstOperands,
     /*   2607 */   // GIR_Coverage, 198,
     /*   2607 */   GIR_Done,
     /*   2608 */ // Label 191: @2608
     /*   2608 */ GIM_Reject,
     /*   2609 */ // Label 186: @2609
     /*   2609 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2634), // Rule ID 699 //
     /*   2614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2627 */   // (urem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODUD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUD),
     /*   2632 */   GIR_RootConstrainSelectedInstOperands,
     /*   2633 */   // GIR_Coverage, 699,
     /*   2633 */   GIR_Done,
     /*   2634 */ // Label 192: @2634
     /*   2634 */ GIM_Reject,
     /*   2635 */ // Label 187: @2635
     /*   2635 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2660), // Rule ID 1155 //
     /*   2640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2653 */   // (urem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUQ),
     /*   2658 */   GIR_RootConstrainSelectedInstOperands,
     /*   2659 */   // GIR_Coverage, 1155,
     /*   2659 */   GIR_Done,
     /*   2660 */ // Label 193: @2660
     /*   2660 */ GIM_Reject,
     /*   2661 */ // Label 188: @2661
     /*   2661 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2686), // Rule ID 1128 //
     /*   2666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2679 */   // (urem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUD),
     /*   2684 */   GIR_RootConstrainSelectedInstOperands,
     /*   2685 */   // GIR_Coverage, 1128,
     /*   2685 */   GIR_Done,
     /*   2686 */ // Label 194: @2686
     /*   2686 */ GIM_Reject,
     /*   2687 */ // Label 189: @2687
     /*   2687 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2712), // Rule ID 1126 //
     /*   2692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2705 */   // (urem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUW),
     /*   2710 */   GIR_RootConstrainSelectedInstOperands,
     /*   2711 */   // GIR_Coverage, 1126,
     /*   2711 */   GIR_Done,
     /*   2712 */ // Label 195: @2712
     /*   2712 */ GIM_Reject,
     /*   2713 */ // Label 190: @2713
     /*   2713 */ GIM_Reject,
     /*   2714 */ // Label 7: @2714
     /*   2714 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 200*/ GIMT_Encode4(5274),
     /*   2725 */ /*GILLT_s1*//*Label 196*/ GIMT_Encode4(2749),
     /*   2729 */ /*GILLT_s32*//*Label 197*/ GIMT_Encode4(2858),
     /*   2733 */ /*GILLT_s64*//*Label 198*/ GIMT_Encode4(2967), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   2745 */ /*GILLT_v4s32*//*Label 199*/ GIMT_Encode4(3076),
     /*   2749 */ // Label 196: @2749
     /*   2749 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2857),
     /*   2754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   2757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   2760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   2764 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(2804), // Rule ID 4913 //
     /*   2769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2785 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2791 */     // (and:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2796 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   2798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2802 */     GIR_RootConstrainSelectedInstOperands,
     /*   2803 */     // GIR_Coverage, 4913,
     /*   2803 */     GIR_EraseRootFromParent_Done,
     /*   2804 */   // Label 202: @2804
     /*   2804 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(2844), // Rule ID 182 //
     /*   2809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2825 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2831 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2836 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   2838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2842 */     GIR_RootConstrainSelectedInstOperands,
     /*   2843 */     // GIR_Coverage, 182,
     /*   2843 */     GIR_EraseRootFromParent_Done,
     /*   2844 */   // Label 203: @2844
     /*   2844 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(2856), // Rule ID 175 //
     /*   2849 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   2854 */     GIR_RootConstrainSelectedInstOperands,
     /*   2855 */     // GIR_Coverage, 175,
     /*   2855 */     GIR_Done,
     /*   2856 */   // Label 204: @2856
     /*   2856 */   GIM_Reject,
     /*   2857 */ // Label 201: @2857
     /*   2857 */ GIM_Reject,
     /*   2858 */ // Label 197: @2858
     /*   2858 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(2966),
     /*   2863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2873 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(2913), // Rule ID 4907 //
     /*   2878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2894 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2900 */     // (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2905 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   2907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2911 */     GIR_RootConstrainSelectedInstOperands,
     /*   2912 */     // GIR_Coverage, 4907,
     /*   2912 */     GIR_EraseRootFromParent_Done,
     /*   2913 */   // Label 206: @2913
     /*   2913 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(2953), // Rule ID 123 //
     /*   2918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2934 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2940 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2945 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   2947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2951 */     GIR_RootConstrainSelectedInstOperands,
     /*   2952 */     // GIR_Coverage, 123,
     /*   2952 */     GIR_EraseRootFromParent_Done,
     /*   2953 */   // Label 207: @2953
     /*   2953 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(2965), // Rule ID 122 //
     /*   2958 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (AND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*   2963 */     GIR_RootConstrainSelectedInstOperands,
     /*   2964 */     // GIR_Coverage, 122,
     /*   2964 */     GIR_Done,
     /*   2965 */   // Label 208: @2965
     /*   2965 */   GIM_Reject,
     /*   2966 */ // Label 205: @2966
     /*   2966 */ GIM_Reject,
     /*   2967 */ // Label 198: @2967
     /*   2967 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3075),
     /*   2972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2982 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3022), // Rule ID 4920 //
     /*   2987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   2999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   3003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   3007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3009 */     // (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3014 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   3016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3020 */     GIR_RootConstrainSelectedInstOperands,
     /*   3021 */     // GIR_Coverage, 4920,
     /*   3021 */     GIR_EraseRootFromParent_Done,
     /*   3022 */   // Label 210: @3022
     /*   3022 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3062), // Rule ID 643 //
     /*   3027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   3043 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   3047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3049 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3054 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   3056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3060 */     GIR_RootConstrainSelectedInstOperands,
     /*   3061 */     // GIR_Coverage, 643,
     /*   3061 */     GIR_EraseRootFromParent_Done,
     /*   3062 */   // Label 211: @3062
     /*   3062 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3074), // Rule ID 642 //
     /*   3067 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (AND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*   3072 */     GIR_RootConstrainSelectedInstOperands,
     /*   3073 */     // GIR_Coverage, 642,
     /*   3073 */     GIR_Done,
     /*   3074 */   // Label 212: @3074
     /*   3074 */   GIM_Reject,
     /*   3075 */ // Label 209: @3075
     /*   3075 */ GIM_Reject,
     /*   3076 */ // Label 199: @3076
     /*   3076 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5273),
     /*   3081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3087 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3165), // Rule ID 5268 //
     /*   3092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3135 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3145 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   3158 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3163 */     GIR_RootConstrainSelectedInstOperands,
     /*   3164 */     // GIR_Coverage, 5268,
     /*   3164 */     GIR_EraseRootFromParent_Done,
     /*   3165 */   // Label 214: @3165
     /*   3165 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3243), // Rule ID 5269 //
     /*   3170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3213 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3219 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3223 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3236 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3241 */     GIR_RootConstrainSelectedInstOperands,
     /*   3242 */     // GIR_Coverage, 5269,
     /*   3242 */     GIR_EraseRootFromParent_Done,
     /*   3243 */   // Label 215: @3243
     /*   3243 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3323), // Rule ID 5270 //
     /*   3248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3291 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3301 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3321 */     GIR_RootConstrainSelectedInstOperands,
     /*   3322 */     // GIR_Coverage, 5270,
     /*   3322 */     GIR_EraseRootFromParent_Done,
     /*   3323 */   // Label 216: @3323
     /*   3323 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3403), // Rule ID 5273 //
     /*   3328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3371 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3381 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3401 */     GIR_RootConstrainSelectedInstOperands,
     /*   3402 */     // GIR_Coverage, 5273,
     /*   3402 */     GIR_EraseRootFromParent_Done,
     /*   3403 */   // Label 217: @3403
     /*   3403 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3481), // Rule ID 4957 //
     /*   3408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3451 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3457 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3461 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   3461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3466 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3479 */     GIR_RootConstrainSelectedInstOperands,
     /*   3480 */     // GIR_Coverage, 4957,
     /*   3480 */     GIR_EraseRootFromParent_Done,
     /*   3481 */   // Label 218: @3481
     /*   3481 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3559), // Rule ID 4951 //
     /*   3486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3529 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3535 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3539 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   3539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3544 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   3557 */     GIR_RootConstrainSelectedInstOperands,
     /*   3558 */     // GIR_Coverage, 4951,
     /*   3558 */     GIR_EraseRootFromParent_Done,
     /*   3559 */   // Label 219: @3559
     /*   3559 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3637), // Rule ID 4955 //
     /*   3564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3607 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3613 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3617 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3622 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3635 */     GIR_RootConstrainSelectedInstOperands,
     /*   3636 */     // GIR_Coverage, 4955,
     /*   3636 */     GIR_EraseRootFromParent_Done,
     /*   3637 */   // Label 220: @3637
     /*   3637 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3715), // Rule ID 4954 //
     /*   3642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3685 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3691 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3695 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3700 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3713 */     GIR_RootConstrainSelectedInstOperands,
     /*   3714 */     // GIR_Coverage, 4954,
     /*   3714 */     GIR_EraseRootFromParent_Done,
     /*   3715 */   // Label 221: @3715
     /*   3715 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3793), // Rule ID 4956 //
     /*   3720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3763 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3773 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3778 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   3788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3791 */     GIR_RootConstrainSelectedInstOperands,
     /*   3792 */     // GIR_Coverage, 4956,
     /*   3792 */     GIR_EraseRootFromParent_Done,
     /*   3793 */   // Label 222: @3793
     /*   3793 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3873), // Rule ID 3398 //
     /*   3798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3825 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3831 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3841 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3845 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3851 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3871 */     GIR_RootConstrainSelectedInstOperands,
     /*   3872 */     // GIR_Coverage, 3398,
     /*   3872 */     GIR_EraseRootFromParent_Done,
     /*   3873 */   // Label 223: @3873
     /*   3873 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3953), // Rule ID 3399 //
     /*   3878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3905 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3921 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3925 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3931 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3951 */     GIR_RootConstrainSelectedInstOperands,
     /*   3952 */     // GIR_Coverage, 3399,
     /*   3952 */     GIR_EraseRootFromParent_Done,
     /*   3953 */   // Label 224: @3953
     /*   3953 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(4033), // Rule ID 3397 //
     /*   3958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3985 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3991 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4001 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4011 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   4024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   4028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4031 */     GIR_RootConstrainSelectedInstOperands,
     /*   4032 */     // GIR_Coverage, 3397,
     /*   4032 */     GIR_EraseRootFromParent_Done,
     /*   4033 */   // Label 225: @4033
     /*   4033 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(4113), // Rule ID 5267 //
     /*   4038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   4065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4081 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4087 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4091 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4111 */     GIR_RootConstrainSelectedInstOperands,
     /*   4112 */     // GIR_Coverage, 5267,
     /*   4112 */     GIR_EraseRootFromParent_Done,
     /*   4113 */   // Label 226: @4113
     /*   4113 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4191), // Rule ID 5271 //
     /*   4118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4161 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4167 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4171 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4184 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4189 */     GIR_RootConstrainSelectedInstOperands,
     /*   4190 */     // GIR_Coverage, 5271,
     /*   4190 */     GIR_EraseRootFromParent_Done,
     /*   4191 */   // Label 227: @4191
     /*   4191 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4269), // Rule ID 5272 //
     /*   4196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4239 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4249 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4262 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4267 */     GIR_RootConstrainSelectedInstOperands,
     /*   4268 */     // GIR_Coverage, 5272,
     /*   4268 */     GIR_EraseRootFromParent_Done,
     /*   4269 */   // Label 228: @4269
     /*   4269 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4347), // Rule ID 3385 //
     /*   4274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4317 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4327 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   4327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4332 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4345 */     GIR_RootConstrainSelectedInstOperands,
     /*   4346 */     // GIR_Coverage, 3385,
     /*   4346 */     GIR_EraseRootFromParent_Done,
     /*   4347 */   // Label 229: @4347
     /*   4347 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4425), // Rule ID 3383 //
     /*   4352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4395 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4401 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4405 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   4405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4410 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   4423 */     GIR_RootConstrainSelectedInstOperands,
     /*   4424 */     // GIR_Coverage, 3383,
     /*   4424 */     GIR_EraseRootFromParent_Done,
     /*   4425 */   // Label 230: @4425
     /*   4425 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4503), // Rule ID 4952 //
     /*   4430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4473 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4479 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4483 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4488 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4501 */     GIR_RootConstrainSelectedInstOperands,
     /*   4502 */     // GIR_Coverage, 4952,
     /*   4502 */     GIR_EraseRootFromParent_Done,
     /*   4503 */   // Label 231: @4503
     /*   4503 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4581), // Rule ID 3384 //
     /*   4508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4561 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4566 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4579 */     GIR_RootConstrainSelectedInstOperands,
     /*   4580 */     // GIR_Coverage, 3384,
     /*   4580 */     GIR_EraseRootFromParent_Done,
     /*   4581 */   // Label 232: @4581
     /*   4581 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(4659), // Rule ID 4953 //
     /*   4586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4629 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4635 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4639 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4644 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   4654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4657 */     GIR_RootConstrainSelectedInstOperands,
     /*   4658 */     // GIR_Coverage, 4953,
     /*   4658 */     GIR_EraseRootFromParent_Done,
     /*   4659 */   // Label 233: @4659
     /*   4659 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(4714), // Rule ID 4928 //
     /*   4664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4691 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4701 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4706 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*   4708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4712 */     GIR_RootConstrainSelectedInstOperands,
     /*   4713 */     // GIR_Coverage, 4928,
     /*   4713 */     GIR_EraseRootFromParent_Done,
     /*   4714 */   // Label 234: @4714
     /*   4714 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(4769), // Rule ID 929 //
     /*   4719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4746 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4752 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4756 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4761 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*   4763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4767 */     GIR_RootConstrainSelectedInstOperands,
     /*   4768 */     // GIR_Coverage, 929,
     /*   4768 */     GIR_EraseRootFromParent_Done,
     /*   4769 */   // Label 235: @4769
     /*   4769 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(4819), // Rule ID 4948 //
     /*   4774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4799 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4812 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   4814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4817 */     GIR_RootConstrainSelectedInstOperands,
     /*   4818 */     // GIR_Coverage, 4948,
     /*   4818 */     GIR_EraseRootFromParent_Done,
     /*   4819 */   // Label 236: @4819
     /*   4819 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(4869), // Rule ID 4950 //
     /*   4824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4849 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   4849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4854 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   4867 */     GIR_RootConstrainSelectedInstOperands,
     /*   4868 */     // GIR_Coverage, 4950,
     /*   4868 */     GIR_EraseRootFromParent_Done,
     /*   4869 */   // Label 237: @4869
     /*   4869 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(4919), // Rule ID 4949 //
     /*   4874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4899 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   4899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4904 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   4917 */     GIR_RootConstrainSelectedInstOperands,
     /*   4918 */     // GIR_Coverage, 4949,
     /*   4918 */     GIR_EraseRootFromParent_Done,
     /*   4919 */   // Label 238: @4919
     /*   4919 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(4969), // Rule ID 3380 //
     /*   4924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4949 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4954 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4967 */     GIR_RootConstrainSelectedInstOperands,
     /*   4968 */     // GIR_Coverage, 3380,
     /*   4968 */     GIR_EraseRootFromParent_Done,
     /*   4969 */   // Label 239: @4969
     /*   4969 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(5019), // Rule ID 3382 //
     /*   4974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4999 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   4999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5004 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   5006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   5017 */     GIR_RootConstrainSelectedInstOperands,
     /*   5018 */     // GIR_Coverage, 3382,
     /*   5018 */     GIR_EraseRootFromParent_Done,
     /*   5019 */   // Label 240: @5019
     /*   5019 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(5069), // Rule ID 3381 //
     /*   5024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5049 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   5049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5054 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   5056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   5067 */     GIR_RootConstrainSelectedInstOperands,
     /*   5068 */     // GIR_Coverage, 3381,
     /*   5068 */     GIR_EraseRootFromParent_Done,
     /*   5069 */   // Label 241: @5069
     /*   5069 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(5088), // Rule ID 928 //
     /*   5074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   5077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5081 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   5081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLAND),
     /*   5086 */     GIR_RootConstrainSelectedInstOperands,
     /*   5087 */     // GIR_Coverage, 928,
     /*   5087 */     GIR_Done,
     /*   5088 */   // Label 242: @5088
     /*   5088 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(5143), // Rule ID 4916 //
     /*   5093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5120 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5126 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5130 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5135 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*   5137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5141 */     GIR_RootConstrainSelectedInstOperands,
     /*   5142 */     // GIR_Coverage, 4916,
     /*   5142 */     GIR_EraseRootFromParent_Done,
     /*   5143 */   // Label 243: @5143
     /*   5143 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(5198), // Rule ID 312 //
     /*   5148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5175 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5185 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5190 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*   5192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5196 */     GIR_RootConstrainSelectedInstOperands,
     /*   5197 */     // GIR_Coverage, 312,
     /*   5197 */     GIR_EraseRootFromParent_Done,
     /*   5198 */   // Label 244: @5198
     /*   5198 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(5253), // Rule ID 1378 //
     /*   5203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5230 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5236 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5240 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*   5240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5245 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*   5247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*   5251 */     GIR_RootConstrainSelectedInstOperands,
     /*   5252 */     // GIR_Coverage, 1378,
     /*   5252 */     GIR_EraseRootFromParent_Done,
     /*   5253 */   // Label 245: @5253
     /*   5253 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(5272), // Rule ID 311 //
     /*   5258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5265 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VAND),
     /*   5270 */     GIR_RootConstrainSelectedInstOperands,
     /*   5271 */     // GIR_Coverage, 311,
     /*   5271 */     GIR_Done,
     /*   5272 */   // Label 246: @5272
     /*   5272 */   GIM_Reject,
     /*   5273 */ // Label 213: @5273
     /*   5273 */ GIM_Reject,
     /*   5274 */ // Label 200: @5274
     /*   5274 */ GIM_Reject,
     /*   5275 */ // Label 8: @5275
     /*   5275 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 251*/ GIMT_Encode4(48416),
     /*   5286 */ /*GILLT_s1*//*Label 247*/ GIMT_Encode4(5310),
     /*   5290 */ /*GILLT_s32*//*Label 248*/ GIMT_Encode4(5419),
     /*   5294 */ /*GILLT_s64*//*Label 249*/ GIMT_Encode4(5528), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   5306 */ /*GILLT_v4s32*//*Label 250*/ GIMT_Encode4(5637),
     /*   5310 */ // Label 247: @5310
     /*   5310 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(5418),
     /*   5315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   5318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   5321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   5325 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(5365), // Rule ID 4914 //
     /*   5330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5346 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5352 */     // (or:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5357 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   5359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5363 */     GIR_RootConstrainSelectedInstOperands,
     /*   5364 */     // GIR_Coverage, 4914,
     /*   5364 */     GIR_EraseRootFromParent_Done,
     /*   5365 */   // Label 253: @5365
     /*   5365 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(5405), // Rule ID 183 //
     /*   5370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5386 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5392 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5397 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   5399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5403 */     GIR_RootConstrainSelectedInstOperands,
     /*   5404 */     // GIR_Coverage, 183,
     /*   5404 */     GIR_EraseRootFromParent_Done,
     /*   5405 */   // Label 254: @5405
     /*   5405 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(5417), // Rule ID 177 //
     /*   5410 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CROR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /*   5415 */     GIR_RootConstrainSelectedInstOperands,
     /*   5416 */     // GIR_Coverage, 177,
     /*   5416 */     GIR_Done,
     /*   5417 */   // Label 255: @5417
     /*   5417 */   GIM_Reject,
     /*   5418 */ // Label 252: @5418
     /*   5418 */ GIM_Reject,
     /*   5419 */ // Label 248: @5419
     /*   5419 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(5527),
     /*   5424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   5427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   5430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   5434 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(5474), // Rule ID 4908 //
     /*   5439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5455 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5461 */     // (or:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5466 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5472 */     GIR_RootConstrainSelectedInstOperands,
     /*   5473 */     // GIR_Coverage, 4908,
     /*   5473 */     GIR_EraseRootFromParent_Done,
     /*   5474 */   // Label 257: @5474
     /*   5474 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(5514), // Rule ID 126 //
     /*   5479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5495 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5501 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5506 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5512 */     GIR_RootConstrainSelectedInstOperands,
     /*   5513 */     // GIR_Coverage, 126,
     /*   5513 */     GIR_EraseRootFromParent_Done,
     /*   5514 */   // Label 258: @5514
     /*   5514 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(5526), // Rule ID 124 //
     /*   5519 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (OR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR),
     /*   5524 */     GIR_RootConstrainSelectedInstOperands,
     /*   5525 */     // GIR_Coverage, 124,
     /*   5525 */     GIR_Done,
     /*   5526 */   // Label 259: @5526
     /*   5526 */   GIM_Reject,
     /*   5527 */ // Label 256: @5527
     /*   5527 */ GIM_Reject,
     /*   5528 */ // Label 249: @5528
     /*   5528 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(5636),
     /*   5533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   5536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   5539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   5543 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(5583), // Rule ID 4921 //
     /*   5548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5564 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5570 */     // (or:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5575 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5581 */     GIR_RootConstrainSelectedInstOperands,
     /*   5582 */     // GIR_Coverage, 4921,
     /*   5582 */     GIR_EraseRootFromParent_Done,
     /*   5583 */   // Label 261: @5583
     /*   5583 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(5623), // Rule ID 646 //
     /*   5588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5604 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5610 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5615 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5621 */     GIR_RootConstrainSelectedInstOperands,
     /*   5622 */     // GIR_Coverage, 646,
     /*   5622 */     GIR_EraseRootFromParent_Done,
     /*   5623 */   // Label 262: @5623
     /*   5623 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(5635), // Rule ID 644 //
     /*   5628 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (OR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /*   5633 */     GIR_RootConstrainSelectedInstOperands,
     /*   5634 */     // GIR_Coverage, 644,
     /*   5634 */     GIR_Done,
     /*   5635 */   // Label 263: @5635
     /*   5635 */   GIM_Reject,
     /*   5636 */ // Label 260: @5636
     /*   5636 */ GIM_Reject,
     /*   5637 */ // Label 250: @5637
     /*   5637 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(48415),
     /*   5642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5648 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5786), // Rule ID 4968 //
     /*   5653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5704 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5716 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5720 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5724 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5728 */     // MIs[5] vA
     /*   5728 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5733 */     // MIs[5] vB
     /*   5733 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5738 */     // MIs[4] vC
     /*   5738 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5743 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5747 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5753 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5755 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5757 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5774 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5784 */     GIR_RootConstrainSelectedInstOperands,
     /*   5785 */     // GIR_Coverage, 4968,
     /*   5785 */     GIR_EraseRootFromParent_Done,
     /*   5786 */   // Label 265: @5786
     /*   5786 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5924), // Rule ID 4969 //
     /*   5791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5842 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5850 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5854 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5858 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5862 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5866 */     // MIs[5] vB
     /*   5866 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5871 */     // MIs[5] vA
     /*   5871 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5876 */     // MIs[4] vC
     /*   5876 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5881 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5885 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5891 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5893 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5895 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5912 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5922 */     GIR_RootConstrainSelectedInstOperands,
     /*   5923 */     // GIR_Coverage, 4969,
     /*   5923 */     GIR_EraseRootFromParent_Done,
     /*   5924 */   // Label 266: @5924
     /*   5924 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(6062), // Rule ID 4970 //
     /*   5929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5976 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5980 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5992 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5996 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6000 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6004 */     // MIs[5] vA
     /*   6004 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6009 */     // MIs[5] vC
     /*   6009 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6014 */     // MIs[4] vB
     /*   6014 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6019 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6023 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6031 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6033 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6050 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6060 */     GIR_RootConstrainSelectedInstOperands,
     /*   6061 */     // GIR_Coverage, 4970,
     /*   6061 */     GIR_EraseRootFromParent_Done,
     /*   6062 */   // Label 267: @6062
     /*   6062 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(6200), // Rule ID 4971 //
     /*   6067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6114 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6118 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6122 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6126 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6130 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6134 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6138 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6142 */     // MIs[5] vC
     /*   6142 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6147 */     // MIs[5] vA
     /*   6147 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6152 */     // MIs[4] vB
     /*   6152 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6157 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6161 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6167 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6169 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6171 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6188 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6198 */     GIR_RootConstrainSelectedInstOperands,
     /*   6199 */     // GIR_Coverage, 4971,
     /*   6199 */     GIR_EraseRootFromParent_Done,
     /*   6200 */   // Label 268: @6200
     /*   6200 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(6338), // Rule ID 4972 //
     /*   6205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6252 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6256 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6260 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6264 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6268 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6272 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6276 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6280 */     // MIs[5] vB
     /*   6280 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6285 */     // MIs[5] vC
     /*   6285 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6290 */     // MIs[4] vA
     /*   6290 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6295 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6299 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6305 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6307 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6309 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6326 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6336 */     GIR_RootConstrainSelectedInstOperands,
     /*   6337 */     // GIR_Coverage, 4972,
     /*   6337 */     GIR_EraseRootFromParent_Done,
     /*   6338 */   // Label 269: @6338
     /*   6338 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(6476), // Rule ID 4973 //
     /*   6343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6390 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6394 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6398 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6402 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6406 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6410 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6414 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6418 */     // MIs[5] vC
     /*   6418 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6423 */     // MIs[5] vB
     /*   6423 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6428 */     // MIs[4] vA
     /*   6428 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6433 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6437 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6445 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6447 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6464 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6474 */     GIR_RootConstrainSelectedInstOperands,
     /*   6475 */     // GIR_Coverage, 4973,
     /*   6475 */     GIR_EraseRootFromParent_Done,
     /*   6476 */   // Label 270: @6476
     /*   6476 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(6614), // Rule ID 4980 //
     /*   6481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6528 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6532 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6536 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6540 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6544 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6548 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6552 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6556 */     // MIs[5] vA
     /*   6556 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6561 */     // MIs[5] vB
     /*   6561 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6566 */     // MIs[4] vC
     /*   6566 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6571 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6575 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6581 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6583 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6585 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6602 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6612 */     GIR_RootConstrainSelectedInstOperands,
     /*   6613 */     // GIR_Coverage, 4980,
     /*   6613 */     GIR_EraseRootFromParent_Done,
     /*   6614 */   // Label 271: @6614
     /*   6614 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(6752), // Rule ID 4981 //
     /*   6619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6666 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6670 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6682 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6686 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6690 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6694 */     // MIs[5] vB
     /*   6694 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6699 */     // MIs[5] vA
     /*   6699 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6704 */     // MIs[4] vC
     /*   6704 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6709 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6713 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6719 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6721 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6723 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6740 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6750 */     GIR_RootConstrainSelectedInstOperands,
     /*   6751 */     // GIR_Coverage, 4981,
     /*   6751 */     GIR_EraseRootFromParent_Done,
     /*   6752 */   // Label 272: @6752
     /*   6752 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(6890), // Rule ID 4982 //
     /*   6757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6804 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6808 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6816 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6820 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6824 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6828 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6832 */     // MIs[5] vA
     /*   6832 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6837 */     // MIs[5] vC
     /*   6837 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6842 */     // MIs[4] vB
     /*   6842 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6847 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6851 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6857 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6859 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6861 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6878 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6888 */     GIR_RootConstrainSelectedInstOperands,
     /*   6889 */     // GIR_Coverage, 4982,
     /*   6889 */     GIR_EraseRootFromParent_Done,
     /*   6890 */   // Label 273: @6890
     /*   6890 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(7028), // Rule ID 4983 //
     /*   6895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6946 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6950 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6954 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6958 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6962 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6966 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6970 */     // MIs[5] vC
     /*   6970 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6975 */     // MIs[5] vA
     /*   6975 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6980 */     // MIs[4] vB
     /*   6980 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6985 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6989 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6995 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6997 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6999 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7016 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7026 */     GIR_RootConstrainSelectedInstOperands,
     /*   7027 */     // GIR_Coverage, 4983,
     /*   7027 */     GIR_EraseRootFromParent_Done,
     /*   7028 */   // Label 274: @7028
     /*   7028 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(7166), // Rule ID 4984 //
     /*   7033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7084 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7088 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7092 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7096 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7100 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7104 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7108 */     // MIs[5] vB
     /*   7108 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7113 */     // MIs[5] vC
     /*   7113 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7118 */     // MIs[4] vA
     /*   7118 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7123 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7127 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7135 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7137 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7154 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7164 */     GIR_RootConstrainSelectedInstOperands,
     /*   7165 */     // GIR_Coverage, 4984,
     /*   7165 */     GIR_EraseRootFromParent_Done,
     /*   7166 */   // Label 275: @7166
     /*   7166 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(7304), // Rule ID 4985 //
     /*   7171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7218 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7222 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7230 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7234 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7238 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7242 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7246 */     // MIs[5] vC
     /*   7246 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7251 */     // MIs[5] vB
     /*   7251 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7256 */     // MIs[4] vA
     /*   7256 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7261 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7265 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7273 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7275 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7292 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7302 */     GIR_RootConstrainSelectedInstOperands,
     /*   7303 */     // GIR_Coverage, 4985,
     /*   7303 */     GIR_EraseRootFromParent_Done,
     /*   7304 */   // Label 276: @7304
     /*   7304 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(7442), // Rule ID 4992 //
     /*   7309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7360 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7364 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7368 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7372 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7376 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7380 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7384 */     // MIs[5] vA
     /*   7384 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7389 */     // MIs[5] vB
     /*   7389 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7394 */     // MIs[4] vC
     /*   7394 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7399 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7403 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7409 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7411 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7413 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7430 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7440 */     GIR_RootConstrainSelectedInstOperands,
     /*   7441 */     // GIR_Coverage, 4992,
     /*   7441 */     GIR_EraseRootFromParent_Done,
     /*   7442 */   // Label 277: @7442
     /*   7442 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(7580), // Rule ID 4993 //
     /*   7447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7494 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7498 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7506 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7510 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7514 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7518 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7522 */     // MIs[5] vB
     /*   7522 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7527 */     // MIs[5] vA
     /*   7527 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7532 */     // MIs[4] vC
     /*   7532 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7537 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7541 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7547 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7549 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7551 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7568 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7578 */     GIR_RootConstrainSelectedInstOperands,
     /*   7579 */     // GIR_Coverage, 4993,
     /*   7579 */     GIR_EraseRootFromParent_Done,
     /*   7580 */   // Label 278: @7580
     /*   7580 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(7718), // Rule ID 4994 //
     /*   7585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7632 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7636 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7640 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7644 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7648 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7652 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7656 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7660 */     // MIs[5] vA
     /*   7660 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7665 */     // MIs[5] vC
     /*   7665 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7670 */     // MIs[4] vB
     /*   7670 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7675 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7679 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7687 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7689 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7706 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7716 */     GIR_RootConstrainSelectedInstOperands,
     /*   7717 */     // GIR_Coverage, 4994,
     /*   7717 */     GIR_EraseRootFromParent_Done,
     /*   7718 */   // Label 279: @7718
     /*   7718 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(7856), // Rule ID 4995 //
     /*   7723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7770 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7774 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7778 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7782 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7786 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7790 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7794 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7798 */     // MIs[5] vC
     /*   7798 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7803 */     // MIs[5] vA
     /*   7803 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7808 */     // MIs[4] vB
     /*   7808 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7813 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7817 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7823 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7825 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7827 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7844 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7854 */     GIR_RootConstrainSelectedInstOperands,
     /*   7855 */     // GIR_Coverage, 4995,
     /*   7855 */     GIR_EraseRootFromParent_Done,
     /*   7856 */   // Label 280: @7856
     /*   7856 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(7994), // Rule ID 4996 //
     /*   7861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7908 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7912 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7924 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7928 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7932 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7936 */     // MIs[5] vB
     /*   7936 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7941 */     // MIs[5] vC
     /*   7941 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7946 */     // MIs[4] vA
     /*   7946 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7951 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7955 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7963 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7965 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7982 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7992 */     GIR_RootConstrainSelectedInstOperands,
     /*   7993 */     // GIR_Coverage, 4996,
     /*   7993 */     GIR_EraseRootFromParent_Done,
     /*   7994 */   // Label 281: @7994
     /*   7994 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8132), // Rule ID 4997 //
     /*   7999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8046 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8050 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8054 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8058 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8062 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8066 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8070 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8074 */     // MIs[5] vC
     /*   8074 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8079 */     // MIs[5] vB
     /*   8079 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8084 */     // MIs[4] vA
     /*   8084 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8089 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8093 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8099 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8101 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8103 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   8112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   8120 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8130 */     GIR_RootConstrainSelectedInstOperands,
     /*   8131 */     // GIR_Coverage, 4997,
     /*   8131 */     GIR_EraseRootFromParent_Done,
     /*   8132 */   // Label 282: @8132
     /*   8132 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8270), // Rule ID 5004 //
     /*   8137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8196 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8200 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8204 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8208 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8212 */     // MIs[5] vA
     /*   8212 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8217 */     // MIs[5] vB
     /*   8217 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8222 */     // MIs[4] vC
     /*   8222 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8227 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8231 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8239 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8241 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8258 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8268 */     GIR_RootConstrainSelectedInstOperands,
     /*   8269 */     // GIR_Coverage, 5004,
     /*   8269 */     GIR_EraseRootFromParent_Done,
     /*   8270 */   // Label 283: @8270
     /*   8270 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8408), // Rule ID 5005 //
     /*   8275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8322 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8326 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8330 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8334 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8338 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8342 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8346 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8350 */     // MIs[5] vB
     /*   8350 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8355 */     // MIs[5] vA
     /*   8355 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8360 */     // MIs[4] vC
     /*   8360 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8365 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8369 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8375 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8377 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8379 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8396 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8406 */     GIR_RootConstrainSelectedInstOperands,
     /*   8407 */     // GIR_Coverage, 5005,
     /*   8407 */     GIR_EraseRootFromParent_Done,
     /*   8408 */   // Label 284: @8408
     /*   8408 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8546), // Rule ID 5006 //
     /*   8413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8464 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8468 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8472 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8476 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8480 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8484 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8488 */     // MIs[5] vA
     /*   8488 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8493 */     // MIs[5] vC
     /*   8493 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8498 */     // MIs[4] vB
     /*   8498 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8503 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8507 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8515 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8517 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8534 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8544 */     GIR_RootConstrainSelectedInstOperands,
     /*   8545 */     // GIR_Coverage, 5006,
     /*   8545 */     GIR_EraseRootFromParent_Done,
     /*   8546 */   // Label 285: @8546
     /*   8546 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8684), // Rule ID 5007 //
     /*   8551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8602 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8610 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8614 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8618 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8622 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8626 */     // MIs[5] vC
     /*   8626 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8631 */     // MIs[5] vA
     /*   8631 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8636 */     // MIs[4] vB
     /*   8636 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8641 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8645 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8653 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8655 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8672 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8682 */     GIR_RootConstrainSelectedInstOperands,
     /*   8683 */     // GIR_Coverage, 5007,
     /*   8683 */     GIR_EraseRootFromParent_Done,
     /*   8684 */   // Label 286: @8684
     /*   8684 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8822), // Rule ID 5008 //
     /*   8689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8736 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8740 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8748 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8752 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8756 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8760 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8764 */     // MIs[5] vB
     /*   8764 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8769 */     // MIs[5] vC
     /*   8769 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8774 */     // MIs[4] vA
     /*   8774 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8779 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8783 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8791 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8793 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8810 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8820 */     GIR_RootConstrainSelectedInstOperands,
     /*   8821 */     // GIR_Coverage, 5008,
     /*   8821 */     GIR_EraseRootFromParent_Done,
     /*   8822 */   // Label 287: @8822
     /*   8822 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8960), // Rule ID 5009 //
     /*   8827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8878 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8882 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8886 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8890 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8894 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8898 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8902 */     // MIs[5] vC
     /*   8902 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8907 */     // MIs[5] vB
     /*   8907 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8912 */     // MIs[4] vA
     /*   8912 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8917 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8921 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8927 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8929 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8931 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8948 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8958 */     GIR_RootConstrainSelectedInstOperands,
     /*   8959 */     // GIR_Coverage, 5009,
     /*   8959 */     GIR_EraseRootFromParent_Done,
     /*   8960 */   // Label 288: @8960
     /*   8960 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(9098), // Rule ID 5016 //
     /*   8965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9020 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9024 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9028 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9032 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9036 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9040 */     // MIs[5] vA
     /*   9040 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9045 */     // MIs[5] vB
     /*   9045 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9050 */     // MIs[4] vC
     /*   9050 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9055 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9059 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9065 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9067 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9069 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9086 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9096 */     GIR_RootConstrainSelectedInstOperands,
     /*   9097 */     // GIR_Coverage, 5016,
     /*   9097 */     GIR_EraseRootFromParent_Done,
     /*   9098 */   // Label 289: @9098
     /*   9098 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(9236), // Rule ID 5017 //
     /*   9103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9150 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9158 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9162 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9166 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9170 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9174 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9178 */     // MIs[5] vB
     /*   9178 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9183 */     // MIs[5] vA
     /*   9183 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9188 */     // MIs[4] vC
     /*   9188 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9193 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9197 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9203 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9205 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9207 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9224 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9234 */     GIR_RootConstrainSelectedInstOperands,
     /*   9235 */     // GIR_Coverage, 5017,
     /*   9235 */     GIR_EraseRootFromParent_Done,
     /*   9236 */   // Label 290: @9236
     /*   9236 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(9374), // Rule ID 5018 //
     /*   9241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9288 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9292 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9304 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9308 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9312 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9316 */     // MIs[5] vA
     /*   9316 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9321 */     // MIs[5] vC
     /*   9321 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9326 */     // MIs[4] vB
     /*   9326 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9331 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9335 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9341 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9343 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9345 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9362 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9372 */     GIR_RootConstrainSelectedInstOperands,
     /*   9373 */     // GIR_Coverage, 5018,
     /*   9373 */     GIR_EraseRootFromParent_Done,
     /*   9374 */   // Label 291: @9374
     /*   9374 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(9512), // Rule ID 5019 //
     /*   9379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9430 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9434 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9438 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9442 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9446 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9450 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9454 */     // MIs[5] vC
     /*   9454 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9459 */     // MIs[5] vA
     /*   9459 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9464 */     // MIs[4] vB
     /*   9464 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9469 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9473 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9479 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9481 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9483 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9500 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9510 */     GIR_RootConstrainSelectedInstOperands,
     /*   9511 */     // GIR_Coverage, 5019,
     /*   9511 */     GIR_EraseRootFromParent_Done,
     /*   9512 */   // Label 292: @9512
     /*   9512 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(9650), // Rule ID 5020 //
     /*   9517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9564 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9568 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9572 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9576 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9580 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9584 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9588 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9592 */     // MIs[5] vB
     /*   9592 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9597 */     // MIs[5] vC
     /*   9597 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9602 */     // MIs[4] vA
     /*   9602 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9607 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9611 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9617 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9619 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9621 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9638 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9648 */     GIR_RootConstrainSelectedInstOperands,
     /*   9649 */     // GIR_Coverage, 5020,
     /*   9649 */     GIR_EraseRootFromParent_Done,
     /*   9650 */   // Label 293: @9650
     /*   9650 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(9788), // Rule ID 5021 //
     /*   9655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9702 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9706 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9710 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9714 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9718 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9722 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9726 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9730 */     // MIs[5] vC
     /*   9730 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9735 */     // MIs[5] vB
     /*   9735 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9740 */     // MIs[4] vA
     /*   9740 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9745 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9749 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9755 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9757 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9759 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9776 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9786 */     GIR_RootConstrainSelectedInstOperands,
     /*   9787 */     // GIR_Coverage, 5021,
     /*   9787 */     GIR_EraseRootFromParent_Done,
     /*   9788 */   // Label 294: @9788
     /*   9788 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(9926), // Rule ID 5028 //
     /*   9793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9856 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9860 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9864 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9868 */     // MIs[5] vA
     /*   9868 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9873 */     // MIs[5] vB
     /*   9873 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9878 */     // MIs[4] vC
     /*   9878 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9883 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9887 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9895 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9897 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   9910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   9914 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9924 */     GIR_RootConstrainSelectedInstOperands,
     /*   9925 */     // GIR_Coverage, 5028,
     /*   9925 */     GIR_EraseRootFromParent_Done,
     /*   9926 */   // Label 295: @9926
     /*   9926 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(10064), // Rule ID 5029 //
     /*   9931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9982 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9986 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9990 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9994 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9998 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10002 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10006 */     // MIs[5] vB
     /*  10006 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10011 */     // MIs[5] vA
     /*  10011 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10016 */     // MIs[4] vC
     /*  10016 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10021 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10025 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10033 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10035 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10052 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10062 */     GIR_RootConstrainSelectedInstOperands,
     /*  10063 */     // GIR_Coverage, 5029,
     /*  10063 */     GIR_EraseRootFromParent_Done,
     /*  10064 */   // Label 296: @10064
     /*  10064 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(10202), // Rule ID 5030 //
     /*  10069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10124 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10128 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10132 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10136 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10140 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10144 */     // MIs[5] vA
     /*  10144 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10149 */     // MIs[5] vC
     /*  10149 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10154 */     // MIs[4] vB
     /*  10154 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10159 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10163 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10169 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10171 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10173 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10190 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10200 */     GIR_RootConstrainSelectedInstOperands,
     /*  10201 */     // GIR_Coverage, 5030,
     /*  10201 */     GIR_EraseRootFromParent_Done,
     /*  10202 */   // Label 297: @10202
     /*  10202 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(10340), // Rule ID 5031 //
     /*  10207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10258 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10262 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10266 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10270 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10274 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10278 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10282 */     // MIs[5] vC
     /*  10282 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10287 */     // MIs[5] vA
     /*  10287 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10292 */     // MIs[4] vB
     /*  10292 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10297 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10301 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10307 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10309 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10311 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10328 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10338 */     GIR_RootConstrainSelectedInstOperands,
     /*  10339 */     // GIR_Coverage, 5031,
     /*  10339 */     GIR_EraseRootFromParent_Done,
     /*  10340 */   // Label 298: @10340
     /*  10340 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(10478), // Rule ID 5032 //
     /*  10345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10392 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10396 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10408 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10412 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10416 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10420 */     // MIs[5] vB
     /*  10420 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10425 */     // MIs[5] vC
     /*  10425 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10430 */     // MIs[4] vA
     /*  10430 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10435 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10439 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10445 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10447 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10449 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10466 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10476 */     GIR_RootConstrainSelectedInstOperands,
     /*  10477 */     // GIR_Coverage, 5032,
     /*  10477 */     GIR_EraseRootFromParent_Done,
     /*  10478 */   // Label 299: @10478
     /*  10478 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(10616), // Rule ID 5033 //
     /*  10483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10530 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10534 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10538 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10542 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10546 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10550 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10554 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10558 */     // MIs[5] vC
     /*  10558 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10563 */     // MIs[5] vB
     /*  10563 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10568 */     // MIs[4] vA
     /*  10568 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10573 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10577 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10583 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10585 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10587 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10604 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10614 */     GIR_RootConstrainSelectedInstOperands,
     /*  10615 */     // GIR_Coverage, 5033,
     /*  10615 */     GIR_EraseRootFromParent_Done,
     /*  10616 */   // Label 300: @10616
     /*  10616 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(10754), // Rule ID 4974 //
     /*  10621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10668 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10672 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10680 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10684 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10688 */     // MIs[4] vC
     /*  10688 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10693 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10697 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10701 */     // MIs[5] vA
     /*  10701 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10706 */     // MIs[5] vB
     /*  10706 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10711 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10715 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10721 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10723 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10725 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10742 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10752 */     GIR_RootConstrainSelectedInstOperands,
     /*  10753 */     // GIR_Coverage, 4974,
     /*  10753 */     GIR_EraseRootFromParent_Done,
     /*  10754 */   // Label 301: @10754
     /*  10754 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(10892), // Rule ID 4975 //
     /*  10759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10810 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10822 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10826 */     // MIs[4] vC
     /*  10826 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10831 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10835 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10839 */     // MIs[5] vB
     /*  10839 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10844 */     // MIs[5] vA
     /*  10844 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10849 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10853 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10859 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10861 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10863 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10880 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10890 */     GIR_RootConstrainSelectedInstOperands,
     /*  10891 */     // GIR_Coverage, 4975,
     /*  10891 */     GIR_EraseRootFromParent_Done,
     /*  10892 */   // Label 302: @10892
     /*  10892 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11030), // Rule ID 4976 //
     /*  10897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10948 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10952 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10956 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10960 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10964 */     // MIs[4] vB
     /*  10964 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10969 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10973 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10977 */     // MIs[5] vA
     /*  10977 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10982 */     // MIs[5] vC
     /*  10982 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10987 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10991 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10997 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10999 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11001 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11018 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11028 */     GIR_RootConstrainSelectedInstOperands,
     /*  11029 */     // GIR_Coverage, 4976,
     /*  11029 */     GIR_EraseRootFromParent_Done,
     /*  11030 */   // Label 303: @11030
     /*  11030 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11168), // Rule ID 4977 //
     /*  11035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11082 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11086 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11094 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11098 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11102 */     // MIs[4] vB
     /*  11102 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11107 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11111 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11115 */     // MIs[5] vC
     /*  11115 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11120 */     // MIs[5] vA
     /*  11120 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11125 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11129 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11135 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11137 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11139 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11156 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11166 */     GIR_RootConstrainSelectedInstOperands,
     /*  11167 */     // GIR_Coverage, 4977,
     /*  11167 */     GIR_EraseRootFromParent_Done,
     /*  11168 */   // Label 304: @11168
     /*  11168 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11306), // Rule ID 4978 //
     /*  11173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11220 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11224 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11232 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11236 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11240 */     // MIs[4] vA
     /*  11240 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11245 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11249 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11253 */     // MIs[5] vB
     /*  11253 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11258 */     // MIs[5] vC
     /*  11258 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11263 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11267 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11273 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11275 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11277 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11294 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11304 */     GIR_RootConstrainSelectedInstOperands,
     /*  11305 */     // GIR_Coverage, 4978,
     /*  11305 */     GIR_EraseRootFromParent_Done,
     /*  11306 */   // Label 305: @11306
     /*  11306 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(11444), // Rule ID 4979 //
     /*  11311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11358 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11362 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11366 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11370 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11374 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11378 */     // MIs[4] vA
     /*  11378 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11383 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11387 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11391 */     // MIs[5] vC
     /*  11391 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11396 */     // MIs[5] vB
     /*  11396 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11401 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11405 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11411 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11413 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11415 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11432 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11442 */     GIR_RootConstrainSelectedInstOperands,
     /*  11443 */     // GIR_Coverage, 4979,
     /*  11443 */     GIR_EraseRootFromParent_Done,
     /*  11444 */   // Label 306: @11444
     /*  11444 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(11582), // Rule ID 4986 //
     /*  11449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11496 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11500 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11508 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11512 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11516 */     // MIs[4] vC
     /*  11516 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11521 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11525 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11529 */     // MIs[5] vA
     /*  11529 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11534 */     // MIs[5] vB
     /*  11534 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11539 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11543 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11551 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11553 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11570 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11580 */     GIR_RootConstrainSelectedInstOperands,
     /*  11581 */     // GIR_Coverage, 4986,
     /*  11581 */     GIR_EraseRootFromParent_Done,
     /*  11582 */   // Label 307: @11582
     /*  11582 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(11720), // Rule ID 4987 //
     /*  11587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11634 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11638 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11646 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11650 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11654 */     // MIs[4] vC
     /*  11654 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11659 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11663 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11667 */     // MIs[5] vB
     /*  11667 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11672 */     // MIs[5] vA
     /*  11672 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11677 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11681 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11687 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11689 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11691 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11708 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11718 */     GIR_RootConstrainSelectedInstOperands,
     /*  11719 */     // GIR_Coverage, 4987,
     /*  11719 */     GIR_EraseRootFromParent_Done,
     /*  11720 */   // Label 308: @11720
     /*  11720 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(11858), // Rule ID 4988 //
     /*  11725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11776 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11780 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11784 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11788 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11792 */     // MIs[4] vB
     /*  11792 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11797 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11801 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11805 */     // MIs[5] vA
     /*  11805 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11810 */     // MIs[5] vC
     /*  11810 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11815 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11819 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11825 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11827 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11829 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11846 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11856 */     GIR_RootConstrainSelectedInstOperands,
     /*  11857 */     // GIR_Coverage, 4988,
     /*  11857 */     GIR_EraseRootFromParent_Done,
     /*  11858 */   // Label 309: @11858
     /*  11858 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(11996), // Rule ID 4989 //
     /*  11863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11898 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11910 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11914 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11918 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11922 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11926 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11930 */     // MIs[4] vB
     /*  11930 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11935 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11939 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11943 */     // MIs[5] vC
     /*  11943 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11948 */     // MIs[5] vA
     /*  11948 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11953 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11957 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11963 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11965 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11967 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11984 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11994 */     GIR_RootConstrainSelectedInstOperands,
     /*  11995 */     // GIR_Coverage, 4989,
     /*  11995 */     GIR_EraseRootFromParent_Done,
     /*  11996 */   // Label 310: @11996
     /*  11996 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12134), // Rule ID 4990 //
     /*  12001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12048 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12052 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12056 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12060 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12064 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12068 */     // MIs[4] vA
     /*  12068 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12073 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12077 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12081 */     // MIs[5] vB
     /*  12081 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12086 */     // MIs[5] vC
     /*  12086 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12091 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12095 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12101 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12103 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12105 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12122 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12132 */     GIR_RootConstrainSelectedInstOperands,
     /*  12133 */     // GIR_Coverage, 4990,
     /*  12133 */     GIR_EraseRootFromParent_Done,
     /*  12134 */   // Label 311: @12134
     /*  12134 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12272), // Rule ID 4991 //
     /*  12139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12190 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12198 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12202 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12206 */     // MIs[4] vA
     /*  12206 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12211 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12215 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12219 */     // MIs[5] vC
     /*  12219 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12224 */     // MIs[5] vB
     /*  12224 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12229 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12233 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12241 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12243 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12260 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12270 */     GIR_RootConstrainSelectedInstOperands,
     /*  12271 */     // GIR_Coverage, 4991,
     /*  12271 */     GIR_EraseRootFromParent_Done,
     /*  12272 */   // Label 312: @12272
     /*  12272 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12410), // Rule ID 4998 //
     /*  12277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12324 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12328 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12332 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12336 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12340 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12344 */     // MIs[4] vC
     /*  12344 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12349 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12353 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12357 */     // MIs[5] vA
     /*  12357 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12362 */     // MIs[5] vB
     /*  12362 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12367 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12371 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12379 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12381 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12398 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12408 */     GIR_RootConstrainSelectedInstOperands,
     /*  12409 */     // GIR_Coverage, 4998,
     /*  12409 */     GIR_EraseRootFromParent_Done,
     /*  12410 */   // Label 313: @12410
     /*  12410 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12548), // Rule ID 4999 //
     /*  12415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12466 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12478 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12482 */     // MIs[4] vC
     /*  12482 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12487 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12491 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12495 */     // MIs[5] vB
     /*  12495 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12500 */     // MIs[5] vA
     /*  12500 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12505 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12509 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12515 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12517 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12519 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12536 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12546 */     GIR_RootConstrainSelectedInstOperands,
     /*  12547 */     // GIR_Coverage, 4999,
     /*  12547 */     GIR_EraseRootFromParent_Done,
     /*  12548 */   // Label 314: @12548
     /*  12548 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12686), // Rule ID 5000 //
     /*  12553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12604 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12616 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12620 */     // MIs[4] vB
     /*  12620 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12625 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12629 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12633 */     // MIs[5] vA
     /*  12633 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12638 */     // MIs[5] vC
     /*  12638 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12643 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12647 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12653 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12655 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12657 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12674 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12684 */     GIR_RootConstrainSelectedInstOperands,
     /*  12685 */     // GIR_Coverage, 5000,
     /*  12685 */     GIR_EraseRootFromParent_Done,
     /*  12686 */   // Label 315: @12686
     /*  12686 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12824), // Rule ID 5001 //
     /*  12691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12742 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12746 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12750 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12754 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12758 */     // MIs[4] vB
     /*  12758 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12763 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12767 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12771 */     // MIs[5] vC
     /*  12771 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12776 */     // MIs[5] vA
     /*  12776 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12781 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12785 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12791 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12793 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12795 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12812 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12822 */     GIR_RootConstrainSelectedInstOperands,
     /*  12823 */     // GIR_Coverage, 5001,
     /*  12823 */     GIR_EraseRootFromParent_Done,
     /*  12824 */   // Label 316: @12824
     /*  12824 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12962), // Rule ID 5002 //
     /*  12829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12880 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12884 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12888 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12892 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12896 */     // MIs[4] vA
     /*  12896 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12901 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12905 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12909 */     // MIs[5] vB
     /*  12909 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12914 */     // MIs[5] vC
     /*  12914 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12919 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12923 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12931 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12933 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12950 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12960 */     GIR_RootConstrainSelectedInstOperands,
     /*  12961 */     // GIR_Coverage, 5002,
     /*  12961 */     GIR_EraseRootFromParent_Done,
     /*  12962 */   // Label 317: @12962
     /*  12962 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(13100), // Rule ID 5003 //
     /*  12967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13022 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13026 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13030 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13034 */     // MIs[4] vA
     /*  13034 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13039 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13043 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13047 */     // MIs[5] vC
     /*  13047 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13052 */     // MIs[5] vB
     /*  13052 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13057 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13061 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13067 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13069 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13071 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  13080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  13088 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13098 */     GIR_RootConstrainSelectedInstOperands,
     /*  13099 */     // GIR_Coverage, 5003,
     /*  13099 */     GIR_EraseRootFromParent_Done,
     /*  13100 */   // Label 318: @13100
     /*  13100 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(13238), // Rule ID 5010 //
     /*  13105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13156 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13160 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13164 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13168 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13172 */     // MIs[4] vC
     /*  13172 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13177 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13181 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13185 */     // MIs[5] vA
     /*  13185 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13190 */     // MIs[5] vB
     /*  13190 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13195 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13199 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13205 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13207 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13209 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13226 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13236 */     GIR_RootConstrainSelectedInstOperands,
     /*  13237 */     // GIR_Coverage, 5010,
     /*  13237 */     GIR_EraseRootFromParent_Done,
     /*  13238 */   // Label 319: @13238
     /*  13238 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13376), // Rule ID 5011 //
     /*  13243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13298 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13302 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13306 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13310 */     // MIs[4] vC
     /*  13310 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13315 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13319 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13323 */     // MIs[5] vB
     /*  13323 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13328 */     // MIs[5] vA
     /*  13328 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13333 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13337 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13343 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13345 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13347 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13364 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13374 */     GIR_RootConstrainSelectedInstOperands,
     /*  13375 */     // GIR_Coverage, 5011,
     /*  13375 */     GIR_EraseRootFromParent_Done,
     /*  13376 */   // Label 320: @13376
     /*  13376 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13514), // Rule ID 5012 //
     /*  13381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13428 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13432 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13440 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13444 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13448 */     // MIs[4] vB
     /*  13448 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13453 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13457 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13461 */     // MIs[5] vA
     /*  13461 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13466 */     // MIs[5] vC
     /*  13466 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13471 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13475 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13483 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13485 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13502 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13512 */     GIR_RootConstrainSelectedInstOperands,
     /*  13513 */     // GIR_Coverage, 5012,
     /*  13513 */     GIR_EraseRootFromParent_Done,
     /*  13514 */   // Label 321: @13514
     /*  13514 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13652), // Rule ID 5013 //
     /*  13519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13566 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13570 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13574 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13578 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13582 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13586 */     // MIs[4] vB
     /*  13586 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13591 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13595 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13599 */     // MIs[5] vC
     /*  13599 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13604 */     // MIs[5] vA
     /*  13604 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13609 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13613 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13619 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13621 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13623 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13640 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13650 */     GIR_RootConstrainSelectedInstOperands,
     /*  13651 */     // GIR_Coverage, 5013,
     /*  13651 */     GIR_EraseRootFromParent_Done,
     /*  13652 */   // Label 322: @13652
     /*  13652 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13790), // Rule ID 5014 //
     /*  13657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13708 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13712 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13716 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13720 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13724 */     // MIs[4] vA
     /*  13724 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13729 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13733 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13737 */     // MIs[5] vB
     /*  13737 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13742 */     // MIs[5] vC
     /*  13742 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13747 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13751 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13757 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13759 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13761 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13778 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13788 */     GIR_RootConstrainSelectedInstOperands,
     /*  13789 */     // GIR_Coverage, 5014,
     /*  13789 */     GIR_EraseRootFromParent_Done,
     /*  13790 */   // Label 323: @13790
     /*  13790 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13928), // Rule ID 5015 //
     /*  13795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13842 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13846 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13850 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13854 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13858 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13862 */     // MIs[4] vA
     /*  13862 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13867 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13871 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13875 */     // MIs[5] vC
     /*  13875 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13880 */     // MIs[5] vB
     /*  13880 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13885 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13889 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13895 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13897 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13899 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13916 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13926 */     GIR_RootConstrainSelectedInstOperands,
     /*  13927 */     // GIR_Coverage, 5015,
     /*  13927 */     GIR_EraseRootFromParent_Done,
     /*  13928 */   // Label 324: @13928
     /*  13928 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(14066), // Rule ID 5022 //
     /*  13933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13984 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13996 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14000 */     // MIs[4] vC
     /*  14000 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14005 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14009 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14013 */     // MIs[5] vA
     /*  14013 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14018 */     // MIs[5] vB
     /*  14018 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14023 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14027 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14033 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14035 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14037 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14054 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14064 */     GIR_RootConstrainSelectedInstOperands,
     /*  14065 */     // GIR_Coverage, 5022,
     /*  14065 */     GIR_EraseRootFromParent_Done,
     /*  14066 */   // Label 325: @14066
     /*  14066 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(14204), // Rule ID 5023 //
     /*  14071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14118 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14126 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14130 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14134 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14138 */     // MIs[4] vC
     /*  14138 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14143 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14147 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14151 */     // MIs[5] vB
     /*  14151 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14156 */     // MIs[5] vA
     /*  14156 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14161 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14165 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14171 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14173 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14175 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14192 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14202 */     GIR_RootConstrainSelectedInstOperands,
     /*  14203 */     // GIR_Coverage, 5023,
     /*  14203 */     GIR_EraseRootFromParent_Done,
     /*  14204 */   // Label 326: @14204
     /*  14204 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(14342), // Rule ID 5024 //
     /*  14209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14260 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14268 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14272 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14276 */     // MIs[4] vB
     /*  14276 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14281 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14285 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14289 */     // MIs[5] vA
     /*  14289 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14294 */     // MIs[5] vC
     /*  14294 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14299 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14303 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14309 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14311 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14313 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14330 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14340 */     GIR_RootConstrainSelectedInstOperands,
     /*  14341 */     // GIR_Coverage, 5024,
     /*  14341 */     GIR_EraseRootFromParent_Done,
     /*  14342 */   // Label 327: @14342
     /*  14342 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(14480), // Rule ID 5025 //
     /*  14347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14394 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14398 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14402 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14406 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14410 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14414 */     // MIs[4] vB
     /*  14414 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14419 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14423 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14427 */     // MIs[5] vC
     /*  14427 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14432 */     // MIs[5] vA
     /*  14432 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14437 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14441 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14447 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14449 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14451 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14468 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14478 */     GIR_RootConstrainSelectedInstOperands,
     /*  14479 */     // GIR_Coverage, 5025,
     /*  14479 */     GIR_EraseRootFromParent_Done,
     /*  14480 */   // Label 328: @14480
     /*  14480 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(14618), // Rule ID 5026 //
     /*  14485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14540 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14544 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14548 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14552 */     // MIs[4] vA
     /*  14552 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14557 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14561 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14565 */     // MIs[5] vB
     /*  14565 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14570 */     // MIs[5] vC
     /*  14570 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14575 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14579 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14585 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14587 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14589 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14606 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14616 */     GIR_RootConstrainSelectedInstOperands,
     /*  14617 */     // GIR_Coverage, 5026,
     /*  14617 */     GIR_EraseRootFromParent_Done,
     /*  14618 */   // Label 329: @14618
     /*  14618 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(14756), // Rule ID 5027 //
     /*  14623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14686 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14690 */     // MIs[4] vA
     /*  14690 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14695 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14699 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14703 */     // MIs[5] vC
     /*  14703 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14708 */     // MIs[5] vB
     /*  14708 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14713 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14717 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14723 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14725 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14727 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14744 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14754 */     GIR_RootConstrainSelectedInstOperands,
     /*  14755 */     // GIR_Coverage, 5027,
     /*  14755 */     GIR_EraseRootFromParent_Done,
     /*  14756 */   // Label 330: @14756
     /*  14756 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14894), // Rule ID 5034 //
     /*  14761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14812 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14816 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14820 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14824 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14828 */     // MIs[4] vC
     /*  14828 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14833 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14837 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14841 */     // MIs[5] vA
     /*  14841 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14846 */     // MIs[5] vB
     /*  14846 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14851 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14855 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14861 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14863 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14865 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  14878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  14882 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14892 */     GIR_RootConstrainSelectedInstOperands,
     /*  14893 */     // GIR_Coverage, 5034,
     /*  14893 */     GIR_EraseRootFromParent_Done,
     /*  14894 */   // Label 331: @14894
     /*  14894 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15032), // Rule ID 5035 //
     /*  14899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14946 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14950 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14962 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14966 */     // MIs[4] vC
     /*  14966 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14971 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14975 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14979 */     // MIs[5] vB
     /*  14979 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14984 */     // MIs[5] vA
     /*  14984 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14989 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14993 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15001 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15003 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15020 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15030 */     GIR_RootConstrainSelectedInstOperands,
     /*  15031 */     // GIR_Coverage, 5035,
     /*  15031 */     GIR_EraseRootFromParent_Done,
     /*  15032 */   // Label 332: @15032
     /*  15032 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15170), // Rule ID 5036 //
     /*  15037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15088 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15092 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15096 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15100 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15104 */     // MIs[4] vB
     /*  15104 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15109 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15113 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15117 */     // MIs[5] vA
     /*  15117 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15122 */     // MIs[5] vC
     /*  15122 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15127 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15131 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15137 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15139 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15141 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15158 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15168 */     GIR_RootConstrainSelectedInstOperands,
     /*  15169 */     // GIR_Coverage, 5036,
     /*  15169 */     GIR_EraseRootFromParent_Done,
     /*  15170 */   // Label 333: @15170
     /*  15170 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(15308), // Rule ID 5037 //
     /*  15175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15222 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15226 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15234 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15238 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15242 */     // MIs[4] vB
     /*  15242 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15251 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15255 */     // MIs[5] vC
     /*  15255 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15260 */     // MIs[5] vA
     /*  15260 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15265 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15269 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15275 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15277 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15279 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15296 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15306 */     GIR_RootConstrainSelectedInstOperands,
     /*  15307 */     // GIR_Coverage, 5037,
     /*  15307 */     GIR_EraseRootFromParent_Done,
     /*  15308 */   // Label 334: @15308
     /*  15308 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(15446), // Rule ID 5038 //
     /*  15313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15360 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15372 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15376 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15380 */     // MIs[4] vA
     /*  15380 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15385 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15389 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15393 */     // MIs[5] vB
     /*  15393 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15398 */     // MIs[5] vC
     /*  15398 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15403 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15407 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15413 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15415 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15417 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15434 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15444 */     GIR_RootConstrainSelectedInstOperands,
     /*  15445 */     // GIR_Coverage, 5038,
     /*  15445 */     GIR_EraseRootFromParent_Done,
     /*  15446 */   // Label 335: @15446
     /*  15446 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(15584), // Rule ID 5039 //
     /*  15451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15498 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15502 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15506 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15510 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15514 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15518 */     // MIs[4] vA
     /*  15518 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15523 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15527 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15531 */     // MIs[5] vC
     /*  15531 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15536 */     // MIs[5] vB
     /*  15536 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15541 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15545 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15551 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15553 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15555 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15572 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15582 */     GIR_RootConstrainSelectedInstOperands,
     /*  15583 */     // GIR_Coverage, 5039,
     /*  15583 */     GIR_EraseRootFromParent_Done,
     /*  15584 */   // Label 336: @15584
     /*  15584 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(15722), // Rule ID 5040 //
     /*  15589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15636 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15648 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15652 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15656 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15660 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15664 */     // MIs[5] vA
     /*  15664 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15669 */     // MIs[5] vB
     /*  15669 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15674 */     // MIs[4] vC
     /*  15674 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15679 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15683 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15689 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15691 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15693 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15710 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15720 */     GIR_RootConstrainSelectedInstOperands,
     /*  15721 */     // GIR_Coverage, 5040,
     /*  15721 */     GIR_EraseRootFromParent_Done,
     /*  15722 */   // Label 337: @15722
     /*  15722 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(15860), // Rule ID 5041 //
     /*  15727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15774 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15778 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15782 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15786 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15790 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15794 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15798 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15802 */     // MIs[5] vB
     /*  15802 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15807 */     // MIs[5] vA
     /*  15807 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15812 */     // MIs[4] vC
     /*  15812 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15817 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15821 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15827 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15829 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15831 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15848 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15858 */     GIR_RootConstrainSelectedInstOperands,
     /*  15859 */     // GIR_Coverage, 5041,
     /*  15859 */     GIR_EraseRootFromParent_Done,
     /*  15860 */   // Label 338: @15860
     /*  15860 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(15998), // Rule ID 5042 //
     /*  15865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15912 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15916 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15920 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15924 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15928 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15932 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15936 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15940 */     // MIs[5] vA
     /*  15940 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15945 */     // MIs[5] vC
     /*  15945 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15950 */     // MIs[4] vB
     /*  15950 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15955 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15959 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15965 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15967 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15969 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15986 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15996 */     GIR_RootConstrainSelectedInstOperands,
     /*  15997 */     // GIR_Coverage, 5042,
     /*  15997 */     GIR_EraseRootFromParent_Done,
     /*  15998 */   // Label 339: @15998
     /*  15998 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(16136), // Rule ID 5043 //
     /*  16003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16066 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16070 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16074 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16078 */     // MIs[5] vC
     /*  16078 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16083 */     // MIs[5] vA
     /*  16083 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16088 */     // MIs[4] vB
     /*  16088 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16093 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16097 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16103 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16105 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16107 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16124 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16134 */     GIR_RootConstrainSelectedInstOperands,
     /*  16135 */     // GIR_Coverage, 5043,
     /*  16135 */     GIR_EraseRootFromParent_Done,
     /*  16136 */   // Label 340: @16136
     /*  16136 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(16274), // Rule ID 5044 //
     /*  16141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16188 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16192 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16200 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16204 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16208 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16212 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16216 */     // MIs[5] vB
     /*  16216 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16221 */     // MIs[5] vC
     /*  16221 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16226 */     // MIs[4] vA
     /*  16226 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16231 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16235 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16241 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16243 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16245 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16262 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16272 */     GIR_RootConstrainSelectedInstOperands,
     /*  16273 */     // GIR_Coverage, 5044,
     /*  16273 */     GIR_EraseRootFromParent_Done,
     /*  16274 */   // Label 341: @16274
     /*  16274 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(16412), // Rule ID 5045 //
     /*  16279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16330 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16338 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16342 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16346 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16350 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16354 */     // MIs[5] vC
     /*  16354 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16359 */     // MIs[5] vB
     /*  16359 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16364 */     // MIs[4] vA
     /*  16364 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16369 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16373 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16381 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16383 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16400 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16410 */     GIR_RootConstrainSelectedInstOperands,
     /*  16411 */     // GIR_Coverage, 5045,
     /*  16411 */     GIR_EraseRootFromParent_Done,
     /*  16412 */   // Label 342: @16412
     /*  16412 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(16550), // Rule ID 5052 //
     /*  16417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16464 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16468 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16484 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16488 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16492 */     // MIs[5] vA
     /*  16492 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16497 */     // MIs[5] vB
     /*  16497 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16502 */     // MIs[4] vC
     /*  16502 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16511 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16517 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16519 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16521 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16538 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16548 */     GIR_RootConstrainSelectedInstOperands,
     /*  16549 */     // GIR_Coverage, 5052,
     /*  16549 */     GIR_EraseRootFromParent_Done,
     /*  16550 */   // Label 343: @16550
     /*  16550 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(16688), // Rule ID 5053 //
     /*  16555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16606 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16610 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16614 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16618 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16622 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16626 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16630 */     // MIs[5] vB
     /*  16630 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16635 */     // MIs[5] vA
     /*  16635 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16640 */     // MIs[4] vC
     /*  16640 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16645 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16649 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16655 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16657 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16659 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16676 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16686 */     GIR_RootConstrainSelectedInstOperands,
     /*  16687 */     // GIR_Coverage, 5053,
     /*  16687 */     GIR_EraseRootFromParent_Done,
     /*  16688 */   // Label 344: @16688
     /*  16688 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(16826), // Rule ID 5054 //
     /*  16693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16740 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16744 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16748 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16752 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16756 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16760 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16764 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16768 */     // MIs[5] vA
     /*  16768 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16773 */     // MIs[5] vC
     /*  16773 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16778 */     // MIs[4] vB
     /*  16778 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16783 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16787 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16793 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16795 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16797 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16814 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16824 */     GIR_RootConstrainSelectedInstOperands,
     /*  16825 */     // GIR_Coverage, 5054,
     /*  16825 */     GIR_EraseRootFromParent_Done,
     /*  16826 */   // Label 345: @16826
     /*  16826 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(16964), // Rule ID 5055 //
     /*  16831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16878 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16882 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16886 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16890 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16894 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16898 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16902 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16906 */     // MIs[5] vC
     /*  16906 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16911 */     // MIs[5] vA
     /*  16911 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16916 */     // MIs[4] vB
     /*  16916 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16921 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16925 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16931 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16933 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16935 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16952 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16962 */     GIR_RootConstrainSelectedInstOperands,
     /*  16963 */     // GIR_Coverage, 5055,
     /*  16963 */     GIR_EraseRootFromParent_Done,
     /*  16964 */   // Label 346: @16964
     /*  16964 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(17102), // Rule ID 5056 //
     /*  16969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17016 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17020 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17024 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17028 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17032 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17036 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17040 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17044 */     // MIs[5] vB
     /*  17044 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17049 */     // MIs[5] vC
     /*  17049 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17054 */     // MIs[4] vA
     /*  17054 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17059 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17063 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17069 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17071 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17073 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17090 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17100 */     GIR_RootConstrainSelectedInstOperands,
     /*  17101 */     // GIR_Coverage, 5056,
     /*  17101 */     GIR_EraseRootFromParent_Done,
     /*  17102 */   // Label 347: @17102
     /*  17102 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17240), // Rule ID 5057 //
     /*  17107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17154 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17158 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17162 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17166 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17170 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17174 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17178 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17182 */     // MIs[5] vC
     /*  17182 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17187 */     // MIs[5] vB
     /*  17187 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17192 */     // MIs[4] vA
     /*  17192 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17197 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17201 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17207 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17209 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17211 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17228 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17238 */     GIR_RootConstrainSelectedInstOperands,
     /*  17239 */     // GIR_Coverage, 5057,
     /*  17239 */     GIR_EraseRootFromParent_Done,
     /*  17240 */   // Label 348: @17240
     /*  17240 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(17378), // Rule ID 5064 //
     /*  17245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17292 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17296 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17300 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17304 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17308 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17312 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17316 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17320 */     // MIs[5] vA
     /*  17320 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17325 */     // MIs[5] vB
     /*  17325 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17330 */     // MIs[4] vC
     /*  17330 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17335 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17339 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17345 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17347 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17349 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17366 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17376 */     GIR_RootConstrainSelectedInstOperands,
     /*  17377 */     // GIR_Coverage, 5064,
     /*  17377 */     GIR_EraseRootFromParent_Done,
     /*  17378 */   // Label 349: @17378
     /*  17378 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(17516), // Rule ID 5065 //
     /*  17383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17430 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17434 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17438 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17442 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17446 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17450 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17454 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17458 */     // MIs[5] vB
     /*  17458 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17463 */     // MIs[5] vA
     /*  17463 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17468 */     // MIs[4] vC
     /*  17468 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17473 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17477 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17483 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17485 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17487 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17504 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17514 */     GIR_RootConstrainSelectedInstOperands,
     /*  17515 */     // GIR_Coverage, 5065,
     /*  17515 */     GIR_EraseRootFromParent_Done,
     /*  17516 */   // Label 350: @17516
     /*  17516 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(17654), // Rule ID 5066 //
     /*  17521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17568 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17572 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17580 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17584 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17588 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17592 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17596 */     // MIs[5] vA
     /*  17596 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17601 */     // MIs[5] vC
     /*  17601 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17606 */     // MIs[4] vB
     /*  17606 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17611 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17615 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17621 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17623 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17625 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17642 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17652 */     GIR_RootConstrainSelectedInstOperands,
     /*  17653 */     // GIR_Coverage, 5066,
     /*  17653 */     GIR_EraseRootFromParent_Done,
     /*  17654 */   // Label 351: @17654
     /*  17654 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(17792), // Rule ID 5067 //
     /*  17659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17706 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17710 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17718 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17722 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17726 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17730 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17734 */     // MIs[5] vC
     /*  17734 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17739 */     // MIs[5] vA
     /*  17739 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17744 */     // MIs[4] vB
     /*  17744 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17749 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17753 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17759 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17761 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17763 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17780 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17790 */     GIR_RootConstrainSelectedInstOperands,
     /*  17791 */     // GIR_Coverage, 5067,
     /*  17791 */     GIR_EraseRootFromParent_Done,
     /*  17792 */   // Label 352: @17792
     /*  17792 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(17930), // Rule ID 5068 //
     /*  17797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17844 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17848 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17860 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17864 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17868 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17872 */     // MIs[5] vB
     /*  17872 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17877 */     // MIs[5] vC
     /*  17877 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17882 */     // MIs[4] vA
     /*  17882 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17887 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17891 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17897 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17899 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17901 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17918 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17928 */     GIR_RootConstrainSelectedInstOperands,
     /*  17929 */     // GIR_Coverage, 5068,
     /*  17929 */     GIR_EraseRootFromParent_Done,
     /*  17930 */   // Label 353: @17930
     /*  17930 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18068), // Rule ID 5069 //
     /*  17935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17982 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17986 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17990 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17994 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17998 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18002 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18006 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18010 */     // MIs[5] vC
     /*  18010 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18015 */     // MIs[5] vB
     /*  18015 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18020 */     // MIs[4] vA
     /*  18020 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18025 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18029 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18035 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18037 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18039 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  18048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  18056 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18066 */     GIR_RootConstrainSelectedInstOperands,
     /*  18067 */     // GIR_Coverage, 5069,
     /*  18067 */     GIR_EraseRootFromParent_Done,
     /*  18068 */   // Label 354: @18068
     /*  18068 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(18206), // Rule ID 5076 //
     /*  18073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18120 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18124 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18132 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18136 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18140 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18144 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18148 */     // MIs[5] vA
     /*  18148 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18153 */     // MIs[5] vB
     /*  18153 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18158 */     // MIs[4] vC
     /*  18158 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18163 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18167 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18175 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18177 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18194 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18204 */     GIR_RootConstrainSelectedInstOperands,
     /*  18205 */     // GIR_Coverage, 5076,
     /*  18205 */     GIR_EraseRootFromParent_Done,
     /*  18206 */   // Label 355: @18206
     /*  18206 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(18344), // Rule ID 5077 //
     /*  18211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18258 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18262 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18266 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18270 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18274 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18278 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18282 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18286 */     // MIs[5] vB
     /*  18286 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18291 */     // MIs[5] vA
     /*  18291 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18296 */     // MIs[4] vC
     /*  18296 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18301 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18305 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18311 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18313 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18315 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18332 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18342 */     GIR_RootConstrainSelectedInstOperands,
     /*  18343 */     // GIR_Coverage, 5077,
     /*  18343 */     GIR_EraseRootFromParent_Done,
     /*  18344 */   // Label 356: @18344
     /*  18344 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(18482), // Rule ID 5078 //
     /*  18349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18404 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18408 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18412 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18416 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18420 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18424 */     // MIs[5] vA
     /*  18424 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18429 */     // MIs[5] vC
     /*  18429 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18434 */     // MIs[4] vB
     /*  18434 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18439 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18443 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18451 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18453 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18470 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18480 */     GIR_RootConstrainSelectedInstOperands,
     /*  18481 */     // GIR_Coverage, 5078,
     /*  18481 */     GIR_EraseRootFromParent_Done,
     /*  18482 */   // Label 357: @18482
     /*  18482 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(18620), // Rule ID 5079 //
     /*  18487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18534 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18538 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18542 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18546 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18550 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18554 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18558 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18562 */     // MIs[5] vC
     /*  18562 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18567 */     // MIs[5] vA
     /*  18567 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18572 */     // MIs[4] vB
     /*  18572 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18577 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18581 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18587 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18589 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18591 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18608 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18618 */     GIR_RootConstrainSelectedInstOperands,
     /*  18619 */     // GIR_Coverage, 5079,
     /*  18619 */     GIR_EraseRootFromParent_Done,
     /*  18620 */   // Label 358: @18620
     /*  18620 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(18758), // Rule ID 5080 //
     /*  18625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18672 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18676 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18680 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18684 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18688 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18692 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18696 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18700 */     // MIs[5] vB
     /*  18700 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18705 */     // MIs[5] vC
     /*  18705 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18710 */     // MIs[4] vA
     /*  18710 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18715 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18719 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18725 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18727 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18729 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18746 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18756 */     GIR_RootConstrainSelectedInstOperands,
     /*  18757 */     // GIR_Coverage, 5080,
     /*  18757 */     GIR_EraseRootFromParent_Done,
     /*  18758 */   // Label 359: @18758
     /*  18758 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(18896), // Rule ID 5081 //
     /*  18763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18814 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18826 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18830 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18834 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18838 */     // MIs[5] vC
     /*  18838 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18843 */     // MIs[5] vB
     /*  18843 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18848 */     // MIs[4] vA
     /*  18848 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18853 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18857 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18863 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18865 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18867 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18884 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18894 */     GIR_RootConstrainSelectedInstOperands,
     /*  18895 */     // GIR_Coverage, 5081,
     /*  18895 */     GIR_EraseRootFromParent_Done,
     /*  18896 */   // Label 360: @18896
     /*  18896 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19034), // Rule ID 5088 //
     /*  18901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18948 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18952 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18956 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18960 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18964 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18968 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18972 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18976 */     // MIs[5] vA
     /*  18976 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18981 */     // MIs[5] vB
     /*  18981 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18986 */     // MIs[4] vC
     /*  18986 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18991 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18995 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19001 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19003 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19005 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19022 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19032 */     GIR_RootConstrainSelectedInstOperands,
     /*  19033 */     // GIR_Coverage, 5088,
     /*  19033 */     GIR_EraseRootFromParent_Done,
     /*  19034 */   // Label 361: @19034
     /*  19034 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19172), // Rule ID 5089 //
     /*  19039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19086 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19090 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19094 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19098 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19102 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19106 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19110 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19114 */     // MIs[5] vB
     /*  19114 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19119 */     // MIs[5] vA
     /*  19119 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19124 */     // MIs[4] vC
     /*  19124 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19129 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19133 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19139 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19141 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19143 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19160 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19170 */     GIR_RootConstrainSelectedInstOperands,
     /*  19171 */     // GIR_Coverage, 5089,
     /*  19171 */     GIR_EraseRootFromParent_Done,
     /*  19172 */   // Label 362: @19172
     /*  19172 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19310), // Rule ID 5090 //
     /*  19177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19224 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19228 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19236 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19240 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19244 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19248 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19252 */     // MIs[5] vA
     /*  19252 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19257 */     // MIs[5] vC
     /*  19257 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19262 */     // MIs[4] vB
     /*  19262 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19267 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19271 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19277 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19279 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19281 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19298 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19308 */     GIR_RootConstrainSelectedInstOperands,
     /*  19309 */     // GIR_Coverage, 5090,
     /*  19309 */     GIR_EraseRootFromParent_Done,
     /*  19310 */   // Label 363: @19310
     /*  19310 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19448), // Rule ID 5091 //
     /*  19315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19362 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19366 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19370 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19374 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19378 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19382 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19386 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19390 */     // MIs[5] vC
     /*  19390 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19395 */     // MIs[5] vA
     /*  19395 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19400 */     // MIs[4] vB
     /*  19400 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19405 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19409 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19417 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19419 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19436 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19446 */     GIR_RootConstrainSelectedInstOperands,
     /*  19447 */     // GIR_Coverage, 5091,
     /*  19447 */     GIR_EraseRootFromParent_Done,
     /*  19448 */   // Label 364: @19448
     /*  19448 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19586), // Rule ID 5092 //
     /*  19453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19500 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19504 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19508 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19512 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19516 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19520 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19524 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19528 */     // MIs[5] vB
     /*  19528 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19533 */     // MIs[5] vC
     /*  19533 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19538 */     // MIs[4] vA
     /*  19538 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19543 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19547 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19553 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19555 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19557 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19574 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19584 */     GIR_RootConstrainSelectedInstOperands,
     /*  19585 */     // GIR_Coverage, 5092,
     /*  19585 */     GIR_EraseRootFromParent_Done,
     /*  19586 */   // Label 365: @19586
     /*  19586 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19724), // Rule ID 5093 //
     /*  19591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19642 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19646 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19650 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19654 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19658 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19662 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19666 */     // MIs[5] vC
     /*  19666 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19671 */     // MIs[5] vB
     /*  19671 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19676 */     // MIs[4] vA
     /*  19676 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19681 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19685 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19691 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19693 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19695 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19712 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19722 */     GIR_RootConstrainSelectedInstOperands,
     /*  19723 */     // GIR_Coverage, 5093,
     /*  19723 */     GIR_EraseRootFromParent_Done,
     /*  19724 */   // Label 366: @19724
     /*  19724 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(19862), // Rule ID 5099 //
     /*  19729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19784 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19788 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19792 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19796 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19800 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19804 */     // MIs[5] vA
     /*  19804 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19809 */     // MIs[5] vB
     /*  19809 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19814 */     // MIs[4] vC
     /*  19814 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19819 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19823 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19829 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19831 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19833 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  19846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  19850 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19860 */     GIR_RootConstrainSelectedInstOperands,
     /*  19861 */     // GIR_Coverage, 5099,
     /*  19861 */     GIR_EraseRootFromParent_Done,
     /*  19862 */   // Label 367: @19862
     /*  19862 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20000), // Rule ID 5100 //
     /*  19867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19914 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19918 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19930 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19934 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19938 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19942 */     // MIs[5] vB
     /*  19942 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19947 */     // MIs[5] vA
     /*  19947 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19952 */     // MIs[4] vC
     /*  19952 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19957 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19961 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19969 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19971 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  19984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  19988 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19998 */     GIR_RootConstrainSelectedInstOperands,
     /*  19999 */     // GIR_Coverage, 5100,
     /*  19999 */     GIR_EraseRootFromParent_Done,
     /*  20000 */   // Label 368: @20000
     /*  20000 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20138), // Rule ID 5101 //
     /*  20005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20052 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20056 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20064 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20068 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20072 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20076 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20080 */     // MIs[5] vA
     /*  20080 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20085 */     // MIs[5] vC
     /*  20085 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20090 */     // MIs[4] vB
     /*  20090 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20095 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20099 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20105 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20107 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20109 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20126 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20136 */     GIR_RootConstrainSelectedInstOperands,
     /*  20137 */     // GIR_Coverage, 5101,
     /*  20137 */     GIR_EraseRootFromParent_Done,
     /*  20138 */   // Label 369: @20138
     /*  20138 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20276), // Rule ID 5102 //
     /*  20143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20194 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20206 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20214 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20218 */     // MIs[5] vC
     /*  20218 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20223 */     // MIs[5] vA
     /*  20223 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20228 */     // MIs[4] vB
     /*  20228 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20233 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20237 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20243 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20245 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20247 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20264 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20274 */     GIR_RootConstrainSelectedInstOperands,
     /*  20275 */     // GIR_Coverage, 5102,
     /*  20275 */     GIR_EraseRootFromParent_Done,
     /*  20276 */   // Label 370: @20276
     /*  20276 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20414), // Rule ID 5103 //
     /*  20281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20332 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20336 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20340 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20344 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20348 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20352 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20356 */     // MIs[5] vB
     /*  20356 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20361 */     // MIs[5] vC
     /*  20361 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20366 */     // MIs[4] vA
     /*  20366 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20371 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20375 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20381 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20383 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20385 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20402 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20412 */     GIR_RootConstrainSelectedInstOperands,
     /*  20413 */     // GIR_Coverage, 5103,
     /*  20413 */     GIR_EraseRootFromParent_Done,
     /*  20414 */   // Label 371: @20414
     /*  20414 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20552), // Rule ID 5104 //
     /*  20419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20470 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20474 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20478 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20482 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20486 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20490 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20494 */     // MIs[5] vC
     /*  20494 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20499 */     // MIs[5] vB
     /*  20499 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20504 */     // MIs[4] vA
     /*  20504 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20509 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20513 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20521 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20523 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20540 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20550 */     GIR_RootConstrainSelectedInstOperands,
     /*  20551 */     // GIR_Coverage, 5104,
     /*  20551 */     GIR_EraseRootFromParent_Done,
     /*  20552 */   // Label 372: @20552
     /*  20552 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20690), // Rule ID 3392 //
     /*  20557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20608 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20616 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20620 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20624 */     // MIs[4] vA
     /*  20624 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20629 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20633 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20637 */     // MIs[5] vB
     /*  20637 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20642 */     // MIs[5] vC
     /*  20642 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20647 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20651 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20657 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20659 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20661 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  20674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  20678 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20688 */     GIR_RootConstrainSelectedInstOperands,
     /*  20689 */     // GIR_Coverage, 3392,
     /*  20689 */     GIR_EraseRootFromParent_Done,
     /*  20690 */   // Label 373: @20690
     /*  20690 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(20828), // Rule ID 5046 //
     /*  20695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20742 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20746 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20754 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20758 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20762 */     // MIs[4] vC
     /*  20762 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20767 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20771 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20775 */     // MIs[5] vA
     /*  20775 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20780 */     // MIs[5] vB
     /*  20780 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20785 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20789 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20795 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20797 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20799 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20816 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20826 */     GIR_RootConstrainSelectedInstOperands,
     /*  20827 */     // GIR_Coverage, 5046,
     /*  20827 */     GIR_EraseRootFromParent_Done,
     /*  20828 */   // Label 374: @20828
     /*  20828 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(20966), // Rule ID 5047 //
     /*  20833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20880 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20884 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20892 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20896 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20900 */     // MIs[4] vC
     /*  20900 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20905 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20909 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20913 */     // MIs[5] vB
     /*  20913 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20918 */     // MIs[5] vA
     /*  20918 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20923 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20927 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20933 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20935 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20937 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20954 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20964 */     GIR_RootConstrainSelectedInstOperands,
     /*  20965 */     // GIR_Coverage, 5047,
     /*  20965 */     GIR_EraseRootFromParent_Done,
     /*  20966 */   // Label 375: @20966
     /*  20966 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21104), // Rule ID 5048 //
     /*  20971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21018 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21022 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21026 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21030 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21034 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21038 */     // MIs[4] vB
     /*  21038 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21043 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21047 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21051 */     // MIs[5] vA
     /*  21051 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21056 */     // MIs[5] vC
     /*  21056 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21061 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21065 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21071 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21073 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21075 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21092 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21102 */     GIR_RootConstrainSelectedInstOperands,
     /*  21103 */     // GIR_Coverage, 5048,
     /*  21103 */     GIR_EraseRootFromParent_Done,
     /*  21104 */   // Label 376: @21104
     /*  21104 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21242), // Rule ID 5049 //
     /*  21109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21168 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21172 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21176 */     // MIs[4] vB
     /*  21176 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21181 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21185 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21189 */     // MIs[5] vC
     /*  21189 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21194 */     // MIs[5] vA
     /*  21194 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21199 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21203 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21209 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21211 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21213 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21230 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21240 */     GIR_RootConstrainSelectedInstOperands,
     /*  21241 */     // GIR_Coverage, 5049,
     /*  21241 */     GIR_EraseRootFromParent_Done,
     /*  21242 */   // Label 377: @21242
     /*  21242 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21380), // Rule ID 5050 //
     /*  21247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21298 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21302 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21306 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21310 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21314 */     // MIs[4] vA
     /*  21314 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21319 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21323 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21327 */     // MIs[5] vB
     /*  21327 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21332 */     // MIs[5] vC
     /*  21332 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21337 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21341 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21347 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21349 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21351 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21368 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21378 */     GIR_RootConstrainSelectedInstOperands,
     /*  21379 */     // GIR_Coverage, 5050,
     /*  21379 */     GIR_EraseRootFromParent_Done,
     /*  21380 */   // Label 378: @21380
     /*  21380 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21518), // Rule ID 5051 //
     /*  21385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21432 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21436 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21448 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21452 */     // MIs[4] vA
     /*  21452 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21457 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21461 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21465 */     // MIs[5] vC
     /*  21465 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21470 */     // MIs[5] vB
     /*  21470 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21475 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21479 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21485 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21487 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21489 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21506 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21516 */     GIR_RootConstrainSelectedInstOperands,
     /*  21517 */     // GIR_Coverage, 5051,
     /*  21517 */     GIR_EraseRootFromParent_Done,
     /*  21518 */   // Label 379: @21518
     /*  21518 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21656), // Rule ID 5058 //
     /*  21523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21570 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21574 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21578 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21582 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21586 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21590 */     // MIs[4] vC
     /*  21590 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21595 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21599 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21603 */     // MIs[5] vA
     /*  21603 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21608 */     // MIs[5] vB
     /*  21608 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21617 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21623 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21625 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21627 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21644 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21654 */     GIR_RootConstrainSelectedInstOperands,
     /*  21655 */     // GIR_Coverage, 5058,
     /*  21655 */     GIR_EraseRootFromParent_Done,
     /*  21656 */   // Label 380: @21656
     /*  21656 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21794), // Rule ID 5059 //
     /*  21661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21708 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21712 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21716 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21720 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21724 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21728 */     // MIs[4] vC
     /*  21728 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21733 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21737 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21741 */     // MIs[5] vB
     /*  21741 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21746 */     // MIs[5] vA
     /*  21746 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21751 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21755 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21763 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21765 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21782 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21792 */     GIR_RootConstrainSelectedInstOperands,
     /*  21793 */     // GIR_Coverage, 5059,
     /*  21793 */     GIR_EraseRootFromParent_Done,
     /*  21794 */   // Label 381: @21794
     /*  21794 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21932), // Rule ID 5060 //
     /*  21799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21846 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21850 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21854 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21858 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21862 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21866 */     // MIs[4] vB
     /*  21866 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21871 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21875 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21879 */     // MIs[5] vA
     /*  21879 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21884 */     // MIs[5] vC
     /*  21884 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21889 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21893 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21901 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21903 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21920 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21930 */     GIR_RootConstrainSelectedInstOperands,
     /*  21931 */     // GIR_Coverage, 5060,
     /*  21931 */     GIR_EraseRootFromParent_Done,
     /*  21932 */   // Label 382: @21932
     /*  21932 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22070), // Rule ID 5061 //
     /*  21937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21984 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21988 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22000 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22004 */     // MIs[4] vB
     /*  22004 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22009 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22013 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22017 */     // MIs[5] vC
     /*  22017 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22022 */     // MIs[5] vA
     /*  22022 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22027 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22031 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22039 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22041 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22058 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22068 */     GIR_RootConstrainSelectedInstOperands,
     /*  22069 */     // GIR_Coverage, 5061,
     /*  22069 */     GIR_EraseRootFromParent_Done,
     /*  22070 */   // Label 383: @22070
     /*  22070 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22208), // Rule ID 5062 //
     /*  22075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22126 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22134 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22138 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22142 */     // MIs[4] vA
     /*  22142 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22147 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22151 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22155 */     // MIs[5] vB
     /*  22155 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22160 */     // MIs[5] vC
     /*  22160 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22165 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22169 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22175 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22177 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22179 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22196 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22206 */     GIR_RootConstrainSelectedInstOperands,
     /*  22207 */     // GIR_Coverage, 5062,
     /*  22207 */     GIR_EraseRootFromParent_Done,
     /*  22208 */   // Label 384: @22208
     /*  22208 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22346), // Rule ID 5063 //
     /*  22213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22264 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22272 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22276 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22280 */     // MIs[4] vA
     /*  22280 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22285 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22289 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22293 */     // MIs[5] vC
     /*  22293 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22298 */     // MIs[5] vB
     /*  22298 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22303 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22307 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22315 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22317 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22334 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22344 */     GIR_RootConstrainSelectedInstOperands,
     /*  22345 */     // GIR_Coverage, 5063,
     /*  22345 */     GIR_EraseRootFromParent_Done,
     /*  22346 */   // Label 385: @22346
     /*  22346 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22484), // Rule ID 5070 //
     /*  22351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22398 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22402 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22410 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22414 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22418 */     // MIs[4] vC
     /*  22418 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22423 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22427 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22431 */     // MIs[5] vA
     /*  22431 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22436 */     // MIs[5] vB
     /*  22436 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22441 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22445 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22451 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22453 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22455 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22472 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22482 */     GIR_RootConstrainSelectedInstOperands,
     /*  22483 */     // GIR_Coverage, 5070,
     /*  22483 */     GIR_EraseRootFromParent_Done,
     /*  22484 */   // Label 386: @22484
     /*  22484 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22622), // Rule ID 5071 //
     /*  22489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22540 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22552 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22556 */     // MIs[4] vC
     /*  22556 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22561 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22565 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22569 */     // MIs[5] vB
     /*  22569 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22574 */     // MIs[5] vA
     /*  22574 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22579 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22583 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22589 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22591 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22593 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22610 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22620 */     GIR_RootConstrainSelectedInstOperands,
     /*  22621 */     // GIR_Coverage, 5071,
     /*  22621 */     GIR_EraseRootFromParent_Done,
     /*  22622 */   // Label 387: @22622
     /*  22622 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22760), // Rule ID 5072 //
     /*  22627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22678 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22682 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22686 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22690 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22694 */     // MIs[4] vB
     /*  22694 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22699 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22703 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22707 */     // MIs[5] vA
     /*  22707 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22712 */     // MIs[5] vC
     /*  22712 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22717 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22721 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22729 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22731 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22748 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22758 */     GIR_RootConstrainSelectedInstOperands,
     /*  22759 */     // GIR_Coverage, 5072,
     /*  22759 */     GIR_EraseRootFromParent_Done,
     /*  22760 */   // Label 388: @22760
     /*  22760 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22898), // Rule ID 5073 //
     /*  22765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22816 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22824 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22828 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22832 */     // MIs[4] vB
     /*  22832 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22837 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22841 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22845 */     // MIs[5] vC
     /*  22845 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22850 */     // MIs[5] vA
     /*  22850 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22855 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22859 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22867 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22869 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22886 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22896 */     GIR_RootConstrainSelectedInstOperands,
     /*  22897 */     // GIR_Coverage, 5073,
     /*  22897 */     GIR_EraseRootFromParent_Done,
     /*  22898 */   // Label 389: @22898
     /*  22898 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23036), // Rule ID 5074 //
     /*  22903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22950 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22954 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22958 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22962 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22966 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22970 */     // MIs[4] vA
     /*  22970 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22975 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22979 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22983 */     // MIs[5] vB
     /*  22983 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22988 */     // MIs[5] vC
     /*  22988 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22993 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22997 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23003 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23005 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23007 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23024 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23034 */     GIR_RootConstrainSelectedInstOperands,
     /*  23035 */     // GIR_Coverage, 5074,
     /*  23035 */     GIR_EraseRootFromParent_Done,
     /*  23036 */   // Label 390: @23036
     /*  23036 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23174), // Rule ID 5075 //
     /*  23041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23088 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23092 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23096 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23100 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23104 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23108 */     // MIs[4] vA
     /*  23108 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23113 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23117 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23121 */     // MIs[5] vC
     /*  23121 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23126 */     // MIs[5] vB
     /*  23126 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23131 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23135 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23145 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23162 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23172 */     GIR_RootConstrainSelectedInstOperands,
     /*  23173 */     // GIR_Coverage, 5075,
     /*  23173 */     GIR_EraseRootFromParent_Done,
     /*  23174 */   // Label 391: @23174
     /*  23174 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23312), // Rule ID 5082 //
     /*  23179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23242 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23246 */     // MIs[4] vC
     /*  23246 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23251 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23255 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23259 */     // MIs[5] vA
     /*  23259 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23264 */     // MIs[5] vB
     /*  23264 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23269 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23273 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23281 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23283 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23300 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23310 */     GIR_RootConstrainSelectedInstOperands,
     /*  23311 */     // GIR_Coverage, 5082,
     /*  23311 */     GIR_EraseRootFromParent_Done,
     /*  23312 */   // Label 392: @23312
     /*  23312 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23450), // Rule ID 5083 //
     /*  23317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23372 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23376 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23380 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23384 */     // MIs[4] vC
     /*  23384 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23389 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23393 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23397 */     // MIs[5] vB
     /*  23397 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23402 */     // MIs[5] vA
     /*  23402 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23407 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23411 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23417 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23419 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23421 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23438 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23448 */     GIR_RootConstrainSelectedInstOperands,
     /*  23449 */     // GIR_Coverage, 5083,
     /*  23449 */     GIR_EraseRootFromParent_Done,
     /*  23450 */   // Label 393: @23450
     /*  23450 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23588), // Rule ID 5084 //
     /*  23455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23510 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23514 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23518 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23522 */     // MIs[4] vB
     /*  23522 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23527 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23531 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23535 */     // MIs[5] vA
     /*  23535 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23540 */     // MIs[5] vC
     /*  23540 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23545 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23549 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23557 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23559 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23576 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23586 */     GIR_RootConstrainSelectedInstOperands,
     /*  23587 */     // GIR_Coverage, 5084,
     /*  23587 */     GIR_EraseRootFromParent_Done,
     /*  23588 */   // Label 394: @23588
     /*  23588 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23726), // Rule ID 5085 //
     /*  23593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23640 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23644 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23648 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23652 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23656 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23660 */     // MIs[4] vB
     /*  23660 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23665 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23669 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23673 */     // MIs[5] vC
     /*  23673 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23678 */     // MIs[5] vA
     /*  23678 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23683 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23687 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23693 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23695 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23697 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23714 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23724 */     GIR_RootConstrainSelectedInstOperands,
     /*  23725 */     // GIR_Coverage, 5085,
     /*  23725 */     GIR_EraseRootFromParent_Done,
     /*  23726 */   // Label 395: @23726
     /*  23726 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23864), // Rule ID 5086 //
     /*  23731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23778 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23782 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23794 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23798 */     // MIs[4] vA
     /*  23798 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23803 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23807 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23811 */     // MIs[5] vB
     /*  23811 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23816 */     // MIs[5] vC
     /*  23816 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23821 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23825 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23831 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23833 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23835 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23852 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23862 */     GIR_RootConstrainSelectedInstOperands,
     /*  23863 */     // GIR_Coverage, 5086,
     /*  23863 */     GIR_EraseRootFromParent_Done,
     /*  23864 */   // Label 396: @23864
     /*  23864 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24002), // Rule ID 5087 //
     /*  23869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23916 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23920 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23932 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23936 */     // MIs[4] vA
     /*  23936 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23941 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23945 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23949 */     // MIs[5] vC
     /*  23949 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23954 */     // MIs[5] vB
     /*  23954 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23959 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23963 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23969 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23971 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23973 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23990 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24000 */     GIR_RootConstrainSelectedInstOperands,
     /*  24001 */     // GIR_Coverage, 5087,
     /*  24001 */     GIR_EraseRootFromParent_Done,
     /*  24002 */   // Label 397: @24002
     /*  24002 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24140), // Rule ID 5094 //
     /*  24007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24058 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24062 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24066 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24070 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24074 */     // MIs[4] vC
     /*  24074 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24079 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24083 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24087 */     // MIs[5] vA
     /*  24087 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24092 */     // MIs[5] vB
     /*  24092 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24097 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24101 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24107 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24109 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24111 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24128 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24138 */     GIR_RootConstrainSelectedInstOperands,
     /*  24139 */     // GIR_Coverage, 5094,
     /*  24139 */     GIR_EraseRootFromParent_Done,
     /*  24140 */   // Label 398: @24140
     /*  24140 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24278), // Rule ID 5095 //
     /*  24145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24192 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24196 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24208 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24212 */     // MIs[4] vC
     /*  24212 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24217 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24221 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24225 */     // MIs[5] vB
     /*  24225 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24230 */     // MIs[5] vA
     /*  24230 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24235 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24239 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24247 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24249 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24266 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24276 */     GIR_RootConstrainSelectedInstOperands,
     /*  24277 */     // GIR_Coverage, 5095,
     /*  24277 */     GIR_EraseRootFromParent_Done,
     /*  24278 */   // Label 399: @24278
     /*  24278 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24416), // Rule ID 5096 //
     /*  24283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24334 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24346 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24350 */     // MIs[4] vB
     /*  24350 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24355 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24359 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24363 */     // MIs[5] vA
     /*  24363 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24368 */     // MIs[5] vC
     /*  24368 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24373 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24377 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24383 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24385 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24387 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24404 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24414 */     GIR_RootConstrainSelectedInstOperands,
     /*  24415 */     // GIR_Coverage, 5096,
     /*  24415 */     GIR_EraseRootFromParent_Done,
     /*  24416 */   // Label 400: @24416
     /*  24416 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24554), // Rule ID 5097 //
     /*  24421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24472 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24476 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24480 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24488 */     // MIs[4] vB
     /*  24488 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24493 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24497 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24501 */     // MIs[5] vC
     /*  24501 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24506 */     // MIs[5] vA
     /*  24506 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24511 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24515 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24521 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24523 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24525 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24542 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24552 */     GIR_RootConstrainSelectedInstOperands,
     /*  24553 */     // GIR_Coverage, 5097,
     /*  24553 */     GIR_EraseRootFromParent_Done,
     /*  24554 */   // Label 401: @24554
     /*  24554 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24692), // Rule ID 5098 //
     /*  24559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24610 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24622 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24626 */     // MIs[4] vA
     /*  24626 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24631 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24635 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24639 */     // MIs[5] vC
     /*  24639 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24644 */     // MIs[5] vB
     /*  24644 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24649 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24653 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24659 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24661 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24663 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24680 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24690 */     GIR_RootConstrainSelectedInstOperands,
     /*  24691 */     // GIR_Coverage, 5098,
     /*  24691 */     GIR_EraseRootFromParent_Done,
     /*  24692 */   // Label 402: @24692
     /*  24692 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24830), // Rule ID 5105 //
     /*  24697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24744 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24748 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24756 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24760 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24764 */     // MIs[4] vC
     /*  24764 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24769 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24773 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24777 */     // MIs[5] vA
     /*  24777 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24782 */     // MIs[5] vB
     /*  24782 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24787 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24791 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24797 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24799 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24801 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24818 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24828 */     GIR_RootConstrainSelectedInstOperands,
     /*  24829 */     // GIR_Coverage, 5105,
     /*  24829 */     GIR_EraseRootFromParent_Done,
     /*  24830 */   // Label 403: @24830
     /*  24830 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24968), // Rule ID 5106 //
     /*  24835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24886 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24898 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24902 */     // MIs[4] vC
     /*  24902 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24907 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24911 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24915 */     // MIs[5] vB
     /*  24915 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24920 */     // MIs[5] vA
     /*  24920 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24925 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24929 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24937 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24939 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24956 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24966 */     GIR_RootConstrainSelectedInstOperands,
     /*  24967 */     // GIR_Coverage, 5106,
     /*  24967 */     GIR_EraseRootFromParent_Done,
     /*  24968 */   // Label 404: @24968
     /*  24968 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(25106), // Rule ID 5107 //
     /*  24973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25028 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25032 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25036 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25040 */     // MIs[4] vB
     /*  25040 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25045 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25049 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25053 */     // MIs[5] vA
     /*  25053 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25058 */     // MIs[5] vC
     /*  25058 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25063 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25067 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25075 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25077 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25104 */     GIR_RootConstrainSelectedInstOperands,
     /*  25105 */     // GIR_Coverage, 5107,
     /*  25105 */     GIR_EraseRootFromParent_Done,
     /*  25106 */   // Label 405: @25106
     /*  25106 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(25244), // Rule ID 5108 //
     /*  25111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25162 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25174 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25178 */     // MIs[4] vB
     /*  25178 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25183 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25187 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25191 */     // MIs[5] vC
     /*  25191 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25196 */     // MIs[5] vA
     /*  25196 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25201 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25205 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25213 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25215 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25232 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25242 */     GIR_RootConstrainSelectedInstOperands,
     /*  25243 */     // GIR_Coverage, 5108,
     /*  25243 */     GIR_EraseRootFromParent_Done,
     /*  25244 */   // Label 406: @25244
     /*  25244 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(25382), // Rule ID 5109 //
     /*  25249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25296 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25300 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25304 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25308 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25312 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25316 */     // MIs[4] vA
     /*  25316 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25321 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25325 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25329 */     // MIs[5] vB
     /*  25329 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25334 */     // MIs[5] vC
     /*  25334 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25339 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25343 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25349 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25351 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25353 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25370 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25380 */     GIR_RootConstrainSelectedInstOperands,
     /*  25381 */     // GIR_Coverage, 5109,
     /*  25381 */     GIR_EraseRootFromParent_Done,
     /*  25382 */   // Label 407: @25382
     /*  25382 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(25520), // Rule ID 5110 //
     /*  25387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25434 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25438 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25450 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25454 */     // MIs[4] vA
     /*  25454 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25459 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25463 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25467 */     // MIs[5] vC
     /*  25467 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25472 */     // MIs[5] vB
     /*  25472 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25477 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25481 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25487 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25489 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25491 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25508 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25518 */     GIR_RootConstrainSelectedInstOperands,
     /*  25519 */     // GIR_Coverage, 5110,
     /*  25519 */     GIR_EraseRootFromParent_Done,
     /*  25520 */   // Label 408: @25520
     /*  25520 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(25658), // Rule ID 5111 //
     /*  25525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25576 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25584 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25592 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25596 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25600 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25604 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25608 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25612 */     // MIs[6] vA
     /*  25612 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25617 */     // MIs[6] vB
     /*  25617 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25622 */     // MIs[5] vC
     /*  25622 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25627 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25629 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25646 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25656 */     GIR_RootConstrainSelectedInstOperands,
     /*  25657 */     // GIR_Coverage, 5111,
     /*  25657 */     GIR_EraseRootFromParent_Done,
     /*  25658 */   // Label 409: @25658
     /*  25658 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(25796), // Rule ID 5112 //
     /*  25663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25714 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25718 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25722 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25728 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25730 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25734 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25738 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25742 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25746 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25750 */     // MIs[6] vB
     /*  25750 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25755 */     // MIs[6] vA
     /*  25755 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25760 */     // MIs[5] vC
     /*  25760 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25765 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25767 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25784 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25794 */     GIR_RootConstrainSelectedInstOperands,
     /*  25795 */     // GIR_Coverage, 5112,
     /*  25795 */     GIR_EraseRootFromParent_Done,
     /*  25796 */   // Label 410: @25796
     /*  25796 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25934), // Rule ID 5113 //
     /*  25801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25852 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25860 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25866 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25868 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25872 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25876 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25880 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25884 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25888 */     // MIs[6] vA
     /*  25888 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25893 */     // MIs[6] vC
     /*  25893 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25898 */     // MIs[5] vB
     /*  25898 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25903 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25905 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25922 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25932 */     GIR_RootConstrainSelectedInstOperands,
     /*  25933 */     // GIR_Coverage, 5113,
     /*  25933 */     GIR_EraseRootFromParent_Done,
     /*  25934 */   // Label 411: @25934
     /*  25934 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(26072), // Rule ID 5114 //
     /*  25939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25986 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25990 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25994 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25998 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26004 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26006 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26010 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26014 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26018 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26022 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26026 */     // MIs[6] vC
     /*  26026 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26031 */     // MIs[6] vA
     /*  26031 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26036 */     // MIs[5] vB
     /*  26036 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26041 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26043 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26060 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26070 */     GIR_RootConstrainSelectedInstOperands,
     /*  26071 */     // GIR_Coverage, 5114,
     /*  26071 */     GIR_EraseRootFromParent_Done,
     /*  26072 */   // Label 412: @26072
     /*  26072 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(26210), // Rule ID 5115 //
     /*  26077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26136 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26142 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26144 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26148 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26152 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26156 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26160 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26164 */     // MIs[6] vB
     /*  26164 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26169 */     // MIs[6] vC
     /*  26169 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26174 */     // MIs[5] vA
     /*  26174 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26179 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26181 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26198 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26208 */     GIR_RootConstrainSelectedInstOperands,
     /*  26209 */     // GIR_Coverage, 5115,
     /*  26209 */     GIR_EraseRootFromParent_Done,
     /*  26210 */   // Label 413: @26210
     /*  26210 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(26348), // Rule ID 5116 //
     /*  26215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26270 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26274 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26282 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26286 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26290 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26294 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26298 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26302 */     // MIs[6] vC
     /*  26302 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26307 */     // MIs[6] vB
     /*  26307 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26312 */     // MIs[5] vA
     /*  26312 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26317 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26319 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26336 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26346 */     GIR_RootConstrainSelectedInstOperands,
     /*  26347 */     // GIR_Coverage, 5116,
     /*  26347 */     GIR_EraseRootFromParent_Done,
     /*  26348 */   // Label 414: @26348
     /*  26348 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(26486), // Rule ID 5123 //
     /*  26353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26412 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26420 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26424 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26428 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26432 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26436 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26440 */     // MIs[6] vA
     /*  26440 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26445 */     // MIs[6] vB
     /*  26445 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26450 */     // MIs[5] vC
     /*  26450 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26455 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26457 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26474 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26484 */     GIR_RootConstrainSelectedInstOperands,
     /*  26485 */     // GIR_Coverage, 5123,
     /*  26485 */     GIR_EraseRootFromParent_Done,
     /*  26486 */   // Label 415: @26486
     /*  26486 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(26624), // Rule ID 5124 //
     /*  26491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26538 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26542 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26546 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26550 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26556 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26558 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26562 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26566 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26570 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26574 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26578 */     // MIs[6] vB
     /*  26578 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26583 */     // MIs[6] vA
     /*  26583 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26588 */     // MIs[5] vC
     /*  26588 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26593 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26595 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26612 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26622 */     GIR_RootConstrainSelectedInstOperands,
     /*  26623 */     // GIR_Coverage, 5124,
     /*  26623 */     GIR_EraseRootFromParent_Done,
     /*  26624 */   // Label 416: @26624
     /*  26624 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(26762), // Rule ID 5125 //
     /*  26629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26680 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26688 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26694 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26696 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26700 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26704 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26708 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26712 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26716 */     // MIs[6] vA
     /*  26716 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26721 */     // MIs[6] vC
     /*  26721 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26726 */     // MIs[5] vB
     /*  26726 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26731 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26733 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26750 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26760 */     GIR_RootConstrainSelectedInstOperands,
     /*  26761 */     // GIR_Coverage, 5125,
     /*  26761 */     GIR_EraseRootFromParent_Done,
     /*  26762 */   // Label 417: @26762
     /*  26762 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(26900), // Rule ID 5126 //
     /*  26767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26818 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26822 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26826 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26834 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26838 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26842 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26846 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26850 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26854 */     // MIs[6] vC
     /*  26854 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26859 */     // MIs[6] vA
     /*  26859 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26864 */     // MIs[5] vB
     /*  26864 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26869 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26871 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26888 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26898 */     GIR_RootConstrainSelectedInstOperands,
     /*  26899 */     // GIR_Coverage, 5126,
     /*  26899 */     GIR_EraseRootFromParent_Done,
     /*  26900 */   // Label 418: @26900
     /*  26900 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(27038), // Rule ID 5127 //
     /*  26905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26952 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26956 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26964 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26972 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26976 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26980 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26984 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26988 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26992 */     // MIs[6] vB
     /*  26992 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26997 */     // MIs[6] vC
     /*  26997 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27002 */     // MIs[5] vA
     /*  27002 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27007 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27009 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27026 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27036 */     GIR_RootConstrainSelectedInstOperands,
     /*  27037 */     // GIR_Coverage, 5127,
     /*  27037 */     GIR_EraseRootFromParent_Done,
     /*  27038 */   // Label 419: @27038
     /*  27038 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(27176), // Rule ID 5128 //
     /*  27043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27094 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27102 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27110 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27114 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27118 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27122 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27126 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27130 */     // MIs[6] vC
     /*  27130 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27135 */     // MIs[6] vB
     /*  27135 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27140 */     // MIs[5] vA
     /*  27140 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27145 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27147 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27164 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27174 */     GIR_RootConstrainSelectedInstOperands,
     /*  27175 */     // GIR_Coverage, 5128,
     /*  27175 */     GIR_EraseRootFromParent_Done,
     /*  27176 */   // Label 420: @27176
     /*  27176 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(27314), // Rule ID 5135 //
     /*  27181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27228 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27232 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27236 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27240 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27246 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27248 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27252 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27256 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27260 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27264 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27268 */     // MIs[6] vA
     /*  27268 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27273 */     // MIs[6] vB
     /*  27273 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27278 */     // MIs[5] vC
     /*  27278 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27283 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27285 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27302 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27312 */     GIR_RootConstrainSelectedInstOperands,
     /*  27313 */     // GIR_Coverage, 5135,
     /*  27313 */     GIR_EraseRootFromParent_Done,
     /*  27314 */   // Label 421: @27314
     /*  27314 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(27452), // Rule ID 5136 //
     /*  27319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27366 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27370 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27374 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27378 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27386 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27390 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27394 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27398 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27402 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27406 */     // MIs[6] vB
     /*  27406 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27411 */     // MIs[6] vA
     /*  27411 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27416 */     // MIs[5] vC
     /*  27416 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27421 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27423 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27440 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27450 */     GIR_RootConstrainSelectedInstOperands,
     /*  27451 */     // GIR_Coverage, 5136,
     /*  27451 */     GIR_EraseRootFromParent_Done,
     /*  27452 */   // Label 422: @27452
     /*  27452 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(27590), // Rule ID 5137 //
     /*  27457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27516 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27524 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27528 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27532 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27536 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27540 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27544 */     // MIs[6] vA
     /*  27544 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27549 */     // MIs[6] vC
     /*  27549 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27554 */     // MIs[5] vB
     /*  27554 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27559 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27561 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27578 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27588 */     GIR_RootConstrainSelectedInstOperands,
     /*  27589 */     // GIR_Coverage, 5137,
     /*  27589 */     GIR_EraseRootFromParent_Done,
     /*  27590 */   // Label 423: @27590
     /*  27590 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(27728), // Rule ID 5138 //
     /*  27595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27642 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27646 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27654 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27660 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27662 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27666 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27670 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27674 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27678 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27682 */     // MIs[6] vC
     /*  27682 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27687 */     // MIs[6] vA
     /*  27687 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27692 */     // MIs[5] vB
     /*  27692 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27697 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27699 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27716 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27726 */     GIR_RootConstrainSelectedInstOperands,
     /*  27727 */     // GIR_Coverage, 5138,
     /*  27727 */     GIR_EraseRootFromParent_Done,
     /*  27728 */   // Label 424: @27728
     /*  27728 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(27866), // Rule ID 5139 //
     /*  27733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27784 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27792 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27798 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27800 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27804 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27808 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27812 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27816 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27820 */     // MIs[6] vB
     /*  27820 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27825 */     // MIs[6] vC
     /*  27825 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27830 */     // MIs[5] vA
     /*  27830 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27835 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27837 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27854 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27864 */     GIR_RootConstrainSelectedInstOperands,
     /*  27865 */     // GIR_Coverage, 5139,
     /*  27865 */     GIR_EraseRootFromParent_Done,
     /*  27866 */   // Label 425: @27866
     /*  27866 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(28004), // Rule ID 5140 //
     /*  27871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27930 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27936 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27938 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27942 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27946 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27950 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27954 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27958 */     // MIs[6] vC
     /*  27958 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27963 */     // MIs[6] vB
     /*  27963 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27968 */     // MIs[5] vA
     /*  27968 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27973 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27975 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27992 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28002 */     GIR_RootConstrainSelectedInstOperands,
     /*  28003 */     // GIR_Coverage, 5140,
     /*  28003 */     GIR_EraseRootFromParent_Done,
     /*  28004 */   // Label 426: @28004
     /*  28004 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(28142), // Rule ID 5147 //
     /*  28009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28056 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28068 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28074 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28076 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28080 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28084 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28088 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28092 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28096 */     // MIs[6] vA
     /*  28096 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28101 */     // MIs[6] vB
     /*  28101 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28106 */     // MIs[5] vC
     /*  28106 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28111 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28113 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28130 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28140 */     GIR_RootConstrainSelectedInstOperands,
     /*  28141 */     // GIR_Coverage, 5147,
     /*  28141 */     GIR_EraseRootFromParent_Done,
     /*  28142 */   // Label 427: @28142
     /*  28142 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(28280), // Rule ID 5148 //
     /*  28147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28206 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28212 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28214 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28218 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28222 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28226 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28230 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28234 */     // MIs[6] vB
     /*  28234 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28239 */     // MIs[6] vA
     /*  28239 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28244 */     // MIs[5] vC
     /*  28244 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28249 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28251 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28268 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28278 */     GIR_RootConstrainSelectedInstOperands,
     /*  28279 */     // GIR_Coverage, 5148,
     /*  28279 */     GIR_EraseRootFromParent_Done,
     /*  28280 */   // Label 428: @28280
     /*  28280 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(28418), // Rule ID 5149 //
     /*  28285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28336 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28344 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28350 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28352 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28356 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28360 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28364 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28368 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28372 */     // MIs[6] vA
     /*  28372 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28377 */     // MIs[6] vC
     /*  28377 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28382 */     // MIs[5] vB
     /*  28382 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28387 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28389 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28406 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28416 */     GIR_RootConstrainSelectedInstOperands,
     /*  28417 */     // GIR_Coverage, 5149,
     /*  28417 */     GIR_EraseRootFromParent_Done,
     /*  28418 */   // Label 429: @28418
     /*  28418 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(28556), // Rule ID 5150 //
     /*  28423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28470 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28474 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28478 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28482 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28490 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28494 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28498 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28502 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28506 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28510 */     // MIs[6] vC
     /*  28510 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28515 */     // MIs[6] vA
     /*  28515 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28520 */     // MIs[5] vB
     /*  28520 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28525 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28527 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28544 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28554 */     GIR_RootConstrainSelectedInstOperands,
     /*  28555 */     // GIR_Coverage, 5150,
     /*  28555 */     GIR_EraseRootFromParent_Done,
     /*  28556 */   // Label 430: @28556
     /*  28556 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(28694), // Rule ID 5151 //
     /*  28561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28612 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28620 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28626 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28628 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28632 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28636 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28640 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28644 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28648 */     // MIs[6] vB
     /*  28648 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28653 */     // MIs[6] vC
     /*  28653 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28658 */     // MIs[5] vA
     /*  28658 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28663 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28665 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28682 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28692 */     GIR_RootConstrainSelectedInstOperands,
     /*  28693 */     // GIR_Coverage, 5151,
     /*  28693 */     GIR_EraseRootFromParent_Done,
     /*  28694 */   // Label 431: @28694
     /*  28694 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(28832), // Rule ID 5152 //
     /*  28699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28746 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28750 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28754 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28758 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28766 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28770 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28774 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28778 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28782 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28786 */     // MIs[6] vC
     /*  28786 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28791 */     // MIs[6] vB
     /*  28791 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28796 */     // MIs[5] vA
     /*  28796 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28801 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28803 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28820 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28830 */     GIR_RootConstrainSelectedInstOperands,
     /*  28831 */     // GIR_Coverage, 5152,
     /*  28831 */     GIR_EraseRootFromParent_Done,
     /*  28832 */   // Label 432: @28832
     /*  28832 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(28970), // Rule ID 5159 //
     /*  28837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28896 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28902 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28904 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28908 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28912 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28916 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28920 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28924 */     // MIs[6] vA
     /*  28924 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28929 */     // MIs[6] vB
     /*  28929 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28934 */     // MIs[5] vC
     /*  28934 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28939 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28941 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  28950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  28954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  28958 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28968 */     GIR_RootConstrainSelectedInstOperands,
     /*  28969 */     // GIR_Coverage, 5159,
     /*  28969 */     GIR_EraseRootFromParent_Done,
     /*  28970 */   // Label 433: @28970
     /*  28970 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(29108), // Rule ID 5160 //
     /*  28975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29022 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29026 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29034 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29042 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29046 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29050 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29054 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29058 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29062 */     // MIs[6] vB
     /*  29062 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29067 */     // MIs[6] vA
     /*  29067 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29072 */     // MIs[5] vC
     /*  29072 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29077 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29079 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29096 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29106 */     GIR_RootConstrainSelectedInstOperands,
     /*  29107 */     // GIR_Coverage, 5160,
     /*  29107 */     GIR_EraseRootFromParent_Done,
     /*  29108 */   // Label 434: @29108
     /*  29108 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(29246), // Rule ID 5161 //
     /*  29113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29160 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29164 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29168 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29172 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29178 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29180 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29184 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29188 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29192 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29196 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29200 */     // MIs[6] vA
     /*  29200 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29205 */     // MIs[6] vC
     /*  29205 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29210 */     // MIs[5] vB
     /*  29210 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29215 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29217 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29234 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29244 */     GIR_RootConstrainSelectedInstOperands,
     /*  29245 */     // GIR_Coverage, 5161,
     /*  29245 */     GIR_EraseRootFromParent_Done,
     /*  29246 */   // Label 435: @29246
     /*  29246 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(29384), // Rule ID 5162 //
     /*  29251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29298 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29302 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29318 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29322 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29326 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29330 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29334 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29338 */     // MIs[6] vC
     /*  29338 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29343 */     // MIs[6] vA
     /*  29343 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29348 */     // MIs[5] vB
     /*  29348 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29353 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29355 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29372 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29382 */     GIR_RootConstrainSelectedInstOperands,
     /*  29383 */     // GIR_Coverage, 5162,
     /*  29383 */     GIR_EraseRootFromParent_Done,
     /*  29384 */   // Label 436: @29384
     /*  29384 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(29522), // Rule ID 5163 //
     /*  29389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29440 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29448 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29454 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29456 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29460 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29464 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29468 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29472 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29476 */     // MIs[6] vB
     /*  29476 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29481 */     // MIs[6] vC
     /*  29481 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29486 */     // MIs[5] vA
     /*  29486 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29491 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29493 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29510 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29520 */     GIR_RootConstrainSelectedInstOperands,
     /*  29521 */     // GIR_Coverage, 5163,
     /*  29521 */     GIR_EraseRootFromParent_Done,
     /*  29522 */   // Label 437: @29522
     /*  29522 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(29660), // Rule ID 5164 //
     /*  29527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29574 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29578 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29582 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29586 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29592 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29594 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29598 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29602 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29606 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29610 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29614 */     // MIs[6] vC
     /*  29614 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29619 */     // MIs[6] vB
     /*  29619 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29624 */     // MIs[5] vA
     /*  29624 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29629 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29631 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29648 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29658 */     GIR_RootConstrainSelectedInstOperands,
     /*  29659 */     // GIR_Coverage, 5164,
     /*  29659 */     GIR_EraseRootFromParent_Done,
     /*  29660 */   // Label 438: @29660
     /*  29660 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(29798), // Rule ID 5171 //
     /*  29665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29712 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29716 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29724 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29730 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29732 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29736 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29740 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29748 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29752 */     // MIs[6] vA
     /*  29752 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29757 */     // MIs[6] vB
     /*  29757 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29762 */     // MIs[5] vC
     /*  29762 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29767 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29769 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29786 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29796 */     GIR_RootConstrainSelectedInstOperands,
     /*  29797 */     // GIR_Coverage, 5171,
     /*  29797 */     GIR_EraseRootFromParent_Done,
     /*  29798 */   // Label 439: @29798
     /*  29798 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(29936), // Rule ID 5172 //
     /*  29803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29850 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29854 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29858 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29862 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29868 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29870 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29874 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29878 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29882 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29886 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29890 */     // MIs[6] vB
     /*  29890 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29895 */     // MIs[6] vA
     /*  29895 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29900 */     // MIs[5] vC
     /*  29900 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29905 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29907 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29924 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29934 */     GIR_RootConstrainSelectedInstOperands,
     /*  29935 */     // GIR_Coverage, 5172,
     /*  29935 */     GIR_EraseRootFromParent_Done,
     /*  29936 */   // Label 440: @29936
     /*  29936 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(30074), // Rule ID 5173 //
     /*  29941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29992 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30000 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30006 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30008 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30012 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30016 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30020 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30024 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30028 */     // MIs[6] vA
     /*  30028 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30033 */     // MIs[6] vC
     /*  30033 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30038 */     // MIs[5] vB
     /*  30038 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30043 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30045 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30062 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30072 */     GIR_RootConstrainSelectedInstOperands,
     /*  30073 */     // GIR_Coverage, 5173,
     /*  30073 */     GIR_EraseRootFromParent_Done,
     /*  30074 */   // Label 441: @30074
     /*  30074 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(30212), // Rule ID 5174 //
     /*  30079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30126 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30130 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30138 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30144 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30146 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30150 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30154 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30158 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30162 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30166 */     // MIs[6] vC
     /*  30166 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30171 */     // MIs[6] vA
     /*  30171 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30176 */     // MIs[5] vB
     /*  30176 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30181 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30183 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30200 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30210 */     GIR_RootConstrainSelectedInstOperands,
     /*  30211 */     // GIR_Coverage, 5174,
     /*  30211 */     GIR_EraseRootFromParent_Done,
     /*  30212 */   // Label 442: @30212
     /*  30212 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(30350), // Rule ID 5175 //
     /*  30217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30264 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30268 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30272 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30276 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30282 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30284 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30288 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30292 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30296 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30300 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30304 */     // MIs[6] vB
     /*  30304 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30309 */     // MIs[6] vC
     /*  30309 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30314 */     // MIs[5] vA
     /*  30314 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30319 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30321 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30338 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30348 */     GIR_RootConstrainSelectedInstOperands,
     /*  30349 */     // GIR_Coverage, 5175,
     /*  30349 */     GIR_EraseRootFromParent_Done,
     /*  30350 */   // Label 443: @30350
     /*  30350 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(30488), // Rule ID 5176 //
     /*  30355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30410 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30414 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30422 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30426 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30430 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30434 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30438 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30442 */     // MIs[6] vC
     /*  30442 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30447 */     // MIs[6] vB
     /*  30447 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30452 */     // MIs[5] vA
     /*  30452 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30457 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30459 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30476 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30486 */     GIR_RootConstrainSelectedInstOperands,
     /*  30487 */     // GIR_Coverage, 5176,
     /*  30487 */     GIR_EraseRootFromParent_Done,
     /*  30488 */   // Label 444: @30488
     /*  30488 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(30626), // Rule ID 5117 //
     /*  30493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30540 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30544 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30548 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30552 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30558 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30560 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30564 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30568 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30572 */     // MIs[5] vC
     /*  30572 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30577 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30581 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30585 */     // MIs[6] vA
     /*  30585 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30590 */     // MIs[6] vB
     /*  30590 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30595 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30597 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30614 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30624 */     GIR_RootConstrainSelectedInstOperands,
     /*  30625 */     // GIR_Coverage, 5117,
     /*  30625 */     GIR_EraseRootFromParent_Done,
     /*  30626 */   // Label 445: @30626
     /*  30626 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(30764), // Rule ID 5118 //
     /*  30631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30682 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30686 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30690 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30696 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30698 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30702 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30706 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30710 */     // MIs[5] vC
     /*  30710 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30715 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30719 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30723 */     // MIs[6] vB
     /*  30723 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30728 */     // MIs[6] vA
     /*  30728 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30733 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30735 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30752 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30762 */     GIR_RootConstrainSelectedInstOperands,
     /*  30763 */     // GIR_Coverage, 5118,
     /*  30763 */     GIR_EraseRootFromParent_Done,
     /*  30764 */   // Label 446: @30764
     /*  30764 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(30902), // Rule ID 5119 //
     /*  30769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30816 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30820 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30824 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30828 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30836 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30840 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30844 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30848 */     // MIs[5] vB
     /*  30848 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30853 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30857 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30861 */     // MIs[6] vA
     /*  30861 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30866 */     // MIs[6] vC
     /*  30866 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30871 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30873 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30890 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30900 */     GIR_RootConstrainSelectedInstOperands,
     /*  30901 */     // GIR_Coverage, 5119,
     /*  30901 */     GIR_EraseRootFromParent_Done,
     /*  30902 */   // Label 447: @30902
     /*  30902 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(31040), // Rule ID 5120 //
     /*  30907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30966 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30974 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30978 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30982 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30986 */     // MIs[5] vB
     /*  30986 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30991 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30995 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30999 */     // MIs[6] vC
     /*  30999 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31004 */     // MIs[6] vA
     /*  31004 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31009 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31011 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31028 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31038 */     GIR_RootConstrainSelectedInstOperands,
     /*  31039 */     // GIR_Coverage, 5120,
     /*  31039 */     GIR_EraseRootFromParent_Done,
     /*  31040 */   // Label 448: @31040
     /*  31040 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(31178), // Rule ID 5121 //
     /*  31045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31092 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31096 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31100 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31104 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31110 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31112 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31116 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31120 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31124 */     // MIs[5] vA
     /*  31124 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31129 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31133 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31137 */     // MIs[6] vB
     /*  31137 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31142 */     // MIs[6] vC
     /*  31142 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31147 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31149 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31166 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31176 */     GIR_RootConstrainSelectedInstOperands,
     /*  31177 */     // GIR_Coverage, 5121,
     /*  31177 */     GIR_EraseRootFromParent_Done,
     /*  31178 */   // Label 449: @31178
     /*  31178 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(31316), // Rule ID 5122 //
     /*  31183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31234 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31238 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31242 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31248 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31250 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31254 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31258 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31262 */     // MIs[5] vA
     /*  31262 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31267 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31271 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31275 */     // MIs[6] vC
     /*  31275 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31280 */     // MIs[6] vB
     /*  31280 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31285 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31287 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31304 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31314 */     GIR_RootConstrainSelectedInstOperands,
     /*  31315 */     // GIR_Coverage, 5122,
     /*  31315 */     GIR_EraseRootFromParent_Done,
     /*  31316 */   // Label 450: @31316
     /*  31316 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(31454), // Rule ID 5129 //
     /*  31321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31380 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31388 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31392 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31396 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31400 */     // MIs[5] vC
     /*  31400 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31405 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31409 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31413 */     // MIs[6] vA
     /*  31413 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31418 */     // MIs[6] vB
     /*  31418 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31423 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31425 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31442 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31452 */     GIR_RootConstrainSelectedInstOperands,
     /*  31453 */     // GIR_Coverage, 5129,
     /*  31453 */     GIR_EraseRootFromParent_Done,
     /*  31454 */   // Label 451: @31454
     /*  31454 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(31592), // Rule ID 5130 //
     /*  31459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31506 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31510 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31514 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31518 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31524 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31526 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31530 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31534 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31538 */     // MIs[5] vC
     /*  31538 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31543 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31547 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31551 */     // MIs[6] vB
     /*  31551 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31556 */     // MIs[6] vA
     /*  31556 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31561 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31563 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31580 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31590 */     GIR_RootConstrainSelectedInstOperands,
     /*  31591 */     // GIR_Coverage, 5130,
     /*  31591 */     GIR_EraseRootFromParent_Done,
     /*  31592 */   // Label 452: @31592
     /*  31592 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(31730), // Rule ID 5131 //
     /*  31597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31644 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31648 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31656 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31664 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31668 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31672 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31676 */     // MIs[5] vB
     /*  31676 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31681 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31685 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31689 */     // MIs[6] vA
     /*  31689 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31694 */     // MIs[6] vC
     /*  31694 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31699 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31701 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31718 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31728 */     GIR_RootConstrainSelectedInstOperands,
     /*  31729 */     // GIR_Coverage, 5131,
     /*  31729 */     GIR_EraseRootFromParent_Done,
     /*  31730 */   // Label 453: @31730
     /*  31730 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(31868), // Rule ID 5132 //
     /*  31735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31782 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31786 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31790 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31794 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31802 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31806 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31810 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31814 */     // MIs[5] vB
     /*  31814 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31819 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31823 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31827 */     // MIs[6] vC
     /*  31827 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31832 */     // MIs[6] vA
     /*  31832 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31837 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31839 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31856 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31866 */     GIR_RootConstrainSelectedInstOperands,
     /*  31867 */     // GIR_Coverage, 5132,
     /*  31867 */     GIR_EraseRootFromParent_Done,
     /*  31868 */   // Label 454: @31868
     /*  31868 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(32006), // Rule ID 5133 //
     /*  31873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31928 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31932 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31940 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31944 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31948 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31952 */     // MIs[5] vA
     /*  31952 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31957 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31961 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31965 */     // MIs[6] vB
     /*  31965 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31970 */     // MIs[6] vC
     /*  31970 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31975 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31977 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31994 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32004 */     GIR_RootConstrainSelectedInstOperands,
     /*  32005 */     // GIR_Coverage, 5133,
     /*  32005 */     GIR_EraseRootFromParent_Done,
     /*  32006 */   // Label 455: @32006
     /*  32006 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(32144), // Rule ID 5134 //
     /*  32011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32058 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32066 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32070 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32076 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32078 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32082 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32086 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32090 */     // MIs[5] vA
     /*  32090 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32095 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32099 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32103 */     // MIs[6] vC
     /*  32103 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32108 */     // MIs[6] vB
     /*  32108 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32113 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32115 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  32124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  32128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  32132 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32142 */     GIR_RootConstrainSelectedInstOperands,
     /*  32143 */     // GIR_Coverage, 5134,
     /*  32143 */     GIR_EraseRootFromParent_Done,
     /*  32144 */   // Label 456: @32144
     /*  32144 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(32282), // Rule ID 5141 //
     /*  32149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32200 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32204 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32208 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32214 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32216 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32220 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32224 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32228 */     // MIs[5] vC
     /*  32228 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32233 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32237 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32241 */     // MIs[6] vA
     /*  32241 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32246 */     // MIs[6] vB
     /*  32246 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32251 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32253 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32270 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32280 */     GIR_RootConstrainSelectedInstOperands,
     /*  32281 */     // GIR_Coverage, 5141,
     /*  32281 */     GIR_EraseRootFromParent_Done,
     /*  32282 */   // Label 457: @32282
     /*  32282 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(32420), // Rule ID 5142 //
     /*  32287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32334 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32338 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32342 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32346 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32352 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32354 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32358 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32362 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32366 */     // MIs[5] vC
     /*  32366 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32371 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32375 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32379 */     // MIs[6] vB
     /*  32379 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32384 */     // MIs[6] vA
     /*  32384 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32389 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32391 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32408 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32418 */     GIR_RootConstrainSelectedInstOperands,
     /*  32419 */     // GIR_Coverage, 5142,
     /*  32419 */     GIR_EraseRootFromParent_Done,
     /*  32420 */   // Label 458: @32420
     /*  32420 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(32558), // Rule ID 5143 //
     /*  32425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32472 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32476 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32484 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32490 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32492 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32496 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32500 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32504 */     // MIs[5] vB
     /*  32504 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32509 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32513 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32517 */     // MIs[6] vA
     /*  32517 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32522 */     // MIs[6] vC
     /*  32522 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32527 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32529 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32546 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32556 */     GIR_RootConstrainSelectedInstOperands,
     /*  32557 */     // GIR_Coverage, 5143,
     /*  32557 */     GIR_EraseRootFromParent_Done,
     /*  32558 */   // Label 459: @32558
     /*  32558 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(32696), // Rule ID 5144 //
     /*  32563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32610 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32614 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32622 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32630 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32634 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32638 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32642 */     // MIs[5] vB
     /*  32642 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32647 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32651 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32655 */     // MIs[6] vC
     /*  32655 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32660 */     // MIs[6] vA
     /*  32660 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32665 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32667 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32684 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32694 */     GIR_RootConstrainSelectedInstOperands,
     /*  32695 */     // GIR_Coverage, 5144,
     /*  32695 */     GIR_EraseRootFromParent_Done,
     /*  32696 */   // Label 460: @32696
     /*  32696 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(32834), // Rule ID 5145 //
     /*  32701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32748 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32756 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32760 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32766 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32768 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32772 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32776 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32780 */     // MIs[5] vA
     /*  32780 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32785 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32789 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32793 */     // MIs[6] vB
     /*  32793 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32798 */     // MIs[6] vC
     /*  32798 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32803 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32805 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32822 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32832 */     GIR_RootConstrainSelectedInstOperands,
     /*  32833 */     // GIR_Coverage, 5145,
     /*  32833 */     GIR_EraseRootFromParent_Done,
     /*  32834 */   // Label 461: @32834
     /*  32834 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(32972), // Rule ID 5146 //
     /*  32839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32886 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32890 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32898 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32906 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32910 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32914 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32918 */     // MIs[5] vA
     /*  32918 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32923 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32927 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32931 */     // MIs[6] vC
     /*  32931 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32936 */     // MIs[6] vB
     /*  32936 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32941 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32943 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32960 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32970 */     GIR_RootConstrainSelectedInstOperands,
     /*  32971 */     // GIR_Coverage, 5146,
     /*  32971 */     GIR_EraseRootFromParent_Done,
     /*  32972 */   // Label 462: @32972
     /*  32972 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(33110), // Rule ID 5153 //
     /*  32977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33024 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33028 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33036 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33042 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33044 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33048 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33052 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33056 */     // MIs[5] vC
     /*  33056 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33061 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33065 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33069 */     // MIs[6] vA
     /*  33069 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33074 */     // MIs[6] vB
     /*  33074 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33079 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33081 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33098 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33108 */     GIR_RootConstrainSelectedInstOperands,
     /*  33109 */     // GIR_Coverage, 5153,
     /*  33109 */     GIR_EraseRootFromParent_Done,
     /*  33110 */   // Label 463: @33110
     /*  33110 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(33248), // Rule ID 5154 //
     /*  33115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33162 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33166 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33170 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33174 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33180 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33182 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33186 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33190 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33194 */     // MIs[5] vC
     /*  33194 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33199 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33203 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33207 */     // MIs[6] vB
     /*  33207 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33212 */     // MIs[6] vA
     /*  33212 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33217 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33219 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33236 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33246 */     GIR_RootConstrainSelectedInstOperands,
     /*  33247 */     // GIR_Coverage, 5154,
     /*  33247 */     GIR_EraseRootFromParent_Done,
     /*  33248 */   // Label 464: @33248
     /*  33248 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(33386), // Rule ID 5155 //
     /*  33253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33312 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33318 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33320 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33324 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33328 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33332 */     // MIs[5] vB
     /*  33332 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33337 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33341 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33345 */     // MIs[6] vA
     /*  33345 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33350 */     // MIs[6] vC
     /*  33350 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33355 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33357 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33374 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33384 */     GIR_RootConstrainSelectedInstOperands,
     /*  33385 */     // GIR_Coverage, 5155,
     /*  33385 */     GIR_EraseRootFromParent_Done,
     /*  33386 */   // Label 465: @33386
     /*  33386 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(33524), // Rule ID 5156 //
     /*  33391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33442 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33446 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33450 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33458 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33462 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33466 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33470 */     // MIs[5] vB
     /*  33470 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33475 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33479 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33483 */     // MIs[6] vC
     /*  33483 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33488 */     // MIs[6] vA
     /*  33488 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33493 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33495 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33512 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33522 */     GIR_RootConstrainSelectedInstOperands,
     /*  33523 */     // GIR_Coverage, 5156,
     /*  33523 */     GIR_EraseRootFromParent_Done,
     /*  33524 */   // Label 466: @33524
     /*  33524 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(33662), // Rule ID 5157 //
     /*  33529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33576 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33580 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33584 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33588 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33594 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33596 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33600 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33604 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33608 */     // MIs[5] vA
     /*  33608 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33613 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33617 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33621 */     // MIs[6] vB
     /*  33621 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33626 */     // MIs[6] vC
     /*  33626 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33631 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33633 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33650 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33660 */     GIR_RootConstrainSelectedInstOperands,
     /*  33661 */     // GIR_Coverage, 5157,
     /*  33661 */     GIR_EraseRootFromParent_Done,
     /*  33662 */   // Label 467: @33662
     /*  33662 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(33800), // Rule ID 5158 //
     /*  33667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33726 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33734 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33738 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33742 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33746 */     // MIs[5] vA
     /*  33746 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33751 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33755 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33759 */     // MIs[6] vC
     /*  33759 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33764 */     // MIs[6] vB
     /*  33764 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33769 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33771 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33788 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33798 */     GIR_RootConstrainSelectedInstOperands,
     /*  33799 */     // GIR_Coverage, 5158,
     /*  33799 */     GIR_EraseRootFromParent_Done,
     /*  33800 */   // Label 468: @33800
     /*  33800 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(33938), // Rule ID 5165 //
     /*  33805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33852 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33856 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33864 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33870 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33872 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33876 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33880 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33884 */     // MIs[5] vC
     /*  33884 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33889 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33893 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33897 */     // MIs[6] vA
     /*  33897 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33902 */     // MIs[6] vB
     /*  33902 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33907 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33909 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  33918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  33922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  33926 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33936 */     GIR_RootConstrainSelectedInstOperands,
     /*  33937 */     // GIR_Coverage, 5165,
     /*  33937 */     GIR_EraseRootFromParent_Done,
     /*  33938 */   // Label 469: @33938
     /*  33938 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(34076), // Rule ID 5166 //
     /*  33943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33990 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33994 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34002 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34010 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34014 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34018 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34022 */     // MIs[5] vC
     /*  34022 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34027 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34031 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34035 */     // MIs[6] vB
     /*  34035 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34040 */     // MIs[6] vA
     /*  34040 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34045 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34047 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34064 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34074 */     GIR_RootConstrainSelectedInstOperands,
     /*  34075 */     // GIR_Coverage, 5166,
     /*  34075 */     GIR_EraseRootFromParent_Done,
     /*  34076 */   // Label 470: @34076
     /*  34076 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(34214), // Rule ID 5167 //
     /*  34081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34132 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34136 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34140 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34146 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34148 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34152 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34156 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34160 */     // MIs[5] vB
     /*  34160 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34165 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34169 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34173 */     // MIs[6] vA
     /*  34173 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34178 */     // MIs[6] vC
     /*  34178 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34183 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34185 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34202 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34212 */     GIR_RootConstrainSelectedInstOperands,
     /*  34213 */     // GIR_Coverage, 5167,
     /*  34213 */     GIR_EraseRootFromParent_Done,
     /*  34214 */   // Label 471: @34214
     /*  34214 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(34352), // Rule ID 5168 //
     /*  34219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34274 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34278 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34286 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34290 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34294 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34298 */     // MIs[5] vB
     /*  34298 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34303 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34307 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34311 */     // MIs[6] vC
     /*  34311 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34316 */     // MIs[6] vA
     /*  34316 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34321 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34323 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34340 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34350 */     GIR_RootConstrainSelectedInstOperands,
     /*  34351 */     // GIR_Coverage, 5168,
     /*  34351 */     GIR_EraseRootFromParent_Done,
     /*  34352 */   // Label 472: @34352
     /*  34352 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(34490), // Rule ID 5169 //
     /*  34357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34404 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34408 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34416 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34422 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34424 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34428 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34432 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34436 */     // MIs[5] vA
     /*  34436 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34441 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34445 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34449 */     // MIs[6] vB
     /*  34449 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34454 */     // MIs[6] vC
     /*  34454 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34459 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34461 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34478 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34488 */     GIR_RootConstrainSelectedInstOperands,
     /*  34489 */     // GIR_Coverage, 5169,
     /*  34489 */     GIR_EraseRootFromParent_Done,
     /*  34490 */   // Label 473: @34490
     /*  34490 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(34628), // Rule ID 5170 //
     /*  34495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34546 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34554 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34560 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34562 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34566 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34570 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34574 */     // MIs[5] vA
     /*  34574 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34579 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34583 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34587 */     // MIs[6] vC
     /*  34587 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34592 */     // MIs[6] vB
     /*  34592 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34597 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34599 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34616 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34626 */     GIR_RootConstrainSelectedInstOperands,
     /*  34627 */     // GIR_Coverage, 5170,
     /*  34627 */     GIR_EraseRootFromParent_Done,
     /*  34628 */   // Label 474: @34628
     /*  34628 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(34766), // Rule ID 5177 //
     /*  34633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34684 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34688 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34692 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34698 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34700 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34704 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34708 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34712 */     // MIs[5] vC
     /*  34712 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34717 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34721 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34725 */     // MIs[6] vA
     /*  34725 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34730 */     // MIs[6] vB
     /*  34730 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34735 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34737 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34754 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34764 */     GIR_RootConstrainSelectedInstOperands,
     /*  34765 */     // GIR_Coverage, 5177,
     /*  34765 */     GIR_EraseRootFromParent_Done,
     /*  34766 */   // Label 475: @34766
     /*  34766 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(34904), // Rule ID 5178 //
     /*  34771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34818 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34822 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34830 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34836 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34838 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34842 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34846 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34850 */     // MIs[5] vC
     /*  34850 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34855 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34859 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34863 */     // MIs[6] vB
     /*  34863 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34868 */     // MIs[6] vA
     /*  34868 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34873 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34875 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34892 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34902 */     GIR_RootConstrainSelectedInstOperands,
     /*  34903 */     // GIR_Coverage, 5178,
     /*  34903 */     GIR_EraseRootFromParent_Done,
     /*  34904 */   // Label 476: @34904
     /*  34904 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(35042), // Rule ID 5179 //
     /*  34909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34956 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34960 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34964 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34968 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34974 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34976 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34980 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34984 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34988 */     // MIs[5] vB
     /*  34988 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34993 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34997 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35001 */     // MIs[6] vA
     /*  35001 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35006 */     // MIs[6] vC
     /*  35006 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35011 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35013 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35030 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35040 */     GIR_RootConstrainSelectedInstOperands,
     /*  35041 */     // GIR_Coverage, 5179,
     /*  35041 */     GIR_EraseRootFromParent_Done,
     /*  35042 */   // Label 477: @35042
     /*  35042 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(35180), // Rule ID 5180 //
     /*  35047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35094 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35098 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35102 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35106 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35112 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35114 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35118 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35122 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35126 */     // MIs[5] vB
     /*  35126 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35131 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35135 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35139 */     // MIs[6] vC
     /*  35139 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35144 */     // MIs[6] vA
     /*  35144 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35149 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35151 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35168 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35178 */     GIR_RootConstrainSelectedInstOperands,
     /*  35179 */     // GIR_Coverage, 5180,
     /*  35179 */     GIR_EraseRootFromParent_Done,
     /*  35180 */   // Label 478: @35180
     /*  35180 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(35318), // Rule ID 5181 //
     /*  35185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35232 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35236 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35240 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35244 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35250 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35252 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35256 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35260 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35264 */     // MIs[5] vA
     /*  35264 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35269 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35273 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35277 */     // MIs[6] vB
     /*  35277 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35282 */     // MIs[6] vC
     /*  35282 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35287 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35289 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35306 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35316 */     GIR_RootConstrainSelectedInstOperands,
     /*  35317 */     // GIR_Coverage, 5181,
     /*  35317 */     GIR_EraseRootFromParent_Done,
     /*  35318 */   // Label 479: @35318
     /*  35318 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(35456), // Rule ID 5182 //
     /*  35323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35370 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35374 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35378 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35382 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35388 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35390 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35394 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35398 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35402 */     // MIs[5] vA
     /*  35402 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35407 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35411 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35415 */     // MIs[6] vC
     /*  35415 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35420 */     // MIs[6] vB
     /*  35420 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35425 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35427 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35444 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35454 */     GIR_RootConstrainSelectedInstOperands,
     /*  35455 */     // GIR_Coverage, 5182,
     /*  35455 */     GIR_EraseRootFromParent_Done,
     /*  35456 */   // Label 480: @35456
     /*  35456 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(35594), // Rule ID 5183 //
     /*  35461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35512 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35516 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35520 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35526 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35528 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35532 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35536 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35540 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35544 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35548 */     // MIs[6] vA
     /*  35548 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35553 */     // MIs[6] vB
     /*  35553 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35558 */     // MIs[5] vC
     /*  35558 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35563 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35565 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35582 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35592 */     GIR_RootConstrainSelectedInstOperands,
     /*  35593 */     // GIR_Coverage, 5183,
     /*  35593 */     GIR_EraseRootFromParent_Done,
     /*  35594 */   // Label 481: @35594
     /*  35594 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(35732), // Rule ID 5184 //
     /*  35599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35646 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35650 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35654 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35658 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35664 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35666 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35670 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35674 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35678 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35682 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35686 */     // MIs[6] vB
     /*  35686 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35691 */     // MIs[6] vA
     /*  35691 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35696 */     // MIs[5] vC
     /*  35696 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35701 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35703 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35720 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35730 */     GIR_RootConstrainSelectedInstOperands,
     /*  35731 */     // GIR_Coverage, 5184,
     /*  35731 */     GIR_EraseRootFromParent_Done,
     /*  35732 */   // Label 482: @35732
     /*  35732 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(35870), // Rule ID 5185 //
     /*  35737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35792 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35796 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35802 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35804 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35808 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35812 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35816 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35820 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35824 */     // MIs[6] vA
     /*  35824 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35829 */     // MIs[6] vC
     /*  35829 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35834 */     // MIs[5] vB
     /*  35834 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35839 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35841 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35858 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35868 */     GIR_RootConstrainSelectedInstOperands,
     /*  35869 */     // GIR_Coverage, 5185,
     /*  35869 */     GIR_EraseRootFromParent_Done,
     /*  35870 */   // Label 483: @35870
     /*  35870 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(36008), // Rule ID 5186 //
     /*  35875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35922 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35926 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35930 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35934 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35940 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35942 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35946 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35950 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35954 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35958 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35962 */     // MIs[6] vC
     /*  35962 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35967 */     // MIs[6] vA
     /*  35967 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35972 */     // MIs[5] vB
     /*  35972 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35977 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35979 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35996 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36006 */     GIR_RootConstrainSelectedInstOperands,
     /*  36007 */     // GIR_Coverage, 5186,
     /*  36007 */     GIR_EraseRootFromParent_Done,
     /*  36008 */   // Label 484: @36008
     /*  36008 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(36146), // Rule ID 5187 //
     /*  36013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36064 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36068 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36072 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36078 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36080 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36084 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36088 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36092 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36096 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36100 */     // MIs[6] vB
     /*  36100 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36105 */     // MIs[6] vC
     /*  36105 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36110 */     // MIs[5] vA
     /*  36110 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36115 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36117 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36134 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36144 */     GIR_RootConstrainSelectedInstOperands,
     /*  36145 */     // GIR_Coverage, 5187,
     /*  36145 */     GIR_EraseRootFromParent_Done,
     /*  36146 */   // Label 485: @36146
     /*  36146 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(36284), // Rule ID 5188 //
     /*  36151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36198 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36202 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36206 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36210 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36216 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36218 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36222 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36226 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36230 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36234 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36238 */     // MIs[6] vC
     /*  36238 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36243 */     // MIs[6] vB
     /*  36243 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36248 */     // MIs[5] vA
     /*  36248 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36253 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36255 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36272 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36282 */     GIR_RootConstrainSelectedInstOperands,
     /*  36283 */     // GIR_Coverage, 5188,
     /*  36283 */     GIR_EraseRootFromParent_Done,
     /*  36284 */   // Label 486: @36284
     /*  36284 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(36422), // Rule ID 5195 //
     /*  36289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36340 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36348 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36354 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36356 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36360 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36364 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36368 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36372 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36376 */     // MIs[6] vA
     /*  36376 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36381 */     // MIs[6] vB
     /*  36381 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36386 */     // MIs[5] vC
     /*  36386 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36391 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36393 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36410 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36420 */     GIR_RootConstrainSelectedInstOperands,
     /*  36421 */     // GIR_Coverage, 5195,
     /*  36421 */     GIR_EraseRootFromParent_Done,
     /*  36422 */   // Label 487: @36422
     /*  36422 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(36560), // Rule ID 5196 //
     /*  36427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36474 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36478 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36482 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36486 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36492 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36494 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36498 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36502 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36506 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36510 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36514 */     // MIs[6] vB
     /*  36514 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36519 */     // MIs[6] vA
     /*  36519 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36524 */     // MIs[5] vC
     /*  36524 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36529 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36531 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36548 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36558 */     GIR_RootConstrainSelectedInstOperands,
     /*  36559 */     // GIR_Coverage, 5196,
     /*  36559 */     GIR_EraseRootFromParent_Done,
     /*  36560 */   // Label 488: @36560
     /*  36560 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(36698), // Rule ID 5197 //
     /*  36565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36612 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36616 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36620 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36624 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36630 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36632 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36636 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36640 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36644 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36648 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36652 */     // MIs[6] vA
     /*  36652 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36657 */     // MIs[6] vC
     /*  36657 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36662 */     // MIs[5] vB
     /*  36662 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36667 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36669 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36686 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36696 */     GIR_RootConstrainSelectedInstOperands,
     /*  36697 */     // GIR_Coverage, 5197,
     /*  36697 */     GIR_EraseRootFromParent_Done,
     /*  36698 */   // Label 489: @36698
     /*  36698 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(36836), // Rule ID 5198 //
     /*  36703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36750 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36754 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36758 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36762 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36768 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36770 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36774 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36778 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36782 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36786 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36790 */     // MIs[6] vC
     /*  36790 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36795 */     // MIs[6] vA
     /*  36795 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36800 */     // MIs[5] vB
     /*  36800 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36805 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36807 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36824 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36834 */     GIR_RootConstrainSelectedInstOperands,
     /*  36835 */     // GIR_Coverage, 5198,
     /*  36835 */     GIR_EraseRootFromParent_Done,
     /*  36836 */   // Label 490: @36836
     /*  36836 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(36974), // Rule ID 5199 //
     /*  36841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36900 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36906 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36916 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36920 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36924 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36928 */     // MIs[6] vB
     /*  36928 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36933 */     // MIs[6] vC
     /*  36933 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36938 */     // MIs[5] vA
     /*  36938 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36943 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36945 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36962 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36972 */     GIR_RootConstrainSelectedInstOperands,
     /*  36973 */     // GIR_Coverage, 5199,
     /*  36973 */     GIR_EraseRootFromParent_Done,
     /*  36974 */   // Label 491: @36974
     /*  36974 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(37112), // Rule ID 5200 //
     /*  36979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37026 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37030 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37034 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37038 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37046 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37050 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37054 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37058 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37062 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37066 */     // MIs[6] vC
     /*  37066 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37071 */     // MIs[6] vB
     /*  37071 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37076 */     // MIs[5] vA
     /*  37076 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37081 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37083 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  37092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  37096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  37100 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37110 */     GIR_RootConstrainSelectedInstOperands,
     /*  37111 */     // GIR_Coverage, 5200,
     /*  37111 */     GIR_EraseRootFromParent_Done,
     /*  37112 */   // Label 492: @37112
     /*  37112 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(37250), // Rule ID 5207 //
     /*  37117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37176 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37182 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37184 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37188 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37192 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37196 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37200 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37204 */     // MIs[6] vA
     /*  37204 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37209 */     // MIs[6] vB
     /*  37209 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37214 */     // MIs[5] vC
     /*  37214 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37219 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37221 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37238 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37248 */     GIR_RootConstrainSelectedInstOperands,
     /*  37249 */     // GIR_Coverage, 5207,
     /*  37249 */     GIR_EraseRootFromParent_Done,
     /*  37250 */   // Label 493: @37250
     /*  37250 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(37388), // Rule ID 5208 //
     /*  37255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37302 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37306 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37310 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37314 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37320 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37322 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37326 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37330 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37334 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37338 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37342 */     // MIs[6] vB
     /*  37342 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37347 */     // MIs[6] vA
     /*  37347 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37352 */     // MIs[5] vC
     /*  37352 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37357 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37359 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37376 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37386 */     GIR_RootConstrainSelectedInstOperands,
     /*  37387 */     // GIR_Coverage, 5208,
     /*  37387 */     GIR_EraseRootFromParent_Done,
     /*  37388 */   // Label 494: @37388
     /*  37388 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(37526), // Rule ID 5209 //
     /*  37393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37440 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37444 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37448 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37452 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37458 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37460 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37464 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37468 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37472 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37476 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37480 */     // MIs[6] vA
     /*  37480 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37485 */     // MIs[6] vC
     /*  37485 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37490 */     // MIs[5] vB
     /*  37490 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37495 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37497 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37514 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37524 */     GIR_RootConstrainSelectedInstOperands,
     /*  37525 */     // GIR_Coverage, 5209,
     /*  37525 */     GIR_EraseRootFromParent_Done,
     /*  37526 */   // Label 495: @37526
     /*  37526 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(37664), // Rule ID 5210 //
     /*  37531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37578 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37582 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37590 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37598 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37602 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37606 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37610 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37614 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37618 */     // MIs[6] vC
     /*  37618 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37623 */     // MIs[6] vA
     /*  37623 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37628 */     // MIs[5] vB
     /*  37628 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37633 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37635 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37652 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37662 */     GIR_RootConstrainSelectedInstOperands,
     /*  37663 */     // GIR_Coverage, 5210,
     /*  37663 */     GIR_EraseRootFromParent_Done,
     /*  37664 */   // Label 496: @37664
     /*  37664 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(37802), // Rule ID 5211 //
     /*  37669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37720 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37724 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37728 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37734 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37736 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37740 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37744 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37748 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37752 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37756 */     // MIs[6] vB
     /*  37756 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37761 */     // MIs[6] vC
     /*  37761 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37766 */     // MIs[5] vA
     /*  37766 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37771 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37773 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37790 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37800 */     GIR_RootConstrainSelectedInstOperands,
     /*  37801 */     // GIR_Coverage, 5211,
     /*  37801 */     GIR_EraseRootFromParent_Done,
     /*  37802 */   // Label 497: @37802
     /*  37802 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(37940), // Rule ID 5212 //
     /*  37807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37854 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37858 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37866 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37874 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37878 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37882 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37886 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37890 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37894 */     // MIs[6] vC
     /*  37894 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37899 */     // MIs[6] vB
     /*  37899 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37904 */     // MIs[5] vA
     /*  37904 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37909 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37911 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37928 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37938 */     GIR_RootConstrainSelectedInstOperands,
     /*  37939 */     // GIR_Coverage, 5212,
     /*  37939 */     GIR_EraseRootFromParent_Done,
     /*  37940 */   // Label 498: @37940
     /*  37940 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(38078), // Rule ID 5219 //
     /*  37945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37996 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38004 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38010 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38012 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38016 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38020 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38024 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38028 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38032 */     // MIs[6] vA
     /*  38032 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38037 */     // MIs[6] vB
     /*  38037 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38042 */     // MIs[5] vC
     /*  38042 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38047 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38049 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38066 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38076 */     GIR_RootConstrainSelectedInstOperands,
     /*  38077 */     // GIR_Coverage, 5219,
     /*  38077 */     GIR_EraseRootFromParent_Done,
     /*  38078 */   // Label 499: @38078
     /*  38078 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(38216), // Rule ID 5220 //
     /*  38083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38130 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38134 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38150 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38154 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38158 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38162 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38166 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38170 */     // MIs[6] vB
     /*  38170 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38175 */     // MIs[6] vA
     /*  38175 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38180 */     // MIs[5] vC
     /*  38180 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38185 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38187 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38204 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38214 */     GIR_RootConstrainSelectedInstOperands,
     /*  38215 */     // GIR_Coverage, 5220,
     /*  38215 */     GIR_EraseRootFromParent_Done,
     /*  38216 */   // Label 500: @38216
     /*  38216 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(38354), // Rule ID 5221 //
     /*  38221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38268 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38272 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38276 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38280 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38286 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38288 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38292 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38296 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38300 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38304 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38308 */     // MIs[6] vA
     /*  38308 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38313 */     // MIs[6] vC
     /*  38313 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38318 */     // MIs[5] vB
     /*  38318 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38323 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38325 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38342 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38352 */     GIR_RootConstrainSelectedInstOperands,
     /*  38353 */     // GIR_Coverage, 5221,
     /*  38353 */     GIR_EraseRootFromParent_Done,
     /*  38354 */   // Label 501: @38354
     /*  38354 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(38492), // Rule ID 5222 //
     /*  38359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38406 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38410 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38418 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38426 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38430 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38434 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38438 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38442 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38446 */     // MIs[6] vC
     /*  38446 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38451 */     // MIs[6] vA
     /*  38451 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38456 */     // MIs[5] vB
     /*  38456 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38461 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38463 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38480 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38490 */     GIR_RootConstrainSelectedInstOperands,
     /*  38491 */     // GIR_Coverage, 5222,
     /*  38491 */     GIR_EraseRootFromParent_Done,
     /*  38492 */   // Label 502: @38492
     /*  38492 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(38630), // Rule ID 5223 //
     /*  38497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38548 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38552 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38556 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38562 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38564 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38568 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38572 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38576 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38580 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38584 */     // MIs[6] vB
     /*  38584 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38589 */     // MIs[6] vC
     /*  38589 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38594 */     // MIs[5] vA
     /*  38594 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38599 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38601 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38618 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38628 */     GIR_RootConstrainSelectedInstOperands,
     /*  38629 */     // GIR_Coverage, 5223,
     /*  38629 */     GIR_EraseRootFromParent_Done,
     /*  38630 */   // Label 503: @38630
     /*  38630 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(38768), // Rule ID 5224 //
     /*  38635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38682 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38686 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38694 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38700 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38702 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38706 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38710 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38714 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38718 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38722 */     // MIs[6] vC
     /*  38722 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38727 */     // MIs[6] vB
     /*  38727 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38732 */     // MIs[5] vA
     /*  38732 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38737 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38739 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38756 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38766 */     GIR_RootConstrainSelectedInstOperands,
     /*  38767 */     // GIR_Coverage, 5224,
     /*  38767 */     GIR_EraseRootFromParent_Done,
     /*  38768 */   // Label 504: @38768
     /*  38768 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(38906), // Rule ID 5231 //
     /*  38773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38820 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38824 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38828 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38832 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38838 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38840 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38844 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38848 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38852 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38856 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38860 */     // MIs[6] vA
     /*  38860 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38865 */     // MIs[6] vB
     /*  38865 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38870 */     // MIs[5] vC
     /*  38870 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38875 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38877 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  38886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  38890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  38894 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38904 */     GIR_RootConstrainSelectedInstOperands,
     /*  38905 */     // GIR_Coverage, 5231,
     /*  38905 */     GIR_EraseRootFromParent_Done,
     /*  38906 */   // Label 505: @38906
     /*  38906 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(39044), // Rule ID 5232 //
     /*  38911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38970 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38978 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38982 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38986 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38990 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38994 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38998 */     // MIs[6] vB
     /*  38998 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39003 */     // MIs[6] vA
     /*  39003 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39008 */     // MIs[5] vC
     /*  39008 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39013 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39015 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39032 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39042 */     GIR_RootConstrainSelectedInstOperands,
     /*  39043 */     // GIR_Coverage, 5232,
     /*  39043 */     GIR_EraseRootFromParent_Done,
     /*  39044 */   // Label 506: @39044
     /*  39044 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(39182), // Rule ID 5233 //
     /*  39049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39100 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39108 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39114 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39116 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39120 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39124 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39128 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39132 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39136 */     // MIs[6] vA
     /*  39136 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39141 */     // MIs[6] vC
     /*  39141 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39146 */     // MIs[5] vB
     /*  39146 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39151 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39153 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39170 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39180 */     GIR_RootConstrainSelectedInstOperands,
     /*  39181 */     // GIR_Coverage, 5233,
     /*  39181 */     GIR_EraseRootFromParent_Done,
     /*  39182 */   // Label 507: @39182
     /*  39182 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(39320), // Rule ID 5234 //
     /*  39187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39234 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39238 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39242 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39246 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39252 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39254 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39258 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39262 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39266 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39270 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39274 */     // MIs[6] vC
     /*  39274 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39279 */     // MIs[6] vA
     /*  39279 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39284 */     // MIs[5] vB
     /*  39284 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39289 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39291 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39308 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39318 */     GIR_RootConstrainSelectedInstOperands,
     /*  39319 */     // GIR_Coverage, 5234,
     /*  39319 */     GIR_EraseRootFromParent_Done,
     /*  39320 */   // Label 508: @39320
     /*  39320 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(39458), // Rule ID 5235 //
     /*  39325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39376 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39380 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39384 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39390 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39392 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39396 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39400 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39404 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39408 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39412 */     // MIs[6] vB
     /*  39412 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39417 */     // MIs[6] vC
     /*  39417 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39422 */     // MIs[5] vA
     /*  39422 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39427 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39429 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39446 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39456 */     GIR_RootConstrainSelectedInstOperands,
     /*  39457 */     // GIR_Coverage, 5235,
     /*  39457 */     GIR_EraseRootFromParent_Done,
     /*  39458 */   // Label 509: @39458
     /*  39458 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(39596), // Rule ID 5236 //
     /*  39463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39510 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39514 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39518 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39522 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39528 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39530 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39534 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39538 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39542 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39546 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39550 */     // MIs[6] vC
     /*  39550 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39555 */     // MIs[6] vB
     /*  39555 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39560 */     // MIs[5] vA
     /*  39560 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39565 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39567 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39584 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39594 */     GIR_RootConstrainSelectedInstOperands,
     /*  39595 */     // GIR_Coverage, 5236,
     /*  39595 */     GIR_EraseRootFromParent_Done,
     /*  39596 */   // Label 510: @39596
     /*  39596 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(39734), // Rule ID 5243 //
     /*  39601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39648 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39652 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39656 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39660 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39666 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39668 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39672 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39676 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39680 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39684 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39688 */     // MIs[6] vA
     /*  39688 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39693 */     // MIs[6] vB
     /*  39693 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39698 */     // MIs[5] vC
     /*  39698 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39703 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39705 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39722 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39732 */     GIR_RootConstrainSelectedInstOperands,
     /*  39733 */     // GIR_Coverage, 5243,
     /*  39733 */     GIR_EraseRootFromParent_Done,
     /*  39734 */   // Label 511: @39734
     /*  39734 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(39872), // Rule ID 5244 //
     /*  39739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39786 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39790 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39794 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39798 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39804 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39806 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39810 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39814 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39818 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39822 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39826 */     // MIs[6] vB
     /*  39826 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39831 */     // MIs[6] vA
     /*  39831 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39836 */     // MIs[5] vC
     /*  39836 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39841 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39843 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39860 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39870 */     GIR_RootConstrainSelectedInstOperands,
     /*  39871 */     // GIR_Coverage, 5244,
     /*  39871 */     GIR_EraseRootFromParent_Done,
     /*  39872 */   // Label 512: @39872
     /*  39872 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(40010), // Rule ID 5245 //
     /*  39877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39924 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39928 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39936 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39944 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39948 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39952 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39956 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39960 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39964 */     // MIs[6] vA
     /*  39964 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39969 */     // MIs[6] vC
     /*  39969 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39974 */     // MIs[5] vB
     /*  39974 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39979 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39981 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39998 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40008 */     GIR_RootConstrainSelectedInstOperands,
     /*  40009 */     // GIR_Coverage, 5245,
     /*  40009 */     GIR_EraseRootFromParent_Done,
     /*  40010 */   // Label 513: @40010
     /*  40010 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(40148), // Rule ID 5246 //
     /*  40015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40066 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40070 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40074 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40080 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40082 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40086 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40090 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40094 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40098 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40102 */     // MIs[6] vC
     /*  40102 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40107 */     // MIs[6] vA
     /*  40107 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40112 */     // MIs[5] vB
     /*  40112 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40117 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40119 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40136 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40146 */     GIR_RootConstrainSelectedInstOperands,
     /*  40147 */     // GIR_Coverage, 5246,
     /*  40147 */     GIR_EraseRootFromParent_Done,
     /*  40148 */   // Label 514: @40148
     /*  40148 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(40286), // Rule ID 5247 //
     /*  40153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40200 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40204 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40208 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40212 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40218 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40220 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40224 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40228 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40232 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40236 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40240 */     // MIs[6] vB
     /*  40240 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40245 */     // MIs[6] vC
     /*  40245 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40250 */     // MIs[5] vA
     /*  40250 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40255 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40257 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40274 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40284 */     GIR_RootConstrainSelectedInstOperands,
     /*  40285 */     // GIR_Coverage, 5247,
     /*  40285 */     GIR_EraseRootFromParent_Done,
     /*  40286 */   // Label 515: @40286
     /*  40286 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(40424), // Rule ID 5248 //
     /*  40291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40338 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40342 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40346 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40350 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40356 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40358 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40362 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40366 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40370 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40374 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40378 */     // MIs[6] vC
     /*  40378 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40383 */     // MIs[6] vB
     /*  40383 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40388 */     // MIs[5] vA
     /*  40388 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40393 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40395 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40412 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40422 */     GIR_RootConstrainSelectedInstOperands,
     /*  40423 */     // GIR_Coverage, 5248,
     /*  40423 */     GIR_EraseRootFromParent_Done,
     /*  40424 */   // Label 516: @40424
     /*  40424 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(40562), // Rule ID 5189 //
     /*  40429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40480 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40484 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40488 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40494 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40496 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40500 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40504 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40508 */     // MIs[5] vC
     /*  40508 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40513 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40517 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40521 */     // MIs[6] vA
     /*  40521 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40526 */     // MIs[6] vB
     /*  40526 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40531 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40533 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40550 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40560 */     GIR_RootConstrainSelectedInstOperands,
     /*  40561 */     // GIR_Coverage, 5189,
     /*  40561 */     GIR_EraseRootFromParent_Done,
     /*  40562 */   // Label 517: @40562
     /*  40562 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(40700), // Rule ID 5190 //
     /*  40567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40622 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40626 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40632 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40634 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40638 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40642 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40646 */     // MIs[5] vC
     /*  40646 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40651 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40655 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40659 */     // MIs[6] vB
     /*  40659 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40664 */     // MIs[6] vA
     /*  40664 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40669 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40671 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40688 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40698 */     GIR_RootConstrainSelectedInstOperands,
     /*  40699 */     // GIR_Coverage, 5190,
     /*  40699 */     GIR_EraseRootFromParent_Done,
     /*  40700 */   // Label 518: @40700
     /*  40700 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(40838), // Rule ID 5191 //
     /*  40705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40756 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40760 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40764 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40770 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40772 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40776 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40780 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40784 */     // MIs[5] vB
     /*  40784 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40789 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40793 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40797 */     // MIs[6] vA
     /*  40797 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40802 */     // MIs[6] vC
     /*  40802 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40807 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40809 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40826 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40836 */     GIR_RootConstrainSelectedInstOperands,
     /*  40837 */     // GIR_Coverage, 5191,
     /*  40837 */     GIR_EraseRootFromParent_Done,
     /*  40838 */   // Label 519: @40838
     /*  40838 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(40976), // Rule ID 5192 //
     /*  40843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40890 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40894 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40898 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40902 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40910 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40914 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40918 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40922 */     // MIs[5] vB
     /*  40922 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40927 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40931 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40935 */     // MIs[6] vC
     /*  40935 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40940 */     // MIs[6] vA
     /*  40940 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40945 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40947 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40964 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40974 */     GIR_RootConstrainSelectedInstOperands,
     /*  40975 */     // GIR_Coverage, 5192,
     /*  40975 */     GIR_EraseRootFromParent_Done,
     /*  40976 */   // Label 520: @40976
     /*  40976 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(41114), // Rule ID 5193 //
     /*  40981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41028 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41032 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41040 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41048 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41052 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41056 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41060 */     // MIs[5] vA
     /*  41060 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41065 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41069 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41073 */     // MIs[6] vB
     /*  41073 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41078 */     // MIs[6] vC
     /*  41078 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41083 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41085 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41102 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41112 */     GIR_RootConstrainSelectedInstOperands,
     /*  41113 */     // GIR_Coverage, 5193,
     /*  41113 */     GIR_EraseRootFromParent_Done,
     /*  41114 */   // Label 521: @41114
     /*  41114 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(41252), // Rule ID 5194 //
     /*  41119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41170 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41174 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41178 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41184 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41186 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41190 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41194 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41198 */     // MIs[5] vA
     /*  41198 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41203 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41207 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41211 */     // MIs[6] vC
     /*  41211 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41216 */     // MIs[6] vB
     /*  41216 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41221 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41223 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41240 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41250 */     GIR_RootConstrainSelectedInstOperands,
     /*  41251 */     // GIR_Coverage, 5194,
     /*  41251 */     GIR_EraseRootFromParent_Done,
     /*  41252 */   // Label 522: @41252
     /*  41252 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(41390), // Rule ID 5201 //
     /*  41257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41308 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41312 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41316 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41322 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41324 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41328 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41332 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41336 */     // MIs[5] vC
     /*  41336 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41341 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41345 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41349 */     // MIs[6] vA
     /*  41349 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41354 */     // MIs[6] vB
     /*  41354 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41359 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41361 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41378 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41388 */     GIR_RootConstrainSelectedInstOperands,
     /*  41389 */     // GIR_Coverage, 5201,
     /*  41389 */     GIR_EraseRootFromParent_Done,
     /*  41390 */   // Label 523: @41390
     /*  41390 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(41528), // Rule ID 5202 //
     /*  41395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41442 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41446 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41450 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41454 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41462 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41466 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41470 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41474 */     // MIs[5] vC
     /*  41474 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41479 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41483 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41487 */     // MIs[6] vB
     /*  41487 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41492 */     // MIs[6] vA
     /*  41492 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41497 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41499 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41516 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41526 */     GIR_RootConstrainSelectedInstOperands,
     /*  41527 */     // GIR_Coverage, 5202,
     /*  41527 */     GIR_EraseRootFromParent_Done,
     /*  41528 */   // Label 524: @41528
     /*  41528 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(41666), // Rule ID 5203 //
     /*  41533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41580 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41584 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41592 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41598 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41600 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41604 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41608 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41612 */     // MIs[5] vB
     /*  41612 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41617 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41621 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41625 */     // MIs[6] vA
     /*  41625 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41630 */     // MIs[6] vC
     /*  41630 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41635 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41637 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41654 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41664 */     GIR_RootConstrainSelectedInstOperands,
     /*  41665 */     // GIR_Coverage, 5203,
     /*  41665 */     GIR_EraseRootFromParent_Done,
     /*  41666 */   // Label 525: @41666
     /*  41666 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(41804), // Rule ID 5204 //
     /*  41671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41718 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41722 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41726 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41730 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41736 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41738 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41742 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41746 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41750 */     // MIs[5] vB
     /*  41750 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41755 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41759 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41763 */     // MIs[6] vC
     /*  41763 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41768 */     // MIs[6] vA
     /*  41768 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41773 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41775 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41792 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41802 */     GIR_RootConstrainSelectedInstOperands,
     /*  41803 */     // GIR_Coverage, 5204,
     /*  41803 */     GIR_EraseRootFromParent_Done,
     /*  41804 */   // Label 526: @41804
     /*  41804 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(41942), // Rule ID 5205 //
     /*  41809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41860 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41864 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41868 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41876 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41880 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41884 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41888 */     // MIs[5] vA
     /*  41888 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41893 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41897 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41901 */     // MIs[6] vB
     /*  41901 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41906 */     // MIs[6] vC
     /*  41906 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41911 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41913 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41930 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41940 */     GIR_RootConstrainSelectedInstOperands,
     /*  41941 */     // GIR_Coverage, 5205,
     /*  41941 */     GIR_EraseRootFromParent_Done,
     /*  41942 */   // Label 527: @41942
     /*  41942 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(42080), // Rule ID 5206 //
     /*  41947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41994 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41998 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42006 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42014 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42018 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42022 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42026 */     // MIs[5] vA
     /*  42026 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42031 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42035 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42039 */     // MIs[6] vC
     /*  42039 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42044 */     // MIs[6] vB
     /*  42044 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42049 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42051 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  42060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  42064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  42068 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42078 */     GIR_RootConstrainSelectedInstOperands,
     /*  42079 */     // GIR_Coverage, 5206,
     /*  42079 */     GIR_EraseRootFromParent_Done,
     /*  42080 */   // Label 528: @42080
     /*  42080 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(42218), // Rule ID 5213 //
     /*  42085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42132 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42140 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42144 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42150 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42152 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42156 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42160 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42164 */     // MIs[5] vC
     /*  42164 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42169 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42173 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42177 */     // MIs[6] vA
     /*  42177 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42182 */     // MIs[6] vB
     /*  42182 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42187 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42189 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42206 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42216 */     GIR_RootConstrainSelectedInstOperands,
     /*  42217 */     // GIR_Coverage, 5213,
     /*  42217 */     GIR_EraseRootFromParent_Done,
     /*  42218 */   // Label 529: @42218
     /*  42218 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(42356), // Rule ID 5214 //
     /*  42223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42270 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42274 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42278 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42282 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42288 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42290 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42294 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42298 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42302 */     // MIs[5] vC
     /*  42302 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42307 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42311 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42315 */     // MIs[6] vB
     /*  42315 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42320 */     // MIs[6] vA
     /*  42320 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42325 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42327 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42344 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42354 */     GIR_RootConstrainSelectedInstOperands,
     /*  42355 */     // GIR_Coverage, 5214,
     /*  42355 */     GIR_EraseRootFromParent_Done,
     /*  42356 */   // Label 530: @42356
     /*  42356 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(42494), // Rule ID 5215 //
     /*  42361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42408 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42412 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42416 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42420 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42426 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42428 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42432 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42436 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42440 */     // MIs[5] vB
     /*  42440 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42445 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42449 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42453 */     // MIs[6] vA
     /*  42453 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42458 */     // MIs[6] vC
     /*  42458 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42463 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42465 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42482 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42492 */     GIR_RootConstrainSelectedInstOperands,
     /*  42493 */     // GIR_Coverage, 5215,
     /*  42493 */     GIR_EraseRootFromParent_Done,
     /*  42494 */   // Label 531: @42494
     /*  42494 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(42632), // Rule ID 5216 //
     /*  42499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42546 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42550 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42554 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42558 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42566 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42570 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42574 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42578 */     // MIs[5] vB
     /*  42578 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42583 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42587 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42591 */     // MIs[6] vC
     /*  42591 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42596 */     // MIs[6] vA
     /*  42596 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42601 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42603 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42620 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42630 */     GIR_RootConstrainSelectedInstOperands,
     /*  42631 */     // GIR_Coverage, 5216,
     /*  42631 */     GIR_EraseRootFromParent_Done,
     /*  42632 */   // Label 532: @42632
     /*  42632 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(42770), // Rule ID 5217 //
     /*  42637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42684 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42688 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42696 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42704 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42708 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42712 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42716 */     // MIs[5] vA
     /*  42716 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42721 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42725 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42729 */     // MIs[6] vB
     /*  42729 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42734 */     // MIs[6] vC
     /*  42734 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42739 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42741 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42758 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42768 */     GIR_RootConstrainSelectedInstOperands,
     /*  42769 */     // GIR_Coverage, 5217,
     /*  42769 */     GIR_EraseRootFromParent_Done,
     /*  42770 */   // Label 533: @42770
     /*  42770 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(42908), // Rule ID 5218 //
     /*  42775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42830 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42834 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42840 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42846 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42850 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42854 */     // MIs[5] vA
     /*  42854 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42859 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42863 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42867 */     // MIs[6] vC
     /*  42867 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42872 */     // MIs[6] vB
     /*  42872 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42877 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42879 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42896 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42906 */     GIR_RootConstrainSelectedInstOperands,
     /*  42907 */     // GIR_Coverage, 5218,
     /*  42907 */     GIR_EraseRootFromParent_Done,
     /*  42908 */   // Label 534: @42908
     /*  42908 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(43046), // Rule ID 5225 //
     /*  42913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42960 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42972 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42978 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42980 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42984 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42988 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42992 */     // MIs[5] vC
     /*  42992 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42997 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43001 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43005 */     // MIs[6] vA
     /*  43005 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43010 */     // MIs[6] vB
     /*  43010 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43015 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43017 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43034 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43044 */     GIR_RootConstrainSelectedInstOperands,
     /*  43045 */     // GIR_Coverage, 5225,
     /*  43045 */     GIR_EraseRootFromParent_Done,
     /*  43046 */   // Label 535: @43046
     /*  43046 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(43184), // Rule ID 5226 //
     /*  43051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43102 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43106 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43110 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43118 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43122 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43126 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43130 */     // MIs[5] vC
     /*  43130 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43135 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43139 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43143 */     // MIs[6] vB
     /*  43143 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43148 */     // MIs[6] vA
     /*  43148 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43153 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43155 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43172 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43182 */     GIR_RootConstrainSelectedInstOperands,
     /*  43183 */     // GIR_Coverage, 5226,
     /*  43183 */     GIR_EraseRootFromParent_Done,
     /*  43184 */   // Label 536: @43184
     /*  43184 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(43322), // Rule ID 5227 //
     /*  43189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43236 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43240 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43244 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43248 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43254 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43256 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43260 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43264 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43268 */     // MIs[5] vB
     /*  43268 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43273 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43277 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43281 */     // MIs[6] vA
     /*  43281 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43286 */     // MIs[6] vC
     /*  43286 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43291 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43293 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43310 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43320 */     GIR_RootConstrainSelectedInstOperands,
     /*  43321 */     // GIR_Coverage, 5227,
     /*  43321 */     GIR_EraseRootFromParent_Done,
     /*  43322 */   // Label 537: @43322
     /*  43322 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(43460), // Rule ID 5228 //
     /*  43327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43374 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43378 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43386 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43394 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43398 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43402 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43406 */     // MIs[5] vB
     /*  43406 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43411 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43415 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43419 */     // MIs[6] vC
     /*  43419 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43424 */     // MIs[6] vA
     /*  43424 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43429 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43431 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43448 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43458 */     GIR_RootConstrainSelectedInstOperands,
     /*  43459 */     // GIR_Coverage, 5228,
     /*  43459 */     GIR_EraseRootFromParent_Done,
     /*  43460 */   // Label 538: @43460
     /*  43460 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(43598), // Rule ID 5229 //
     /*  43465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43512 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43516 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43520 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43524 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43532 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43536 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43540 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43544 */     // MIs[5] vA
     /*  43544 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43549 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43553 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43557 */     // MIs[6] vB
     /*  43557 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43562 */     // MIs[6] vC
     /*  43562 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43567 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43569 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43586 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43596 */     GIR_RootConstrainSelectedInstOperands,
     /*  43597 */     // GIR_Coverage, 5229,
     /*  43597 */     GIR_EraseRootFromParent_Done,
     /*  43598 */   // Label 539: @43598
     /*  43598 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(43736), // Rule ID 5230 //
     /*  43603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43650 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43654 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43662 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43670 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43674 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43678 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43682 */     // MIs[5] vA
     /*  43682 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43687 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43691 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43695 */     // MIs[6] vC
     /*  43695 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43700 */     // MIs[6] vB
     /*  43700 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43705 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43707 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43724 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43734 */     GIR_RootConstrainSelectedInstOperands,
     /*  43735 */     // GIR_Coverage, 5230,
     /*  43735 */     GIR_EraseRootFromParent_Done,
     /*  43736 */   // Label 540: @43736
     /*  43736 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(43874), // Rule ID 5237 //
     /*  43741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43788 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43792 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43796 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43800 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43806 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43808 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43812 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43816 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43820 */     // MIs[5] vC
     /*  43820 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43825 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43829 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43833 */     // MIs[6] vA
     /*  43833 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43838 */     // MIs[6] vB
     /*  43838 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43843 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43845 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  43854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  43858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  43862 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43872 */     GIR_RootConstrainSelectedInstOperands,
     /*  43873 */     // GIR_Coverage, 5237,
     /*  43873 */     GIR_EraseRootFromParent_Done,
     /*  43874 */   // Label 541: @43874
     /*  43874 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(44012), // Rule ID 5238 //
     /*  43879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43926 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43930 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43934 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43938 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43944 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43946 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43950 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43954 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43958 */     // MIs[5] vC
     /*  43958 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43963 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43967 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43971 */     // MIs[6] vB
     /*  43971 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43976 */     // MIs[6] vA
     /*  43976 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43981 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43983 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  43992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  43996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44000 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44010 */     GIR_RootConstrainSelectedInstOperands,
     /*  44011 */     // GIR_Coverage, 5238,
     /*  44011 */     GIR_EraseRootFromParent_Done,
     /*  44012 */   // Label 542: @44012
     /*  44012 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(44150), // Rule ID 5239 //
     /*  44017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44064 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44068 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44072 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44076 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44082 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44084 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44088 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44092 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44096 */     // MIs[5] vB
     /*  44096 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44101 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44105 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44109 */     // MIs[6] vA
     /*  44109 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44114 */     // MIs[6] vC
     /*  44114 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44119 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44121 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44138 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44148 */     GIR_RootConstrainSelectedInstOperands,
     /*  44149 */     // GIR_Coverage, 5239,
     /*  44149 */     GIR_EraseRootFromParent_Done,
     /*  44150 */   // Label 543: @44150
     /*  44150 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(44288), // Rule ID 5240 //
     /*  44155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44202 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44206 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44210 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44214 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44220 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44222 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44226 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44230 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44234 */     // MIs[5] vB
     /*  44234 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44239 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44243 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44247 */     // MIs[6] vC
     /*  44247 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44252 */     // MIs[6] vA
     /*  44252 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44257 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44259 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44276 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44286 */     GIR_RootConstrainSelectedInstOperands,
     /*  44287 */     // GIR_Coverage, 5240,
     /*  44287 */     GIR_EraseRootFromParent_Done,
     /*  44288 */   // Label 544: @44288
     /*  44288 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(44426), // Rule ID 5241 //
     /*  44293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44340 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44344 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44348 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44352 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44358 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44360 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44364 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44368 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44372 */     // MIs[5] vA
     /*  44372 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44377 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44381 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44385 */     // MIs[6] vB
     /*  44385 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44390 */     // MIs[6] vC
     /*  44390 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44395 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44397 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44414 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44424 */     GIR_RootConstrainSelectedInstOperands,
     /*  44425 */     // GIR_Coverage, 5241,
     /*  44425 */     GIR_EraseRootFromParent_Done,
     /*  44426 */   // Label 545: @44426
     /*  44426 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(44564), // Rule ID 5242 //
     /*  44431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44478 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44490 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44496 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44498 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44502 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44506 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44510 */     // MIs[5] vA
     /*  44510 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44515 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44519 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44523 */     // MIs[6] vC
     /*  44523 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44528 */     // MIs[6] vB
     /*  44528 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44533 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44535 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44552 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44562 */     GIR_RootConstrainSelectedInstOperands,
     /*  44563 */     // GIR_Coverage, 5242,
     /*  44563 */     GIR_EraseRootFromParent_Done,
     /*  44564 */   // Label 546: @44564
     /*  44564 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(44702), // Rule ID 5249 //
     /*  44569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44616 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44620 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44624 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44628 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44636 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44640 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44644 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44648 */     // MIs[5] vC
     /*  44648 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44653 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44657 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44661 */     // MIs[6] vA
     /*  44661 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44666 */     // MIs[6] vB
     /*  44666 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44671 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44673 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44690 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44700 */     GIR_RootConstrainSelectedInstOperands,
     /*  44701 */     // GIR_Coverage, 5249,
     /*  44701 */     GIR_EraseRootFromParent_Done,
     /*  44702 */   // Label 547: @44702
     /*  44702 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(44840), // Rule ID 5250 //
     /*  44707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44754 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44758 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44762 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44766 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44774 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44778 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44782 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44786 */     // MIs[5] vC
     /*  44786 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44791 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44795 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44799 */     // MIs[6] vB
     /*  44799 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44804 */     // MIs[6] vA
     /*  44804 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44809 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44811 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44828 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44838 */     GIR_RootConstrainSelectedInstOperands,
     /*  44839 */     // GIR_Coverage, 5250,
     /*  44839 */     GIR_EraseRootFromParent_Done,
     /*  44840 */   // Label 548: @44840
     /*  44840 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(44978), // Rule ID 5251 //
     /*  44845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44896 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44904 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44910 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44912 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44916 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44920 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44924 */     // MIs[5] vB
     /*  44924 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44929 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44933 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44937 */     // MIs[6] vA
     /*  44937 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44942 */     // MIs[6] vC
     /*  44942 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44947 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44949 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44966 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44976 */     GIR_RootConstrainSelectedInstOperands,
     /*  44977 */     // GIR_Coverage, 5251,
     /*  44977 */     GIR_EraseRootFromParent_Done,
     /*  44978 */   // Label 549: @44978
     /*  44978 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(45116), // Rule ID 5252 //
     /*  44983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45030 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45034 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45038 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45042 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45050 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45054 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45058 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45062 */     // MIs[5] vB
     /*  45062 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45067 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45071 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45075 */     // MIs[6] vC
     /*  45075 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45080 */     // MIs[6] vA
     /*  45080 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45085 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45087 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45104 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45114 */     GIR_RootConstrainSelectedInstOperands,
     /*  45115 */     // GIR_Coverage, 5252,
     /*  45115 */     GIR_EraseRootFromParent_Done,
     /*  45116 */   // Label 550: @45116
     /*  45116 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(45254), // Rule ID 5253 //
     /*  45121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45172 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45176 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45180 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45188 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45192 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45196 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45200 */     // MIs[5] vA
     /*  45200 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45205 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45209 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45213 */     // MIs[6] vB
     /*  45213 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45218 */     // MIs[6] vC
     /*  45218 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45223 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45225 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45242 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45252 */     GIR_RootConstrainSelectedInstOperands,
     /*  45253 */     // GIR_Coverage, 5253,
     /*  45253 */     GIR_EraseRootFromParent_Done,
     /*  45254 */   // Label 551: @45254
     /*  45254 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(45392), // Rule ID 5254 //
     /*  45259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45310 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45314 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45318 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45326 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45330 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45334 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45338 */     // MIs[5] vA
     /*  45338 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45343 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45347 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45351 */     // MIs[6] vC
     /*  45351 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45356 */     // MIs[6] vB
     /*  45356 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45361 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45363 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45380 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45390 */     GIR_RootConstrainSelectedInstOperands,
     /*  45391 */     // GIR_Coverage, 5254,
     /*  45391 */     GIR_EraseRootFromParent_Done,
     /*  45392 */   // Label 552: @45392
     /*  45392 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(45486), // Rule ID 4941 //
     /*  45397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45440 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45446 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45448 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45452 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45456 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45460 */     // MIs[4] C
     /*  45460 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45465 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45467 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45484 */     GIR_RootConstrainSelectedInstOperands,
     /*  45485 */     // GIR_Coverage, 4941,
     /*  45485 */     GIR_EraseRootFromParent_Done,
     /*  45486 */   // Label 553: @45486
     /*  45486 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(45580), // Rule ID 1581 //
     /*  45491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45534 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45540 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45542 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45546 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45550 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45554 */     // MIs[4] C
     /*  45554 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45559 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45561 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45578 */     GIR_RootConstrainSelectedInstOperands,
     /*  45579 */     // GIR_Coverage, 1581,
     /*  45579 */     GIR_EraseRootFromParent_Done,
     /*  45580 */   // Label 554: @45580
     /*  45580 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(45674), // Rule ID 4943 //
     /*  45585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45628 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45640 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45644 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45648 */     // MIs[4] C
     /*  45648 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45653 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45655 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45672 */     GIR_RootConstrainSelectedInstOperands,
     /*  45673 */     // GIR_Coverage, 4943,
     /*  45673 */     GIR_EraseRootFromParent_Done,
     /*  45674 */   // Label 555: @45674
     /*  45674 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(45768), // Rule ID 4942 //
     /*  45679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45722 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45728 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45738 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45742 */     // MIs[4] C
     /*  45742 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45747 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45749 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45766 */     GIR_RootConstrainSelectedInstOperands,
     /*  45767 */     // GIR_Coverage, 4942,
     /*  45767 */     GIR_EraseRootFromParent_Done,
     /*  45768 */   // Label 556: @45768
     /*  45768 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(45862), // Rule ID 4944 //
     /*  45773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45820 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45824 */     // MIs[3] C
     /*  45824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45829 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45833 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45839 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45841 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45843 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  45856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  45860 */     GIR_RootConstrainSelectedInstOperands,
     /*  45861 */     // GIR_Coverage, 4944,
     /*  45861 */     GIR_EraseRootFromParent_Done,
     /*  45862 */   // Label 557: @45862
     /*  45862 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(45956), // Rule ID 4946 //
     /*  45867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45914 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45918 */     // MIs[3] C
     /*  45918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45923 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45927 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45933 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45937 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  45950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  45954 */     GIR_RootConstrainSelectedInstOperands,
     /*  45955 */     // GIR_Coverage, 4946,
     /*  45955 */     GIR_EraseRootFromParent_Done,
     /*  45956 */   // Label 558: @45956
     /*  45956 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(46050), // Rule ID 4945 //
     /*  45961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46008 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46012 */     // MIs[3] C
     /*  46012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  46017 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46021 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46027 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46029 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46031 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  46044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  46048 */     GIR_RootConstrainSelectedInstOperands,
     /*  46049 */     // GIR_Coverage, 4945,
     /*  46049 */     GIR_EraseRootFromParent_Done,
     /*  46050 */   // Label 559: @46050
     /*  46050 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(46144), // Rule ID 4947 //
     /*  46055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  46058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46102 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46106 */     // MIs[3] C
     /*  46106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  46111 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46115 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46123 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46125 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  46138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  46142 */     GIR_RootConstrainSelectedInstOperands,
     /*  46143 */     // GIR_Coverage, 4947,
     /*  46143 */     GIR_EraseRootFromParent_Done,
     /*  46144 */   // Label 560: @46144
     /*  46144 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(46231), // Rule ID 4967 //
     /*  46149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46192 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46198 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46202 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46219 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  46229 */     GIR_RootConstrainSelectedInstOperands,
     /*  46230 */     // GIR_Coverage, 4967,
     /*  46230 */     GIR_EraseRootFromParent_Done,
     /*  46231 */   // Label 561: @46231
     /*  46231 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(46316), // Rule ID 4961 //
     /*  46236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46279 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46285 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46289 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  46302 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46304 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46314 */     GIR_RootConstrainSelectedInstOperands,
     /*  46315 */     // GIR_Coverage, 4961,
     /*  46315 */     GIR_EraseRootFromParent_Done,
     /*  46316 */   // Label 562: @46316
     /*  46316 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(46401), // Rule ID 4962 //
     /*  46321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46364 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46370 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46374 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46387 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46389 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46399 */     GIR_RootConstrainSelectedInstOperands,
     /*  46400 */     // GIR_Coverage, 4962,
     /*  46400 */     GIR_EraseRootFromParent_Done,
     /*  46401 */   // Label 563: @46401
     /*  46401 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(46488), // Rule ID 4963 //
     /*  46406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46449 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46455 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46459 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46476 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46486 */     GIR_RootConstrainSelectedInstOperands,
     /*  46487 */     // GIR_Coverage, 4963,
     /*  46487 */     GIR_EraseRootFromParent_Done,
     /*  46488 */   // Label 564: @46488
     /*  46488 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(46573), // Rule ID 5282 //
     /*  46493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46536 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46542 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46546 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  46546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46551 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46561 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  46571 */     GIR_RootConstrainSelectedInstOperands,
     /*  46572 */     // GIR_Coverage, 5282,
     /*  46572 */     GIR_EraseRootFromParent_Done,
     /*  46573 */   // Label 565: @46573
     /*  46573 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(46658), // Rule ID 5283 //
     /*  46578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46621 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46627 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46631 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  46631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46636 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46646 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  46656 */     GIR_RootConstrainSelectedInstOperands,
     /*  46657 */     // GIR_Coverage, 5283,
     /*  46657 */     GIR_EraseRootFromParent_Done,
     /*  46658 */   // Label 566: @46658
     /*  46658 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(46743), // Rule ID 5280 //
     /*  46663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46706 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46712 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46716 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46721 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46731 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46741 */     GIR_RootConstrainSelectedInstOperands,
     /*  46742 */     // GIR_Coverage, 5280,
     /*  46742 */     GIR_EraseRootFromParent_Done,
     /*  46743 */   // Label 567: @46743
     /*  46743 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(46828), // Rule ID 5279 //
     /*  46748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46791 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46797 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46801 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46806 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46816 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46826 */     GIR_RootConstrainSelectedInstOperands,
     /*  46827 */     // GIR_Coverage, 5279,
     /*  46827 */     GIR_EraseRootFromParent_Done,
     /*  46828 */   // Label 568: @46828
     /*  46828 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(46913), // Rule ID 5281 //
     /*  46833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46876 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46882 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46886 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46891 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  46901 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46911 */     GIR_RootConstrainSelectedInstOperands,
     /*  46912 */     // GIR_Coverage, 5281,
     /*  46912 */     GIR_EraseRootFromParent_Done,
     /*  46913 */   // Label 569: @46913
     /*  46913 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(47000), // Rule ID 3391 //
     /*  46918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46945 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46951 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46961 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46965 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46971 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  46980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  46984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  46988 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  46998 */     GIR_RootConstrainSelectedInstOperands,
     /*  46999 */     // GIR_Coverage, 3391,
     /*  46999 */     GIR_EraseRootFromParent_Done,
     /*  47000 */   // Label 570: @47000
     /*  47000 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(47087), // Rule ID 3389 //
     /*  47005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47032 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47038 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47048 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47052 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47058 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47075 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47085 */     GIR_RootConstrainSelectedInstOperands,
     /*  47086 */     // GIR_Coverage, 3389,
     /*  47086 */     GIR_EraseRootFromParent_Done,
     /*  47087 */   // Label 571: @47087
     /*  47087 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(47174), // Rule ID 3390 //
     /*  47092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47119 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47125 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47135 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47139 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47145 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47162 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47172 */     GIR_RootConstrainSelectedInstOperands,
     /*  47173 */     // GIR_Coverage, 3390,
     /*  47173 */     GIR_EraseRootFromParent_Done,
     /*  47174 */   // Label 572: @47174
     /*  47174 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(47261), // Rule ID 4966 //
     /*  47179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47232 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47249 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47259 */     GIR_RootConstrainSelectedInstOperands,
     /*  47260 */     // GIR_Coverage, 4966,
     /*  47260 */     GIR_EraseRootFromParent_Done,
     /*  47261 */   // Label 573: @47261
     /*  47261 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(47346), // Rule ID 4964 //
     /*  47266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47309 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47319 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  47332 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47334 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47344 */     GIR_RootConstrainSelectedInstOperands,
     /*  47345 */     // GIR_Coverage, 4964,
     /*  47345 */     GIR_EraseRootFromParent_Done,
     /*  47346 */   // Label 574: @47346
     /*  47346 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(47431), // Rule ID 4965 //
     /*  47351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47394 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47404 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47417 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47419 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47429 */     GIR_RootConstrainSelectedInstOperands,
     /*  47430 */     // GIR_Coverage, 4965,
     /*  47430 */     GIR_EraseRootFromParent_Done,
     /*  47431 */   // Label 575: @47431
     /*  47431 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(47516), // Rule ID 3404 //
     /*  47436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47479 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47485 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47489 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  47489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47494 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47504 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  47514 */     GIR_RootConstrainSelectedInstOperands,
     /*  47515 */     // GIR_Coverage, 3404,
     /*  47515 */     GIR_EraseRootFromParent_Done,
     /*  47516 */   // Label 576: @47516
     /*  47516 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(47601), // Rule ID 3405 //
     /*  47521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47564 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47570 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47574 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  47574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47579 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47589 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  47599 */     GIR_RootConstrainSelectedInstOperands,
     /*  47600 */     // GIR_Coverage, 3405,
     /*  47600 */     GIR_EraseRootFromParent_Done,
     /*  47601 */   // Label 577: @47601
     /*  47601 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(47686), // Rule ID 5277 //
     /*  47606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47649 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47655 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47659 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47664 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47674 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47684 */     GIR_RootConstrainSelectedInstOperands,
     /*  47685 */     // GIR_Coverage, 5277,
     /*  47685 */     GIR_EraseRootFromParent_Done,
     /*  47686 */   // Label 578: @47686
     /*  47686 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(47771), // Rule ID 3403 //
     /*  47691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47734 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47744 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47749 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47759 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47769 */     GIR_RootConstrainSelectedInstOperands,
     /*  47770 */     // GIR_Coverage, 3403,
     /*  47770 */     GIR_EraseRootFromParent_Done,
     /*  47771 */   // Label 579: @47771
     /*  47771 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(47856), // Rule ID 5278 //
     /*  47776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47819 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47825 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47829 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47834 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  47844 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47854 */     GIR_RootConstrainSelectedInstOperands,
     /*  47855 */     // GIR_Coverage, 5278,
     /*  47855 */     GIR_EraseRootFromParent_Done,
     /*  47856 */   // Label 580: @47856
     /*  47856 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(47911), // Rule ID 4931 //
     /*  47861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47888 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47894 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47898 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47903 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  47905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47909 */     GIR_RootConstrainSelectedInstOperands,
     /*  47910 */     // GIR_Coverage, 4931,
     /*  47910 */     GIR_EraseRootFromParent_Done,
     /*  47911 */   // Label 581: @47911
     /*  47911 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(47966), // Rule ID 942 //
     /*  47916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47943 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47953 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47958 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*  47960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47964 */     GIR_RootConstrainSelectedInstOperands,
     /*  47965 */     // GIR_Coverage, 942,
     /*  47965 */     GIR_EraseRootFromParent_Done,
     /*  47966 */   // Label 582: @47966
     /*  47966 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(48016), // Rule ID 5276 //
     /*  47971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47996 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  47996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48001 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  48003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48014 */     GIR_RootConstrainSelectedInstOperands,
     /*  48015 */     // GIR_Coverage, 5276,
     /*  48015 */     GIR_EraseRootFromParent_Done,
     /*  48016 */   // Label 583: @48016
     /*  48016 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(48066), // Rule ID 5275 //
     /*  48021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48046 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  48055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  48059 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  48061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48064 */     GIR_RootConstrainSelectedInstOperands,
     /*  48065 */     // GIR_Coverage, 5275,
     /*  48065 */     GIR_EraseRootFromParent_Done,
     /*  48066 */   // Label 584: @48066
     /*  48066 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(48116), // Rule ID 5284 //
     /*  48071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48096 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48101 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  48103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48114 */     GIR_RootConstrainSelectedInstOperands,
     /*  48115 */     // GIR_Coverage, 5284,
     /*  48115 */     GIR_EraseRootFromParent_Done,
     /*  48116 */   // Label 585: @48116
     /*  48116 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(48166), // Rule ID 3402 //
     /*  48121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48146 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  48146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48151 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48164 */     GIR_RootConstrainSelectedInstOperands,
     /*  48165 */     // GIR_Coverage, 3402,
     /*  48165 */     GIR_EraseRootFromParent_Done,
     /*  48166 */   // Label 586: @48166
     /*  48166 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(48216), // Rule ID 3401 //
     /*  48171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48196 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48201 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48214 */     GIR_RootConstrainSelectedInstOperands,
     /*  48215 */     // GIR_Coverage, 3401,
     /*  48215 */     GIR_EraseRootFromParent_Done,
     /*  48216 */   // Label 587: @48216
     /*  48216 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(48266), // Rule ID 3406 //
     /*  48221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48246 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48251 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48264 */     GIR_RootConstrainSelectedInstOperands,
     /*  48265 */     // GIR_Coverage, 3406,
     /*  48265 */     GIR_EraseRootFromParent_Done,
     /*  48266 */   // Label 588: @48266
     /*  48266 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(48285), // Rule ID 931 //
     /*  48271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  48274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48278 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  48278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLOR),
     /*  48283 */     GIR_RootConstrainSelectedInstOperands,
     /*  48284 */     // GIR_Coverage, 931,
     /*  48284 */     GIR_Done,
     /*  48285 */   // Label 589: @48285
     /*  48285 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(48340), // Rule ID 4919 //
     /*  48290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48317 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48327 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48332 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  48334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48338 */     GIR_RootConstrainSelectedInstOperands,
     /*  48339 */     // GIR_Coverage, 4919,
     /*  48339 */     GIR_EraseRootFromParent_Done,
     /*  48340 */   // Label 590: @48340
     /*  48340 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(48395), // Rule ID 489 //
     /*  48345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48372 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48382 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48387 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*  48389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48393 */     GIR_RootConstrainSelectedInstOperands,
     /*  48394 */     // GIR_Coverage, 489,
     /*  48394 */     GIR_EraseRootFromParent_Done,
     /*  48395 */   // Label 591: @48395
     /*  48395 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(48414), // Rule ID 386 //
     /*  48400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  48403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48407 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VOR),
     /*  48412 */     GIR_RootConstrainSelectedInstOperands,
     /*  48413 */     // GIR_Coverage, 386,
     /*  48413 */     GIR_Done,
     /*  48414 */   // Label 592: @48414
     /*  48414 */   GIM_Reject,
     /*  48415 */ // Label 264: @48415
     /*  48415 */ GIM_Reject,
     /*  48416 */ // Label 251: @48416
     /*  48416 */ GIM_Reject,
     /*  48417 */ // Label 9: @48417
     /*  48417 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 597*/ GIMT_Encode4(57523),
     /*  48428 */ /*GILLT_s1*//*Label 593*/ GIMT_Encode4(48452),
     /*  48432 */ /*GILLT_s32*//*Label 594*/ GIMT_Encode4(53889),
     /*  48436 */ /*GILLT_s64*//*Label 595*/ GIMT_Encode4(54144), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48448 */ /*GILLT_v4s32*//*Label 596*/ GIMT_Encode4(54399),
     /*  48452 */ // Label 593: @48452
     /*  48452 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(53888),
     /*  48457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  48460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  48463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48467 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(48558), // Rule ID 3028 //
     /*  48472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48487 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48491 */     // MIs[1] Operand 1
     /*  48491 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48504 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48508 */     // MIs[2] Operand 1
     /*  48508 */     // No operand predicates
     /*  48508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48514 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  48514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48557 */     // GIR_Coverage, 3028,
     /*  48557 */     GIR_EraseRootFromParent_Done,
     /*  48558 */   // Label 599: @48558
     /*  48558 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(48649), // Rule ID 3044 //
     /*  48563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48578 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48582 */     // MIs[1] Operand 1
     /*  48582 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48599 */     // MIs[2] Operand 1
     /*  48599 */     // No operand predicates
     /*  48599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48605 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  48605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48648 */     // GIR_Coverage, 3044,
     /*  48648 */     GIR_EraseRootFromParent_Done,
     /*  48649 */   // Label 600: @48649
     /*  48649 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(48740), // Rule ID 3052 //
     /*  48654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48669 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48673 */     // MIs[1] Operand 1
     /*  48673 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48686 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48690 */     // MIs[2] Operand 1
     /*  48690 */     // No operand predicates
     /*  48690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48696 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  48696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48722 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  48729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48739 */     // GIR_Coverage, 3052,
     /*  48739 */     GIR_EraseRootFromParent_Done,
     /*  48740 */   // Label 601: @48740
     /*  48740 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(48831), // Rule ID 3124 //
     /*  48745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48760 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48764 */     // MIs[1] Operand 1
     /*  48764 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48781 */     // MIs[2] Operand 1
     /*  48781 */     // No operand predicates
     /*  48781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48787 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  48787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48813 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48830 */     // GIR_Coverage, 3124,
     /*  48830 */     GIR_EraseRootFromParent_Done,
     /*  48831 */   // Label 602: @48831
     /*  48831 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(48922), // Rule ID 3140 //
     /*  48836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48851 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48855 */     // MIs[1] Operand 1
     /*  48855 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48872 */     // MIs[2] Operand 1
     /*  48872 */     // No operand predicates
     /*  48872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48878 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  48878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48904 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48921 */     // GIR_Coverage, 3140,
     /*  48921 */     GIR_EraseRootFromParent_Done,
     /*  48922 */   // Label 603: @48922
     /*  48922 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(49013), // Rule ID 3148 //
     /*  48927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48942 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48946 */     // MIs[1] Operand 1
     /*  48946 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48959 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48963 */     // MIs[2] Operand 1
     /*  48963 */     // No operand predicates
     /*  48963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48969 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  48969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48995 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49012 */     // GIR_Coverage, 3148,
     /*  49012 */     GIR_EraseRootFromParent_Done,
     /*  49013 */   // Label 604: @49013
     /*  49013 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(49104), // Rule ID 3810 //
     /*  49018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49033 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49037 */     // MIs[1] Operand 1
     /*  49037 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49050 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49054 */     // MIs[2] Operand 1
     /*  49054 */     // No operand predicates
     /*  49054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49060 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  49060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49086 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49103 */     // GIR_Coverage, 3810,
     /*  49103 */     GIR_EraseRootFromParent_Done,
     /*  49104 */   // Label 605: @49104
     /*  49104 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(49195), // Rule ID 3826 //
     /*  49109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49128 */     // MIs[1] Operand 1
     /*  49128 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49141 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49145 */     // MIs[2] Operand 1
     /*  49145 */     // No operand predicates
     /*  49145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49151 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  49151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49177 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49194 */     // GIR_Coverage, 3826,
     /*  49194 */     GIR_EraseRootFromParent_Done,
     /*  49195 */   // Label 606: @49195
     /*  49195 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(49286), // Rule ID 3834 //
     /*  49200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49215 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49219 */     // MIs[1] Operand 1
     /*  49219 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49232 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49236 */     // MIs[2] Operand 1
     /*  49236 */     // No operand predicates
     /*  49236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49242 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  49242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49268 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49285 */     // GIR_Coverage, 3834,
     /*  49285 */     GIR_EraseRootFromParent_Done,
     /*  49286 */   // Label 607: @49286
     /*  49286 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(49377), // Rule ID 3906 //
     /*  49291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49306 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49310 */     // MIs[1] Operand 1
     /*  49310 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49323 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49327 */     // MIs[2] Operand 1
     /*  49327 */     // No operand predicates
     /*  49327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49333 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  49333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49359 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49376 */     // GIR_Coverage, 3906,
     /*  49376 */     GIR_EraseRootFromParent_Done,
     /*  49377 */   // Label 608: @49377
     /*  49377 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(49468), // Rule ID 3922 //
     /*  49382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49397 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49401 */     // MIs[1] Operand 1
     /*  49401 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49414 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49418 */     // MIs[2] Operand 1
     /*  49418 */     // No operand predicates
     /*  49418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49424 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  49424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49450 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49467 */     // GIR_Coverage, 3922,
     /*  49467 */     GIR_EraseRootFromParent_Done,
     /*  49468 */   // Label 609: @49468
     /*  49468 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(49559), // Rule ID 3930 //
     /*  49473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49488 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49492 */     // MIs[1] Operand 1
     /*  49492 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49509 */     // MIs[2] Operand 1
     /*  49509 */     // No operand predicates
     /*  49509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49515 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  49515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49558 */     // GIR_Coverage, 3930,
     /*  49558 */     GIR_EraseRootFromParent_Done,
     /*  49559 */   // Label 610: @49559
     /*  49559 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(49639), // Rule ID 3172 //
     /*  49564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49579 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49583 */     // MIs[1] Operand 1
     /*  49583 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49594 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  49594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49610 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49621 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49638 */     // GIR_Coverage, 3172,
     /*  49638 */     GIR_EraseRootFromParent_Done,
     /*  49639 */   // Label 611: @49639
     /*  49639 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(49719), // Rule ID 3188 //
     /*  49644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49659 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49663 */     // MIs[1] Operand 1
     /*  49663 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  49668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49674 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  49674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49701 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49718 */     // GIR_Coverage, 3188,
     /*  49718 */     GIR_EraseRootFromParent_Done,
     /*  49719 */   // Label 612: @49719
     /*  49719 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(49799), // Rule ID 3204 //
     /*  49724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49739 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49743 */     // MIs[1] Operand 1
     /*  49743 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  49748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49754 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  49754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49781 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49798 */     // GIR_Coverage, 3204,
     /*  49798 */     GIR_EraseRootFromParent_Done,
     /*  49799 */   // Label 613: @49799
     /*  49799 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(49879), // Rule ID 3220 //
     /*  49804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49819 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49823 */     // MIs[1] Operand 1
     /*  49823 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  49828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49834 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  49834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49861 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  49868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49878 */     // GIR_Coverage, 3220,
     /*  49878 */     GIR_EraseRootFromParent_Done,
     /*  49879 */   // Label 614: @49879
     /*  49879 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(49959), // Rule ID 3228 //
     /*  49884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49899 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49903 */     // MIs[1] Operand 1
     /*  49903 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49914 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  49914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  49921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49926 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49958 */     // GIR_Coverage, 3228,
     /*  49958 */     GIR_EraseRootFromParent_Done,
     /*  49959 */   // Label 615: @49959
     /*  49959 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(50039), // Rule ID 3244 //
     /*  49964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49979 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49983 */     // MIs[1] Operand 1
     /*  49983 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  49988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49994 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  49994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50021 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50038 */     // GIR_Coverage, 3244,
     /*  50038 */     GIR_EraseRootFromParent_Done,
     /*  50039 */   // Label 616: @50039
     /*  50039 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(50119), // Rule ID 3260 //
     /*  50044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50059 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50063 */     // MIs[1] Operand 1
     /*  50063 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50074 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  50074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50101 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50118 */     // GIR_Coverage, 3260,
     /*  50118 */     GIR_EraseRootFromParent_Done,
     /*  50119 */   // Label 617: @50119
     /*  50119 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(50199), // Rule ID 3276 //
     /*  50124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50139 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50143 */     // MIs[1] Operand 1
     /*  50143 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50154 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  50154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50181 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50198 */     // GIR_Coverage, 3276,
     /*  50198 */     GIR_EraseRootFromParent_Done,
     /*  50199 */   // Label 618: @50199
     /*  50199 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(50279), // Rule ID 3284 //
     /*  50204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50219 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50223 */     // MIs[1] Operand 1
     /*  50223 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50234 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  50234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50261 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50278 */     // GIR_Coverage, 3284,
     /*  50278 */     GIR_EraseRootFromParent_Done,
     /*  50279 */   // Label 619: @50279
     /*  50279 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(50359), // Rule ID 3300 //
     /*  50284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50299 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50303 */     // MIs[1] Operand 1
     /*  50303 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50314 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  50314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50326 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50341 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50358 */     // GIR_Coverage, 3300,
     /*  50358 */     GIR_EraseRootFromParent_Done,
     /*  50359 */   // Label 620: @50359
     /*  50359 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(50439), // Rule ID 3316 //
     /*  50364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50379 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50383 */     // MIs[1] Operand 1
     /*  50383 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50394 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  50394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50421 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50438 */     // GIR_Coverage, 3316,
     /*  50438 */     GIR_EraseRootFromParent_Done,
     /*  50439 */   // Label 621: @50439
     /*  50439 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(50519), // Rule ID 3332 //
     /*  50444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50459 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50463 */     // MIs[1] Operand 1
     /*  50463 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50474 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  50474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50501 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50518 */     // GIR_Coverage, 3332,
     /*  50518 */     GIR_EraseRootFromParent_Done,
     /*  50519 */   // Label 622: @50519
     /*  50519 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(50599), // Rule ID 4010 //
     /*  50524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50539 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50543 */     // MIs[1] Operand 1
     /*  50543 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50554 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  50554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50581 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50598 */     // GIR_Coverage, 4010,
     /*  50598 */     GIR_EraseRootFromParent_Done,
     /*  50599 */   // Label 623: @50599
     /*  50599 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(50679), // Rule ID 4042 //
     /*  50604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50619 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50623 */     // MIs[1] Operand 1
     /*  50623 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50634 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  50634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50678 */     // GIR_Coverage, 4042,
     /*  50678 */     GIR_EraseRootFromParent_Done,
     /*  50679 */   // Label 624: @50679
     /*  50679 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(50759), // Rule ID 4074 //
     /*  50684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50699 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50703 */     // MIs[1] Operand 1
     /*  50703 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50714 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  50714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50741 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50758 */     // GIR_Coverage, 4074,
     /*  50758 */     GIR_EraseRootFromParent_Done,
     /*  50759 */   // Label 625: @50759
     /*  50759 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(50839), // Rule ID 4106 //
     /*  50764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50779 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50783 */     // MIs[1] Operand 1
     /*  50783 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50794 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  50794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50821 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50838 */     // GIR_Coverage, 4106,
     /*  50838 */     GIR_EraseRootFromParent_Done,
     /*  50839 */   // Label 626: @50839
     /*  50839 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(50919), // Rule ID 4122 //
     /*  50844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50863 */     // MIs[1] Operand 1
     /*  50863 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50874 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  50874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50901 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50918 */     // GIR_Coverage, 4122,
     /*  50918 */     GIR_EraseRootFromParent_Done,
     /*  50919 */   // Label 627: @50919
     /*  50919 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(50999), // Rule ID 4154 //
     /*  50924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50939 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50943 */     // MIs[1] Operand 1
     /*  50943 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50954 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  50954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50981 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50998 */     // GIR_Coverage, 4154,
     /*  50998 */     GIR_EraseRootFromParent_Done,
     /*  50999 */   // Label 628: @50999
     /*  50999 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(51079), // Rule ID 4186 //
     /*  51004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51019 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51023 */     // MIs[1] Operand 1
     /*  51023 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51034 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  51034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51078 */     // GIR_Coverage, 4186,
     /*  51078 */     GIR_EraseRootFromParent_Done,
     /*  51079 */   // Label 629: @51079
     /*  51079 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(51159), // Rule ID 4218 //
     /*  51084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51099 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51103 */     // MIs[1] Operand 1
     /*  51103 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51114 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  51114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51158 */     // GIR_Coverage, 4218,
     /*  51158 */     GIR_EraseRootFromParent_Done,
     /*  51159 */   // Label 630: @51159
     /*  51159 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(51239), // Rule ID 4248 //
     /*  51164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51179 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51183 */     // MIs[1] Operand 1
     /*  51183 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51194 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  51194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51210 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51221 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  51228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51238 */     // GIR_Coverage, 4248,
     /*  51238 */     GIR_EraseRootFromParent_Done,
     /*  51239 */   // Label 631: @51239
     /*  51239 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(51319), // Rule ID 4280 //
     /*  51244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51263 */     // MIs[1] Operand 1
     /*  51263 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51274 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  51274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51301 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51318 */     // GIR_Coverage, 4280,
     /*  51318 */     GIR_EraseRootFromParent_Done,
     /*  51319 */   // Label 632: @51319
     /*  51319 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(51399), // Rule ID 4312 //
     /*  51324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51339 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51343 */     // MIs[1] Operand 1
     /*  51343 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51354 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  51354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51398 */     // GIR_Coverage, 4312,
     /*  51398 */     GIR_EraseRootFromParent_Done,
     /*  51399 */   // Label 633: @51399
     /*  51399 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(51479), // Rule ID 4344 //
     /*  51404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51419 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51423 */     // MIs[1] Operand 1
     /*  51423 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51434 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  51434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51461 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51478 */     // GIR_Coverage, 4344,
     /*  51478 */     GIR_EraseRootFromParent_Done,
     /*  51479 */   // Label 634: @51479
     /*  51479 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(51559), // Rule ID 4575 //
     /*  51484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51503 */     // MIs[1] Operand 1
     /*  51503 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51514 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /*  51521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51558 */     // GIR_Coverage, 4575,
     /*  51558 */     GIR_EraseRootFromParent_Done,
     /*  51559 */   // Label 635: @51559
     /*  51559 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(51639), // Rule ID 4607 //
     /*  51564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51579 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51583 */     // MIs[1] Operand 1
     /*  51583 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51594 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /*  51601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51610 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51621 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51638 */     // GIR_Coverage, 4607,
     /*  51638 */     GIR_EraseRootFromParent_Done,
     /*  51639 */   // Label 636: @51639
     /*  51639 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(51719), // Rule ID 4639 //
     /*  51644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51659 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51663 */     // MIs[1] Operand 1
     /*  51663 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51674 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /*  51681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51701 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51718 */     // GIR_Coverage, 4639,
     /*  51718 */     GIR_EraseRootFromParent_Done,
     /*  51719 */   // Label 637: @51719
     /*  51719 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(51799), // Rule ID 4683 //
     /*  51724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51739 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51743 */     // MIs[1] Operand 1
     /*  51743 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51754 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /*  51761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51781 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51798 */     // GIR_Coverage, 4683,
     /*  51798 */     GIR_EraseRootFromParent_Done,
     /*  51799 */   // Label 638: @51799
     /*  51799 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(51879), // Rule ID 4715 //
     /*  51804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51819 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51823 */     // MIs[1] Operand 1
     /*  51823 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51834 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /*  51841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51861 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51878 */     // GIR_Coverage, 4715,
     /*  51878 */     GIR_EraseRootFromParent_Done,
     /*  51879 */   // Label 639: @51879
     /*  51879 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(51959), // Rule ID 4747 //
     /*  51884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51899 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51903 */     // MIs[1] Operand 1
     /*  51903 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51914 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /*  51921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51926 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51958 */     // GIR_Coverage, 4747,
     /*  51958 */     GIR_EraseRootFromParent_Done,
     /*  51959 */   // Label 640: @51959
     /*  51959 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(52039), // Rule ID 2974 //
     /*  51964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  51967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  51975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51979 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51983 */     // MIs[1] Operand 1
     /*  51983 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  51988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51994 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  51994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52021 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52038 */     // GIR_Coverage, 2974,
     /*  52038 */     GIR_EraseRootFromParent_Done,
     /*  52039 */   // Label 641: @52039
     /*  52039 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(52119), // Rule ID 2988 //
     /*  52044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52059 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52063 */     // MIs[1] Operand 1
     /*  52063 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52074 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52101 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52118 */     // GIR_Coverage, 2988,
     /*  52118 */     GIR_EraseRootFromParent_Done,
     /*  52119 */   // Label 642: @52119
     /*  52119 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(52199), // Rule ID 2996 //
     /*  52124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52139 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52143 */     // MIs[1] Operand 1
     /*  52143 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52154 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52181 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52198 */     // GIR_Coverage, 2996,
     /*  52198 */     GIR_EraseRootFromParent_Done,
     /*  52199 */   // Label 643: @52199
     /*  52199 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(52279), // Rule ID 3004 //
     /*  52204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52219 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52223 */     // MIs[1] Operand 1
     /*  52223 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52234 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52261 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52278 */     // GIR_Coverage, 3004,
     /*  52278 */     GIR_EraseRootFromParent_Done,
     /*  52279 */   // Label 644: @52279
     /*  52279 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(52359), // Rule ID 3012 //
     /*  52284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52299 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52303 */     // MIs[1] Operand 1
     /*  52303 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52314 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  52314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52326 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52341 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52358 */     // GIR_Coverage, 3012,
     /*  52358 */     GIR_EraseRootFromParent_Done,
     /*  52359 */   // Label 645: @52359
     /*  52359 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(52439), // Rule ID 3076 //
     /*  52364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52379 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52383 */     // MIs[1] Operand 1
     /*  52383 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52394 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52421 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52438 */     // GIR_Coverage, 3076,
     /*  52438 */     GIR_EraseRootFromParent_Done,
     /*  52439 */   // Label 646: @52439
     /*  52439 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(52519), // Rule ID 3084 //
     /*  52444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52459 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52463 */     // MIs[1] Operand 1
     /*  52463 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52474 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52501 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52518 */     // GIR_Coverage, 3084,
     /*  52518 */     GIR_EraseRootFromParent_Done,
     /*  52519 */   // Label 647: @52519
     /*  52519 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(52599), // Rule ID 3092 //
     /*  52524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52539 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52543 */     // MIs[1] Operand 1
     /*  52543 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52554 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52581 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52598 */     // GIR_Coverage, 3092,
     /*  52598 */     GIR_EraseRootFromParent_Done,
     /*  52599 */   // Label 648: @52599
     /*  52599 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(52679), // Rule ID 3100 //
     /*  52604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52619 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52623 */     // MIs[1] Operand 1
     /*  52623 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52634 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52678 */     // GIR_Coverage, 3100,
     /*  52678 */     GIR_EraseRootFromParent_Done,
     /*  52679 */   // Label 649: @52679
     /*  52679 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(52759), // Rule ID 3108 //
     /*  52684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52699 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52703 */     // MIs[1] Operand 1
     /*  52703 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52714 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  52714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52741 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52758 */     // GIR_Coverage, 3108,
     /*  52758 */     GIR_EraseRootFromParent_Done,
     /*  52759 */   // Label 650: @52759
     /*  52759 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(52839), // Rule ID 3858 //
     /*  52764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52779 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52783 */     // MIs[1] Operand 1
     /*  52783 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52794 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52821 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52838 */     // GIR_Coverage, 3858,
     /*  52838 */     GIR_EraseRootFromParent_Done,
     /*  52839 */   // Label 651: @52839
     /*  52839 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(52919), // Rule ID 3866 //
     /*  52844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52863 */     // MIs[1] Operand 1
     /*  52863 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52874 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52901 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52918 */     // GIR_Coverage, 3866,
     /*  52918 */     GIR_EraseRootFromParent_Done,
     /*  52919 */   // Label 652: @52919
     /*  52919 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(52999), // Rule ID 3874 //
     /*  52924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52939 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52943 */     // MIs[1] Operand 1
     /*  52943 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52954 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52981 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52998 */     // GIR_Coverage, 3874,
     /*  52998 */     GIR_EraseRootFromParent_Done,
     /*  52999 */   // Label 653: @52999
     /*  52999 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(53079), // Rule ID 3882 //
     /*  53004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53019 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53023 */     // MIs[1] Operand 1
     /*  53023 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53034 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  53034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53078 */     // GIR_Coverage, 3882,
     /*  53078 */     GIR_EraseRootFromParent_Done,
     /*  53079 */   // Label 654: @53079
     /*  53079 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(53159), // Rule ID 3890 //
     /*  53084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53099 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53103 */     // MIs[1] Operand 1
     /*  53103 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53114 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  53114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53158 */     // GIR_Coverage, 3890,
     /*  53158 */     GIR_EraseRootFromParent_Done,
     /*  53159 */   // Label 655: @53159
     /*  53159 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(53239), // Rule ID 3954 //
     /*  53164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53179 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53183 */     // MIs[1] Operand 1
     /*  53183 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  53188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53194 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53210 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53221 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53238 */     // GIR_Coverage, 3954,
     /*  53238 */     GIR_EraseRootFromParent_Done,
     /*  53239 */   // Label 656: @53239
     /*  53239 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(53319), // Rule ID 3962 //
     /*  53244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53263 */     // MIs[1] Operand 1
     /*  53263 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  53268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53274 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53301 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53318 */     // GIR_Coverage, 3962,
     /*  53318 */     GIR_EraseRootFromParent_Done,
     /*  53319 */   // Label 657: @53319
     /*  53319 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(53399), // Rule ID 3970 //
     /*  53324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53339 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53343 */     // MIs[1] Operand 1
     /*  53343 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  53348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53354 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53398 */     // GIR_Coverage, 3970,
     /*  53398 */     GIR_EraseRootFromParent_Done,
     /*  53399 */   // Label 658: @53399
     /*  53399 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(53479), // Rule ID 3978 //
     /*  53404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53419 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53423 */     // MIs[1] Operand 1
     /*  53423 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53434 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53461 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53478 */     // GIR_Coverage, 3978,
     /*  53478 */     GIR_EraseRootFromParent_Done,
     /*  53479 */   // Label 659: @53479
     /*  53479 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(53559), // Rule ID 3986 //
     /*  53484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53503 */     // MIs[1] Operand 1
     /*  53503 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53514 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  53514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53558 */     // GIR_Coverage, 3986,
     /*  53558 */     GIR_EraseRootFromParent_Done,
     /*  53559 */   // Label 660: @53559
     /*  53559 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(53601), // Rule ID 176 //
     /*  53564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53586 */     // (xor:{ *:[i1] } (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNAND),
     /*  53589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53599 */     GIR_RootConstrainSelectedInstOperands,
     /*  53600 */     // GIR_Coverage, 176,
     /*  53600 */     GIR_EraseRootFromParent_Done,
     /*  53601 */   // Label 661: @53601
     /*  53601 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(53643), // Rule ID 179 //
     /*  53606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53628 */     // (xor:{ *:[i1] } (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOR),
     /*  53631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53641 */     GIR_RootConstrainSelectedInstOperands,
     /*  53642 */     // GIR_Coverage, 179,
     /*  53642 */     GIR_EraseRootFromParent_Done,
     /*  53643 */   // Label 662: @53643
     /*  53643 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(53683), // Rule ID 4911 //
     /*  53648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53670 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRB)  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53679 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRB
     /*  53681 */     GIR_RootConstrainSelectedInstOperands,
     /*  53682 */     // GIR_Coverage, 4911,
     /*  53682 */     GIR_EraseRootFromParent_Done,
     /*  53683 */   // Label 663: @53683
     /*  53683 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(53725), // Rule ID 180 //
     /*  53688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53710 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53723 */     GIR_RootConstrainSelectedInstOperands,
     /*  53724 */     // GIR_Coverage, 180,
     /*  53724 */     GIR_EraseRootFromParent_Done,
     /*  53725 */   // Label 664: @53725
     /*  53725 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(53762), // Rule ID 4847 //
     /*  53730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53748 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i32:{ *:[i32] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } ?:{ *:[i32] }:$in)
     /*  53748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /*  53751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53760 */     GIR_RootConstrainSelectedInstOperands,
     /*  53761 */     // GIR_Coverage, 4847,
     /*  53761 */     GIR_EraseRootFromParent_Done,
     /*  53762 */   // Label 665: @53762
     /*  53762 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(53799), // Rule ID 4848 //
     /*  53767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53785 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i64:{ *:[i64] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } ?:{ *:[i64] }:$in)
     /*  53785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /*  53788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53797 */     GIR_RootConstrainSelectedInstOperands,
     /*  53798 */     // GIR_Coverage, 4848,
     /*  53798 */     GIR_EraseRootFromParent_Done,
     /*  53799 */   // Label 666: @53799
     /*  53799 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(53839), // Rule ID 4912 //
     /*  53804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53820 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53826 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }))  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53835 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRB
     /*  53837 */     GIR_RootConstrainSelectedInstOperands,
     /*  53838 */     // GIR_Coverage, 4912,
     /*  53838 */     GIR_EraseRootFromParent_Done,
     /*  53839 */   // Label 667: @53839
     /*  53839 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(53857), // Rule ID 181 //
     /*  53844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53848 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } i1:{ *:[i1] }:$CRA)
     /*  53848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53853 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*  53855 */     GIR_RootConstrainSelectedInstOperands,
     /*  53856 */     // GIR_Coverage, 181,
     /*  53856 */     GIR_EraseRootFromParent_Done,
     /*  53857 */   // Label 668: @53857
     /*  53857 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(53875), // Rule ID 2902 //
     /*  53862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53866 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$in, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$in)
     /*  53866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53871 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  53873 */     GIR_RootConstrainSelectedInstOperands,
     /*  53874 */     // GIR_Coverage, 2902,
     /*  53874 */     GIR_EraseRootFromParent_Done,
     /*  53875 */   // Label 669: @53875
     /*  53875 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(53887), // Rule ID 178 //
     /*  53880 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRXOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*  53885 */     GIR_RootConstrainSelectedInstOperands,
     /*  53886 */     // GIR_Coverage, 178,
     /*  53886 */     GIR_Done,
     /*  53887 */   // Label 670: @53887
     /*  53887 */   GIM_Reject,
     /*  53888 */ // Label 598: @53888
     /*  53888 */ GIM_Reject,
     /*  53889 */ // Label 594: @53889
     /*  53889 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(54143),
     /*  53894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  53904 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(53946), // Rule ID 121 //
     /*  53909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53931 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NAND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  53934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  53940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  53944 */     GIR_RootConstrainSelectedInstOperands,
     /*  53945 */     // GIR_Coverage, 121,
     /*  53945 */     GIR_EraseRootFromParent_Done,
     /*  53946 */   // Label 672: @53946
     /*  53946 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(53988), // Rule ID 125 //
     /*  53951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53973 */     // (xor:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  53976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  53982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  53986 */     GIR_RootConstrainSelectedInstOperands,
     /*  53987 */     // GIR_Coverage, 125,
     /*  53987 */     GIR_EraseRootFromParent_Done,
     /*  53988 */   // Label 673: @53988
     /*  53988 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(54028), // Rule ID 4909 //
     /*  53993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54015 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }), i32:{ *:[i32] }:$RB)  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54024 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54026 */     GIR_RootConstrainSelectedInstOperands,
     /*  54027 */     // GIR_Coverage, 4909,
     /*  54027 */     GIR_EraseRootFromParent_Done,
     /*  54028 */   // Label 674: @54028
     /*  54028 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(54070), // Rule ID 127 //
     /*  54033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54055 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54068 */     GIR_RootConstrainSelectedInstOperands,
     /*  54069 */     // GIR_Coverage, 127,
     /*  54069 */     GIR_EraseRootFromParent_Done,
     /*  54070 */   // Label 675: @54070
     /*  54070 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(54110), // Rule ID 4910 //
     /*  54075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54091 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54097 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }))  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54106 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54108 */     GIR_RootConstrainSelectedInstOperands,
     /*  54109 */     // GIR_Coverage, 4910,
     /*  54109 */     GIR_EraseRootFromParent_Done,
     /*  54110 */   // Label 676: @54110
     /*  54110 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(54130), // Rule ID 1207 //
     /*  54115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54119 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$in)
     /*  54119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  54122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54124 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54126 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54128 */     GIR_RootConstrainSelectedInstOperands,
     /*  54129 */     // GIR_Coverage, 1207,
     /*  54129 */     GIR_EraseRootFromParent_Done,
     /*  54130 */   // Label 677: @54130
     /*  54130 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(54142), // Rule ID 128 //
     /*  54135 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (XOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR),
     /*  54140 */     GIR_RootConstrainSelectedInstOperands,
     /*  54141 */     // GIR_Coverage, 128,
     /*  54141 */     GIR_Done,
     /*  54142 */   // Label 678: @54142
     /*  54142 */   GIM_Reject,
     /*  54143 */ // Label 671: @54143
     /*  54143 */ GIM_Reject,
     /*  54144 */ // Label 595: @54144
     /*  54144 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(54398),
     /*  54149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  54159 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(54201), // Rule ID 641 //
     /*  54164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54186 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NAND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  54189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54199 */     GIR_RootConstrainSelectedInstOperands,
     /*  54200 */     // GIR_Coverage, 641,
     /*  54200 */     GIR_EraseRootFromParent_Done,
     /*  54201 */   // Label 680: @54201
     /*  54201 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(54243), // Rule ID 645 //
     /*  54206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54228 */     // (xor:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54241 */     GIR_RootConstrainSelectedInstOperands,
     /*  54242 */     // GIR_Coverage, 645,
     /*  54242 */     GIR_EraseRootFromParent_Done,
     /*  54243 */   // Label 681: @54243
     /*  54243 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(54283), // Rule ID 4922 //
     /*  54248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54264 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54270 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }), i64:{ *:[i64] }:$RB)  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54279 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54281 */     GIR_RootConstrainSelectedInstOperands,
     /*  54282 */     // GIR_Coverage, 4922,
     /*  54282 */     GIR_EraseRootFromParent_Done,
     /*  54283 */   // Label 682: @54283
     /*  54283 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(54325), // Rule ID 647 //
     /*  54288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54310 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54323 */     GIR_RootConstrainSelectedInstOperands,
     /*  54324 */     // GIR_Coverage, 647,
     /*  54324 */     GIR_EraseRootFromParent_Done,
     /*  54325 */   // Label 683: @54325
     /*  54325 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(54365), // Rule ID 4923 //
     /*  54330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54346 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54352 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }))  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54361 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54363 */     GIR_RootConstrainSelectedInstOperands,
     /*  54364 */     // GIR_Coverage, 4923,
     /*  54364 */     GIR_EraseRootFromParent_Done,
     /*  54365 */   // Label 684: @54365
     /*  54365 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(54385), // Rule ID 1519 //
     /*  54370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54374 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i64] }:$in)
     /*  54374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54379 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54381 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54383 */     GIR_RootConstrainSelectedInstOperands,
     /*  54384 */     // GIR_Coverage, 1519,
     /*  54384 */     GIR_EraseRootFromParent_Done,
     /*  54385 */   // Label 685: @54385
     /*  54385 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(54397), // Rule ID 648 //
     /*  54390 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (XOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR8),
     /*  54395 */     GIR_RootConstrainSelectedInstOperands,
     /*  54396 */     // GIR_Coverage, 648,
     /*  54396 */     GIR_Done,
     /*  54397 */   // Label 686: @54397
     /*  54397 */   GIM_Reject,
     /*  54398 */ // Label 679: @54398
     /*  54398 */ GIM_Reject,
     /*  54399 */ // Label 596: @54399
     /*  54399 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(57522),
     /*  54404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54410 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(54497), // Rule ID 4958 //
     /*  54415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54458 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54468 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  54477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  54481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  54485 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54495 */     GIR_RootConstrainSelectedInstOperands,
     /*  54496 */     // GIR_Coverage, 4958,
     /*  54496 */     GIR_EraseRootFromParent_Done,
     /*  54497 */   // Label 688: @54497
     /*  54497 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(54584), // Rule ID 4960 //
     /*  54502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54545 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54551 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54555 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54572 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54582 */     GIR_RootConstrainSelectedInstOperands,
     /*  54583 */     // GIR_Coverage, 4960,
     /*  54583 */     GIR_EraseRootFromParent_Done,
     /*  54584 */   // Label 689: @54584
     /*  54584 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(54671), // Rule ID 4959 //
     /*  54589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54632 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54638 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54642 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54659 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54669 */     GIR_RootConstrainSelectedInstOperands,
     /*  54670 */     // GIR_Coverage, 4959,
     /*  54670 */     GIR_EraseRootFromParent_Done,
     /*  54671 */   // Label 690: @54671
     /*  54671 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(54758), // Rule ID 3386 //
     /*  54676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54719 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54725 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54729 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54746 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54756 */     GIR_RootConstrainSelectedInstOperands,
     /*  54757 */     // GIR_Coverage, 3386,
     /*  54757 */     GIR_EraseRootFromParent_Done,
     /*  54758 */   // Label 691: @54758
     /*  54758 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(54845), // Rule ID 3388 //
     /*  54763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54806 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54812 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54816 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54833 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54843 */     GIR_RootConstrainSelectedInstOperands,
     /*  54844 */     // GIR_Coverage, 3388,
     /*  54844 */     GIR_EraseRootFromParent_Done,
     /*  54845 */   // Label 692: @54845
     /*  54845 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(54932), // Rule ID 3387 //
     /*  54850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54893 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54903 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54920 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54930 */     GIR_RootConstrainSelectedInstOperands,
     /*  54931 */     // GIR_Coverage, 3387,
     /*  54931 */     GIR_EraseRootFromParent_Done,
     /*  54932 */   // Label 693: @54932
     /*  54932 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(55019), // Rule ID 5258 //
     /*  54937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54980 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54986 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54990 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  54990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  54999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  55003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55007 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55017 */     GIR_RootConstrainSelectedInstOperands,
     /*  55018 */     // GIR_Coverage, 5258,
     /*  55018 */     GIR_EraseRootFromParent_Done,
     /*  55019 */   // Label 694: @55019
     /*  55019 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(55106), // Rule ID 5266 //
     /*  55024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55067 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55077 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55104 */     GIR_RootConstrainSelectedInstOperands,
     /*  55105 */     // GIR_Coverage, 5266,
     /*  55105 */     GIR_EraseRootFromParent_Done,
     /*  55106 */   // Label 695: @55106
     /*  55106 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(55193), // Rule ID 5265 //
     /*  55111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55154 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55160 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55164 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  55177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55181 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55191 */     GIR_RootConstrainSelectedInstOperands,
     /*  55192 */     // GIR_Coverage, 5265,
     /*  55192 */     GIR_EraseRootFromParent_Done,
     /*  55193 */   // Label 696: @55193
     /*  55193 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(55280), // Rule ID 5274 //
     /*  55198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55241 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55251 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55268 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55278 */     GIR_RootConstrainSelectedInstOperands,
     /*  55279 */     // GIR_Coverage, 5274,
     /*  55279 */     GIR_EraseRootFromParent_Done,
     /*  55280 */   // Label 697: @55280
     /*  55280 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(55367), // Rule ID 3396 //
     /*  55285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55328 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55334 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55338 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55355 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55365 */     GIR_RootConstrainSelectedInstOperands,
     /*  55366 */     // GIR_Coverage, 3396,
     /*  55366 */     GIR_EraseRootFromParent_Done,
     /*  55367 */   // Label 698: @55367
     /*  55367 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(55454), // Rule ID 3395 //
     /*  55372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55415 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55425 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55442 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55452 */     GIR_RootConstrainSelectedInstOperands,
     /*  55453 */     // GIR_Coverage, 3395,
     /*  55453 */     GIR_EraseRootFromParent_Done,
     /*  55454 */   // Label 699: @55454
     /*  55454 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(55541), // Rule ID 3400 //
     /*  55459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55502 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55508 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55512 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55529 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55539 */     GIR_RootConstrainSelectedInstOperands,
     /*  55540 */     // GIR_Coverage, 3400,
     /*  55540 */     GIR_EraseRootFromParent_Done,
     /*  55541 */   // Label 700: @55541
     /*  55541 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(55628), // Rule ID 5263 //
     /*  55546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  55573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55599 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  55612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55616 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55626 */     GIR_RootConstrainSelectedInstOperands,
     /*  55627 */     // GIR_Coverage, 5263,
     /*  55627 */     GIR_EraseRootFromParent_Done,
     /*  55628 */   // Label 701: @55628
     /*  55628 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(55713), // Rule ID 5257 //
     /*  55633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55676 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55682 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55686 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55691 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55701 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55711 */     GIR_RootConstrainSelectedInstOperands,
     /*  55712 */     // GIR_Coverage, 5257,
     /*  55712 */     GIR_EraseRootFromParent_Done,
     /*  55713 */   // Label 702: @55713
     /*  55713 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(55800), // Rule ID 5255 //
     /*  55718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55761 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55767 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55771 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55788 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55798 */     GIR_RootConstrainSelectedInstOperands,
     /*  55799 */     // GIR_Coverage, 5255,
     /*  55799 */     GIR_EraseRootFromParent_Done,
     /*  55800 */   // Label 703: @55800
     /*  55800 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(55885), // Rule ID 5262 //
     /*  55805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55848 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55854 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55858 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55863 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55873 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55883 */     GIR_RootConstrainSelectedInstOperands,
     /*  55884 */     // GIR_Coverage, 5262,
     /*  55884 */     GIR_EraseRootFromParent_Done,
     /*  55885 */   // Label 704: @55885
     /*  55885 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(55972), // Rule ID 5260 //
     /*  55890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55933 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55943 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55960 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55970 */     GIR_RootConstrainSelectedInstOperands,
     /*  55971 */     // GIR_Coverage, 5260,
     /*  55971 */     GIR_EraseRootFromParent_Done,
     /*  55972 */   // Label 705: @55972
     /*  55972 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(56059), // Rule ID 3393 //
     /*  55977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56020 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56026 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56030 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56047 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56057 */     GIR_RootConstrainSelectedInstOperands,
     /*  56058 */     // GIR_Coverage, 3393,
     /*  56058 */     GIR_EraseRootFromParent_Done,
     /*  56059 */   // Label 706: @56059
     /*  56059 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(56146), // Rule ID 3394 //
     /*  56064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56107 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56113 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56117 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56134 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56144 */     GIR_RootConstrainSelectedInstOperands,
     /*  56145 */     // GIR_Coverage, 3394,
     /*  56145 */     GIR_EraseRootFromParent_Done,
     /*  56146 */   // Label 707: @56146
     /*  56146 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(56233), // Rule ID 5256 //
     /*  56151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56178 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56184 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56204 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56221 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56231 */     GIR_RootConstrainSelectedInstOperands,
     /*  56232 */     // GIR_Coverage, 5256,
     /*  56232 */     GIR_EraseRootFromParent_Done,
     /*  56233 */   // Label 708: @56233
     /*  56233 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(56320), // Rule ID 5261 //
     /*  56238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56265 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56281 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56285 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56291 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56308 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56318 */     GIR_RootConstrainSelectedInstOperands,
     /*  56319 */     // GIR_Coverage, 5261,
     /*  56319 */     GIR_EraseRootFromParent_Done,
     /*  56320 */   // Label 709: @56320
     /*  56320 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(56405), // Rule ID 5259 //
     /*  56325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56368 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56374 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56376 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56378 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56383 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56393 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56403 */     GIR_RootConstrainSelectedInstOperands,
     /*  56404 */     // GIR_Coverage, 5259,
     /*  56404 */     GIR_EraseRootFromParent_Done,
     /*  56405 */   // Label 710: @56405
     /*  56405 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(56490), // Rule ID 5264 //
     /*  56410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56453 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56463 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56468 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56478 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56488 */     GIR_RootConstrainSelectedInstOperands,
     /*  56489 */     // GIR_Coverage, 5264,
     /*  56489 */     GIR_EraseRootFromParent_Done,
     /*  56490 */   // Label 711: @56490
     /*  56490 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(56547), // Rule ID 940 //
     /*  56495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56522 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56528 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56532 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNAND),
     /*  56535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56545 */     GIR_RootConstrainSelectedInstOperands,
     /*  56546 */     // GIR_Coverage, 940,
     /*  56546 */     GIR_EraseRootFromParent_Done,
     /*  56547 */   // Label 712: @56547
     /*  56547 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(56604), // Rule ID 930 //
     /*  56552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56579 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56585 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56589 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56602 */     GIR_RootConstrainSelectedInstOperands,
     /*  56603 */     // GIR_Coverage, 930,
     /*  56603 */     GIR_EraseRootFromParent_Done,
     /*  56604 */   // Label 713: @56604
     /*  56604 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(56659), // Rule ID 4929 //
     /*  56609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56636 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56642 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56646 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XB)  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56655 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  56657 */     GIR_RootConstrainSelectedInstOperands,
     /*  56658 */     // GIR_Coverage, 4929,
     /*  56658 */     GIR_EraseRootFromParent_Done,
     /*  56659 */   // Label 714: @56659
     /*  56659 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(56716), // Rule ID 939 //
     /*  56664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56691 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56701 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56714 */     GIR_RootConstrainSelectedInstOperands,
     /*  56715 */     // GIR_Coverage, 939,
     /*  56715 */     GIR_EraseRootFromParent_Done,
     /*  56716 */   // Label 715: @56716
     /*  56716 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(56771), // Rule ID 4930 //
     /*  56721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56748 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56758 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }))  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56767 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /*  56769 */     GIR_RootConstrainSelectedInstOperands,
     /*  56770 */     // GIR_Coverage, 4930,
     /*  56770 */     GIR_EraseRootFromParent_Done,
     /*  56771 */   // Label 716: @56771
     /*  56771 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(56808), // Rule ID 1580 //
     /*  56776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56787 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56793 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  56795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56797 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$A)
     /*  56797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56802 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56804 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56806 */     GIR_RootConstrainSelectedInstOperands,
     /*  56807 */     // GIR_Coverage, 1580,
     /*  56807 */     GIR_EraseRootFromParent_Done,
     /*  56808 */   // Label 717: @56808
     /*  56808 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(56858), // Rule ID 5286 //
     /*  56813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56838 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  56838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56843 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  56856 */     GIR_RootConstrainSelectedInstOperands,
     /*  56857 */     // GIR_Coverage, 5286,
     /*  56857 */     GIR_EraseRootFromParent_Done,
     /*  56858 */   // Label 718: @56858
     /*  56858 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(56908), // Rule ID 5287 //
     /*  56863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56888 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  56888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56893 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  56906 */     GIR_RootConstrainSelectedInstOperands,
     /*  56907 */     // GIR_Coverage, 5287,
     /*  56907 */     GIR_EraseRootFromParent_Done,
     /*  56908 */   // Label 719: @56908
     /*  56908 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(56958), // Rule ID 5285 //
     /*  56913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56938 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  56938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  56951 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  56953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  56956 */     GIR_RootConstrainSelectedInstOperands,
     /*  56957 */     // GIR_Coverage, 5285,
     /*  56957 */     GIR_EraseRootFromParent_Done,
     /*  56958 */   // Label 720: @56958
     /*  56958 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(57008), // Rule ID 3408 //
     /*  56963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56988 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  56988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56993 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  57006 */     GIR_RootConstrainSelectedInstOperands,
     /*  57007 */     // GIR_Coverage, 3408,
     /*  57007 */     GIR_EraseRootFromParent_Done,
     /*  57008 */   // Label 721: @57008
     /*  57008 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(57058), // Rule ID 3409 //
     /*  57013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57038 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  57038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57043 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  57056 */     GIR_RootConstrainSelectedInstOperands,
     /*  57057 */     // GIR_Coverage, 3409,
     /*  57057 */     GIR_EraseRootFromParent_Done,
     /*  57058 */   // Label 722: @57058
     /*  57058 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(57108), // Rule ID 3407 //
     /*  57063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57088 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  57088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57093 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  57106 */     GIR_RootConstrainSelectedInstOperands,
     /*  57107 */     // GIR_Coverage, 3407,
     /*  57107 */     GIR_EraseRootFromParent_Done,
     /*  57108 */   // Label 723: @57108
     /*  57108 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(57127), // Rule ID 932 //
     /*  57113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57120 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  57120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLXOR),
     /*  57125 */     GIR_RootConstrainSelectedInstOperands,
     /*  57126 */     // GIR_Coverage, 932,
     /*  57126 */     GIR_Done,
     /*  57127 */   // Label 724: @57127
     /*  57127 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(57184), // Rule ID 488 //
     /*  57132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57159 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57169 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNAND),
     /*  57172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57182 */     GIR_RootConstrainSelectedInstOperands,
     /*  57183 */     // GIR_Coverage, 488,
     /*  57183 */     GIR_EraseRootFromParent_Done,
     /*  57184 */   // Label 725: @57184
     /*  57184 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(57241), // Rule ID 385 //
     /*  57189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57216 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57222 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57226 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57239 */     GIR_RootConstrainSelectedInstOperands,
     /*  57240 */     // GIR_Coverage, 385,
     /*  57240 */     GIR_EraseRootFromParent_Done,
     /*  57241 */   // Label 726: @57241
     /*  57241 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(57298), // Rule ID 1377 //
     /*  57246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57273 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57283 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  57283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  57292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  57296 */     GIR_RootConstrainSelectedInstOperands,
     /*  57297 */     // GIR_Coverage, 1377,
     /*  57297 */     GIR_EraseRootFromParent_Done,
     /*  57298 */   // Label 727: @57298
     /*  57298 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(57353), // Rule ID 4917 //
     /*  57303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57330 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57340 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VB)  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57349 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  57351 */     GIR_RootConstrainSelectedInstOperands,
     /*  57352 */     // GIR_Coverage, 4917,
     /*  57352 */     GIR_EraseRootFromParent_Done,
     /*  57353 */   // Label 728: @57353
     /*  57353 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(57410), // Rule ID 487 //
     /*  57358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57385 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57391 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57395 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57408 */     GIR_RootConstrainSelectedInstOperands,
     /*  57409 */     // GIR_Coverage, 487,
     /*  57409 */     GIR_EraseRootFromParent_Done,
     /*  57410 */   // Label 729: @57410
     /*  57410 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(57465), // Rule ID 4918 //
     /*  57415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57442 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57452 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }))  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57461 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  57463 */     GIR_RootConstrainSelectedInstOperands,
     /*  57464 */     // GIR_Coverage, 4918,
     /*  57464 */     GIR_EraseRootFromParent_Done,
     /*  57465 */   // Label 730: @57465
     /*  57465 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(57502), // Rule ID 1376 //
     /*  57470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57481 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57487 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  57489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57491 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vA)
     /*  57491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57496 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57498 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57500 */     GIR_RootConstrainSelectedInstOperands,
     /*  57501 */     // GIR_Coverage, 1376,
     /*  57501 */     GIR_EraseRootFromParent_Done,
     /*  57502 */   // Label 731: @57502
     /*  57502 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(57521), // Rule ID 387 //
     /*  57507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57514 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VXOR),
     /*  57519 */     GIR_RootConstrainSelectedInstOperands,
     /*  57520 */     // GIR_Coverage, 387,
     /*  57520 */     GIR_Done,
     /*  57521 */   // Label 732: @57521
     /*  57521 */   GIM_Reject,
     /*  57522 */ // Label 687: @57522
     /*  57522 */ GIM_Reject,
     /*  57523 */ // Label 597: @57523
     /*  57523 */ GIM_Reject,
     /*  57524 */ // Label 10: @57524
     /*  57524 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(57824),
     /*  57529 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  57532 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  57538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57545 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(57667), // Rule ID 2124 //
     /*  57550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  57553 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57553 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57556 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57560 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57565 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57571 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57574 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57578 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57583 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57586 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57589 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57592 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57597 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57602 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57605 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57609 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57614 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57632 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57638 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57665 */     GIR_RootConstrainSelectedInstOperands,
     /*  57666 */     // GIR_Coverage, 2124,
     /*  57666 */     GIR_EraseRootFromParent_Done,
     /*  57667 */   // Label 734: @57667
     /*  57667 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(57789), // Rule ID 2127 //
     /*  57672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  57675 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57675 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57678 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57682 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57687 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57693 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57696 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57700 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57705 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57708 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57711 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57714 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57719 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57736 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57754 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57757 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57760 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57787 */     GIR_RootConstrainSelectedInstOperands,
     /*  57788 */     // GIR_Coverage, 2127,
     /*  57788 */     GIR_EraseRootFromParent_Done,
     /*  57789 */   // Label 735: @57789
     /*  57789 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(57804), // Rule ID 2872 //
     /*  57794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64),
     /*  57797 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rB, i64:{ *:[i64] }:$rA)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57802 */     GIR_RootConstrainSelectedInstOperands,
     /*  57803 */     // GIR_Coverage, 2872,
     /*  57803 */     GIR_Done,
     /*  57804 */   // Label 736: @57804
     /*  57804 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(57823), // Rule ID 2876 //
     /*  57809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian),
     /*  57812 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rA, i64:{ *:[i64] }:$rB)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rB
     /*  57819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rA
     /*  57821 */     GIR_RootConstrainSelectedInstOperands,
     /*  57822 */     // GIR_Coverage, 2876,
     /*  57822 */     GIR_EraseRootFromParent_Done,
     /*  57823 */   // Label 737: @57823
     /*  57823 */   GIM_Reject,
     /*  57824 */ // Label 733: @57824
     /*  57824 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(58349),
     /*  57829 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  57832 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  57838 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(57889), // Rule ID 2038 //
     /*  57843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  57846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt5NonZero),
     /*  57862 */     // MIs[1] Operand 1
     /*  57862 */     // No operand predicates
     /*  57862 */     // MIs[0] A
     /*  57862 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57867 */     // MIs[0] A
     /*  57867 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57872 */     // MIs[0] A
     /*  57872 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57879 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A)  =>  (VSPLTISW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSPLTISW),
     /*  57882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57887 */     GIR_RootConstrainSelectedInstOperands,
     /*  57888 */     // GIR_Coverage, 2038,
     /*  57888 */     GIR_EraseRootFromParent_Done,
     /*  57889 */   // Label 739: @57889
     /*  57889 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(57940), // Rule ID 3375 //
     /*  57894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immNonAllOneNonZero),
     /*  57913 */     // MIs[1] Operand 1
     /*  57913 */     // No operand predicates
     /*  57913 */     // MIs[0] A
     /*  57913 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57918 */     // MIs[0] A
     /*  57918 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57923 */     // MIs[0] A
     /*  57923 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57930 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A)  =>  (XXSPLTIW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIW),
     /*  57933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57938 */     GIR_RootConstrainSelectedInstOperands,
     /*  57939 */     // GIR_Coverage, 3375,
     /*  57939 */     GIR_EraseRootFromParent_Done,
     /*  57940 */   // Label 740: @57940
     /*  57940 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(58076), // Rule ID 1728 //
     /*  57945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  57954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  57957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  57973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57981 */     // MIs[2] A
     /*  57981 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  57986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  57990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57994 */     // MIs[3] A
     /*  57994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  57999 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/4, // MIs[4]
     /*  58003 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  58007 */     // MIs[4] A
     /*  58007 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  58012 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58014 */     // (build_vector:{ *:[v4f32] } (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A))  =>  (XXSPLTW:{ *:[v4f32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (XSCVDPSP:{ *:[f64] } f64:{ *:[f64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  58014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSP),
     /*  58021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58026 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  58030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58050 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58074 */     GIR_RootConstrainSelectedInstOperands,
     /*  58075 */     // GIR_Coverage, 1728,
     /*  58075 */     GIR_EraseRootFromParent_Done,
     /*  58076 */   // Label 741: @58076
     /*  58076 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(58134), // Rule ID 1729 //
     /*  58081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58088 */     // MIs[0] A
     /*  58088 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58093 */     // MIs[0] A
     /*  58093 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58098 */     // MIs[0] A
     /*  58098 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58103 */     // (build_vector:{ *:[v4f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A)  =>  (XXSPLTW:{ *:[v4f32] } (XSCVDPSPN:{ *:[v4f32] } ?:{ *:[f32] }:$A), 0:{ *:[i32] })
     /*  58103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58132 */     GIR_RootConstrainSelectedInstOperands,
     /*  58133 */     // GIR_Coverage, 1729,
     /*  58133 */     GIR_EraseRootFromParent_Done,
     /*  58134 */   // Label 742: @58134
     /*  58134 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(58223), // Rule ID 2126 //
     /*  58139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  58142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58146 */     // MIs[0] A
     /*  58146 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58151 */     // MIs[0] A
     /*  58151 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58156 */     // MIs[0] A
     /*  58156 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58161 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58173 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58191 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58194 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58197 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58221 */     GIR_RootConstrainSelectedInstOperands,
     /*  58222 */     // GIR_Coverage, 2126,
     /*  58222 */     GIR_EraseRootFromParent_Done,
     /*  58223 */   // Label 743: @58223
     /*  58223 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(58312), // Rule ID 2129 //
     /*  58228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  58231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58235 */     // MIs[0] A
     /*  58235 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58240 */     // MIs[0] A
     /*  58240 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58245 */     // MIs[0] A
     /*  58245 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58250 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58250 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58253 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58257 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58262 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58280 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58283 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58310 */     GIR_RootConstrainSelectedInstOperands,
     /*  58311 */     // GIR_Coverage, 2129,
     /*  58311 */     GIR_EraseRootFromParent_Done,
     /*  58312 */   // Label 744: @58312
     /*  58312 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(58348), // Rule ID 2262 //
     /*  58317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58324 */     // MIs[0] A
     /*  58324 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58329 */     // MIs[0] A
     /*  58329 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58334 */     // MIs[0] A
     /*  58334 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58339 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (MTVSRWS:{ *:[v4i32] } ?:{ *:[i32] }:$A)
     /*  58339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWS),
     /*  58342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58344 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  58346 */     GIR_RootConstrainSelectedInstOperands,
     /*  58347 */     // GIR_Coverage, 2262,
     /*  58347 */     GIR_EraseRootFromParent_Done,
     /*  58348 */   // Label 745: @58348
     /*  58348 */   GIM_Reject,
     /*  58349 */ // Label 738: @58349
     /*  58349 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(58490), // Rule ID 2263 //
     /*  58354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58357 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/17,
     /*  58360 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  58378 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immNonAllOneAnyExt8),
     /*  58382 */   // MIs[1] Operand 1
     /*  58382 */   // No operand predicates
     /*  58382 */   // MIs[0] A
     /*  58382 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58387 */   // MIs[0] A
     /*  58387 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58392 */   // MIs[0] A
     /*  58392 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58397 */   // MIs[0] A
     /*  58397 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58402 */   // MIs[0] A
     /*  58402 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58407 */   // MIs[0] A
     /*  58407 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58412 */   // MIs[0] A
     /*  58412 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58417 */   // MIs[0] A
     /*  58417 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/9, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58422 */   // MIs[0] A
     /*  58422 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/10, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58427 */   // MIs[0] A
     /*  58427 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/11, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58432 */   // MIs[0] A
     /*  58432 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/12, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58437 */   // MIs[0] A
     /*  58437 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/13, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58442 */   // MIs[0] A
     /*  58442 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/14, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58447 */   // MIs[0] A
     /*  58447 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/15, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58452 */   // MIs[0] A
     /*  58452 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/16, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58457 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58459 */   // (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSPLTIB:{ *:[v4i32] } (imm:{ *:[i32] }):$A), VSRC:{ *:[i32] })
     /*  58459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIB),
     /*  58466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58471 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // A
     /*  58474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58484 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58489 */   // GIR_Coverage, 2263,
     /*  58489 */   GIR_EraseRootFromParent_Done,
     /*  58490 */ // Label 746: @58490
     /*  58490 */ GIM_Reject,
     /*  58491 */ // Label 11: @58491
     /*  58491 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 754*/ GIMT_Encode4(60767),
     /*  58502 */ /*GILLT_s32*//*Label 747*/ GIMT_Encode4(58530),
     /*  58506 */ /*GILLT_s64*//*Label 748*/ GIMT_Encode4(58603),
     /*  58510 */ /*GILLT_s128*//*Label 749*/ GIMT_Encode4(58651),
     /*  58514 */ /*GILLT_v2s64*//*Label 750*/ GIMT_Encode4(59055),
     /*  58518 */ /*GILLT_v4s32*//*Label 751*/ GIMT_Encode4(59617),
     /*  58522 */ /*GILLT_v8s16*//*Label 752*/ GIMT_Encode4(60168),
     /*  58526 */ /*GILLT_v16s8*//*Label 753*/ GIMT_Encode4(60496),
     /*  58530 */ // Label 747: @58530
     /*  58530 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(58602), // Rule ID 2022 //
     /*  58535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  58545 */   // (bitconvert:{ *:[i32] } f32:{ *:[f32] }:$A)  =>  (MFVSRWZ:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f64] } (XSCVDPSPN:{ *:[v4i32] } ?:{ *:[f32] }:$A), sub_64:{ *:[i32] }))
     /*  58545 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  58548 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58552 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58557 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  58566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58575 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  58582 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  58587 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /*  58595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  58597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58600 */   GIR_RootConstrainSelectedInstOperands,
     /*  58601 */   // GIR_Coverage, 2022,
     /*  58601 */   GIR_EraseRootFromParent_Done,
     /*  58602 */ // Label 755: @58602
     /*  58602 */ GIM_Reject,
     /*  58603 */ // Label 748: @58603
     /*  58603 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(58650),
     /*  58608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  58611 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(58630), // Rule ID 2024 //
     /*  58616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  58623 */     // (bitconvert:{ *:[i64] } f64:{ *:[f64] }:$A)  =>  (MFVSRD:{ *:[i64] } ?:{ *:[f64] }:$A)
     /*  58623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  58628 */     GIR_RootConstrainSelectedInstOperands,
     /*  58629 */     // GIR_Coverage, 2024,
     /*  58629 */     GIR_Done,
     /*  58630 */   // Label 757: @58630
     /*  58630 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(58649), // Rule ID 2025 //
     /*  58635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58642 */     // (bitconvert:{ *:[f64] } i64:{ *:[i64] }:$S)  =>  (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$S)
     /*  58642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  58647 */     GIR_RootConstrainSelectedInstOperands,
     /*  58648 */     // GIR_Coverage, 2025,
     /*  58648 */     GIR_Done,
     /*  58649 */   // Label 758: @58649
     /*  58649 */   GIM_Reject,
     /*  58650 */ // Label 756: @58650
     /*  58650 */ GIM_Reject,
     /*  58651 */ // Label 749: @58651
     /*  58651 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(58708), // Rule ID 1928 //
     /*  58656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  58659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58666 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58670 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58676 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  58678 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58680 */   // (bitconvert:{ *:[v1i128] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  58680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  58687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58702 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58707 */   // GIR_Coverage, 1928,
     /*  58707 */   GIR_EraseRootFromParent_Done,
     /*  58708 */ // Label 759: @58708
     /*  58708 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(58734), // Rule ID 1615 //
     /*  58713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58723 */   // (bitconvert:{ *:[v1i128] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  58723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58733 */   // GIR_Coverage, 1615,
     /*  58733 */   GIR_Done,
     /*  58734 */ // Label 760: @58734
     /*  58734 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(58766), // Rule ID 1330 //
     /*  58739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58753 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58765 */   // GIR_Coverage, 1330,
     /*  58765 */   GIR_EraseRootFromParent_Done,
     /*  58766 */ // Label 761: @58766
     /*  58766 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(58798), // Rule ID 1331 //
     /*  58771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58785 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58788 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58797 */   // GIR_Coverage, 1331,
     /*  58797 */   GIR_EraseRootFromParent_Done,
     /*  58798 */ // Label 762: @58798
     /*  58798 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(58830), // Rule ID 1332 //
     /*  58803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58817 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58829 */   // GIR_Coverage, 1332,
     /*  58829 */   GIR_EraseRootFromParent_Done,
     /*  58830 */ // Label 763: @58830
     /*  58830 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(58862), // Rule ID 1333 //
     /*  58835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58849 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58852 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58861 */   // GIR_Coverage, 1333,
     /*  58861 */   GIR_EraseRootFromParent_Done,
     /*  58862 */ // Label 764: @58862
     /*  58862 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(58894), // Rule ID 1334 //
     /*  58867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58881 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58884 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58886 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58893 */   // GIR_Coverage, 1334,
     /*  58893 */   GIR_EraseRootFromParent_Done,
     /*  58894 */ // Label 765: @58894
     /*  58894 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(58926), // Rule ID 1335 //
     /*  58899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58913 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58916 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58918 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58925 */   // GIR_Coverage, 1335,
     /*  58925 */   GIR_EraseRootFromParent_Done,
     /*  58926 */ // Label 766: @58926
     /*  58926 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(58958), // Rule ID 1336 //
     /*  58931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58945 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58948 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58957 */   // GIR_Coverage, 1336,
     /*  58957 */   GIR_EraseRootFromParent_Done,
     /*  58958 */ // Label 767: @58958
     /*  58958 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(58990), // Rule ID 1337 //
     /*  58963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58977 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58980 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58982 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58984 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58989 */   // GIR_Coverage, 1337,
     /*  58989 */   GIR_EraseRootFromParent_Done,
     /*  58990 */ // Label 768: @58990
     /*  58990 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(59022), // Rule ID 1338 //
     /*  58995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59009 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59012 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59014 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59016 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59021 */   // GIR_Coverage, 1338,
     /*  59021 */   GIR_EraseRootFromParent_Done,
     /*  59022 */ // Label 769: @59022
     /*  59022 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(59054), // Rule ID 1339 //
     /*  59027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59041 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v2f64] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59044 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59046 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59048 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59053 */   // GIR_Coverage, 1339,
     /*  59053 */   GIR_EraseRootFromParent_Done,
     /*  59054 */ // Label 770: @59054
     /*  59054 */ GIM_Reject,
     /*  59055 */ // Label 750: @59055
     /*  59055 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(59112), // Rule ID 1929 //
     /*  59060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59070 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59074 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59080 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59082 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59084 */   // (bitconvert:{ *:[v2i64] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  59084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  59087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59111 */   // GIR_Coverage, 1929,
     /*  59111 */   GIR_EraseRootFromParent_Done,
     /*  59112 */ // Label 771: @59112
     /*  59112 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(59138), // Rule ID 1596 //
     /*  59117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59127 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59137 */   // GIR_Coverage, 1596,
     /*  59137 */   GIR_Done,
     /*  59138 */ // Label 772: @59138
     /*  59138 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(59164), // Rule ID 1597 //
     /*  59143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59153 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59163 */   // GIR_Coverage, 1597,
     /*  59163 */   GIR_Done,
     /*  59164 */ // Label 773: @59164
     /*  59164 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(59190), // Rule ID 1598 //
     /*  59169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59179 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59184 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59189 */   // GIR_Coverage, 1598,
     /*  59189 */   GIR_Done,
     /*  59190 */ // Label 774: @59190
     /*  59190 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(59216), // Rule ID 1599 //
     /*  59195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59205 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59210 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59215 */   // GIR_Coverage, 1599,
     /*  59215 */   GIR_Done,
     /*  59216 */ // Label 775: @59216
     /*  59216 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(59242), // Rule ID 1604 //
     /*  59221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59231 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59241 */   // GIR_Coverage, 1604,
     /*  59241 */   GIR_Done,
     /*  59242 */ // Label 776: @59242
     /*  59242 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(59268), // Rule ID 1605 //
     /*  59247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59257 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59262 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59267 */   // GIR_Coverage, 1605,
     /*  59267 */   GIR_Done,
     /*  59268 */ // Label 777: @59268
     /*  59268 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(59294), // Rule ID 1606 //
     /*  59273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59283 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59293 */   // GIR_Coverage, 1606,
     /*  59293 */   GIR_Done,
     /*  59294 */ // Label 778: @59294
     /*  59294 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(59320), // Rule ID 1607 //
     /*  59299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59309 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59319 */   // GIR_Coverage, 1607,
     /*  59319 */   GIR_Done,
     /*  59320 */ // Label 779: @59320
     /*  59320 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(59346), // Rule ID 1612 //
     /*  59325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59335 */   // (bitconvert:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59340 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59345 */   // GIR_Coverage, 1612,
     /*  59345 */   GIR_Done,
     /*  59346 */ // Label 780: @59346
     /*  59346 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(59372), // Rule ID 1613 //
     /*  59351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59361 */   // (bitconvert:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59371 */   // GIR_Coverage, 1613,
     /*  59371 */   GIR_Done,
     /*  59372 */ // Label 781: @59372
     /*  59372 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(59398), // Rule ID 1614 //
     /*  59377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59387 */   // (bitconvert:{ *:[v2f64] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v1i128] }:$A, VRRC:{ *:[i32] })
     /*  59387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59392 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59397 */   // GIR_Coverage, 1614,
     /*  59397 */   GIR_Done,
     /*  59398 */ // Label 782: @59398
     /*  59398 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(59424), // Rule ID 1616 //
     /*  59403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59413 */   // (bitconvert:{ *:[v2i64] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59423 */   // GIR_Coverage, 1616,
     /*  59423 */   GIR_Done,
     /*  59424 */ // Label 783: @59424
     /*  59424 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(59456), // Rule ID 1325 //
     /*  59429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59443 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59446 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59448 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59450 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59455 */   // GIR_Coverage, 1325,
     /*  59455 */   GIR_EraseRootFromParent_Done,
     /*  59456 */ // Label 784: @59456
     /*  59456 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(59488), // Rule ID 1326 //
     /*  59461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59475 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59478 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59480 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59482 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59487 */   // GIR_Coverage, 1326,
     /*  59487 */   GIR_EraseRootFromParent_Done,
     /*  59488 */ // Label 785: @59488
     /*  59488 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(59520), // Rule ID 1327 //
     /*  59493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59507 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59510 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59514 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59519 */   // GIR_Coverage, 1327,
     /*  59519 */   GIR_EraseRootFromParent_Done,
     /*  59520 */ // Label 786: @59520
     /*  59520 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(59552), // Rule ID 1328 //
     /*  59525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59539 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59542 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59544 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59546 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59551 */   // GIR_Coverage, 1328,
     /*  59551 */   GIR_EraseRootFromParent_Done,
     /*  59552 */ // Label 787: @59552
     /*  59552 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(59584), // Rule ID 1329 //
     /*  59557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59571 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59574 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59576 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59583 */   // GIR_Coverage, 1329,
     /*  59583 */   GIR_EraseRootFromParent_Done,
     /*  59584 */ // Label 788: @59584
     /*  59584 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(59616), // Rule ID 1344 //
     /*  59589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59603 */   // (bitconvert:{ *:[v2f64] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v2f64] }:$src
     /*  59603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59606 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59608 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59615 */   // GIR_Coverage, 1344,
     /*  59615 */   GIR_EraseRootFromParent_Done,
     /*  59616 */ // Label 789: @59616
     /*  59616 */ GIM_Reject,
     /*  59617 */ // Label 751: @59617
     /*  59617 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(59653), // Rule ID 941 //
     /*  59622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59632 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59636 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59642 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59646 */   // (bitconvert:{ *:[v4i32] } immAllOnesV:{ *:[v16i8] })  =>  (XXLEQVOnes:{ *:[v4i32] })
     /*  59646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  59651 */   GIR_RootConstrainSelectedInstOperands,
     /*  59652 */   // GIR_Coverage, 941,
     /*  59652 */   GIR_EraseRootFromParent_Done,
     /*  59653 */ // Label 790: @59653
     /*  59653 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(59679), // Rule ID 1600 //
     /*  59658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59668 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59673 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59678 */   // GIR_Coverage, 1600,
     /*  59678 */   GIR_Done,
     /*  59679 */ // Label 791: @59679
     /*  59679 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(59705), // Rule ID 1601 //
     /*  59684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59694 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59704 */   // GIR_Coverage, 1601,
     /*  59704 */   GIR_Done,
     /*  59705 */ // Label 792: @59705
     /*  59705 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(59731), // Rule ID 1608 //
     /*  59710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59720 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59725 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59730 */   // GIR_Coverage, 1608,
     /*  59730 */   GIR_Done,
     /*  59731 */ // Label 793: @59731
     /*  59731 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(59757), // Rule ID 1609 //
     /*  59736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59746 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59756 */   // GIR_Coverage, 1609,
     /*  59756 */   GIR_Done,
     /*  59757 */ // Label 794: @59757
     /*  59757 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(59783), // Rule ID 1617 //
     /*  59762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59772 */   // (bitconvert:{ *:[v4i32] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59782 */   // GIR_Coverage, 1617,
     /*  59782 */   GIR_Done,
     /*  59783 */ // Label 795: @59783
     /*  59783 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(59815), // Rule ID 1315 //
     /*  59788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59802 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59805 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59807 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59814 */   // GIR_Coverage, 1315,
     /*  59814 */   GIR_EraseRootFromParent_Done,
     /*  59815 */ // Label 796: @59815
     /*  59815 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(59847), // Rule ID 1316 //
     /*  59820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59834 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59837 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59839 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59841 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59846 */   // GIR_Coverage, 1316,
     /*  59846 */   GIR_EraseRootFromParent_Done,
     /*  59847 */ // Label 797: @59847
     /*  59847 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(59879), // Rule ID 1317 //
     /*  59852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59866 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59869 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59871 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59873 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59878 */   // GIR_Coverage, 1317,
     /*  59878 */   GIR_EraseRootFromParent_Done,
     /*  59879 */ // Label 798: @59879
     /*  59879 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(59911), // Rule ID 1318 //
     /*  59884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59898 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59901 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59903 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59910 */   // GIR_Coverage, 1318,
     /*  59910 */   GIR_EraseRootFromParent_Done,
     /*  59911 */ // Label 799: @59911
     /*  59911 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(59943), // Rule ID 1319 //
     /*  59916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59930 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59933 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59942 */   // GIR_Coverage, 1319,
     /*  59942 */   GIR_EraseRootFromParent_Done,
     /*  59943 */ // Label 800: @59943
     /*  59943 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(59975), // Rule ID 1320 //
     /*  59948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59962 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  59962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59965 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59969 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59974 */   // GIR_Coverage, 1320,
     /*  59974 */   GIR_EraseRootFromParent_Done,
     /*  59975 */ // Label 801: @59975
     /*  59975 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(60007), // Rule ID 1321 //
     /*  59980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59994 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  59994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59997 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59999 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60006 */   // GIR_Coverage, 1321,
     /*  60006 */   GIR_EraseRootFromParent_Done,
     /*  60007 */ // Label 802: @60007
     /*  60007 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(60039), // Rule ID 1322 //
     /*  60012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60026 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60029 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60031 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60033 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60038 */   // GIR_Coverage, 1322,
     /*  60038 */   GIR_EraseRootFromParent_Done,
     /*  60039 */ // Label 803: @60039
     /*  60039 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(60071), // Rule ID 1323 //
     /*  60044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60058 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60061 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60063 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60070 */   // GIR_Coverage, 1323,
     /*  60070 */   GIR_EraseRootFromParent_Done,
     /*  60071 */ // Label 804: @60071
     /*  60071 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(60103), // Rule ID 1324 //
     /*  60076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60090 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60093 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60095 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60102 */   // GIR_Coverage, 1324,
     /*  60102 */   GIR_EraseRootFromParent_Done,
     /*  60103 */ // Label 805: @60103
     /*  60103 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(60135), // Rule ID 1342 //
     /*  60108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60122 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  60122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60134 */   // GIR_Coverage, 1342,
     /*  60134 */   GIR_EraseRootFromParent_Done,
     /*  60135 */ // Label 806: @60135
     /*  60135 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(60167), // Rule ID 1343 //
     /*  60140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60154 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60157 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60159 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60166 */   // GIR_Coverage, 1343,
     /*  60166 */   GIR_EraseRootFromParent_Done,
     /*  60167 */ // Label 807: @60167
     /*  60167 */ GIM_Reject,
     /*  60168 */ // Label 752: @60168
     /*  60168 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(60225), // Rule ID 1930 //
     /*  60173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  60176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60183 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60187 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60193 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  60195 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60197 */   // (bitconvert:{ *:[v8i16] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  60197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  60200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  60204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60224 */   // GIR_Coverage, 1930,
     /*  60224 */   GIR_EraseRootFromParent_Done,
     /*  60225 */ // Label 808: @60225
     /*  60225 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(60251), // Rule ID 1602 //
     /*  60230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60240 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60250 */   // GIR_Coverage, 1602,
     /*  60250 */   GIR_Done,
     /*  60251 */ // Label 809: @60251
     /*  60251 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(60277), // Rule ID 1610 //
     /*  60256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60266 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60276 */   // GIR_Coverage, 1610,
     /*  60276 */   GIR_Done,
     /*  60277 */ // Label 810: @60277
     /*  60277 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(60303), // Rule ID 1618 //
     /*  60282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60292 */   // (bitconvert:{ *:[v8i16] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60302 */   // GIR_Coverage, 1618,
     /*  60302 */   GIR_Done,
     /*  60303 */ // Label 811: @60303
     /*  60303 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(60335), // Rule ID 1310 //
     /*  60308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60322 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60325 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60334 */   // GIR_Coverage, 1310,
     /*  60334 */   GIR_EraseRootFromParent_Done,
     /*  60335 */ // Label 812: @60335
     /*  60335 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(60367), // Rule ID 1311 //
     /*  60340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60354 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60366 */   // GIR_Coverage, 1311,
     /*  60366 */   GIR_EraseRootFromParent_Done,
     /*  60367 */ // Label 813: @60367
     /*  60367 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(60399), // Rule ID 1312 //
     /*  60372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60386 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60389 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60391 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60398 */   // GIR_Coverage, 1312,
     /*  60398 */   GIR_EraseRootFromParent_Done,
     /*  60399 */ // Label 814: @60399
     /*  60399 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(60431), // Rule ID 1313 //
     /*  60404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60418 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60421 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60423 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60430 */   // GIR_Coverage, 1313,
     /*  60430 */   GIR_EraseRootFromParent_Done,
     /*  60431 */ // Label 815: @60431
     /*  60431 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(60463), // Rule ID 1314 //
     /*  60436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60450 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60453 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60455 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60462 */   // GIR_Coverage, 1314,
     /*  60462 */   GIR_EraseRootFromParent_Done,
     /*  60463 */ // Label 816: @60463
     /*  60463 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(60495), // Rule ID 1341 //
     /*  60468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60482 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60485 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60487 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60494 */   // GIR_Coverage, 1341,
     /*  60494 */   GIR_EraseRootFromParent_Done,
     /*  60495 */ // Label 817: @60495
     /*  60495 */ GIM_Reject,
     /*  60496 */ // Label 753: @60496
     /*  60496 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(60522), // Rule ID 1603 //
     /*  60501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60511 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60521 */   // GIR_Coverage, 1603,
     /*  60521 */   GIR_Done,
     /*  60522 */ // Label 818: @60522
     /*  60522 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(60548), // Rule ID 1611 //
     /*  60527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60537 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60542 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60547 */   // GIR_Coverage, 1611,
     /*  60547 */   GIR_Done,
     /*  60548 */ // Label 819: @60548
     /*  60548 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(60574), // Rule ID 1619 //
     /*  60553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60563 */   // (bitconvert:{ *:[v16i8] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60573 */   // GIR_Coverage, 1619,
     /*  60573 */   GIR_Done,
     /*  60574 */ // Label 820: @60574
     /*  60574 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(60606), // Rule ID 1305 //
     /*  60579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  60585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60593 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60605 */   // GIR_Coverage, 1305,
     /*  60605 */   GIR_EraseRootFromParent_Done,
     /*  60606 */ // Label 821: @60606
     /*  60606 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(60638), // Rule ID 1306 //
     /*  60611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60625 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60637 */   // GIR_Coverage, 1306,
     /*  60637 */   GIR_EraseRootFromParent_Done,
     /*  60638 */ // Label 822: @60638
     /*  60638 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(60670), // Rule ID 1307 //
     /*  60643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60657 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60669 */   // GIR_Coverage, 1307,
     /*  60669 */   GIR_EraseRootFromParent_Done,
     /*  60670 */ // Label 823: @60670
     /*  60670 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(60702), // Rule ID 1308 //
     /*  60675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60689 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60701 */   // GIR_Coverage, 1308,
     /*  60701 */   GIR_EraseRootFromParent_Done,
     /*  60702 */ // Label 824: @60702
     /*  60702 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(60734), // Rule ID 1309 //
     /*  60707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60721 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60733 */   // GIR_Coverage, 1309,
     /*  60733 */   GIR_EraseRootFromParent_Done,
     /*  60734 */ // Label 825: @60734
     /*  60734 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(60766), // Rule ID 1340 //
     /*  60739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60753 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60765 */   // GIR_Coverage, 1340,
     /*  60765 */   GIR_EraseRootFromParent_Done,
     /*  60766 */ // Label 826: @60766
     /*  60766 */ GIM_Reject,
     /*  60767 */ // Label 754: @60767
     /*  60767 */ GIM_Reject,
     /*  60768 */ // Label 12: @60768
     /*  60768 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 832*/ GIMT_Encode4(61042),
     /*  60779 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(60799),
     /*  60783 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(60892),
     /*  60787 */ /*GILLT_s128*//*Label 829*/ GIMT_Encode4(60940),
     /*  60791 */ /*GILLT_v2s64*//*Label 830*/ GIMT_Encode4(60971),
     /*  60795 */ /*GILLT_v4s32*//*Label 831*/ GIMT_Encode4(60994),
     /*  60799 */ // Label 827: @60799
     /*  60799 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(60891),
     /*  60804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60807 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(60871), // Rule ID 1706 //
     /*  60812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60819 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIZ:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  60819 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  60822 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60826 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60831 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  60835 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  60843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60852 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60870 */     // GIR_Coverage, 1706,
     /*  60870 */     GIR_EraseRootFromParent_Done,
     /*  60871 */   // Label 834: @60871
     /*  60871 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(60890), // Rule ID 150 //
     /*  60876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  60883 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIZS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  60883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZS),
     /*  60888 */     GIR_RootConstrainSelectedInstOperands,
     /*  60889 */     // GIR_Coverage, 150,
     /*  60889 */     GIR_Done,
     /*  60890 */   // Label 835: @60890
     /*  60890 */   GIM_Reject,
     /*  60891 */ // Label 833: @60891
     /*  60891 */ GIM_Reject,
     /*  60892 */ // Label 828: @60892
     /*  60892 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(60939),
     /*  60897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  60900 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(60919), // Rule ID 911 //
     /*  60905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60912 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIZ:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  60912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60917 */     GIR_RootConstrainSelectedInstOperands,
     /*  60918 */     // GIR_Coverage, 911,
     /*  60918 */     GIR_Done,
     /*  60919 */   // Label 837: @60919
     /*  60919 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(60938), // Rule ID 148 //
     /*  60924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  60931 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIZD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  60931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZD),
     /*  60936 */     GIR_RootConstrainSelectedInstOperands,
     /*  60937 */     // GIR_Coverage, 148,
     /*  60937 */     GIR_Done,
     /*  60938 */   // Label 838: @60938
     /*  60938 */   GIM_Reject,
     /*  60939 */ // Label 836: @60939
     /*  60939 */ GIM_Reject,
     /*  60940 */ // Label 829: @60940
     /*  60940 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(60970), // Rule ID 2157 //
     /*  60945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  60948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60955 */   // (ftrunc:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 1:{ *:[i32] })
     /*  60955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  60958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  60960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60963 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  60965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60968 */   GIR_RootConstrainSelectedInstOperands,
     /*  60969 */   // GIR_Coverage, 2157,
     /*  60969 */   GIR_EraseRootFromParent_Done,
     /*  60970 */ // Label 839: @60970
     /*  60970 */ GIM_Reject,
     /*  60971 */ // Label 830: @60971
     /*  60971 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(60993), // Rule ID 919 //
     /*  60976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60986 */   // (ftrunc:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIZ:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  60986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIZ),
     /*  60991 */   GIR_RootConstrainSelectedInstOperands,
     /*  60992 */   // GIR_Coverage, 919,
     /*  60992 */   GIR_Done,
     /*  60993 */ // Label 840: @60993
     /*  60993 */ GIM_Reject,
     /*  60994 */ // Label 831: @60994
     /*  60994 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(61041),
     /*  60999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  61002 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(61021), // Rule ID 927 //
     /*  61007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61014 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIZ),
     /*  61019 */     GIR_RootConstrainSelectedInstOperands,
     /*  61020 */     // GIR_Coverage, 927,
     /*  61020 */     GIR_Done,
     /*  61021 */   // Label 842: @61021
     /*  61021 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(61040), // Rule ID 1415 //
     /*  61026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  61029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61033 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIZ:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /*  61033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  61038 */     GIR_RootConstrainSelectedInstOperands,
     /*  61039 */     // GIR_Coverage, 1415,
     /*  61039 */     GIR_Done,
     /*  61040 */   // Label 843: @61040
     /*  61040 */   GIM_Reject,
     /*  61041 */ // Label 841: @61041
     /*  61041 */ GIM_Reject,
     /*  61042 */ // Label 832: @61042
     /*  61042 */ GIM_Reject,
     /*  61043 */ // Label 13: @61043
     /*  61043 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 849*/ GIMT_Encode4(61292),
     /*  61054 */ /*GILLT_s32*//*Label 844*/ GIMT_Encode4(61074),
     /*  61058 */ /*GILLT_s64*//*Label 845*/ GIMT_Encode4(61167),
     /*  61062 */ /*GILLT_s128*//*Label 846*/ GIMT_Encode4(61215),
     /*  61066 */ /*GILLT_v2s64*//*Label 847*/ GIMT_Encode4(61246),
     /*  61070 */ /*GILLT_v4s32*//*Label 848*/ GIMT_Encode4(61269),
     /*  61074 */ // Label 844: @61074
     /*  61074 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(61166),
     /*  61079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61082 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(61146), // Rule ID 1700 //
     /*  61087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61094 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  61094 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61097 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61101 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61145 */     // GIR_Coverage, 1700,
     /*  61145 */     GIR_EraseRootFromParent_Done,
     /*  61146 */   // Label 851: @61146
     /*  61146 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(61165), // Rule ID 142 //
     /*  61151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  61158 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRINS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  61158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRINS),
     /*  61163 */     GIR_RootConstrainSelectedInstOperands,
     /*  61164 */     // GIR_Coverage, 142,
     /*  61164 */     GIR_Done,
     /*  61165 */   // Label 852: @61165
     /*  61165 */   GIM_Reject,
     /*  61166 */ // Label 850: @61166
     /*  61166 */ GIM_Reject,
     /*  61167 */ // Label 845: @61167
     /*  61167 */ GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(61214),
     /*  61172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61175 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(61194), // Rule ID 905 //
     /*  61180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61187 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPI:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  61187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61192 */     GIR_RootConstrainSelectedInstOperands,
     /*  61193 */     // GIR_Coverage, 905,
     /*  61193 */     GIR_Done,
     /*  61194 */   // Label 854: @61194
     /*  61194 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(61213), // Rule ID 140 //
     /*  61199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61206 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIND:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  61206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIND),
     /*  61211 */     GIR_RootConstrainSelectedInstOperands,
     /*  61212 */     // GIR_Coverage, 140,
     /*  61212 */     GIR_Done,
     /*  61213 */   // Label 855: @61213
     /*  61213 */   GIM_Reject,
     /*  61214 */ // Label 853: @61214
     /*  61214 */ GIM_Reject,
     /*  61215 */ // Label 846: @61215
     /*  61215 */ GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(61245), // Rule ID 2155 //
     /*  61220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  61223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  61226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61230 */   // (fround:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 0:{ *:[i32] })
     /*  61230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  61233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  61235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61238 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  61240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61243 */   GIR_RootConstrainSelectedInstOperands,
     /*  61244 */   // GIR_Coverage, 2155,
     /*  61244 */   GIR_EraseRootFromParent_Done,
     /*  61245 */ // Label 856: @61245
     /*  61245 */ GIM_Reject,
     /*  61246 */ // Label 847: @61246
     /*  61246 */ GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(61268), // Rule ID 913 //
     /*  61251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61261 */   // (fround:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPI:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  61261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPI),
     /*  61266 */   GIR_RootConstrainSelectedInstOperands,
     /*  61267 */   // GIR_Coverage, 913,
     /*  61267 */   GIR_Done,
     /*  61268 */ // Label 857: @61268
     /*  61268 */ GIM_Reject,
     /*  61269 */ // Label 848: @61269
     /*  61269 */ GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(61291), // Rule ID 921 //
     /*  61274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  61280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61284 */   // (fround:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPI:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPI),
     /*  61289 */   GIR_RootConstrainSelectedInstOperands,
     /*  61290 */   // GIR_Coverage, 921,
     /*  61290 */   GIR_Done,
     /*  61291 */ // Label 858: @61291
     /*  61291 */ GIM_Reject,
     /*  61292 */ // Label 849: @61292
     /*  61292 */ GIM_Reject,
     /*  61293 */ // Label 14: @61293
     /*  61293 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(61423),
     /*  61298 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61301 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 862*/ GIMT_Encode4(61422),
     /*  61312 */   /*GILLT_s32*//*Label 860*/ GIMT_Encode4(61320),
     /*  61316 */   /*GILLT_s64*//*Label 861*/ GIMT_Encode4(61381),
     /*  61320 */   // Label 860: @61320
     /*  61320 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(61380), // Rule ID 2027 //
     /*  61325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61332 */     // (lrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61344 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61378 */     GIR_RootConstrainSelectedInstOperands,
     /*  61379 */     // GIR_Coverage, 2027,
     /*  61379 */     GIR_EraseRootFromParent_Done,
     /*  61380 */   // Label 863: @61380
     /*  61380 */   GIM_Reject,
     /*  61381 */   // Label 861: @61381
     /*  61381 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(61421), // Rule ID 2026 //
     /*  61386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61393 */     // (lrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61405 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61419 */     GIR_RootConstrainSelectedInstOperands,
     /*  61420 */     // GIR_Coverage, 2026,
     /*  61420 */     GIR_EraseRootFromParent_Done,
     /*  61421 */   // Label 864: @61421
     /*  61421 */   GIM_Reject,
     /*  61422 */   // Label 862: @61422
     /*  61422 */   GIM_Reject,
     /*  61423 */ // Label 859: @61423
     /*  61423 */ GIM_Reject,
     /*  61424 */ // Label 15: @61424
     /*  61424 */ GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(61554),
     /*  61429 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61432 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 868*/ GIMT_Encode4(61553),
     /*  61443 */   /*GILLT_s32*//*Label 866*/ GIMT_Encode4(61451),
     /*  61447 */   /*GILLT_s64*//*Label 867*/ GIMT_Encode4(61512),
     /*  61451 */   // Label 866: @61451
     /*  61451 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(61511), // Rule ID 2029 //
     /*  61456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61463 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61463 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61466 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61470 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61475 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61479 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61496 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61509 */     GIR_RootConstrainSelectedInstOperands,
     /*  61510 */     // GIR_Coverage, 2029,
     /*  61510 */     GIR_EraseRootFromParent_Done,
     /*  61511 */   // Label 869: @61511
     /*  61511 */   GIM_Reject,
     /*  61512 */   // Label 867: @61512
     /*  61512 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(61552), // Rule ID 2028 //
     /*  61517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61524 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61550 */     GIR_RootConstrainSelectedInstOperands,
     /*  61551 */     // GIR_Coverage, 2028,
     /*  61551 */     GIR_EraseRootFromParent_Done,
     /*  61552 */   // Label 870: @61552
     /*  61552 */   GIM_Reject,
     /*  61553 */   // Label 868: @61553
     /*  61553 */   GIM_Reject,
     /*  61554 */ // Label 865: @61554
     /*  61554 */ GIM_Reject,
     /*  61555 */ // Label 16: @61555
     /*  61555 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(61574), // Rule ID 635 //
     /*  61560 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61567 */   // (readcyclecounter:{ *:[i64] })  =>  (MFTB8:{ *:[i64] })
     /*  61567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFTB8),
     /*  61572 */   GIR_RootConstrainSelectedInstOperands,
     /*  61573 */   // GIR_Coverage, 635,
     /*  61573 */   GIR_Done,
     /*  61574 */ // Label 871: @61574
     /*  61574 */ GIM_Reject,
     /*  61575 */ // Label 17: @61575
     /*  61575 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 874*/ GIMT_Encode4(61650),
     /*  61586 */ /*GILLT_s32*//*Label 872*/ GIMT_Encode4(61594),
     /*  61590 */ /*GILLT_s64*//*Label 873*/ GIMT_Encode4(61622),
     /*  61594 */ // Label 872: @61594
     /*  61594 */ GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(61621), // Rule ID 1265 //
     /*  61599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61602 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61606 */   // MIs[0] Operand 1
     /*  61606 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61609 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61615 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61619 */   GIR_RootConstrainSelectedInstOperands,
     /*  61620 */   // GIR_Coverage, 1265,
     /*  61620 */   GIR_EraseRootFromParent_Done,
     /*  61621 */ // Label 875: @61621
     /*  61621 */ GIM_Reject,
     /*  61622 */ // Label 873: @61622
     /*  61622 */ GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(61649), // Rule ID 1264 //
     /*  61627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61630 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61634 */   // MIs[0] Operand 1
     /*  61634 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61637 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61643 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61647 */   GIR_RootConstrainSelectedInstOperands,
     /*  61648 */   // GIR_Coverage, 1264,
     /*  61648 */   GIR_EraseRootFromParent_Done,
     /*  61649 */ // Label 876: @61649
     /*  61649 */ GIM_Reject,
     /*  61650 */ // Label 874: @61650
     /*  61650 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(61699),
     /*  61655 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  61658 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61661 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(61681), // Rule ID 1266 //
     /*  61666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61669 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (SYNC 1:{ *:[i32] })
     /*  61669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61679 */     GIR_RootConstrainSelectedInstOperands,
     /*  61680 */     // GIR_Coverage, 1266,
     /*  61680 */     GIR_EraseRootFromParent_Done,
     /*  61681 */   // Label 878: @61681
     /*  61681 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(61698), // Rule ID 1267 //
     /*  61686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  61689 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (MSYNC)
     /*  61689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  61692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61696 */     GIR_RootConstrainSelectedInstOperands,
     /*  61697 */     // GIR_Coverage, 1267,
     /*  61697 */     GIR_EraseRootFromParent_Done,
     /*  61698 */   // Label 879: @61698
     /*  61698 */   GIM_Reject,
     /*  61699 */ // Label 877: @61699
     /*  61699 */ GIM_Reject,
     /*  61700 */ // Label 18: @61700
     /*  61700 */ GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(61762),
     /*  61705 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  61708 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /*  61711 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(61749), // Rule ID 17 //
     /*  61716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  61728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  61732 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61738 */     // (brcond (xor:{ *:[i1] } i1:{ *:[i1] }:$BI, -1:{ *:[i1] }), (bb:{ *:[Other] }):$BD)  =>  (BCn i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCn),
     /*  61741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // BI
     /*  61745 */     GIR_RootToRootCopy, /*OpIdx*/1, // BD
     /*  61747 */     GIR_RootConstrainSelectedInstOperands,
     /*  61748 */     // GIR_Coverage, 17,
     /*  61748 */     GIR_EraseRootFromParent_Done,
     /*  61749 */   // Label 881: @61749
     /*  61749 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(61761), // Rule ID 16 //
     /*  61754 */     // (brcond i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)  =>  (BC i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BC),
     /*  61759 */     GIR_RootConstrainSelectedInstOperands,
     /*  61760 */     // GIR_Coverage, 16,
     /*  61760 */     GIR_Done,
     /*  61761 */   // Label 882: @61761
     /*  61761 */   GIM_Reject,
     /*  61762 */ // Label 880: @61762
     /*  61762 */ GIM_Reject,
     /*  61763 */ // Label 19: @61763
     /*  61763 */ GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(61911),
     /*  61768 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  61771 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(61798), // Rule ID 1163 //
     /*  61776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  61779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmsetdmrz),
     /*  61784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  61787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  61791 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10625:{ *:[iPTR] })  =>  (DMSETDMRZ:{ *:[v1024i1] })
     /*  61791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMSETDMRZ),
     /*  61794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61796 */     GIR_RootConstrainSelectedInstOperands,
     /*  61797 */     // GIR_Coverage, 1163,
     /*  61797 */     GIR_EraseRootFromParent_Done,
     /*  61798 */   // Label 884: @61798
     /*  61798 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(61825), // Rule ID 1166 //
     /*  61803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  61806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  61818 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10717:{ *:[iPTR] })  =>  (XXSETACCZ:{ *:[v512i1] })
     /*  61818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSETACCZ),
     /*  61821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61823 */     GIR_RootConstrainSelectedInstOperands,
     /*  61824 */     // GIR_Coverage, 1166,
     /*  61824 */     GIR_EraseRootFromParent_Done,
     /*  61825 */   // Label 885: @61825
     /*  61825 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(61852), // Rule ID 1167 //
     /*  61830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  61833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  61845 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10717:{ *:[iPTR] })  =>  (XXSETACCZW:{ *:[v512i1] })
     /*  61845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSETACCZW),
     /*  61848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61850 */     GIR_RootConstrainSelectedInstOperands,
     /*  61851 */     // GIR_Coverage, 1167,
     /*  61851 */     GIR_EraseRootFromParent_Done,
     /*  61852 */   // Label 886: @61852
     /*  61852 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(61876), // Rule ID 4896 //
     /*  61857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfmsr),
     /*  61862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61869 */     // (intrinsic_wo_chain:{ *:[i32] } 10616:{ *:[iPTR] })  =>  (MFMSR:{ *:[i32] })
     /*  61869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFMSR),
     /*  61872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61874 */     GIR_RootConstrainSelectedInstOperands,
     /*  61875 */     // GIR_Coverage, 4896,
     /*  61875 */     GIR_EraseRootFromParent_Done,
     /*  61876 */   // Label 887: @61876
     /*  61876 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(61910), // Rule ID 4897 //
     /*  61881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mftbu),
     /*  61886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61893 */     // (intrinsic_wo_chain:{ *:[i32] } 10618:{ *:[iPTR] })  =>  (MFTB:{ *:[i32] } 269:{ *:[i32] })
     /*  61893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFTB),
     /*  61896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61898 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(269),
     /*  61908 */     GIR_RootConstrainSelectedInstOperands,
     /*  61909 */     // GIR_Coverage, 4897,
     /*  61909 */     GIR_EraseRootFromParent_Done,
     /*  61910 */   // Label 888: @61910
     /*  61910 */   GIM_Reject,
     /*  61911 */ // Label 883: @61911
     /*  61911 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(65587),
     /*  61916 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  61919 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(61955), // Rule ID 1748 //
     /*  61924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  61932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61946 */     // (intrinsic_wo_chain:{ *:[f64] } 10591:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XB)  =>  (XSRSQRTEDP:{ *:[f64] } ?:{ *:[f64] }:$XB)
     /*  61946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTEDP),
     /*  61949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  61951 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  61953 */     GIR_RootConstrainSelectedInstOperands,
     /*  61954 */     // GIR_Coverage, 1748,
     /*  61954 */     GIR_EraseRootFromParent_Done,
     /*  61955 */   // Label 890: @61955
     /*  61955 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(61991), // Rule ID 1939 //
     /*  61960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  61963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  61968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61982 */     // (intrinsic_wo_chain:{ *:[f32] } 10592:{ *:[iPTR] }, vssrc:{ *:[f32] }:$XB)  =>  (XSRSQRTESP:{ *:[f32] } ?:{ *:[f32] }:$XB)
     /*  61982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTESP),
     /*  61985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  61987 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  61989 */     GIR_RootConstrainSelectedInstOperands,
     /*  61990 */     // GIR_Coverage, 1939,
     /*  61990 */     GIR_EraseRootFromParent_Done,
     /*  61991 */   // Label 891: @61991
     /*  61991 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(62023), // Rule ID 872 //
     /*  61996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsp),
     /*  62004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62014 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10810:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSP:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSP),
     /*  62017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62019 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62021 */     GIR_RootConstrainSelectedInstOperands,
     /*  62022 */     // GIR_Coverage, 872,
     /*  62022 */     GIR_EraseRootFromParent_Done,
     /*  62023 */   // Label 892: @62023
     /*  62023 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(62055), // Rule ID 875 //
     /*  62028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsxws),
     /*  62036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62046 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10811:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXWS),
     /*  62049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62051 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62053 */     GIR_RootConstrainSelectedInstOperands,
     /*  62054 */     // GIR_Coverage, 875,
     /*  62054 */     GIR_EraseRootFromParent_Done,
     /*  62055 */   // Label 893: @62055
     /*  62055 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(62087), // Rule ID 878 //
     /*  62060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpuxws),
     /*  62068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62078 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10812:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXWS),
     /*  62081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62083 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62085 */     GIR_RootConstrainSelectedInstOperands,
     /*  62086 */     // GIR_Coverage, 878,
     /*  62086 */     GIR_EraseRootFromParent_Done,
     /*  62087 */   // Label 894: @62087
     /*  62087 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(62119), // Rule ID 879 //
     /*  62092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspdp),
     /*  62100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62110 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10815:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPDP:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPDP),
     /*  62113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62115 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62117 */     GIR_RootConstrainSelectedInstOperands,
     /*  62118 */     // GIR_Coverage, 879,
     /*  62118 */     GIR_EraseRootFromParent_Done,
     /*  62119 */   // Label 895: @62119
     /*  62119 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(62151), // Rule ID 880 //
     /*  62124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspsxds),
     /*  62132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62142 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10817:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXDS),
     /*  62145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62147 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62149 */     GIR_RootConstrainSelectedInstOperands,
     /*  62150 */     // GIR_Coverage, 880,
     /*  62150 */     GIR_EraseRootFromParent_Done,
     /*  62151 */   // Label 896: @62151
     /*  62151 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(62183), // Rule ID 883 //
     /*  62156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspuxds),
     /*  62164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62174 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10818:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXDS),
     /*  62177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62179 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62181 */     GIR_RootConstrainSelectedInstOperands,
     /*  62182 */     // GIR_Coverage, 883,
     /*  62182 */     GIR_EraseRootFromParent_Done,
     /*  62183 */   // Label 897: @62183
     /*  62183 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(62215), // Rule ID 888 //
     /*  62188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxdsp),
     /*  62196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62206 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10819:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDSP),
     /*  62209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62211 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62213 */     GIR_RootConstrainSelectedInstOperands,
     /*  62214 */     // GIR_Coverage, 888,
     /*  62214 */     GIR_EraseRootFromParent_Done,
     /*  62215 */   // Label 898: @62215
     /*  62215 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(62247), // Rule ID 893 //
     /*  62220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxdsp),
     /*  62228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62238 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10821:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDSP),
     /*  62241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62243 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62245 */     GIR_RootConstrainSelectedInstOperands,
     /*  62246 */     // GIR_Coverage, 893,
     /*  62246 */     GIR_EraseRootFromParent_Done,
     /*  62247 */   // Label 899: @62247
     /*  62247 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(62279), // Rule ID 896 //
     /*  62252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxwdp),
     /*  62260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62270 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10820:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWDP),
     /*  62273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62275 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62277 */     GIR_RootConstrainSelectedInstOperands,
     /*  62278 */     // GIR_Coverage, 896,
     /*  62278 */     GIR_EraseRootFromParent_Done,
     /*  62279 */   // Label 900: @62279
     /*  62279 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(62311), // Rule ID 897 //
     /*  62284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxwdp),
     /*  62292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62302 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10822:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWDP),
     /*  62305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62307 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62309 */     GIR_RootConstrainSelectedInstOperands,
     /*  62310 */     // GIR_Coverage, 897,
     /*  62310 */     GIR_EraseRootFromParent_Done,
     /*  62311 */   // Label 901: @62311
     /*  62311 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(62343), // Rule ID 1005 //
     /*  62316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_sqrtf128_round_to_odd),
     /*  62324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  62327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  62334 */     // (intrinsic_wo_chain:{ *:[f128] } 10746:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSSQRTQPO:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /*  62334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQPO),
     /*  62337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62339 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62341 */     GIR_RootConstrainSelectedInstOperands,
     /*  62342 */     // GIR_Coverage, 1005,
     /*  62342 */     GIR_EraseRootFromParent_Done,
     /*  62343 */   // Label 902: @62343
     /*  62343 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(62375), // Rule ID 1012 //
     /*  62348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_truncf128_round_to_odd),
     /*  62356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /*  62366 */     // (intrinsic_wo_chain:{ *:[f64] } 10773:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSCVQPDPO:{ *:[f64] } f128:{ *:[f128] }:$RB)
     /*  62366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /*  62369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62371 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62373 */     GIR_RootConstrainSelectedInstOperands,
     /*  62374 */     // GIR_Coverage, 1012,
     /*  62374 */     GIR_EraseRootFromParent_Done,
     /*  62375 */   // Label 903: @62375
     /*  62375 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(62407), // Rule ID 1021 //
     /*  62380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsphp),
     /*  62388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62398 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10816:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPHP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPHP),
     /*  62401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62403 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62405 */     GIR_RootConstrainSelectedInstOperands,
     /*  62406 */     // GIR_Coverage, 1021,
     /*  62406 */     GIR_EraseRootFromParent_Done,
     /*  62407 */   // Label 904: @62407
     /*  62407 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(62439), // Rule ID 1025 //
     /*  62412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpdp),
     /*  62420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62430 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10844:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXEXPDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPDP),
     /*  62433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62435 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62437 */     GIR_RootConstrainSelectedInstOperands,
     /*  62438 */     // GIR_Coverage, 1025,
     /*  62438 */     GIR_EraseRootFromParent_Done,
     /*  62439 */   // Label 905: @62439
     /*  62439 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(62471), // Rule ID 1026 //
     /*  62444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpsp),
     /*  62452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62462 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10845:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXEXPSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPSP),
     /*  62465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62467 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62469 */     GIR_RootConstrainSelectedInstOperands,
     /*  62470 */     // GIR_Coverage, 1026,
     /*  62470 */     GIR_EraseRootFromParent_Done,
     /*  62471 */   // Label 906: @62471
     /*  62471 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(62503), // Rule ID 1027 //
     /*  62476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigdp),
     /*  62484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62494 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10846:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXSIGDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGDP),
     /*  62497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62499 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62501 */     GIR_RootConstrainSelectedInstOperands,
     /*  62502 */     // GIR_Coverage, 1027,
     /*  62502 */     GIR_EraseRootFromParent_Done,
     /*  62503 */   // Label 907: @62503
     /*  62503 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(62535), // Rule ID 1028 //
     /*  62508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigsp),
     /*  62516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62526 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10847:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXSIGSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGSP),
     /*  62529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62531 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62533 */     GIR_RootConstrainSelectedInstOperands,
     /*  62534 */     // GIR_Coverage, 1028,
     /*  62534 */     GIR_EraseRootFromParent_Done,
     /*  62535 */   // Label 908: @62535
     /*  62535 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(62590), // Rule ID 1656 //
     /*  62540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtdp),
     /*  62548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62558 */     // (intrinsic_wo_chain:{ *:[i32] } 10840:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTDP:{ *:[i32] } ?:{ *:[v2f64] }:$A), GPRC:{ *:[i32] })
     /*  62558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTDP),
     /*  62565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62589 */     // GIR_Coverage, 1656,
     /*  62589 */     GIR_EraseRootFromParent_Done,
     /*  62590 */   // Label 909: @62590
     /*  62590 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(62645), // Rule ID 1657 //
     /*  62595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtsp),
     /*  62603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62613 */     // (intrinsic_wo_chain:{ *:[i32] } 10841:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTSP:{ *:[i32] } ?:{ *:[v4f32] }:$A), GPRC:{ *:[i32] })
     /*  62613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTSP),
     /*  62620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62644 */     // GIR_Coverage, 1657,
     /*  62644 */     GIR_EraseRootFromParent_Done,
     /*  62645 */   // Label 910: @62645
     /*  62645 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(62677), // Rule ID 1658 //
     /*  62650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvresp),
     /*  62658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62668 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10833:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRESP),
     /*  62671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62673 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62675 */     GIR_RootConstrainSelectedInstOperands,
     /*  62676 */     // GIR_Coverage, 1658,
     /*  62676 */     GIR_EraseRootFromParent_Done,
     /*  62677 */   // Label 911: @62677
     /*  62677 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(62709), // Rule ID 1659 //
     /*  62682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvredp),
     /*  62690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62700 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10832:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVREDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVREDP),
     /*  62703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62705 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62707 */     GIR_RootConstrainSelectedInstOperands,
     /*  62708 */     // GIR_Coverage, 1659,
     /*  62708 */     GIR_EraseRootFromParent_Done,
     /*  62709 */   // Label 912: @62709
     /*  62709 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(62741), // Rule ID 1660 //
     /*  62714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtesp),
     /*  62722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62732 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10836:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRSQRTESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTESP),
     /*  62735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62737 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62739 */     GIR_RootConstrainSelectedInstOperands,
     /*  62740 */     // GIR_Coverage, 1660,
     /*  62740 */     GIR_EraseRootFromParent_Done,
     /*  62741 */   // Label 913: @62741
     /*  62741 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(62773), // Rule ID 1661 //
     /*  62746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtedp),
     /*  62754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62764 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10835:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVRSQRTEDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTEDP),
     /*  62767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62769 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62771 */     GIR_RootConstrainSelectedInstOperands,
     /*  62772 */     // GIR_Coverage, 1661,
     /*  62772 */     GIR_EraseRootFromParent_Done,
     /*  62773 */   // Label 914: @62773
     /*  62773 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(62805), // Rule ID 1747 //
     /*  62778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  62786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62796 */     // (intrinsic_wo_chain:{ *:[f64] } 10589:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSREDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSREDP),
     /*  62799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62801 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62803 */     GIR_RootConstrainSelectedInstOperands,
     /*  62804 */     // GIR_Coverage, 1747,
     /*  62804 */     GIR_EraseRootFromParent_Done,
     /*  62805 */   // Label 915: @62805
     /*  62805 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(62837), // Rule ID 1749 //
     /*  62810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  62818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62828 */     // (intrinsic_wo_chain:{ *:[f64] } 10584:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSNABSDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /*  62831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62833 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62835 */     GIR_RootConstrainSelectedInstOperands,
     /*  62836 */     // GIR_Coverage, 1749,
     /*  62836 */     GIR_EraseRootFromParent_Done,
     /*  62837 */   // Label 916: @62837
     /*  62837 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(62869), // Rule ID 1750 //
     /*  62842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  62850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62860 */     // (intrinsic_wo_chain:{ *:[f32] } 10585:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSNABSDPs:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /*  62863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62865 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62867 */     GIR_RootConstrainSelectedInstOperands,
     /*  62868 */     // GIR_Coverage, 1750,
     /*  62868 */     GIR_EraseRootFromParent_Done,
     /*  62869 */   // Label 917: @62869
     /*  62869 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(62901), // Rule ID 1934 //
     /*  62874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  62882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62892 */     // (intrinsic_wo_chain:{ *:[f32] } 10590:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSRESP:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRESP),
     /*  62895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62897 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62899 */     GIR_RootConstrainSelectedInstOperands,
     /*  62900 */     // GIR_Coverage, 1934,
     /*  62900 */     GIR_EraseRootFromParent_Done,
     /*  62901 */   // Label 918: @62901
     /*  62901 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(62985), // Rule ID 1935 //
     /*  62906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_exp),
     /*  62914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62924 */     // (intrinsic_wo_chain:{ *:[i32] } 10569:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (EXTRACT_SUBREG:{ *:[i32] } (XSXEXPDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  62924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  62927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62940 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  62948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSXEXPDP),
     /*  62952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62957 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62967 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  62974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  62984 */     // GIR_Coverage, 1935,
     /*  62984 */     GIR_EraseRootFromParent_Done,
     /*  62985 */   // Label 919: @62985
     /*  62985 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(63039), // Rule ID 1936 //
     /*  62990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_sig),
     /*  62998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63008 */     // (intrinsic_wo_chain:{ *:[i64] } 10570:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSXSIGDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] }))
     /*  63008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  63029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSXSIGDP),
     /*  63032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63037 */     GIR_RootConstrainSelectedInstOperands,
     /*  63038 */     // GIR_Coverage, 1936,
     /*  63038 */     GIR_EraseRootFromParent_Done,
     /*  63039 */   // Label 920: @63039
     /*  63039 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(63093), // Rule ID 2151 //
     /*  63044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvhpsp),
     /*  63052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63062 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10813:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A)  =>  (XVCVHPSP:{ *:[v4f32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }))
     /*  63062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVHPSP),
     /*  63086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  63088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63091 */     GIR_RootConstrainSelectedInstOperands,
     /*  63092 */     // GIR_Coverage, 2151,
     /*  63092 */     GIR_EraseRootFromParent_Done,
     /*  63093 */   // Label 921: @63093
     /*  63093 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(63173), // Rule ID 2165 //
     /*  63098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_extract_expq),
     /*  63106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  63112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63116 */     // (intrinsic_wo_chain:{ *:[i64] } 10737:{ *:[iPTR] }, f128:{ *:[f128] }:$vA)  =>  (MFVSRD:{ *:[i64] } (EXTRACT_SUBREG:{ *:[f64] } (XSXEXPQP:{ *:[v2i64] } ?:{ *:[f128] }:$vA), sub_64:{ *:[i32] }))
     /*  63116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  63119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSXEXPQP),
     /*  63123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63128 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vA
     /*  63132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  63134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63146 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  63153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /*  63158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  63166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63171 */     GIR_RootConstrainSelectedInstOperands,
     /*  63172 */     // GIR_Coverage, 2165,
     /*  63172 */     GIR_EraseRootFromParent_Done,
     /*  63173 */   // Label 922: @63173
     /*  63173 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(63216), // Rule ID 1093 //
     /*  63178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  63181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  63186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63204 */     // MIs[1] Operand 1
     /*  63204 */     // No operand predicates
     /*  63204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63206 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10234:{ *:[iPTR] }, (imm:{ *:[i64] }):$D)  =>  (MTVSRBMI:{ *:[v16i8] } (imm:{ *:[i64] }):$D)
     /*  63206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBMI),
     /*  63209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*  63214 */     GIR_RootConstrainSelectedInstOperands,
     /*  63215 */     // GIR_Coverage, 1093,
     /*  63215 */     GIR_EraseRootFromParent_Done,
     /*  63216 */   // Label 923: @63216
     /*  63216 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(63249), // Rule ID 4850 //
     /*  63221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  63226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63240 */     // (intrinsic_wo_chain:{ *:[f64] } 10591:{ *:[iPTR] }, f8rc:{ *:[f64] }:$frB)  =>  (FRSQRTE:{ *:[f64] } ?:{ *:[f64] }:$frB)
     /*  63240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTE),
     /*  63243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63245 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63247 */     GIR_RootConstrainSelectedInstOperands,
     /*  63248 */     // GIR_Coverage, 4850,
     /*  63248 */     GIR_EraseRootFromParent_Done,
     /*  63249 */   // Label 924: @63249
     /*  63249 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(63282), // Rule ID 4851 //
     /*  63254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  63259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63273 */     // (intrinsic_wo_chain:{ *:[f32] } 10592:{ *:[iPTR] }, f4rc:{ *:[f32] }:$frB)  =>  (FRSQRTES:{ *:[f32] } ?:{ *:[f32] }:$frB)
     /*  63273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTES),
     /*  63276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63278 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63280 */     GIR_RootConstrainSelectedInstOperands,
     /*  63281 */     // GIR_Coverage, 4851,
     /*  63281 */     GIR_EraseRootFromParent_Done,
     /*  63282 */   // Label 925: @63282
     /*  63282 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(63311), // Rule ID 73 //
     /*  63287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  63292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63302 */     // (intrinsic_wo_chain:{ *:[i32] } 10732:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (POPCNTB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB),
     /*  63305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63307 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63309 */     GIR_RootConstrainSelectedInstOperands,
     /*  63310 */     // GIR_Coverage, 73,
     /*  63310 */     GIR_EraseRootFromParent_Done,
     /*  63311 */   // Label 926: @63311
     /*  63311 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(63340), // Rule ID 74 //
     /*  63316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcd),
     /*  63321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63331 */     // (intrinsic_wo_chain:{ *:[i32] } 10528:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CDTBCD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD),
     /*  63334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63336 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63338 */     GIR_RootConstrainSelectedInstOperands,
     /*  63339 */     // GIR_Coverage, 74,
     /*  63339 */     GIR_EraseRootFromParent_Done,
     /*  63340 */   // Label 927: @63340
     /*  63340 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(63369), // Rule ID 75 //
     /*  63345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtd),
     /*  63350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63360 */     // (intrinsic_wo_chain:{ *:[i32] } 10526:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CBCDTD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD),
     /*  63363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63365 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63367 */     GIR_RootConstrainSelectedInstOperands,
     /*  63368 */     // GIR_Coverage, 75,
     /*  63368 */     GIR_EraseRootFromParent_Done,
     /*  63369 */   // Label 928: @63369
     /*  63369 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(63401), // Rule ID 321 //
     /*  63374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexptefp),
     /*  63382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63392 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10341:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VEXPTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPTEFP),
     /*  63395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63397 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63399 */     GIR_RootConstrainSelectedInstOperands,
     /*  63400 */     // GIR_Coverage, 321,
     /*  63400 */     GIR_EraseRootFromParent_Done,
     /*  63401 */   // Label 929: @63401
     /*  63401 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(63433), // Rule ID 322 //
     /*  63406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vlogefp),
     /*  63414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63424 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10379:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VLOGEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VLOGEFP),
     /*  63427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63429 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63431 */     GIR_RootConstrainSelectedInstOperands,
     /*  63432 */     // GIR_Coverage, 322,
     /*  63432 */     GIR_EraseRootFromParent_Done,
     /*  63433 */   // Label 930: @63433
     /*  63433 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(63465), // Rule ID 363 //
     /*  63438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrefp),
     /*  63446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63456 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10447:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VREFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VREFP),
     /*  63459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63461 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63463 */     GIR_RootConstrainSelectedInstOperands,
     /*  63464 */     // GIR_Coverage, 363,
     /*  63464 */     GIR_EraseRootFromParent_Done,
     /*  63465 */   // Label 931: @63465
     /*  63465 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(63497), // Rule ID 364 //
     /*  63470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfim),
     /*  63478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63488 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10448:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /*  63491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63493 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63495 */     GIR_RootConstrainSelectedInstOperands,
     /*  63496 */     // GIR_Coverage, 364,
     /*  63496 */     GIR_EraseRootFromParent_Done,
     /*  63497 */   // Label 932: @63497
     /*  63497 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(63529), // Rule ID 365 //
     /*  63502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfin),
     /*  63510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63520 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10449:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIN:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /*  63523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63525 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63527 */     GIR_RootConstrainSelectedInstOperands,
     /*  63528 */     // GIR_Coverage, 365,
     /*  63528 */     GIR_EraseRootFromParent_Done,
     /*  63529 */   // Label 933: @63529
     /*  63529 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(63561), // Rule ID 366 //
     /*  63534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfip),
     /*  63542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63552 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10450:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /*  63555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63557 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63559 */     GIR_RootConstrainSelectedInstOperands,
     /*  63560 */     // GIR_Coverage, 366,
     /*  63560 */     GIR_EraseRootFromParent_Done,
     /*  63561 */   // Label 934: @63561
     /*  63561 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(63593), // Rule ID 367 //
     /*  63566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfiz),
     /*  63574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63584 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10451:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  63587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63589 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63591 */     GIR_RootConstrainSelectedInstOperands,
     /*  63592 */     // GIR_Coverage, 367,
     /*  63592 */     GIR_EraseRootFromParent_Done,
     /*  63593 */   // Label 935: @63593
     /*  63593 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(63625), // Rule ID 368 //
     /*  63598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrsqrtefp),
     /*  63606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63616 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10462:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRSQRTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRSQRTEFP),
     /*  63619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63621 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63623 */     GIR_RootConstrainSelectedInstOperands,
     /*  63624 */     // GIR_Coverage, 368,
     /*  63624 */     GIR_EraseRootFromParent_Done,
     /*  63625 */   // Label 936: @63625
     /*  63625 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(63657), // Rule ID 419 //
     /*  63630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhpx),
     /*  63638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63648 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10504:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHPX),
     /*  63651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63653 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63655 */     GIR_RootConstrainSelectedInstOperands,
     /*  63656 */     // GIR_Coverage, 419,
     /*  63656 */     GIR_EraseRootFromParent_Done,
     /*  63657 */   // Label 937: @63657
     /*  63657 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(63689), // Rule ID 420 //
     /*  63662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsb),
     /*  63670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63680 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10505:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKHSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSB),
     /*  63683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63685 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63687 */     GIR_RootConstrainSelectedInstOperands,
     /*  63688 */     // GIR_Coverage, 420,
     /*  63688 */     GIR_EraseRootFromParent_Done,
     /*  63689 */   // Label 938: @63689
     /*  63689 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(63721), // Rule ID 421 //
     /*  63694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsh),
     /*  63702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63712 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10506:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSH),
     /*  63715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63717 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63719 */     GIR_RootConstrainSelectedInstOperands,
     /*  63720 */     // GIR_Coverage, 421,
     /*  63720 */     GIR_EraseRootFromParent_Done,
     /*  63721 */   // Label 939: @63721
     /*  63721 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(63753), // Rule ID 422 //
     /*  63726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklpx),
     /*  63734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63744 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10508:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLPX),
     /*  63747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63749 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63751 */     GIR_RootConstrainSelectedInstOperands,
     /*  63752 */     // GIR_Coverage, 422,
     /*  63752 */     GIR_EraseRootFromParent_Done,
     /*  63753 */   // Label 940: @63753
     /*  63753 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(63785), // Rule ID 423 //
     /*  63758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsb),
     /*  63766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63776 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10509:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKLSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSB),
     /*  63779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63781 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63783 */     GIR_RootConstrainSelectedInstOperands,
     /*  63784 */     // GIR_Coverage, 423,
     /*  63784 */     GIR_EraseRootFromParent_Done,
     /*  63785 */   // Label 941: @63785
     /*  63785 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(63817), // Rule ID 424 //
     /*  63790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsh),
     /*  63798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10510:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSH),
     /*  63811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63813 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63815 */     GIR_RootConstrainSelectedInstOperands,
     /*  63816 */     // GIR_Coverage, 424,
     /*  63816 */     GIR_EraseRootFromParent_Done,
     /*  63817 */   // Label 942: @63817
     /*  63817 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(63849), // Rule ID 504 //
     /*  63822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsw),
     /*  63830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63840 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10507:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKHSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSW),
     /*  63843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63845 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63847 */     GIR_RootConstrainSelectedInstOperands,
     /*  63848 */     // GIR_Coverage, 504,
     /*  63848 */     GIR_EraseRootFromParent_Done,
     /*  63849 */   // Label 943: @63849
     /*  63849 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(63881), // Rule ID 505 //
     /*  63854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsw),
     /*  63862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63872 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10511:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKLSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSW),
     /*  63875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63877 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63879 */     GIR_RootConstrainSelectedInstOperands,
     /*  63880 */     // GIR_Coverage, 505,
     /*  63880 */     GIR_EraseRootFromParent_Done,
     /*  63881 */   // Label 944: @63881
     /*  63881 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(63913), // Rule ID 506 //
     /*  63886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgbbd),
     /*  63894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63904 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10361:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VGBBD:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  63904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGBBD),
     /*  63907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63909 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63911 */     GIR_RootConstrainSelectedInstOperands,
     /*  63912 */     // GIR_Coverage, 506,
     /*  63912 */     GIR_EraseRootFromParent_Done,
     /*  63913 */   // Label 945: @63913
     /*  63913 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(63945), // Rule ID 514 //
     /*  63918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  63921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vsbox),
     /*  63926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  63932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63936 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10216:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA)  =>  (VSBOX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA)
     /*  63936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSBOX),
     /*  63939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63941 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  63943 */     GIR_RootConstrainSelectedInstOperands,
     /*  63944 */     // GIR_Coverage, 514,
     /*  63944 */     GIR_EraseRootFromParent_Done,
     /*  63945 */   // Label 946: @63945
     /*  63945 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(63977), // Rule ID 530 //
     /*  63950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  63953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzlsbb),
     /*  63958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63968 */     // (intrinsic_wo_chain:{ *:[i32] } 10271:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  63968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZLSBB),
     /*  63971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63973 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63975 */     GIR_RootConstrainSelectedInstOperands,
     /*  63976 */     // GIR_Coverage, 530,
     /*  63976 */     GIR_EraseRootFromParent_Done,
     /*  63977 */   // Label 947: @63977
     /*  63977 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(64009), // Rule ID 531 //
     /*  63982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  63985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzlsbb),
     /*  63990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64000 */     // (intrinsic_wo_chain:{ *:[i32] } 10329:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZLSBB),
     /*  64003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64005 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64007 */     GIR_RootConstrainSelectedInstOperands,
     /*  64008 */     // GIR_Coverage, 531,
     /*  64008 */     GIR_EraseRootFromParent_Done,
     /*  64009 */   // Label 948: @64009
     /*  64009 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(64041), // Rule ID 536 //
     /*  64014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2w),
     /*  64022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64032 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10356:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2W:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /*  64035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64037 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64039 */     GIR_RootConstrainSelectedInstOperands,
     /*  64040 */     // GIR_Coverage, 536,
     /*  64040 */     GIR_EraseRootFromParent_Done,
     /*  64041 */   // Label 949: @64041
     /*  64041 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(64073), // Rule ID 537 //
     /*  64046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2w),
     /*  64054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64064 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10359:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2W:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /*  64067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64069 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64071 */     GIR_RootConstrainSelectedInstOperands,
     /*  64072 */     // GIR_Coverage, 537,
     /*  64072 */     GIR_EraseRootFromParent_Done,
     /*  64073 */   // Label 950: @64073
     /*  64073 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(64105), // Rule ID 538 //
     /*  64078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2d),
     /*  64086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64096 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10355:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2D:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VB)
     /*  64096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /*  64099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64101 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64103 */     GIR_RootConstrainSelectedInstOperands,
     /*  64104 */     // GIR_Coverage, 538,
     /*  64104 */     GIR_EraseRootFromParent_Done,
     /*  64105 */   // Label 951: @64105
     /*  64105 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(64137), // Rule ID 539 //
     /*  64110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2d),
     /*  64118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64128 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10358:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2D:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$VB)
     /*  64128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /*  64131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64133 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64135 */     GIR_RootConstrainSelectedInstOperands,
     /*  64136 */     // GIR_Coverage, 539,
     /*  64136 */     GIR_EraseRootFromParent_Done,
     /*  64137 */   // Label 952: @64137
     /*  64137 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(64169), // Rule ID 540 //
     /*  64142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsw2d),
     /*  64150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64160 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10360:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTSW2D:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  64160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /*  64163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64165 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64167 */     GIR_RootConstrainSelectedInstOperands,
     /*  64168 */     // GIR_Coverage, 540,
     /*  64168 */     GIR_EraseRootFromParent_Done,
     /*  64169 */   // Label 953: @64169
     /*  64169 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(64201), // Rule ID 543 //
     /*  64174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybw),
     /*  64182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64192 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10446:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VPRTYBW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBW),
     /*  64195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64197 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64199 */     GIR_RootConstrainSelectedInstOperands,
     /*  64200 */     // GIR_Coverage, 543,
     /*  64200 */     GIR_EraseRootFromParent_Done,
     /*  64201 */   // Label 954: @64201
     /*  64201 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(64233), // Rule ID 544 //
     /*  64206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybd),
     /*  64214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64224 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10444:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VPRTYBD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBD),
     /*  64227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64229 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64231 */     GIR_RootConstrainSelectedInstOperands,
     /*  64232 */     // GIR_Coverage, 544,
     /*  64232 */     GIR_EraseRootFromParent_Done,
     /*  64233 */   // Label 955: @64233
     /*  64233 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(64265), // Rule ID 545 //
     /*  64238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybq),
     /*  64246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64256 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10445:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VPRTYBQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBQ),
     /*  64259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64261 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64263 */     GIR_RootConstrainSelectedInstOperands,
     /*  64264 */     // GIR_Coverage, 545,
     /*  64264 */     GIR_EraseRootFromParent_Done,
     /*  64265 */   // Label 956: @64265
     /*  64265 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(64294), // Rule ID 689 //
     /*  64270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  64275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64285 */     // (intrinsic_wo_chain:{ *:[i64] } 10732:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (POPCNTB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB8),
     /*  64288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64290 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64292 */     GIR_RootConstrainSelectedInstOperands,
     /*  64293 */     // GIR_Coverage, 689,
     /*  64293 */     GIR_EraseRootFromParent_Done,
     /*  64294 */   // Label 957: @64294
     /*  64294 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(64323), // Rule ID 690 //
     /*  64299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcdd),
     /*  64304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64314 */     // (intrinsic_wo_chain:{ *:[i64] } 10529:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CDTBCD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD8),
     /*  64317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64319 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64321 */     GIR_RootConstrainSelectedInstOperands,
     /*  64322 */     // GIR_Coverage, 690,
     /*  64322 */     GIR_EraseRootFromParent_Done,
     /*  64323 */   // Label 958: @64323
     /*  64323 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(64352), // Rule ID 691 //
     /*  64328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtdd),
     /*  64333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64343 */     // (intrinsic_wo_chain:{ *:[i64] } 10527:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CBCDTD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD8),
     /*  64346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64348 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64350 */     GIR_RootConstrainSelectedInstOperands,
     /*  64351 */     // GIR_Coverage, 691,
     /*  64351 */     GIR_EraseRootFromParent_Done,
     /*  64352 */   // Label 959: @64352
     /*  64352 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(64384), // Rule ID 1058 //
     /*  64357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribr),
     /*  64365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64375 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10483:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBR:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBR),
     /*  64378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64380 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64382 */     GIR_RootConstrainSelectedInstOperands,
     /*  64383 */     // GIR_Coverage, 1058,
     /*  64383 */     GIR_EraseRootFromParent_Done,
     /*  64384 */   // Label 960: @64384
     /*  64384 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(64416), // Rule ID 1059 //
     /*  64389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribl),
     /*  64397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64407 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10481:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBL:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBL),
     /*  64410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64412 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64414 */     GIR_RootConstrainSelectedInstOperands,
     /*  64415 */     // GIR_Coverage, 1059,
     /*  64415 */     GIR_EraseRootFromParent_Done,
     /*  64416 */   // Label 961: @64416
     /*  64416 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(64448), // Rule ID 1060 //
     /*  64421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihr),
     /*  64429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64439 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10487:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHR:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHR),
     /*  64442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64444 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64446 */     GIR_RootConstrainSelectedInstOperands,
     /*  64447 */     // GIR_Coverage, 1060,
     /*  64447 */     GIR_EraseRootFromParent_Done,
     /*  64448 */   // Label 962: @64448
     /*  64448 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(64480), // Rule ID 1061 //
     /*  64453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihl),
     /*  64461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64471 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10485:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHL:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHL),
     /*  64474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64476 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64478 */     GIR_RootConstrainSelectedInstOperands,
     /*  64479 */     // GIR_Coverage, 1061,
     /*  64479 */     GIR_EraseRootFromParent_Done,
     /*  64480 */   // Label 963: @64480
     /*  64480 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(64512), // Rule ID 1078 //
     /*  64485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractbm),
     /*  64493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64503 */     // (intrinsic_wo_chain:{ *:[i32] } 10350:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTRACTBM:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTBM),
     /*  64506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64508 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64510 */     GIR_RootConstrainSelectedInstOperands,
     /*  64511 */     // GIR_Coverage, 1078,
     /*  64511 */     GIR_EraseRootFromParent_Done,
     /*  64512 */   // Label 964: @64512
     /*  64512 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(64544), // Rule ID 1079 //
     /*  64517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextracthm),
     /*  64525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64535 */     // (intrinsic_wo_chain:{ *:[i32] } 10352:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTRACTHM:{ *:[i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTHM),
     /*  64538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64540 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64542 */     GIR_RootConstrainSelectedInstOperands,
     /*  64543 */     // GIR_Coverage, 1079,
     /*  64543 */     GIR_EraseRootFromParent_Done,
     /*  64544 */   // Label 965: @64544
     /*  64544 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(64576), // Rule ID 1080 //
     /*  64549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractwm),
     /*  64557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64567 */     // (intrinsic_wo_chain:{ *:[i32] } 10354:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTRACTWM:{ *:[i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTWM),
     /*  64570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64572 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64574 */     GIR_RootConstrainSelectedInstOperands,
     /*  64575 */     // GIR_Coverage, 1080,
     /*  64575 */     GIR_EraseRootFromParent_Done,
     /*  64576 */   // Label 966: @64576
     /*  64576 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(64608), // Rule ID 1081 //
     /*  64581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractdm),
     /*  64589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64599 */     // (intrinsic_wo_chain:{ *:[i32] } 10351:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTRACTDM:{ *:[i32] } v2i64:{ *:[v2i64] }:$VB)
     /*  64599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTDM),
     /*  64602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64604 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64606 */     GIR_RootConstrainSelectedInstOperands,
     /*  64607 */     // GIR_Coverage, 1081,
     /*  64607 */     GIR_EraseRootFromParent_Done,
     /*  64608 */   // Label 967: @64608
     /*  64608 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(64640), // Rule ID 1082 //
     /*  64613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractqm),
     /*  64621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64631 */     // (intrinsic_wo_chain:{ *:[i32] } 10353:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXTRACTQM:{ *:[i32] } v1i128:{ *:[v1i128] }:$VB)
     /*  64631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTQM),
     /*  64634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64636 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64638 */     GIR_RootConstrainSelectedInstOperands,
     /*  64639 */     // GIR_Coverage, 1082,
     /*  64639 */     GIR_EraseRootFromParent_Done,
     /*  64640 */   // Label 968: @64640
     /*  64640 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(64672), // Rule ID 1083 //
     /*  64645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandbm),
     /*  64653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64663 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10336:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXPANDBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDBM),
     /*  64666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64668 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64670 */     GIR_RootConstrainSelectedInstOperands,
     /*  64671 */     // GIR_Coverage, 1083,
     /*  64671 */     GIR_EraseRootFromParent_Done,
     /*  64672 */   // Label 969: @64672
     /*  64672 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(64704), // Rule ID 1084 //
     /*  64677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandhm),
     /*  64685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64695 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10338:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXPANDHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDHM),
     /*  64698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64700 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64702 */     GIR_RootConstrainSelectedInstOperands,
     /*  64703 */     // GIR_Coverage, 1084,
     /*  64703 */     GIR_EraseRootFromParent_Done,
     /*  64704 */   // Label 970: @64704
     /*  64704 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(64736), // Rule ID 1085 //
     /*  64709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandwm),
     /*  64717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64727 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10340:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXPANDWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDWM),
     /*  64730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64732 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64734 */     GIR_RootConstrainSelectedInstOperands,
     /*  64735 */     // GIR_Coverage, 1085,
     /*  64735 */     GIR_EraseRootFromParent_Done,
     /*  64736 */   // Label 971: @64736
     /*  64736 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(64768), // Rule ID 1086 //
     /*  64741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpanddm),
     /*  64749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64759 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10337:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXPANDDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDDM),
     /*  64762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64764 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64766 */     GIR_RootConstrainSelectedInstOperands,
     /*  64767 */     // GIR_Coverage, 1086,
     /*  64767 */     GIR_EraseRootFromParent_Done,
     /*  64768 */   // Label 972: @64768
     /*  64768 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(64800), // Rule ID 1087 //
     /*  64773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandqm),
     /*  64781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64791 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10339:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXPANDQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDQM),
     /*  64794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64796 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64798 */     GIR_RootConstrainSelectedInstOperands,
     /*  64799 */     // GIR_Coverage, 1087,
     /*  64799 */     GIR_EraseRootFromParent_Done,
     /*  64800 */   // Label 973: @64800
     /*  64800 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(64832), // Rule ID 1088 //
     /*  64805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  64813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64823 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10234:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRBM:{ *:[v16i8] } i64:{ *:[i64] }:$VB)
     /*  64823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBM),
     /*  64826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64828 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64830 */     GIR_RootConstrainSelectedInstOperands,
     /*  64831 */     // GIR_Coverage, 1088,
     /*  64831 */     GIR_EraseRootFromParent_Done,
     /*  64832 */   // Label 974: @64832
     /*  64832 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(64864), // Rule ID 1089 //
     /*  64837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrhm),
     /*  64845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64855 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10236:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRHM:{ *:[v8i16] } i64:{ *:[i64] }:$VB)
     /*  64855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRHM),
     /*  64858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64860 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64862 */     GIR_RootConstrainSelectedInstOperands,
     /*  64863 */     // GIR_Coverage, 1089,
     /*  64863 */     GIR_EraseRootFromParent_Done,
     /*  64864 */   // Label 975: @64864
     /*  64864 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(64896), // Rule ID 1090 //
     /*  64869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrwm),
     /*  64877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64887 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10238:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRWM:{ *:[v4i32] } i64:{ *:[i64] }:$VB)
     /*  64887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWM),
     /*  64890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64892 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64894 */     GIR_RootConstrainSelectedInstOperands,
     /*  64895 */     // GIR_Coverage, 1090,
     /*  64895 */     GIR_EraseRootFromParent_Done,
     /*  64896 */   // Label 976: @64896
     /*  64896 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(64928), // Rule ID 1091 //
     /*  64901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrdm),
     /*  64909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64919 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10235:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRDM:{ *:[v2i64] } i64:{ *:[i64] }:$VB)
     /*  64919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDM),
     /*  64922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64924 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64926 */     GIR_RootConstrainSelectedInstOperands,
     /*  64927 */     // GIR_Coverage, 1091,
     /*  64927 */     GIR_EraseRootFromParent_Done,
     /*  64928 */   // Label 977: @64928
     /*  64928 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(64960), // Rule ID 1092 //
     /*  64933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrqm),
     /*  64941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64951 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10237:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRQM:{ *:[v1i128] } i64:{ *:[i64] }:$VB)
     /*  64951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRQM),
     /*  64954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64956 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64958 */     GIR_RootConstrainSelectedInstOperands,
     /*  64959 */     // GIR_Coverage, 1092,
     /*  64959 */     GIR_EraseRootFromParent_Done,
     /*  64960 */   // Label 978: @64960
     /*  64960 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(64992), // Rule ID 1156 //
     /*  64965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsd2q),
     /*  64973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64983 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10357:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTSD2Q:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VB)
     /*  64983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSD2Q),
     /*  64986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64988 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64990 */     GIR_RootConstrainSelectedInstOperands,
     /*  64991 */     // GIR_Coverage, 1156,
     /*  64991 */     GIR_EraseRootFromParent_Done,
     /*  64992 */   // Label 979: @64992
     /*  64992 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(65024), // Rule ID 1161 //
     /*  64997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  65000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmmr),
     /*  65005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  65008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  65011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  65015 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10624:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMMR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$AB)
     /*  65015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMMR),
     /*  65018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65020 */     GIR_RootToRootCopy, /*OpIdx*/2, // AB
     /*  65022 */     GIR_RootConstrainSelectedInstOperands,
     /*  65023 */     // GIR_Coverage, 1161,
     /*  65023 */     GIR_EraseRootFromParent_Done,
     /*  65024 */   // Label 980: @65024
     /*  65024 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(65056), // Rule ID 1164 //
     /*  65029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmfacc),
     /*  65037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65047 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10715:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$AT)  =>  (XXMFACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$AT)
     /*  65047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMFACC),
     /*  65050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[ATo]
     /*  65052 */     GIR_RootToRootCopy, /*OpIdx*/2, // AT
     /*  65054 */     GIR_RootConstrainSelectedInstOperands,
     /*  65055 */     // GIR_Coverage, 1164,
     /*  65055 */     GIR_EraseRootFromParent_Done,
     /*  65056 */   // Label 981: @65056
     /*  65056 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(65088), // Rule ID 1165 //
     /*  65061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmtacc),
     /*  65069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65079 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10716:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi)  =>  (XXMTACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$ATi)
     /*  65079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMTACC),
     /*  65082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65084 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  65086 */     GIR_RootConstrainSelectedInstOperands,
     /*  65087 */     // GIR_Coverage, 1165,
     /*  65087 */     GIR_EraseRootFromParent_Done,
     /*  65088 */   // Label 982: @65088
     /*  65088 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(65117), // Rule ID 1280 //
     /*  65093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  65098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65108 */     // (intrinsic_wo_chain:{ *:[f64] } 10589:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FRE:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRE),
     /*  65111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65113 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65115 */     GIR_RootConstrainSelectedInstOperands,
     /*  65116 */     // GIR_Coverage, 1280,
     /*  65116 */     GIR_EraseRootFromParent_Done,
     /*  65117 */   // Label 983: @65117
     /*  65117 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(65146), // Rule ID 1281 //
     /*  65122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  65127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65137 */     // (intrinsic_wo_chain:{ *:[f32] } 10590:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FRES:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRES),
     /*  65140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65142 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65144 */     GIR_RootConstrainSelectedInstOperands,
     /*  65145 */     // GIR_Coverage, 1281,
     /*  65145 */     GIR_EraseRootFromParent_Done,
     /*  65146 */   // Label 984: @65146
     /*  65146 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(65175), // Rule ID 1282 //
     /*  65151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  65156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65166 */     // (intrinsic_wo_chain:{ *:[f64] } 10584:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FNABSD:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /*  65169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65171 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65173 */     GIR_RootConstrainSelectedInstOperands,
     /*  65174 */     // GIR_Coverage, 1282,
     /*  65174 */     GIR_EraseRootFromParent_Done,
     /*  65175 */   // Label 985: @65175
     /*  65175 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(65204), // Rule ID 1283 //
     /*  65180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  65185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65195 */     // (intrinsic_wo_chain:{ *:[f32] } 10585:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FNABSS:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /*  65198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65200 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65202 */     GIR_RootConstrainSelectedInstOperands,
     /*  65203 */     // GIR_Coverage, 1283,
     /*  65203 */     GIR_EraseRootFromParent_Done,
     /*  65204 */   // Label 986: @65204
     /*  65204 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(65279), // Rule ID 3357 //
     /*  65209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspbf16),
     /*  65217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65227 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10814:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVSPBF16:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65239 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65243 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVSPBF16),
     /*  65255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65260 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65278 */     // GIR_Coverage, 3357,
     /*  65278 */     GIR_EraseRootFromParent_Done,
     /*  65279 */   // Label 987: @65279
     /*  65279 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(65354), // Rule ID 3358 //
     /*  65284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvbf16spn),
     /*  65292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65302 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10809:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVBF16SPN:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65318 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVBF16SPN),
     /*  65330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65353 */     // GIR_Coverage, 3358,
     /*  65353 */     GIR_EraseRootFromParent_Done,
     /*  65354 */   // Label 988: @65354
     /*  65354 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(65383), // Rule ID 4888 //
     /*  65359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfid),
     /*  65364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65374 */     // (intrinsic_wo_chain:{ *:[f64] } 10571:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVSXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSXDDP),
     /*  65377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65379 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65381 */     GIR_RootConstrainSelectedInstOperands,
     /*  65382 */     // GIR_Coverage, 4888,
     /*  65382 */     GIR_EraseRootFromParent_Done,
     /*  65383 */   // Label 989: @65383
     /*  65383 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(65412), // Rule ID 4889 //
     /*  65388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfud),
     /*  65393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65403 */     // (intrinsic_wo_chain:{ *:[f64] } 10572:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVUXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUXDDP),
     /*  65406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65408 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65410 */     GIR_RootConstrainSelectedInstOperands,
     /*  65411 */     // GIR_Coverage, 4889,
     /*  65411 */     GIR_EraseRootFromParent_Done,
     /*  65412 */   // Label 990: @65412
     /*  65412 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(65441), // Rule ID 4890 //
     /*  65417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctid),
     /*  65422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65432 */     // (intrinsic_wo_chain:{ *:[f64] } 10573:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTID:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  65435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65437 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65439 */     GIR_RootConstrainSelectedInstOperands,
     /*  65440 */     // GIR_Coverage, 4890,
     /*  65440 */     GIR_EraseRootFromParent_Done,
     /*  65441 */   // Label 991: @65441
     /*  65441 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(65470), // Rule ID 4891 //
     /*  65446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctidz),
     /*  65451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65461 */     // (intrinsic_wo_chain:{ *:[f64] } 10574:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXDS),
     /*  65464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65466 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65468 */     GIR_RootConstrainSelectedInstOperands,
     /*  65469 */     // GIR_Coverage, 4891,
     /*  65469 */     GIR_EraseRootFromParent_Done,
     /*  65470 */   // Label 992: @65470
     /*  65470 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(65499), // Rule ID 4892 //
     /*  65475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiw),
     /*  65480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65490 */     // (intrinsic_wo_chain:{ *:[f64] } 10575:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTIW:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /*  65493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65495 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65497 */     GIR_RootConstrainSelectedInstOperands,
     /*  65498 */     // GIR_Coverage, 4892,
     /*  65498 */     GIR_EraseRootFromParent_Done,
     /*  65499 */   // Label 993: @65499
     /*  65499 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(65528), // Rule ID 4893 //
     /*  65504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiwz),
     /*  65509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65519 */     // (intrinsic_wo_chain:{ *:[f64] } 10576:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXWS),
     /*  65522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65524 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65526 */     GIR_RootConstrainSelectedInstOperands,
     /*  65527 */     // GIR_Coverage, 4893,
     /*  65527 */     GIR_EraseRootFromParent_Done,
     /*  65528 */   // Label 994: @65528
     /*  65528 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(65557), // Rule ID 4894 //
     /*  65533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctudz),
     /*  65538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65548 */     // (intrinsic_wo_chain:{ *:[f64] } 10577:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXDS),
     /*  65551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65553 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65555 */     GIR_RootConstrainSelectedInstOperands,
     /*  65556 */     // GIR_Coverage, 4894,
     /*  65556 */     GIR_EraseRootFromParent_Done,
     /*  65557 */   // Label 995: @65557
     /*  65557 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(65586), // Rule ID 4895 //
     /*  65562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctuwz),
     /*  65567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65577 */     // (intrinsic_wo_chain:{ *:[f64] } 10578:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXWS),
     /*  65580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65582 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65584 */     GIR_RootConstrainSelectedInstOperands,
     /*  65585 */     // GIR_Coverage, 4895,
     /*  65585 */     GIR_EraseRootFromParent_Done,
     /*  65586 */   // Label 996: @65586
     /*  65586 */   GIM_Reject,
     /*  65587 */ // Label 889: @65587
     /*  65587 */ GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(74223),
     /*  65592 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  65595 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(65666), // Rule ID 2167 //
     /*  65600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxextractuw),
     /*  65608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  65617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  65625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65629 */     // MIs[1] Operand 1
     /*  65629 */     // No operand predicates
     /*  65629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65631 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10853:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXEXTRACTUW:{ *:[f64] } ?:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM), VSRC:{ *:[i32] })
     /*  65631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  65634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXEXTRACTUW),
     /*  65638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65643 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  65647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  65650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65665 */     // GIR_Coverage, 2167,
     /*  65665 */     GIR_EraseRootFromParent_Done,
     /*  65666 */   // Label 998: @65666
     /*  65666 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(65703), // Rule ID 1029 //
     /*  65671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcsp),
     /*  65679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65689 */     // MIs[0] DCMX
     /*  65689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65692 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10843:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCSP:{ *:[v4i32] } (timm:{ *:[i32] }):$DCMX, v4f32:{ *:[v4f32] }:$XB)
     /*  65692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCSP),
     /*  65695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65697 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65699 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65701 */     GIR_RootConstrainSelectedInstOperands,
     /*  65702 */     // GIR_Coverage, 1029,
     /*  65702 */     GIR_EraseRootFromParent_Done,
     /*  65703 */   // Label 999: @65703
     /*  65703 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(65740), // Rule ID 1030 //
     /*  65708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcdp),
     /*  65716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65726 */     // MIs[0] DCMX
     /*  65726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65729 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10842:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCDP:{ *:[v2i64] } (timm:{ *:[i32] }):$DCMX, v2f64:{ *:[v2f64] }:$XB)
     /*  65729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCDP),
     /*  65732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65734 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65736 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65738 */     GIR_RootConstrainSelectedInstOperands,
     /*  65739 */     // GIR_Coverage, 1030,
     /*  65739 */     GIR_EraseRootFromParent_Done,
     /*  65740 */   // Label 1000: @65740
     /*  65740 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(65785), // Rule ID 898 //
     /*  65745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmaxdp),
     /*  65753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65774 */     // (intrinsic_wo_chain:{ *:[f64] } 10795:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMAXDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /*  65777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65779 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65781 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65783 */     GIR_RootConstrainSelectedInstOperands,
     /*  65784 */     // GIR_Coverage, 898,
     /*  65784 */     GIR_EraseRootFromParent_Done,
     /*  65785 */   // Label 1001: @65785
     /*  65785 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(65830), // Rule ID 899 //
     /*  65790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmindp),
     /*  65798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65819 */     // (intrinsic_wo_chain:{ *:[f64] } 10796:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMINDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /*  65822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65824 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65826 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65828 */     GIR_RootConstrainSelectedInstOperands,
     /*  65829 */     // GIR_Coverage, 899,
     /*  65829 */     GIR_EraseRootFromParent_Done,
     /*  65830 */   // Label 1002: @65830
     /*  65830 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(65875), // Rule ID 900 //
     /*  65835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxdp),
     /*  65843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65864 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10827:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMAXDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /*  65867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65869 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65871 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65873 */     GIR_RootConstrainSelectedInstOperands,
     /*  65874 */     // GIR_Coverage, 900,
     /*  65874 */     GIR_EraseRootFromParent_Done,
     /*  65875 */   // Label 1003: @65875
     /*  65875 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(65920), // Rule ID 901 //
     /*  65880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmindp),
     /*  65888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65909 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10829:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMINDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /*  65912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65914 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65916 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65918 */     GIR_RootConstrainSelectedInstOperands,
     /*  65919 */     // GIR_Coverage, 901,
     /*  65919 */     GIR_EraseRootFromParent_Done,
     /*  65920 */   // Label 1004: @65920
     /*  65920 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(65965), // Rule ID 902 //
     /*  65925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxsp),
     /*  65933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65954 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10828:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMAXSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  65954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /*  65957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65959 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65961 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65963 */     GIR_RootConstrainSelectedInstOperands,
     /*  65964 */     // GIR_Coverage, 902,
     /*  65964 */     GIR_EraseRootFromParent_Done,
     /*  65965 */   // Label 1005: @65965
     /*  65965 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(66010), // Rule ID 903 //
     /*  65970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvminsp),
     /*  65978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65999 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10830:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMINSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  65999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /*  66002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66004 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66006 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66008 */     GIR_RootConstrainSelectedInstOperands,
     /*  66009 */     // GIR_Coverage, 903,
     /*  66009 */     GIR_EraseRootFromParent_Done,
     /*  66010 */   // Label 1006: @66010
     /*  66010 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(66047), // Rule ID 827 //
     /*  66015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqdp),
     /*  66023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66036 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10797:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPEQDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQDP),
     /*  66039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66041 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66043 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66045 */     GIR_RootConstrainSelectedInstOperands,
     /*  66046 */     // GIR_Coverage, 827,
     /*  66046 */     GIR_EraseRootFromParent_Done,
     /*  66047 */   // Label 1007: @66047
     /*  66047 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(66084), // Rule ID 829 //
     /*  66052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqsp),
     /*  66060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66073 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10799:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPEQSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQSP),
     /*  66076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66078 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66080 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66082 */     GIR_RootConstrainSelectedInstOperands,
     /*  66083 */     // GIR_Coverage, 829,
     /*  66083 */     GIR_EraseRootFromParent_Done,
     /*  66084 */   // Label 1008: @66084
     /*  66084 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(66121), // Rule ID 831 //
     /*  66089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgedp),
     /*  66097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66110 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10801:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGEDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGEDP),
     /*  66113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66115 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66117 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66119 */     GIR_RootConstrainSelectedInstOperands,
     /*  66120 */     // GIR_Coverage, 831,
     /*  66120 */     GIR_EraseRootFromParent_Done,
     /*  66121 */   // Label 1009: @66121
     /*  66121 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(66158), // Rule ID 833 //
     /*  66126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgesp),
     /*  66134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66147 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10803:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGESP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGESP),
     /*  66150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66152 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66154 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66156 */     GIR_RootConstrainSelectedInstOperands,
     /*  66157 */     // GIR_Coverage, 833,
     /*  66157 */     GIR_EraseRootFromParent_Done,
     /*  66158 */   // Label 1010: @66158
     /*  66158 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(66195), // Rule ID 835 //
     /*  66163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtdp),
     /*  66171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66184 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10805:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGTDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTDP),
     /*  66187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66189 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66191 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66193 */     GIR_RootConstrainSelectedInstOperands,
     /*  66194 */     // GIR_Coverage, 835,
     /*  66194 */     GIR_EraseRootFromParent_Done,
     /*  66195 */   // Label 1011: @66195
     /*  66195 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(66232), // Rule ID 837 //
     /*  66200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtsp),
     /*  66208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66221 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10807:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGTSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTSP),
     /*  66224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66226 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66228 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66230 */     GIR_RootConstrainSelectedInstOperands,
     /*  66231 */     // GIR_Coverage, 837,
     /*  66231 */     GIR_EraseRootFromParent_Done,
     /*  66232 */   // Label 1012: @66232
     /*  66232 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(66269), // Rule ID 1001 //
     /*  66237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addf128_round_to_odd),
     /*  66245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66258 */     // (intrinsic_wo_chain:{ *:[f128] } 10203:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSADDQPO),
     /*  66261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66263 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66265 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66267 */     GIR_RootConstrainSelectedInstOperands,
     /*  66268 */     // GIR_Coverage, 1001,
     /*  66268 */     GIR_EraseRootFromParent_Done,
     /*  66269 */   // Label 1013: @66269
     /*  66269 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(66306), // Rule ID 1002 //
     /*  66274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulf128_round_to_odd),
     /*  66282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66295 */     // (intrinsic_wo_chain:{ *:[f128] } 10724:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMULQPO),
     /*  66298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66300 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66302 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66304 */     GIR_RootConstrainSelectedInstOperands,
     /*  66305 */     // GIR_Coverage, 1002,
     /*  66305 */     GIR_EraseRootFromParent_Done,
     /*  66306 */   // Label 1014: @66306
     /*  66306 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(66343), // Rule ID 1003 //
     /*  66311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_subf128_round_to_odd),
     /*  66319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66332 */     // (intrinsic_wo_chain:{ *:[f128] } 10755:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSUBQPO),
     /*  66335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66337 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66339 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66341 */     GIR_RootConstrainSelectedInstOperands,
     /*  66342 */     // GIR_Coverage, 1003,
     /*  66342 */     GIR_EraseRootFromParent_Done,
     /*  66343 */   // Label 1015: @66343
     /*  66343 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(66380), // Rule ID 1004 //
     /*  66348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divf128_round_to_odd),
     /*  66356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66369 */     // (intrinsic_wo_chain:{ *:[f128] } 10565:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSDIVQPO),
     /*  66372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66374 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66376 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66378 */     GIR_RootConstrainSelectedInstOperands,
     /*  66379 */     // GIR_Coverage, 1004,
     /*  66379 */     GIR_EraseRootFromParent_Done,
     /*  66380 */   // Label 1016: @66380
     /*  66380 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(66417), // Rule ID 1023 //
     /*  66385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpdp),
     /*  66393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66406 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10825:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)  =>  (XVIEXPDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)
     /*  66406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPDP),
     /*  66409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66411 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66413 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66415 */     GIR_RootConstrainSelectedInstOperands,
     /*  66416 */     // GIR_Coverage, 1023,
     /*  66416 */     GIR_EraseRootFromParent_Done,
     /*  66417 */   // Label 1017: @66417
     /*  66417 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(66454), // Rule ID 1024 //
     /*  66422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpsp),
     /*  66430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66443 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10826:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XVIEXPSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  66443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPSP),
     /*  66446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66448 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66450 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66452 */     GIR_RootConstrainSelectedInstOperands,
     /*  66453 */     // GIR_Coverage, 1024,
     /*  66453 */     GIR_EraseRootFromParent_Done,
     /*  66454 */   // Label 1018: @66454
     /*  66454 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(66491), // Rule ID 1652 //
     /*  66459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivsp),
     /*  66467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66480 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10824:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (XVDIVSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B)
     /*  66480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /*  66483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66485 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66487 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66489 */     GIR_RootConstrainSelectedInstOperands,
     /*  66490 */     // GIR_Coverage, 1652,
     /*  66490 */     GIR_EraseRootFromParent_Done,
     /*  66491 */   // Label 1019: @66491
     /*  66491 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(66528), // Rule ID 1653 //
     /*  66496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivdp),
     /*  66504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66517 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10823:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (XVDIVDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B)
     /*  66517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /*  66520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66522 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66524 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66526 */     GIR_RootConstrainSelectedInstOperands,
     /*  66527 */     // GIR_Coverage, 1653,
     /*  66527 */     GIR_EraseRootFromParent_Done,
     /*  66528 */   // Label 1020: @66528
     /*  66528 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(66590), // Rule ID 1654 //
     /*  66533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivdp),
     /*  66541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66554 */     // (intrinsic_wo_chain:{ *:[i32] } 10837:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVDP:{ *:[i32] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B), GPRC:{ *:[i32] })
     /*  66554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVDP),
     /*  66561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66589 */     // GIR_Coverage, 1654,
     /*  66589 */     GIR_EraseRootFromParent_Done,
     /*  66590 */   // Label 1021: @66590
     /*  66590 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(66652), // Rule ID 1655 //
     /*  66595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivsp),
     /*  66603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66616 */     // (intrinsic_wo_chain:{ *:[i32] } 10838:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVSP:{ *:[i32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B), GPRC:{ *:[i32] })
     /*  66616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVSP),
     /*  66623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66651 */     // GIR_Coverage, 1655,
     /*  66651 */     GIR_EraseRootFromParent_Done,
     /*  66652 */   // Label 1022: @66652
     /*  66652 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(66689), // Rule ID 1899 //
     /*  66657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxleqv),
     /*  66665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66678 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10859:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B)  =>  (XXLEQV:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  66678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  66681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66683 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66685 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66687 */     GIR_RootConstrainSelectedInstOperands,
     /*  66688 */     // GIR_Coverage, 1899,
     /*  66688 */     GIR_EraseRootFromParent_Done,
     /*  66689 */   // Label 1023: @66689
     /*  66689 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(66771), // Rule ID 1937 //
     /*  66694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_insert_exp),
     /*  66702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  66705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  66708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66715 */     // (intrinsic_wo_chain:{ *:[f64] } 10600:{ *:[iPTR] }, f64:{ *:[f64] }:$A, i64:{ *:[i64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f64] } (XSIEXPDP:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[i64] } ?:{ *:[f64] }:$A, G8RC:{ *:[i32] }), ?:{ *:[i64] }:$B), F8RC:{ *:[i32] })
     /*  66715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  66718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66731 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  66736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSIEXPDP),
     /*  66743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66748 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66751 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66770 */     // GIR_Coverage, 1937,
     /*  66770 */     GIR_EraseRootFromParent_Done,
     /*  66771 */   // Label 1024: @66771
     /*  66771 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(66827), // Rule ID 2164 //
     /*  66776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_insert_exp_qp),
     /*  66784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66797 */     // (intrinsic_wo_chain:{ *:[f128] } 10738:{ *:[iPTR] }, f128:{ *:[f128] }:$vA, i64:{ *:[i64] }:$vB)  =>  (XSIEXPQP:{ *:[f128] } ?:{ *:[f128] }:$vA, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$vB))
     /*  66797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  66800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  66804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vB
     /*  66813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSIEXPQP),
     /*  66818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  66820 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  66822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66825 */     GIR_RootConstrainSelectedInstOperands,
     /*  66826 */     // GIR_Coverage, 2164,
     /*  66826 */     GIR_EraseRootFromParent_Done,
     /*  66827 */   // Label 1025: @66827
     /*  66827 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(66918), // Rule ID 3347 //
     /*  66832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  66857 */     // (intrinsic_wo_chain:{ *:[i32] } 10839:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 1:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_lt:{ *:[i32] })
     /*  66857 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  66860 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66864 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  66873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  66885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66890 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66900 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  66907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  66917 */     // GIR_Coverage, 3347,
     /*  66917 */     GIR_EraseRootFromParent_Done,
     /*  66918 */   // Label 1026: @66918
     /*  66918 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(67009), // Rule ID 3348 //
     /*  66923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  66948 */     // (intrinsic_wo_chain:{ *:[i32] } 10839:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 0:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_eq:{ *:[i32] })
     /*  66948 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  66951 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66955 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66960 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  66964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  66976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66981 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  66998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  67003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  67008 */     // GIR_Coverage, 3348,
     /*  67008 */     GIR_EraseRootFromParent_Done,
     /*  67009 */   // Label 1027: @67009
     /*  67009 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(67052), // Rule ID 317 //
     /*  67014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67032 */     // MIs[0] Operand 3
     /*  67032 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67043 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10265:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFSX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /*  67046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67048 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67050 */     GIR_RootConstrainSelectedInstOperands,
     /*  67051 */     // GIR_Coverage, 317,
     /*  67051 */     GIR_EraseRootFromParent_Done,
     /*  67052 */   // Label 1028: @67052
     /*  67052 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(67095), // Rule ID 318 //
     /*  67057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67075 */     // MIs[0] Operand 3
     /*  67075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10327:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTUXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /*  67089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67091 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67093 */     GIR_RootConstrainSelectedInstOperands,
     /*  67094 */     // GIR_Coverage, 318,
     /*  67094 */     GIR_EraseRootFromParent_Done,
     /*  67095 */   // Label 1029: @67095
     /*  67095 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(67138), // Rule ID 319 //
     /*  67100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67118 */     // MIs[0] Operand 3
     /*  67118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67129 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10267:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFUX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /*  67132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67134 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67136 */     GIR_RootConstrainSelectedInstOperands,
     /*  67137 */     // GIR_Coverage, 319,
     /*  67137 */     GIR_EraseRootFromParent_Done,
     /*  67138 */   // Label 1030: @67138
     /*  67138 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(67181), // Rule ID 320 //
     /*  67143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67161 */     // MIs[0] Operand 3
     /*  67161 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67172 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10326:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTSXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /*  67175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67177 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67179 */     GIR_RootConstrainSelectedInstOperands,
     /*  67180 */     // GIR_Coverage, 320,
     /*  67180 */     GIR_EraseRootFromParent_Done,
     /*  67181 */   // Label 1031: @67181
     /*  67181 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(67252), // Rule ID 3343 //
     /*  67186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvbm),
     /*  67194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67215 */     // MIs[1] Operand 1
     /*  67215 */     // No operand predicates
     /*  67215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67217 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10854:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXGENPCVBM:{ *:[v4i32] } ?:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVBM),
     /*  67224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67251 */     // GIR_Coverage, 3343,
     /*  67251 */     GIR_EraseRootFromParent_Done,
     /*  67252 */   // Label 1032: @67252
     /*  67252 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(67323), // Rule ID 3344 //
     /*  67257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvhm),
     /*  67265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67286 */     // MIs[1] Operand 1
     /*  67286 */     // No operand predicates
     /*  67286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67288 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10856:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXGENPCVHM:{ *:[v4i32] } ?:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVHM),
     /*  67295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67322 */     // GIR_Coverage, 3344,
     /*  67322 */     GIR_EraseRootFromParent_Done,
     /*  67323 */   // Label 1033: @67323
     /*  67323 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(67394), // Rule ID 3345 //
     /*  67328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvwm),
     /*  67336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67357 */     // MIs[1] Operand 1
     /*  67357 */     // No operand predicates
     /*  67357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67359 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10857:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (XXGENPCVWM:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVWM),
     /*  67366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67393 */     // GIR_Coverage, 3345,
     /*  67393 */     GIR_EraseRootFromParent_Done,
     /*  67394 */   // Label 1034: @67394
     /*  67394 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(67465), // Rule ID 3346 //
     /*  67399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvdm),
     /*  67407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  67410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67428 */     // MIs[1] Operand 1
     /*  67428 */     // No operand predicates
     /*  67428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67430 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10855:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXGENPCVDM:{ *:[v4i32] } ?:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVDM),
     /*  67437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67464 */     // GIR_Coverage, 3346,
     /*  67464 */     GIR_EraseRootFromParent_Done,
     /*  67465 */   // Label 1035: @67465
     /*  67465 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(67502), // Rule ID 313 //
     /*  67470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67488 */     // MIs[0] VA
     /*  67488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67491 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10265:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFSX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX),
     /*  67494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67496 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67498 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67500 */     GIR_RootConstrainSelectedInstOperands,
     /*  67501 */     // GIR_Coverage, 313,
     /*  67501 */     GIR_EraseRootFromParent_Done,
     /*  67502 */   // Label 1036: @67502
     /*  67502 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(67539), // Rule ID 314 //
     /*  67507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67525 */     // MIs[0] VA
     /*  67525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67528 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10267:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFUX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX),
     /*  67531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67533 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67535 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67537 */     GIR_RootConstrainSelectedInstOperands,
     /*  67538 */     // GIR_Coverage, 314,
     /*  67538 */     GIR_EraseRootFromParent_Done,
     /*  67539 */   // Label 1037: @67539
     /*  67539 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(67576), // Rule ID 315 //
     /*  67544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67562 */     // MIs[0] VA
     /*  67562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67565 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10326:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTSXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS),
     /*  67568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67570 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67572 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67574 */     GIR_RootConstrainSelectedInstOperands,
     /*  67575 */     // GIR_Coverage, 315,
     /*  67575 */     GIR_EraseRootFromParent_Done,
     /*  67576 */   // Label 1038: @67576
     /*  67576 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(67613), // Rule ID 316 //
     /*  67581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67599 */     // MIs[0] VA
     /*  67599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67602 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10327:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTUXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS),
     /*  67605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67607 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67609 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67611 */     GIR_RootConstrainSelectedInstOperands,
     /*  67612 */     // GIR_Coverage, 316,
     /*  67612 */     GIR_EraseRootFromParent_Done,
     /*  67613 */   // Label 1039: @67613
     /*  67613 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(67650), // Rule ID 1094 //
     /*  67618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbb),
     /*  67626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67636 */     // MIs[0] MP
     /*  67636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67639 */     // (intrinsic_wo_chain:{ *:[i64] } 10322:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBB:{ *:[i64] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBB),
     /*  67642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67644 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67646 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67648 */     GIR_RootConstrainSelectedInstOperands,
     /*  67649 */     // GIR_Coverage, 1094,
     /*  67649 */     GIR_EraseRootFromParent_Done,
     /*  67650 */   // Label 1040: @67650
     /*  67650 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(67687), // Rule ID 1095 //
     /*  67655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbh),
     /*  67663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67673 */     // MIs[0] MP
     /*  67673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67676 */     // (intrinsic_wo_chain:{ *:[i64] } 10324:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBH:{ *:[i64] } v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBH),
     /*  67679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67681 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67683 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67685 */     GIR_RootConstrainSelectedInstOperands,
     /*  67686 */     // GIR_Coverage, 1095,
     /*  67686 */     GIR_EraseRootFromParent_Done,
     /*  67687 */   // Label 1041: @67687
     /*  67687 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(67724), // Rule ID 1096 //
     /*  67692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbw),
     /*  67700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67710 */     // MIs[0] MP
     /*  67710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67713 */     // (intrinsic_wo_chain:{ *:[i64] } 10325:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBW:{ *:[i64] } v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBW),
     /*  67716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67718 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67720 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67722 */     GIR_RootConstrainSelectedInstOperands,
     /*  67723 */     // GIR_Coverage, 1096,
     /*  67723 */     GIR_EraseRootFromParent_Done,
     /*  67724 */   // Label 1042: @67724
     /*  67724 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(67761), // Rule ID 1097 //
     /*  67729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbd),
     /*  67737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67747 */     // MIs[0] MP
     /*  67747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67750 */     // (intrinsic_wo_chain:{ *:[i64] } 10323:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBD:{ *:[i64] } v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBD),
     /*  67753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67755 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67757 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67759 */     GIR_RootConstrainSelectedInstOperands,
     /*  67760 */     // GIR_Coverage, 1097,
     /*  67760 */     GIR_EraseRootFromParent_Done,
     /*  67761 */   // Label 1043: @67761
     /*  67761 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(67798), // Rule ID 1111 //
     /*  67766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgnb),
     /*  67774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  67780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67784 */     // MIs[0] N
     /*  67784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67787 */     // (intrinsic_wo_chain:{ *:[i64] } 10362:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)  =>  (VGNB:{ *:[i64] } v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)
     /*  67787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGNB),
     /*  67790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67792 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67794 */     GIR_RootToRootCopy, /*OpIdx*/3, // N
     /*  67796 */     GIR_RootConstrainSelectedInstOperands,
     /*  67797 */     // GIR_Coverage, 1111,
     /*  67797 */     GIR_EraseRootFromParent_Done,
     /*  67798 */   // Label 1044: @67798
     /*  67798 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(67843), // Rule ID 204 //
     /*  67803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divwe),
     /*  67811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  67814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  67817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67832 */     // (intrinsic_wo_chain:{ *:[i32] } 10566:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWE:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  67832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWE),
     /*  67835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  67837 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  67839 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67841 */     GIR_RootConstrainSelectedInstOperands,
     /*  67842 */     // GIR_Coverage, 204,
     /*  67842 */     GIR_EraseRootFromParent_Done,
     /*  67843 */   // Label 1045: @67843
     /*  67843 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(67888), // Rule ID 205 //
     /*  67848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divweu),
     /*  67856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  67859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  67862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67877 */     // (intrinsic_wo_chain:{ *:[i32] } 10567:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWEU:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  67877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWEU),
     /*  67880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  67882 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  67884 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67886 */     GIR_RootConstrainSelectedInstOperands,
     /*  67887 */     // GIR_Coverage, 205,
     /*  67887 */     GIR_EraseRootFromParent_Done,
     /*  67888 */   // Label 1046: @67888
     /*  67888 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(67933), // Rule ID 686 //
     /*  67893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBPERMD),
     /*  67896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bpermd),
     /*  67901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  67907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  67910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67922 */     // (intrinsic_wo_chain:{ *:[i64] } 10525:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)  =>  (BPERMD:{ *:[i64] } g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)
     /*  67922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BPERMD),
     /*  67925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  67927 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  67929 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67931 */     GIR_RootConstrainSelectedInstOperands,
     /*  67932 */     // GIR_Coverage, 686,
     /*  67932 */     GIR_EraseRootFromParent_Done,
     /*  67933 */   // Label 1047: @67933
     /*  67933 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(67978), // Rule ID 695 //
     /*  67938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divde),
     /*  67946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  67952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  67955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67967 */     // (intrinsic_wo_chain:{ *:[i64] } 10563:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDE:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  67967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDE),
     /*  67970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  67972 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  67974 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67976 */     GIR_RootConstrainSelectedInstOperands,
     /*  67977 */     // GIR_Coverage, 695,
     /*  67977 */     GIR_EraseRootFromParent_Done,
     /*  67978 */   // Label 1048: @67978
     /*  67978 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(68023), // Rule ID 700 //
     /*  67983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divdeu),
     /*  67991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  67997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68012 */     // (intrinsic_wo_chain:{ *:[i64] } 10564:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDEU:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  68012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDEU),
     /*  68015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68017 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68019 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68021 */     GIR_RootConstrainSelectedInstOperands,
     /*  68022 */     // GIR_Coverage, 700,
     /*  68022 */     GIR_EraseRootFromParent_Done,
     /*  68023 */   // Label 1049: @68023
     /*  68023 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(68089), // Rule ID 1558 //
     /*  68028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpeqb),
     /*  68036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68057 */     // (intrinsic_wo_chain:{ *:[i64] } 10533:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPEQB:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPEQB),
     /*  68064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68087 */     GIR_RootConstrainSelectedInstOperands,
     /*  68088 */     // GIR_Coverage, 1558,
     /*  68088 */     GIR_EraseRootFromParent_Done,
     /*  68089 */   // Label 1050: @68089
     /*  68089 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(68155), // Rule ID 1559 //
     /*  68094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setb),
     /*  68102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68123 */     // (intrinsic_wo_chain:{ *:[i64] } 10743:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  68130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68139 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68153 */     GIR_RootConstrainSelectedInstOperands,
     /*  68154 */     // GIR_Coverage, 1559,
     /*  68154 */     GIR_EraseRootFromParent_Done,
     /*  68155 */   // Label 1051: @68155
     /*  68155 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(68200), // Rule ID 1563 //
     /*  68160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhd),
     /*  68168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68189 */     // (intrinsic_wo_chain:{ *:[i64] } 10725:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /*  68192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68194 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68196 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68198 */     GIR_RootConstrainSelectedInstOperands,
     /*  68199 */     // GIR_Coverage, 1563,
     /*  68199 */     GIR_EraseRootFromParent_Done,
     /*  68200 */   // Label 1052: @68200
     /*  68200 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(68245), // Rule ID 1564 //
     /*  68205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhdu),
     /*  68213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68234 */     // (intrinsic_wo_chain:{ *:[i64] } 10726:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /*  68237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68239 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68241 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68243 */     GIR_RootConstrainSelectedInstOperands,
     /*  68244 */     // GIR_Coverage, 1564,
     /*  68244 */     GIR_EraseRootFromParent_Done,
     /*  68245 */   // Label 1053: @68245
     /*  68245 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(68287), // Rule ID 1567 //
     /*  68250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68276 */     // (intrinsic_wo_chain:{ *:[i64] } 10532:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (CMPB8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB8),
     /*  68279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68281 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68283 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68285 */     GIR_RootConstrainSelectedInstOperands,
     /*  68286 */     // GIR_Coverage, 1567,
     /*  68286 */     GIR_EraseRootFromParent_Done,
     /*  68287 */   // Label 1054: @68287
     /*  68287 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(68329), // Rule ID 4874 //
     /*  68292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhw),
     /*  68297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68318 */     // (intrinsic_wo_chain:{ *:[i32] } 10727:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHW:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /*  68321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68323 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68325 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68327 */     GIR_RootConstrainSelectedInstOperands,
     /*  68328 */     // GIR_Coverage, 4874,
     /*  68328 */     GIR_EraseRootFromParent_Done,
     /*  68329 */   // Label 1055: @68329
     /*  68329 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(68371), // Rule ID 4875 //
     /*  68334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhwu),
     /*  68339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68360 */     // (intrinsic_wo_chain:{ *:[i32] } 10728:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHWU:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /*  68363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68365 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68367 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68369 */     GIR_RootConstrainSelectedInstOperands,
     /*  68370 */     // GIR_Coverage, 4875,
     /*  68370 */     GIR_EraseRootFromParent_Done,
     /*  68371 */   // Label 1056: @68371
     /*  68371 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(68413), // Rule ID 4876 //
     /*  68376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68402 */     // (intrinsic_wo_chain:{ *:[i32] } 10532:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (CMPB:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB),
     /*  68405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68407 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68409 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68411 */     GIR_RootConstrainSelectedInstOperands,
     /*  68412 */     // GIR_Coverage, 4876,
     /*  68412 */     GIR_EraseRootFromParent_Done,
     /*  68413 */   // Label 1057: @68413
     /*  68413 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(68447), // Rule ID 76 //
     /*  68418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6s),
     /*  68423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68436 */     // (intrinsic_wo_chain:{ *:[i32] } 10204:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADDG6S:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  68436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S),
     /*  68439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68441 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68443 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68445 */     GIR_RootConstrainSelectedInstOperands,
     /*  68446 */     // GIR_Coverage, 76,
     /*  68446 */     GIR_EraseRootFromParent_Done,
     /*  68447 */   // Label 1058: @68447
     /*  68447 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(68484), // Rule ID 304 //
     /*  68452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuw),
     /*  68460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68473 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10248:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUW),
     /*  68476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68478 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68480 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68482 */     GIR_RootConstrainSelectedInstOperands,
     /*  68483 */     // GIR_Coverage, 304,
     /*  68483 */     GIR_EraseRootFromParent_Done,
     /*  68484 */   // Label 1059: @68484
     /*  68484 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(68521), // Rule ID 305 //
     /*  68489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsbs),
     /*  68497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68510 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10251:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /*  68513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68515 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68517 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68519 */     GIR_RootConstrainSelectedInstOperands,
     /*  68520 */     // GIR_Coverage, 305,
     /*  68520 */     GIR_EraseRootFromParent_Done,
     /*  68521 */   // Label 1060: @68521
     /*  68521 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(68558), // Rule ID 306 //
     /*  68526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddshs),
     /*  68534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68547 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10252:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /*  68550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68552 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68554 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68556 */     GIR_RootConstrainSelectedInstOperands,
     /*  68557 */     // GIR_Coverage, 306,
     /*  68557 */     GIR_EraseRootFromParent_Done,
     /*  68558 */   // Label 1061: @68558
     /*  68558 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(68595), // Rule ID 307 //
     /*  68563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsws),
     /*  68571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10253:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /*  68587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68589 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68591 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68593 */     GIR_RootConstrainSelectedInstOperands,
     /*  68594 */     // GIR_Coverage, 307,
     /*  68594 */     GIR_EraseRootFromParent_Done,
     /*  68595 */   // Label 1062: @68595
     /*  68595 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(68632), // Rule ID 308 //
     /*  68600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddubs),
     /*  68608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68621 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10254:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /*  68624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68626 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68628 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68630 */     GIR_RootConstrainSelectedInstOperands,
     /*  68631 */     // GIR_Coverage, 308,
     /*  68631 */     GIR_EraseRootFromParent_Done,
     /*  68632 */   // Label 1063: @68632
     /*  68632 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(68669), // Rule ID 309 //
     /*  68637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduhs),
     /*  68645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68658 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10255:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /*  68661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68663 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68665 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68667 */     GIR_RootConstrainSelectedInstOperands,
     /*  68668 */     // GIR_Coverage, 309,
     /*  68668 */     GIR_EraseRootFromParent_Done,
     /*  68669 */   // Label 1064: @68669
     /*  68669 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(68706), // Rule ID 310 //
     /*  68674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduws),
     /*  68682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68695 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10256:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /*  68698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68700 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68702 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68704 */     GIR_RootConstrainSelectedInstOperands,
     /*  68705 */     // GIR_Coverage, 310,
     /*  68705 */     GIR_EraseRootFromParent_Done,
     /*  68706 */   // Label 1065: @68706
     /*  68706 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(68743), // Rule ID 323 //
     /*  68711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsb),
     /*  68719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68732 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10257:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSB),
     /*  68735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68737 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68739 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68741 */     GIR_RootConstrainSelectedInstOperands,
     /*  68742 */     // GIR_Coverage, 323,
     /*  68742 */     GIR_EraseRootFromParent_Done,
     /*  68743 */   // Label 1066: @68743
     /*  68743 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(68780), // Rule ID 324 //
     /*  68748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsh),
     /*  68756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68769 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10258:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSH),
     /*  68772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68774 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68776 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68778 */     GIR_RootConstrainSelectedInstOperands,
     /*  68779 */     // GIR_Coverage, 324,
     /*  68779 */     GIR_EraseRootFromParent_Done,
     /*  68780 */   // Label 1067: @68780
     /*  68780 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(68817), // Rule ID 325 //
     /*  68785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsw),
     /*  68793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68806 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10259:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSW),
     /*  68809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68811 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68813 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68815 */     GIR_RootConstrainSelectedInstOperands,
     /*  68816 */     // GIR_Coverage, 325,
     /*  68816 */     GIR_EraseRootFromParent_Done,
     /*  68817 */   // Label 1068: @68817
     /*  68817 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(68854), // Rule ID 326 //
     /*  68822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgub),
     /*  68830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68843 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10260:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUB),
     /*  68846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68848 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68850 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68852 */     GIR_RootConstrainSelectedInstOperands,
     /*  68853 */     // GIR_Coverage, 326,
     /*  68853 */     GIR_EraseRootFromParent_Done,
     /*  68854 */   // Label 1069: @68854
     /*  68854 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(68891), // Rule ID 327 //
     /*  68859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguh),
     /*  68867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68880 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10261:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUH),
     /*  68883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68885 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68887 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68889 */     GIR_RootConstrainSelectedInstOperands,
     /*  68890 */     // GIR_Coverage, 327,
     /*  68890 */     GIR_EraseRootFromParent_Done,
     /*  68891 */   // Label 1070: @68891
     /*  68891 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(68928), // Rule ID 328 //
     /*  68896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguw),
     /*  68904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68917 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10262:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUW),
     /*  68920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68922 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68924 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68926 */     GIR_RootConstrainSelectedInstOperands,
     /*  68927 */     // GIR_Coverage, 328,
     /*  68927 */     GIR_EraseRootFromParent_Done,
     /*  68928 */   // Label 1071: @68928
     /*  68928 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(68965), // Rule ID 329 //
     /*  68933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxfp),
     /*  68941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68954 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10381:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMAXFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  68954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXFP),
     /*  68957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68959 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68961 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68963 */     GIR_RootConstrainSelectedInstOperands,
     /*  68964 */     // GIR_Coverage, 329,
     /*  68964 */     GIR_EraseRootFromParent_Done,
     /*  68965 */   // Label 1072: @68965
     /*  68965 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(69002), // Rule ID 330 //
     /*  68970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsb),
     /*  68978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68991 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10382:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /*  68994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68996 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68998 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69000 */     GIR_RootConstrainSelectedInstOperands,
     /*  69001 */     // GIR_Coverage, 330,
     /*  69001 */     GIR_EraseRootFromParent_Done,
     /*  69002 */   // Label 1073: @69002
     /*  69002 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(69039), // Rule ID 331 //
     /*  69007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsh),
     /*  69015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69028 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10384:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /*  69031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69033 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69035 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69037 */     GIR_RootConstrainSelectedInstOperands,
     /*  69038 */     // GIR_Coverage, 331,
     /*  69038 */     GIR_EraseRootFromParent_Done,
     /*  69039 */   // Label 1074: @69039
     /*  69039 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(69076), // Rule ID 332 //
     /*  69044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsw),
     /*  69052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69065 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10385:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /*  69068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69070 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69072 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69074 */     GIR_RootConstrainSelectedInstOperands,
     /*  69075 */     // GIR_Coverage, 332,
     /*  69075 */     GIR_EraseRootFromParent_Done,
     /*  69076 */   // Label 1075: @69076
     /*  69076 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(69113), // Rule ID 333 //
     /*  69081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxub),
     /*  69089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69102 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10386:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /*  69105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69107 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69109 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69111 */     GIR_RootConstrainSelectedInstOperands,
     /*  69112 */     // GIR_Coverage, 333,
     /*  69112 */     GIR_EraseRootFromParent_Done,
     /*  69113 */   // Label 1076: @69113
     /*  69113 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(69150), // Rule ID 334 //
     /*  69118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuh),
     /*  69126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69139 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10388:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /*  69142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69144 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69146 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69148 */     GIR_RootConstrainSelectedInstOperands,
     /*  69149 */     // GIR_Coverage, 334,
     /*  69149 */     GIR_EraseRootFromParent_Done,
     /*  69150 */   // Label 1077: @69150
     /*  69150 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(69187), // Rule ID 335 //
     /*  69155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuw),
     /*  69163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69176 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10389:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /*  69179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69181 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69183 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69185 */     GIR_RootConstrainSelectedInstOperands,
     /*  69186 */     // GIR_Coverage, 335,
     /*  69186 */     GIR_EraseRootFromParent_Done,
     /*  69187 */   // Label 1078: @69187
     /*  69187 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(69224), // Rule ID 336 //
     /*  69192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminfp),
     /*  69200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69213 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10392:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMINFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  69213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINFP),
     /*  69216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69218 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69220 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69222 */     GIR_RootConstrainSelectedInstOperands,
     /*  69223 */     // GIR_Coverage, 336,
     /*  69223 */     GIR_EraseRootFromParent_Done,
     /*  69224 */   // Label 1079: @69224
     /*  69224 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(69261), // Rule ID 337 //
     /*  69229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsb),
     /*  69237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69250 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10393:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /*  69253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69255 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69257 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69259 */     GIR_RootConstrainSelectedInstOperands,
     /*  69260 */     // GIR_Coverage, 337,
     /*  69260 */     GIR_EraseRootFromParent_Done,
     /*  69261 */   // Label 1080: @69261
     /*  69261 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(69298), // Rule ID 338 //
     /*  69266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsh),
     /*  69274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69287 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10395:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /*  69290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69292 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69294 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69296 */     GIR_RootConstrainSelectedInstOperands,
     /*  69297 */     // GIR_Coverage, 338,
     /*  69297 */     GIR_EraseRootFromParent_Done,
     /*  69298 */   // Label 1081: @69298
     /*  69298 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(69335), // Rule ID 339 //
     /*  69303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsw),
     /*  69311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69324 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10396:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /*  69327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69329 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69331 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69333 */     GIR_RootConstrainSelectedInstOperands,
     /*  69334 */     // GIR_Coverage, 339,
     /*  69334 */     GIR_EraseRootFromParent_Done,
     /*  69335 */   // Label 1082: @69335
     /*  69335 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(69372), // Rule ID 340 //
     /*  69340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminub),
     /*  69348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69361 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10397:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /*  69364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69366 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69368 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69370 */     GIR_RootConstrainSelectedInstOperands,
     /*  69371 */     // GIR_Coverage, 340,
     /*  69371 */     GIR_EraseRootFromParent_Done,
     /*  69372 */   // Label 1083: @69372
     /*  69372 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(69409), // Rule ID 341 //
     /*  69377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuh),
     /*  69385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69398 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10399:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /*  69401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69403 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69405 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69407 */     GIR_RootConstrainSelectedInstOperands,
     /*  69408 */     // GIR_Coverage, 341,
     /*  69408 */     GIR_EraseRootFromParent_Done,
     /*  69409 */   // Label 1084: @69409
     /*  69409 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(69446), // Rule ID 342 //
     /*  69414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuw),
     /*  69422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69435 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10400:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /*  69438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69440 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69442 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69444 */     GIR_RootConstrainSelectedInstOperands,
     /*  69445 */     // GIR_Coverage, 342,
     /*  69445 */     GIR_EraseRootFromParent_Done,
     /*  69446 */   // Label 1085: @69446
     /*  69446 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(69483), // Rule ID 355 //
     /*  69451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesb),
     /*  69459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69472 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10410:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULESB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESB),
     /*  69475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69477 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69479 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69481 */     GIR_RootConstrainSelectedInstOperands,
     /*  69482 */     // GIR_Coverage, 355,
     /*  69482 */     GIR_EraseRootFromParent_Done,
     /*  69483 */   // Label 1086: @69483
     /*  69483 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(69520), // Rule ID 356 //
     /*  69488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesh),
     /*  69496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69509 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10412:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULESH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESH),
     /*  69512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69514 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69516 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69518 */     GIR_RootConstrainSelectedInstOperands,
     /*  69519 */     // GIR_Coverage, 356,
     /*  69519 */     GIR_EraseRootFromParent_Done,
     /*  69520 */   // Label 1087: @69520
     /*  69520 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(69557), // Rule ID 357 //
     /*  69525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleub),
     /*  69533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69546 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10414:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULEUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUB),
     /*  69549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69551 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69553 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69555 */     GIR_RootConstrainSelectedInstOperands,
     /*  69556 */     // GIR_Coverage, 357,
     /*  69556 */     GIR_EraseRootFromParent_Done,
     /*  69557 */   // Label 1088: @69557
     /*  69557 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(69594), // Rule ID 358 //
     /*  69562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuh),
     /*  69570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69583 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10416:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULEUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUH),
     /*  69586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69588 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69590 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69592 */     GIR_RootConstrainSelectedInstOperands,
     /*  69593 */     // GIR_Coverage, 358,
     /*  69593 */     GIR_EraseRootFromParent_Done,
     /*  69594 */   // Label 1089: @69594
     /*  69594 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(69631), // Rule ID 359 //
     /*  69599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosb),
     /*  69607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69620 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10422:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSB),
     /*  69623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69625 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69627 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69629 */     GIR_RootConstrainSelectedInstOperands,
     /*  69630 */     // GIR_Coverage, 359,
     /*  69630 */     GIR_EraseRootFromParent_Done,
     /*  69631 */   // Label 1090: @69631
     /*  69631 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(69668), // Rule ID 360 //
     /*  69636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosh),
     /*  69644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69657 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10424:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSH),
     /*  69660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69662 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69664 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69666 */     GIR_RootConstrainSelectedInstOperands,
     /*  69667 */     // GIR_Coverage, 360,
     /*  69667 */     GIR_EraseRootFromParent_Done,
     /*  69668 */   // Label 1091: @69668
     /*  69668 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(69705), // Rule ID 361 //
     /*  69673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloub),
     /*  69681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69694 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10426:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUB),
     /*  69697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69699 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69701 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69703 */     GIR_RootConstrainSelectedInstOperands,
     /*  69704 */     // GIR_Coverage, 361,
     /*  69704 */     GIR_EraseRootFromParent_Done,
     /*  69705 */   // Label 1092: @69705
     /*  69705 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(69742), // Rule ID 362 //
     /*  69710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouh),
     /*  69718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69731 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10428:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUH),
     /*  69734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69736 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69738 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69740 */     GIR_RootConstrainSelectedInstOperands,
     /*  69741 */     // GIR_Coverage, 362,
     /*  69741 */     GIR_EraseRootFromParent_Done,
     /*  69742 */   // Label 1093: @69742
     /*  69742 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(69779), // Rule ID 369 //
     /*  69747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuw),
     /*  69755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69768 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10490:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUW),
     /*  69771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69773 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69775 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69777 */     GIR_RootConstrainSelectedInstOperands,
     /*  69778 */     // GIR_Coverage, 369,
     /*  69778 */     GIR_EraseRootFromParent_Done,
     /*  69779 */   // Label 1094: @69779
     /*  69779 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(69816), // Rule ID 374 //
     /*  69784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsbs),
     /*  69792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69805 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10493:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /*  69808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69810 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69812 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69814 */     GIR_RootConstrainSelectedInstOperands,
     /*  69815 */     // GIR_Coverage, 374,
     /*  69815 */     GIR_EraseRootFromParent_Done,
     /*  69816 */   // Label 1095: @69816
     /*  69816 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(69853), // Rule ID 375 //
     /*  69821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubshs),
     /*  69829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69842 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10494:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /*  69845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69847 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69849 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69851 */     GIR_RootConstrainSelectedInstOperands,
     /*  69852 */     // GIR_Coverage, 375,
     /*  69852 */     GIR_EraseRootFromParent_Done,
     /*  69853 */   // Label 1096: @69853
     /*  69853 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(69890), // Rule ID 376 //
     /*  69858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsws),
     /*  69866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69879 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10495:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /*  69882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69884 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69886 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69888 */     GIR_RootConstrainSelectedInstOperands,
     /*  69889 */     // GIR_Coverage, 376,
     /*  69889 */     GIR_EraseRootFromParent_Done,
     /*  69890 */   // Label 1097: @69890
     /*  69890 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(69927), // Rule ID 377 //
     /*  69895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsububs),
     /*  69903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69916 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10496:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /*  69919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69921 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69923 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69925 */     GIR_RootConstrainSelectedInstOperands,
     /*  69926 */     // GIR_Coverage, 377,
     /*  69926 */     GIR_EraseRootFromParent_Done,
     /*  69927 */   // Label 1098: @69927
     /*  69927 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(69964), // Rule ID 378 //
     /*  69932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuhs),
     /*  69940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69953 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10497:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /*  69956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69958 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69960 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69962 */     GIR_RootConstrainSelectedInstOperands,
     /*  69963 */     // GIR_Coverage, 378,
     /*  69963 */     GIR_EraseRootFromParent_Done,
     /*  69964 */   // Label 1099: @69964
     /*  69964 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(70001), // Rule ID 379 //
     /*  69969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuws),
     /*  69977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69990 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10498:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /*  69993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69995 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69997 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69999 */     GIR_RootConstrainSelectedInstOperands,
     /*  70000 */     // GIR_Coverage, 379,
     /*  70000 */     GIR_EraseRootFromParent_Done,
     /*  70001 */   // Label 1100: @70001
     /*  70001 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(70038), // Rule ID 388 //
     /*  70006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlb),
     /*  70014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70027 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10452:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /*  70030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70032 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70034 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70036 */     GIR_RootConstrainSelectedInstOperands,
     /*  70037 */     // GIR_Coverage, 388,
     /*  70037 */     GIR_EraseRootFromParent_Done,
     /*  70038 */   // Label 1101: @70038
     /*  70038 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(70075), // Rule ID 389 //
     /*  70043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlh),
     /*  70051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70064 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10456:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /*  70067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70069 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70071 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70073 */     GIR_RootConstrainSelectedInstOperands,
     /*  70074 */     // GIR_Coverage, 389,
     /*  70074 */     GIR_EraseRootFromParent_Done,
     /*  70075 */   // Label 1102: @70075
     /*  70075 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(70112), // Rule ID 390 //
     /*  70080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlw),
     /*  70088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70101 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10459:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /*  70104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70106 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70108 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70110 */     GIR_RootConstrainSelectedInstOperands,
     /*  70111 */     // GIR_Coverage, 390,
     /*  70111 */     GIR_EraseRootFromParent_Done,
     /*  70112 */   // Label 1103: @70112
     /*  70112 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(70149), // Rule ID 391 //
     /*  70117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsl),
     /*  70125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70138 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10464:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /*  70141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70143 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70145 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70147 */     GIR_RootConstrainSelectedInstOperands,
     /*  70148 */     // GIR_Coverage, 391,
     /*  70148 */     GIR_EraseRootFromParent_Done,
     /*  70149 */   // Label 1104: @70149
     /*  70149 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(70186), // Rule ID 392 //
     /*  70154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslo),
     /*  70162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70175 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10468:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /*  70178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70180 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70182 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70184 */     GIR_RootConstrainSelectedInstOperands,
     /*  70185 */     // GIR_Coverage, 392,
     /*  70185 */     GIR_EraseRootFromParent_Done,
     /*  70186 */   // Label 1105: @70186
     /*  70186 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(70223), // Rule ID 393 //
     /*  70191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslb),
     /*  70199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70212 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10465:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /*  70215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70217 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70219 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70221 */     GIR_RootConstrainSelectedInstOperands,
     /*  70222 */     // GIR_Coverage, 393,
     /*  70222 */     GIR_EraseRootFromParent_Done,
     /*  70223 */   // Label 1106: @70223
     /*  70223 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(70260), // Rule ID 394 //
     /*  70228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslh),
     /*  70236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70249 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10467:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /*  70252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70254 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70256 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70258 */     GIR_RootConstrainSelectedInstOperands,
     /*  70259 */     // GIR_Coverage, 394,
     /*  70259 */     GIR_EraseRootFromParent_Done,
     /*  70260 */   // Label 1107: @70260
     /*  70260 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(70297), // Rule ID 395 //
     /*  70265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslw),
     /*  70273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70286 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10470:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /*  70289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70291 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70293 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70295 */     GIR_RootConstrainSelectedInstOperands,
     /*  70296 */     // GIR_Coverage, 395,
     /*  70296 */     GIR_EraseRootFromParent_Done,
     /*  70297 */   // Label 1108: @70297
     /*  70297 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(70334), // Rule ID 399 //
     /*  70302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsr),
     /*  70310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70323 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10471:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /*  70326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70328 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70330 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70332 */     GIR_RootConstrainSelectedInstOperands,
     /*  70333 */     // GIR_Coverage, 399,
     /*  70333 */     GIR_EraseRootFromParent_Done,
     /*  70334 */   // Label 1109: @70334
     /*  70334 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(70371), // Rule ID 400 //
     /*  70339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsro),
     /*  70347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70360 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10478:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /*  70363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70365 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70367 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70369 */     GIR_RootConstrainSelectedInstOperands,
     /*  70370 */     // GIR_Coverage, 400,
     /*  70370 */     GIR_EraseRootFromParent_Done,
     /*  70371 */   // Label 1110: @70371
     /*  70371 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(70408), // Rule ID 401 //
     /*  70376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrab),
     /*  70384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70397 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10472:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRAB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /*  70400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70402 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70404 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70406 */     GIR_RootConstrainSelectedInstOperands,
     /*  70407 */     // GIR_Coverage, 401,
     /*  70407 */     GIR_EraseRootFromParent_Done,
     /*  70408 */   // Label 1111: @70408
     /*  70408 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(70445), // Rule ID 402 //
     /*  70413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrah),
     /*  70421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70434 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10473:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRAH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /*  70437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70439 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70441 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70443 */     GIR_RootConstrainSelectedInstOperands,
     /*  70444 */     // GIR_Coverage, 402,
     /*  70444 */     GIR_EraseRootFromParent_Done,
     /*  70445 */   // Label 1112: @70445
     /*  70445 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(70482), // Rule ID 403 //
     /*  70450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsraw),
     /*  70458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10474:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /*  70474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70476 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70478 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70480 */     GIR_RootConstrainSelectedInstOperands,
     /*  70481 */     // GIR_Coverage, 403,
     /*  70481 */     GIR_EraseRootFromParent_Done,
     /*  70482 */   // Label 1113: @70482
     /*  70482 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(70519), // Rule ID 404 //
     /*  70487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrb),
     /*  70495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70508 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10475:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /*  70511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70513 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70515 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70517 */     GIR_RootConstrainSelectedInstOperands,
     /*  70518 */     // GIR_Coverage, 404,
     /*  70518 */     GIR_EraseRootFromParent_Done,
     /*  70519 */   // Label 1114: @70519
     /*  70519 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(70556), // Rule ID 405 //
     /*  70524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrh),
     /*  70532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70545 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10477:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /*  70548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70550 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70552 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70554 */     GIR_RootConstrainSelectedInstOperands,
     /*  70555 */     // GIR_Coverage, 405,
     /*  70555 */     GIR_EraseRootFromParent_Done,
     /*  70556 */   // Label 1115: @70556
     /*  70556 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(70593), // Rule ID 406 //
     /*  70561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrw),
     /*  70569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70582 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10480:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /*  70585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70587 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70589 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70591 */     GIR_RootConstrainSelectedInstOperands,
     /*  70592 */     // GIR_Coverage, 406,
     /*  70592 */     GIR_EraseRootFromParent_Done,
     /*  70593 */   // Label 1116: @70593
     /*  70593 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(70630), // Rule ID 410 //
     /*  70598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkpx),
     /*  70606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70619 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10434:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKPX:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKPX),
     /*  70622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70624 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70626 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70628 */     GIR_RootConstrainSelectedInstOperands,
     /*  70629 */     // GIR_Coverage, 410,
     /*  70629 */     GIR_EraseRootFromParent_Done,
     /*  70630 */   // Label 1117: @70630
     /*  70630 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(70667), // Rule ID 457 //
     /*  70635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesw),
     /*  70643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70656 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10413:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULESW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESW),
     /*  70659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70661 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70663 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70665 */     GIR_RootConstrainSelectedInstOperands,
     /*  70666 */     // GIR_Coverage, 457,
     /*  70666 */     GIR_EraseRootFromParent_Done,
     /*  70667 */   // Label 1118: @70667
     /*  70667 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(70704), // Rule ID 458 //
     /*  70672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuw),
     /*  70680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70693 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10417:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULEUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUW),
     /*  70696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70698 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70700 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70702 */     GIR_RootConstrainSelectedInstOperands,
     /*  70703 */     // GIR_Coverage, 458,
     /*  70703 */     GIR_EraseRootFromParent_Done,
     /*  70704 */   // Label 1119: @70704
     /*  70704 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(70741), // Rule ID 459 //
     /*  70709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosw),
     /*  70717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70730 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10425:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSW),
     /*  70733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70735 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70737 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70739 */     GIR_RootConstrainSelectedInstOperands,
     /*  70740 */     // GIR_Coverage, 459,
     /*  70740 */     GIR_EraseRootFromParent_Done,
     /*  70741 */   // Label 1120: @70741
     /*  70741 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(70778), // Rule ID 460 //
     /*  70746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouw),
     /*  70754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70767 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10429:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUW),
     /*  70770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70772 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70774 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70776 */     GIR_RootConstrainSelectedInstOperands,
     /*  70777 */     // GIR_Coverage, 460,
     /*  70777 */     GIR_EraseRootFromParent_Done,
     /*  70778 */   // Label 1121: @70778
     /*  70778 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(70815), // Rule ID 462 //
     /*  70783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsd),
     /*  70791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70804 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10383:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /*  70807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70809 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70811 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70813 */     GIR_RootConstrainSelectedInstOperands,
     /*  70814 */     // GIR_Coverage, 462,
     /*  70814 */     GIR_EraseRootFromParent_Done,
     /*  70815 */   // Label 1122: @70815
     /*  70815 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(70852), // Rule ID 463 //
     /*  70820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxud),
     /*  70828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70841 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10387:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /*  70844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70846 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70848 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70850 */     GIR_RootConstrainSelectedInstOperands,
     /*  70851 */     // GIR_Coverage, 463,
     /*  70851 */     GIR_EraseRootFromParent_Done,
     /*  70852 */   // Label 1123: @70852
     /*  70852 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(70889), // Rule ID 464 //
     /*  70857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsd),
     /*  70865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70878 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10394:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /*  70881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70883 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70885 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70887 */     GIR_RootConstrainSelectedInstOperands,
     /*  70888 */     // GIR_Coverage, 464,
     /*  70888 */     GIR_EraseRootFromParent_Done,
     /*  70889 */   // Label 1124: @70889
     /*  70889 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(70926), // Rule ID 465 //
     /*  70894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminud),
     /*  70902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70915 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10398:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /*  70918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70920 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70922 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70924 */     GIR_RootConstrainSelectedInstOperands,
     /*  70925 */     // GIR_Coverage, 465,
     /*  70925 */     GIR_EraseRootFromParent_Done,
     /*  70926 */   // Label 1125: @70926
     /*  70926 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(70963), // Rule ID 468 //
     /*  70931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrld),
     /*  70939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70952 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10453:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /*  70955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70957 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70959 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70961 */     GIR_RootConstrainSelectedInstOperands,
     /*  70962 */     // GIR_Coverage, 468,
     /*  70962 */     GIR_EraseRootFromParent_Done,
     /*  70963 */   // Label 1126: @70963
     /*  70963 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(71000), // Rule ID 472 //
     /*  70968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuq),
     /*  70976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  70979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  70982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  70985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70989 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10247:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  70989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUQ),
     /*  70992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70994 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70996 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70998 */     GIR_RootConstrainSelectedInstOperands,
     /*  70999 */     // GIR_Coverage, 472,
     /*  70999 */     GIR_EraseRootFromParent_Done,
     /*  71000 */   // Label 1127: @71000
     /*  71000 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(71037), // Rule ID 477 //
     /*  71005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuq),
     /*  71013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  71016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  71019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  71022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71026 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10489:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  71026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUQ),
     /*  71029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71031 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71033 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71035 */     GIR_RootConstrainSelectedInstOperands,
     /*  71036 */     // GIR_Coverage, 477,
     /*  71036 */     GIR_EraseRootFromParent_Done,
     /*  71037 */   // Label 1128: @71037
     /*  71037 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(71074), // Rule ID 496 //
     /*  71042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumb),
     /*  71050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71063 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10212:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VPMSUMB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMB),
     /*  71066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71068 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71070 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71072 */     GIR_RootConstrainSelectedInstOperands,
     /*  71073 */     // GIR_Coverage, 496,
     /*  71073 */     GIR_EraseRootFromParent_Done,
     /*  71074 */   // Label 1129: @71074
     /*  71074 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(71111), // Rule ID 497 //
     /*  71079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumh),
     /*  71087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71100 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10214:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPMSUMH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMH),
     /*  71103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71105 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71107 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71109 */     GIR_RootConstrainSelectedInstOperands,
     /*  71110 */     // GIR_Coverage, 497,
     /*  71110 */     GIR_EraseRootFromParent_Done,
     /*  71111 */   // Label 1130: @71111
     /*  71111 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(71148), // Rule ID 498 //
     /*  71116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumw),
     /*  71124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71137 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10215:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPMSUMW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMW),
     /*  71140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71142 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71144 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71146 */     GIR_RootConstrainSelectedInstOperands,
     /*  71147 */     // GIR_Coverage, 498,
     /*  71147 */     GIR_EraseRootFromParent_Done,
     /*  71148 */   // Label 1131: @71148
     /*  71148 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(71185), // Rule ID 499 //
     /*  71153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumd),
     /*  71161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71174 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10213:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPMSUMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMD),
     /*  71177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71179 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71181 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71183 */     GIR_RootConstrainSelectedInstOperands,
     /*  71184 */     // GIR_Coverage, 499,
     /*  71184 */     GIR_EraseRootFromParent_Done,
     /*  71185 */   // Label 1132: @71185
     /*  71185 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(71222), // Rule ID 507 //
     /*  71190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermq),
     /*  71198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71211 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10264:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMQ:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMQ),
     /*  71214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71216 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71218 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71220 */     GIR_RootConstrainSelectedInstOperands,
     /*  71221 */     // GIR_Coverage, 507,
     /*  71221 */     GIR_EraseRootFromParent_Done,
     /*  71222 */   // Label 1133: @71222
     /*  71222 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(71259), // Rule ID 510 //
     /*  71227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipher),
     /*  71235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71248 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10206:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHER),
     /*  71251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71253 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71255 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71257 */     GIR_RootConstrainSelectedInstOperands,
     /*  71258 */     // GIR_Coverage, 510,
     /*  71258 */     GIR_EraseRootFromParent_Done,
     /*  71259 */   // Label 1134: @71259
     /*  71259 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(71296), // Rule ID 511 //
     /*  71264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipherlast),
     /*  71272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71285 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10207:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHERLAST),
     /*  71288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71290 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71292 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71294 */     GIR_RootConstrainSelectedInstOperands,
     /*  71295 */     // GIR_Coverage, 511,
     /*  71295 */     GIR_EraseRootFromParent_Done,
     /*  71296 */   // Label 1135: @71296
     /*  71296 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(71333), // Rule ID 512 //
     /*  71301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipher),
     /*  71309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71322 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10208:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHER),
     /*  71325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71327 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71329 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71331 */     GIR_RootConstrainSelectedInstOperands,
     /*  71332 */     // GIR_Coverage, 512,
     /*  71332 */     GIR_EraseRootFromParent_Done,
     /*  71333 */   // Label 1136: @71333
     /*  71333 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(71370), // Rule ID 513 //
     /*  71338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipherlast),
     /*  71346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71359 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10209:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHERLAST),
     /*  71362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71364 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71366 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71368 */     GIR_RootConstrainSelectedInstOperands,
     /*  71369 */     // GIR_Coverage, 513,
     /*  71369 */     GIR_EraseRootFromParent_Done,
     /*  71370 */   // Label 1137: @71370
     /*  71370 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(71407), // Rule ID 546 //
     /*  71375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermd),
     /*  71383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71396 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10263:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMD),
     /*  71399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71401 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71403 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71405 */     GIR_RootConstrainSelectedInstOperands,
     /*  71406 */     // GIR_Coverage, 546,
     /*  71406 */     GIR_EraseRootFromParent_Done,
     /*  71407 */   // Label 1138: @71407
     /*  71407 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(71444), // Rule ID 547 //
     /*  71412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwnm),
     /*  71420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71433 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10461:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLWNM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWNM),
     /*  71436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71438 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71440 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71442 */     GIR_RootConstrainSelectedInstOperands,
     /*  71443 */     // GIR_Coverage, 547,
     /*  71443 */     GIR_EraseRootFromParent_Done,
     /*  71444 */   // Label 1139: @71444
     /*  71444 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(71481), // Rule ID 549 //
     /*  71449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldnm),
     /*  71457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71470 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10455:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLDNM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDNM),
     /*  71473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71475 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71477 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71479 */     GIR_RootConstrainSelectedInstOperands,
     /*  71480 */     // GIR_Coverage, 549,
     /*  71480 */     GIR_EraseRootFromParent_Done,
     /*  71481 */   // Label 1140: @71481
     /*  71481 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(71518), // Rule ID 551 //
     /*  71486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslv),
     /*  71494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71507 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10469:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLV),
     /*  71510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71512 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71514 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71516 */     GIR_RootConstrainSelectedInstOperands,
     /*  71517 */     // GIR_Coverage, 551,
     /*  71517 */     GIR_EraseRootFromParent_Done,
     /*  71518 */   // Label 1141: @71518
     /*  71518 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(71555), // Rule ID 552 //
     /*  71523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrv),
     /*  71531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71544 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10479:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRV),
     /*  71547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71549 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71551 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71553 */     GIR_RootConstrainSelectedInstOperands,
     /*  71554 */     // GIR_Coverage, 552,
     /*  71554 */     GIR_EraseRootFromParent_Done,
     /*  71555 */   // Label 1142: @71555
     /*  71555 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71592), // Rule ID 553 //
     /*  71560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsdub),
     /*  71568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71581 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10244:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VABSDUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUB),
     /*  71584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71586 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71588 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71590 */     GIR_RootConstrainSelectedInstOperands,
     /*  71591 */     // GIR_Coverage, 553,
     /*  71591 */     GIR_EraseRootFromParent_Done,
     /*  71592 */   // Label 1143: @71592
     /*  71592 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71629), // Rule ID 554 //
     /*  71597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduh),
     /*  71605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71618 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10245:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VABSDUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUH),
     /*  71621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71623 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71625 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71627 */     GIR_RootConstrainSelectedInstOperands,
     /*  71628 */     // GIR_Coverage, 554,
     /*  71628 */     GIR_EraseRootFromParent_Done,
     /*  71629 */   // Label 1144: @71629
     /*  71629 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71666), // Rule ID 555 //
     /*  71634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduw),
     /*  71642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71655 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10246:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VABSDUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUW),
     /*  71658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71660 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71662 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71664 */     GIR_RootConstrainSelectedInstOperands,
     /*  71665 */     // GIR_Coverage, 555,
     /*  71665 */     GIR_EraseRootFromParent_Done,
     /*  71666 */   // Label 1145: @71666
     /*  71666 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71700), // Rule ID 692 //
     /*  71671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6sd),
     /*  71676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71689 */     // (intrinsic_wo_chain:{ *:[i64] } 10205:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADDG6S8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*  71689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S8),
     /*  71692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  71694 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  71696 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71698 */     GIR_RootConstrainSelectedInstOperands,
     /*  71699 */     // GIR_Coverage, 692,
     /*  71699 */     GIR_EraseRootFromParent_Done,
     /*  71700 */   // Label 1146: @71700
     /*  71700 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71737), // Rule ID 1106 //
     /*  71705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpdepd),
     /*  71713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71726 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10431:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPDEPD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPDEPD),
     /*  71729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71731 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71733 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71735 */     GIR_RootConstrainSelectedInstOperands,
     /*  71736 */     // GIR_Coverage, 1106,
     /*  71736 */     GIR_EraseRootFromParent_Done,
     /*  71737 */   // Label 1147: @71737
     /*  71737 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71774), // Rule ID 1107 //
     /*  71742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpextd),
     /*  71750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71763 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10433:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPEXTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPEXTD),
     /*  71766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71768 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71770 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71772 */     GIR_RootConstrainSelectedInstOperands,
     /*  71773 */     // GIR_Coverage, 1107,
     /*  71773 */     GIR_EraseRootFromParent_Done,
     /*  71774 */   // Label 1148: @71774
     /*  71774 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71811), // Rule ID 1108 //
     /*  71779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pdepd),
     /*  71787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71800 */     // (intrinsic_wo_chain:{ *:[i64] } 10730:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PDEPD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  71800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PDEPD),
     /*  71803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  71805 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  71807 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71809 */     GIR_RootConstrainSelectedInstOperands,
     /*  71810 */     // GIR_Coverage, 1108,
     /*  71810 */     GIR_EraseRootFromParent_Done,
     /*  71811 */   // Label 1149: @71811
     /*  71811 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71848), // Rule ID 1109 //
     /*  71816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pextd),
     /*  71824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71837 */     // (intrinsic_wo_chain:{ *:[i64] } 10731:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PEXTD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  71837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PEXTD),
     /*  71840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  71842 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  71844 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71846 */     GIR_RootConstrainSelectedInstOperands,
     /*  71847 */     // GIR_Coverage, 1109,
     /*  71847 */     GIR_EraseRootFromParent_Done,
     /*  71848 */   // Label 1150: @71848
     /*  71848 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(71885), // Rule ID 1110 //
     /*  71853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfuged),
     /*  71861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71874 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10266:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCFUGED:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUGED),
     /*  71877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71879 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71881 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71883 */     GIR_RootConstrainSelectedInstOperands,
     /*  71884 */     // GIR_Coverage, 1110,
     /*  71884 */     GIR_EraseRootFromParent_Done,
     /*  71885 */   // Label 1151: @71885
     /*  71885 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71922), // Rule ID 1112 //
     /*  71890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cfuged),
     /*  71898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71911 */     // (intrinsic_wo_chain:{ *:[i64] } 10531:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CFUGED:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  71911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CFUGED),
     /*  71914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  71916 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  71918 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71920 */     GIR_RootConstrainSelectedInstOperands,
     /*  71921 */     // GIR_Coverage, 1112,
     /*  71921 */     GIR_EraseRootFromParent_Done,
     /*  71922 */   // Label 1152: @71922
     /*  71922 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71959), // Rule ID 1114 //
     /*  71927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzdm),
     /*  71935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71948 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10270:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZDM),
     /*  71951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71953 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71955 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71957 */     GIR_RootConstrainSelectedInstOperands,
     /*  71958 */     // GIR_Coverage, 1114,
     /*  71958 */     GIR_EraseRootFromParent_Done,
     /*  71959 */   // Label 1153: @71959
     /*  71959 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(71996), // Rule ID 1115 //
     /*  71964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzdm),
     /*  71972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71985 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10328:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZDM),
     /*  71988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71990 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71992 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71994 */     GIR_RootConstrainSelectedInstOperands,
     /*  71995 */     // GIR_Coverage, 1115,
     /*  71995 */     GIR_EraseRootFromParent_Done,
     /*  71996 */   // Label 1154: @71996
     /*  71996 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(72033), // Rule ID 1116 //
     /*  72001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cntlzdm),
     /*  72009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72022 */     // (intrinsic_wo_chain:{ *:[i64] } 10536:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTLZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTLZDM),
     /*  72025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72027 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72029 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72031 */     GIR_RootConstrainSelectedInstOperands,
     /*  72032 */     // GIR_Coverage, 1116,
     /*  72032 */     GIR_EraseRootFromParent_Done,
     /*  72033 */   // Label 1155: @72033
     /*  72033 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(72070), // Rule ID 1117 //
     /*  72038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cnttzdm),
     /*  72046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72059 */     // (intrinsic_wo_chain:{ *:[i64] } 10537:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTTZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTTZDM),
     /*  72062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72064 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72066 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72068 */     GIR_RootConstrainSelectedInstOperands,
     /*  72069 */     // GIR_Coverage, 1117,
     /*  72069 */     GIR_EraseRootFromParent_Done,
     /*  72070 */   // Label 1156: @72070
     /*  72070 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(72107), // Rule ID 1118 //
     /*  72075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrlb),
     /*  72083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72096 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10268:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRLB),
     /*  72099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72101 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72103 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72105 */     GIR_RootConstrainSelectedInstOperands,
     /*  72106 */     // GIR_Coverage, 1118,
     /*  72106 */     GIR_EraseRootFromParent_Done,
     /*  72107 */   // Label 1157: @72107
     /*  72107 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72144), // Rule ID 1119 //
     /*  72112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrrb),
     /*  72120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72133 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10269:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRRB),
     /*  72136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72138 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72140 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72142 */     GIR_RootConstrainSelectedInstOperands,
     /*  72143 */     // GIR_Coverage, 1119,
     /*  72143 */     GIR_EraseRootFromParent_Done,
     /*  72144 */   // Label 1158: @72144
     /*  72144 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72181), // Rule ID 1133 //
     /*  72149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesw),
     /*  72157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72170 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10332:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVESW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESW),
     /*  72173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72175 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72177 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72179 */     GIR_RootConstrainSelectedInstOperands,
     /*  72180 */     // GIR_Coverage, 1133,
     /*  72180 */     GIR_EraseRootFromParent_Done,
     /*  72181 */   // Label 1159: @72181
     /*  72181 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72218), // Rule ID 1134 //
     /*  72186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuw),
     /*  72194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72207 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10335:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVEUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUW),
     /*  72210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72212 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72214 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72216 */     GIR_RootConstrainSelectedInstOperands,
     /*  72217 */     // GIR_Coverage, 1134,
     /*  72217 */     GIR_EraseRootFromParent_Done,
     /*  72218 */   // Label 1160: @72218
     /*  72218 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72255), // Rule ID 1135 //
     /*  72223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesd),
     /*  72231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72244 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10330:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVESD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESD),
     /*  72247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72249 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72251 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72253 */     GIR_RootConstrainSelectedInstOperands,
     /*  72254 */     // GIR_Coverage, 1135,
     /*  72254 */     GIR_EraseRootFromParent_Done,
     /*  72255 */   // Label 1161: @72255
     /*  72255 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72292), // Rule ID 1136 //
     /*  72260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveud),
     /*  72268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72281 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10333:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVEUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUD),
     /*  72284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72286 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72288 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72290 */     GIR_RootConstrainSelectedInstOperands,
     /*  72291 */     // GIR_Coverage, 1136,
     /*  72291 */     GIR_EraseRootFromParent_Done,
     /*  72292 */   // Label 1162: @72292
     /*  72292 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72329), // Rule ID 1139 //
     /*  72297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesd),
     /*  72305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72318 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10411:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULESD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESD),
     /*  72321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72323 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72325 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72327 */     GIR_RootConstrainSelectedInstOperands,
     /*  72328 */     // GIR_Coverage, 1139,
     /*  72328 */     GIR_EraseRootFromParent_Done,
     /*  72329 */   // Label 1163: @72329
     /*  72329 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72366), // Rule ID 1140 //
     /*  72334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleud),
     /*  72342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72355 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10415:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULEUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUD),
     /*  72358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72360 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72362 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72364 */     GIR_RootConstrainSelectedInstOperands,
     /*  72365 */     // GIR_Coverage, 1140,
     /*  72365 */     GIR_EraseRootFromParent_Done,
     /*  72366 */   // Label 1164: @72366
     /*  72366 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72403), // Rule ID 1141 //
     /*  72371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosd),
     /*  72379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72392 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10423:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOSD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSD),
     /*  72395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72397 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72399 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72401 */     GIR_RootConstrainSelectedInstOperands,
     /*  72402 */     // GIR_Coverage, 1141,
     /*  72402 */     GIR_EraseRootFromParent_Done,
     /*  72403 */   // Label 1165: @72403
     /*  72403 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72440), // Rule ID 1142 //
     /*  72408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloud),
     /*  72416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72429 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10427:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUD),
     /*  72432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72434 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72436 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72438 */     GIR_RootConstrainSelectedInstOperands,
     /*  72439 */     // GIR_Coverage, 1142,
     /*  72439 */     GIR_EraseRootFromParent_Done,
     /*  72440 */   // Label 1166: @72440
     /*  72440 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72477), // Rule ID 1146 //
     /*  72445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesq),
     /*  72453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72466 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10331:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVESQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESQ),
     /*  72469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72471 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72473 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72475 */     GIR_RootConstrainSelectedInstOperands,
     /*  72476 */     // GIR_Coverage, 1146,
     /*  72476 */     GIR_EraseRootFromParent_Done,
     /*  72477 */   // Label 1167: @72477
     /*  72477 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72514), // Rule ID 1147 //
     /*  72482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuq),
     /*  72490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72503 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10334:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVEUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUQ),
     /*  72506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72508 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72510 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72512 */     GIR_RootConstrainSelectedInstOperands,
     /*  72513 */     // GIR_Coverage, 1147,
     /*  72513 */     GIR_EraseRootFromParent_Done,
     /*  72514 */   // Label 1168: @72514
     /*  72514 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72551), // Rule ID 1157 //
     /*  72519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqnm),
     /*  72527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72540 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10458:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VRLQNM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQNM),
     /*  72543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72545 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72547 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72549 */     GIR_RootConstrainSelectedInstOperands,
     /*  72550 */     // GIR_Coverage, 1157,
     /*  72550 */     GIR_EraseRootFromParent_Done,
     /*  72551 */   // Label 1169: @72551
     /*  72551 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72588), // Rule ID 1162 //
     /*  72556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  72559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxor),
     /*  72564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  72570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v1024s1,
     /*  72573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72577 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10626:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMXOR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)
     /*  72577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXOR),
     /*  72580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72582 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  72584 */     GIR_RootToRootCopy, /*OpIdx*/3, // AB
     /*  72586 */     GIR_RootConstrainSelectedInstOperands,
     /*  72587 */     // GIR_Coverage, 1162,
     /*  72587 */     GIR_EraseRootFromParent_Done,
     /*  72588 */   // Label 1170: @72588
     /*  72588 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72645), // Rule ID 2904 //
     /*  72593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_PairedVectorMemops),
     /*  72596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_assemble_pair),
     /*  72601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v256s1,
     /*  72604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRpRCRegClassID),
     /*  72614 */     // (intrinsic_wo_chain:{ *:[v256i1] } 10779:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vs1, v16i8:{ *:[v16i8] }:$vs0)  =>  (REG_SEQUENCE:{ *:[v256i1] } VSRpRC:{ *:[i32] }, ?:{ *:[v16i8] }:$vs0, sub_vsx1:{ *:[i32] }, ?:{ *:[v16i8] }:$vs1, sub_vsx0:{ *:[i32] })
     /*  72614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  72617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72619 */     GIR_RootToRootCopy, /*OpIdx*/3, // vs0
     /*  72621 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/22,
     /*  72624 */     GIR_RootToRootCopy, /*OpIdx*/2, // vs1
     /*  72626 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/21,
     /*  72629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRpRCRegClassID),
     /*  72634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72644 */     // GIR_Coverage, 2904,
     /*  72644 */     GIR_EraseRootFromParent_Done,
     /*  72645 */   // Label 1171: @72645
     /*  72645 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72682), // Rule ID 3339 //
     /*  72650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsw),
     /*  72658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72671 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10419:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /*  72674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72676 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72678 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72680 */     GIR_RootConstrainSelectedInstOperands,
     /*  72681 */     // GIR_Coverage, 3339,
     /*  72681 */     GIR_EraseRootFromParent_Done,
     /*  72682 */   // Label 1172: @72682
     /*  72682 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72719), // Rule ID 3340 //
     /*  72687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhuw),
     /*  72695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72708 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10421:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /*  72711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72713 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72715 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72717 */     GIR_RootConstrainSelectedInstOperands,
     /*  72718 */     // GIR_Coverage, 3340,
     /*  72718 */     GIR_EraseRootFromParent_Done,
     /*  72719 */   // Label 1173: @72719
     /*  72719 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72756), // Rule ID 3341 //
     /*  72724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsd),
     /*  72732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72745 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10418:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHSD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /*  72748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72750 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72752 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72754 */     GIR_RootConstrainSelectedInstOperands,
     /*  72755 */     // GIR_Coverage, 3341,
     /*  72755 */     GIR_EraseRootFromParent_Done,
     /*  72756 */   // Label 1174: @72756
     /*  72756 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72793), // Rule ID 3342 //
     /*  72761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhud),
     /*  72769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72782 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10420:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHUD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /*  72785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72787 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72789 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72791 */     GIR_RootConstrainSelectedInstOperands,
     /*  72792 */     // GIR_Coverage, 3342,
     /*  72792 */     GIR_EraseRootFromParent_Done,
     /*  72793 */   // Label 1175: @72793
     /*  72793 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72852), // Rule ID 3509 //
     /*  72798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  72801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4),
     /*  72806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  72812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72819 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10637:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  72822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  72835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4),
     /*  72843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72845 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  72847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72850 */     GIR_RootConstrainSelectedInstOperands,
     /*  72851 */     // GIR_Coverage, 3509,
     /*  72851 */     GIR_EraseRootFromParent_Done,
     /*  72852 */   // Label 1176: @72852
     /*  72852 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72911), // Rule ID 3512 //
     /*  72857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  72860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2),
     /*  72865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  72871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72878 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10627:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  72881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  72894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2),
     /*  72902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72904 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  72906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72909 */     GIR_RootConstrainSelectedInstOperands,
     /*  72910 */     // GIR_Coverage, 3512,
     /*  72910 */     GIR_EraseRootFromParent_Done,
     /*  72911 */   // Label 1177: @72911
     /*  72911 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72970), // Rule ID 3517 //
     /*  72916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  72919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2),
     /*  72924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  72930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72937 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10632:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  72940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  72953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2),
     /*  72961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72963 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  72965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72968 */     GIR_RootConstrainSelectedInstOperands,
     /*  72969 */     // GIR_Coverage, 3517,
     /*  72969 */     GIR_EraseRootFromParent_Done,
     /*  72970 */   // Label 1178: @72970
     /*  72970 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(73051), // Rule ID 3535 //
     /*  72975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  72978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  72983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  72986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  72996 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10710:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72996 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  72999 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73003 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73008 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8),
     /*  73041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73049 */     GIR_RootConstrainSelectedInstOperands,
     /*  73050 */     // GIR_Coverage, 3535,
     /*  73050 */     GIR_EraseRootFromParent_Done,
     /*  73051 */   // Label 1179: @73051
     /*  73051 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73132), // Rule ID 3537 //
     /*  73056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  73064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73077 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10712:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73089 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4),
     /*  73122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73130 */     GIR_RootConstrainSelectedInstOperands,
     /*  73131 */     // GIR_Coverage, 3537,
     /*  73131 */     GIR_EraseRootFromParent_Done,
     /*  73132 */   // Label 1180: @73132
     /*  73132 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73213), // Rule ID 3539 //
     /*  73137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  73145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73158 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10708:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2S),
     /*  73203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73211 */     GIR_RootConstrainSelectedInstOperands,
     /*  73212 */     // GIR_Coverage, 3539,
     /*  73212 */     GIR_EraseRootFromParent_Done,
     /*  73213 */   // Label 1181: @73213
     /*  73213 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73294), // Rule ID 3541 //
     /*  73218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  73226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73239 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10710:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73239 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73246 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73251 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8W),
     /*  73284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73292 */     GIR_RootConstrainSelectedInstOperands,
     /*  73293 */     // GIR_Coverage, 3541,
     /*  73293 */     GIR_EraseRootFromParent_Done,
     /*  73294 */   // Label 1182: @73294
     /*  73294 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73375), // Rule ID 3543 //
     /*  73299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  73307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73320 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10712:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73320 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73323 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73327 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73332 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4W),
     /*  73365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73373 */     GIR_RootConstrainSelectedInstOperands,
     /*  73374 */     // GIR_Coverage, 3543,
     /*  73374 */     GIR_EraseRootFromParent_Done,
     /*  73375 */   // Label 1183: @73375
     /*  73375 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73456), // Rule ID 3545 //
     /*  73380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  73388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73401 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10708:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73413 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SW),
     /*  73446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73454 */     GIR_RootConstrainSelectedInstOperands,
     /*  73455 */     // GIR_Coverage, 3545,
     /*  73455 */     GIR_EraseRootFromParent_Done,
     /*  73456 */   // Label 1184: @73456
     /*  73456 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73537), // Rule ID 3547 //
     /*  73461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73482 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10691:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73494 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2),
     /*  73527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73535 */     GIR_RootConstrainSelectedInstOperands,
     /*  73536 */     // GIR_Coverage, 3547,
     /*  73536 */     GIR_EraseRootFromParent_Done,
     /*  73537 */   // Label 1185: @73537
     /*  73537 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73618), // Rule ID 3552 //
     /*  73542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73563 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10691:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2W),
     /*  73608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73616 */     GIR_RootConstrainSelectedInstOperands,
     /*  73617 */     // GIR_Coverage, 3552,
     /*  73617 */     GIR_EraseRootFromParent_Done,
     /*  73618 */   // Label 1186: @73618
     /*  73618 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73699), // Rule ID 3557 //
     /*  73623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  73631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73644 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10696:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GER),
     /*  73689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73697 */     GIR_RootConstrainSelectedInstOperands,
     /*  73698 */     // GIR_Coverage, 3557,
     /*  73698 */     GIR_EraseRootFromParent_Done,
     /*  73699 */   // Label 1187: @73699
     /*  73699 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73758), // Rule ID 3562 //
     /*  73704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  73712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73725 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10701:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GER),
     /*  73749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73751 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  73753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73756 */     GIR_RootConstrainSelectedInstOperands,
     /*  73757 */     // GIR_Coverage, 3562,
     /*  73757 */     GIR_EraseRootFromParent_Done,
     /*  73758 */   // Label 1188: @73758
     /*  73758 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73839), // Rule ID 3567 //
     /*  73763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  73771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73784 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10686:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73796 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2),
     /*  73829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73837 */     GIR_RootConstrainSelectedInstOperands,
     /*  73838 */     // GIR_Coverage, 3567,
     /*  73838 */     GIR_EraseRootFromParent_Done,
     /*  73839 */   // Label 1189: @73839
     /*  73839 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73920), // Rule ID 3572 //
     /*  73844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  73852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73865 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10706:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2),
     /*  73910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73918 */     GIR_RootConstrainSelectedInstOperands,
     /*  73919 */     // GIR_Coverage, 3572,
     /*  73919 */     GIR_EraseRootFromParent_Done,
     /*  73920 */   // Label 1190: @73920
     /*  73920 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(74001), // Rule ID 3575 //
     /*  73925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  73933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73946 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10696:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73946 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73949 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73953 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73958 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERW),
     /*  73991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73999 */     GIR_RootConstrainSelectedInstOperands,
     /*  74000 */     // GIR_Coverage, 3575,
     /*  74000 */     GIR_EraseRootFromParent_Done,
     /*  74001 */   // Label 1191: @74001
     /*  74001 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(74060), // Rule ID 3580 //
     /*  74006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  74014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  74020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74027 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10701:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERW),
     /*  74051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74053 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  74055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74058 */     GIR_RootConstrainSelectedInstOperands,
     /*  74059 */     // GIR_Coverage, 3580,
     /*  74059 */     GIR_EraseRootFromParent_Done,
     /*  74060 */   // Label 1192: @74060
     /*  74060 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74141), // Rule ID 3585 //
     /*  74065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  74073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74086 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10686:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74086 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74089 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74093 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74098 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74102 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74119 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2W),
     /*  74131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74139 */     GIR_RootConstrainSelectedInstOperands,
     /*  74140 */     // GIR_Coverage, 3585,
     /*  74140 */     GIR_EraseRootFromParent_Done,
     /*  74141 */   // Label 1193: @74141
     /*  74141 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74222), // Rule ID 3590 //
     /*  74146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  74154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74167 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10706:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2W),
     /*  74212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74220 */     GIR_RootConstrainSelectedInstOperands,
     /*  74221 */     // GIR_Coverage, 3590,
     /*  74221 */     GIR_EraseRootFromParent_Done,
     /*  74222 */   // Label 1194: @74222
     /*  74222 */   GIM_Reject,
     /*  74223 */ // Label 997: @74223
     /*  74223 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(81551),
     /*  74228 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  74231 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74289), // Rule ID 1007 //
     /*  74236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /*  74268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /*  74272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74274 */     // (intrinsic_wo_chain:{ *:[f128] } 10581:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQPO),
     /*  74277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /*  74283 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74285 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74287 */     GIR_RootConstrainSelectedInstOperands,
     /*  74288 */     // GIR_Coverage, 1007,
     /*  74288 */     GIR_EraseRootFromParent_Done,
     /*  74289 */   // Label 1196: @74289
     /*  74289 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74342), // Rule ID 2166 //
     /*  74294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxinsertw),
     /*  74302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74326 */     // MIs[1] Operand 1
     /*  74326 */     // No operand predicates
     /*  74326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74328 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10858:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v2i64:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)  =>  (XXINSERTW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)
     /*  74328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXINSERTW),
     /*  74331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74333 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74335 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // IMM
     /*  74340 */     GIR_RootConstrainSelectedInstOperands,
     /*  74341 */     // GIR_Coverage, 2166,
     /*  74341 */     GIR_EraseRootFromParent_Done,
     /*  74342 */   // Label 1197: @74342
     /*  74342 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74384), // Rule ID 1006 //
     /*  74347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74371 */     // (intrinsic_wo_chain:{ *:[f128] } 10581:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQPO),
     /*  74374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74376 */     GIR_RootToRootCopy, /*OpIdx*/4, // RSTi
     /*  74378 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74380 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74382 */     GIR_RootConstrainSelectedInstOperands,
     /*  74383 */     // GIR_Coverage, 1006,
     /*  74383 */     GIR_EraseRootFromParent_Done,
     /*  74384 */   // Label 1198: @74384
     /*  74384 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74426), // Rule ID 1745 //
     /*  74389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  74397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74413 */     // (intrinsic_wo_chain:{ *:[f64] } 10582:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSMSUBMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMDP),
     /*  74416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74418 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74420 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74422 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74424 */     GIR_RootConstrainSelectedInstOperands,
     /*  74425 */     // GIR_Coverage, 1745,
     /*  74425 */     GIR_EraseRootFromParent_Done,
     /*  74426 */   // Label 1199: @74426
     /*  74426 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74468), // Rule ID 1746 //
     /*  74431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  74439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74455 */     // (intrinsic_wo_chain:{ *:[f64] } 10586:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSNMADDMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMDP),
     /*  74458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74460 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74462 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74464 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74466 */     GIR_RootConstrainSelectedInstOperands,
     /*  74467 */     // GIR_Coverage, 1746,
     /*  74467 */     GIR_EraseRootFromParent_Done,
     /*  74468 */   // Label 1200: @74468
     /*  74468 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74510), // Rule ID 1932 //
     /*  74473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  74481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74497 */     // (intrinsic_wo_chain:{ *:[f32] } 10583:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSMSUBMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMSP),
     /*  74500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74502 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74504 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74506 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74508 */     GIR_RootConstrainSelectedInstOperands,
     /*  74509 */     // GIR_Coverage, 1932,
     /*  74509 */     GIR_EraseRootFromParent_Done,
     /*  74510 */   // Label 1201: @74510
     /*  74510 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74552), // Rule ID 1933 //
     /*  74515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  74523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74539 */     // (intrinsic_wo_chain:{ *:[f32] } 10587:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSNMADDMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMSP),
     /*  74542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74544 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74546 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74548 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74550 */     GIR_RootConstrainSelectedInstOperands,
     /*  74551 */     // GIR_Coverage, 1933,
     /*  74551 */     GIR_EraseRootFromParent_Done,
     /*  74552 */   // Label 1202: @74552
     /*  74552 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74594), // Rule ID 508 //
     /*  74557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmaw),
     /*  74565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74575 */     // MIs[0] ST
     /*  74575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74578 */     // MIs[0] SIX
     /*  74578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74581 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10218:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAW),
     /*  74584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74586 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74588 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74590 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74592 */     GIR_RootConstrainSelectedInstOperands,
     /*  74593 */     // GIR_Coverage, 508,
     /*  74593 */     GIR_EraseRootFromParent_Done,
     /*  74594 */   // Label 1203: @74594
     /*  74594 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74636), // Rule ID 509 //
     /*  74599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmad),
     /*  74607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74617 */     // MIs[0] ST
     /*  74617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74620 */     // MIs[0] SIX
     /*  74620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74623 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10217:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAD),
     /*  74626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74628 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74630 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74632 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74634 */     GIR_RootConstrainSelectedInstOperands,
     /*  74635 */     // GIR_Coverage, 509,
     /*  74635 */     GIR_EraseRootFromParent_Done,
     /*  74636 */   // Label 1204: @74636
     /*  74636 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(74678), // Rule ID 1056 //
     /*  74641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsldbi),
     /*  74649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74662 */     // MIs[0] SD
     /*  74662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74665 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10466:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSLDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLDBI),
     /*  74668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74670 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74672 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74674 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74676 */     GIR_RootConstrainSelectedInstOperands,
     /*  74677 */     // GIR_Coverage, 1056,
     /*  74677 */     GIR_EraseRootFromParent_Done,
     /*  74678 */   // Label 1205: @74678
     /*  74678 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(74720), // Rule ID 1057 //
     /*  74683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrdbi),
     /*  74691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74704 */     // MIs[0] SD
     /*  74704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74707 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10476:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSRDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRDBI),
     /*  74710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74712 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74714 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74716 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74718 */     GIR_RootConstrainSelectedInstOperands,
     /*  74719 */     // GIR_Coverage, 1057,
     /*  74719 */     GIR_EraseRootFromParent_Done,
     /*  74720 */   // Label 1206: @74720
     /*  74720 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(74762), // Rule ID 1062 //
     /*  74725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsw),
     /*  74733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74746 */     // MIs[0] VA
     /*  74746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74749 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10374:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, (timm:{ *:[i32] }):$VA, i32:{ *:[i32] }:$VB)
     /*  74749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSW),
     /*  74752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74754 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  74756 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  74758 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  74760 */     GIR_RootConstrainSelectedInstOperands,
     /*  74761 */     // GIR_Coverage, 1062,
     /*  74761 */     GIR_EraseRootFromParent_Done,
     /*  74762 */   // Label 1207: @74762
     /*  74762 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(74804), // Rule ID 1063 //
     /*  74767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsd),
     /*  74775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74788 */     // MIs[0] VA
     /*  74788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74791 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10367:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, (timm:{ *:[i32] }):$VA, i64:{ *:[i64] }:$VB)
     /*  74791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSD),
     /*  74794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74796 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  74798 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  74800 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  74802 */     GIR_RootConstrainSelectedInstOperands,
     /*  74803 */     // GIR_Coverage, 1063,
     /*  74803 */     GIR_EraseRootFromParent_Done,
     /*  74804 */   // Label 1208: @74804
     /*  74804 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(74849), // Rule ID 1444 //
     /*  74809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  74812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdadd),
     /*  74817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74830 */     // MIs[0] PS
     /*  74830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74833 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10521:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDADD_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  74833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDADD_rec),
     /*  74836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74838 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  74840 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  74842 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  74844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  74847 */     GIR_RootConstrainSelectedInstOperands,
     /*  74848 */     // GIR_Coverage, 1444,
     /*  74848 */     GIR_EraseRootFromParent_Done,
     /*  74849 */   // Label 1209: @74849
     /*  74849 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(74894), // Rule ID 1445 //
     /*  74854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  74857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdsub),
     /*  74862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74875 */     // MIs[0] PS
     /*  74875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74878 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10523:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDSUB_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  74878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDSUB_rec),
     /*  74881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74883 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  74885 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  74887 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  74889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  74892 */     GIR_RootConstrainSelectedInstOperands,
     /*  74893 */     // GIR_Coverage, 1445,
     /*  74893 */     GIR_EraseRootFromParent_Done,
     /*  74894 */   // Label 1210: @74894
     /*  74894 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(74948), // Rule ID 1560 //
     /*  74899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  74902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhd),
     /*  74907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74935 */     // (intrinsic_wo_chain:{ *:[i64] } 10609:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  74935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHD),
     /*  74938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  74940 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  74942 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  74944 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  74946 */     GIR_RootConstrainSelectedInstOperands,
     /*  74947 */     // GIR_Coverage, 1560,
     /*  74947 */     GIR_EraseRootFromParent_Done,
     /*  74948 */   // Label 1211: @74948
     /*  74948 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75002), // Rule ID 1561 //
     /*  74953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  74956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhdu),
     /*  74961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74989 */     // (intrinsic_wo_chain:{ *:[i64] } 10610:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  74989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHDU),
     /*  74992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  74994 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  74996 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  74998 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75000 */     GIR_RootConstrainSelectedInstOperands,
     /*  75001 */     // GIR_Coverage, 1561,
     /*  75001 */     GIR_EraseRootFromParent_Done,
     /*  75002 */   // Label 1212: @75002
     /*  75002 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75056), // Rule ID 1562 //
     /*  75007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  75010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddld),
     /*  75015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75043 */     // (intrinsic_wo_chain:{ *:[i64] } 10611:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDLD8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  75043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDLD8),
     /*  75046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75048 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  75050 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  75052 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75054 */     GIR_RootConstrainSelectedInstOperands,
     /*  75055 */     // GIR_Coverage, 1562,
     /*  75055 */     GIR_EraseRootFromParent_Done,
     /*  75056 */   // Label 1213: @75056
     /*  75056 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75107), // Rule ID 4849 //
     /*  75061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fsel),
     /*  75066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75094 */     // (intrinsic_wo_chain:{ *:[f64] } 10593:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FRA, f8rc:{ *:[f64] }:$FRC, f8rc:{ *:[f64] }:$FRB)  =>  (FSELD:{ *:[f64] } ?:{ *:[f64] }:$FRA, ?:{ *:[f64] }:$FRC, ?:{ *:[f64] }:$FRB)
     /*  75094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FSELD),
     /*  75097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  75099 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRA
     /*  75101 */     GIR_RootToRootCopy, /*OpIdx*/3, // FRC
     /*  75103 */     GIR_RootToRootCopy, /*OpIdx*/4, // FRB
     /*  75105 */     GIR_RootConstrainSelectedInstOperands,
     /*  75106 */     // GIR_Coverage, 4849,
     /*  75106 */     GIR_EraseRootFromParent_Done,
     /*  75107 */   // Label 1214: @75107
     /*  75107 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75149), // Rule ID 296 //
     /*  75112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmladduhm),
     /*  75120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75136 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10401:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMLADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  75136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*  75139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75141 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75143 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75145 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75147 */     GIR_RootConstrainSelectedInstOperands,
     /*  75148 */     // GIR_Coverage, 296,
     /*  75148 */     GIR_EraseRootFromParent_Done,
     /*  75149 */   // Label 1215: @75149
     /*  75149 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75191), // Rule ID 297 //
     /*  75154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vperm),
     /*  75162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75178 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10432:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)  =>  (VPERM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)
     /*  75178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERM),
     /*  75181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75183 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75185 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75187 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75189 */     GIR_RootConstrainSelectedInstOperands,
     /*  75190 */     // GIR_Coverage, 297,
     /*  75190 */     GIR_EraseRootFromParent_Done,
     /*  75191 */   // Label 1216: @75191
     /*  75191 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75233), // Rule ID 298 //
     /*  75196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsel),
     /*  75204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75220 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10463:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VSEL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /*  75223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75225 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75227 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75229 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75231 */     GIR_RootConstrainSelectedInstOperands,
     /*  75232 */     // GIR_Coverage, 298,
     /*  75232 */     GIR_EraseRootFromParent_Done,
     /*  75233 */   // Label 1217: @75233
     /*  75233 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75275), // Rule ID 349 //
     /*  75238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsummbm),
     /*  75246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75262 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10403:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMMBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMMBM),
     /*  75265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75267 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75269 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75271 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75273 */     GIR_RootConstrainSelectedInstOperands,
     /*  75274 */     // GIR_Coverage, 349,
     /*  75274 */     GIR_EraseRootFromParent_Done,
     /*  75275 */   // Label 1218: @75275
     /*  75275 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75317), // Rule ID 350 //
     /*  75280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshm),
     /*  75288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75304 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10404:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHM),
     /*  75307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75309 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75311 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75313 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75315 */     GIR_RootConstrainSelectedInstOperands,
     /*  75316 */     // GIR_Coverage, 350,
     /*  75316 */     GIR_EraseRootFromParent_Done,
     /*  75317 */   // Label 1219: @75317
     /*  75317 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(75359), // Rule ID 351 //
     /*  75322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumubm),
     /*  75330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75346 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10406:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUBM),
     /*  75349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75351 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75353 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75355 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75357 */     GIR_RootConstrainSelectedInstOperands,
     /*  75358 */     // GIR_Coverage, 351,
     /*  75358 */     GIR_EraseRootFromParent_Done,
     /*  75359 */   // Label 1220: @75359
     /*  75359 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(75401), // Rule ID 352 //
     /*  75364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhm),
     /*  75372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75388 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10408:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHM),
     /*  75391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75393 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75395 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75397 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75399 */     GIR_RootConstrainSelectedInstOperands,
     /*  75400 */     // GIR_Coverage, 352,
     /*  75400 */     GIR_EraseRootFromParent_Done,
     /*  75401 */   // Label 1221: @75401
     /*  75401 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(75443), // Rule ID 471 //
     /*  75406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddeuqm),
     /*  75414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75430 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10250:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDEUQM),
     /*  75433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75435 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75437 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75439 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75441 */     GIR_RootConstrainSelectedInstOperands,
     /*  75442 */     // GIR_Coverage, 471,
     /*  75442 */     GIR_EraseRootFromParent_Done,
     /*  75443 */   // Label 1222: @75443
     /*  75443 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(75485), // Rule ID 473 //
     /*  75448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddecuq),
     /*  75456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75472 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10249:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDECUQ),
     /*  75475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75477 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75479 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75481 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75483 */     GIR_RootConstrainSelectedInstOperands,
     /*  75484 */     // GIR_Coverage, 473,
     /*  75484 */     GIR_EraseRootFromParent_Done,
     /*  75485 */   // Label 1223: @75485
     /*  75485 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(75527), // Rule ID 476 //
     /*  75490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubeuqm),
     /*  75498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75514 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10492:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBEUQM),
     /*  75517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75519 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75521 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75523 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75525 */     GIR_RootConstrainSelectedInstOperands,
     /*  75526 */     // GIR_Coverage, 476,
     /*  75526 */     GIR_EraseRootFromParent_Done,
     /*  75527 */   // Label 1224: @75527
     /*  75527 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(75569), // Rule ID 478 //
     /*  75532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubecuq),
     /*  75540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75556 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10491:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBECUQ),
     /*  75559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75561 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75563 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75565 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75567 */     GIR_RootConstrainSelectedInstOperands,
     /*  75568 */     // GIR_Coverage, 478,
     /*  75568 */     GIR_EraseRootFromParent_Done,
     /*  75569 */   // Label 1225: @75569
     /*  75569 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(75611), // Rule ID 515 //
     /*  75574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumudm),
     /*  75582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75598 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10407:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMUDM:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUDM),
     /*  75601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75603 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75605 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75607 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75609 */     GIR_RootConstrainSelectedInstOperands,
     /*  75610 */     // GIR_Coverage, 515,
     /*  75610 */     GIR_EraseRootFromParent_Done,
     /*  75611 */   // Label 1226: @75611
     /*  75611 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(75653), // Rule ID 548 //
     /*  75616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwmi),
     /*  75624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75640 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10460:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)  =>  (VRLWMI:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)
     /*  75640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWMI),
     /*  75643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75645 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75647 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75649 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75651 */     GIR_RootConstrainSelectedInstOperands,
     /*  75652 */     // GIR_Coverage, 548,
     /*  75652 */     GIR_EraseRootFromParent_Done,
     /*  75653 */   // Label 1227: @75653
     /*  75653 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(75695), // Rule ID 550 //
     /*  75658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldmi),
     /*  75666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  75678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75682 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10454:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)  =>  (VRLDMI:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)
     /*  75682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDMI),
     /*  75685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75687 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75689 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75691 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75693 */     GIR_RootConstrainSelectedInstOperands,
     /*  75694 */     // GIR_Coverage, 550,
     /*  75694 */     GIR_EraseRootFromParent_Done,
     /*  75695 */   // Label 1228: @75695
     /*  75695 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(75737), // Rule ID 1064 //
     /*  75700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvlx),
     /*  75708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75724 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10365:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  75724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVLX),
     /*  75727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75729 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75731 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75733 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75735 */     GIR_RootConstrainSelectedInstOperands,
     /*  75736 */     // GIR_Coverage, 1064,
     /*  75736 */     GIR_EraseRootFromParent_Done,
     /*  75737 */   // Label 1229: @75737
     /*  75737 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(75779), // Rule ID 1065 //
     /*  75742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvrx),
     /*  75750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75766 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10366:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  75766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVRX),
     /*  75769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75771 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75773 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75775 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75777 */     GIR_RootConstrainSelectedInstOperands,
     /*  75778 */     // GIR_Coverage, 1065,
     /*  75778 */     GIR_EraseRootFromParent_Done,
     /*  75779 */   // Label 1230: @75779
     /*  75779 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(75821), // Rule ID 1066 //
     /*  75784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvlx),
     /*  75792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75808 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10372:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  75808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVLX),
     /*  75811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75813 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75815 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75817 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75819 */     GIR_RootConstrainSelectedInstOperands,
     /*  75820 */     // GIR_Coverage, 1066,
     /*  75820 */     GIR_EraseRootFromParent_Done,
     /*  75821 */   // Label 1231: @75821
     /*  75821 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(75863), // Rule ID 1067 //
     /*  75826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvrx),
     /*  75834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75850 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10373:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  75850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVRX),
     /*  75853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75855 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75857 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75859 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75861 */     GIR_RootConstrainSelectedInstOperands,
     /*  75862 */     // GIR_Coverage, 1067,
     /*  75862 */     GIR_EraseRootFromParent_Done,
     /*  75863 */   // Label 1232: @75863
     /*  75863 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(75905), // Rule ID 1068 //
     /*  75868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvlx),
     /*  75876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75892 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10377:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  75892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVLX),
     /*  75895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75897 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75899 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75901 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75903 */     GIR_RootConstrainSelectedInstOperands,
     /*  75904 */     // GIR_Coverage, 1068,
     /*  75904 */     GIR_EraseRootFromParent_Done,
     /*  75905 */   // Label 1233: @75905
     /*  75905 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(75947), // Rule ID 1069 //
     /*  75910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvrx),
     /*  75918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75934 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10378:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  75934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVRX),
     /*  75937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75939 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75941 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75943 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75945 */     GIR_RootConstrainSelectedInstOperands,
     /*  75946 */     // GIR_Coverage, 1069,
     /*  75946 */     GIR_EraseRootFromParent_Done,
     /*  75947 */   // Label 1234: @75947
     /*  75947 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(75989), // Rule ID 1070 //
     /*  75952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsblx),
     /*  75960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75976 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10363:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  75976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /*  75979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75981 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75983 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75985 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75987 */     GIR_RootConstrainSelectedInstOperands,
     /*  75988 */     // GIR_Coverage, 1070,
     /*  75988 */     GIR_EraseRootFromParent_Done,
     /*  75989 */   // Label 1235: @75989
     /*  75989 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(76031), // Rule ID 1071 //
     /*  75994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbrx),
     /*  76002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76018 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10364:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBRX),
     /*  76021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76023 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76025 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76027 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76029 */     GIR_RootConstrainSelectedInstOperands,
     /*  76030 */     // GIR_Coverage, 1071,
     /*  76030 */     GIR_EraseRootFromParent_Done,
     /*  76031 */   // Label 1236: @76031
     /*  76031 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(76073), // Rule ID 1072 //
     /*  76036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshlx),
     /*  76044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76060 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10370:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /*  76063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76065 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76067 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76069 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76071 */     GIR_RootConstrainSelectedInstOperands,
     /*  76072 */     // GIR_Coverage, 1072,
     /*  76072 */     GIR_EraseRootFromParent_Done,
     /*  76073 */   // Label 1237: @76073
     /*  76073 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(76115), // Rule ID 1073 //
     /*  76078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshrx),
     /*  76086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76102 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10371:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHRX),
     /*  76105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76107 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76109 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76111 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76113 */     GIR_RootConstrainSelectedInstOperands,
     /*  76114 */     // GIR_Coverage, 1073,
     /*  76114 */     GIR_EraseRootFromParent_Done,
     /*  76115 */   // Label 1238: @76115
     /*  76115 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(76157), // Rule ID 1074 //
     /*  76120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswlx),
     /*  76128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76144 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10375:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWLX),
     /*  76147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76149 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76151 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76153 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76155 */     GIR_RootConstrainSelectedInstOperands,
     /*  76156 */     // GIR_Coverage, 1074,
     /*  76156 */     GIR_EraseRootFromParent_Done,
     /*  76157 */   // Label 1239: @76157
     /*  76157 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(76199), // Rule ID 1075 //
     /*  76162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswrx),
     /*  76170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76186 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10376:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWRX),
     /*  76189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76191 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76193 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76195 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76197 */     GIR_RootConstrainSelectedInstOperands,
     /*  76198 */     // GIR_Coverage, 1075,
     /*  76198 */     GIR_EraseRootFromParent_Done,
     /*  76199 */   // Label 1240: @76199
     /*  76199 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(76241), // Rule ID 1076 //
     /*  76204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdlx),
     /*  76212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76228 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10368:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  76228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDLX),
     /*  76231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76233 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76235 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76237 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76239 */     GIR_RootConstrainSelectedInstOperands,
     /*  76240 */     // GIR_Coverage, 1076,
     /*  76240 */     GIR_EraseRootFromParent_Done,
     /*  76241 */   // Label 1241: @76241
     /*  76241 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(76283), // Rule ID 1077 //
     /*  76246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdrx),
     /*  76254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76270 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10369:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  76270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDRX),
     /*  76273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76275 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76277 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76279 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76281 */     GIR_RootConstrainSelectedInstOperands,
     /*  76282 */     // GIR_Coverage, 1077,
     /*  76282 */     GIR_EraseRootFromParent_Done,
     /*  76283 */   // Label 1242: @76283
     /*  76283 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(76325), // Rule ID 1098 //
     /*  76288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvlx),
     /*  76296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76312 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10344:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVLX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVLX),
     /*  76315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76317 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76319 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76321 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76323 */     GIR_RootConstrainSelectedInstOperands,
     /*  76324 */     // GIR_Coverage, 1098,
     /*  76324 */     GIR_EraseRootFromParent_Done,
     /*  76325 */   // Label 1243: @76325
     /*  76325 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(76367), // Rule ID 1099 //
     /*  76330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvrx),
     /*  76338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76354 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10345:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVRX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVRX),
     /*  76357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76359 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76361 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76363 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76365 */     GIR_RootConstrainSelectedInstOperands,
     /*  76366 */     // GIR_Coverage, 1099,
     /*  76366 */     GIR_EraseRootFromParent_Done,
     /*  76367 */   // Label 1244: @76367
     /*  76367 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(76409), // Rule ID 1100 //
     /*  76372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvlx),
     /*  76380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76396 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10346:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVLX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVLX),
     /*  76399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76401 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76403 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76405 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76407 */     GIR_RootConstrainSelectedInstOperands,
     /*  76408 */     // GIR_Coverage, 1100,
     /*  76408 */     GIR_EraseRootFromParent_Done,
     /*  76409 */   // Label 1245: @76409
     /*  76409 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(76451), // Rule ID 1101 //
     /*  76414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvrx),
     /*  76422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76438 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10347:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVRX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVRX),
     /*  76441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76443 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76445 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76447 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76449 */     GIR_RootConstrainSelectedInstOperands,
     /*  76450 */     // GIR_Coverage, 1101,
     /*  76450 */     GIR_EraseRootFromParent_Done,
     /*  76451 */   // Label 1246: @76451
     /*  76451 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(76493), // Rule ID 1102 //
     /*  76456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvlx),
     /*  76464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76480 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10348:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVLX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVLX),
     /*  76483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76485 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76487 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76489 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76491 */     GIR_RootConstrainSelectedInstOperands,
     /*  76492 */     // GIR_Coverage, 1102,
     /*  76492 */     GIR_EraseRootFromParent_Done,
     /*  76493 */   // Label 1247: @76493
     /*  76493 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(76535), // Rule ID 1103 //
     /*  76498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvrx),
     /*  76506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76522 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10349:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVRX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVRX),
     /*  76525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76527 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76529 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76531 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76533 */     GIR_RootConstrainSelectedInstOperands,
     /*  76534 */     // GIR_Coverage, 1103,
     /*  76534 */     GIR_EraseRootFromParent_Done,
     /*  76535 */   // Label 1248: @76535
     /*  76535 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(76577), // Rule ID 1104 //
     /*  76540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvlx),
     /*  76548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76564 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10342:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVLX),
     /*  76567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76569 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76571 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76573 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76575 */     GIR_RootConstrainSelectedInstOperands,
     /*  76576 */     // GIR_Coverage, 1104,
     /*  76576 */     GIR_EraseRootFromParent_Done,
     /*  76577 */   // Label 1249: @76577
     /*  76577 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(76619), // Rule ID 1105 //
     /*  76582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvrx),
     /*  76590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76606 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10343:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVRX),
     /*  76609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76611 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76613 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76615 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76617 */     GIR_RootConstrainSelectedInstOperands,
     /*  76618 */     // GIR_Coverage, 1105,
     /*  76618 */     GIR_EraseRootFromParent_Done,
     /*  76619 */   // Label 1250: @76619
     /*  76619 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(76661), // Rule ID 1143 //
     /*  76624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumcud),
     /*  76632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76648 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10402:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMCUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  76648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMCUD),
     /*  76651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76653 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76655 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76657 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76659 */     GIR_RootConstrainSelectedInstOperands,
     /*  76660 */     // GIR_Coverage, 1143,
     /*  76660 */     GIR_EraseRootFromParent_Done,
     /*  76661 */   // Label 1251: @76661
     /*  76661 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(76703), // Rule ID 1158 //
     /*  76666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqmi),
     /*  76674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  76680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  76683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76690 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10457:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)  =>  (VRLQMI:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)
     /*  76690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQMI),
     /*  76693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76695 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  76697 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  76699 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  76701 */     GIR_RootConstrainSelectedInstOperands,
     /*  76702 */     // GIR_Coverage, 1158,
     /*  76702 */     GIR_EraseRootFromParent_Done,
     /*  76703 */   // Label 1252: @76703
     /*  76703 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(76742), // Rule ID 1276 //
     /*  76708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  76713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  76716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  76719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  76729 */     // (intrinsic_wo_chain:{ *:[f64] } 10582:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FMSUB:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  76729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /*  76732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76734 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76736 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76738 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76740 */     GIR_RootConstrainSelectedInstOperands,
     /*  76741 */     // GIR_Coverage, 1276,
     /*  76741 */     GIR_EraseRootFromParent_Done,
     /*  76742 */   // Label 1253: @76742
     /*  76742 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(76781), // Rule ID 1277 //
     /*  76747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  76752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  76768 */     // (intrinsic_wo_chain:{ *:[f32] } 10583:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FMSUBS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  76768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /*  76771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76773 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76775 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76777 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76779 */     GIR_RootConstrainSelectedInstOperands,
     /*  76780 */     // GIR_Coverage, 1277,
     /*  76780 */     GIR_EraseRootFromParent_Done,
     /*  76781 */   // Label 1254: @76781
     /*  76781 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(76820), // Rule ID 1278 //
     /*  76786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  76791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  76794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  76797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  76807 */     // (intrinsic_wo_chain:{ *:[f64] } 10586:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FNMADD:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  76807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /*  76810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76812 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76814 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76816 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76818 */     GIR_RootConstrainSelectedInstOperands,
     /*  76819 */     // GIR_Coverage, 1278,
     /*  76819 */     GIR_EraseRootFromParent_Done,
     /*  76820 */   // Label 1255: @76820
     /*  76820 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(76859), // Rule ID 1279 //
     /*  76825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  76830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  76846 */     // (intrinsic_wo_chain:{ *:[f32] } 10587:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FNMADDS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  76846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /*  76849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76851 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76853 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76855 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76857 */     GIR_RootConstrainSelectedInstOperands,
     /*  76858 */     // GIR_Coverage, 1279,
     /*  76858 */     GIR_EraseRootFromParent_Done,
     /*  76859 */   // Label 1256: @76859
     /*  76859 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(76901), // Rule ID 1381 //
     /*  76864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  76867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaddfp),
     /*  76872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76888 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10380:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  76888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /*  76891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76893 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76895 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76897 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76899 */     GIR_RootConstrainSelectedInstOperands,
     /*  76900 */     // GIR_Coverage, 1381,
     /*  76900 */     GIR_EraseRootFromParent_Done,
     /*  76901 */   // Label 1257: @76901
     /*  76901 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(76943), // Rule ID 1382 //
     /*  76906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  76909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vnmsubfp),
     /*  76914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76930 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10430:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VNMSUBFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  76930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /*  76933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76935 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76937 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76939 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76941 */     GIR_RootConstrainSelectedInstOperands,
     /*  76942 */     // GIR_Coverage, 1382,
     /*  76942 */     GIR_EraseRootFromParent_Done,
     /*  76943 */   // Label 1258: @76943
     /*  76943 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(77048), // Rule ID 1577 //
     /*  76948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsLittleEndian),
     /*  76951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  76956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76972 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10210:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, (XXLNOR:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] })))
     /*  76972 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  76975 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  76979 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76984 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  76988 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  76993 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  76996 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77000 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77005 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  77009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  77021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77029 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77039 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77041 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77046 */     GIR_RootConstrainSelectedInstOperands,
     /*  77047 */     // GIR_Coverage, 1577,
     /*  77047 */     GIR_EraseRootFromParent_Done,
     /*  77048 */   // Label 1259: @77048
     /*  77048 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(77090), // Rule ID 1578 //
     /*  77053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsBigEndian),
     /*  77056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  77061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77077 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10210:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  77077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77082 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77084 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77086 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  77088 */     GIR_RootConstrainSelectedInstOperands,
     /*  77089 */     // GIR_Coverage, 1578,
     /*  77089 */     GIR_EraseRootFromParent_Done,
     /*  77090 */   // Label 1260: @77090
     /*  77090 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(77132), // Rule ID 1579 //
     /*  77095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX),
     /*  77098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor_be),
     /*  77103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77119 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10211:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  77119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77124 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77126 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77128 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  77130 */     GIR_RootConstrainSelectedInstOperands,
     /*  77131 */     // GIR_Coverage, 1579,
     /*  77131 */     GIR_EraseRootFromParent_Done,
     /*  77132 */   // Label 1261: @77132
     /*  77132 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(77261), // Rule ID 3425 //
     /*  77137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvb),
     /*  77145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10848:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXBLENDVB:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  77161 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  77164 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77168 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77173 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  77177 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77182 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77185 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77189 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77194 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  77198 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  77219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVB),
     /*  77231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77236 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77239 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77242 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77260 */     // GIR_Coverage, 3425,
     /*  77260 */     GIR_EraseRootFromParent_Done,
     /*  77261 */   // Label 1262: @77261
     /*  77261 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(77390), // Rule ID 3426 //
     /*  77266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvh),
     /*  77274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  77286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77290 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10850:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A, v8i16:{ *:[v8i16] }:$B, v8i16:{ *:[v8i16] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBLENDVH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  77290 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  77293 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77297 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77302 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  77306 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77311 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77314 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77318 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77323 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  77327 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77344 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  77348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVH),
     /*  77360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77368 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77389 */     // GIR_Coverage, 3426,
     /*  77389 */     GIR_EraseRootFromParent_Done,
     /*  77390 */   // Label 1263: @77390
     /*  77390 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(77432), // Rule ID 3427 //
     /*  77395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvw),
     /*  77403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  77415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77419 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10851:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C)  =>  (XXBLENDVW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  77419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVW),
     /*  77422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77424 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77426 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77428 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77430 */     GIR_RootConstrainSelectedInstOperands,
     /*  77431 */     // GIR_Coverage, 3427,
     /*  77431 */     GIR_EraseRootFromParent_Done,
     /*  77432 */   // Label 1264: @77432
     /*  77432 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(77474), // Rule ID 3428 //
     /*  77437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvd),
     /*  77445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  77448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  77457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77461 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10849:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, v2i64:{ *:[v2i64] }:$B, v2i64:{ *:[v2i64] }:$C)  =>  (XXBLENDVD:{ *:[v2i64] } ?:{ *:[v2i64] }:$A, ?:{ *:[v2i64] }:$B, ?:{ *:[v2i64] }:$C)
     /*  77461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVD),
     /*  77464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77466 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77468 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77470 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77472 */     GIR_RootConstrainSelectedInstOperands,
     /*  77473 */     // GIR_Coverage, 3428,
     /*  77473 */     GIR_EraseRootFromParent_Done,
     /*  77474 */   // Label 1265: @77474
     /*  77474 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(77538), // Rule ID 3510 //
     /*  77479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4pp),
     /*  77487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77503 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10638:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4PP),
     /*  77527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77529 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77531 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77536 */     GIR_RootConstrainSelectedInstOperands,
     /*  77537 */     // GIR_Coverage, 3510,
     /*  77537 */     GIR_EraseRootFromParent_Done,
     /*  77538 */   // Label 1266: @77538
     /*  77538 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(77602), // Rule ID 3511 //
     /*  77543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4spp),
     /*  77551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77567 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10639:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4SPP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4SPP),
     /*  77591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77593 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77595 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77600 */     GIR_RootConstrainSelectedInstOperands,
     /*  77601 */     // GIR_Coverage, 3511,
     /*  77601 */     GIR_EraseRootFromParent_Done,
     /*  77602 */   // Label 1267: @77602
     /*  77602 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(77666), // Rule ID 3513 //
     /*  77607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2pp),
     /*  77615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77631 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10631:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77643 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2PP),
     /*  77655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77657 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77659 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77664 */     GIR_RootConstrainSelectedInstOperands,
     /*  77665 */     // GIR_Coverage, 3513,
     /*  77665 */     GIR_EraseRootFromParent_Done,
     /*  77666 */   // Label 1268: @77666
     /*  77666 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(77730), // Rule ID 3514 //
     /*  77671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2pn),
     /*  77679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77695 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10630:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2PN),
     /*  77719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77721 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77723 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77728 */     GIR_RootConstrainSelectedInstOperands,
     /*  77729 */     // GIR_Coverage, 3514,
     /*  77729 */     GIR_EraseRootFromParent_Done,
     /*  77730 */   // Label 1269: @77730
     /*  77730 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(77794), // Rule ID 3515 //
     /*  77735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2np),
     /*  77743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77759 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10629:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2NP),
     /*  77783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77785 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77787 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77792 */     GIR_RootConstrainSelectedInstOperands,
     /*  77793 */     // GIR_Coverage, 3515,
     /*  77793 */     GIR_EraseRootFromParent_Done,
     /*  77794 */   // Label 1270: @77794
     /*  77794 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(77858), // Rule ID 3516 //
     /*  77799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2nn),
     /*  77807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77823 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10628:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2NN),
     /*  77847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77849 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77851 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77856 */     GIR_RootConstrainSelectedInstOperands,
     /*  77857 */     // GIR_Coverage, 3516,
     /*  77857 */     GIR_EraseRootFromParent_Done,
     /*  77858 */   // Label 1271: @77858
     /*  77858 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(77922), // Rule ID 3518 //
     /*  77863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2pp),
     /*  77871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77887 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10636:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2PP),
     /*  77911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77913 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77915 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77920 */     GIR_RootConstrainSelectedInstOperands,
     /*  77921 */     // GIR_Coverage, 3518,
     /*  77921 */     GIR_EraseRootFromParent_Done,
     /*  77922 */   // Label 1272: @77922
     /*  77922 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(77986), // Rule ID 3519 //
     /*  77927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2pn),
     /*  77935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77951 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10635:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2PN),
     /*  77975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77977 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77979 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77984 */     GIR_RootConstrainSelectedInstOperands,
     /*  77985 */     // GIR_Coverage, 3519,
     /*  77985 */     GIR_EraseRootFromParent_Done,
     /*  77986 */   // Label 1273: @77986
     /*  77986 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(78050), // Rule ID 3520 //
     /*  77991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2np),
     /*  77999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78015 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10634:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78027 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2NP),
     /*  78039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78041 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78043 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78048 */     GIR_RootConstrainSelectedInstOperands,
     /*  78049 */     // GIR_Coverage, 3520,
     /*  78049 */     GIR_EraseRootFromParent_Done,
     /*  78050 */   // Label 1274: @78050
     /*  78050 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(78114), // Rule ID 3521 //
     /*  78055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2nn),
     /*  78063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78079 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10633:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2NN),
     /*  78103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78105 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78107 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78112 */     GIR_RootConstrainSelectedInstOperands,
     /*  78113 */     // GIR_Coverage, 3521,
     /*  78113 */     GIR_EraseRootFromParent_Done,
     /*  78114 */   // Label 1275: @78114
     /*  78114 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(78200), // Rule ID 3536 //
     /*  78119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  78127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78143 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10711:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78155 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8PP),
     /*  78188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78190 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78198 */     GIR_RootConstrainSelectedInstOperands,
     /*  78199 */     // GIR_Coverage, 3536,
     /*  78199 */     GIR_EraseRootFromParent_Done,
     /*  78200 */   // Label 1276: @78200
     /*  78200 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(78286), // Rule ID 3538 //
     /*  78205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  78213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78229 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10713:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78229 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78232 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78236 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78241 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78245 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4PP),
     /*  78274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78276 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78284 */     GIR_RootConstrainSelectedInstOperands,
     /*  78285 */     // GIR_Coverage, 3538,
     /*  78285 */     GIR_EraseRootFromParent_Done,
     /*  78286 */   // Label 1277: @78286
     /*  78286 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(78372), // Rule ID 3540 //
     /*  78291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  78299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78315 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10709:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78315 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78318 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78322 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SPP),
     /*  78360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78362 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78370 */     GIR_RootConstrainSelectedInstOperands,
     /*  78371 */     // GIR_Coverage, 3540,
     /*  78371 */     GIR_EraseRootFromParent_Done,
     /*  78372 */   // Label 1278: @78372
     /*  78372 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(78458), // Rule ID 3542 //
     /*  78377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  78385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78401 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10711:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78413 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8WPP),
     /*  78446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78448 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78456 */     GIR_RootConstrainSelectedInstOperands,
     /*  78457 */     // GIR_Coverage, 3542,
     /*  78457 */     GIR_EraseRootFromParent_Done,
     /*  78458 */   // Label 1279: @78458
     /*  78458 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(78544), // Rule ID 3544 //
     /*  78463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  78471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78487 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10713:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78487 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78490 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78494 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78499 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78503 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78520 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WPP),
     /*  78532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78534 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78542 */     GIR_RootConstrainSelectedInstOperands,
     /*  78543 */     // GIR_Coverage, 3544,
     /*  78543 */     GIR_EraseRootFromParent_Done,
     /*  78544 */   // Label 1280: @78544
     /*  78544 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(78630), // Rule ID 3546 //
     /*  78549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  78557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78573 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10709:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78573 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78576 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78580 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78585 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SWPP),
     /*  78618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78620 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78628 */     GIR_RootConstrainSelectedInstOperands,
     /*  78629 */     // GIR_Coverage, 3546,
     /*  78629 */     GIR_EraseRootFromParent_Done,
     /*  78630 */   // Label 1281: @78630
     /*  78630 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(78716), // Rule ID 3548 //
     /*  78635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  78643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78659 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10695:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78671 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78675 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PP),
     /*  78704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78706 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78714 */     GIR_RootConstrainSelectedInstOperands,
     /*  78715 */     // GIR_Coverage, 3548,
     /*  78715 */     GIR_EraseRootFromParent_Done,
     /*  78716 */   // Label 1282: @78716
     /*  78716 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(78802), // Rule ID 3549 //
     /*  78721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  78729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78745 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10694:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78745 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78748 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78752 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78757 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78761 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PN),
     /*  78790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78792 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78800 */     GIR_RootConstrainSelectedInstOperands,
     /*  78801 */     // GIR_Coverage, 3549,
     /*  78801 */     GIR_EraseRootFromParent_Done,
     /*  78802 */   // Label 1283: @78802
     /*  78802 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(78888), // Rule ID 3550 //
     /*  78807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  78815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78831 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10693:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78843 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NP),
     /*  78876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78878 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78886 */     GIR_RootConstrainSelectedInstOperands,
     /*  78887 */     // GIR_Coverage, 3550,
     /*  78887 */     GIR_EraseRootFromParent_Done,
     /*  78888 */   // Label 1284: @78888
     /*  78888 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(78974), // Rule ID 3551 //
     /*  78893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  78901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78917 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10692:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78929 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NN),
     /*  78962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78964 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78972 */     GIR_RootConstrainSelectedInstOperands,
     /*  78973 */     // GIR_Coverage, 3551,
     /*  78973 */     GIR_EraseRootFromParent_Done,
     /*  78974 */   // Label 1285: @78974
     /*  78974 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(79060), // Rule ID 3553 //
     /*  78979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  78987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79003 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10695:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPP),
     /*  79048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79050 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79058 */     GIR_RootConstrainSelectedInstOperands,
     /*  79059 */     // GIR_Coverage, 3553,
     /*  79059 */     GIR_EraseRootFromParent_Done,
     /*  79060 */   // Label 1286: @79060
     /*  79060 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(79146), // Rule ID 3554 //
     /*  79065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  79073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79089 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10694:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79089 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79092 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79096 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79101 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPN),
     /*  79134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79136 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79144 */     GIR_RootConstrainSelectedInstOperands,
     /*  79145 */     // GIR_Coverage, 3554,
     /*  79145 */     GIR_EraseRootFromParent_Done,
     /*  79146 */   // Label 1287: @79146
     /*  79146 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(79232), // Rule ID 3555 //
     /*  79151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  79159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79175 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10693:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79175 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79178 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79182 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNP),
     /*  79220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79222 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79230 */     GIR_RootConstrainSelectedInstOperands,
     /*  79231 */     // GIR_Coverage, 3555,
     /*  79231 */     GIR_EraseRootFromParent_Done,
     /*  79232 */   // Label 1288: @79232
     /*  79232 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(79318), // Rule ID 3556 //
     /*  79237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  79245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79261 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10692:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79273 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNN),
     /*  79306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79308 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79316 */     GIR_RootConstrainSelectedInstOperands,
     /*  79317 */     // GIR_Coverage, 3556,
     /*  79317 */     GIR_EraseRootFromParent_Done,
     /*  79318 */   // Label 1289: @79318
     /*  79318 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(79404), // Rule ID 3558 //
     /*  79323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  79331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79347 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10700:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPP),
     /*  79392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79394 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79402 */     GIR_RootConstrainSelectedInstOperands,
     /*  79403 */     // GIR_Coverage, 3558,
     /*  79403 */     GIR_EraseRootFromParent_Done,
     /*  79404 */   // Label 1290: @79404
     /*  79404 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(79490), // Rule ID 3559 //
     /*  79409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  79417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79433 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10699:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79445 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPN),
     /*  79478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79480 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79488 */     GIR_RootConstrainSelectedInstOperands,
     /*  79489 */     // GIR_Coverage, 3559,
     /*  79489 */     GIR_EraseRootFromParent_Done,
     /*  79490 */   // Label 1291: @79490
     /*  79490 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(79576), // Rule ID 3560 //
     /*  79495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  79503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79519 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10698:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79531 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79535 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNP),
     /*  79564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79566 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79574 */     GIR_RootConstrainSelectedInstOperands,
     /*  79575 */     // GIR_Coverage, 3560,
     /*  79575 */     GIR_EraseRootFromParent_Done,
     /*  79576 */   // Label 1292: @79576
     /*  79576 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(79662), // Rule ID 3561 //
     /*  79581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  79589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79605 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10697:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79605 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79608 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79612 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79617 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79621 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNN),
     /*  79650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79652 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79660 */     GIR_RootConstrainSelectedInstOperands,
     /*  79661 */     // GIR_Coverage, 3561,
     /*  79661 */     GIR_EraseRootFromParent_Done,
     /*  79662 */   // Label 1293: @79662
     /*  79662 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(79726), // Rule ID 3563 //
     /*  79667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  79675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79691 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10705:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPP),
     /*  79715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79717 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79719 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79724 */     GIR_RootConstrainSelectedInstOperands,
     /*  79725 */     // GIR_Coverage, 3563,
     /*  79725 */     GIR_EraseRootFromParent_Done,
     /*  79726 */   // Label 1294: @79726
     /*  79726 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(79790), // Rule ID 3564 //
     /*  79731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  79739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79755 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10704:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPN),
     /*  79779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79781 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79783 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79788 */     GIR_RootConstrainSelectedInstOperands,
     /*  79789 */     // GIR_Coverage, 3564,
     /*  79789 */     GIR_EraseRootFromParent_Done,
     /*  79790 */   // Label 1295: @79790
     /*  79790 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(79854), // Rule ID 3565 //
     /*  79795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  79803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79819 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10703:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  79843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79845 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79847 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79852 */     GIR_RootConstrainSelectedInstOperands,
     /*  79853 */     // GIR_Coverage, 3565,
     /*  79853 */     GIR_EraseRootFromParent_Done,
     /*  79854 */   // Label 1296: @79854
     /*  79854 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(79918), // Rule ID 3566 //
     /*  79859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  79867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79883 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10702:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNN),
     /*  79907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79909 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79911 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79916 */     GIR_RootConstrainSelectedInstOperands,
     /*  79917 */     // GIR_Coverage, 3566,
     /*  79917 */     GIR_EraseRootFromParent_Done,
     /*  79918 */   // Label 1297: @79918
     /*  79918 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(80004), // Rule ID 3568 //
     /*  79923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  79931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79947 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10690:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79947 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79950 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79954 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PP),
     /*  79992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79994 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80002 */     GIR_RootConstrainSelectedInstOperands,
     /*  80003 */     // GIR_Coverage, 3568,
     /*  80003 */     GIR_EraseRootFromParent_Done,
     /*  80004 */   // Label 1298: @80004
     /*  80004 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(80090), // Rule ID 3569 //
     /*  80009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  80017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80033 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10689:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80033 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80036 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80040 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80045 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PN),
     /*  80078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80080 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80088 */     GIR_RootConstrainSelectedInstOperands,
     /*  80089 */     // GIR_Coverage, 3569,
     /*  80089 */     GIR_EraseRootFromParent_Done,
     /*  80090 */   // Label 1299: @80090
     /*  80090 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(80176), // Rule ID 3570 //
     /*  80095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  80103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80119 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10688:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80119 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80122 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80126 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80131 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NP),
     /*  80164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80166 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80174 */     GIR_RootConstrainSelectedInstOperands,
     /*  80175 */     // GIR_Coverage, 3570,
     /*  80175 */     GIR_EraseRootFromParent_Done,
     /*  80176 */   // Label 1300: @80176
     /*  80176 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(80262), // Rule ID 3571 //
     /*  80181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  80189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80205 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10687:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80205 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80208 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80212 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80217 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80221 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NN),
     /*  80250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80252 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80260 */     GIR_RootConstrainSelectedInstOperands,
     /*  80261 */     // GIR_Coverage, 3571,
     /*  80261 */     GIR_EraseRootFromParent_Done,
     /*  80262 */   // Label 1301: @80262
     /*  80262 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(80348), // Rule ID 3573 //
     /*  80267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  80275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80291 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10707:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80291 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80294 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80298 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80303 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80307 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2PP),
     /*  80336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80338 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80346 */     GIR_RootConstrainSelectedInstOperands,
     /*  80347 */     // GIR_Coverage, 3573,
     /*  80347 */     GIR_EraseRootFromParent_Done,
     /*  80348 */   // Label 1302: @80348
     /*  80348 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(80434), // Rule ID 3574 //
     /*  80353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  80361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80377 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10714:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80389 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4SPP),
     /*  80422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80424 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80432 */     GIR_RootConstrainSelectedInstOperands,
     /*  80433 */     // GIR_Coverage, 3574,
     /*  80433 */     GIR_EraseRootFromParent_Done,
     /*  80434 */   // Label 1303: @80434
     /*  80434 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(80520), // Rule ID 3576 //
     /*  80439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  80447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80463 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10700:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80463 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80466 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80470 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80475 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80479 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPP),
     /*  80508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80510 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80518 */     GIR_RootConstrainSelectedInstOperands,
     /*  80519 */     // GIR_Coverage, 3576,
     /*  80519 */     GIR_EraseRootFromParent_Done,
     /*  80520 */   // Label 1304: @80520
     /*  80520 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(80606), // Rule ID 3577 //
     /*  80525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  80533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80549 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10699:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80549 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80552 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80556 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80561 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPN),
     /*  80594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80596 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80604 */     GIR_RootConstrainSelectedInstOperands,
     /*  80605 */     // GIR_Coverage, 3577,
     /*  80605 */     GIR_EraseRootFromParent_Done,
     /*  80606 */   // Label 1305: @80606
     /*  80606 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(80692), // Rule ID 3578 //
     /*  80611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  80619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80635 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10698:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80651 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNP),
     /*  80680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80682 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80690 */     GIR_RootConstrainSelectedInstOperands,
     /*  80691 */     // GIR_Coverage, 3578,
     /*  80691 */     GIR_EraseRootFromParent_Done,
     /*  80692 */   // Label 1306: @80692
     /*  80692 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(80778), // Rule ID 3579 //
     /*  80697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  80705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80721 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10697:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80721 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80724 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80728 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80737 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNN),
     /*  80766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80768 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80776 */     GIR_RootConstrainSelectedInstOperands,
     /*  80777 */     // GIR_Coverage, 3579,
     /*  80777 */     GIR_EraseRootFromParent_Done,
     /*  80778 */   // Label 1307: @80778
     /*  80778 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(80842), // Rule ID 3581 //
     /*  80783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  80791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80807 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10705:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80819 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPP),
     /*  80831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80833 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80835 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80840 */     GIR_RootConstrainSelectedInstOperands,
     /*  80841 */     // GIR_Coverage, 3581,
     /*  80841 */     GIR_EraseRootFromParent_Done,
     /*  80842 */   // Label 1308: @80842
     /*  80842 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(80906), // Rule ID 3582 //
     /*  80847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  80855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80871 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10704:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPN),
     /*  80895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80897 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80899 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80904 */     GIR_RootConstrainSelectedInstOperands,
     /*  80905 */     // GIR_Coverage, 3582,
     /*  80905 */     GIR_EraseRootFromParent_Done,
     /*  80906 */   // Label 1309: @80906
     /*  80906 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(80970), // Rule ID 3583 //
     /*  80911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  80919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80935 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10703:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  80959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80961 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80963 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80968 */     GIR_RootConstrainSelectedInstOperands,
     /*  80969 */     // GIR_Coverage, 3583,
     /*  80969 */     GIR_EraseRootFromParent_Done,
     /*  80970 */   // Label 1310: @80970
     /*  80970 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(81034), // Rule ID 3584 //
     /*  80975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  80983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80999 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10702:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81011 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWNN),
     /*  81023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81025 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81027 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81032 */     GIR_RootConstrainSelectedInstOperands,
     /*  81033 */     // GIR_Coverage, 3584,
     /*  81033 */     GIR_EraseRootFromParent_Done,
     /*  81034 */   // Label 1311: @81034
     /*  81034 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(81120), // Rule ID 3586 //
     /*  81039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  81047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81063 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10690:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81079 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPP),
     /*  81108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81110 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81118 */     GIR_RootConstrainSelectedInstOperands,
     /*  81119 */     // GIR_Coverage, 3586,
     /*  81119 */     GIR_EraseRootFromParent_Done,
     /*  81120 */   // Label 1312: @81120
     /*  81120 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(81206), // Rule ID 3587 //
     /*  81125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  81133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81149 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10689:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81161 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPN),
     /*  81194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81196 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81204 */     GIR_RootConstrainSelectedInstOperands,
     /*  81205 */     // GIR_Coverage, 3587,
     /*  81205 */     GIR_EraseRootFromParent_Done,
     /*  81206 */   // Label 1313: @81206
     /*  81206 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(81292), // Rule ID 3588 //
     /*  81211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  81219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81235 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10688:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81251 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNP),
     /*  81280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81282 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81290 */     GIR_RootConstrainSelectedInstOperands,
     /*  81291 */     // GIR_Coverage, 3588,
     /*  81291 */     GIR_EraseRootFromParent_Done,
     /*  81292 */   // Label 1314: @81292
     /*  81292 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(81378), // Rule ID 3589 //
     /*  81297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  81305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81321 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10687:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81333 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNN),
     /*  81366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81368 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81376 */     GIR_RootConstrainSelectedInstOperands,
     /*  81377 */     // GIR_Coverage, 3589,
     /*  81377 */     GIR_EraseRootFromParent_Done,
     /*  81378 */   // Label 1315: @81378
     /*  81378 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(81464), // Rule ID 3591 //
     /*  81383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  81391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81407 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10707:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2WPP),
     /*  81452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81454 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81462 */     GIR_RootConstrainSelectedInstOperands,
     /*  81463 */     // GIR_Coverage, 3591,
     /*  81463 */     GIR_EraseRootFromParent_Done,
     /*  81464 */   // Label 1316: @81464
     /*  81464 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(81550), // Rule ID 3592 //
     /*  81469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  81477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81493 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10714:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81493 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81496 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81500 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81505 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81509 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WSPP),
     /*  81538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81540 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81548 */     GIR_RootConstrainSelectedInstOperands,
     /*  81549 */     // GIR_Coverage, 3592,
     /*  81549 */     GIR_EraseRootFromParent_Done,
     /*  81550 */   // Label 1317: @81550
     /*  81550 */   GIM_Reject,
     /*  81551 */ // Label 1195: @81551
     /*  81551 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(82175),
     /*  81556 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  81559 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(81678), // Rule ID 3604 //
     /*  81564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  81572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81603 */     // MIs[1] Operand 1
     /*  81603 */     // No operand predicates
     /*  81603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81611 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81615 */     // MIs[2] Operand 1
     /*  81615 */     // No operand predicates
     /*  81615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81617 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10667:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  81617 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81620 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81624 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81629 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81633 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GER),
     /*  81662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81676 */     GIR_RootConstrainSelectedInstOperands,
     /*  81677 */     // GIR_Coverage, 3604,
     /*  81677 */     GIR_EraseRootFromParent_Done,
     /*  81678 */   // Label 1319: @81678
     /*  81678 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(81775), // Rule ID 3609 //
     /*  81683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  81691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  81697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81722 */     // MIs[1] Operand 1
     /*  81722 */     // No operand predicates
     /*  81722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81730 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81734 */     // MIs[2] Operand 1
     /*  81734 */     // No operand predicates
     /*  81734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81736 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10672:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  81736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GER),
     /*  81760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81762 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  81764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81773 */     GIR_RootConstrainSelectedInstOperands,
     /*  81774 */     // GIR_Coverage, 3609,
     /*  81774 */     GIR_EraseRootFromParent_Done,
     /*  81775 */   // Label 1320: @81775
     /*  81775 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(81894), // Rule ID 3633 //
     /*  81780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  81783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  81788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81819 */     // MIs[1] Operand 1
     /*  81819 */     // No operand predicates
     /*  81819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81831 */     // MIs[2] Operand 1
     /*  81831 */     // No operand predicates
     /*  81831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81833 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10667:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  81833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81836 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81840 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81845 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERW),
     /*  81878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81892 */     GIR_RootConstrainSelectedInstOperands,
     /*  81893 */     // GIR_Coverage, 3633,
     /*  81893 */     GIR_EraseRootFromParent_Done,
     /*  81894 */   // Label 1321: @81894
     /*  81894 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(81991), // Rule ID 3638 //
     /*  81899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  81902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  81907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  81913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81938 */     // MIs[1] Operand 1
     /*  81938 */     // No operand predicates
     /*  81938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81946 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81950 */     // MIs[2] Operand 1
     /*  81950 */     // No operand predicates
     /*  81950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81952 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10672:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  81952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERW),
     /*  81976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81978 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  81980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81989 */     GIR_RootConstrainSelectedInstOperands,
     /*  81990 */     // GIR_Coverage, 3638,
     /*  81990 */     GIR_EraseRootFromParent_Done,
     /*  81991 */   // Label 1322: @81991
     /*  81991 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(82038), // Rule ID 1113 //
     /*  81996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  81999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxeval),
     /*  82004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  82007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  82013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  82016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82020 */     // MIs[0] IMM
     /*  82020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  82023 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10852:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)  =>  (XXEVAL:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)
     /*  82023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  82026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  82028 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  82030 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  82032 */     GIR_RootToRootCopy, /*OpIdx*/4, // XC
     /*  82034 */     GIR_RootToRootCopy, /*OpIdx*/5, // IMM
     /*  82036 */     GIR_RootConstrainSelectedInstOperands,
     /*  82037 */     // GIR_Coverage, 1113,
     /*  82037 */     GIR_EraseRootFromParent_Done,
     /*  82038 */   // Label 1323: @82038
     /*  82038 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(82174), // Rule ID 3424 //
     /*  82043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  82046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxpermx),
     /*  82051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  82054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  82063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82067 */     // MIs[0] D
     /*  82067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  82070 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10860:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C, (timm:{ *:[i32] }):$D)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXPERMX:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] }), ?:{ *:[i32] }:$D), VSRC:{ *:[i32] })
     /*  82070 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  82073 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82077 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82082 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  82086 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82091 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  82094 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82098 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82103 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  82107 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82112 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82115 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82119 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82124 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  82128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMX),
     /*  82140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82145 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  82151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  82154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // D
     /*  82158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82173 */     // GIR_Coverage, 3424,
     /*  82173 */     GIR_EraseRootFromParent_Done,
     /*  82174 */   // Label 1324: @82174
     /*  82174 */   GIM_Reject,
     /*  82175 */ // Label 1318: @82175
     /*  82175 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(85981),
     /*  82180 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  82183 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(82298), // Rule ID 3522 //
     /*  82188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4),
     /*  82196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82230 */     // MIs[1] Operand 1
     /*  82230 */     // No operand predicates
     /*  82230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82242 */     // MIs[2] Operand 1
     /*  82242 */     // No operand predicates
     /*  82242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82250 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82254 */     // MIs[3] Operand 1
     /*  82254 */     // No operand predicates
     /*  82254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82256 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10654:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  82256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4),
     /*  82280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82282 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82296 */     GIR_RootConstrainSelectedInstOperands,
     /*  82297 */     // GIR_Coverage, 3522,
     /*  82297 */     GIR_EraseRootFromParent_Done,
     /*  82298 */   // Label 1326: @82298
     /*  82298 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(82413), // Rule ID 3525 //
     /*  82303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2),
     /*  82311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82345 */     // MIs[1] Operand 1
     /*  82345 */     // No operand predicates
     /*  82345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82353 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82357 */     // MIs[2] Operand 1
     /*  82357 */     // No operand predicates
     /*  82357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82365 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82369 */     // MIs[3] Operand 1
     /*  82369 */     // No operand predicates
     /*  82369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82371 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10644:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82383 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2),
     /*  82395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82397 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82411 */     GIR_RootConstrainSelectedInstOperands,
     /*  82412 */     // GIR_Coverage, 3525,
     /*  82412 */     GIR_EraseRootFromParent_Done,
     /*  82413 */   // Label 1327: @82413
     /*  82413 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(82528), // Rule ID 3530 //
     /*  82418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2),
     /*  82426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82460 */     // MIs[1] Operand 1
     /*  82460 */     // No operand predicates
     /*  82460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82468 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82472 */     // MIs[2] Operand 1
     /*  82472 */     // No operand predicates
     /*  82472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82480 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82484 */     // MIs[3] Operand 1
     /*  82484 */     // No operand predicates
     /*  82484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82486 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10649:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2),
     /*  82510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82512 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82526 */     GIR_RootConstrainSelectedInstOperands,
     /*  82527 */     // GIR_Coverage, 3530,
     /*  82527 */     GIR_EraseRootFromParent_Done,
     /*  82528 */   // Label 1328: @82528
     /*  82528 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(82665), // Rule ID 3593 //
     /*  82533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  82541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82575 */     // MIs[1] Operand 1
     /*  82575 */     // No operand predicates
     /*  82575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82587 */     // MIs[2] Operand 1
     /*  82587 */     // No operand predicates
     /*  82587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82595 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82599 */     // MIs[3] Operand 1
     /*  82599 */     // No operand predicates
     /*  82599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82601 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10681:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  82601 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82604 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82608 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82613 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8),
     /*  82646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82663 */     GIR_RootConstrainSelectedInstOperands,
     /*  82664 */     // GIR_Coverage, 3593,
     /*  82664 */     GIR_EraseRootFromParent_Done,
     /*  82665 */   // Label 1329: @82665
     /*  82665 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(82802), // Rule ID 3595 //
     /*  82670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  82678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82712 */     // MIs[1] Operand 1
     /*  82712 */     // No operand predicates
     /*  82712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82724 */     // MIs[2] Operand 1
     /*  82724 */     // No operand predicates
     /*  82724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82732 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82736 */     // MIs[3] Operand 1
     /*  82736 */     // No operand predicates
     /*  82736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82738 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10683:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  82738 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82741 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82745 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4),
     /*  82783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82800 */     GIR_RootConstrainSelectedInstOperands,
     /*  82801 */     // GIR_Coverage, 3595,
     /*  82801 */     GIR_EraseRootFromParent_Done,
     /*  82802 */   // Label 1330: @82802
     /*  82802 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(82939), // Rule ID 3597 //
     /*  82807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  82815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82849 */     // MIs[1] Operand 1
     /*  82849 */     // No operand predicates
     /*  82849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82857 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82861 */     // MIs[2] Operand 1
     /*  82861 */     // No operand predicates
     /*  82861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82869 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82873 */     // MIs[3] Operand 1
     /*  82873 */     // No operand predicates
     /*  82873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82875 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10679:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82875 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82878 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82882 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82891 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2S),
     /*  82920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82937 */     GIR_RootConstrainSelectedInstOperands,
     /*  82938 */     // GIR_Coverage, 3597,
     /*  82938 */     GIR_EraseRootFromParent_Done,
     /*  82939 */   // Label 1331: @82939
     /*  82939 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(83076), // Rule ID 3599 //
     /*  82944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  82952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82986 */     // MIs[1] Operand 1
     /*  82986 */     // No operand predicates
     /*  82986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82994 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82998 */     // MIs[2] Operand 1
     /*  82998 */     // No operand predicates
     /*  82998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83006 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83010 */     // MIs[3] Operand 1
     /*  83010 */     // No operand predicates
     /*  83010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83012 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10662:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83012 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83015 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83019 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83024 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83028 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83045 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2),
     /*  83057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83074 */     GIR_RootConstrainSelectedInstOperands,
     /*  83075 */     // GIR_Coverage, 3599,
     /*  83075 */     GIR_EraseRootFromParent_Done,
     /*  83076 */   // Label 1332: @83076
     /*  83076 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(83213), // Rule ID 3614 //
     /*  83081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  83089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83123 */     // MIs[1] Operand 1
     /*  83123 */     // No operand predicates
     /*  83123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83131 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83135 */     // MIs[2] Operand 1
     /*  83135 */     // No operand predicates
     /*  83135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83147 */     // MIs[3] Operand 1
     /*  83147 */     // No operand predicates
     /*  83147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83149 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10657:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83161 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2),
     /*  83194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83211 */     GIR_RootConstrainSelectedInstOperands,
     /*  83212 */     // GIR_Coverage, 3614,
     /*  83212 */     GIR_EraseRootFromParent_Done,
     /*  83213 */   // Label 1333: @83213
     /*  83213 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(83350), // Rule ID 3619 //
     /*  83218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  83226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83260 */     // MIs[1] Operand 1
     /*  83260 */     // No operand predicates
     /*  83260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83268 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83272 */     // MIs[2] Operand 1
     /*  83272 */     // No operand predicates
     /*  83272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83280 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83284 */     // MIs[3] Operand 1
     /*  83284 */     // No operand predicates
     /*  83284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83286 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10677:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83302 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83319 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2),
     /*  83331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83348 */     GIR_RootConstrainSelectedInstOperands,
     /*  83349 */     // GIR_Coverage, 3619,
     /*  83349 */     GIR_EraseRootFromParent_Done,
     /*  83350 */   // Label 1334: @83350
     /*  83350 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(83487), // Rule ID 3622 //
     /*  83355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  83363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83397 */     // MIs[1] Operand 1
     /*  83397 */     // No operand predicates
     /*  83397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83405 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83409 */     // MIs[2] Operand 1
     /*  83409 */     // No operand predicates
     /*  83409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83417 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  83421 */     // MIs[3] Operand 1
     /*  83421 */     // No operand predicates
     /*  83421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83423 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10681:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  83423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83435 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8W),
     /*  83468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83485 */     GIR_RootConstrainSelectedInstOperands,
     /*  83486 */     // GIR_Coverage, 3622,
     /*  83486 */     GIR_EraseRootFromParent_Done,
     /*  83487 */   // Label 1335: @83487
     /*  83487 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(83624), // Rule ID 3624 //
     /*  83492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  83500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83534 */     // MIs[1] Operand 1
     /*  83534 */     // No operand predicates
     /*  83534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83542 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83546 */     // MIs[2] Operand 1
     /*  83546 */     // No operand predicates
     /*  83546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83554 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83558 */     // MIs[3] Operand 1
     /*  83558 */     // No operand predicates
     /*  83558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83560 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10683:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  83560 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83563 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83567 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83572 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4W),
     /*  83605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83622 */     GIR_RootConstrainSelectedInstOperands,
     /*  83623 */     // GIR_Coverage, 3624,
     /*  83623 */     GIR_EraseRootFromParent_Done,
     /*  83624 */   // Label 1336: @83624
     /*  83624 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(83761), // Rule ID 3626 //
     /*  83629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  83637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83671 */     // MIs[1] Operand 1
     /*  83671 */     // No operand predicates
     /*  83671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83679 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83683 */     // MIs[2] Operand 1
     /*  83683 */     // No operand predicates
     /*  83683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83695 */     // MIs[3] Operand 1
     /*  83695 */     // No operand predicates
     /*  83695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83697 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10679:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83709 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SW),
     /*  83742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83759 */     GIR_RootConstrainSelectedInstOperands,
     /*  83760 */     // GIR_Coverage, 3626,
     /*  83760 */     GIR_EraseRootFromParent_Done,
     /*  83761 */   // Label 1337: @83761
     /*  83761 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(83898), // Rule ID 3628 //
     /*  83766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  83774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83808 */     // MIs[1] Operand 1
     /*  83808 */     // No operand predicates
     /*  83808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83816 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83820 */     // MIs[2] Operand 1
     /*  83820 */     // No operand predicates
     /*  83820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83828 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83832 */     // MIs[3] Operand 1
     /*  83832 */     // No operand predicates
     /*  83832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83834 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10662:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83846 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83850 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2W),
     /*  83879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83896 */     GIR_RootConstrainSelectedInstOperands,
     /*  83897 */     // GIR_Coverage, 3628,
     /*  83897 */     GIR_EraseRootFromParent_Done,
     /*  83898 */   // Label 1338: @83898
     /*  83898 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(84035), // Rule ID 3643 //
     /*  83903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  83911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83945 */     // MIs[1] Operand 1
     /*  83945 */     // No operand predicates
     /*  83945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83953 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83957 */     // MIs[2] Operand 1
     /*  83957 */     // No operand predicates
     /*  83957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83965 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83969 */     // MIs[3] Operand 1
     /*  83969 */     // No operand predicates
     /*  83969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83971 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10657:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2W),
     /*  84016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84033 */     GIR_RootConstrainSelectedInstOperands,
     /*  84034 */     // GIR_Coverage, 3643,
     /*  84034 */     GIR_EraseRootFromParent_Done,
     /*  84035 */   // Label 1339: @84035
     /*  84035 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(84172), // Rule ID 3648 //
     /*  84040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  84048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  84074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84082 */     // MIs[1] Operand 1
     /*  84082 */     // No operand predicates
     /*  84082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  84086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84090 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84094 */     // MIs[2] Operand 1
     /*  84094 */     // No operand predicates
     /*  84094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  84098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84102 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84106 */     // MIs[3] Operand 1
     /*  84106 */     // No operand predicates
     /*  84106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84108 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10677:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  84108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84120 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2W),
     /*  84153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84170 */     GIR_RootConstrainSelectedInstOperands,
     /*  84171 */     // GIR_Coverage, 3648,
     /*  84171 */     GIR_EraseRootFromParent_Done,
     /*  84172 */   // Label 1340: @84172
     /*  84172 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(84296), // Rule ID 3605 //
     /*  84177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  84185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84219 */     // MIs[1] Operand 1
     /*  84219 */     // No operand predicates
     /*  84219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84227 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84231 */     // MIs[2] Operand 1
     /*  84231 */     // No operand predicates
     /*  84231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84233 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10671:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84233 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84236 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84240 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84245 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84249 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPP),
     /*  84278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84280 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84294 */     GIR_RootConstrainSelectedInstOperands,
     /*  84295 */     // GIR_Coverage, 3605,
     /*  84295 */     GIR_EraseRootFromParent_Done,
     /*  84296 */   // Label 1341: @84296
     /*  84296 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(84420), // Rule ID 3606 //
     /*  84301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  84309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84343 */     // MIs[1] Operand 1
     /*  84343 */     // No operand predicates
     /*  84343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84351 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84355 */     // MIs[2] Operand 1
     /*  84355 */     // No operand predicates
     /*  84355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84357 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10670:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84369 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPN),
     /*  84402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84404 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84418 */     GIR_RootConstrainSelectedInstOperands,
     /*  84419 */     // GIR_Coverage, 3606,
     /*  84419 */     GIR_EraseRootFromParent_Done,
     /*  84420 */   // Label 1342: @84420
     /*  84420 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(84544), // Rule ID 3607 //
     /*  84425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  84433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84467 */     // MIs[1] Operand 1
     /*  84467 */     // No operand predicates
     /*  84467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84479 */     // MIs[2] Operand 1
     /*  84479 */     // No operand predicates
     /*  84479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84481 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10669:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84481 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84484 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84488 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNP),
     /*  84526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84528 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84542 */     GIR_RootConstrainSelectedInstOperands,
     /*  84543 */     // GIR_Coverage, 3607,
     /*  84543 */     GIR_EraseRootFromParent_Done,
     /*  84544 */   // Label 1343: @84544
     /*  84544 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(84668), // Rule ID 3608 //
     /*  84549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  84557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84591 */     // MIs[1] Operand 1
     /*  84591 */     // No operand predicates
     /*  84591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84599 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84603 */     // MIs[2] Operand 1
     /*  84603 */     // No operand predicates
     /*  84603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84605 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10668:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84605 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84608 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84612 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84617 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84621 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNN),
     /*  84650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84652 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84666 */     GIR_RootConstrainSelectedInstOperands,
     /*  84667 */     // GIR_Coverage, 3608,
     /*  84667 */     GIR_EraseRootFromParent_Done,
     /*  84668 */   // Label 1344: @84668
     /*  84668 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(84770), // Rule ID 3610 //
     /*  84673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  84681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84715 */     // MIs[1] Operand 1
     /*  84715 */     // No operand predicates
     /*  84715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84723 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84727 */     // MIs[2] Operand 1
     /*  84727 */     // No operand predicates
     /*  84727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84729 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10676:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPP),
     /*  84753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84755 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84757 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84768 */     GIR_RootConstrainSelectedInstOperands,
     /*  84769 */     // GIR_Coverage, 3610,
     /*  84769 */     GIR_EraseRootFromParent_Done,
     /*  84770 */   // Label 1345: @84770
     /*  84770 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(84872), // Rule ID 3611 //
     /*  84775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  84783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84817 */     // MIs[1] Operand 1
     /*  84817 */     // No operand predicates
     /*  84817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84829 */     // MIs[2] Operand 1
     /*  84829 */     // No operand predicates
     /*  84829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84831 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10675:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPN),
     /*  84855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84857 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84859 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84870 */     GIR_RootConstrainSelectedInstOperands,
     /*  84871 */     // GIR_Coverage, 3611,
     /*  84871 */     GIR_EraseRootFromParent_Done,
     /*  84872 */   // Label 1346: @84872
     /*  84872 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(84974), // Rule ID 3612 //
     /*  84877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  84885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84919 */     // MIs[1] Operand 1
     /*  84919 */     // No operand predicates
     /*  84919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84927 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84931 */     // MIs[2] Operand 1
     /*  84931 */     // No operand predicates
     /*  84931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84933 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10674:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNP),
     /*  84957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84959 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84961 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84972 */     GIR_RootConstrainSelectedInstOperands,
     /*  84973 */     // GIR_Coverage, 3612,
     /*  84973 */     GIR_EraseRootFromParent_Done,
     /*  84974 */   // Label 1347: @84974
     /*  84974 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(85076), // Rule ID 3613 //
     /*  84979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  84987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85021 */     // MIs[1] Operand 1
     /*  85021 */     // No operand predicates
     /*  85021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85029 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85033 */     // MIs[2] Operand 1
     /*  85033 */     // No operand predicates
     /*  85033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85035 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10673:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNN),
     /*  85059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85061 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85063 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85074 */     GIR_RootConstrainSelectedInstOperands,
     /*  85075 */     // GIR_Coverage, 3613,
     /*  85075 */     GIR_EraseRootFromParent_Done,
     /*  85076 */   // Label 1348: @85076
     /*  85076 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(85200), // Rule ID 3634 //
     /*  85081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  85089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85123 */     // MIs[1] Operand 1
     /*  85123 */     // No operand predicates
     /*  85123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85131 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85135 */     // MIs[2] Operand 1
     /*  85135 */     // No operand predicates
     /*  85135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85137 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10671:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85149 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPP),
     /*  85182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85184 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85198 */     GIR_RootConstrainSelectedInstOperands,
     /*  85199 */     // GIR_Coverage, 3634,
     /*  85199 */     GIR_EraseRootFromParent_Done,
     /*  85200 */   // Label 1349: @85200
     /*  85200 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(85324), // Rule ID 3635 //
     /*  85205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  85213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85247 */     // MIs[1] Operand 1
     /*  85247 */     // No operand predicates
     /*  85247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85255 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85259 */     // MIs[2] Operand 1
     /*  85259 */     // No operand predicates
     /*  85259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85261 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10670:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85273 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPN),
     /*  85306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85308 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85322 */     GIR_RootConstrainSelectedInstOperands,
     /*  85323 */     // GIR_Coverage, 3635,
     /*  85323 */     GIR_EraseRootFromParent_Done,
     /*  85324 */   // Label 1350: @85324
     /*  85324 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(85448), // Rule ID 3636 //
     /*  85329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  85337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85371 */     // MIs[1] Operand 1
     /*  85371 */     // No operand predicates
     /*  85371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85383 */     // MIs[2] Operand 1
     /*  85383 */     // No operand predicates
     /*  85383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85385 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10669:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85397 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85401 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNP),
     /*  85430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85432 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85446 */     GIR_RootConstrainSelectedInstOperands,
     /*  85447 */     // GIR_Coverage, 3636,
     /*  85447 */     GIR_EraseRootFromParent_Done,
     /*  85448 */   // Label 1351: @85448
     /*  85448 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(85572), // Rule ID 3637 //
     /*  85453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  85461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85495 */     // MIs[1] Operand 1
     /*  85495 */     // No operand predicates
     /*  85495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85503 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85507 */     // MIs[2] Operand 1
     /*  85507 */     // No operand predicates
     /*  85507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85509 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10668:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85509 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85512 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85516 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85525 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNN),
     /*  85554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85556 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85570 */     GIR_RootConstrainSelectedInstOperands,
     /*  85571 */     // GIR_Coverage, 3637,
     /*  85571 */     GIR_EraseRootFromParent_Done,
     /*  85572 */   // Label 1352: @85572
     /*  85572 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(85674), // Rule ID 3639 //
     /*  85577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  85585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85619 */     // MIs[1] Operand 1
     /*  85619 */     // No operand predicates
     /*  85619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85627 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85631 */     // MIs[2] Operand 1
     /*  85631 */     // No operand predicates
     /*  85631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85633 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10676:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPP),
     /*  85657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85659 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85661 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85672 */     GIR_RootConstrainSelectedInstOperands,
     /*  85673 */     // GIR_Coverage, 3639,
     /*  85673 */     GIR_EraseRootFromParent_Done,
     /*  85674 */   // Label 1353: @85674
     /*  85674 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(85776), // Rule ID 3640 //
     /*  85679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  85687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85721 */     // MIs[1] Operand 1
     /*  85721 */     // No operand predicates
     /*  85721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85733 */     // MIs[2] Operand 1
     /*  85733 */     // No operand predicates
     /*  85733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85735 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10675:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPN),
     /*  85759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85761 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85763 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85774 */     GIR_RootConstrainSelectedInstOperands,
     /*  85775 */     // GIR_Coverage, 3640,
     /*  85775 */     GIR_EraseRootFromParent_Done,
     /*  85776 */   // Label 1354: @85776
     /*  85776 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(85878), // Rule ID 3641 //
     /*  85781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  85789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85823 */     // MIs[1] Operand 1
     /*  85823 */     // No operand predicates
     /*  85823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85831 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85835 */     // MIs[2] Operand 1
     /*  85835 */     // No operand predicates
     /*  85835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85837 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10674:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNP),
     /*  85861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85863 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85865 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85876 */     GIR_RootConstrainSelectedInstOperands,
     /*  85877 */     // GIR_Coverage, 3641,
     /*  85877 */     GIR_EraseRootFromParent_Done,
     /*  85878 */   // Label 1355: @85878
     /*  85878 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(85980), // Rule ID 3642 //
     /*  85883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  85891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85925 */     // MIs[1] Operand 1
     /*  85925 */     // No operand predicates
     /*  85925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85937 */     // MIs[2] Operand 1
     /*  85937 */     // No operand predicates
     /*  85937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85939 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10673:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85951 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNN),
     /*  85963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85965 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85967 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85978 */     GIR_RootConstrainSelectedInstOperands,
     /*  85979 */     // GIR_Coverage, 3642,
     /*  85979 */     GIR_EraseRootFromParent_Done,
     /*  85980 */   // Label 1356: @85980
     /*  85980 */   GIM_Reject,
     /*  85981 */ // Label 1325: @85981
     /*  85981 */ GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(90882),
     /*  85986 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  85989 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(86109), // Rule ID 3523 //
     /*  85994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4pp),
     /*  86002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86039 */     // MIs[1] Operand 1
     /*  86039 */     // No operand predicates
     /*  86039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86047 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86051 */     // MIs[2] Operand 1
     /*  86051 */     // No operand predicates
     /*  86051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86059 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86063 */     // MIs[3] Operand 1
     /*  86063 */     // No operand predicates
     /*  86063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86065 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10655:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  86065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4PP),
     /*  86089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86091 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86093 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86107 */     GIR_RootConstrainSelectedInstOperands,
     /*  86108 */     // GIR_Coverage, 3523,
     /*  86108 */     GIR_EraseRootFromParent_Done,
     /*  86109 */   // Label 1358: @86109
     /*  86109 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(86229), // Rule ID 3524 //
     /*  86114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4spp),
     /*  86122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86159 */     // MIs[1] Operand 1
     /*  86159 */     // No operand predicates
     /*  86159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86167 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86171 */     // MIs[2] Operand 1
     /*  86171 */     // No operand predicates
     /*  86171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86179 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86183 */     // MIs[3] Operand 1
     /*  86183 */     // No operand predicates
     /*  86183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86185 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10656:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4SPP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  86185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4SPP),
     /*  86209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86211 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86213 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86227 */     GIR_RootConstrainSelectedInstOperands,
     /*  86228 */     // GIR_Coverage, 3524,
     /*  86228 */     GIR_EraseRootFromParent_Done,
     /*  86229 */   // Label 1359: @86229
     /*  86229 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(86349), // Rule ID 3526 //
     /*  86234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2pp),
     /*  86242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86279 */     // MIs[1] Operand 1
     /*  86279 */     // No operand predicates
     /*  86279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86287 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86291 */     // MIs[2] Operand 1
     /*  86291 */     // No operand predicates
     /*  86291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86299 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86303 */     // MIs[3] Operand 1
     /*  86303 */     // No operand predicates
     /*  86303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86305 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10648:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2PP),
     /*  86329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86331 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86333 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86347 */     GIR_RootConstrainSelectedInstOperands,
     /*  86348 */     // GIR_Coverage, 3526,
     /*  86348 */     GIR_EraseRootFromParent_Done,
     /*  86349 */   // Label 1360: @86349
     /*  86349 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(86469), // Rule ID 3527 //
     /*  86354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2pn),
     /*  86362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86399 */     // MIs[1] Operand 1
     /*  86399 */     // No operand predicates
     /*  86399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86407 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86411 */     // MIs[2] Operand 1
     /*  86411 */     // No operand predicates
     /*  86411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86419 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86423 */     // MIs[3] Operand 1
     /*  86423 */     // No operand predicates
     /*  86423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86425 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10647:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86437 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2PN),
     /*  86449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86451 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86453 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86467 */     GIR_RootConstrainSelectedInstOperands,
     /*  86468 */     // GIR_Coverage, 3527,
     /*  86468 */     GIR_EraseRootFromParent_Done,
     /*  86469 */   // Label 1361: @86469
     /*  86469 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(86589), // Rule ID 3528 //
     /*  86474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2np),
     /*  86482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86519 */     // MIs[1] Operand 1
     /*  86519 */     // No operand predicates
     /*  86519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86527 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86531 */     // MIs[2] Operand 1
     /*  86531 */     // No operand predicates
     /*  86531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86539 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86543 */     // MIs[3] Operand 1
     /*  86543 */     // No operand predicates
     /*  86543 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86545 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10646:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86557 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2NP),
     /*  86569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86571 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86573 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86587 */     GIR_RootConstrainSelectedInstOperands,
     /*  86588 */     // GIR_Coverage, 3528,
     /*  86588 */     GIR_EraseRootFromParent_Done,
     /*  86589 */   // Label 1362: @86589
     /*  86589 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(86709), // Rule ID 3529 //
     /*  86594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2nn),
     /*  86602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86639 */     // MIs[1] Operand 1
     /*  86639 */     // No operand predicates
     /*  86639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86647 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86651 */     // MIs[2] Operand 1
     /*  86651 */     // No operand predicates
     /*  86651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86659 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86663 */     // MIs[3] Operand 1
     /*  86663 */     // No operand predicates
     /*  86663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86665 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10645:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2NN),
     /*  86689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86691 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86693 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86707 */     GIR_RootConstrainSelectedInstOperands,
     /*  86708 */     // GIR_Coverage, 3529,
     /*  86708 */     GIR_EraseRootFromParent_Done,
     /*  86709 */   // Label 1363: @86709
     /*  86709 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(86829), // Rule ID 3531 //
     /*  86714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2pp),
     /*  86722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86759 */     // MIs[1] Operand 1
     /*  86759 */     // No operand predicates
     /*  86759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86767 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86771 */     // MIs[2] Operand 1
     /*  86771 */     // No operand predicates
     /*  86771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86779 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86783 */     // MIs[3] Operand 1
     /*  86783 */     // No operand predicates
     /*  86783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86785 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10653:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2PP),
     /*  86809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86811 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86813 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86827 */     GIR_RootConstrainSelectedInstOperands,
     /*  86828 */     // GIR_Coverage, 3531,
     /*  86828 */     GIR_EraseRootFromParent_Done,
     /*  86829 */   // Label 1364: @86829
     /*  86829 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(86949), // Rule ID 3532 //
     /*  86834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2pn),
     /*  86842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86879 */     // MIs[1] Operand 1
     /*  86879 */     // No operand predicates
     /*  86879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86887 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86891 */     // MIs[2] Operand 1
     /*  86891 */     // No operand predicates
     /*  86891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86899 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86903 */     // MIs[3] Operand 1
     /*  86903 */     // No operand predicates
     /*  86903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86905 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10652:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2PN),
     /*  86929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86931 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86933 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86947 */     GIR_RootConstrainSelectedInstOperands,
     /*  86948 */     // GIR_Coverage, 3532,
     /*  86948 */     GIR_EraseRootFromParent_Done,
     /*  86949 */   // Label 1365: @86949
     /*  86949 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(87069), // Rule ID 3533 //
     /*  86954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2np),
     /*  86962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86999 */     // MIs[1] Operand 1
     /*  86999 */     // No operand predicates
     /*  86999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87007 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87011 */     // MIs[2] Operand 1
     /*  87011 */     // No operand predicates
     /*  87011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87019 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87023 */     // MIs[3] Operand 1
     /*  87023 */     // No operand predicates
     /*  87023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87025 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10651:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2NP),
     /*  87049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87051 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87053 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87067 */     GIR_RootConstrainSelectedInstOperands,
     /*  87068 */     // GIR_Coverage, 3533,
     /*  87068 */     GIR_EraseRootFromParent_Done,
     /*  87069 */   // Label 1366: @87069
     /*  87069 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(87189), // Rule ID 3534 //
     /*  87074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2nn),
     /*  87082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87119 */     // MIs[1] Operand 1
     /*  87119 */     // No operand predicates
     /*  87119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87127 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87131 */     // MIs[2] Operand 1
     /*  87131 */     // No operand predicates
     /*  87131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87139 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87143 */     // MIs[3] Operand 1
     /*  87143 */     // No operand predicates
     /*  87143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87145 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10650:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2NN),
     /*  87169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87171 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87173 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87187 */     GIR_RootConstrainSelectedInstOperands,
     /*  87188 */     // GIR_Coverage, 3534,
     /*  87188 */     GIR_EraseRootFromParent_Done,
     /*  87189 */   // Label 1367: @87189
     /*  87189 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(87331), // Rule ID 3594 //
     /*  87194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  87202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87239 */     // MIs[1] Operand 1
     /*  87239 */     // No operand predicates
     /*  87239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87247 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87251 */     // MIs[2] Operand 1
     /*  87251 */     // No operand predicates
     /*  87251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87259 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87263 */     // MIs[3] Operand 1
     /*  87263 */     // No operand predicates
     /*  87263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87265 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10682:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  87265 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87268 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87272 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8PP),
     /*  87310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87312 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87329 */     GIR_RootConstrainSelectedInstOperands,
     /*  87330 */     // GIR_Coverage, 3594,
     /*  87330 */     GIR_EraseRootFromParent_Done,
     /*  87331 */   // Label 1368: @87331
     /*  87331 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(87473), // Rule ID 3596 //
     /*  87336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  87344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87381 */     // MIs[1] Operand 1
     /*  87381 */     // No operand predicates
     /*  87381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87389 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87393 */     // MIs[2] Operand 1
     /*  87393 */     // No operand predicates
     /*  87393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87401 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87405 */     // MIs[3] Operand 1
     /*  87405 */     // No operand predicates
     /*  87405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87407 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10684:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  87407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4PP),
     /*  87452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87454 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87471 */     GIR_RootConstrainSelectedInstOperands,
     /*  87472 */     // GIR_Coverage, 3596,
     /*  87472 */     GIR_EraseRootFromParent_Done,
     /*  87473 */   // Label 1369: @87473
     /*  87473 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(87615), // Rule ID 3598 //
     /*  87478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  87486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87523 */     // MIs[1] Operand 1
     /*  87523 */     // No operand predicates
     /*  87523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87531 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87535 */     // MIs[2] Operand 1
     /*  87535 */     // No operand predicates
     /*  87535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87543 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87547 */     // MIs[3] Operand 1
     /*  87547 */     // No operand predicates
     /*  87547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87549 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10680:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87549 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87552 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87556 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87561 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SPP),
     /*  87594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87596 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87613 */     GIR_RootConstrainSelectedInstOperands,
     /*  87614 */     // GIR_Coverage, 3598,
     /*  87614 */     GIR_EraseRootFromParent_Done,
     /*  87615 */   // Label 1370: @87615
     /*  87615 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(87757), // Rule ID 3600 //
     /*  87620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  87628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87665 */     // MIs[1] Operand 1
     /*  87665 */     // No operand predicates
     /*  87665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87677 */     // MIs[2] Operand 1
     /*  87677 */     // No operand predicates
     /*  87677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87685 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87689 */     // MIs[3] Operand 1
     /*  87689 */     // No operand predicates
     /*  87689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87691 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10666:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PP),
     /*  87736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87738 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87755 */     GIR_RootConstrainSelectedInstOperands,
     /*  87756 */     // GIR_Coverage, 3600,
     /*  87756 */     GIR_EraseRootFromParent_Done,
     /*  87757 */   // Label 1371: @87757
     /*  87757 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(87899), // Rule ID 3601 //
     /*  87762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  87770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87807 */     // MIs[1] Operand 1
     /*  87807 */     // No operand predicates
     /*  87807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87815 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87819 */     // MIs[2] Operand 1
     /*  87819 */     // No operand predicates
     /*  87819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87827 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87831 */     // MIs[3] Operand 1
     /*  87831 */     // No operand predicates
     /*  87831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87833 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10665:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87836 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87840 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87845 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PN),
     /*  87878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87880 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87897 */     GIR_RootConstrainSelectedInstOperands,
     /*  87898 */     // GIR_Coverage, 3601,
     /*  87898 */     GIR_EraseRootFromParent_Done,
     /*  87899 */   // Label 1372: @87899
     /*  87899 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88041), // Rule ID 3602 //
     /*  87904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  87912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87949 */     // MIs[1] Operand 1
     /*  87949 */     // No operand predicates
     /*  87949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87957 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87961 */     // MIs[2] Operand 1
     /*  87961 */     // No operand predicates
     /*  87961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87969 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87973 */     // MIs[3] Operand 1
     /*  87973 */     // No operand predicates
     /*  87973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87975 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10664:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NP),
     /*  88020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88022 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88039 */     GIR_RootConstrainSelectedInstOperands,
     /*  88040 */     // GIR_Coverage, 3602,
     /*  88040 */     GIR_EraseRootFromParent_Done,
     /*  88041 */   // Label 1373: @88041
     /*  88041 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(88183), // Rule ID 3603 //
     /*  88046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  88054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88091 */     // MIs[1] Operand 1
     /*  88091 */     // No operand predicates
     /*  88091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88103 */     // MIs[2] Operand 1
     /*  88103 */     // No operand predicates
     /*  88103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88111 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88115 */     // MIs[3] Operand 1
     /*  88115 */     // No operand predicates
     /*  88115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88117 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10663:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88120 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88124 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NN),
     /*  88162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88164 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88181 */     GIR_RootConstrainSelectedInstOperands,
     /*  88182 */     // GIR_Coverage, 3603,
     /*  88182 */     GIR_EraseRootFromParent_Done,
     /*  88183 */   // Label 1374: @88183
     /*  88183 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(88325), // Rule ID 3615 //
     /*  88188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  88196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88233 */     // MIs[1] Operand 1
     /*  88233 */     // No operand predicates
     /*  88233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88245 */     // MIs[2] Operand 1
     /*  88245 */     // No operand predicates
     /*  88245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88253 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88257 */     // MIs[3] Operand 1
     /*  88257 */     // No operand predicates
     /*  88257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88259 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10661:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88259 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88262 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88266 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88271 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PP),
     /*  88304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88306 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88323 */     GIR_RootConstrainSelectedInstOperands,
     /*  88324 */     // GIR_Coverage, 3615,
     /*  88324 */     GIR_EraseRootFromParent_Done,
     /*  88325 */   // Label 1375: @88325
     /*  88325 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88467), // Rule ID 3616 //
     /*  88330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  88338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88375 */     // MIs[1] Operand 1
     /*  88375 */     // No operand predicates
     /*  88375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88383 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88387 */     // MIs[2] Operand 1
     /*  88387 */     // No operand predicates
     /*  88387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88395 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88399 */     // MIs[3] Operand 1
     /*  88399 */     // No operand predicates
     /*  88399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88401 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10660:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88413 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PN),
     /*  88446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88448 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88465 */     GIR_RootConstrainSelectedInstOperands,
     /*  88466 */     // GIR_Coverage, 3616,
     /*  88466 */     GIR_EraseRootFromParent_Done,
     /*  88467 */   // Label 1376: @88467
     /*  88467 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88609), // Rule ID 3617 //
     /*  88472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  88480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88517 */     // MIs[1] Operand 1
     /*  88517 */     // No operand predicates
     /*  88517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88529 */     // MIs[2] Operand 1
     /*  88529 */     // No operand predicates
     /*  88529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88537 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88541 */     // MIs[3] Operand 1
     /*  88541 */     // No operand predicates
     /*  88541 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88543 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10659:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88555 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NP),
     /*  88588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88590 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88607 */     GIR_RootConstrainSelectedInstOperands,
     /*  88608 */     // GIR_Coverage, 3617,
     /*  88608 */     GIR_EraseRootFromParent_Done,
     /*  88609 */   // Label 1377: @88609
     /*  88609 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88751), // Rule ID 3618 //
     /*  88614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  88622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88659 */     // MIs[1] Operand 1
     /*  88659 */     // No operand predicates
     /*  88659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88667 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88671 */     // MIs[2] Operand 1
     /*  88671 */     // No operand predicates
     /*  88671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88683 */     // MIs[3] Operand 1
     /*  88683 */     // No operand predicates
     /*  88683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88685 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10658:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88697 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88701 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NN),
     /*  88730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88732 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88749 */     GIR_RootConstrainSelectedInstOperands,
     /*  88750 */     // GIR_Coverage, 3618,
     /*  88750 */     GIR_EraseRootFromParent_Done,
     /*  88751 */   // Label 1378: @88751
     /*  88751 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88893), // Rule ID 3620 //
     /*  88756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  88764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88801 */     // MIs[1] Operand 1
     /*  88801 */     // No operand predicates
     /*  88801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88813 */     // MIs[2] Operand 1
     /*  88813 */     // No operand predicates
     /*  88813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88821 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88825 */     // MIs[3] Operand 1
     /*  88825 */     // No operand predicates
     /*  88825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88827 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10685:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4SPP),
     /*  88872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88874 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88891 */     GIR_RootConstrainSelectedInstOperands,
     /*  88892 */     // GIR_Coverage, 3620,
     /*  88892 */     GIR_EraseRootFromParent_Done,
     /*  88893 */   // Label 1379: @88893
     /*  88893 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(89035), // Rule ID 3621 //
     /*  88898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  88906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88943 */     // MIs[1] Operand 1
     /*  88943 */     // No operand predicates
     /*  88943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88955 */     // MIs[2] Operand 1
     /*  88955 */     // No operand predicates
     /*  88955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88963 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88967 */     // MIs[3] Operand 1
     /*  88967 */     // No operand predicates
     /*  88967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88969 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10678:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88969 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88972 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88976 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88981 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2PP),
     /*  89014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89016 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89033 */     GIR_RootConstrainSelectedInstOperands,
     /*  89034 */     // GIR_Coverage, 3621,
     /*  89034 */     GIR_EraseRootFromParent_Done,
     /*  89035 */   // Label 1380: @89035
     /*  89035 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(89177), // Rule ID 3623 //
     /*  89040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  89048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89085 */     // MIs[1] Operand 1
     /*  89085 */     // No operand predicates
     /*  89085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89093 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89097 */     // MIs[2] Operand 1
     /*  89097 */     // No operand predicates
     /*  89097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89105 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  89109 */     // MIs[3] Operand 1
     /*  89109 */     // No operand predicates
     /*  89109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89111 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10682:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  89111 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89114 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89118 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89123 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8WPP),
     /*  89156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89158 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89175 */     GIR_RootConstrainSelectedInstOperands,
     /*  89176 */     // GIR_Coverage, 3623,
     /*  89176 */     GIR_EraseRootFromParent_Done,
     /*  89177 */   // Label 1381: @89177
     /*  89177 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(89319), // Rule ID 3625 //
     /*  89182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  89190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89227 */     // MIs[1] Operand 1
     /*  89227 */     // No operand predicates
     /*  89227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89239 */     // MIs[2] Operand 1
     /*  89239 */     // No operand predicates
     /*  89239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89247 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89251 */     // MIs[3] Operand 1
     /*  89251 */     // No operand predicates
     /*  89251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89253 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10684:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  89253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89265 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WPP),
     /*  89298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89300 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89317 */     GIR_RootConstrainSelectedInstOperands,
     /*  89318 */     // GIR_Coverage, 3625,
     /*  89318 */     GIR_EraseRootFromParent_Done,
     /*  89319 */   // Label 1382: @89319
     /*  89319 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(89461), // Rule ID 3627 //
     /*  89324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  89332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89369 */     // MIs[1] Operand 1
     /*  89369 */     // No operand predicates
     /*  89369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89381 */     // MIs[2] Operand 1
     /*  89381 */     // No operand predicates
     /*  89381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89389 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89393 */     // MIs[3] Operand 1
     /*  89393 */     // No operand predicates
     /*  89393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89395 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10680:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89395 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89398 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89402 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89407 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89411 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SWPP),
     /*  89440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89442 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89459 */     GIR_RootConstrainSelectedInstOperands,
     /*  89460 */     // GIR_Coverage, 3627,
     /*  89460 */     GIR_EraseRootFromParent_Done,
     /*  89461 */   // Label 1383: @89461
     /*  89461 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(89603), // Rule ID 3629 //
     /*  89466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  89474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89511 */     // MIs[1] Operand 1
     /*  89511 */     // No operand predicates
     /*  89511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89519 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89523 */     // MIs[2] Operand 1
     /*  89523 */     // No operand predicates
     /*  89523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89531 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89535 */     // MIs[3] Operand 1
     /*  89535 */     // No operand predicates
     /*  89535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89537 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10666:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89549 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89553 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPP),
     /*  89582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89584 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89601 */     GIR_RootConstrainSelectedInstOperands,
     /*  89602 */     // GIR_Coverage, 3629,
     /*  89602 */     GIR_EraseRootFromParent_Done,
     /*  89603 */   // Label 1384: @89603
     /*  89603 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(89745), // Rule ID 3630 //
     /*  89608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  89616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89653 */     // MIs[1] Operand 1
     /*  89653 */     // No operand predicates
     /*  89653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89661 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89665 */     // MIs[2] Operand 1
     /*  89665 */     // No operand predicates
     /*  89665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89673 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89677 */     // MIs[3] Operand 1
     /*  89677 */     // No operand predicates
     /*  89677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89679 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10665:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPN),
     /*  89724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89726 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89743 */     GIR_RootConstrainSelectedInstOperands,
     /*  89744 */     // GIR_Coverage, 3630,
     /*  89744 */     GIR_EraseRootFromParent_Done,
     /*  89745 */   // Label 1385: @89745
     /*  89745 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(89887), // Rule ID 3631 //
     /*  89750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  89758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89795 */     // MIs[1] Operand 1
     /*  89795 */     // No operand predicates
     /*  89795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89803 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89807 */     // MIs[2] Operand 1
     /*  89807 */     // No operand predicates
     /*  89807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89815 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89819 */     // MIs[3] Operand 1
     /*  89819 */     // No operand predicates
     /*  89819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89821 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10664:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89821 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89824 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89828 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89833 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNP),
     /*  89866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89868 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89885 */     GIR_RootConstrainSelectedInstOperands,
     /*  89886 */     // GIR_Coverage, 3631,
     /*  89886 */     GIR_EraseRootFromParent_Done,
     /*  89887 */   // Label 1386: @89887
     /*  89887 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(90029), // Rule ID 3632 //
     /*  89892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  89900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89937 */     // MIs[1] Operand 1
     /*  89937 */     // No operand predicates
     /*  89937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89945 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89949 */     // MIs[2] Operand 1
     /*  89949 */     // No operand predicates
     /*  89949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89957 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89961 */     // MIs[3] Operand 1
     /*  89961 */     // No operand predicates
     /*  89961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89963 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10663:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNN),
     /*  90008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90010 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90027 */     GIR_RootConstrainSelectedInstOperands,
     /*  90028 */     // GIR_Coverage, 3632,
     /*  90028 */     GIR_EraseRootFromParent_Done,
     /*  90029 */   // Label 1387: @90029
     /*  90029 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(90171), // Rule ID 3644 //
     /*  90034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  90042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90079 */     // MIs[1] Operand 1
     /*  90079 */     // No operand predicates
     /*  90079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90091 */     // MIs[2] Operand 1
     /*  90091 */     // No operand predicates
     /*  90091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90099 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90103 */     // MIs[3] Operand 1
     /*  90103 */     // No operand predicates
     /*  90103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90105 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10661:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90105 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90108 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90112 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90117 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPP),
     /*  90150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90152 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90169 */     GIR_RootConstrainSelectedInstOperands,
     /*  90170 */     // GIR_Coverage, 3644,
     /*  90170 */     GIR_EraseRootFromParent_Done,
     /*  90171 */   // Label 1388: @90171
     /*  90171 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(90313), // Rule ID 3645 //
     /*  90176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  90184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90221 */     // MIs[1] Operand 1
     /*  90221 */     // No operand predicates
     /*  90221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90229 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90233 */     // MIs[2] Operand 1
     /*  90233 */     // No operand predicates
     /*  90233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90241 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90245 */     // MIs[3] Operand 1
     /*  90245 */     // No operand predicates
     /*  90245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90247 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10660:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90259 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPN),
     /*  90292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90294 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90311 */     GIR_RootConstrainSelectedInstOperands,
     /*  90312 */     // GIR_Coverage, 3645,
     /*  90312 */     GIR_EraseRootFromParent_Done,
     /*  90313 */   // Label 1389: @90313
     /*  90313 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(90455), // Rule ID 3646 //
     /*  90318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  90326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90363 */     // MIs[1] Operand 1
     /*  90363 */     // No operand predicates
     /*  90363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90371 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90375 */     // MIs[2] Operand 1
     /*  90375 */     // No operand predicates
     /*  90375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90383 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90387 */     // MIs[3] Operand 1
     /*  90387 */     // No operand predicates
     /*  90387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90389 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10659:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90389 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90392 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90396 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90401 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNP),
     /*  90434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90436 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90453 */     GIR_RootConstrainSelectedInstOperands,
     /*  90454 */     // GIR_Coverage, 3646,
     /*  90454 */     GIR_EraseRootFromParent_Done,
     /*  90455 */   // Label 1390: @90455
     /*  90455 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(90597), // Rule ID 3647 //
     /*  90460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  90468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90505 */     // MIs[1] Operand 1
     /*  90505 */     // No operand predicates
     /*  90505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90517 */     // MIs[2] Operand 1
     /*  90517 */     // No operand predicates
     /*  90517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90525 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90529 */     // MIs[3] Operand 1
     /*  90529 */     // No operand predicates
     /*  90529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90531 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10658:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90531 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90534 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90538 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90543 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90547 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90564 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNN),
     /*  90576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90578 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90595 */     GIR_RootConstrainSelectedInstOperands,
     /*  90596 */     // GIR_Coverage, 3647,
     /*  90596 */     GIR_EraseRootFromParent_Done,
     /*  90597 */   // Label 1391: @90597
     /*  90597 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(90739), // Rule ID 3649 //
     /*  90602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  90610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90647 */     // MIs[1] Operand 1
     /*  90647 */     // No operand predicates
     /*  90647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90655 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90659 */     // MIs[2] Operand 1
     /*  90659 */     // No operand predicates
     /*  90659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90667 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90671 */     // MIs[3] Operand 1
     /*  90671 */     // No operand predicates
     /*  90671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90673 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10685:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90673 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90676 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90680 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90685 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WSPP),
     /*  90718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90720 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90737 */     GIR_RootConstrainSelectedInstOperands,
     /*  90738 */     // GIR_Coverage, 3649,
     /*  90738 */     GIR_EraseRootFromParent_Done,
     /*  90739 */   // Label 1392: @90739
     /*  90739 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(90881), // Rule ID 3650 //
     /*  90744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  90752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  90777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90789 */     // MIs[1] Operand 1
     /*  90789 */     // No operand predicates
     /*  90789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90797 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90801 */     // MIs[2] Operand 1
     /*  90801 */     // No operand predicates
     /*  90801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90809 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90813 */     // MIs[3] Operand 1
     /*  90813 */     // No operand predicates
     /*  90813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90815 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10678:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2WPP),
     /*  90860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90862 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90879 */     GIR_RootConstrainSelectedInstOperands,
     /*  90880 */     // GIR_Coverage, 3650,
     /*  90880 */     GIR_EraseRootFromParent_Done,
     /*  90881 */   // Label 1393: @90881
     /*  90881 */   GIM_Reject,
     /*  90882 */ // Label 1357: @90882
     /*  90882 */ GIM_Reject,
     /*  90883 */ // Label 20: @90883
     /*  90883 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(91222),
     /*  90888 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  90891 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(90910), // Rule ID 106 //
     /*  90896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  90901 */     // (intrinsic_void 10568:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  90901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  90904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90908 */     GIR_RootConstrainSelectedInstOperands,
     /*  90909 */     // GIR_Coverage, 106,
     /*  90909 */     GIR_EraseRootFromParent_Done,
     /*  90910 */   // Label 1395: @90910
     /*  90910 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(90935), // Rule ID 1195 //
     /*  90915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  90918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  90923 */     // (intrinsic_void 10756:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  90923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  90926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90933 */     GIR_RootConstrainSelectedInstOperands,
     /*  90934 */     // GIR_Coverage, 1195,
     /*  90934 */     GIR_EraseRootFromParent_Done,
     /*  90935 */   // Label 1396: @90935
     /*  90935 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(90960), // Rule ID 1196 //
     /*  90940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  90943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  90948 */     // (intrinsic_void 10603:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  90948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  90951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90958 */     GIR_RootConstrainSelectedInstOperands,
     /*  90959 */     // GIR_Coverage, 1196,
     /*  90959 */     GIR_EraseRootFromParent_Done,
     /*  90960 */   // Label 1397: @90960
     /*  90960 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(90985), // Rule ID 1197 //
     /*  90965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  90968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  90973 */     // (intrinsic_void 10608:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  90973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  90976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  90979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90983 */     GIR_RootConstrainSelectedInstOperands,
     /*  90984 */     // GIR_Coverage, 1197,
     /*  90984 */     GIR_EraseRootFromParent_Done,
     /*  90985 */   // Label 1398: @90985
     /*  90985 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(91010), // Rule ID 1198 //
     /*  90990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  90993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  90998 */     // (intrinsic_void 10602:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  90998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91008 */     GIR_RootConstrainSelectedInstOperands,
     /*  91009 */     // GIR_Coverage, 1198,
     /*  91009 */     GIR_EraseRootFromParent_Done,
     /*  91010 */   // Label 1399: @91010
     /*  91010 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(91032), // Rule ID 1199 //
     /*  91015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  91023 */     // (intrinsic_void 10756:{ *:[iPTR] })  =>  (MSYNC)
     /*  91023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91030 */     GIR_RootConstrainSelectedInstOperands,
     /*  91031 */     // GIR_Coverage, 1199,
     /*  91031 */     GIR_EraseRootFromParent_Done,
     /*  91032 */   // Label 1400: @91032
     /*  91032 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(91054), // Rule ID 1200 //
     /*  91037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  91045 */     // (intrinsic_void 10603:{ *:[iPTR] })  =>  (MSYNC)
     /*  91045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91052 */     GIR_RootConstrainSelectedInstOperands,
     /*  91053 */     // GIR_Coverage, 1200,
     /*  91053 */     GIR_EraseRootFromParent_Done,
     /*  91054 */   // Label 1401: @91054
     /*  91054 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(91076), // Rule ID 1201 //
     /*  91059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  91067 */     // (intrinsic_void 10608:{ *:[iPTR] })  =>  (MSYNC)
     /*  91067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91074 */     GIR_RootConstrainSelectedInstOperands,
     /*  91075 */     // GIR_Coverage, 1201,
     /*  91075 */     GIR_EraseRootFromParent_Done,
     /*  91076 */   // Label 1402: @91076
     /*  91076 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(91098), // Rule ID 1202 //
     /*  91081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  91089 */     // (intrinsic_void 10602:{ *:[iPTR] })  =>  (MSYNC)
     /*  91089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91096 */     GIR_RootConstrainSelectedInstOperands,
     /*  91097 */     // GIR_Coverage, 1202,
     /*  91097 */     GIR_EraseRootFromParent_Done,
     /*  91098 */   // Label 1403: @91098
     /*  91098 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(91117), // Rule ID 1203 //
     /*  91103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  91108 */     // (intrinsic_void 10568:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91115 */     GIR_RootConstrainSelectedInstOperands,
     /*  91116 */     // GIR_Coverage, 1203,
     /*  91116 */     GIR_EraseRootFromParent_Done,
     /*  91117 */   // Label 1404: @91117
     /*  91117 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(91136), // Rule ID 1204 //
     /*  91122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_eieio),
     /*  91127 */     // (intrinsic_void 10601:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91134 */     GIR_RootConstrainSelectedInstOperands,
     /*  91135 */     // GIR_Coverage, 1204,
     /*  91135 */     GIR_EraseRootFromParent_Done,
     /*  91136 */   // Label 1405: @91136
     /*  91136 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(91158), // Rule ID 1230 //
     /*  91141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_fence),
     /*  91146 */     // (intrinsic_void 10579:{ *:[iPTR] })  =>  (FENCE)
     /*  91146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FENCE),
     /*  91149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91156 */     GIR_RootConstrainSelectedInstOperands,
     /*  91157 */     // GIR_Coverage, 1230,
     /*  91157 */     GIR_EraseRootFromParent_Done,
     /*  91158 */   // Label 1406: @91158
     /*  91158 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(91180), // Rule ID 1284 //
     /*  91163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsAIX),
     /*  91166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  91171 */     // (intrinsic_void 10220:{ *:[iPTR] })  =>  (NOP)
     /*  91171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOP),
     /*  91174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91178 */     GIR_RootConstrainSelectedInstOperands,
     /*  91179 */     // GIR_Coverage, 1284,
     /*  91179 */     GIR_EraseRootFromParent_Done,
     /*  91180 */   // Label 1407: @91180
     /*  91180 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(91202), // Rule ID 1285 //
     /*  91185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotAIX),
     /*  91188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  91193 */     // (intrinsic_void 10220:{ *:[iPTR] })  =>  (DSSALL)
     /*  91193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSSALL),
     /*  91196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91200 */     GIR_RootConstrainSelectedInstOperands,
     /*  91201 */     // GIR_Coverage, 1285,
     /*  91201 */     GIR_EraseRootFromParent_Done,
     /*  91202 */   // Label 1408: @91202
     /*  91202 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(91221), // Rule ID 4852 //
     /*  91207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_isync),
     /*  91212 */     // (intrinsic_void 10604:{ *:[iPTR] })  =>  (ISYNC)
     /*  91212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ISYNC),
     /*  91215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91219 */     GIR_RootConstrainSelectedInstOperands,
     /*  91220 */     // GIR_Coverage, 4852,
     /*  91220 */     GIR_EraseRootFromParent_Done,
     /*  91221 */   // Label 1409: @91221
     /*  91221 */   GIM_Reject,
     /*  91222 */ // Label 1394: @91222
     /*  91222 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(92105),
     /*  91227 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91230 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(91269), // Rule ID 269 //
     /*  91235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dss),
     /*  91243 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91254 */     // MIs[1] Operand 1
     /*  91254 */     // No operand predicates
     /*  91254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91256 */     // (intrinsic_void 10219:{ *:[iPTR] }, (imm:{ *:[i32] }):$STRM)  =>  (DSS (imm:{ *:[i32] }):$STRM)
     /*  91256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSS),
     /*  91259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  91262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91267 */     GIR_RootConstrainSelectedInstOperands,
     /*  91268 */     // GIR_Coverage, 269,
     /*  91268 */     GIR_EraseRootFromParent_Done,
     /*  91269 */   // Label 1411: @91269
     /*  91269 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(91295), // Rule ID 193 //
     /*  91274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  91277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb0),
     /*  91282 */     // MIs[0] FM
     /*  91282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  91285 */     // (intrinsic_void 10718:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB0 (timm:{ *:[i32] }):$FM)
     /*  91285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB0),
     /*  91288 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  91290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91293 */     GIR_RootConstrainSelectedInstOperands,
     /*  91294 */     // GIR_Coverage, 193,
     /*  91294 */     GIR_EraseRootFromParent_Done,
     /*  91295 */   // Label 1412: @91295
     /*  91295 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(91321), // Rule ID 194 //
     /*  91300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  91303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb1),
     /*  91308 */     // MIs[0] FM
     /*  91308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  91311 */     // (intrinsic_void 10719:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB1 (timm:{ *:[i32] }):$FM)
     /*  91311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB1),
     /*  91314 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  91316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91319 */     GIR_RootConstrainSelectedInstOperands,
     /*  91320 */     // GIR_Coverage, 194,
     /*  91320 */     GIR_EraseRootFromParent_Done,
     /*  91321 */   // Label 1413: @91321
     /*  91321 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(91348), // Rule ID 278 //
     /*  91326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mfvscr),
     /*  91334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91341 */     // (intrinsic_w_chain:{ *:[v8i16] } 10232:{ *:[iPTR] })  =>  (MFVSCR:{ *:[v8i16] })
     /*  91341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSCR),
     /*  91344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  91346 */     GIR_RootConstrainSelectedInstOperands,
     /*  91347 */     // GIR_Coverage, 278,
     /*  91347 */     GIR_EraseRootFromParent_Done,
     /*  91348 */   // Label 1414: @91348
     /*  91348 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(91372), // Rule ID 1231 //
     /*  91353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_readflm),
     /*  91358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  91365 */     // (intrinsic_w_chain:{ *:[f64] } 10733:{ *:[iPTR] })  =>  (MFFS:{ *:[f64] })
     /*  91365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFS),
     /*  91368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91370 */     GIR_RootConstrainSelectedInstOperands,
     /*  91371 */     // GIR_Coverage, 1231,
     /*  91371 */     GIR_EraseRootFromParent_Done,
     /*  91372 */   // Label 1415: @91372
     /*  91372 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(91400), // Rule ID 1232 //
     /*  91377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mffsl),
     /*  91382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  91389 */     // (intrinsic_w_chain:{ *:[f64] } 10615:{ *:[iPTR] })  =>  (MFFSL:{ *:[f64] })
     /*  91389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFSL),
     /*  91392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91398 */     GIR_RootConstrainSelectedInstOperands,
     /*  91399 */     // GIR_Coverage, 1232,
     /*  91399 */     GIR_EraseRootFromParent_Done,
     /*  91400 */   // Label 1416: @91400
     /*  91400 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(91464), // Rule ID 1568 //
     /*  91405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn32),
     /*  91413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91420 */     // (intrinsic_w_chain:{ *:[i32] } 10545:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (DARN:{ *:[i64] } 0:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  91420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  91435 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91446 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  91453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91463 */     // GIR_Coverage, 1568,
     /*  91463 */     GIR_EraseRootFromParent_Done,
     /*  91464 */   // Label 1417: @91464
     /*  91464 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(91498), // Rule ID 1569 //
     /*  91469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn),
     /*  91477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91484 */     // (intrinsic_w_chain:{ *:[i64] } 10544:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 1:{ *:[i32] })
     /*  91484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91496 */     GIR_RootConstrainSelectedInstOperands,
     /*  91497 */     // GIR_Coverage, 1569,
     /*  91497 */     GIR_EraseRootFromParent_Done,
     /*  91498 */   // Label 1418: @91498
     /*  91498 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(91532), // Rule ID 1570 //
     /*  91503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darnraw),
     /*  91511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91518 */     // (intrinsic_w_chain:{ *:[i64] } 10546:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 2:{ *:[i32] })
     /*  91518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  91526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91530 */     GIR_RootConstrainSelectedInstOperands,
     /*  91531 */     // GIR_Coverage, 1570,
     /*  91531 */     GIR_EraseRootFromParent_Done,
     /*  91532 */   // Label 1419: @91532
     /*  91532 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(91563), // Rule ID 2886 //
     /*  91537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tcheck),
     /*  91545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91552 */     // (intrinsic_w_chain:{ *:[i32] } 10763:{ *:[iPTR] })  =>  (TCHECK_RET:{ *:[i32] })
     /*  91552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TCHECK_RET),
     /*  91555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /*  91557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91561 */     GIR_RootConstrainSelectedInstOperands,
     /*  91562 */     // GIR_Coverage, 2886,
     /*  91562 */     GIR_EraseRootFromParent_Done,
     /*  91563 */   // Label 1420: @91563
     /*  91563 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91604), // Rule ID 2890 //
     /*  91568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasr),
     /*  91576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91583 */     // (intrinsic_w_chain:{ *:[i64] } 10595:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 130:{ *:[i32] })
     /*  91583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91588 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  91598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91602 */     GIR_RootConstrainSelectedInstOperands,
     /*  91603 */     // GIR_Coverage, 2890,
     /*  91603 */     GIR_EraseRootFromParent_Done,
     /*  91604 */   // Label 1421: @91604
     /*  91604 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(91645), // Rule ID 2891 //
     /*  91609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasru),
     /*  91617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91624 */     // (intrinsic_w_chain:{ *:[i64] } 10596:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 131:{ *:[i32] })
     /*  91624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91629 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  91639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91643 */     GIR_RootConstrainSelectedInstOperands,
     /*  91644 */     // GIR_Coverage, 2891,
     /*  91644 */     GIR_EraseRootFromParent_Done,
     /*  91645 */   // Label 1422: @91645
     /*  91645 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(91686), // Rule ID 2892 //
     /*  91650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfhar),
     /*  91658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91665 */     // (intrinsic_w_chain:{ *:[i64] } 10597:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 128:{ *:[i32] })
     /*  91665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91670 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  91680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91684 */     GIR_RootConstrainSelectedInstOperands,
     /*  91685 */     // GIR_Coverage, 2892,
     /*  91685 */     GIR_EraseRootFromParent_Done,
     /*  91686 */   // Label 1423: @91686
     /*  91686 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(91727), // Rule ID 2893 //
     /*  91691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfiar),
     /*  91699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91706 */     // (intrinsic_w_chain:{ *:[i64] } 10598:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 129:{ *:[i32] })
     /*  91706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91711 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  91721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91725 */     GIR_RootConstrainSelectedInstOperands,
     /*  91726 */     // GIR_Coverage, 2893,
     /*  91726 */     GIR_EraseRootFromParent_Done,
     /*  91727 */   // Label 1424: @91727
     /*  91727 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(91758), // Rule ID 4900 //
     /*  91732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtmsr),
     /*  91737 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91744 */     // (intrinsic_void 10722:{ *:[iPTR] }, gprc:{ *:[i32] }:$RS)  =>  (MTMSR ?:{ *:[i32] }:$RS, 0:{ *:[i32] })
     /*  91744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTMSR),
     /*  91747 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /*  91749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91756 */     GIR_RootConstrainSelectedInstOperands,
     /*  91757 */     // GIR_Coverage, 4900,
     /*  91757 */     GIR_EraseRootFromParent_Done,
     /*  91758 */   // Label 1425: @91758
     /*  91758 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91785), // Rule ID 189 //
     /*  91763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  91768 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91771 */     // (intrinsic_void 322:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (MTCTRloop:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  91771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTRloop),
     /*  91774 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  91776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  91779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91783 */     GIR_RootConstrainSelectedInstOperands,
     /*  91784 */     // GIR_Coverage, 189,
     /*  91784 */     GIR_EraseRootFromParent_Done,
     /*  91785 */   // Label 1426: @91785
     /*  91785 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91808), // Rule ID 279 //
     /*  91790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_mtvscr),
     /*  91798 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91801 */     // (intrinsic_void 10233:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (MTVSCR v4i32:{ *:[v4i32] }:$VB)
     /*  91801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSCR),
     /*  91804 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  91806 */     GIR_RootConstrainSelectedInstOperands,
     /*  91807 */     // GIR_Coverage, 279,
     /*  91807 */     GIR_EraseRootFromParent_Done,
     /*  91808 */   // Label 1427: @91808
     /*  91808 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91835), // Rule ID 633 //
     /*  91813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  91818 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91821 */     // (intrinsic_void 322:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (MTCTR8loop:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  91821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTR8loop),
     /*  91824 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  91826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  91829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91833 */     GIR_RootConstrainSelectedInstOperands,
     /*  91834 */     // GIR_Coverage, 633,
     /*  91834 */     GIR_EraseRootFromParent_Done,
     /*  91835 */   // Label 1428: @91835
     /*  91835 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91872), // Rule ID 2894 //
     /*  91840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasr),
     /*  91848 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91851 */     // (intrinsic_void 10739:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 130:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  91851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  91854 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  91864 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  91866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91870 */     GIR_RootConstrainSelectedInstOperands,
     /*  91871 */     // GIR_Coverage, 2894,
     /*  91871 */     GIR_EraseRootFromParent_Done,
     /*  91872 */   // Label 1429: @91872
     /*  91872 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91909), // Rule ID 2895 //
     /*  91877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasru),
     /*  91885 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91888 */     // (intrinsic_void 10740:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 131:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  91888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  91891 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  91901 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  91903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91907 */     GIR_RootConstrainSelectedInstOperands,
     /*  91908 */     // GIR_Coverage, 2895,
     /*  91908 */     GIR_EraseRootFromParent_Done,
     /*  91909 */   // Label 1430: @91909
     /*  91909 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91946), // Rule ID 2896 //
     /*  91914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfhar),
     /*  91922 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91925 */     // (intrinsic_void 10741:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 128:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  91925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  91928 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  91938 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  91940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91944 */     GIR_RootConstrainSelectedInstOperands,
     /*  91945 */     // GIR_Coverage, 2896,
     /*  91945 */     GIR_EraseRootFromParent_Done,
     /*  91946 */   // Label 1431: @91946
     /*  91946 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(91983), // Rule ID 2897 //
     /*  91951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfiar),
     /*  91959 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91962 */     // (intrinsic_void 10742:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 129:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  91962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  91965 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  91975 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  91977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91981 */     GIR_RootConstrainSelectedInstOperands,
     /*  91982 */     // GIR_Coverage, 2897,
     /*  91982 */     GIR_EraseRootFromParent_Done,
     /*  91983 */   // Label 1432: @91983
     /*  91983 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(92011), // Rule ID 2888 //
     /*  91988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_trechkpt),
     /*  91996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91999 */     // (intrinsic_w_chain:{ *:[i32] } 10770:{ *:[iPTR] })  =>  (TRECHKPT:{ *:[i32] })
     /*  91999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECHKPT),
     /*  92002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92009 */     GIR_RootConstrainSelectedInstOperands,
     /*  92010 */     // GIR_Coverage, 2888,
     /*  92010 */     GIR_EraseRootFromParent_Done,
     /*  92011 */   // Label 1433: @92011
     /*  92011 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92042), // Rule ID 2898 //
     /*  92016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tendall),
     /*  92024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92027 */     // (intrinsic_w_chain:{ *:[i32] } 10766:{ *:[iPTR] })  =>  (TEND:{ *:[i32] } 1:{ *:[i32] })
     /*  92027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TEND),
     /*  92030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  92033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92040 */     GIR_RootConstrainSelectedInstOperands,
     /*  92041 */     // GIR_Coverage, 2898,
     /*  92041 */     GIR_EraseRootFromParent_Done,
     /*  92042 */   // Label 1434: @92042
     /*  92042 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(92073), // Rule ID 2899 //
     /*  92047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tresume),
     /*  92055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92058 */     // (intrinsic_w_chain:{ *:[i32] } 10772:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 1:{ *:[i32] })
     /*  92058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  92061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  92064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92071 */     GIR_RootConstrainSelectedInstOperands,
     /*  92072 */     // GIR_Coverage, 2899,
     /*  92072 */     GIR_EraseRootFromParent_Done,
     /*  92073 */   // Label 1435: @92073
     /*  92073 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(92104), // Rule ID 2900 //
     /*  92078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tsuspend),
     /*  92086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92089 */     // (intrinsic_w_chain:{ *:[i32] } 10775:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 0:{ *:[i32] })
     /*  92089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  92092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92102 */     GIR_RootConstrainSelectedInstOperands,
     /*  92103 */     // GIR_Coverage, 2900,
     /*  92103 */     GIR_EraseRootFromParent_Done,
     /*  92104 */   // Label 1436: @92104
     /*  92104 */   GIM_Reject,
     /*  92105 */ // Label 1410: @92105
     /*  92105 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(92631),
     /*  92110 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92113 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(92144), // Rule ID 1172 //
     /*  92118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  92121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsfi),
     /*  92126 */     // MIs[0] BF
     /*  92126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92129 */     // MIs[0] U
     /*  92129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92132 */     // (intrinsic_void 10721:{ *:[iPTR] }, (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)  =>  (MTFSFIb (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)
     /*  92132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFIb),
     /*  92135 */     GIR_RootToRootCopy, /*OpIdx*/1, // BF
     /*  92137 */     GIR_RootToRootCopy, /*OpIdx*/2, // U
     /*  92139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92142 */     GIR_RootConstrainSelectedInstOperands,
     /*  92143 */     // GIR_Coverage, 1172,
     /*  92143 */     GIR_EraseRootFromParent_Done,
     /*  92144 */   // Label 1438: @92144
     /*  92144 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(92192), // Rule ID 12 //
     /*  92149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  92154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92172 */     // MIs[1] Operand 1
     /*  92172 */     // No operand predicates
     /*  92172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92174 */     // (intrinsic_w_chain:{ *:[f64] } 10745:{ *:[iPTR] }, (imm:{ *:[i32] }):$RND)  =>  (SETRNDi:{ *:[f64] } (imm:{ *:[i32] }):$RND)
     /*  92174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRNDi),
     /*  92177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RND
     /*  92182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92190 */     GIR_RootConstrainSelectedInstOperands,
     /*  92191 */     // GIR_Coverage, 12,
     /*  92191 */     GIR_EraseRootFromParent_Done,
     /*  92192 */   // Label 1439: @92192
     /*  92192 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92240), // Rule ID 190 //
     /*  92197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  92202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  92205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  92212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92220 */     // MIs[1] Operand 1
     /*  92220 */     // No operand predicates
     /*  92220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92222 */     // (intrinsic_w_chain:{ *:[i1] } 221:{ *:[iPTR] }, (imm:{ *:[i32] }):$stride)  =>  (DecreaseCTRloop:{ *:[i1] }:{ *:[i32] } (imm:{ *:[i32] }):$stride)
     /*  92222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTRloop),
     /*  92225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  92230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  92233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92238 */     GIR_RootConstrainSelectedInstOperands,
     /*  92239 */     // GIR_Coverage, 190,
     /*  92239 */     GIR_EraseRootFromParent_Done,
     /*  92240 */   // Label 1440: @92240
     /*  92240 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92288), // Rule ID 634 //
     /*  92245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  92250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  92253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  92260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92268 */     // MIs[1] Operand 1
     /*  92268 */     // No operand predicates
     /*  92268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92270 */     // (intrinsic_w_chain:{ *:[i1] } 221:{ *:[iPTR] }, (imm:{ *:[i64] }):$stride)  =>  (DecreaseCTR8loop:{ *:[i1] }:{ *:[i64] } (imm:{ *:[i64] }):$stride)
     /*  92270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTR8loop),
     /*  92273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  92278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  92281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92286 */     GIR_RootConstrainSelectedInstOperands,
     /*  92287 */     // GIR_Coverage, 634,
     /*  92287 */     GIR_EraseRootFromParent_Done,
     /*  92288 */   // Label 1441: @92288
     /*  92288 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92321), // Rule ID 1173 //
     /*  92293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fixed_addr_ld),
     /*  92298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92305 */     // MIs[0] imm
     /*  92305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92308 */     // (intrinsic_w_chain:{ *:[i32] } 10580:{ *:[iPTR] }, (timm:{ *:[i32] }):$imm)  =>  (PPCLdFixedAddr:{ *:[i32] } (timm:{ *:[i32] }):$imm)
     /*  92308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PPCLdFixedAddr),
     /*  92311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92313 */     GIR_RootToRootCopy, /*OpIdx*/2, // imm
     /*  92315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92319 */     GIR_RootConstrainSelectedInstOperands,
     /*  92320 */     // GIR_Coverage, 1173,
     /*  92320 */     GIR_EraseRootFromParent_Done,
     /*  92321 */   // Label 1442: @92321
     /*  92321 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92354), // Rule ID 1573 //
     /*  92326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  92331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92338 */     // MIs[0] SPR
     /*  92338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92341 */     // (intrinsic_w_chain:{ *:[i64] } 10617:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR8:{ *:[i64] } ?:{ *:[i32] }:$SPR)
     /*  92341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  92344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92346 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  92348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92352 */     GIR_RootConstrainSelectedInstOperands,
     /*  92353 */     // GIR_Coverage, 1573,
     /*  92353 */     GIR_EraseRootFromParent_Done,
     /*  92354 */   // Label 1443: @92354
     /*  92354 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92387), // Rule ID 4898 //
     /*  92359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  92364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92371 */     // MIs[0] SPR
     /*  92371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92374 */     // (intrinsic_w_chain:{ *:[i32] } 10617:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR:{ *:[i32] } ?:{ *:[i32] }:$SPR)
     /*  92374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR),
     /*  92377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92379 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  92381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92385 */     GIR_RootConstrainSelectedInstOperands,
     /*  92386 */     // GIR_Coverage, 4898,
     /*  92386 */     GIR_EraseRootFromParent_Done,
     /*  92387 */   // Label 1444: @92387
     /*  92387 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92420), // Rule ID 1574 //
     /*  92392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  92397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92400 */     // MIs[0] SPR
     /*  92400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92407 */     // (intrinsic_void 10723:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, g8rc:{ *:[i64] }:$RT)  =>  (MTSPR8 ?:{ *:[i32] }:$SPR, ?:{ *:[i64] }:$RT)
     /*  92407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92410 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  92412 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92418 */     GIR_RootConstrainSelectedInstOperands,
     /*  92419 */     // GIR_Coverage, 1574,
     /*  92419 */     GIR_EraseRootFromParent_Done,
     /*  92420 */   // Label 1445: @92420
     /*  92420 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92453), // Rule ID 4899 //
     /*  92425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  92430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92433 */     // MIs[0] SPR
     /*  92433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92440 */     // (intrinsic_void 10723:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, gprc:{ *:[i32] }:$RT)  =>  (MTSPR ?:{ *:[i32] }:$SPR, ?:{ *:[i32] }:$RT)
     /*  92440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR),
     /*  92443 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  92445 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92451 */     GIR_RootConstrainSelectedInstOperands,
     /*  92452 */     // GIR_Coverage, 4899,
     /*  92452 */     GIR_EraseRootFromParent_Done,
     /*  92453 */   // Label 1446: @92453
     /*  92453 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92484), // Rule ID 195 //
     /*  92458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  92461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsf),
     /*  92466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92469 */     // MIs[0] FM
     /*  92469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92472 */     // (intrinsic_void 10720:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)  =>  (MTFSFb (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)
     /*  92472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFb),
     /*  92475 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  92477 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92482 */     GIR_RootConstrainSelectedInstOperands,
     /*  92483 */     // GIR_Coverage, 195,
     /*  92483 */     GIR_EraseRootFromParent_Done,
     /*  92484 */   // Label 1447: @92484
     /*  92484 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92524), // Rule ID 13 //
     /*  92489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  92494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92508 */     // (intrinsic_w_chain:{ *:[f64] } 10745:{ *:[iPTR] }, gprc:{ *:[i32] }:$in)  =>  (SETRND:{ *:[f64] } gprc:{ *:[i32] }:$in)
     /*  92508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRND),
     /*  92511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92513 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  92515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92522 */     GIR_RootConstrainSelectedInstOperands,
     /*  92523 */     // GIR_Coverage, 13,
     /*  92523 */     GIR_EraseRootFromParent_Done,
     /*  92524 */   // Label 1448: @92524
     /*  92524 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92564), // Rule ID 14 //
     /*  92529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setflm),
     /*  92534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92548 */     // (intrinsic_w_chain:{ *:[f64] } 10744:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FLM)  =>  (SETFLM:{ *:[f64] } f8rc:{ *:[f64] }:$FLM)
     /*  92548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETFLM),
     /*  92551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92553 */     GIR_RootToRootCopy, /*OpIdx*/2, // FLM
     /*  92555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92562 */     GIR_RootConstrainSelectedInstOperands,
     /*  92563 */     // GIR_Coverage, 14,
     /*  92563 */     GIR_EraseRootFromParent_Done,
     /*  92564 */   // Label 1449: @92564
     /*  92564 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92597), // Rule ID 2881 //
     /*  92569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tabort),
     /*  92577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92583 */     // (intrinsic_w_chain:{ *:[i32] } 10757:{ *:[iPTR] }, i32:{ *:[i32] }:$R)  =>  (TABORT:{ *:[i32] } ?:{ *:[i32] }:$R)
     /*  92583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TABORT),
     /*  92586 */     GIR_RootToRootCopy, /*OpIdx*/2, // R
     /*  92588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92595 */     GIR_RootConstrainSelectedInstOperands,
     /*  92596 */     // GIR_Coverage, 2881,
     /*  92596 */     GIR_EraseRootFromParent_Done,
     /*  92597 */   // Label 1450: @92597
     /*  92597 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(92630), // Rule ID 2887 //
     /*  92602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_treclaim),
     /*  92610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92616 */     // (intrinsic_w_chain:{ *:[i32] } 10771:{ *:[iPTR] }, i32:{ *:[i32] }:$RA)  =>  (TRECLAIM:{ *:[i32] } ?:{ *:[i32] }:$RA)
     /*  92616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECLAIM),
     /*  92619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  92621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92628 */     GIR_RootConstrainSelectedInstOperands,
     /*  92629 */     // GIR_Coverage, 2887,
     /*  92629 */     GIR_EraseRootFromParent_Done,
     /*  92630 */   // Label 1451: @92630
     /*  92630 */   GIM_Reject,
     /*  92631 */ // Label 1437: @92631
     /*  92631 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(93558),
     /*  92636 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92639 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(92689), // Rule ID 270 //
     /*  92644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  92652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92658 */     // MIs[0] RA
     /*  92658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92670 */     // MIs[1] Operand 1
     /*  92670 */     // No operand predicates
     /*  92670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92672 */     // (intrinsic_void 10221:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST),
     /*  92675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92678 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92680 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92687 */     GIR_RootConstrainSelectedInstOperands,
     /*  92688 */     // GIR_Coverage, 270,
     /*  92688 */     GIR_EraseRootFromParent_Done,
     /*  92689 */   // Label 1453: @92689
     /*  92689 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(92739), // Rule ID 271 //
     /*  92694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  92702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92708 */     // MIs[0] RA
     /*  92708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92720 */     // MIs[1] Operand 1
     /*  92720 */     // No operand predicates
     /*  92720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92722 */     // (intrinsic_void 10224:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT),
     /*  92725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92728 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92730 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92737 */     GIR_RootConstrainSelectedInstOperands,
     /*  92738 */     // GIR_Coverage, 271,
     /*  92738 */     GIR_EraseRootFromParent_Done,
     /*  92739 */   // Label 1454: @92739
     /*  92739 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(92789), // Rule ID 272 //
     /*  92744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  92752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92758 */     // MIs[0] RA
     /*  92758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92770 */     // MIs[1] Operand 1
     /*  92770 */     // No operand predicates
     /*  92770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92772 */     // (intrinsic_void 10222:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST),
     /*  92775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92778 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92780 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92787 */     GIR_RootConstrainSelectedInstOperands,
     /*  92788 */     // GIR_Coverage, 272,
     /*  92788 */     GIR_EraseRootFromParent_Done,
     /*  92789 */   // Label 1455: @92789
     /*  92789 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(92839), // Rule ID 273 //
     /*  92794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  92802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92808 */     // MIs[0] RA
     /*  92808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92820 */     // MIs[1] Operand 1
     /*  92820 */     // No operand predicates
     /*  92820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92822 */     // (intrinsic_void 10223:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT),
     /*  92825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92828 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92830 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92837 */     GIR_RootConstrainSelectedInstOperands,
     /*  92838 */     // GIR_Coverage, 273,
     /*  92838 */     GIR_EraseRootFromParent_Done,
     /*  92839 */   // Label 1456: @92839
     /*  92839 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(92889), // Rule ID 274 //
     /*  92844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  92852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92858 */     // MIs[0] RA
     /*  92858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92870 */     // MIs[1] Operand 1
     /*  92870 */     // No operand predicates
     /*  92870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92872 */     // (intrinsic_void 10221:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST64),
     /*  92875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92878 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92880 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92887 */     GIR_RootConstrainSelectedInstOperands,
     /*  92888 */     // GIR_Coverage, 274,
     /*  92888 */     GIR_EraseRootFromParent_Done,
     /*  92889 */   // Label 1457: @92889
     /*  92889 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(92939), // Rule ID 275 //
     /*  92894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  92902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92908 */     // MIs[0] RA
     /*  92908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92920 */     // MIs[1] Operand 1
     /*  92920 */     // No operand predicates
     /*  92920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92922 */     // (intrinsic_void 10224:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT64),
     /*  92925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92928 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92930 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92937 */     GIR_RootConstrainSelectedInstOperands,
     /*  92938 */     // GIR_Coverage, 275,
     /*  92938 */     GIR_EraseRootFromParent_Done,
     /*  92939 */   // Label 1458: @92939
     /*  92939 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(92989), // Rule ID 276 //
     /*  92944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  92952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92958 */     // MIs[0] RA
     /*  92958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92970 */     // MIs[1] Operand 1
     /*  92970 */     // No operand predicates
     /*  92970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92972 */     // (intrinsic_void 10222:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST64),
     /*  92975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92978 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92980 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92987 */     GIR_RootConstrainSelectedInstOperands,
     /*  92988 */     // GIR_Coverage, 276,
     /*  92988 */     GIR_EraseRootFromParent_Done,
     /*  92989 */   // Label 1459: @92989
     /*  92989 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93039), // Rule ID 277 //
     /*  92994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  93002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93008 */     // MIs[0] RA
     /*  93008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93020 */     // MIs[1] Operand 1
     /*  93020 */     // No operand predicates
     /*  93020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93022 */     // (intrinsic_void 10223:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT64),
     /*  93025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93028 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93030 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93037 */     GIR_RootConstrainSelectedInstOperands,
     /*  93038 */     // GIR_Coverage, 277,
     /*  93038 */     GIR_EraseRootFromParent_Done,
     /*  93039 */   // Label 1460: @93039
     /*  93039 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93076), // Rule ID 380 //
     /*  93044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsumsws),
     /*  93052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93065 */     // (intrinsic_w_chain:{ *:[v4i32] } 10503:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUMSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUMSWS),
     /*  93068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93070 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93072 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93074 */     GIR_RootConstrainSelectedInstOperands,
     /*  93075 */     // GIR_Coverage, 380,
     /*  93075 */     GIR_EraseRootFromParent_Done,
     /*  93076 */   // Label 1461: @93076
     /*  93076 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(93113), // Rule ID 381 //
     /*  93081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum2sws),
     /*  93089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93102 */     // (intrinsic_w_chain:{ *:[v4i32] } 10499:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM2SWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM2SWS),
     /*  93105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93107 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93109 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93111 */     GIR_RootConstrainSelectedInstOperands,
     /*  93112 */     // GIR_Coverage, 381,
     /*  93112 */     GIR_EraseRootFromParent_Done,
     /*  93113 */   // Label 1462: @93113
     /*  93113 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(93150), // Rule ID 382 //
     /*  93118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4sbs),
     /*  93126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93139 */     // (intrinsic_w_chain:{ *:[v4i32] } 10500:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SBS),
     /*  93142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93144 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93146 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93148 */     GIR_RootConstrainSelectedInstOperands,
     /*  93149 */     // GIR_Coverage, 382,
     /*  93149 */     GIR_EraseRootFromParent_Done,
     /*  93150 */   // Label 1463: @93150
     /*  93150 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(93187), // Rule ID 383 //
     /*  93155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4shs),
     /*  93163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93176 */     // (intrinsic_w_chain:{ *:[v4i32] } 10501:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SHS),
     /*  93179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93181 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93183 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93185 */     GIR_RootConstrainSelectedInstOperands,
     /*  93186 */     // GIR_Coverage, 383,
     /*  93186 */     GIR_EraseRootFromParent_Done,
     /*  93187 */   // Label 1464: @93187
     /*  93187 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(93224), // Rule ID 384 //
     /*  93192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4ubs),
     /*  93200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93213 */     // (intrinsic_w_chain:{ *:[v4i32] } 10502:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4UBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4UBS),
     /*  93216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93218 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93220 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93222 */     GIR_RootConstrainSelectedInstOperands,
     /*  93223 */     // GIR_Coverage, 384,
     /*  93223 */     GIR_EraseRootFromParent_Done,
     /*  93224 */   // Label 1465: @93224
     /*  93224 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(93261), // Rule ID 411 //
     /*  93229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshss),
     /*  93237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93250 */     // (intrinsic_w_chain:{ *:[v16i8] } 10437:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHSS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHSS),
     /*  93253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93255 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93257 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93259 */     GIR_RootConstrainSelectedInstOperands,
     /*  93260 */     // GIR_Coverage, 411,
     /*  93260 */     GIR_EraseRootFromParent_Done,
     /*  93261 */   // Label 1466: @93261
     /*  93261 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(93298), // Rule ID 412 //
     /*  93266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshus),
     /*  93274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93287 */     // (intrinsic_w_chain:{ *:[v16i8] } 10438:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHUS),
     /*  93290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93292 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93294 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93296 */     GIR_RootConstrainSelectedInstOperands,
     /*  93297 */     // GIR_Coverage, 412,
     /*  93297 */     GIR_EraseRootFromParent_Done,
     /*  93298 */   // Label 1467: @93298
     /*  93298 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(93335), // Rule ID 413 //
     /*  93303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswss),
     /*  93311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93324 */     // (intrinsic_w_chain:{ *:[v8i16] } 10439:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWSS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWSS),
     /*  93327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93329 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93331 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93333 */     GIR_RootConstrainSelectedInstOperands,
     /*  93334 */     // GIR_Coverage, 413,
     /*  93334 */     GIR_EraseRootFromParent_Done,
     /*  93335 */   // Label 1468: @93335
     /*  93335 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(93372), // Rule ID 414 //
     /*  93340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswus),
     /*  93348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93361 */     // (intrinsic_w_chain:{ *:[v8i16] } 10440:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWUS),
     /*  93364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93366 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93368 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93370 */     GIR_RootConstrainSelectedInstOperands,
     /*  93371 */     // GIR_Coverage, 414,
     /*  93371 */     GIR_EraseRootFromParent_Done,
     /*  93372 */   // Label 1469: @93372
     /*  93372 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(93409), // Rule ID 415 //
     /*  93377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuhus),
     /*  93385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93398 */     // (intrinsic_w_chain:{ *:[v16i8] } 10442:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKUHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUHUS),
     /*  93401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93403 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93405 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93407 */     GIR_RootConstrainSelectedInstOperands,
     /*  93408 */     // GIR_Coverage, 415,
     /*  93408 */     GIR_EraseRootFromParent_Done,
     /*  93409 */   // Label 1470: @93409
     /*  93409 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(93446), // Rule ID 416 //
     /*  93414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuwus),
     /*  93422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93435 */     // (intrinsic_w_chain:{ *:[v8i16] } 10443:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKUWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUWUS),
     /*  93438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93440 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93442 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93444 */     GIR_RootConstrainSelectedInstOperands,
     /*  93445 */     // GIR_Coverage, 416,
     /*  93445 */     GIR_EraseRootFromParent_Done,
     /*  93446 */   // Label 1471: @93446
     /*  93446 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(93483), // Rule ID 500 //
     /*  93451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdss),
     /*  93459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93472 */     // (intrinsic_w_chain:{ *:[v4i32] } 10435:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDSS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDSS),
     /*  93475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93477 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93479 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93481 */     GIR_RootConstrainSelectedInstOperands,
     /*  93482 */     // GIR_Coverage, 500,
     /*  93482 */     GIR_EraseRootFromParent_Done,
     /*  93483 */   // Label 1472: @93483
     /*  93483 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(93520), // Rule ID 501 //
     /*  93488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdus),
     /*  93496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93509 */     // (intrinsic_w_chain:{ *:[v4i32] } 10436:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDUS),
     /*  93512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93514 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93516 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93518 */     GIR_RootConstrainSelectedInstOperands,
     /*  93519 */     // GIR_Coverage, 501,
     /*  93519 */     GIR_EraseRootFromParent_Done,
     /*  93520 */   // Label 1473: @93520
     /*  93520 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93557), // Rule ID 502 //
     /*  93525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkudus),
     /*  93533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93546 */     // (intrinsic_w_chain:{ *:[v4i32] } 10441:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKUDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUDUS),
     /*  93549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93551 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93553 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93555 */     GIR_RootConstrainSelectedInstOperands,
     /*  93556 */     // GIR_Coverage, 502,
     /*  93556 */     GIR_EraseRootFromParent_Done,
     /*  93557 */   // Label 1474: @93557
     /*  93557 */   GIM_Reject,
     /*  93558 */ // Label 1452: @93558
     /*  93558 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93774),
     /*  93563 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  93566 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(93605), // Rule ID 762 //
     /*  93571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addex),
     /*  93576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  93589 */     // MIs[0] CY
     /*  93589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  93592 */     // (intrinsic_w_chain:{ *:[i64] } 10202:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)  =>  (ADDEX8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)
     /*  93592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDEX8),
     /*  93595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93597 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93599 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93601 */     GIR_RootToRootCopy, /*OpIdx*/4, // CY
     /*  93603 */     GIR_RootConstrainSelectedInstOperands,
     /*  93604 */     // GIR_Coverage, 762,
     /*  93604 */     GIR_EraseRootFromParent_Done,
     /*  93605 */   // Label 1476: @93605
     /*  93605 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93647), // Rule ID 294 //
     /*  93610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhaddshs),
     /*  93618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  93630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93634 */     // (intrinsic_w_chain:{ *:[v8i16] } 10390:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  93634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHADDSHS),
     /*  93637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93639 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93641 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93643 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93645 */     GIR_RootConstrainSelectedInstOperands,
     /*  93646 */     // GIR_Coverage, 294,
     /*  93646 */     GIR_EraseRootFromParent_Done,
     /*  93647 */   // Label 1477: @93647
     /*  93647 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93689), // Rule ID 295 //
     /*  93652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhraddshs),
     /*  93660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  93672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93676 */     // (intrinsic_w_chain:{ *:[v8i16] } 10391:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHRADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  93676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHRADDSHS),
     /*  93679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93681 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93683 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93685 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93687 */     GIR_RootConstrainSelectedInstOperands,
     /*  93688 */     // GIR_Coverage, 295,
     /*  93688 */     GIR_EraseRootFromParent_Done,
     /*  93689 */   // Label 1478: @93689
     /*  93689 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93731), // Rule ID 353 //
     /*  93694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshs),
     /*  93702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  93714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93718 */     // (intrinsic_w_chain:{ *:[v4i32] } 10405:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  93718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHS),
     /*  93721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93723 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93725 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93727 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93729 */     GIR_RootConstrainSelectedInstOperands,
     /*  93730 */     // GIR_Coverage, 353,
     /*  93730 */     GIR_EraseRootFromParent_Done,
     /*  93731 */   // Label 1479: @93731
     /*  93731 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93773), // Rule ID 354 //
     /*  93736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhs),
     /*  93744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  93756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93760 */     // (intrinsic_w_chain:{ *:[v4i32] } 10409:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  93760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHS),
     /*  93763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93765 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93767 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93769 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93771 */     GIR_RootConstrainSelectedInstOperands,
     /*  93772 */     // GIR_Coverage, 354,
     /*  93772 */     GIR_EraseRootFromParent_Done,
     /*  93773 */   // Label 1480: @93773
     /*  93773 */   GIM_Reject,
     /*  93774 */ // Label 1475: @93774
     /*  93774 */ GIM_Reject,
     /*  93775 */ // Label 21: @93775
     /*  93775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1483*/ GIMT_Encode4(114530),
     /*  93786 */ /*GILLT_s32*//*Label 1481*/ GIMT_Encode4(93794),
     /*  93790 */ /*GILLT_s64*//*Label 1482*/ GIMT_Encode4(104015),
     /*  93794 */ // Label 1481: @93794
     /*  93794 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(104014),
     /*  93799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  93802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  93806 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(93918), // Rule ID 5292 //
     /*  93811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  93823 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  93827 */     // MIs[1] Operand 1
     /*  93827 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  93832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  93844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  93848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  93856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  93860 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  93864 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  93868 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93874 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  93874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  93881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  93890 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  93893 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  93896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  93901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  93903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  93907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93916 */     GIR_RootConstrainSelectedInstOperands,
     /*  93917 */     // GIR_Coverage, 5292,
     /*  93917 */     GIR_EraseRootFromParent_Done,
     /*  93918 */   // Label 1485: @93918
     /*  93918 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(94057), // Rule ID 5295 //
     /*  93923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  93935 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  93939 */     // MIs[1] Operand 1
     /*  93939 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  93944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  93956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  93960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  93968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  93972 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  93976 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  93980 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93986 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  93986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  93989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  93993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94002 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  94005 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94039 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94056 */     // GIR_Coverage, 5295,
     /*  94056 */     GIR_EraseRootFromParent_Done,
     /*  94057 */   // Label 1486: @94057
     /*  94057 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94190), // Rule ID 5300 //
     /*  94062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94074 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94078 */     // MIs[1] Operand 1
     /*  94078 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94115 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94125 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94125 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94128 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94132 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94137 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94141 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  94144 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  94156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94188 */     GIR_RootConstrainSelectedInstOperands,
     /*  94189 */     // GIR_Coverage, 5300,
     /*  94189 */     GIR_EraseRootFromParent_Done,
     /*  94190 */   // Label 1487: @94190
     /*  94190 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94350), // Rule ID 5303 //
     /*  94195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94207 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94211 */     // MIs[1] Operand 1
     /*  94211 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94244 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94248 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94252 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94258 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94258 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  94261 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94265 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94270 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94274 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  94277 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  94280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  94285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  94289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94322 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94332 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94349 */     // GIR_Coverage, 5303,
     /*  94349 */     GIR_EraseRootFromParent_Done,
     /*  94350 */   // Label 1488: @94350
     /*  94350 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94462), // Rule ID 3773 //
     /*  94355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94367 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94371 */     // MIs[1] Operand 1
     /*  94371 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94408 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94412 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94418 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94434 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  94437 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  94440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94460 */     GIR_RootConstrainSelectedInstOperands,
     /*  94461 */     // GIR_Coverage, 3773,
     /*  94461 */     GIR_EraseRootFromParent_Done,
     /*  94462 */   // Label 1489: @94462
     /*  94462 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94601), // Rule ID 3776 //
     /*  94467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94479 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94483 */     // MIs[1] Operand 1
     /*  94483 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94512 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94516 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94520 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94524 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94530 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94542 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94546 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  94549 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94583 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94600 */     // GIR_Coverage, 3776,
     /*  94600 */     GIR_EraseRootFromParent_Done,
     /*  94601 */   // Label 1490: @94601
     /*  94601 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94734), // Rule ID 3781 //
     /*  94606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94622 */     // MIs[1] Operand 1
     /*  94622 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94655 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94659 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94663 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94669 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94685 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  94688 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  94700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94732 */     GIR_RootConstrainSelectedInstOperands,
     /*  94733 */     // GIR_Coverage, 3781,
     /*  94733 */     GIR_EraseRootFromParent_Done,
     /*  94734 */   // Label 1491: @94734
     /*  94734 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94894), // Rule ID 3784 //
     /*  94739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94751 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94755 */     // MIs[1] Operand 1
     /*  94755 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94792 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94796 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94802 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94802 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  94805 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94809 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94814 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94818 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  94821 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  94824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  94829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  94833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94893 */     // GIR_Coverage, 3784,
     /*  94893 */     GIR_EraseRootFromParent_Done,
     /*  94894 */   // Label 1492: @94894
     /*  94894 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94963), // Rule ID 3693 //
     /*  94899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94911 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94915 */     // MIs[1] Operand 1
     /*  94915 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94920 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94926 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  94933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  94947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  94955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94961 */     GIR_RootConstrainSelectedInstOperands,
     /*  94962 */     // GIR_Coverage, 3693,
     /*  94962 */     GIR_EraseRootFromParent_Done,
     /*  94963 */   // Label 1493: @94963
     /*  94963 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(95059), // Rule ID 3696 //
     /*  94968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94980 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94984 */     // MIs[1] Operand 1
     /*  94984 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94989 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94995 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  94998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95025 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95028 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  95031 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95041 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95058 */     // GIR_Coverage, 3696,
     /*  95058 */     GIR_EraseRootFromParent_Done,
     /*  95059 */   // Label 1494: @95059
     /*  95059 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(95166), // Rule ID 3701 //
     /*  95064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95076 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95080 */     // MIs[1] Operand 1
     /*  95080 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95091 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95091 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95094 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95098 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95103 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95109 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95112 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95116 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95121 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95142 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  95158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95164 */     GIR_RootConstrainSelectedInstOperands,
     /*  95165 */     // GIR_Coverage, 3701,
     /*  95165 */     GIR_EraseRootFromParent_Done,
     /*  95166 */   // Label 1495: @95166
     /*  95166 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(95300), // Rule ID 3704 //
     /*  95171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95183 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95187 */     // MIs[1] Operand 1
     /*  95187 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95192 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95198 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95198 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  95201 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95205 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95210 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95216 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  95219 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95223 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95228 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95234 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95237 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95241 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95246 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  95249 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  95252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95266 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95269 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  95272 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95282 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95299 */     // GIR_Coverage, 3704,
     /*  95299 */     GIR_EraseRootFromParent_Done,
     /*  95300 */   // Label 1496: @95300
     /*  95300 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(95352), // Rule ID 3709 //
     /*  95305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95317 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95321 */     // MIs[1] Operand 1
     /*  95321 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  95326 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95332 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95350 */     GIR_RootConstrainSelectedInstOperands,
     /*  95351 */     // GIR_Coverage, 3709,
     /*  95351 */     GIR_EraseRootFromParent_Done,
     /*  95352 */   // Label 1497: @95352
     /*  95352 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(95431), // Rule ID 3712 //
     /*  95357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95373 */     // MIs[1] Operand 1
     /*  95373 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  95378 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95384 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95400 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95403 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95430 */     // GIR_Coverage, 3712,
     /*  95430 */     GIR_EraseRootFromParent_Done,
     /*  95431 */   // Label 1498: @95431
     /*  95431 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95504), // Rule ID 3717 //
     /*  95436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95448 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95452 */     // MIs[1] Operand 1
     /*  95452 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  95457 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95463 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95502 */     GIR_RootConstrainSelectedInstOperands,
     /*  95503 */     // GIR_Coverage, 3717,
     /*  95503 */     GIR_EraseRootFromParent_Done,
     /*  95504 */   // Label 1499: @95504
     /*  95504 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95604), // Rule ID 3720 //
     /*  95509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95521 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95525 */     // MIs[1] Operand 1
     /*  95525 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  95530 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95536 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95548 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95586 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95603 */     // GIR_Coverage, 3720,
     /*  95603 */     GIR_EraseRootFromParent_Done,
     /*  95604 */   // Label 1500: @95604
     /*  95604 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95694), // Rule ID 3725 //
     /*  95609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95621 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95625 */     // MIs[1] Operand 1
     /*  95625 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  95630 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95636 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  95643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95648 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*  95661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95666 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95669 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95692 */     GIR_RootConstrainSelectedInstOperands,
     /*  95693 */     // GIR_Coverage, 3725,
     /*  95693 */     GIR_EraseRootFromParent_Done,
     /*  95694 */   // Label 1501: @95694
     /*  95694 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95811), // Rule ID 3728 //
     /*  95699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95711 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95715 */     // MIs[1] Operand 1
     /*  95715 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  95720 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95726 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  95729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  95733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95738 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95744 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95747 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*  95751 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95756 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  95759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95780 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95793 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95810 */     // GIR_Coverage, 3728,
     /*  95810 */     GIR_EraseRootFromParent_Done,
     /*  95811 */   // Label 1502: @95811
     /*  95811 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(95901), // Rule ID 3733 //
     /*  95816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95832 */     // MIs[1] Operand 1
     /*  95832 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  95837 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95843 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  95850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*  95868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95877 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95899 */     GIR_RootConstrainSelectedInstOperands,
     /*  95900 */     // GIR_Coverage, 3733,
     /*  95900 */     GIR_EraseRootFromParent_Done,
     /*  95901 */   // Label 1503: @95901
     /*  95901 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(96018), // Rule ID 3736 //
     /*  95906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95918 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95922 */     // MIs[1] Operand 1
     /*  95922 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  95927 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95933 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95933 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  95936 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  95940 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95945 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*  95958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95967 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  95970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95984 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95987 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96000 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96017 */     // GIR_Coverage, 3736,
     /*  96017 */     GIR_EraseRootFromParent_Done,
     /*  96018 */   // Label 1504: @96018
     /*  96018 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(96111), // Rule ID 3741 //
     /*  96023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96035 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96039 */     // MIs[1] Operand 1
     /*  96039 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  96044 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96050 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  96057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96062 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96066 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  96069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*  96078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96109 */     GIR_RootConstrainSelectedInstOperands,
     /*  96110 */     // GIR_Coverage, 3741,
     /*  96110 */     GIR_EraseRootFromParent_Done,
     /*  96111 */   // Label 1505: @96111
     /*  96111 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(96231), // Rule ID 3744 //
     /*  96116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96128 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96132 */     // MIs[1] Operand 1
     /*  96132 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  96137 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96143 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96143 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96146 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  96150 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96155 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96159 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  96162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*  96171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96176 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96180 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96197 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96200 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96203 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96213 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96230 */     // GIR_Coverage, 3744,
     /*  96230 */     GIR_EraseRootFromParent_Done,
     /*  96231 */   // Label 1506: @96231
     /*  96231 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(96324), // Rule ID 3749 //
     /*  96236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96248 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96252 */     // MIs[1] Operand 1
     /*  96252 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96257 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96263 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  96270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96275 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96279 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  96282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  96291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96296 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96322 */     GIR_RootConstrainSelectedInstOperands,
     /*  96323 */     // GIR_Coverage, 3749,
     /*  96323 */     GIR_EraseRootFromParent_Done,
     /*  96324 */   // Label 1507: @96324
     /*  96324 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(96444), // Rule ID 3752 //
     /*  96329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96341 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96345 */     // MIs[1] Operand 1
     /*  96345 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96350 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96356 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96356 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96359 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  96363 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96368 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96372 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  96375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  96384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96389 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96393 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96410 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96416 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96426 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96443 */     // GIR_Coverage, 3752,
     /*  96443 */     GIR_EraseRootFromParent_Done,
     /*  96444 */   // Label 1508: @96444
     /*  96444 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(96517), // Rule ID 3757 //
     /*  96449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96461 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96465 */     // MIs[1] Operand 1
     /*  96465 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96476 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  96483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96515 */     GIR_RootConstrainSelectedInstOperands,
     /*  96516 */     // GIR_Coverage, 3757,
     /*  96516 */     GIR_EraseRootFromParent_Done,
     /*  96517 */   // Label 1509: @96517
     /*  96517 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(96617), // Rule ID 3760 //
     /*  96522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96534 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96538 */     // MIs[1] Operand 1
     /*  96538 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96543 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96549 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96549 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96552 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  96556 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96561 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96565 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96586 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96589 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96599 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96616 */     // GIR_Coverage, 3760,
     /*  96616 */     GIR_EraseRootFromParent_Done,
     /*  96617 */   // Label 1510: @96617
     /*  96617 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96669), // Rule ID 3765 //
     /*  96622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96634 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96638 */     // MIs[1] Operand 1
     /*  96638 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96643 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96649 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96667 */     GIR_RootConstrainSelectedInstOperands,
     /*  96668 */     // GIR_Coverage, 3765,
     /*  96668 */     GIR_EraseRootFromParent_Done,
     /*  96669 */   // Label 1511: @96669
     /*  96669 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96748), // Rule ID 3768 //
     /*  96674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96686 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96690 */     // MIs[1] Operand 1
     /*  96690 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96695 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96701 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96720 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96730 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96747 */     // GIR_Coverage, 3768,
     /*  96747 */     GIR_EraseRootFromParent_Done,
     /*  96748 */   // Label 1512: @96748
     /*  96748 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96851), // Rule ID 3033 //
     /*  96753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  96756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96768 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96772 */     // MIs[1] Operand 1
     /*  96772 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  96781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  96785 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  96789 */     // MIs[2] Operand 1
     /*  96789 */     // No operand predicates
     /*  96789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  96791 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /*  96791 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96794 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  96798 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96803 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  96810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96824 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  96831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96849 */     GIR_RootConstrainSelectedInstOperands,
     /*  96850 */     // GIR_Coverage, 3033,
     /*  96850 */     GIR_EraseRootFromParent_Done,
     /*  96851 */   // Label 1513: @96851
     /*  96851 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96954), // Rule ID 3049 //
     /*  96856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  96859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96871 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96875 */     // MIs[1] Operand 1
     /*  96875 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  96884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  96888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  96892 */     // MIs[2] Operand 1
     /*  96892 */     // No operand predicates
     /*  96892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  96894 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /*  96894 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96897 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  96901 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96906 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  96913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96927 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  96934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96952 */     GIR_RootConstrainSelectedInstOperands,
     /*  96953 */     // GIR_Coverage, 3049,
     /*  96953 */     GIR_EraseRootFromParent_Done,
     /*  96954 */   // Label 1514: @96954
     /*  96954 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(97057), // Rule ID 3057 //
     /*  96959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  96962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96974 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96978 */     // MIs[1] Operand 1
     /*  96978 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  96983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  96987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  96991 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  96995 */     // MIs[2] Operand 1
     /*  96995 */     // No operand predicates
     /*  96995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  96997 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /*  96997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97009 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97030 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97055 */     GIR_RootConstrainSelectedInstOperands,
     /*  97056 */     // GIR_Coverage, 3057,
     /*  97056 */     GIR_EraseRootFromParent_Done,
     /*  97057 */   // Label 1515: @97057
     /*  97057 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(97160), // Rule ID 3129 //
     /*  97062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97077 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97081 */     // MIs[1] Operand 1
     /*  97081 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97094 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97098 */     // MIs[2] Operand 1
     /*  97098 */     // No operand predicates
     /*  97098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97100 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /*  97100 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97103 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97107 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97112 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97133 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97158 */     GIR_RootConstrainSelectedInstOperands,
     /*  97159 */     // GIR_Coverage, 3129,
     /*  97159 */     GIR_EraseRootFromParent_Done,
     /*  97160 */   // Label 1516: @97160
     /*  97160 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(97263), // Rule ID 3145 //
     /*  97165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97184 */     // MIs[1] Operand 1
     /*  97184 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97201 */     // MIs[2] Operand 1
     /*  97201 */     // No operand predicates
     /*  97201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97203 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /*  97203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97236 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97261 */     GIR_RootConstrainSelectedInstOperands,
     /*  97262 */     // GIR_Coverage, 3145,
     /*  97262 */     GIR_EraseRootFromParent_Done,
     /*  97263 */   // Label 1517: @97263
     /*  97263 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(97366), // Rule ID 3153 //
     /*  97268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97283 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97287 */     // MIs[1] Operand 1
     /*  97287 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  97292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97300 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97304 */     // MIs[2] Operand 1
     /*  97304 */     // No operand predicates
     /*  97304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97306 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /*  97306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97339 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97364 */     GIR_RootConstrainSelectedInstOperands,
     /*  97365 */     // GIR_Coverage, 3153,
     /*  97365 */     GIR_EraseRootFromParent_Done,
     /*  97366 */   // Label 1518: @97366
     /*  97366 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(97509), // Rule ID 3815 //
     /*  97371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97386 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97390 */     // MIs[1] Operand 1
     /*  97390 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97403 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97407 */     // MIs[2] Operand 1
     /*  97407 */     // No operand predicates
     /*  97407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97409 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97421 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97430 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97433 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97437 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97442 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97447 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97450 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97454 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97459 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97476 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97507 */     GIR_RootConstrainSelectedInstOperands,
     /*  97508 */     // GIR_Coverage, 3815,
     /*  97508 */     GIR_EraseRootFromParent_Done,
     /*  97509 */   // Label 1519: @97509
     /*  97509 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(97652), // Rule ID 3831 //
     /*  97514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97529 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97533 */     // MIs[1] Operand 1
     /*  97533 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97546 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97550 */     // MIs[2] Operand 1
     /*  97550 */     // No operand predicates
     /*  97550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97552 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97564 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97573 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97576 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97580 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97585 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97590 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97593 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97597 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97602 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97619 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97650 */     GIR_RootConstrainSelectedInstOperands,
     /*  97651 */     // GIR_Coverage, 3831,
     /*  97651 */     GIR_EraseRootFromParent_Done,
     /*  97652 */   // Label 1520: @97652
     /*  97652 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(97795), // Rule ID 3839 //
     /*  97657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97672 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97676 */     // MIs[1] Operand 1
     /*  97676 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  97681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97689 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97693 */     // MIs[2] Operand 1
     /*  97693 */     // No operand predicates
     /*  97693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97695 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97707 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97716 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97719 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97723 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97728 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97733 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97736 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97740 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97745 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97762 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97793 */     GIR_RootConstrainSelectedInstOperands,
     /*  97794 */     // GIR_Coverage, 3839,
     /*  97794 */     GIR_EraseRootFromParent_Done,
     /*  97795 */   // Label 1521: @97795
     /*  97795 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(97938), // Rule ID 3911 //
     /*  97800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97815 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97819 */     // MIs[1] Operand 1
     /*  97819 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97832 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97836 */     // MIs[2] Operand 1
     /*  97836 */     // No operand predicates
     /*  97836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97838 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97850 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97859 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97862 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97866 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97871 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97876 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97879 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97883 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97888 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97905 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97936 */     GIR_RootConstrainSelectedInstOperands,
     /*  97937 */     // GIR_Coverage, 3911,
     /*  97937 */     GIR_EraseRootFromParent_Done,
     /*  97938 */   // Label 1522: @97938
     /*  97938 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(98081), // Rule ID 3927 //
     /*  97943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97958 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97962 */     // MIs[1] Operand 1
     /*  97962 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97975 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97979 */     // MIs[2] Operand 1
     /*  97979 */     // No operand predicates
     /*  97979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97981 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97981 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97984 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97988 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97993 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98002 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98005 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98009 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98014 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98019 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98022 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98026 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98031 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98048 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98079 */     GIR_RootConstrainSelectedInstOperands,
     /*  98080 */     // GIR_Coverage, 3927,
     /*  98080 */     GIR_EraseRootFromParent_Done,
     /*  98081 */   // Label 1523: @98081
     /*  98081 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(98224), // Rule ID 3935 //
     /*  98086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  98089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  98097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98101 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98105 */     // MIs[1] Operand 1
     /*  98105 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  98110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98118 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  98122 */     // MIs[2] Operand 1
     /*  98122 */     // No operand predicates
     /*  98122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98124 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  98131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98136 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98145 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98148 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98152 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98157 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98174 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98191 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98222 */     GIR_RootConstrainSelectedInstOperands,
     /*  98223 */     // GIR_Coverage, 3935,
     /*  98223 */     GIR_EraseRootFromParent_Done,
     /*  98224 */   // Label 1524: @98224
     /*  98224 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(98316), // Rule ID 3177 //
     /*  98229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98244 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98248 */     // MIs[1] Operand 1
     /*  98248 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98255 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /*  98255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98267 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98271 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98289 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98314 */     GIR_RootConstrainSelectedInstOperands,
     /*  98315 */     // GIR_Coverage, 3177,
     /*  98315 */     GIR_EraseRootFromParent_Done,
     /*  98316 */   // Label 1525: @98316
     /*  98316 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(98408), // Rule ID 3193 //
     /*  98321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98340 */     // MIs[1] Operand 1
     /*  98340 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  98345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98347 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /*  98347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98363 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98381 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98406 */     GIR_RootConstrainSelectedInstOperands,
     /*  98407 */     // GIR_Coverage, 3193,
     /*  98407 */     GIR_EraseRootFromParent_Done,
     /*  98408 */   // Label 1526: @98408
     /*  98408 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(98500), // Rule ID 3209 //
     /*  98413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98428 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98432 */     // MIs[1] Operand 1
     /*  98432 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  98437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98439 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /*  98439 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98442 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98446 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98473 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98498 */     GIR_RootConstrainSelectedInstOperands,
     /*  98499 */     // GIR_Coverage, 3209,
     /*  98499 */     GIR_EraseRootFromParent_Done,
     /*  98500 */   // Label 1527: @98500
     /*  98500 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(98592), // Rule ID 3225 //
     /*  98505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98520 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98524 */     // MIs[1] Operand 1
     /*  98524 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  98529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98531 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /*  98531 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98534 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98538 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98543 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98565 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  98572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98590 */     GIR_RootConstrainSelectedInstOperands,
     /*  98591 */     // GIR_Coverage, 3225,
     /*  98591 */     GIR_EraseRootFromParent_Done,
     /*  98592 */   // Label 1528: @98592
     /*  98592 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(98684), // Rule ID 3233 //
     /*  98597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98612 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98616 */     // MIs[1] Operand 1
     /*  98616 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98623 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /*  98623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98639 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98657 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98682 */     GIR_RootConstrainSelectedInstOperands,
     /*  98683 */     // GIR_Coverage, 3233,
     /*  98683 */     GIR_EraseRootFromParent_Done,
     /*  98684 */   // Label 1529: @98684
     /*  98684 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(98776), // Rule ID 3249 //
     /*  98689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98704 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98708 */     // MIs[1] Operand 1
     /*  98708 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  98713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98715 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /*  98715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98731 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98749 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98774 */     GIR_RootConstrainSelectedInstOperands,
     /*  98775 */     // GIR_Coverage, 3249,
     /*  98775 */     GIR_EraseRootFromParent_Done,
     /*  98776 */   // Label 1530: @98776
     /*  98776 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(98868), // Rule ID 3265 //
     /*  98781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98796 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98800 */     // MIs[1] Operand 1
     /*  98800 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  98805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98807 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /*  98807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98841 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98866 */     GIR_RootConstrainSelectedInstOperands,
     /*  98867 */     // GIR_Coverage, 3265,
     /*  98867 */     GIR_EraseRootFromParent_Done,
     /*  98868 */   // Label 1531: @98868
     /*  98868 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(98960), // Rule ID 3281 //
     /*  98873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98888 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98892 */     // MIs[1] Operand 1
     /*  98892 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  98897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98899 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /*  98899 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98902 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98906 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98915 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98933 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  98940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98958 */     GIR_RootConstrainSelectedInstOperands,
     /*  98959 */     // GIR_Coverage, 3281,
     /*  98959 */     GIR_EraseRootFromParent_Done,
     /*  98960 */   // Label 1532: @98960
     /*  98960 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(99052), // Rule ID 3289 //
     /*  98965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  98980 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  98984 */     // MIs[1] Operand 1
     /*  98984 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98991 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /*  98991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  98998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99025 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99050 */     GIR_RootConstrainSelectedInstOperands,
     /*  99051 */     // GIR_Coverage, 3289,
     /*  99051 */     GIR_EraseRootFromParent_Done,
     /*  99052 */   // Label 1533: @99052
     /*  99052 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(99144), // Rule ID 3305 //
     /*  99057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99072 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99076 */     // MIs[1] Operand 1
     /*  99076 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99083 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /*  99083 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99086 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99090 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99095 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99117 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99142 */     GIR_RootConstrainSelectedInstOperands,
     /*  99143 */     // GIR_Coverage, 3305,
     /*  99143 */     GIR_EraseRootFromParent_Done,
     /*  99144 */   // Label 1534: @99144
     /*  99144 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(99236), // Rule ID 3321 //
     /*  99149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99168 */     // MIs[1] Operand 1
     /*  99168 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99175 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /*  99175 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99178 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99182 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99209 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  99216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99234 */     GIR_RootConstrainSelectedInstOperands,
     /*  99235 */     // GIR_Coverage, 3321,
     /*  99235 */     GIR_EraseRootFromParent_Done,
     /*  99236 */   // Label 1535: @99236
     /*  99236 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(99328), // Rule ID 3337 //
     /*  99241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99256 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99260 */     // MIs[1] Operand 1
     /*  99260 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  99265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99267 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /*  99267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99283 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99301 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  99308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99326 */     GIR_RootConstrainSelectedInstOperands,
     /*  99327 */     // GIR_Coverage, 3337,
     /*  99327 */     GIR_EraseRootFromParent_Done,
     /*  99328 */   // Label 1536: @99328
     /*  99328 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(99460), // Rule ID 4020 //
     /*  99333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99348 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99352 */     // MIs[1] Operand 1
     /*  99352 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  99357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99359 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99381 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99384 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99388 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99393 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99398 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99401 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99405 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99410 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99427 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99458 */     GIR_RootConstrainSelectedInstOperands,
     /*  99459 */     // GIR_Coverage, 4020,
     /*  99459 */     GIR_EraseRootFromParent_Done,
     /*  99460 */   // Label 1537: @99460
     /*  99460 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99592), // Rule ID 4052 //
     /*  99465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99484 */     // MIs[1] Operand 1
     /*  99484 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99491 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99507 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99513 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99516 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99520 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99525 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99530 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99533 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99537 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99542 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99559 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99590 */     GIR_RootConstrainSelectedInstOperands,
     /*  99591 */     // GIR_Coverage, 4052,
     /*  99591 */     GIR_EraseRootFromParent_Done,
     /*  99592 */   // Label 1538: @99592
     /*  99592 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99724), // Rule ID 4084 //
     /*  99597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99612 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99616 */     // MIs[1] Operand 1
     /*  99616 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99623 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99639 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99645 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99648 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99652 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99657 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99662 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99665 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99669 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99674 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99691 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  99698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99722 */     GIR_RootConstrainSelectedInstOperands,
     /*  99723 */     // GIR_Coverage, 4084,
     /*  99723 */     GIR_EraseRootFromParent_Done,
     /*  99724 */   // Label 1539: @99724
     /*  99724 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99856), // Rule ID 4116 //
     /*  99729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99744 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99748 */     // MIs[1] Operand 1
     /*  99748 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  99753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99755 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99755 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99758 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99762 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99767 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99771 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99777 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99780 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99784 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99789 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99794 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99797 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99801 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99806 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99823 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  99830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99854 */     GIR_RootConstrainSelectedInstOperands,
     /*  99855 */     // GIR_Coverage, 4116,
     /*  99855 */     GIR_EraseRootFromParent_Done,
     /*  99856 */   // Label 1540: @99856
     /*  99856 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99988), // Rule ID 4132 //
     /*  99861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99876 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99880 */     // MIs[1] Operand 1
     /*  99880 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  99885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99887 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  99894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99903 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99909 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99912 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99916 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99921 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99938 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99955 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99986 */     GIR_RootConstrainSelectedInstOperands,
     /*  99987 */     // GIR_Coverage, 4132,
     /*  99987 */     GIR_EraseRootFromParent_Done,
     /*  99988 */   // Label 1541: @99988
     /*  99988 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(100120), // Rule ID 4164 //
     /*  99993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100008 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100012 */     // MIs[1] Operand 1
     /* 100012 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 100017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100019 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100035 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100041 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100044 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100048 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100053 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100058 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100061 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100065 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100070 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100087 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100118 */     GIR_RootConstrainSelectedInstOperands,
     /* 100119 */     // GIR_Coverage, 4164,
     /* 100119 */     GIR_EraseRootFromParent_Done,
     /* 100120 */   // Label 1542: @100120
     /* 100120 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(100252), // Rule ID 4196 //
     /* 100125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100140 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100144 */     // MIs[1] Operand 1
     /* 100144 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 100149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100151 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100151 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100154 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100158 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100163 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100167 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100173 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100176 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100180 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100185 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100190 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100193 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100197 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100202 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100219 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100250 */     GIR_RootConstrainSelectedInstOperands,
     /* 100251 */     // GIR_Coverage, 4196,
     /* 100251 */     GIR_EraseRootFromParent_Done,
     /* 100252 */   // Label 1543: @100252
     /* 100252 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(100384), // Rule ID 4228 //
     /* 100257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100272 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100276 */     // MIs[1] Operand 1
     /* 100276 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 100281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100283 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100295 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100299 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100305 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100308 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100312 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100317 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100322 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100325 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100329 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100334 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100351 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 100358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100382 */     GIR_RootConstrainSelectedInstOperands,
     /* 100383 */     // GIR_Coverage, 4228,
     /* 100383 */     GIR_EraseRootFromParent_Done,
     /* 100384 */   // Label 1544: @100384
     /* 100384 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(100516), // Rule ID 4258 //
     /* 100389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100404 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100408 */     // MIs[1] Operand 1
     /* 100408 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 100413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100415 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100431 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100437 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100440 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100444 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100449 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100454 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100457 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100461 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100466 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100483 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 100490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100514 */     GIR_RootConstrainSelectedInstOperands,
     /* 100515 */     // GIR_Coverage, 4258,
     /* 100515 */     GIR_EraseRootFromParent_Done,
     /* 100516 */   // Label 1545: @100516
     /* 100516 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(100648), // Rule ID 4290 //
     /* 100521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100536 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100540 */     // MIs[1] Operand 1
     /* 100540 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 100545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100547 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100547 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100550 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100554 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100559 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100563 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100569 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100572 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100576 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100581 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100586 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100589 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100593 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100598 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100615 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100646 */     GIR_RootConstrainSelectedInstOperands,
     /* 100647 */     // GIR_Coverage, 4290,
     /* 100647 */     GIR_EraseRootFromParent_Done,
     /* 100648 */   // Label 1546: @100648
     /* 100648 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(100780), // Rule ID 4322 //
     /* 100653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100668 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100672 */     // MIs[1] Operand 1
     /* 100672 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 100677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100679 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100695 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100701 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100704 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100708 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100713 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100718 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100721 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100725 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100730 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100747 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100778 */     GIR_RootConstrainSelectedInstOperands,
     /* 100779 */     // GIR_Coverage, 4322,
     /* 100779 */     GIR_EraseRootFromParent_Done,
     /* 100780 */   // Label 1547: @100780
     /* 100780 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100912), // Rule ID 4354 //
     /* 100785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100800 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100804 */     // MIs[1] Operand 1
     /* 100804 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 100809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100811 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100811 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100814 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100818 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100833 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100836 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100840 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100845 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100850 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100853 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100857 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100862 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100879 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 100886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100910 */     GIR_RootConstrainSelectedInstOperands,
     /* 100911 */     // GIR_Coverage, 4354,
     /* 100911 */     GIR_EraseRootFromParent_Done,
     /* 100912 */   // Label 1548: @100912
     /* 100912 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(101044), // Rule ID 4585 //
     /* 100917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 100920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 100932 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100936 */     // MIs[1] Operand 1
     /* 100936 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 100941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100943 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100943 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100946 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 100950 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100965 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100968 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100972 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100977 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100982 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100985 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100989 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100994 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101011 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101042 */     GIR_RootConstrainSelectedInstOperands,
     /* 101043 */     // GIR_Coverage, 4585,
     /* 101043 */     GIR_EraseRootFromParent_Done,
     /* 101044 */   // Label 1549: @101044
     /* 101044 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(101176), // Rule ID 4617 //
     /* 101049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101064 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101068 */     // MIs[1] Operand 1
     /* 101068 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 101073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101075 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101075 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101078 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 101082 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101091 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101097 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101100 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101104 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101109 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101114 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101117 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101121 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101126 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101143 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101174 */     GIR_RootConstrainSelectedInstOperands,
     /* 101175 */     // GIR_Coverage, 4617,
     /* 101175 */     GIR_EraseRootFromParent_Done,
     /* 101176 */   // Label 1550: @101176
     /* 101176 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(101308), // Rule ID 4649 //
     /* 101181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101196 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101200 */     // MIs[1] Operand 1
     /* 101200 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 101205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101207 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101207 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101210 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 101214 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101223 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101229 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101232 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101236 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101241 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101246 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101249 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101253 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101258 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101275 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101306 */     GIR_RootConstrainSelectedInstOperands,
     /* 101307 */     // GIR_Coverage, 4649,
     /* 101307 */     GIR_EraseRootFromParent_Done,
     /* 101308 */   // Label 1551: @101308
     /* 101308 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(101440), // Rule ID 4693 //
     /* 101313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101328 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101332 */     // MIs[1] Operand 1
     /* 101332 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 101337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101339 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 101346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101351 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101361 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101364 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101368 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101373 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101378 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101381 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101385 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101390 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101407 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101438 */     GIR_RootConstrainSelectedInstOperands,
     /* 101439 */     // GIR_Coverage, 4693,
     /* 101439 */     GIR_EraseRootFromParent_Done,
     /* 101440 */   // Label 1552: @101440
     /* 101440 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(101572), // Rule ID 4725 //
     /* 101445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101460 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101464 */     // MIs[1] Operand 1
     /* 101464 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 101469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101471 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 101478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101493 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101496 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101500 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101505 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101510 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101513 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101517 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101522 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101539 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101570 */     GIR_RootConstrainSelectedInstOperands,
     /* 101571 */     // GIR_Coverage, 4725,
     /* 101571 */     GIR_EraseRootFromParent_Done,
     /* 101572 */   // Label 1553: @101572
     /* 101572 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(101704), // Rule ID 4757 //
     /* 101577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101592 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101596 */     // MIs[1] Operand 1
     /* 101596 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 101601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101603 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101603 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101606 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 101610 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101619 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101625 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101628 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101632 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101637 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101642 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101645 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101649 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101654 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101671 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101702 */     GIR_RootConstrainSelectedInstOperands,
     /* 101703 */     // GIR_Coverage, 4757,
     /* 101703 */     GIR_EraseRootFromParent_Done,
     /* 101704 */   // Label 1554: @101704
     /* 101704 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(101796), // Rule ID 2979 //
     /* 101709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 101712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101724 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101728 */     // MIs[1] Operand 1
     /* 101728 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 101733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101735 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 101735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 101742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101751 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101769 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 101776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 101789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 101791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101794 */     GIR_RootConstrainSelectedInstOperands,
     /* 101795 */     // GIR_Coverage, 2979,
     /* 101795 */     GIR_EraseRootFromParent_Done,
     /* 101796 */   // Label 1555: @101796
     /* 101796 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(101888), // Rule ID 2993 //
     /* 101801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 101804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101816 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101820 */     // MIs[1] Operand 1
     /* 101820 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 101825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101827 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 101827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 101834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101843 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101861 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 101868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 101881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 101883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101886 */     GIR_RootConstrainSelectedInstOperands,
     /* 101887 */     // GIR_Coverage, 2993,
     /* 101887 */     GIR_EraseRootFromParent_Done,
     /* 101888 */   // Label 1556: @101888
     /* 101888 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(101980), // Rule ID 3001 //
     /* 101893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 101896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101908 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101912 */     // MIs[1] Operand 1
     /* 101912 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 101917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101919 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 101919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 101926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101953 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 101973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 101975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101978 */     GIR_RootConstrainSelectedInstOperands,
     /* 101979 */     // GIR_Coverage, 3001,
     /* 101979 */     GIR_EraseRootFromParent_Done,
     /* 101980 */   // Label 1557: @101980
     /* 101980 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(102072), // Rule ID 3009 //
     /* 101985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 101988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102000 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102004 */     // MIs[1] Operand 1
     /* 102004 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 102009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102011 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 102011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102023 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102027 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102045 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102070 */     GIR_RootConstrainSelectedInstOperands,
     /* 102071 */     // GIR_Coverage, 3009,
     /* 102071 */     GIR_EraseRootFromParent_Done,
     /* 102072 */   // Label 1558: @102072
     /* 102072 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(102164), // Rule ID 3017 //
     /* 102077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102096 */     // MIs[1] Operand 1
     /* 102096 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102103 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 102103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102137 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 102144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102162 */     GIR_RootConstrainSelectedInstOperands,
     /* 102163 */     // GIR_Coverage, 3017,
     /* 102163 */     GIR_EraseRootFromParent_Done,
     /* 102164 */   // Label 1559: @102164
     /* 102164 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(102256), // Rule ID 3081 //
     /* 102169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102184 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102188 */     // MIs[1] Operand 1
     /* 102188 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102195 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 102195 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 102202 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102211 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102229 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102254 */     GIR_RootConstrainSelectedInstOperands,
     /* 102255 */     // GIR_Coverage, 3081,
     /* 102255 */     GIR_EraseRootFromParent_Done,
     /* 102256 */   // Label 1560: @102256
     /* 102256 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(102348), // Rule ID 3089 //
     /* 102261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102276 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102280 */     // MIs[1] Operand 1
     /* 102280 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 102285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102287 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 102287 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102290 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102294 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102299 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102303 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102321 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102346 */     GIR_RootConstrainSelectedInstOperands,
     /* 102347 */     // GIR_Coverage, 3089,
     /* 102347 */     GIR_EraseRootFromParent_Done,
     /* 102348 */   // Label 1561: @102348
     /* 102348 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(102440), // Rule ID 3097 //
     /* 102353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102368 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102372 */     // MIs[1] Operand 1
     /* 102372 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 102377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102379 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 102379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 102386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102391 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102395 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102413 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102438 */     GIR_RootConstrainSelectedInstOperands,
     /* 102439 */     // GIR_Coverage, 3097,
     /* 102439 */     GIR_EraseRootFromParent_Done,
     /* 102440 */   // Label 1562: @102440
     /* 102440 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(102532), // Rule ID 3105 //
     /* 102445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102460 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102464 */     // MIs[1] Operand 1
     /* 102464 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 102469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102471 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 102471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102505 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102530 */     GIR_RootConstrainSelectedInstOperands,
     /* 102531 */     // GIR_Coverage, 3105,
     /* 102531 */     GIR_EraseRootFromParent_Done,
     /* 102532 */   // Label 1563: @102532
     /* 102532 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(102624), // Rule ID 3113 //
     /* 102537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102552 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102556 */     // MIs[1] Operand 1
     /* 102556 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102563 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 102563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102579 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102597 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 102604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102622 */     GIR_RootConstrainSelectedInstOperands,
     /* 102623 */     // GIR_Coverage, 3113,
     /* 102623 */     GIR_EraseRootFromParent_Done,
     /* 102624 */   // Label 1564: @102624
     /* 102624 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(102756), // Rule ID 3863 //
     /* 102629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 102632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102644 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102648 */     // MIs[1] Operand 1
     /* 102648 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102655 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 102655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102671 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102677 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 102680 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102684 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102689 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 102692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102694 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102697 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102701 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102706 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102723 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 102743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 102754 */     GIR_RootConstrainSelectedInstOperands,
     /* 102755 */     // GIR_Coverage, 3863,
     /* 102755 */     GIR_EraseRootFromParent_Done,
     /* 102756 */   // Label 1565: @102756
     /* 102756 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(102888), // Rule ID 3871 //
     /* 102761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 102764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102776 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102780 */     // MIs[1] Operand 1
     /* 102780 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 102785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102787 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 102787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102803 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102809 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 102812 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102816 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102821 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 102824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102838 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102855 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 102875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 102886 */     GIR_RootConstrainSelectedInstOperands,
     /* 102887 */     // GIR_Coverage, 3871,
     /* 102887 */     GIR_EraseRootFromParent_Done,
     /* 102888 */   // Label 1566: @102888
     /* 102888 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(103020), // Rule ID 3879 //
     /* 102893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 102896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102908 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102912 */     // MIs[1] Operand 1
     /* 102912 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 102917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102919 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 102919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102941 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 102944 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102948 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102953 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 102956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102958 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102961 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102965 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102970 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102987 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103018 */     GIR_RootConstrainSelectedInstOperands,
     /* 103019 */     // GIR_Coverage, 3879,
     /* 103019 */     GIR_EraseRootFromParent_Done,
     /* 103020 */   // Label 1567: @103020
     /* 103020 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(103152), // Rule ID 3887 //
     /* 103025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103040 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103044 */     // MIs[1] Operand 1
     /* 103044 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 103049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103051 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103063 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103067 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103073 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103076 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103080 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103085 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103090 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103093 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103097 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103102 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103119 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103150 */     GIR_RootConstrainSelectedInstOperands,
     /* 103151 */     // GIR_Coverage, 3887,
     /* 103151 */     GIR_EraseRootFromParent_Done,
     /* 103152 */   // Label 1568: @103152
     /* 103152 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(103284), // Rule ID 3895 //
     /* 103157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103172 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103176 */     // MIs[1] Operand 1
     /* 103176 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 103181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103183 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103183 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103186 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103190 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103199 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103205 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103208 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103212 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103217 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103222 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103225 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103229 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103234 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103251 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 103258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103282 */     GIR_RootConstrainSelectedInstOperands,
     /* 103283 */     // GIR_Coverage, 3895,
     /* 103283 */     GIR_EraseRootFromParent_Done,
     /* 103284 */   // Label 1569: @103284
     /* 103284 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(103416), // Rule ID 3959 //
     /* 103289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103304 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103308 */     // MIs[1] Operand 1
     /* 103308 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 103313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103315 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103315 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103318 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 103322 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103331 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103337 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103340 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103344 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103349 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103354 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103357 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103361 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103366 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103383 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103414 */     GIR_RootConstrainSelectedInstOperands,
     /* 103415 */     // GIR_Coverage, 3959,
     /* 103415 */     GIR_EraseRootFromParent_Done,
     /* 103416 */   // Label 1570: @103416
     /* 103416 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(103548), // Rule ID 3967 //
     /* 103421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103436 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103440 */     // MIs[1] Operand 1
     /* 103440 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 103445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103447 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 103454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103463 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103469 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103472 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103476 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103481 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103486 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103489 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103493 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103498 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103515 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103546 */     GIR_RootConstrainSelectedInstOperands,
     /* 103547 */     // GIR_Coverage, 3967,
     /* 103547 */     GIR_EraseRootFromParent_Done,
     /* 103548 */   // Label 1571: @103548
     /* 103548 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(103680), // Rule ID 3975 //
     /* 103553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103568 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103572 */     // MIs[1] Operand 1
     /* 103572 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 103577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103579 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 103586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103591 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103601 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103604 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103608 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103613 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103618 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103621 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103625 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103630 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103647 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103678 */     GIR_RootConstrainSelectedInstOperands,
     /* 103679 */     // GIR_Coverage, 3975,
     /* 103679 */     GIR_EraseRootFromParent_Done,
     /* 103680 */   // Label 1572: @103680
     /* 103680 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(103812), // Rule ID 3983 //
     /* 103685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103700 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103704 */     // MIs[1] Operand 1
     /* 103704 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 103709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103711 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103711 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 103718 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103733 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103736 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103740 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103745 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103750 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103753 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103757 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103762 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103779 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103810 */     GIR_RootConstrainSelectedInstOperands,
     /* 103811 */     // GIR_Coverage, 3983,
     /* 103811 */     GIR_EraseRootFromParent_Done,
     /* 103812 */   // Label 1573: @103812
     /* 103812 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(103944), // Rule ID 3991 //
     /* 103817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103832 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103836 */     // MIs[1] Operand 1
     /* 103836 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 103841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103843 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 103850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103865 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103868 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103872 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103877 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103882 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103885 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103889 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103894 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103911 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 103918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103942 */     GIR_RootConstrainSelectedInstOperands,
     /* 103943 */     // GIR_Coverage, 3991,
     /* 103943 */     GIR_EraseRootFromParent_Done,
     /* 103944 */   // Label 1574: @103944
     /* 103944 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(103959), // Rule ID 2985 //
     /* 103949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 103952 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 103952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 103957 */     GIR_RootConstrainSelectedInstOperands,
     /* 103958 */     // GIR_Coverage, 2985,
     /* 103958 */     GIR_Done,
     /* 103959 */   // Label 1575: @103959
     /* 103959 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(104013), // Rule ID 3669 //
     /* 103964 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 103964 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103967 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103971 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103976 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 103979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 103996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 104001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104003 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 104005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104011 */     GIR_RootConstrainSelectedInstOperands,
     /* 104012 */     // GIR_Coverage, 3669,
     /* 104012 */     GIR_EraseRootFromParent_Done,
     /* 104013 */   // Label 1576: @104013
     /* 104013 */   GIM_Reject,
     /* 104014 */ // Label 1484: @104014
     /* 104014 */ GIM_Reject,
     /* 104015 */ // Label 1482: @104015
     /* 104015 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(114529),
     /* 104020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 104023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104027 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(104136), // Rule ID 5293 //
     /* 104032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104044 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104048 */     // MIs[1] Operand 1
     /* 104048 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104077 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104081 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104085 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104095 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104111 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 104114 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 104117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104134 */     GIR_RootConstrainSelectedInstOperands,
     /* 104135 */     // GIR_Coverage, 5293,
     /* 104135 */     GIR_EraseRootFromParent_Done,
     /* 104136 */   // Label 1578: @104136
     /* 104136 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(104299), // Rule ID 5294 //
     /* 104141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104153 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104157 */     // MIs[1] Operand 1
     /* 104157 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104190 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104194 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104198 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104204 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104204 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104207 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104211 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104216 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104220 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 104223 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 104226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104228 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104240 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104244 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104247 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104250 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104298 */     // GIR_Coverage, 5294,
     /* 104298 */     GIR_EraseRootFromParent_Done,
     /* 104299 */   // Label 1579: @104299
     /* 104299 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(104429), // Rule ID 5301 //
     /* 104304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104320 */     // MIs[1] Operand 1
     /* 104320 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104349 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104353 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104357 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104361 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104367 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104383 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 104386 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 104389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 104398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104403 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104427 */     GIR_RootConstrainSelectedInstOperands,
     /* 104428 */     // GIR_Coverage, 5301,
     /* 104428 */     GIR_EraseRootFromParent_Done,
     /* 104429 */   // Label 1580: @104429
     /* 104429 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(104613), // Rule ID 5302 //
     /* 104434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104446 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104450 */     // MIs[1] Operand 1
     /* 104450 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104479 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104483 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104487 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104497 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104497 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104500 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104504 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104509 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104513 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 104516 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 104519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104521 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104524 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 104528 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104533 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104537 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104555 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104558 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 104561 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104564 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104612 */     // GIR_Coverage, 5302,
     /* 104612 */     GIR_EraseRootFromParent_Done,
     /* 104613 */   // Label 1581: @104613
     /* 104613 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(104722), // Rule ID 3774 //
     /* 104618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104630 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104634 */     // MIs[1] Operand 1
     /* 104634 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104671 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104675 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104681 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104697 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 104700 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 104703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 104714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104720 */     GIR_RootConstrainSelectedInstOperands,
     /* 104721 */     // GIR_Coverage, 3774,
     /* 104721 */     GIR_EraseRootFromParent_Done,
     /* 104722 */   // Label 1582: @104722
     /* 104722 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(104885), // Rule ID 3775 //
     /* 104727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104739 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104743 */     // MIs[1] Operand 1
     /* 104743 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104776 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104780 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104784 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104790 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104790 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104793 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104797 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104802 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104806 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 104809 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 104812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104814 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104817 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104821 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104826 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 104830 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104833 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104836 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104869 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104884 */     // GIR_Coverage, 3775,
     /* 104884 */     GIR_EraseRootFromParent_Done,
     /* 104885 */   // Label 1583: @104885
     /* 104885 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(105015), // Rule ID 3782 //
     /* 104890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104902 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104906 */     // MIs[1] Operand 1
     /* 104906 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104939 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104943 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104947 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104953 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104953 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104956 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104960 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104965 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104969 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 104972 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 104975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 104984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 104993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 104997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 105002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105013 */     GIR_RootConstrainSelectedInstOperands,
     /* 105014 */     // GIR_Coverage, 3782,
     /* 105014 */     GIR_EraseRootFromParent_Done,
     /* 105015 */   // Label 1584: @105015
     /* 105015 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(105199), // Rule ID 3783 //
     /* 105020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105036 */     // MIs[1] Operand 1
     /* 105036 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 105045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 105049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 105053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 105057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 105065 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 105069 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 105073 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 105077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105083 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105083 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 105086 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105090 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105095 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105099 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 105102 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 105105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105107 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105110 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105114 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105119 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105123 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105129 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105132 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 105136 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105141 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105144 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 105147 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105150 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105198 */     // GIR_Coverage, 3783,
     /* 105198 */     GIR_EraseRootFromParent_Done,
     /* 105199 */   // Label 1585: @105199
     /* 105199 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(105265), // Rule ID 3694 //
     /* 105204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105216 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105220 */     // MIs[1] Operand 1
     /* 105220 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105225 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105231 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 105231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 105260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105263 */     GIR_RootConstrainSelectedInstOperands,
     /* 105264 */     // GIR_Coverage, 3694,
     /* 105264 */     GIR_EraseRootFromParent_Done,
     /* 105265 */   // Label 1586: @105265
     /* 105265 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(105385), // Rule ID 3695 //
     /* 105270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105282 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105286 */     // MIs[1] Operand 1
     /* 105286 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105291 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105297 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105297 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105300 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105304 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105309 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105315 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105318 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105322 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105327 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105330 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 105333 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105336 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105384 */     // GIR_Coverage, 3695,
     /* 105384 */     GIR_EraseRootFromParent_Done,
     /* 105385 */   // Label 1587: @105385
     /* 105385 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(105489), // Rule ID 3702 //
     /* 105390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105402 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105406 */     // MIs[1] Operand 1
     /* 105406 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105411 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105417 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 105417 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 105420 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105424 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105429 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105435 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 105438 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105442 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105447 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 105460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105465 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105468 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 105471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 105484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105487 */     GIR_RootConstrainSelectedInstOperands,
     /* 105488 */     // GIR_Coverage, 3702,
     /* 105488 */     GIR_EraseRootFromParent_Done,
     /* 105489 */   // Label 1588: @105489
     /* 105489 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(105647), // Rule ID 3703 //
     /* 105494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105506 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105510 */     // MIs[1] Operand 1
     /* 105510 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105515 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105521 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105521 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 105524 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105528 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105533 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 105539 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 105542 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105546 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105551 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105557 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105560 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105564 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105569 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 105572 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 105575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105577 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105580 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105584 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105589 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105592 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 105595 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105598 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105646 */     // GIR_Coverage, 3703,
     /* 105646 */     GIR_EraseRootFromParent_Done,
     /* 105647 */   // Label 1589: @105647
     /* 105647 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(105696), // Rule ID 3710 //
     /* 105652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105668 */     // MIs[1] Operand 1
     /* 105668 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 105673 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105679 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 105679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105694 */     GIR_RootConstrainSelectedInstOperands,
     /* 105695 */     // GIR_Coverage, 3710,
     /* 105695 */     GIR_EraseRootFromParent_Done,
     /* 105696 */   // Label 1590: @105696
     /* 105696 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(105799), // Rule ID 3711 //
     /* 105701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105713 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105717 */     // MIs[1] Operand 1
     /* 105717 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 105722 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105728 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105728 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105731 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105735 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105740 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105744 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 105747 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105750 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105798 */     // GIR_Coverage, 3711,
     /* 105798 */     GIR_EraseRootFromParent_Done,
     /* 105799 */   // Label 1591: @105799
     /* 105799 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(105869), // Rule ID 3718 //
     /* 105804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105816 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105820 */     // MIs[1] Operand 1
     /* 105820 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 105825 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105831 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 105831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 105838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105867 */     GIR_RootConstrainSelectedInstOperands,
     /* 105868 */     // GIR_Coverage, 3718,
     /* 105868 */     GIR_EraseRootFromParent_Done,
     /* 105869 */   // Label 1592: @105869
     /* 105869 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(105993), // Rule ID 3719 //
     /* 105874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105886 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105890 */     // MIs[1] Operand 1
     /* 105890 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 105895 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105901 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105901 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105904 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105908 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105913 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105917 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105935 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105938 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 105941 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105992 */     // GIR_Coverage, 3719,
     /* 105992 */     GIR_EraseRootFromParent_Done,
     /* 105993 */   // Label 1593: @105993
     /* 105993 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(106080), // Rule ID 3726 //
     /* 105998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106010 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106014 */     // MIs[1] Operand 1
     /* 106014 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106019 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106025 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106025 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106028 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 106032 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106037 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 106050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106078 */     GIR_RootConstrainSelectedInstOperands,
     /* 106079 */     // GIR_Coverage, 3726,
     /* 106079 */     GIR_EraseRootFromParent_Done,
     /* 106080 */   // Label 1594: @106080
     /* 106080 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(106221), // Rule ID 3727 //
     /* 106085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106097 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106101 */     // MIs[1] Operand 1
     /* 106101 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106106 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106112 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106112 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106115 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 106119 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106124 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106130 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106133 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 106137 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106142 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106145 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106151 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106154 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106158 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106163 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106166 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106169 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106172 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106220 */     // GIR_Coverage, 3727,
     /* 106220 */     GIR_EraseRootFromParent_Done,
     /* 106221 */   // Label 1595: @106221
     /* 106221 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(106308), // Rule ID 3734 //
     /* 106226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106238 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106242 */     // MIs[1] Operand 1
     /* 106242 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 106247 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106253 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 106260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106265 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 106278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106306 */     GIR_RootConstrainSelectedInstOperands,
     /* 106307 */     // GIR_Coverage, 3734,
     /* 106307 */     GIR_EraseRootFromParent_Done,
     /* 106308 */   // Label 1596: @106308
     /* 106308 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(106449), // Rule ID 3735 //
     /* 106313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106325 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106329 */     // MIs[1] Operand 1
     /* 106329 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 106334 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106340 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106340 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106343 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 106347 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106352 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106358 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106361 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 106365 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106370 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106374 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106391 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106394 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106397 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106400 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106448 */     // GIR_Coverage, 3735,
     /* 106448 */     GIR_EraseRootFromParent_Done,
     /* 106449 */   // Label 1597: @106449
     /* 106449 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(106539), // Rule ID 3742 //
     /* 106454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106466 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106470 */     // MIs[1] Operand 1
     /* 106470 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106475 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106481 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106481 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106484 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 106488 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 106509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106518 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106537 */     GIR_RootConstrainSelectedInstOperands,
     /* 106538 */     // GIR_Coverage, 3742,
     /* 106538 */     GIR_EraseRootFromParent_Done,
     /* 106539 */   // Label 1598: @106539
     /* 106539 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(106683), // Rule ID 3743 //
     /* 106544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106556 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106560 */     // MIs[1] Operand 1
     /* 106560 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106565 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106571 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106571 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106574 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 106578 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106583 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106587 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 106590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106592 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106595 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 106599 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106604 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106608 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106625 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106628 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106631 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106634 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106682 */     // GIR_Coverage, 3743,
     /* 106682 */     GIR_EraseRootFromParent_Done,
     /* 106683 */   // Label 1599: @106683
     /* 106683 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(106773), // Rule ID 3750 //
     /* 106688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106700 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106704 */     // MIs[1] Operand 1
     /* 106704 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 106709 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106715 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 106722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106731 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 106743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106752 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106771 */     GIR_RootConstrainSelectedInstOperands,
     /* 106772 */     // GIR_Coverage, 3750,
     /* 106772 */     GIR_EraseRootFromParent_Done,
     /* 106773 */   // Label 1600: @106773
     /* 106773 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(106917), // Rule ID 3751 //
     /* 106778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106790 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106794 */     // MIs[1] Operand 1
     /* 106794 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 106799 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106805 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106805 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106808 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 106812 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106817 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106821 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 106824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 106833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106838 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106842 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106859 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106862 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106865 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106868 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106916 */     // GIR_Coverage, 3751,
     /* 106916 */     GIR_EraseRootFromParent_Done,
     /* 106917 */   // Label 1601: @106917
     /* 106917 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(106987), // Rule ID 3758 //
     /* 106922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106934 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106938 */     // MIs[1] Operand 1
     /* 106938 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106949 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 106956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106985 */     GIR_RootConstrainSelectedInstOperands,
     /* 106986 */     // GIR_Coverage, 3758,
     /* 106986 */     GIR_EraseRootFromParent_Done,
     /* 106987 */   // Label 1602: @106987
     /* 106987 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(107111), // Rule ID 3759 //
     /* 106992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107004 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107008 */     // MIs[1] Operand 1
     /* 107008 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 107013 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107019 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107019 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 107022 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 107026 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107031 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107035 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107041 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107044 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107048 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107053 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107056 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107059 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107062 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107110 */     // GIR_Coverage, 3759,
     /* 107110 */     GIR_EraseRootFromParent_Done,
     /* 107111 */   // Label 1603: @107111
     /* 107111 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(107160), // Rule ID 3766 //
     /* 107116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107128 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107132 */     // MIs[1] Operand 1
     /* 107132 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107137 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107143 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 107143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 107146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 107148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 107158 */     GIR_RootConstrainSelectedInstOperands,
     /* 107159 */     // GIR_Coverage, 3766,
     /* 107159 */     GIR_EraseRootFromParent_Done,
     /* 107160 */   // Label 1604: @107160
     /* 107160 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(107263), // Rule ID 3767 //
     /* 107165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107177 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107181 */     // MIs[1] Operand 1
     /* 107181 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107186 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107192 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107204 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107208 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107214 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107262 */     // GIR_Coverage, 3767,
     /* 107262 */     GIR_EraseRootFromParent_Done,
     /* 107263 */   // Label 1605: @107263
     /* 107263 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(107366), // Rule ID 3034 //
     /* 107268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107283 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107287 */     // MIs[1] Operand 1
     /* 107287 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107300 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107304 */     // MIs[2] Operand 1
     /* 107304 */     // No operand predicates
     /* 107304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107306 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 107306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107339 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107364 */     GIR_RootConstrainSelectedInstOperands,
     /* 107365 */     // GIR_Coverage, 3034,
     /* 107365 */     GIR_EraseRootFromParent_Done,
     /* 107366 */   // Label 1606: @107366
     /* 107366 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(107469), // Rule ID 3050 //
     /* 107371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107386 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107390 */     // MIs[1] Operand 1
     /* 107390 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107403 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107407 */     // MIs[2] Operand 1
     /* 107407 */     // No operand predicates
     /* 107407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107409 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 107409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107421 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107442 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 107449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107467 */     GIR_RootConstrainSelectedInstOperands,
     /* 107468 */     // GIR_Coverage, 3050,
     /* 107468 */     GIR_EraseRootFromParent_Done,
     /* 107469 */   // Label 1607: @107469
     /* 107469 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(107572), // Rule ID 3058 //
     /* 107474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107489 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107493 */     // MIs[1] Operand 1
     /* 107493 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 107498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107506 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107510 */     // MIs[2] Operand 1
     /* 107510 */     // No operand predicates
     /* 107510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107512 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 107512 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107515 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107519 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107524 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107545 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 107552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107570 */     GIR_RootConstrainSelectedInstOperands,
     /* 107571 */     // GIR_Coverage, 3058,
     /* 107571 */     GIR_EraseRootFromParent_Done,
     /* 107572 */   // Label 1608: @107572
     /* 107572 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(107675), // Rule ID 3130 //
     /* 107577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107592 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107596 */     // MIs[1] Operand 1
     /* 107596 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107609 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 107613 */     // MIs[2] Operand 1
     /* 107613 */     // No operand predicates
     /* 107613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107615 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 107615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 107622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107648 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107673 */     GIR_RootConstrainSelectedInstOperands,
     /* 107674 */     // GIR_Coverage, 3130,
     /* 107674 */     GIR_EraseRootFromParent_Done,
     /* 107675 */   // Label 1609: @107675
     /* 107675 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(107778), // Rule ID 3146 //
     /* 107680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107695 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107699 */     // MIs[1] Operand 1
     /* 107699 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 107716 */     // MIs[2] Operand 1
     /* 107716 */     // No operand predicates
     /* 107716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107718 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 107718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 107725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107730 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107751 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 107758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107776 */     GIR_RootConstrainSelectedInstOperands,
     /* 107777 */     // GIR_Coverage, 3146,
     /* 107777 */     GIR_EraseRootFromParent_Done,
     /* 107778 */   // Label 1610: @107778
     /* 107778 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(107881), // Rule ID 3154 //
     /* 107783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107798 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107802 */     // MIs[1] Operand 1
     /* 107802 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 107807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107815 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 107819 */     // MIs[2] Operand 1
     /* 107819 */     // No operand predicates
     /* 107819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107821 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 107821 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107824 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 107828 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107833 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107854 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 107861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107879 */     GIR_RootConstrainSelectedInstOperands,
     /* 107880 */     // GIR_Coverage, 3154,
     /* 107880 */     GIR_EraseRootFromParent_Done,
     /* 107881 */   // Label 1611: @107881
     /* 107881 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(108024), // Rule ID 3816 //
     /* 107886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 107889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107901 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107905 */     // MIs[1] Operand 1
     /* 107905 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107918 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107922 */     // MIs[2] Operand 1
     /* 107922 */     // No operand predicates
     /* 107922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107924 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 107924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107945 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 107948 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107952 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107957 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 107960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 107962 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 107965 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107969 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107974 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 107977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107991 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108022 */     GIR_RootConstrainSelectedInstOperands,
     /* 108023 */     // GIR_Coverage, 3816,
     /* 108023 */     GIR_EraseRootFromParent_Done,
     /* 108024 */   // Label 1612: @108024
     /* 108024 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(108167), // Rule ID 3832 //
     /* 108029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108044 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108048 */     // MIs[1] Operand 1
     /* 108048 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108061 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108065 */     // MIs[2] Operand 1
     /* 108065 */     // No operand predicates
     /* 108065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108067 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108070 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108074 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108079 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108088 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108091 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108095 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108100 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108105 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108108 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108112 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108117 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108134 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108165 */     GIR_RootConstrainSelectedInstOperands,
     /* 108166 */     // GIR_Coverage, 3832,
     /* 108166 */     GIR_EraseRootFromParent_Done,
     /* 108167 */   // Label 1613: @108167
     /* 108167 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(108310), // Rule ID 3840 //
     /* 108172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108191 */     // MIs[1] Operand 1
     /* 108191 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108204 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108208 */     // MIs[2] Operand 1
     /* 108208 */     // No operand predicates
     /* 108208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108210 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108210 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108213 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108217 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108222 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108231 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108234 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108238 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108243 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108260 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108277 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108308 */     GIR_RootConstrainSelectedInstOperands,
     /* 108309 */     // GIR_Coverage, 3840,
     /* 108309 */     GIR_EraseRootFromParent_Done,
     /* 108310 */   // Label 1614: @108310
     /* 108310 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(108453), // Rule ID 3912 //
     /* 108315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108330 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108334 */     // MIs[1] Operand 1
     /* 108334 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 108339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108351 */     // MIs[2] Operand 1
     /* 108351 */     // No operand predicates
     /* 108351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108353 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108365 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108374 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108377 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108381 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108386 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108391 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108394 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108398 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108403 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108420 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108451 */     GIR_RootConstrainSelectedInstOperands,
     /* 108452 */     // GIR_Coverage, 3912,
     /* 108452 */     GIR_EraseRootFromParent_Done,
     /* 108453 */   // Label 1615: @108453
     /* 108453 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(108596), // Rule ID 3928 //
     /* 108458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108473 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108477 */     // MIs[1] Operand 1
     /* 108477 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108494 */     // MIs[2] Operand 1
     /* 108494 */     // No operand predicates
     /* 108494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108496 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108496 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108499 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108503 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108508 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108517 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108520 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108524 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108529 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108534 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108537 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108541 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108546 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108563 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108594 */     GIR_RootConstrainSelectedInstOperands,
     /* 108595 */     // GIR_Coverage, 3928,
     /* 108595 */     GIR_EraseRootFromParent_Done,
     /* 108596 */   // Label 1616: @108596
     /* 108596 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(108739), // Rule ID 3936 //
     /* 108601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108616 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108620 */     // MIs[1] Operand 1
     /* 108620 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108633 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108637 */     // MIs[2] Operand 1
     /* 108637 */     // No operand predicates
     /* 108637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108639 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108639 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108642 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108646 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108651 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108660 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108663 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108667 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108672 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108689 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108706 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108737 */     GIR_RootConstrainSelectedInstOperands,
     /* 108738 */     // GIR_Coverage, 3936,
     /* 108738 */     GIR_EraseRootFromParent_Done,
     /* 108739 */   // Label 1617: @108739
     /* 108739 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(108831), // Rule ID 3178 //
     /* 108744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 108747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108759 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108763 */     // MIs[1] Operand 1
     /* 108763 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 108768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108770 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 108770 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108773 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 108777 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108782 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108786 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108804 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 108824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 108826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108829 */     GIR_RootConstrainSelectedInstOperands,
     /* 108830 */     // GIR_Coverage, 3178,
     /* 108830 */     GIR_EraseRootFromParent_Done,
     /* 108831 */   // Label 1618: @108831
     /* 108831 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(108923), // Rule ID 3194 //
     /* 108836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 108839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108851 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108855 */     // MIs[1] Operand 1
     /* 108855 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 108860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108862 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 108862 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108865 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 108869 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108874 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108878 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108896 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 108916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 108918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108921 */     GIR_RootConstrainSelectedInstOperands,
     /* 108922 */     // GIR_Coverage, 3194,
     /* 108922 */     GIR_EraseRootFromParent_Done,
     /* 108923 */   // Label 1619: @108923
     /* 108923 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(109015), // Rule ID 3210 //
     /* 108928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 108931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108943 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108947 */     // MIs[1] Operand 1
     /* 108947 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 108952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108954 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 108954 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108957 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 108961 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108966 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108988 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109013 */     GIR_RootConstrainSelectedInstOperands,
     /* 109014 */     // GIR_Coverage, 3210,
     /* 109014 */     GIR_EraseRootFromParent_Done,
     /* 109015 */   // Label 1620: @109015
     /* 109015 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(109107), // Rule ID 3226 //
     /* 109020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109035 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109039 */     // MIs[1] Operand 1
     /* 109039 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109046 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 109046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109062 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109080 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109105 */     GIR_RootConstrainSelectedInstOperands,
     /* 109106 */     // GIR_Coverage, 3226,
     /* 109106 */     GIR_EraseRootFromParent_Done,
     /* 109107 */   // Label 1621: @109107
     /* 109107 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(109199), // Rule ID 3234 //
     /* 109112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109127 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109131 */     // MIs[1] Operand 1
     /* 109131 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109138 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 109138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109150 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109154 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109172 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109197 */     GIR_RootConstrainSelectedInstOperands,
     /* 109198 */     // GIR_Coverage, 3234,
     /* 109198 */     GIR_EraseRootFromParent_Done,
     /* 109199 */   // Label 1622: @109199
     /* 109199 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(109291), // Rule ID 3250 //
     /* 109204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109219 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109223 */     // MIs[1] Operand 1
     /* 109223 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109230 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 109230 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109233 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109237 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109242 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109246 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109264 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109289 */     GIR_RootConstrainSelectedInstOperands,
     /* 109290 */     // GIR_Coverage, 3250,
     /* 109290 */     GIR_EraseRootFromParent_Done,
     /* 109291 */   // Label 1623: @109291
     /* 109291 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(109383), // Rule ID 3266 //
     /* 109296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109311 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109315 */     // MIs[1] Operand 1
     /* 109315 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109322 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 109322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109338 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109356 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109381 */     GIR_RootConstrainSelectedInstOperands,
     /* 109382 */     // GIR_Coverage, 3266,
     /* 109382 */     GIR_EraseRootFromParent_Done,
     /* 109383 */   // Label 1624: @109383
     /* 109383 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(109475), // Rule ID 3282 //
     /* 109388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109403 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109407 */     // MIs[1] Operand 1
     /* 109407 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109414 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 109414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109426 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109430 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109448 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109473 */     GIR_RootConstrainSelectedInstOperands,
     /* 109474 */     // GIR_Coverage, 3282,
     /* 109474 */     GIR_EraseRootFromParent_Done,
     /* 109475 */   // Label 1625: @109475
     /* 109475 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(109567), // Rule ID 3290 //
     /* 109480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109499 */     // MIs[1] Operand 1
     /* 109499 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109506 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 109506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109518 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109522 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109540 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109565 */     GIR_RootConstrainSelectedInstOperands,
     /* 109566 */     // GIR_Coverage, 3290,
     /* 109566 */     GIR_EraseRootFromParent_Done,
     /* 109567 */   // Label 1626: @109567
     /* 109567 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(109659), // Rule ID 3306 //
     /* 109572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109587 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109591 */     // MIs[1] Operand 1
     /* 109591 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109598 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 109598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109610 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109614 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109632 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109657 */     GIR_RootConstrainSelectedInstOperands,
     /* 109658 */     // GIR_Coverage, 3306,
     /* 109658 */     GIR_EraseRootFromParent_Done,
     /* 109659 */   // Label 1627: @109659
     /* 109659 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(109751), // Rule ID 3322 //
     /* 109664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109679 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109683 */     // MIs[1] Operand 1
     /* 109683 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109690 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 109690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109702 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109706 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109724 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109749 */     GIR_RootConstrainSelectedInstOperands,
     /* 109750 */     // GIR_Coverage, 3322,
     /* 109750 */     GIR_EraseRootFromParent_Done,
     /* 109751 */   // Label 1628: @109751
     /* 109751 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(109843), // Rule ID 3338 //
     /* 109756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109771 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109775 */     // MIs[1] Operand 1
     /* 109775 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109782 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 109782 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109785 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109789 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109794 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109798 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109816 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109841 */     GIR_RootConstrainSelectedInstOperands,
     /* 109842 */     // GIR_Coverage, 3338,
     /* 109842 */     GIR_EraseRootFromParent_Done,
     /* 109843 */   // Label 1629: @109843
     /* 109843 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(109975), // Rule ID 4022 //
     /* 109848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 109851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109863 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109867 */     // MIs[1] Operand 1
     /* 109867 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109874 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 109874 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109877 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109881 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109886 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109890 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109896 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 109899 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109903 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109908 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 109911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 109913 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 109916 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109920 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109925 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109942 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109973 */     GIR_RootConstrainSelectedInstOperands,
     /* 109974 */     // GIR_Coverage, 4022,
     /* 109974 */     GIR_EraseRootFromParent_Done,
     /* 109975 */   // Label 1630: @109975
     /* 109975 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(110107), // Rule ID 4054 //
     /* 109980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 109983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109995 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109999 */     // MIs[1] Operand 1
     /* 109999 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 110004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110006 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110018 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110022 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110028 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110031 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110035 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110040 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110045 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110048 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110052 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110057 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110074 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110105 */     GIR_RootConstrainSelectedInstOperands,
     /* 110106 */     // GIR_Coverage, 4054,
     /* 110106 */     GIR_EraseRootFromParent_Done,
     /* 110107 */   // Label 1631: @110107
     /* 110107 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(110239), // Rule ID 4086 //
     /* 110112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110127 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110131 */     // MIs[1] Operand 1
     /* 110131 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110138 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110150 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110154 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110160 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110163 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110167 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110172 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110177 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110180 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110184 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110189 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110206 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110237 */     GIR_RootConstrainSelectedInstOperands,
     /* 110238 */     // GIR_Coverage, 4086,
     /* 110238 */     GIR_EraseRootFromParent_Done,
     /* 110239 */   // Label 1632: @110239
     /* 110239 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(110371), // Rule ID 4118 //
     /* 110244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110263 */     // MIs[1] Operand 1
     /* 110263 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 110268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110270 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110286 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110292 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110295 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110299 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110304 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110309 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110312 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110316 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110321 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110338 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 110345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110369 */     GIR_RootConstrainSelectedInstOperands,
     /* 110370 */     // GIR_Coverage, 4118,
     /* 110370 */     GIR_EraseRootFromParent_Done,
     /* 110371 */   // Label 1633: @110371
     /* 110371 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(110503), // Rule ID 4134 //
     /* 110376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110391 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110395 */     // MIs[1] Operand 1
     /* 110395 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 110400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110402 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110414 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110418 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110424 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110427 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110431 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110436 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110441 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110444 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110448 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110453 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110470 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110501 */     GIR_RootConstrainSelectedInstOperands,
     /* 110502 */     // GIR_Coverage, 4134,
     /* 110502 */     GIR_EraseRootFromParent_Done,
     /* 110503 */   // Label 1634: @110503
     /* 110503 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(110635), // Rule ID 4166 //
     /* 110508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110523 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110527 */     // MIs[1] Operand 1
     /* 110527 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 110532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110534 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110546 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110550 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110556 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110559 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110563 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110568 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110573 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110576 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110580 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110585 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110602 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110633 */     GIR_RootConstrainSelectedInstOperands,
     /* 110634 */     // GIR_Coverage, 4166,
     /* 110634 */     GIR_EraseRootFromParent_Done,
     /* 110635 */   // Label 1635: @110635
     /* 110635 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(110767), // Rule ID 4198 //
     /* 110640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110655 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110659 */     // MIs[1] Operand 1
     /* 110659 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110666 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110688 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110691 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110695 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110700 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110705 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110708 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110712 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110717 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110734 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110765 */     GIR_RootConstrainSelectedInstOperands,
     /* 110766 */     // GIR_Coverage, 4198,
     /* 110766 */     GIR_EraseRootFromParent_Done,
     /* 110767 */   // Label 1636: @110767
     /* 110767 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(110899), // Rule ID 4230 //
     /* 110772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110791 */     // MIs[1] Operand 1
     /* 110791 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 110796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110798 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110798 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110801 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110805 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110810 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110814 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110820 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110823 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110827 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110832 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110837 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110840 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110844 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110849 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110866 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 110873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110897 */     GIR_RootConstrainSelectedInstOperands,
     /* 110898 */     // GIR_Coverage, 4230,
     /* 110898 */     GIR_EraseRootFromParent_Done,
     /* 110899 */   // Label 1637: @110899
     /* 110899 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(111031), // Rule ID 4260 //
     /* 110904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 110919 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 110923 */     // MIs[1] Operand 1
     /* 110923 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 110928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110930 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110930 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110933 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 110937 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110942 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110952 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110955 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110959 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110964 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110969 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110972 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110976 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110981 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110998 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 111005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111029 */     GIR_RootConstrainSelectedInstOperands,
     /* 111030 */     // GIR_Coverage, 4260,
     /* 111030 */     GIR_EraseRootFromParent_Done,
     /* 111031 */   // Label 1638: @111031
     /* 111031 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(111163), // Rule ID 4292 //
     /* 111036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111051 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111055 */     // MIs[1] Operand 1
     /* 111055 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111062 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111074 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111078 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111084 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111087 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111091 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111096 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111101 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111104 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111108 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111113 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111130 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111161 */     GIR_RootConstrainSelectedInstOperands,
     /* 111162 */     // GIR_Coverage, 4292,
     /* 111162 */     GIR_EraseRootFromParent_Done,
     /* 111163 */   // Label 1639: @111163
     /* 111163 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(111295), // Rule ID 4324 //
     /* 111168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111183 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111187 */     // MIs[1] Operand 1
     /* 111187 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 111192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111194 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111194 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111197 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111201 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111206 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111210 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111216 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111219 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111223 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111228 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111233 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111236 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111240 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111245 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111262 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 111269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111293 */     GIR_RootConstrainSelectedInstOperands,
     /* 111294 */     // GIR_Coverage, 4324,
     /* 111294 */     GIR_EraseRootFromParent_Done,
     /* 111295 */   // Label 1640: @111295
     /* 111295 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(111427), // Rule ID 4356 //
     /* 111300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111319 */     // MIs[1] Operand 1
     /* 111319 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 111324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111326 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111338 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111342 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111348 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111351 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111355 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111360 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111365 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111368 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111372 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111377 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111394 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 111401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111425 */     GIR_RootConstrainSelectedInstOperands,
     /* 111426 */     // GIR_Coverage, 4356,
     /* 111426 */     GIR_EraseRootFromParent_Done,
     /* 111427 */   // Label 1641: @111427
     /* 111427 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(111559), // Rule ID 4587 //
     /* 111432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111447 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111451 */     // MIs[1] Operand 1
     /* 111451 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 111456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111458 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111458 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111461 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 111465 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111470 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111474 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111480 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111483 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111487 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111492 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111497 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111500 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111504 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111509 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111526 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111557 */     GIR_RootConstrainSelectedInstOperands,
     /* 111558 */     // GIR_Coverage, 4587,
     /* 111558 */     GIR_EraseRootFromParent_Done,
     /* 111559 */   // Label 1642: @111559
     /* 111559 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(111691), // Rule ID 4619 //
     /* 111564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111579 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111583 */     // MIs[1] Operand 1
     /* 111583 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111590 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 111597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111602 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111606 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111612 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111615 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111619 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111624 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111629 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111632 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111636 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111641 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111658 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111689 */     GIR_RootConstrainSelectedInstOperands,
     /* 111690 */     // GIR_Coverage, 4619,
     /* 111690 */     GIR_EraseRootFromParent_Done,
     /* 111691 */   // Label 1643: @111691
     /* 111691 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(111823), // Rule ID 4651 //
     /* 111696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111711 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111715 */     // MIs[1] Operand 1
     /* 111715 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 111720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111722 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 111729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111734 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111738 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111744 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111747 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111751 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111756 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111761 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111764 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111768 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111773 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111790 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111821 */     GIR_RootConstrainSelectedInstOperands,
     /* 111822 */     // GIR_Coverage, 4651,
     /* 111822 */     GIR_EraseRootFromParent_Done,
     /* 111823 */   // Label 1644: @111823
     /* 111823 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(111955), // Rule ID 4695 //
     /* 111828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111843 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111847 */     // MIs[1] Operand 1
     /* 111847 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 111852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111854 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 111861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111866 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111870 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111876 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111879 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111883 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111888 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111893 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111896 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111900 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111905 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111922 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111953 */     GIR_RootConstrainSelectedInstOperands,
     /* 111954 */     // GIR_Coverage, 4695,
     /* 111954 */     GIR_EraseRootFromParent_Done,
     /* 111955 */   // Label 1645: @111955
     /* 111955 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(112087), // Rule ID 4727 //
     /* 111960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111975 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111979 */     // MIs[1] Operand 1
     /* 111979 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111986 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 111993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112002 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112008 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112011 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112015 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112020 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112037 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112054 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112085 */     GIR_RootConstrainSelectedInstOperands,
     /* 112086 */     // GIR_Coverage, 4727,
     /* 112086 */     GIR_EraseRootFromParent_Done,
     /* 112087 */   // Label 1646: @112087
     /* 112087 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(112219), // Rule ID 4759 //
     /* 112092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112107 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112111 */     // MIs[1] Operand 1
     /* 112111 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 112116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112118 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112118 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112121 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 112125 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112130 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112134 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112140 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112143 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112147 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112152 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112157 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112160 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112164 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112169 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112186 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112217 */     GIR_RootConstrainSelectedInstOperands,
     /* 112218 */     // GIR_Coverage, 4759,
     /* 112218 */     GIR_EraseRootFromParent_Done,
     /* 112219 */   // Label 1647: @112219
     /* 112219 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(112311), // Rule ID 2980 //
     /* 112224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112239 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112243 */     // MIs[1] Operand 1
     /* 112243 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 112248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112250 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 112250 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112253 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 112257 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112262 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112266 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112284 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112309 */     GIR_RootConstrainSelectedInstOperands,
     /* 112310 */     // GIR_Coverage, 2980,
     /* 112310 */     GIR_EraseRootFromParent_Done,
     /* 112311 */   // Label 1648: @112311
     /* 112311 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(112403), // Rule ID 2994 //
     /* 112316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112331 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112335 */     // MIs[1] Operand 1
     /* 112335 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 112340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112342 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 112342 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112345 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112349 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112358 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112376 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112401 */     GIR_RootConstrainSelectedInstOperands,
     /* 112402 */     // GIR_Coverage, 2994,
     /* 112402 */     GIR_EraseRootFromParent_Done,
     /* 112403 */   // Label 1649: @112403
     /* 112403 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(112495), // Rule ID 3002 //
     /* 112408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112423 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112427 */     // MIs[1] Operand 1
     /* 112427 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 112432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112434 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 112434 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112437 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 112441 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112446 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112450 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112468 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112493 */     GIR_RootConstrainSelectedInstOperands,
     /* 112494 */     // GIR_Coverage, 3002,
     /* 112494 */     GIR_EraseRootFromParent_Done,
     /* 112495 */   // Label 1650: @112495
     /* 112495 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(112587), // Rule ID 3010 //
     /* 112500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112515 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112519 */     // MIs[1] Operand 1
     /* 112519 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 112524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112526 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 112526 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112529 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112533 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112538 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112542 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112560 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112585 */     GIR_RootConstrainSelectedInstOperands,
     /* 112586 */     // GIR_Coverage, 3010,
     /* 112586 */     GIR_EraseRootFromParent_Done,
     /* 112587 */   // Label 1651: @112587
     /* 112587 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(112679), // Rule ID 3018 //
     /* 112592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112607 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112611 */     // MIs[1] Operand 1
     /* 112611 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 112616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112618 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 112618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112630 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112634 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112652 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 112659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112677 */     GIR_RootConstrainSelectedInstOperands,
     /* 112678 */     // GIR_Coverage, 3018,
     /* 112678 */     GIR_EraseRootFromParent_Done,
     /* 112679 */   // Label 1652: @112679
     /* 112679 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(112771), // Rule ID 3082 //
     /* 112684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112699 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112703 */     // MIs[1] Operand 1
     /* 112703 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 112708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112710 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 112710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 112717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112722 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112726 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112744 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112769 */     GIR_RootConstrainSelectedInstOperands,
     /* 112770 */     // GIR_Coverage, 3082,
     /* 112770 */     GIR_EraseRootFromParent_Done,
     /* 112771 */   // Label 1653: @112771
     /* 112771 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(112863), // Rule ID 3090 //
     /* 112776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112791 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112795 */     // MIs[1] Operand 1
     /* 112795 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 112800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112802 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 112802 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112805 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 112809 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112814 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112818 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112836 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112861 */     GIR_RootConstrainSelectedInstOperands,
     /* 112862 */     // GIR_Coverage, 3090,
     /* 112862 */     GIR_EraseRootFromParent_Done,
     /* 112863 */   // Label 1654: @112863
     /* 112863 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(112955), // Rule ID 3098 //
     /* 112868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112883 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112887 */     // MIs[1] Operand 1
     /* 112887 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 112892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112894 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 112894 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112897 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 112901 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112906 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112910 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112928 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112953 */     GIR_RootConstrainSelectedInstOperands,
     /* 112954 */     // GIR_Coverage, 3098,
     /* 112954 */     GIR_EraseRootFromParent_Done,
     /* 112955 */   // Label 1655: @112955
     /* 112955 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(113047), // Rule ID 3106 //
     /* 112960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112975 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112979 */     // MIs[1] Operand 1
     /* 112979 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 112984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112986 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 112986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 112993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113002 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113020 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113045 */     GIR_RootConstrainSelectedInstOperands,
     /* 113046 */     // GIR_Coverage, 3106,
     /* 113046 */     GIR_EraseRootFromParent_Done,
     /* 113047 */   // Label 1656: @113047
     /* 113047 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(113139), // Rule ID 3114 //
     /* 113052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113067 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113071 */     // MIs[1] Operand 1
     /* 113071 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 113076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113078 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 113078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113090 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113094 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113112 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 113119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113137 */     GIR_RootConstrainSelectedInstOperands,
     /* 113138 */     // GIR_Coverage, 3114,
     /* 113138 */     GIR_EraseRootFromParent_Done,
     /* 113139 */   // Label 1657: @113139
     /* 113139 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(113271), // Rule ID 3864 //
     /* 113144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113159 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113163 */     // MIs[1] Operand 1
     /* 113163 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 113168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113170 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 113177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113182 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113186 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113192 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113195 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113199 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113204 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113209 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113212 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113216 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113221 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113238 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113269 */     GIR_RootConstrainSelectedInstOperands,
     /* 113270 */     // GIR_Coverage, 3864,
     /* 113270 */     GIR_EraseRootFromParent_Done,
     /* 113271 */   // Label 1658: @113271
     /* 113271 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(113403), // Rule ID 3872 //
     /* 113276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113295 */     // MIs[1] Operand 1
     /* 113295 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113302 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113324 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113327 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113331 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113336 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113341 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113344 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113348 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113353 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113370 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113401 */     GIR_RootConstrainSelectedInstOperands,
     /* 113402 */     // GIR_Coverage, 3872,
     /* 113402 */     GIR_EraseRootFromParent_Done,
     /* 113403 */   // Label 1659: @113403
     /* 113403 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(113535), // Rule ID 3880 //
     /* 113408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113423 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113427 */     // MIs[1] Operand 1
     /* 113427 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 113432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113434 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113434 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113437 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 113441 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113446 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113450 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113456 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113459 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113463 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113468 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113473 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113476 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113480 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113485 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113502 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113533 */     GIR_RootConstrainSelectedInstOperands,
     /* 113534 */     // GIR_Coverage, 3880,
     /* 113534 */     GIR_EraseRootFromParent_Done,
     /* 113535 */   // Label 1660: @113535
     /* 113535 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(113667), // Rule ID 3888 //
     /* 113540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113555 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113559 */     // MIs[1] Operand 1
     /* 113559 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 113564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113566 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113582 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113588 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113591 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113595 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113600 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113605 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113608 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113612 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113617 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113634 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113665 */     GIR_RootConstrainSelectedInstOperands,
     /* 113666 */     // GIR_Coverage, 3888,
     /* 113666 */     GIR_EraseRootFromParent_Done,
     /* 113667 */   // Label 1661: @113667
     /* 113667 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(113799), // Rule ID 3896 //
     /* 113672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113687 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113691 */     // MIs[1] Operand 1
     /* 113691 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 113696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113698 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113710 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113714 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113720 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113723 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113727 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113732 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113737 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113740 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113744 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113749 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113766 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 113773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113797 */     GIR_RootConstrainSelectedInstOperands,
     /* 113798 */     // GIR_Coverage, 3896,
     /* 113798 */     GIR_EraseRootFromParent_Done,
     /* 113799 */   // Label 1662: @113799
     /* 113799 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(113931), // Rule ID 3960 //
     /* 113804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113819 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113823 */     // MIs[1] Operand 1
     /* 113823 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 113828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113830 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 113837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113846 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113852 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113855 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113859 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113864 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113869 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113872 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113876 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113881 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113898 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113929 */     GIR_RootConstrainSelectedInstOperands,
     /* 113930 */     // GIR_Coverage, 3960,
     /* 113930 */     GIR_EraseRootFromParent_Done,
     /* 113931 */   // Label 1663: @113931
     /* 113931 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(114063), // Rule ID 3968 //
     /* 113936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113951 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113955 */     // MIs[1] Operand 1
     /* 113955 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113962 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113974 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113978 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113984 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113987 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113991 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113996 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114001 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114004 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114008 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114013 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114030 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114061 */     GIR_RootConstrainSelectedInstOperands,
     /* 114062 */     // GIR_Coverage, 3968,
     /* 114062 */     GIR_EraseRootFromParent_Done,
     /* 114063 */   // Label 1664: @114063
     /* 114063 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(114195), // Rule ID 3976 //
     /* 114068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114083 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114087 */     // MIs[1] Operand 1
     /* 114087 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 114092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114094 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114094 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114097 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 114101 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114110 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114116 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114119 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114123 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114128 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114133 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114136 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114140 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114145 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114162 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114193 */     GIR_RootConstrainSelectedInstOperands,
     /* 114194 */     // GIR_Coverage, 3976,
     /* 114194 */     GIR_EraseRootFromParent_Done,
     /* 114195 */   // Label 1665: @114195
     /* 114195 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(114327), // Rule ID 3984 //
     /* 114200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114215 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114219 */     // MIs[1] Operand 1
     /* 114219 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 114224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114226 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114226 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114229 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114233 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114238 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114242 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114248 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114251 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114255 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114260 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114265 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114268 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114272 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114277 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114294 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114325 */     GIR_RootConstrainSelectedInstOperands,
     /* 114326 */     // GIR_Coverage, 3984,
     /* 114326 */     GIR_EraseRootFromParent_Done,
     /* 114327 */   // Label 1666: @114327
     /* 114327 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(114459), // Rule ID 3992 //
     /* 114332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114347 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114351 */     // MIs[1] Operand 1
     /* 114351 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 114356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114358 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114370 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114380 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114383 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114387 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114392 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114397 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114400 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114404 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114409 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114426 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 114433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114457 */     GIR_RootConstrainSelectedInstOperands,
     /* 114458 */     // GIR_Coverage, 3992,
     /* 114458 */     GIR_EraseRootFromParent_Done,
     /* 114459 */   // Label 1667: @114459
     /* 114459 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(114474), // Rule ID 2986 //
     /* 114464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 114467 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 114467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 114472 */     GIR_RootConstrainSelectedInstOperands,
     /* 114473 */     // GIR_Coverage, 2986,
     /* 114473 */     GIR_Done,
     /* 114474 */   // Label 1668: @114474
     /* 114474 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(114528), // Rule ID 3670 //
     /* 114479 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 114479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114491 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 114494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114508 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 114511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114518 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 114520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114526 */     GIR_RootConstrainSelectedInstOperands,
     /* 114527 */     // GIR_Coverage, 3670,
     /* 114527 */     GIR_EraseRootFromParent_Done,
     /* 114528 */   // Label 1669: @114528
     /* 114528 */   GIM_Reject,
     /* 114529 */ // Label 1577: @114529
     /* 114529 */ GIM_Reject,
     /* 114530 */ // Label 1483: @114530
     /* 114530 */ GIM_Reject,
     /* 114531 */ // Label 22: @114531
     /* 114531 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(114716),
     /* 114536 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 114539 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1673*/ GIMT_Encode4(114650),
     /* 114550 */   /*GILLT_s32*//*Label 1671*/ GIMT_Encode4(114558),
     /* 114554 */   /*GILLT_s64*//*Label 1672*/ GIMT_Encode4(114604),
     /* 114558 */   // Label 1671: @114558
     /* 114558 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(114603), // Rule ID 1168 //
     /* 114563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 114575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 114579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 114587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114589 */     // (trunc:{ *:[i1] } (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] }))  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 114589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /* 114592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 114598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 114601 */     GIR_RootConstrainSelectedInstOperands,
     /* 114602 */     // GIR_Coverage, 1168,
     /* 114602 */     GIR_EraseRootFromParent_Done,
     /* 114603 */   // Label 1674: @114603
     /* 114603 */   GIM_Reject,
     /* 114604 */   // Label 1672: @114604
     /* 114604 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(114649), // Rule ID 1170 //
     /* 114609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 114621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114629 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 114633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114635 */     // (trunc:{ *:[i1] } (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] }))  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 114635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /* 114638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 114644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 114647 */     GIR_RootConstrainSelectedInstOperands,
     /* 114648 */     // GIR_Coverage, 1170,
     /* 114648 */     GIR_EraseRootFromParent_Done,
     /* 114649 */   // Label 1675: @114649
     /* 114649 */   GIM_Reject,
     /* 114650 */   // Label 1673: @114650
     /* 114650 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1678*/ GIMT_Encode4(114715),
     /* 114661 */   /*GILLT_s32*//*Label 1676*/ GIMT_Encode4(114669),
     /* 114665 */   /*GILLT_s64*//*Label 1677*/ GIMT_Encode4(114692),
     /* 114669 */   // Label 1676: @114669
     /* 114669 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(114691), // Rule ID 1169 //
     /* 114674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114678 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$in)  =>  (ANDI_rec_1_GT_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 114678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT),
     /* 114683 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 114689 */     GIR_RootConstrainSelectedInstOperands,
     /* 114690 */     // GIR_Coverage, 1169,
     /* 114690 */     GIR_Done,
     /* 114691 */   // Label 1679: @114691
     /* 114691 */   GIM_Reject,
     /* 114692 */   // Label 1677: @114692
     /* 114692 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(114714), // Rule ID 1171 //
     /* 114697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114701 */     // (trunc:{ *:[i1] } i64:{ *:[i64] }:$in)  =>  (ANDI_rec_1_GT_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 114701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT8),
     /* 114706 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 114712 */     GIR_RootConstrainSelectedInstOperands,
     /* 114713 */     // GIR_Coverage, 1171,
     /* 114713 */     GIR_Done,
     /* 114714 */   // Label 1680: @114714
     /* 114714 */   GIM_Reject,
     /* 114715 */   // Label 1678: @114715
     /* 114715 */   GIM_Reject,
     /* 114716 */ // Label 1670: @114716
     /* 114716 */ GIM_Reject,
     /* 114717 */ // Label 23: @114717
     /* 114717 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 1684*/ GIMT_Encode4(114868),
     /* 114728 */ /*GILLT_s1*//*Label 1681*/ GIMT_Encode4(114740),
     /* 114732 */ /*GILLT_s32*//*Label 1682*/ GIMT_Encode4(114820),
     /* 114736 */ /*GILLT_s64*//*Label 1683*/ GIMT_Encode4(114844),
     /* 114740 */ // Label 1681: @114740
     /* 114740 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(114819),
     /* 114745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114749 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(114772), // Rule ID 184 //
     /* 114754 */     // MIs[0] Operand 1
     /* 114754 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 114765 */     // 1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 114765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 114768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 114770 */     GIR_RootConstrainSelectedInstOperands,
     /* 114771 */     // GIR_Coverage, 184,
     /* 114771 */     GIR_EraseRootFromParent_Done,
     /* 114772 */   // Label 1686: @114772
     /* 114772 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(114795), // Rule ID 185 //
     /* 114777 */     // MIs[0] Operand 1
     /* 114777 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 114788 */     // 0:{ *:[i1] }  =>  (CRUNSET:{ *:[i1] })
     /* 114788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRUNSET),
     /* 114791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 114793 */     GIR_RootConstrainSelectedInstOperands,
     /* 114794 */     // GIR_Coverage, 185,
     /* 114794 */     GIR_EraseRootFromParent_Done,
     /* 114795 */   // Label 1687: @114795
     /* 114795 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(114818), // Rule ID 3664 //
     /* 114800 */     // MIs[0] Operand 1
     /* 114800 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 114811 */     // -1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 114811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 114814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 114816 */     GIR_RootConstrainSelectedInstOperands,
     /* 114817 */     // GIR_Coverage, 3664,
     /* 114817 */     GIR_EraseRootFromParent_Done,
     /* 114818 */   // Label 1688: @114818
     /* 114818 */   GIM_Reject,
     /* 114819 */ // Label 1685: @114819
     /* 114819 */ GIM_Reject,
     /* 114820 */ // Label 1682: @114820
     /* 114820 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(114843), // Rule ID 113 //
     /* 114825 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 114829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 114833 */   // MIs[0] Operand 1
     /* 114833 */   // No operand predicates
     /* 114833 */   // (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D  =>  (LI:{ *:[i32] } (imm:{ *:[i32] }):$D)
     /* 114833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 114836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114838 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 114841 */   GIR_RootConstrainSelectedInstOperands,
     /* 114842 */   // GIR_Coverage, 113,
     /* 114842 */   GIR_EraseRootFromParent_Done,
     /* 114843 */ // Label 1689: @114843
     /* 114843 */ GIM_Reject,
     /* 114844 */ // Label 1683: @114844
     /* 114844 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(114867), // Rule ID 639 //
     /* 114849 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 114853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 114857 */   // MIs[0] Operand 1
     /* 114857 */   // No operand predicates
     /* 114857 */   // (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D  =>  (LI8:{ *:[i64] } (imm:{ *:[i64] }):$D)
     /* 114857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114862 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 114865 */   GIR_RootConstrainSelectedInstOperands,
     /* 114866 */   // GIR_Coverage, 639,
     /* 114866 */   GIR_EraseRootFromParent_Done,
     /* 114867 */ // Label 1690: @114867
     /* 114867 */ GIM_Reject,
     /* 114868 */ // Label 1684: @114868
     /* 114868 */ GIM_Reject,
     /* 114869 */ // Label 24: @114869
     /* 114869 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1693*/ GIMT_Encode4(129900),
     /* 114880 */ /*GILLT_s32*//*Label 1691*/ GIMT_Encode4(114888),
     /* 114884 */ /*GILLT_s64*//*Label 1692*/ GIMT_Encode4(122167),
     /* 114888 */ // Label 1691: @114888
     /* 114888 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(122166),
     /* 114893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 114896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 114900 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(115003), // Rule ID 3031 //
     /* 114905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 114908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114920 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 114924 */     // MIs[1] Operand 1
     /* 114924 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 114929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 114933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 114941 */     // MIs[2] Operand 1
     /* 114941 */     // No operand predicates
     /* 114941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114943 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 114943 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114946 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 114950 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 114962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114976 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115001 */     GIR_RootConstrainSelectedInstOperands,
     /* 115002 */     // GIR_Coverage, 3031,
     /* 115002 */     GIR_EraseRootFromParent_Done,
     /* 115003 */   // Label 1695: @115003
     /* 115003 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(115106), // Rule ID 3047 //
     /* 115008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115023 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115027 */     // MIs[1] Operand 1
     /* 115027 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115040 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115044 */     // MIs[2] Operand 1
     /* 115044 */     // No operand predicates
     /* 115044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115046 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 115046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115079 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115104 */     GIR_RootConstrainSelectedInstOperands,
     /* 115105 */     // GIR_Coverage, 3047,
     /* 115105 */     GIR_EraseRootFromParent_Done,
     /* 115106 */   // Label 1696: @115106
     /* 115106 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(115209), // Rule ID 3055 //
     /* 115111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115126 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115130 */     // MIs[1] Operand 1
     /* 115130 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115143 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115147 */     // MIs[2] Operand 1
     /* 115147 */     // No operand predicates
     /* 115147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115149 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 115149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115161 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115182 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115207 */     GIR_RootConstrainSelectedInstOperands,
     /* 115208 */     // GIR_Coverage, 3055,
     /* 115208 */     GIR_EraseRootFromParent_Done,
     /* 115209 */   // Label 1697: @115209
     /* 115209 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(115312), // Rule ID 3127 //
     /* 115214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115229 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115233 */     // MIs[1] Operand 1
     /* 115233 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115250 */     // MIs[2] Operand 1
     /* 115250 */     // No operand predicates
     /* 115250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115252 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 115252 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115255 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115259 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115264 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115285 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115310 */     GIR_RootConstrainSelectedInstOperands,
     /* 115311 */     // GIR_Coverage, 3127,
     /* 115311 */     GIR_EraseRootFromParent_Done,
     /* 115312 */   // Label 1698: @115312
     /* 115312 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(115415), // Rule ID 3143 //
     /* 115317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115332 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115336 */     // MIs[1] Operand 1
     /* 115336 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115349 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115353 */     // MIs[2] Operand 1
     /* 115353 */     // No operand predicates
     /* 115353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115355 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 115355 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115358 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115362 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115388 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115413 */     GIR_RootConstrainSelectedInstOperands,
     /* 115414 */     // GIR_Coverage, 3143,
     /* 115414 */     GIR_EraseRootFromParent_Done,
     /* 115415 */   // Label 1699: @115415
     /* 115415 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(115518), // Rule ID 3151 //
     /* 115420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115435 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115439 */     // MIs[1] Operand 1
     /* 115439 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115452 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115456 */     // MIs[2] Operand 1
     /* 115456 */     // No operand predicates
     /* 115456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115458 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 115458 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115461 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115465 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115470 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115491 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115516 */     GIR_RootConstrainSelectedInstOperands,
     /* 115517 */     // GIR_Coverage, 3151,
     /* 115517 */     GIR_EraseRootFromParent_Done,
     /* 115518 */   // Label 1700: @115518
     /* 115518 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(115661), // Rule ID 3812 //
     /* 115523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115538 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115542 */     // MIs[1] Operand 1
     /* 115542 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115555 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115559 */     // MIs[2] Operand 1
     /* 115559 */     // No operand predicates
     /* 115559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115561 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115561 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115564 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115568 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115573 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115582 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115585 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115589 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115594 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115599 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115602 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115606 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115611 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115628 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115659 */     GIR_RootConstrainSelectedInstOperands,
     /* 115660 */     // GIR_Coverage, 3812,
     /* 115660 */     GIR_EraseRootFromParent_Done,
     /* 115661 */   // Label 1701: @115661
     /* 115661 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(115804), // Rule ID 3828 //
     /* 115666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115681 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115685 */     // MIs[1] Operand 1
     /* 115685 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115698 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115702 */     // MIs[2] Operand 1
     /* 115702 */     // No operand predicates
     /* 115702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115704 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115704 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115707 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115711 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115716 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115725 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115728 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115732 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115737 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115742 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115745 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115749 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115754 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115771 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115802 */     GIR_RootConstrainSelectedInstOperands,
     /* 115803 */     // GIR_Coverage, 3828,
     /* 115803 */     GIR_EraseRootFromParent_Done,
     /* 115804 */   // Label 1702: @115804
     /* 115804 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(115947), // Rule ID 3836 //
     /* 115809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115824 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115828 */     // MIs[1] Operand 1
     /* 115828 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115841 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115845 */     // MIs[2] Operand 1
     /* 115845 */     // No operand predicates
     /* 115845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115847 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115868 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115871 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115875 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115880 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115885 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115888 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115892 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115897 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115914 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115945 */     GIR_RootConstrainSelectedInstOperands,
     /* 115946 */     // GIR_Coverage, 3836,
     /* 115946 */     GIR_EraseRootFromParent_Done,
     /* 115947 */   // Label 1703: @115947
     /* 115947 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(116090), // Rule ID 3908 //
     /* 115952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115967 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115971 */     // MIs[1] Operand 1
     /* 115971 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115988 */     // MIs[2] Operand 1
     /* 115988 */     // No operand predicates
     /* 115988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115990 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116002 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116011 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116014 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116018 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116023 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116028 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116031 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116035 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116040 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116057 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116088 */     GIR_RootConstrainSelectedInstOperands,
     /* 116089 */     // GIR_Coverage, 3908,
     /* 116089 */     GIR_EraseRootFromParent_Done,
     /* 116090 */   // Label 1704: @116090
     /* 116090 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(116233), // Rule ID 3924 //
     /* 116095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116110 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116114 */     // MIs[1] Operand 1
     /* 116114 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 116119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116127 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116131 */     // MIs[2] Operand 1
     /* 116131 */     // No operand predicates
     /* 116131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116133 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116133 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116136 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116140 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116145 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116154 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116157 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116161 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116166 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116171 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116174 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116178 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116183 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116200 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116231 */     GIR_RootConstrainSelectedInstOperands,
     /* 116232 */     // GIR_Coverage, 3924,
     /* 116232 */     GIR_EraseRootFromParent_Done,
     /* 116233 */   // Label 1705: @116233
     /* 116233 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(116376), // Rule ID 3932 //
     /* 116238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116253 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116257 */     // MIs[1] Operand 1
     /* 116257 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 116262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116270 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116274 */     // MIs[2] Operand 1
     /* 116274 */     // No operand predicates
     /* 116274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116276 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116276 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116279 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116283 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116288 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116297 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116300 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116304 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116309 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116314 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116317 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116321 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116326 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116343 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116374 */     GIR_RootConstrainSelectedInstOperands,
     /* 116375 */     // GIR_Coverage, 3932,
     /* 116375 */     GIR_EraseRootFromParent_Done,
     /* 116376 */   // Label 1706: @116376
     /* 116376 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(116468), // Rule ID 3175 //
     /* 116381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116396 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116400 */     // MIs[1] Operand 1
     /* 116400 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 116405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116407 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 116407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116423 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116441 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116466 */     GIR_RootConstrainSelectedInstOperands,
     /* 116467 */     // GIR_Coverage, 3175,
     /* 116467 */     GIR_EraseRootFromParent_Done,
     /* 116468 */   // Label 1707: @116468
     /* 116468 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(116560), // Rule ID 3191 //
     /* 116473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116488 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116492 */     // MIs[1] Operand 1
     /* 116492 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 116497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116499 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 116499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116511 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116533 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116558 */     GIR_RootConstrainSelectedInstOperands,
     /* 116559 */     // GIR_Coverage, 3191,
     /* 116559 */     GIR_EraseRootFromParent_Done,
     /* 116560 */   // Label 1708: @116560
     /* 116560 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(116652), // Rule ID 3207 //
     /* 116565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116580 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116584 */     // MIs[1] Operand 1
     /* 116584 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 116589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116591 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 116591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116603 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116607 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116625 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116650 */     GIR_RootConstrainSelectedInstOperands,
     /* 116651 */     // GIR_Coverage, 3207,
     /* 116651 */     GIR_EraseRootFromParent_Done,
     /* 116652 */   // Label 1709: @116652
     /* 116652 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(116744), // Rule ID 3223 //
     /* 116657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116672 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116676 */     // MIs[1] Operand 1
     /* 116676 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 116681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116683 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 116683 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116690 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116695 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116717 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 116724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116742 */     GIR_RootConstrainSelectedInstOperands,
     /* 116743 */     // GIR_Coverage, 3223,
     /* 116743 */     GIR_EraseRootFromParent_Done,
     /* 116744 */   // Label 1710: @116744
     /* 116744 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(116836), // Rule ID 3231 //
     /* 116749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116764 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116768 */     // MIs[1] Operand 1
     /* 116768 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 116773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116775 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 116775 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116778 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 116782 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116787 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116791 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116809 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116834 */     GIR_RootConstrainSelectedInstOperands,
     /* 116835 */     // GIR_Coverage, 3231,
     /* 116835 */     GIR_EraseRootFromParent_Done,
     /* 116836 */   // Label 1711: @116836
     /* 116836 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(116928), // Rule ID 3247 //
     /* 116841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116856 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116860 */     // MIs[1] Operand 1
     /* 116860 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 116865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116867 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 116867 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116870 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 116874 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116879 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116901 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116926 */     GIR_RootConstrainSelectedInstOperands,
     /* 116927 */     // GIR_Coverage, 3247,
     /* 116927 */     GIR_EraseRootFromParent_Done,
     /* 116928 */   // Label 1712: @116928
     /* 116928 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(117020), // Rule ID 3263 //
     /* 116933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116948 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116952 */     // MIs[1] Operand 1
     /* 116952 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 116957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116959 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 116959 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116962 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 116966 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116971 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116993 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117018 */     GIR_RootConstrainSelectedInstOperands,
     /* 117019 */     // GIR_Coverage, 3263,
     /* 117019 */     GIR_EraseRootFromParent_Done,
     /* 117020 */   // Label 1713: @117020
     /* 117020 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(117112), // Rule ID 3279 //
     /* 117025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117040 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117044 */     // MIs[1] Operand 1
     /* 117044 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117051 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 117051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117063 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117067 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117085 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117110 */     GIR_RootConstrainSelectedInstOperands,
     /* 117111 */     // GIR_Coverage, 3279,
     /* 117111 */     GIR_EraseRootFromParent_Done,
     /* 117112 */   // Label 1714: @117112
     /* 117112 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(117204), // Rule ID 3287 //
     /* 117117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117132 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117136 */     // MIs[1] Operand 1
     /* 117136 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117143 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 117143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117155 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117159 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117177 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117202 */     GIR_RootConstrainSelectedInstOperands,
     /* 117203 */     // GIR_Coverage, 3287,
     /* 117203 */     GIR_EraseRootFromParent_Done,
     /* 117204 */   // Label 1715: @117204
     /* 117204 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(117296), // Rule ID 3303 //
     /* 117209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117224 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117228 */     // MIs[1] Operand 1
     /* 117228 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117235 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 117235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117251 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117269 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117294 */     GIR_RootConstrainSelectedInstOperands,
     /* 117295 */     // GIR_Coverage, 3303,
     /* 117295 */     GIR_EraseRootFromParent_Done,
     /* 117296 */   // Label 1716: @117296
     /* 117296 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(117388), // Rule ID 3319 //
     /* 117301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117320 */     // MIs[1] Operand 1
     /* 117320 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 117325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117327 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 117327 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117330 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117334 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117361 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117386 */     GIR_RootConstrainSelectedInstOperands,
     /* 117387 */     // GIR_Coverage, 3319,
     /* 117387 */     GIR_EraseRootFromParent_Done,
     /* 117388 */   // Label 1717: @117388
     /* 117388 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(117480), // Rule ID 3335 //
     /* 117393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117408 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117412 */     // MIs[1] Operand 1
     /* 117412 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117419 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 117419 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117422 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117426 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117431 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117435 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117453 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117478 */     GIR_RootConstrainSelectedInstOperands,
     /* 117479 */     // GIR_Coverage, 3335,
     /* 117479 */     GIR_EraseRootFromParent_Done,
     /* 117480 */   // Label 1718: @117480
     /* 117480 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(117612), // Rule ID 4014 //
     /* 117485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117500 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117504 */     // MIs[1] Operand 1
     /* 117504 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117511 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117511 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117518 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117523 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117527 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117533 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117536 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117540 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117545 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117550 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117553 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117557 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117562 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117579 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117610 */     GIR_RootConstrainSelectedInstOperands,
     /* 117611 */     // GIR_Coverage, 4014,
     /* 117611 */     GIR_EraseRootFromParent_Done,
     /* 117612 */   // Label 1719: @117612
     /* 117612 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(117744), // Rule ID 4046 //
     /* 117617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117632 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117636 */     // MIs[1] Operand 1
     /* 117636 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117643 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117655 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117659 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117665 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117668 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117672 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117677 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117682 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117685 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117689 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117694 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117711 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117742 */     GIR_RootConstrainSelectedInstOperands,
     /* 117743 */     // GIR_Coverage, 4046,
     /* 117743 */     GIR_EraseRootFromParent_Done,
     /* 117744 */   // Label 1720: @117744
     /* 117744 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(117876), // Rule ID 4078 //
     /* 117749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117764 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117768 */     // MIs[1] Operand 1
     /* 117768 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 117773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117775 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117775 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117778 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117782 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117787 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117791 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117797 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117800 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117804 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117809 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117814 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117817 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117821 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117826 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117843 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117874 */     GIR_RootConstrainSelectedInstOperands,
     /* 117875 */     // GIR_Coverage, 4078,
     /* 117875 */     GIR_EraseRootFromParent_Done,
     /* 117876 */   // Label 1721: @117876
     /* 117876 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(118008), // Rule ID 4110 //
     /* 117881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117900 */     // MIs[1] Operand 1
     /* 117900 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117907 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117919 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117923 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117929 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117932 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117936 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117941 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117958 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117975 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118006 */     GIR_RootConstrainSelectedInstOperands,
     /* 118007 */     // GIR_Coverage, 4110,
     /* 118007 */     GIR_EraseRootFromParent_Done,
     /* 118008 */   // Label 1722: @118008
     /* 118008 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(118140), // Rule ID 4126 //
     /* 118013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118028 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118032 */     // MIs[1] Operand 1
     /* 118032 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 118037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118039 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118051 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118055 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118061 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118064 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118068 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118073 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118090 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118107 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118138 */     GIR_RootConstrainSelectedInstOperands,
     /* 118139 */     // GIR_Coverage, 4126,
     /* 118139 */     GIR_EraseRootFromParent_Done,
     /* 118140 */   // Label 1723: @118140
     /* 118140 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(118272), // Rule ID 4158 //
     /* 118145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118160 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118164 */     // MIs[1] Operand 1
     /* 118164 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 118169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118171 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118183 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118193 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118196 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118200 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118205 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118210 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118213 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118217 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118222 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118239 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118270 */     GIR_RootConstrainSelectedInstOperands,
     /* 118271 */     // GIR_Coverage, 4158,
     /* 118271 */     GIR_EraseRootFromParent_Done,
     /* 118272 */   // Label 1724: @118272
     /* 118272 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(118404), // Rule ID 4190 //
     /* 118277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118292 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118296 */     // MIs[1] Operand 1
     /* 118296 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 118301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118303 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118315 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118319 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118325 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118328 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118332 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118337 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118342 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118345 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118349 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118354 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118371 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118402 */     GIR_RootConstrainSelectedInstOperands,
     /* 118403 */     // GIR_Coverage, 4190,
     /* 118403 */     GIR_EraseRootFromParent_Done,
     /* 118404 */   // Label 1725: @118404
     /* 118404 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(118536), // Rule ID 4222 //
     /* 118409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118424 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118428 */     // MIs[1] Operand 1
     /* 118428 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 118433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118435 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118435 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118438 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118442 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118447 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118457 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118460 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118464 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118469 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118474 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118477 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118481 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118486 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118503 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 118510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118534 */     GIR_RootConstrainSelectedInstOperands,
     /* 118535 */     // GIR_Coverage, 4222,
     /* 118535 */     GIR_EraseRootFromParent_Done,
     /* 118536 */   // Label 1726: @118536
     /* 118536 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(118668), // Rule ID 4252 //
     /* 118541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118556 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118560 */     // MIs[1] Operand 1
     /* 118560 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 118565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118567 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118579 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118583 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118589 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118592 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118596 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118601 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118606 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118609 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118613 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118618 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118635 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118666 */     GIR_RootConstrainSelectedInstOperands,
     /* 118667 */     // GIR_Coverage, 4252,
     /* 118667 */     GIR_EraseRootFromParent_Done,
     /* 118668 */   // Label 1727: @118668
     /* 118668 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(118800), // Rule ID 4284 //
     /* 118673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118688 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118692 */     // MIs[1] Operand 1
     /* 118692 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 118697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118699 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118699 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118702 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118706 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118711 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118721 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118724 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118728 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118733 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118738 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118741 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118745 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118750 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118767 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118798 */     GIR_RootConstrainSelectedInstOperands,
     /* 118799 */     // GIR_Coverage, 4284,
     /* 118799 */     GIR_EraseRootFromParent_Done,
     /* 118800 */   // Label 1728: @118800
     /* 118800 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(118932), // Rule ID 4316 //
     /* 118805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118820 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118824 */     // MIs[1] Operand 1
     /* 118824 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 118829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118831 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118843 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118847 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118853 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118856 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118860 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118865 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118870 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118873 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118877 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118882 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118899 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118930 */     GIR_RootConstrainSelectedInstOperands,
     /* 118931 */     // GIR_Coverage, 4316,
     /* 118931 */     GIR_EraseRootFromParent_Done,
     /* 118932 */   // Label 1729: @118932
     /* 118932 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(119064), // Rule ID 4348 //
     /* 118937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118952 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118956 */     // MIs[1] Operand 1
     /* 118956 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 118961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118963 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118979 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118985 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118988 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118992 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118997 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119002 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119005 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119009 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119014 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119031 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 119038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119062 */     GIR_RootConstrainSelectedInstOperands,
     /* 119063 */     // GIR_Coverage, 4348,
     /* 119063 */     GIR_EraseRootFromParent_Done,
     /* 119064 */   // Label 1730: @119064
     /* 119064 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(119196), // Rule ID 4579 //
     /* 119069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119084 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119088 */     // MIs[1] Operand 1
     /* 119088 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 119093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119095 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119095 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119098 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 119102 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119107 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119111 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119117 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119120 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119124 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119129 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119134 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119137 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119141 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119146 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119163 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119194 */     GIR_RootConstrainSelectedInstOperands,
     /* 119195 */     // GIR_Coverage, 4579,
     /* 119195 */     GIR_EraseRootFromParent_Done,
     /* 119196 */   // Label 1731: @119196
     /* 119196 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(119328), // Rule ID 4611 //
     /* 119201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119216 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119220 */     // MIs[1] Operand 1
     /* 119220 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119227 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 119234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119239 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119243 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119249 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119252 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119256 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119261 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119266 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119269 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119273 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119278 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119295 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119326 */     GIR_RootConstrainSelectedInstOperands,
     /* 119327 */     // GIR_Coverage, 4611,
     /* 119327 */     GIR_EraseRootFromParent_Done,
     /* 119328 */   // Label 1732: @119328
     /* 119328 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(119460), // Rule ID 4643 //
     /* 119333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119348 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119352 */     // MIs[1] Operand 1
     /* 119352 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 119357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119359 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 119366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119381 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119384 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119388 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119393 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119398 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119401 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119405 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119410 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119427 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119458 */     GIR_RootConstrainSelectedInstOperands,
     /* 119459 */     // GIR_Coverage, 4643,
     /* 119459 */     GIR_EraseRootFromParent_Done,
     /* 119460 */   // Label 1733: @119460
     /* 119460 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(119592), // Rule ID 4687 //
     /* 119465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119484 */     // MIs[1] Operand 1
     /* 119484 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 119489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119491 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 119498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119507 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119513 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119516 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119520 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119525 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119530 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119533 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119537 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119542 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119559 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119590 */     GIR_RootConstrainSelectedInstOperands,
     /* 119591 */     // GIR_Coverage, 4687,
     /* 119591 */     GIR_EraseRootFromParent_Done,
     /* 119592 */   // Label 1734: @119592
     /* 119592 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(119724), // Rule ID 4719 //
     /* 119597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119612 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119616 */     // MIs[1] Operand 1
     /* 119616 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119623 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 119630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119639 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119645 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119648 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119652 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119657 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119662 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119665 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119669 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119674 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119691 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119722 */     GIR_RootConstrainSelectedInstOperands,
     /* 119723 */     // GIR_Coverage, 4719,
     /* 119723 */     GIR_EraseRootFromParent_Done,
     /* 119724 */   // Label 1735: @119724
     /* 119724 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(119856), // Rule ID 4751 //
     /* 119729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119744 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119748 */     // MIs[1] Operand 1
     /* 119748 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 119753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119755 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119755 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119758 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 119762 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119767 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119771 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119777 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119780 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119784 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119789 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119794 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119797 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119801 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119806 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119823 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119854 */     GIR_RootConstrainSelectedInstOperands,
     /* 119855 */     // GIR_Coverage, 4751,
     /* 119855 */     GIR_EraseRootFromParent_Done,
     /* 119856 */   // Label 1736: @119856
     /* 119856 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(119948), // Rule ID 2977 //
     /* 119861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 119864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119876 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119880 */     // MIs[1] Operand 1
     /* 119880 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 119885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119887 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 119887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 119894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119903 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119921 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 119928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 119941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 119943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119946 */     GIR_RootConstrainSelectedInstOperands,
     /* 119947 */     // GIR_Coverage, 2977,
     /* 119947 */     GIR_EraseRootFromParent_Done,
     /* 119948 */   // Label 1737: @119948
     /* 119948 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(120040), // Rule ID 2991 //
     /* 119953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 119956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119968 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119972 */     // MIs[1] Operand 1
     /* 119972 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 119977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119979 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 119979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 119986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119991 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119995 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120013 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120038 */     GIR_RootConstrainSelectedInstOperands,
     /* 120039 */     // GIR_Coverage, 2991,
     /* 120039 */     GIR_EraseRootFromParent_Done,
     /* 120040 */   // Label 1738: @120040
     /* 120040 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(120132), // Rule ID 2999 //
     /* 120045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120060 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120064 */     // MIs[1] Operand 1
     /* 120064 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 120069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120071 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 120071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 120078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120105 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120130 */     GIR_RootConstrainSelectedInstOperands,
     /* 120131 */     // GIR_Coverage, 2999,
     /* 120131 */     GIR_EraseRootFromParent_Done,
     /* 120132 */   // Label 1739: @120132
     /* 120132 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(120224), // Rule ID 3007 //
     /* 120137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120152 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120156 */     // MIs[1] Operand 1
     /* 120156 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120163 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 120163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120197 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120222 */     GIR_RootConstrainSelectedInstOperands,
     /* 120223 */     // GIR_Coverage, 3007,
     /* 120223 */     GIR_EraseRootFromParent_Done,
     /* 120224 */   // Label 1740: @120224
     /* 120224 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(120316), // Rule ID 3015 //
     /* 120229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120244 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120248 */     // MIs[1] Operand 1
     /* 120248 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 120253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120255 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 120255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120267 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120271 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120289 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 120296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120314 */     GIR_RootConstrainSelectedInstOperands,
     /* 120315 */     // GIR_Coverage, 3015,
     /* 120315 */     GIR_EraseRootFromParent_Done,
     /* 120316 */   // Label 1741: @120316
     /* 120316 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(120408), // Rule ID 3079 //
     /* 120321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120340 */     // MIs[1] Operand 1
     /* 120340 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 120345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120347 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 120347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 120354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120363 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120381 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120406 */     GIR_RootConstrainSelectedInstOperands,
     /* 120407 */     // GIR_Coverage, 3079,
     /* 120407 */     GIR_EraseRootFromParent_Done,
     /* 120408 */   // Label 1742: @120408
     /* 120408 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(120500), // Rule ID 3087 //
     /* 120413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120428 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120432 */     // MIs[1] Operand 1
     /* 120432 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120439 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 120439 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120442 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120446 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120473 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120498 */     GIR_RootConstrainSelectedInstOperands,
     /* 120499 */     // GIR_Coverage, 3087,
     /* 120499 */     GIR_EraseRootFromParent_Done,
     /* 120500 */   // Label 1743: @120500
     /* 120500 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(120592), // Rule ID 3095 //
     /* 120505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120520 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120524 */     // MIs[1] Operand 1
     /* 120524 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 120529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120531 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 120531 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120534 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 120538 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120543 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120565 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120590 */     GIR_RootConstrainSelectedInstOperands,
     /* 120591 */     // GIR_Coverage, 3095,
     /* 120591 */     GIR_EraseRootFromParent_Done,
     /* 120592 */   // Label 1744: @120592
     /* 120592 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(120684), // Rule ID 3103 //
     /* 120597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120612 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120616 */     // MIs[1] Operand 1
     /* 120616 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120623 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 120623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120639 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120657 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120682 */     GIR_RootConstrainSelectedInstOperands,
     /* 120683 */     // GIR_Coverage, 3103,
     /* 120683 */     GIR_EraseRootFromParent_Done,
     /* 120684 */   // Label 1745: @120684
     /* 120684 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(120776), // Rule ID 3111 //
     /* 120689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120704 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120708 */     // MIs[1] Operand 1
     /* 120708 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 120713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120715 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 120715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120731 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120749 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 120756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120774 */     GIR_RootConstrainSelectedInstOperands,
     /* 120775 */     // GIR_Coverage, 3111,
     /* 120775 */     GIR_EraseRootFromParent_Done,
     /* 120776 */   // Label 1746: @120776
     /* 120776 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(120908), // Rule ID 3860 //
     /* 120781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 120784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120796 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120800 */     // MIs[1] Operand 1
     /* 120800 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 120805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120807 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 120807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 120814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120829 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 120832 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120836 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120841 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 120849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120858 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120875 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 120895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120906 */     GIR_RootConstrainSelectedInstOperands,
     /* 120907 */     // GIR_Coverage, 3860,
     /* 120907 */     GIR_EraseRootFromParent_Done,
     /* 120908 */   // Label 1747: @120908
     /* 120908 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(121040), // Rule ID 3868 //
     /* 120913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 120916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120932 */     // MIs[1] Operand 1
     /* 120932 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120939 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 120939 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120942 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120946 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120961 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 120964 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120968 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120973 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 120981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120990 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121007 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121038 */     GIR_RootConstrainSelectedInstOperands,
     /* 121039 */     // GIR_Coverage, 3868,
     /* 121039 */     GIR_EraseRootFromParent_Done,
     /* 121040 */   // Label 1748: @121040
     /* 121040 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(121172), // Rule ID 3876 //
     /* 121045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121060 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121064 */     // MIs[1] Operand 1
     /* 121064 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 121069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121071 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 121078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121093 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121096 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121100 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121105 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121110 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121113 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121117 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121122 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121139 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121170 */     GIR_RootConstrainSelectedInstOperands,
     /* 121171 */     // GIR_Coverage, 3876,
     /* 121171 */     GIR_EraseRootFromParent_Done,
     /* 121172 */   // Label 1749: @121172
     /* 121172 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(121304), // Rule ID 3884 //
     /* 121177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121192 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121196 */     // MIs[1] Operand 1
     /* 121196 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 121201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121203 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121225 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121228 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121232 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121237 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121242 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121245 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121249 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121254 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121271 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121302 */     GIR_RootConstrainSelectedInstOperands,
     /* 121303 */     // GIR_Coverage, 3884,
     /* 121303 */     GIR_EraseRootFromParent_Done,
     /* 121304 */   // Label 1750: @121304
     /* 121304 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(121436), // Rule ID 3892 //
     /* 121309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121324 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121328 */     // MIs[1] Operand 1
     /* 121328 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 121333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121335 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121335 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121338 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121342 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121351 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121357 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121360 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121364 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121369 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121374 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121377 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121381 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121386 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121403 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 121410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121434 */     GIR_RootConstrainSelectedInstOperands,
     /* 121435 */     // GIR_Coverage, 3892,
     /* 121435 */     GIR_EraseRootFromParent_Done,
     /* 121436 */   // Label 1751: @121436
     /* 121436 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(121568), // Rule ID 3956 //
     /* 121441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121460 */     // MIs[1] Operand 1
     /* 121460 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 121465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121467 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 121474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121479 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121489 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121492 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121496 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121501 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121506 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121509 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121513 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121518 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121535 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121566 */     GIR_RootConstrainSelectedInstOperands,
     /* 121567 */     // GIR_Coverage, 3956,
     /* 121567 */     GIR_EraseRootFromParent_Done,
     /* 121568 */   // Label 1752: @121568
     /* 121568 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(121700), // Rule ID 3964 //
     /* 121573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121588 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121592 */     // MIs[1] Operand 1
     /* 121592 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 121597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121599 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121599 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121602 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 121606 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121611 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121621 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121624 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121628 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121633 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121638 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121641 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121645 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121650 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121667 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121698 */     GIR_RootConstrainSelectedInstOperands,
     /* 121699 */     // GIR_Coverage, 3964,
     /* 121699 */     GIR_EraseRootFromParent_Done,
     /* 121700 */   // Label 1753: @121700
     /* 121700 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(121832), // Rule ID 3972 //
     /* 121705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121724 */     // MIs[1] Operand 1
     /* 121724 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 121729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121731 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121731 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121734 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 121738 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121743 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121753 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121756 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121760 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121765 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121782 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121799 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121830 */     GIR_RootConstrainSelectedInstOperands,
     /* 121831 */     // GIR_Coverage, 3972,
     /* 121831 */     GIR_EraseRootFromParent_Done,
     /* 121832 */   // Label 1754: @121832
     /* 121832 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(121964), // Rule ID 3980 //
     /* 121837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121852 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121856 */     // MIs[1] Operand 1
     /* 121856 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 121861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121863 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 121870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121879 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121885 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121888 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121892 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121897 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121902 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121905 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121909 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121914 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121931 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121962 */     GIR_RootConstrainSelectedInstOperands,
     /* 121963 */     // GIR_Coverage, 3980,
     /* 121963 */     GIR_EraseRootFromParent_Done,
     /* 121964 */   // Label 1755: @121964
     /* 121964 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(122096), // Rule ID 3988 //
     /* 121969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121984 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121988 */     // MIs[1] Operand 1
     /* 121988 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 121993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121995 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 122002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122017 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 122020 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122024 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122029 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122034 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 122037 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122041 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122046 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122063 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122094 */     GIR_RootConstrainSelectedInstOperands,
     /* 122095 */     // GIR_Coverage, 3988,
     /* 122095 */     GIR_EraseRootFromParent_Done,
     /* 122096 */   // Label 1756: @122096
     /* 122096 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(122111), // Rule ID 2983 //
     /* 122101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122104 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETNBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 122104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC),
     /* 122109 */     GIR_RootConstrainSelectedInstOperands,
     /* 122110 */     // GIR_Coverage, 2983,
     /* 122110 */     GIR_Done,
     /* 122111 */   // Label 1757: @122111
     /* 122111 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(122165), // Rule ID 3666 //
     /* 122116 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } -1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 122116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122128 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 122131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122145 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 122148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122155 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 122157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 122163 */     GIR_RootConstrainSelectedInstOperands,
     /* 122164 */     // GIR_Coverage, 3666,
     /* 122164 */     GIR_EraseRootFromParent_Done,
     /* 122165 */   // Label 1758: @122165
     /* 122165 */   GIM_Reject,
     /* 122166 */ // Label 1694: @122166
     /* 122166 */ GIM_Reject,
     /* 122167 */ // Label 1692: @122167
     /* 122167 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(122277), // Rule ID 3032 //
     /* 122172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122194 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122198 */   // MIs[1] Operand 1
     /* 122198 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122203 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122207 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122211 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122215 */   // MIs[2] Operand 1
     /* 122215 */   // No operand predicates
     /* 122215 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122217 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 122217 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122220 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122224 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122229 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122233 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122250 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122257 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122262 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122275 */   GIR_RootConstrainSelectedInstOperands,
     /* 122276 */   // GIR_Coverage, 3032,
     /* 122276 */   GIR_EraseRootFromParent_Done,
     /* 122277 */ // Label 1759: @122277
     /* 122277 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(122387), // Rule ID 3048 //
     /* 122282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122300 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122304 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122308 */   // MIs[1] Operand 1
     /* 122308 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122313 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122317 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122321 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122325 */   // MIs[2] Operand 1
     /* 122325 */   // No operand predicates
     /* 122325 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122327 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 122327 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122330 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122334 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122339 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122343 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122360 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122367 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122385 */   GIR_RootConstrainSelectedInstOperands,
     /* 122386 */   // GIR_Coverage, 3048,
     /* 122386 */   GIR_EraseRootFromParent_Done,
     /* 122387 */ // Label 1760: @122387
     /* 122387 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(122497), // Rule ID 3056 //
     /* 122392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122402 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122410 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122414 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122418 */   // MIs[1] Operand 1
     /* 122418 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 122423 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122427 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122431 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122435 */   // MIs[2] Operand 1
     /* 122435 */   // No operand predicates
     /* 122435 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122437 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 122437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122453 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122470 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122477 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122482 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122495 */   GIR_RootConstrainSelectedInstOperands,
     /* 122496 */   // GIR_Coverage, 3056,
     /* 122496 */   GIR_EraseRootFromParent_Done,
     /* 122497 */ // Label 1761: @122497
     /* 122497 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(122607), // Rule ID 3128 //
     /* 122502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122512 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122520 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122524 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122528 */   // MIs[1] Operand 1
     /* 122528 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122533 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122537 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122541 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122545 */   // MIs[2] Operand 1
     /* 122545 */   // No operand predicates
     /* 122545 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122547 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 122547 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122550 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122554 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122559 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122563 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122580 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122587 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122605 */   GIR_RootConstrainSelectedInstOperands,
     /* 122606 */   // GIR_Coverage, 3128,
     /* 122606 */   GIR_EraseRootFromParent_Done,
     /* 122607 */ // Label 1762: @122607
     /* 122607 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(122717), // Rule ID 3144 //
     /* 122612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122622 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122626 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122634 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122638 */   // MIs[1] Operand 1
     /* 122638 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122643 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122647 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122651 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122655 */   // MIs[2] Operand 1
     /* 122655 */   // No operand predicates
     /* 122655 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122657 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 122657 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122660 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122664 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122669 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122673 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122690 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122715 */   GIR_RootConstrainSelectedInstOperands,
     /* 122716 */   // GIR_Coverage, 3144,
     /* 122716 */   GIR_EraseRootFromParent_Done,
     /* 122717 */ // Label 1763: @122717
     /* 122717 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(122827), // Rule ID 3152 //
     /* 122722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122740 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122744 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122748 */   // MIs[1] Operand 1
     /* 122748 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 122753 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122757 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122761 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122765 */   // MIs[2] Operand 1
     /* 122765 */   // No operand predicates
     /* 122765 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122767 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 122767 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122770 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122774 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122779 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122783 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122800 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122807 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122812 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122825 */   GIR_RootConstrainSelectedInstOperands,
     /* 122826 */   // GIR_Coverage, 3152,
     /* 122826 */   GIR_EraseRootFromParent_Done,
     /* 122827 */ // Label 1764: @122827
     /* 122827 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(122977), // Rule ID 3814 //
     /* 122832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122854 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122858 */   // MIs[1] Operand 1
     /* 122858 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122863 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122867 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122871 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122875 */   // MIs[2] Operand 1
     /* 122875 */   // No operand predicates
     /* 122875 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122877 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 122877 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122880 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122884 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122889 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122893 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122898 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 122901 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122905 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122910 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122915 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 122918 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122922 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122927 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122944 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 122964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122972 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122975 */   GIR_RootConstrainSelectedInstOperands,
     /* 122976 */   // GIR_Coverage, 3814,
     /* 122976 */   GIR_EraseRootFromParent_Done,
     /* 122977 */ // Label 1765: @122977
     /* 122977 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(123127), // Rule ID 3830 //
     /* 122982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123000 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123004 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123008 */   // MIs[1] Operand 1
     /* 123008 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 123013 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123017 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123021 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123025 */   // MIs[2] Operand 1
     /* 123025 */   // No operand predicates
     /* 123025 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123027 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123027 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123030 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123034 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123039 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123043 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123048 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123051 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123055 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123060 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123065 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123068 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123072 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123077 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123094 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123119 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123125 */   GIR_RootConstrainSelectedInstOperands,
     /* 123126 */   // GIR_Coverage, 3830,
     /* 123126 */   GIR_EraseRootFromParent_Done,
     /* 123127 */ // Label 1766: @123127
     /* 123127 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(123277), // Rule ID 3838 //
     /* 123132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123150 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123154 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123158 */   // MIs[1] Operand 1
     /* 123158 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123163 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123167 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123171 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123175 */   // MIs[2] Operand 1
     /* 123175 */   // No operand predicates
     /* 123175 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123177 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123177 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123180 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123184 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123189 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123193 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123198 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123201 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123205 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123210 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123215 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123218 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123222 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123227 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123244 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123251 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123256 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123275 */   GIR_RootConstrainSelectedInstOperands,
     /* 123276 */   // GIR_Coverage, 3838,
     /* 123276 */   GIR_EraseRootFromParent_Done,
     /* 123277 */ // Label 1767: @123277
     /* 123277 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(123427), // Rule ID 3910 //
     /* 123282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123300 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123304 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123308 */   // MIs[1] Operand 1
     /* 123308 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 123313 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123317 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123321 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123325 */   // MIs[2] Operand 1
     /* 123325 */   // No operand predicates
     /* 123325 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123327 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123327 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123330 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123334 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123339 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123343 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123348 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123351 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123355 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123360 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123365 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123368 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123372 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123377 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123394 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123406 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123425 */   GIR_RootConstrainSelectedInstOperands,
     /* 123426 */   // GIR_Coverage, 3910,
     /* 123426 */   GIR_EraseRootFromParent_Done,
     /* 123427 */ // Label 1768: @123427
     /* 123427 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(123577), // Rule ID 3926 //
     /* 123432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123450 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123454 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123458 */   // MIs[1] Operand 1
     /* 123458 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 123463 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123467 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123471 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123475 */   // MIs[2] Operand 1
     /* 123475 */   // No operand predicates
     /* 123475 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123477 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123477 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123480 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123484 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123489 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123493 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123498 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123501 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123505 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123510 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123515 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123518 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123522 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123527 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123544 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123575 */   GIR_RootConstrainSelectedInstOperands,
     /* 123576 */   // GIR_Coverage, 3926,
     /* 123576 */   GIR_EraseRootFromParent_Done,
     /* 123577 */ // Label 1769: @123577
     /* 123577 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(123727), // Rule ID 3934 //
     /* 123582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123600 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123604 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123608 */   // MIs[1] Operand 1
     /* 123608 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123613 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123617 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123621 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123625 */   // MIs[2] Operand 1
     /* 123625 */   // No operand predicates
     /* 123625 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123627 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123627 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123630 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123634 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123639 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123643 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123648 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123651 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123655 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123660 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123665 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123668 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123672 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123677 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123694 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123701 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123706 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123725 */   GIR_RootConstrainSelectedInstOperands,
     /* 123726 */   // GIR_Coverage, 3934,
     /* 123726 */   GIR_EraseRootFromParent_Done,
     /* 123727 */ // Label 1770: @123727
     /* 123727 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(123826), // Rule ID 3176 //
     /* 123732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 123735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123750 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123754 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123758 */   // MIs[1] Operand 1
     /* 123758 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 123763 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123765 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 123765 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123768 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 123772 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123777 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123781 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123799 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123806 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123811 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 123819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 123821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123824 */   GIR_RootConstrainSelectedInstOperands,
     /* 123825 */   // GIR_Coverage, 3176,
     /* 123825 */   GIR_EraseRootFromParent_Done,
     /* 123826 */ // Label 1771: @123826
     /* 123826 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(123925), // Rule ID 3192 //
     /* 123831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 123834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123841 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123845 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123849 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123853 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123857 */   // MIs[1] Operand 1
     /* 123857 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 123862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123864 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 123864 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123867 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 123871 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123876 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123880 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123898 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123905 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123910 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 123918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 123920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123923 */   GIR_RootConstrainSelectedInstOperands,
     /* 123924 */   // GIR_Coverage, 3192,
     /* 123924 */   GIR_EraseRootFromParent_Done,
     /* 123925 */ // Label 1772: @123925
     /* 123925 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(124024), // Rule ID 3208 //
     /* 123930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 123933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123948 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123952 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123956 */   // MIs[1] Operand 1
     /* 123956 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 123961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123963 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 123963 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123966 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 123970 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123975 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123979 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123997 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124004 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124022 */   GIR_RootConstrainSelectedInstOperands,
     /* 124023 */   // GIR_Coverage, 3208,
     /* 124023 */   GIR_EraseRootFromParent_Done,
     /* 124024 */ // Label 1773: @124024
     /* 124024 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(124123), // Rule ID 3224 //
     /* 124029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124047 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124051 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124055 */   // MIs[1] Operand 1
     /* 124055 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124060 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124062 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 124062 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124065 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124069 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124074 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124078 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124096 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124121 */   GIR_RootConstrainSelectedInstOperands,
     /* 124122 */   // GIR_Coverage, 3224,
     /* 124122 */   GIR_EraseRootFromParent_Done,
     /* 124123 */ // Label 1774: @124123
     /* 124123 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(124222), // Rule ID 3232 //
     /* 124128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124138 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124142 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124146 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124150 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124154 */   // MIs[1] Operand 1
     /* 124154 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124159 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124161 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 124161 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124164 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124168 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124173 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124177 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124195 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124220 */   GIR_RootConstrainSelectedInstOperands,
     /* 124221 */   // GIR_Coverage, 3232,
     /* 124221 */   GIR_EraseRootFromParent_Done,
     /* 124222 */ // Label 1775: @124222
     /* 124222 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(124321), // Rule ID 3248 //
     /* 124227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124237 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124241 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124245 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124249 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124253 */   // MIs[1] Operand 1
     /* 124253 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124258 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124260 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 124260 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124263 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124267 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124272 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124276 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124294 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124301 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124306 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124319 */   GIR_RootConstrainSelectedInstOperands,
     /* 124320 */   // GIR_Coverage, 3248,
     /* 124320 */   GIR_EraseRootFromParent_Done,
     /* 124321 */ // Label 1776: @124321
     /* 124321 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(124420), // Rule ID 3264 //
     /* 124326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124336 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124344 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124348 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124352 */   // MIs[1] Operand 1
     /* 124352 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124357 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124359 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 124359 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124362 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124366 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124371 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124375 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124393 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124400 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124405 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124418 */   GIR_RootConstrainSelectedInstOperands,
     /* 124419 */   // GIR_Coverage, 3264,
     /* 124419 */   GIR_EraseRootFromParent_Done,
     /* 124420 */ // Label 1777: @124420
     /* 124420 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(124519), // Rule ID 3280 //
     /* 124425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124435 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124443 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124447 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124451 */   // MIs[1] Operand 1
     /* 124451 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124456 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124458 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 124458 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124461 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124465 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124470 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124474 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124492 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124499 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124504 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124517 */   GIR_RootConstrainSelectedInstOperands,
     /* 124518 */   // GIR_Coverage, 3280,
     /* 124518 */   GIR_EraseRootFromParent_Done,
     /* 124519 */ // Label 1778: @124519
     /* 124519 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(124618), // Rule ID 3288 //
     /* 124524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124542 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124546 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124550 */   // MIs[1] Operand 1
     /* 124550 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124555 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124557 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 124557 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124560 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124564 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124569 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124573 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124591 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124616 */   GIR_RootConstrainSelectedInstOperands,
     /* 124617 */   // GIR_Coverage, 3288,
     /* 124617 */   GIR_EraseRootFromParent_Done,
     /* 124618 */ // Label 1779: @124618
     /* 124618 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(124717), // Rule ID 3304 //
     /* 124623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124641 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124645 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124649 */   // MIs[1] Operand 1
     /* 124649 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124654 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124656 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 124656 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124659 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124663 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124668 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124672 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124690 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124715 */   GIR_RootConstrainSelectedInstOperands,
     /* 124716 */   // GIR_Coverage, 3304,
     /* 124716 */   GIR_EraseRootFromParent_Done,
     /* 124717 */ // Label 1780: @124717
     /* 124717 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(124816), // Rule ID 3320 //
     /* 124722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124740 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124744 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124748 */   // MIs[1] Operand 1
     /* 124748 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124753 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124755 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 124755 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124758 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124762 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124767 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124771 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124789 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124796 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124801 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124814 */   GIR_RootConstrainSelectedInstOperands,
     /* 124815 */   // GIR_Coverage, 3320,
     /* 124815 */   GIR_EraseRootFromParent_Done,
     /* 124816 */ // Label 1781: @124816
     /* 124816 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(124915), // Rule ID 3336 //
     /* 124821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124831 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124839 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124843 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124847 */   // MIs[1] Operand 1
     /* 124847 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124854 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 124854 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124857 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124861 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124866 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124870 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124888 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124895 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124900 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124913 */   GIR_RootConstrainSelectedInstOperands,
     /* 124914 */   // GIR_Coverage, 3336,
     /* 124914 */   GIR_EraseRootFromParent_Done,
     /* 124915 */ // Label 1782: @124915
     /* 124915 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(125054), // Rule ID 4018 //
     /* 124920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 124923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124930 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124934 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124938 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124942 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124946 */   // MIs[1] Operand 1
     /* 124946 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124953 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 124953 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124956 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124960 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124965 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124969 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124975 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 124978 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124982 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124987 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 124990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 124992 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 124995 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124999 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125004 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125009 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125012 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125016 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125021 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125028 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125033 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125049 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125052 */   GIR_RootConstrainSelectedInstOperands,
     /* 125053 */   // GIR_Coverage, 4018,
     /* 125053 */   GIR_EraseRootFromParent_Done,
     /* 125054 */ // Label 1783: @125054
     /* 125054 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(125193), // Rule ID 4050 //
     /* 125059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125069 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125073 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125077 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125081 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125085 */   // MIs[1] Operand 1
     /* 125085 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 125090 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125092 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125092 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125095 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125099 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125104 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125108 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125114 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125117 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125121 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125126 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125131 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125134 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125138 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125143 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125160 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125167 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125172 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125191 */   GIR_RootConstrainSelectedInstOperands,
     /* 125192 */   // GIR_Coverage, 4050,
     /* 125192 */   GIR_EraseRootFromParent_Done,
     /* 125193 */ // Label 1784: @125193
     /* 125193 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(125332), // Rule ID 4082 //
     /* 125198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125216 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125220 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125224 */   // MIs[1] Operand 1
     /* 125224 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 125229 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125231 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125231 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125234 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125238 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125243 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125247 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125253 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125256 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125260 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125265 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125270 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125273 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125277 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125282 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125299 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125306 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125311 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125324 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125330 */   GIR_RootConstrainSelectedInstOperands,
     /* 125331 */   // GIR_Coverage, 4082,
     /* 125331 */   GIR_EraseRootFromParent_Done,
     /* 125332 */ // Label 1785: @125332
     /* 125332 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(125471), // Rule ID 4114 //
     /* 125337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125355 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125359 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125363 */   // MIs[1] Operand 1
     /* 125363 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 125368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125370 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125370 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125373 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125377 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125382 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125386 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125392 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125395 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125399 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125404 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125409 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125412 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125416 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125421 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125438 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 125445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125450 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125469 */   GIR_RootConstrainSelectedInstOperands,
     /* 125470 */   // GIR_Coverage, 4114,
     /* 125470 */   GIR_EraseRootFromParent_Done,
     /* 125471 */ // Label 1786: @125471
     /* 125471 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(125610), // Rule ID 4130 //
     /* 125476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125486 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125494 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125498 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125502 */   // MIs[1] Operand 1
     /* 125502 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 125507 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125509 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125509 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125512 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125516 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125521 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125525 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125531 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125534 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125538 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125543 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125548 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125551 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125555 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125560 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125577 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125584 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125589 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125608 */   GIR_RootConstrainSelectedInstOperands,
     /* 125609 */   // GIR_Coverage, 4130,
     /* 125609 */   GIR_EraseRootFromParent_Done,
     /* 125610 */ // Label 1787: @125610
     /* 125610 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(125749), // Rule ID 4162 //
     /* 125615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125633 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125637 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125641 */   // MIs[1] Operand 1
     /* 125641 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 125646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125648 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125648 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125651 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125655 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125660 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125664 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125670 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125673 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125677 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125682 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125687 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125690 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125694 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125699 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125704 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125707 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125711 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125716 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125723 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125728 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125744 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125747 */   GIR_RootConstrainSelectedInstOperands,
     /* 125748 */   // GIR_Coverage, 4162,
     /* 125748 */   GIR_EraseRootFromParent_Done,
     /* 125749 */ // Label 1788: @125749
     /* 125749 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(125888), // Rule ID 4194 //
     /* 125754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125764 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125772 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125776 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125780 */   // MIs[1] Operand 1
     /* 125780 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 125785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125787 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125787 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125790 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125794 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125799 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125803 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125809 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125812 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125816 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125821 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125826 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125829 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125833 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125838 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125855 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125862 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125886 */   GIR_RootConstrainSelectedInstOperands,
     /* 125887 */   // GIR_Coverage, 4194,
     /* 125887 */   GIR_EraseRootFromParent_Done,
     /* 125888 */ // Label 1789: @125888
     /* 125888 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(126027), // Rule ID 4226 //
     /* 125893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125903 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125907 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125911 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125915 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125919 */   // MIs[1] Operand 1
     /* 125919 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 125924 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125926 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125926 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125929 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125933 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125938 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125942 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125948 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125951 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125955 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125960 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125965 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125968 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125972 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125977 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125994 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 126001 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126006 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126025 */   GIR_RootConstrainSelectedInstOperands,
     /* 126026 */   // GIR_Coverage, 4226,
     /* 126026 */   GIR_EraseRootFromParent_Done,
     /* 126027 */ // Label 1790: @126027
     /* 126027 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(126166), // Rule ID 4256 //
     /* 126032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126042 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126046 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126050 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126054 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126058 */   // MIs[1] Operand 1
     /* 126058 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 126063 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126065 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126065 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126068 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126072 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126077 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126081 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126087 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126090 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126094 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126099 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126104 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126107 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126111 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126116 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126121 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126128 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126133 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 126140 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126145 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126164 */   GIR_RootConstrainSelectedInstOperands,
     /* 126165 */   // GIR_Coverage, 4256,
     /* 126165 */   GIR_EraseRootFromParent_Done,
     /* 126166 */ // Label 1791: @126166
     /* 126166 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(126305), // Rule ID 4288 //
     /* 126171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126189 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126193 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126197 */   // MIs[1] Operand 1
     /* 126197 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 126202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126204 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126204 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126207 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126211 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126216 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126220 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126226 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126229 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126233 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126238 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126243 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126246 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126250 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126255 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126272 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126284 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126303 */   GIR_RootConstrainSelectedInstOperands,
     /* 126304 */   // GIR_Coverage, 4288,
     /* 126304 */   GIR_EraseRootFromParent_Done,
     /* 126305 */ // Label 1792: @126305
     /* 126305 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(126444), // Rule ID 4320 //
     /* 126310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126328 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126332 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126336 */   // MIs[1] Operand 1
     /* 126336 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 126341 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126343 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126343 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126346 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126350 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126355 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126359 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126365 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126368 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126372 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126377 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126382 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126385 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126389 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126394 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126411 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 126418 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126442 */   GIR_RootConstrainSelectedInstOperands,
     /* 126443 */   // GIR_Coverage, 4320,
     /* 126443 */   GIR_EraseRootFromParent_Done,
     /* 126444 */ // Label 1793: @126444
     /* 126444 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(126583), // Rule ID 4352 //
     /* 126449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126467 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126471 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126475 */   // MIs[1] Operand 1
     /* 126475 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 126480 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126482 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126482 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126485 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126489 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126494 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126498 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126504 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126507 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126511 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126516 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126521 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126524 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126528 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126533 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126550 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 126557 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126562 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126581 */   GIR_RootConstrainSelectedInstOperands,
     /* 126582 */   // GIR_Coverage, 4352,
     /* 126582 */   GIR_EraseRootFromParent_Done,
     /* 126583 */ // Label 1794: @126583
     /* 126583 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(126722), // Rule ID 4583 //
     /* 126588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 126591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126598 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126606 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126610 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126614 */   // MIs[1] Operand 1
     /* 126614 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 126619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126621 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126621 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126624 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 126628 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126633 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126637 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126643 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126646 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126650 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126655 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126660 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126663 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126667 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126672 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126689 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126696 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126701 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126711 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126720 */   GIR_RootConstrainSelectedInstOperands,
     /* 126721 */   // GIR_Coverage, 4583,
     /* 126721 */   GIR_EraseRootFromParent_Done,
     /* 126722 */ // Label 1795: @126722
     /* 126722 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(126861), // Rule ID 4615 //
     /* 126727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 126730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126745 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126749 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126753 */   // MIs[1] Operand 1
     /* 126753 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 126758 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126760 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126760 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126763 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 126767 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126772 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126776 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126782 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126785 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126789 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126794 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126799 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126802 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126806 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126811 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126828 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126859 */   GIR_RootConstrainSelectedInstOperands,
     /* 126860 */   // GIR_Coverage, 4615,
     /* 126860 */   GIR_EraseRootFromParent_Done,
     /* 126861 */ // Label 1796: @126861
     /* 126861 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(127000), // Rule ID 4647 //
     /* 126866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 126869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126876 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126884 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126888 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126892 */   // MIs[1] Operand 1
     /* 126892 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 126897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126899 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126899 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126902 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 126906 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126911 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126915 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126921 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126924 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126928 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126933 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126938 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126941 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126945 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126950 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126967 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126974 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126979 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126998 */   GIR_RootConstrainSelectedInstOperands,
     /* 126999 */   // GIR_Coverage, 4647,
     /* 126999 */   GIR_EraseRootFromParent_Done,
     /* 127000 */ // Label 1797: @127000
     /* 127000 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(127139), // Rule ID 4691 //
     /* 127005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127015 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127019 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127023 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127027 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127031 */   // MIs[1] Operand 1
     /* 127031 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 127036 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127038 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127038 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127041 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 127045 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127050 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127054 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127060 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127063 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127067 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127072 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127077 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127080 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127084 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127089 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127094 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127097 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127101 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127106 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127118 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127137 */   GIR_RootConstrainSelectedInstOperands,
     /* 127138 */   // GIR_Coverage, 4691,
     /* 127138 */   GIR_EraseRootFromParent_Done,
     /* 127139 */ // Label 1798: @127139
     /* 127139 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(127278), // Rule ID 4723 //
     /* 127144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127162 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127166 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127170 */   // MIs[1] Operand 1
     /* 127170 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 127175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127177 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127177 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127180 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 127184 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127189 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127193 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127199 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127202 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127206 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127211 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127216 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127219 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127223 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127228 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127245 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127252 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127257 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127276 */   GIR_RootConstrainSelectedInstOperands,
     /* 127277 */   // GIR_Coverage, 4723,
     /* 127277 */   GIR_EraseRootFromParent_Done,
     /* 127278 */ // Label 1799: @127278
     /* 127278 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(127417), // Rule ID 4755 //
     /* 127283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127301 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127305 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127309 */   // MIs[1] Operand 1
     /* 127309 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 127314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127316 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127316 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127319 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 127323 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127328 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127332 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127338 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127341 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127345 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127350 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127355 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127358 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127362 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127367 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127384 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127391 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127396 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127415 */   GIR_RootConstrainSelectedInstOperands,
     /* 127416 */   // GIR_Coverage, 4755,
     /* 127416 */   GIR_EraseRootFromParent_Done,
     /* 127417 */ // Label 1800: @127417
     /* 127417 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(127516), // Rule ID 2978 //
     /* 127422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127432 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127440 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127444 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127448 */   // MIs[1] Operand 1
     /* 127448 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 127453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127455 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 127455 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127458 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 127462 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127467 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127471 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127489 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127496 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127501 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127514 */   GIR_RootConstrainSelectedInstOperands,
     /* 127515 */   // GIR_Coverage, 2978,
     /* 127515 */   GIR_EraseRootFromParent_Done,
     /* 127516 */ // Label 1801: @127516
     /* 127516 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(127615), // Rule ID 2992 //
     /* 127521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127531 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127535 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127539 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127543 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127547 */   // MIs[1] Operand 1
     /* 127547 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 127552 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127554 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 127554 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127557 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 127561 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127566 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127570 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127588 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127600 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127613 */   GIR_RootConstrainSelectedInstOperands,
     /* 127614 */   // GIR_Coverage, 2992,
     /* 127614 */   GIR_EraseRootFromParent_Done,
     /* 127615 */ // Label 1802: @127615
     /* 127615 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(127714), // Rule ID 3000 //
     /* 127620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127630 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127642 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127646 */   // MIs[1] Operand 1
     /* 127646 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 127651 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127653 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 127653 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127656 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 127660 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127665 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127669 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127687 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127694 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127699 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127712 */   GIR_RootConstrainSelectedInstOperands,
     /* 127713 */   // GIR_Coverage, 3000,
     /* 127713 */   GIR_EraseRootFromParent_Done,
     /* 127714 */ // Label 1803: @127714
     /* 127714 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(127813), // Rule ID 3008 //
     /* 127719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127729 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127733 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127737 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127741 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127745 */   // MIs[1] Operand 1
     /* 127745 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 127750 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127752 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 127752 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127755 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 127759 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127764 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127768 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127786 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127811 */   GIR_RootConstrainSelectedInstOperands,
     /* 127812 */   // GIR_Coverage, 3008,
     /* 127812 */   GIR_EraseRootFromParent_Done,
     /* 127813 */ // Label 1804: @127813
     /* 127813 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(127912), // Rule ID 3016 //
     /* 127818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127836 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127840 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127844 */   // MIs[1] Operand 1
     /* 127844 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 127849 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127851 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 127851 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127854 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 127858 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127863 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127867 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127885 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 127892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127910 */   GIR_RootConstrainSelectedInstOperands,
     /* 127911 */   // GIR_Coverage, 3016,
     /* 127911 */   GIR_EraseRootFromParent_Done,
     /* 127912 */ // Label 1805: @127912
     /* 127912 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(128011), // Rule ID 3080 //
     /* 127917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127935 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127939 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127943 */   // MIs[1] Operand 1
     /* 127943 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 127948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127950 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 127950 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127953 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 127957 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127962 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127966 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127984 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127991 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127996 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128009 */   GIR_RootConstrainSelectedInstOperands,
     /* 128010 */   // GIR_Coverage, 3080,
     /* 128010 */   GIR_EraseRootFromParent_Done,
     /* 128011 */ // Label 1806: @128011
     /* 128011 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(128110), // Rule ID 3088 //
     /* 128016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128026 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128034 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128038 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128042 */   // MIs[1] Operand 1
     /* 128042 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 128047 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128049 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 128049 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128052 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128056 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128061 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128065 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128083 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128090 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128108 */   GIR_RootConstrainSelectedInstOperands,
     /* 128109 */   // GIR_Coverage, 3088,
     /* 128109 */   GIR_EraseRootFromParent_Done,
     /* 128110 */ // Label 1807: @128110
     /* 128110 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(128209), // Rule ID 3096 //
     /* 128115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128125 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128129 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128133 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128137 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128141 */   // MIs[1] Operand 1
     /* 128141 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 128146 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128148 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 128148 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128151 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 128155 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128160 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128164 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128182 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128189 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128194 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128207 */   GIR_RootConstrainSelectedInstOperands,
     /* 128208 */   // GIR_Coverage, 3096,
     /* 128208 */   GIR_EraseRootFromParent_Done,
     /* 128209 */ // Label 1808: @128209
     /* 128209 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(128308), // Rule ID 3104 //
     /* 128214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128224 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128228 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128232 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128236 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128240 */   // MIs[1] Operand 1
     /* 128240 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 128245 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128247 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 128247 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128250 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128254 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128259 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128263 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128281 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128293 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128306 */   GIR_RootConstrainSelectedInstOperands,
     /* 128307 */   // GIR_Coverage, 3104,
     /* 128307 */   GIR_EraseRootFromParent_Done,
     /* 128308 */ // Label 1809: @128308
     /* 128308 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(128407), // Rule ID 3112 //
     /* 128313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128331 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128335 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128339 */   // MIs[1] Operand 1
     /* 128339 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 128344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128346 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 128346 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128349 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128353 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128358 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128362 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128380 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 128387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128405 */   GIR_RootConstrainSelectedInstOperands,
     /* 128406 */   // GIR_Coverage, 3112,
     /* 128406 */   GIR_EraseRootFromParent_Done,
     /* 128407 */ // Label 1810: @128407
     /* 128407 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(128546), // Rule ID 3862 //
     /* 128412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128422 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128430 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128434 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128438 */   // MIs[1] Operand 1
     /* 128438 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 128443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128445 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128445 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128448 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 128452 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128457 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128461 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128467 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128470 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128474 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128479 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128484 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128487 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128491 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128496 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128513 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128525 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128544 */   GIR_RootConstrainSelectedInstOperands,
     /* 128545 */   // GIR_Coverage, 3862,
     /* 128545 */   GIR_EraseRootFromParent_Done,
     /* 128546 */ // Label 1811: @128546
     /* 128546 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(128685), // Rule ID 3870 //
     /* 128551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128561 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128565 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128569 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128573 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128577 */   // MIs[1] Operand 1
     /* 128577 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 128582 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128584 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128584 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128587 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128591 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128596 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128600 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128606 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128609 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128613 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128618 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128623 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128626 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128630 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128635 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128652 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128683 */   GIR_RootConstrainSelectedInstOperands,
     /* 128684 */   // GIR_Coverage, 3870,
     /* 128684 */   GIR_EraseRootFromParent_Done,
     /* 128685 */ // Label 1812: @128685
     /* 128685 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(128824), // Rule ID 3878 //
     /* 128690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128708 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128712 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128716 */   // MIs[1] Operand 1
     /* 128716 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 128721 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128723 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128723 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128726 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 128730 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128735 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128739 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128745 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128748 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128752 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128757 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128762 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128765 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128769 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128774 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128791 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128803 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128822 */   GIR_RootConstrainSelectedInstOperands,
     /* 128823 */   // GIR_Coverage, 3878,
     /* 128823 */   GIR_EraseRootFromParent_Done,
     /* 128824 */ // Label 1813: @128824
     /* 128824 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(128963), // Rule ID 3886 //
     /* 128829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128847 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128851 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128855 */   // MIs[1] Operand 1
     /* 128855 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 128860 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128862 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128874 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128878 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128884 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128887 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128891 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128896 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128901 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128904 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128908 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128913 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128930 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128937 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128942 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128961 */   GIR_RootConstrainSelectedInstOperands,
     /* 128962 */   // GIR_Coverage, 3886,
     /* 128962 */   GIR_EraseRootFromParent_Done,
     /* 128963 */ // Label 1814: @128963
     /* 128963 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(129102), // Rule ID 3894 //
     /* 128968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128978 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128982 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128986 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128990 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128994 */   // MIs[1] Operand 1
     /* 128994 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 128999 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129001 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129001 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129004 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 129008 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129013 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129017 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129023 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129026 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129030 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129035 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129040 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129043 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129047 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129052 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129069 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 129076 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129100 */   GIR_RootConstrainSelectedInstOperands,
     /* 129101 */   // GIR_Coverage, 3894,
     /* 129101 */   GIR_EraseRootFromParent_Done,
     /* 129102 */ // Label 1815: @129102
     /* 129102 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(129241), // Rule ID 3958 //
     /* 129107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129117 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129121 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129125 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129129 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129133 */   // MIs[1] Operand 1
     /* 129133 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 129138 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129140 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129140 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129143 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 129147 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129152 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129156 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129162 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129165 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129169 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129174 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129179 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129182 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129186 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129191 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129208 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 129215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129220 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129239 */   GIR_RootConstrainSelectedInstOperands,
     /* 129240 */   // GIR_Coverage, 3958,
     /* 129240 */   GIR_EraseRootFromParent_Done,
     /* 129241 */ // Label 1816: @129241
     /* 129241 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(129380), // Rule ID 3966 //
     /* 129246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129256 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129268 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129272 */   // MIs[1] Operand 1
     /* 129272 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 129277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129279 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129279 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129282 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129286 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129291 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129295 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129301 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129304 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129308 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129313 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129318 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129321 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129325 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129330 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129347 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 129354 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129359 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129378 */   GIR_RootConstrainSelectedInstOperands,
     /* 129379 */   // GIR_Coverage, 3966,
     /* 129379 */   GIR_EraseRootFromParent_Done,
     /* 129380 */ // Label 1817: @129380
     /* 129380 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(129519), // Rule ID 3974 //
     /* 129385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129395 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129399 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129403 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129407 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129411 */   // MIs[1] Operand 1
     /* 129411 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 129416 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129418 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129418 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129421 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 129425 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129430 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129434 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129440 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129443 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129447 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129452 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129457 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129460 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129464 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129469 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129486 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129493 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129498 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129517 */   GIR_RootConstrainSelectedInstOperands,
     /* 129518 */   // GIR_Coverage, 3974,
     /* 129518 */   GIR_EraseRootFromParent_Done,
     /* 129519 */ // Label 1818: @129519
     /* 129519 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(129658), // Rule ID 3982 //
     /* 129524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129542 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129546 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129550 */   // MIs[1] Operand 1
     /* 129550 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 129555 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129557 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129557 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129560 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129564 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129569 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129573 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129579 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129582 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129586 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129591 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129596 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129599 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129603 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129608 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129625 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129632 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129637 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129653 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129656 */   GIR_RootConstrainSelectedInstOperands,
     /* 129657 */   // GIR_Coverage, 3982,
     /* 129657 */   GIR_EraseRootFromParent_Done,
     /* 129658 */ // Label 1819: @129658
     /* 129658 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(129797), // Rule ID 3990 //
     /* 129663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129681 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129685 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129689 */   // MIs[1] Operand 1
     /* 129689 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 129694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129696 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129696 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129699 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129703 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129708 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129712 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129718 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129721 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129725 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129730 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129735 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129738 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129742 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129747 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129764 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 129771 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129786 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129795 */   GIR_RootConstrainSelectedInstOperands,
     /* 129796 */   // GIR_Coverage, 3990,
     /* 129796 */   GIR_EraseRootFromParent_Done,
     /* 129797 */ // Label 1820: @129797
     /* 129797 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(129816), // Rule ID 680 //
     /* 129802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129809 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$RST)  =>  (EXTSW_32_64:{ *:[i64] } i32:{ *:[i32] }:$RST)
     /* 129809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EXTSW_32_64),
     /* 129814 */   GIR_RootConstrainSelectedInstOperands,
     /* 129815 */   // GIR_Coverage, 680,
     /* 129815 */   GIR_Done,
     /* 129816 */ // Label 1821: @129816
     /* 129816 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(129838), // Rule ID 2984 //
     /* 129821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 129824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129831 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETNBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 129831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC8),
     /* 129836 */   GIR_RootConstrainSelectedInstOperands,
     /* 129837 */   // GIR_Coverage, 2984,
     /* 129837 */   GIR_Done,
     /* 129838 */ // Label 1822: @129838
     /* 129838 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(129899), // Rule ID 3668 //
     /* 129843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129850 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } -1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 129850 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 129853 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129857 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129862 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 129865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129879 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 129882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129889 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 129891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 129897 */   GIR_RootConstrainSelectedInstOperands,
     /* 129898 */   // GIR_Coverage, 3668,
     /* 129898 */   GIR_EraseRootFromParent_Done,
     /* 129899 */ // Label 1823: @129899
     /* 129899 */ GIM_Reject,
     /* 129900 */ // Label 1693: @129900
     /* 129900 */ GIM_Reject,
     /* 129901 */ // Label 25: @129901
     /* 129901 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 1828*/ GIMT_Encode4(130253),
     /* 129912 */ /*GILLT_s32*//*Label 1824*/ GIMT_Encode4(129932),
     /* 129916 */ /*GILLT_s64*//*Label 1825*/ GIMT_Encode4(129996), GIMT_Encode4(0),
     /* 129924 */ /*GILLT_v2s64*//*Label 1826*/ GIMT_Encode4(130085),
     /* 129928 */ /*GILLT_v4s32*//*Label 1827*/ GIMT_Encode4(130183),
     /* 129932 */ // Label 1824: @129932
     /* 129932 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(129995),
     /* 129937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 129944 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(129969), // Rule ID 135 //
     /* 129949 */     // MIs[0] Operand 2
     /* 129949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 129960 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i8:{ *:[Other] })  =>  (EXTSB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 129960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB),
     /* 129963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129965 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 129967 */     GIR_RootConstrainSelectedInstOperands,
     /* 129968 */     // GIR_Coverage, 135,
     /* 129968 */     GIR_EraseRootFromParent_Done,
     /* 129969 */   // Label 1830: @129969
     /* 129969 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(129994), // Rule ID 136 //
     /* 129974 */     // MIs[0] Operand 2
     /* 129974 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 129985 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i16:{ *:[Other] })  =>  (EXTSH:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 129985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH),
     /* 129988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129990 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 129992 */     GIR_RootConstrainSelectedInstOperands,
     /* 129993 */     // GIR_Coverage, 136,
     /* 129993 */     GIR_EraseRootFromParent_Done,
     /* 129994 */   // Label 1831: @129994
     /* 129994 */   GIM_Reject,
     /* 129995 */ // Label 1829: @129995
     /* 129995 */ GIM_Reject,
     /* 129996 */ // Label 1825: @129996
     /* 129996 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(130084),
     /* 130001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 130004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130008 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(130033), // Rule ID 677 //
     /* 130013 */     // MIs[0] Operand 2
     /* 130013 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130024 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i8:{ *:[Other] })  =>  (EXTSB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB8),
     /* 130027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130029 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130031 */     GIR_RootConstrainSelectedInstOperands,
     /* 130032 */     // GIR_Coverage, 677,
     /* 130032 */     GIR_EraseRootFromParent_Done,
     /* 130033 */   // Label 1833: @130033
     /* 130033 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(130058), // Rule ID 678 //
     /* 130038 */     // MIs[0] Operand 2
     /* 130038 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130049 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i16:{ *:[Other] })  =>  (EXTSH8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH8),
     /* 130052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130054 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130056 */     GIR_RootConstrainSelectedInstOperands,
     /* 130057 */     // GIR_Coverage, 678,
     /* 130057 */     GIR_EraseRootFromParent_Done,
     /* 130058 */   // Label 1834: @130058
     /* 130058 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(130083), // Rule ID 679 //
     /* 130063 */     // MIs[0] Operand 2
     /* 130063 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 130074 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i32:{ *:[Other] })  =>  (EXTSW:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSW),
     /* 130077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130079 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130081 */     GIR_RootConstrainSelectedInstOperands,
     /* 130082 */     // GIR_Coverage, 679,
     /* 130082 */     GIR_EraseRootFromParent_Done,
     /* 130083 */   // Label 1835: @130083
     /* 130083 */   GIM_Reject,
     /* 130084 */ // Label 1832: @130084
     /* 130084 */ GIM_Reject,
     /* 130085 */ // Label 1826: @130085
     /* 130085 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(130182),
     /* 130090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 130093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 130097 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(130125), // Rule ID 1450 //
     /* 130102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130105 */     // MIs[0] Operand 2
     /* 130105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130116 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i8:{ *:[Other] })  =>  (VEXTSB2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /* 130119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130121 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130123 */     GIR_RootConstrainSelectedInstOperands,
     /* 130124 */     // GIR_Coverage, 1450,
     /* 130124 */     GIR_EraseRootFromParent_Done,
     /* 130125 */   // Label 1837: @130125
     /* 130125 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(130153), // Rule ID 1451 //
     /* 130130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130133 */     // MIs[0] Operand 2
     /* 130133 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130144 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i16:{ *:[Other] })  =>  (VEXTSH2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /* 130147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130149 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130151 */     GIR_RootConstrainSelectedInstOperands,
     /* 130152 */     // GIR_Coverage, 1451,
     /* 130152 */     GIR_EraseRootFromParent_Done,
     /* 130153 */   // Label 1838: @130153
     /* 130153 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(130181), // Rule ID 1452 //
     /* 130158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130161 */     // MIs[0] Operand 2
     /* 130161 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 130172 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i32:{ *:[Other] })  =>  (VEXTSW2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /* 130175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130177 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130179 */     GIR_RootConstrainSelectedInstOperands,
     /* 130180 */     // GIR_Coverage, 1452,
     /* 130180 */     GIR_EraseRootFromParent_Done,
     /* 130181 */   // Label 1839: @130181
     /* 130181 */   GIM_Reject,
     /* 130182 */ // Label 1836: @130182
     /* 130182 */ GIM_Reject,
     /* 130183 */ // Label 1827: @130183
     /* 130183 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(130252),
     /* 130188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 130191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 130195 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(130223), // Rule ID 1448 //
     /* 130200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130203 */     // MIs[0] Operand 2
     /* 130203 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130214 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i8:{ *:[Other] })  =>  (VEXTSB2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 130214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /* 130217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130219 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130221 */     GIR_RootConstrainSelectedInstOperands,
     /* 130222 */     // GIR_Coverage, 1448,
     /* 130222 */     GIR_EraseRootFromParent_Done,
     /* 130223 */   // Label 1841: @130223
     /* 130223 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(130251), // Rule ID 1449 //
     /* 130228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130231 */     // MIs[0] Operand 2
     /* 130231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130242 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i16:{ *:[Other] })  =>  (VEXTSH2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 130242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /* 130245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130247 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130249 */     GIR_RootConstrainSelectedInstOperands,
     /* 130250 */     // GIR_Coverage, 1449,
     /* 130250 */     GIR_EraseRootFromParent_Done,
     /* 130251 */   // Label 1842: @130251
     /* 130251 */   GIM_Reject,
     /* 130252 */ // Label 1840: @130252
     /* 130252 */ GIM_Reject,
     /* 130253 */ // Label 1828: @130253
     /* 130253 */ GIM_Reject,
     /* 130254 */ // Label 26: @130254
     /* 130254 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1845*/ GIMT_Encode4(151723),
     /* 130265 */ /*GILLT_s32*//*Label 1843*/ GIMT_Encode4(130273),
     /* 130269 */ /*GILLT_s64*//*Label 1844*/ GIMT_Encode4(140494),
     /* 130273 */ // Label 1843: @130273
     /* 130273 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(140493),
     /* 130278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 130281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130285 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(130397), // Rule ID 5288 //
     /* 130290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130302 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130306 */     // MIs[1] Operand 1
     /* 130306 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130335 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130339 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130343 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130347 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130353 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130369 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 130372 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 130375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130395 */     GIR_RootConstrainSelectedInstOperands,
     /* 130396 */     // GIR_Coverage, 5288,
     /* 130396 */     GIR_EraseRootFromParent_Done,
     /* 130397 */   // Label 1847: @130397
     /* 130397 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(130536), // Rule ID 5291 //
     /* 130402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130414 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130418 */     // MIs[1] Operand 1
     /* 130418 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 130435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 130439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130447 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 130451 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130455 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130459 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130465 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130477 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130481 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 130484 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 130487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 130496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130505 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130508 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130518 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130535 */     // GIR_Coverage, 5291,
     /* 130535 */     GIR_EraseRootFromParent_Done,
     /* 130536 */   // Label 1848: @130536
     /* 130536 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(130669), // Rule ID 5296 //
     /* 130541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130553 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130557 */     // MIs[1] Operand 1
     /* 130557 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 130562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130586 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130590 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130594 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130598 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130604 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130604 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130607 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130611 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130616 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130620 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 130623 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 130626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 130635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 130661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130667 */     GIR_RootConstrainSelectedInstOperands,
     /* 130668 */     // GIR_Coverage, 5296,
     /* 130668 */     GIR_EraseRootFromParent_Done,
     /* 130669 */   // Label 1849: @130669
     /* 130669 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(130829), // Rule ID 5299 //
     /* 130674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130686 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130690 */     // MIs[1] Operand 1
     /* 130690 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 130695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 130707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 130711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 130723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130727 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130731 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130737 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130737 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 130740 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130744 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130749 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130753 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 130756 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 130759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 130764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 130768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130773 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130777 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 130790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130795 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 130801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130811 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130818 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130828 */     // GIR_Coverage, 5299,
     /* 130828 */     GIR_EraseRootFromParent_Done,
     /* 130829 */   // Label 1850: @130829
     /* 130829 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(130941), // Rule ID 3769 //
     /* 130834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130846 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130850 */     // MIs[1] Operand 1
     /* 130850 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 130875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130879 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130883 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130887 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130891 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130897 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130913 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 130916 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 130919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 130930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130939 */     GIR_RootConstrainSelectedInstOperands,
     /* 130940 */     // GIR_Coverage, 3769,
     /* 130940 */     GIR_EraseRootFromParent_Done,
     /* 130941 */   // Label 1851: @130941
     /* 130941 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(131080), // Rule ID 3772 //
     /* 130946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130958 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130962 */     // MIs[1] Operand 1
     /* 130962 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 130979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 130983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 130987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130991 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 130995 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130999 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131009 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131009 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131012 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131016 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131021 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131025 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 131028 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 131031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131045 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131062 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131079 */     // GIR_Coverage, 3772,
     /* 131079 */     GIR_EraseRootFromParent_Done,
     /* 131080 */   // Label 1852: @131080
     /* 131080 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(131213), // Rule ID 3777 //
     /* 131085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131097 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131101 */     // MIs[1] Operand 1
     /* 131101 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 131118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 131122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131130 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 131134 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131138 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131142 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131148 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131148 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131151 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131155 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131160 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131164 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 131167 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 131170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 131197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 131205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131211 */     GIR_RootConstrainSelectedInstOperands,
     /* 131212 */     // GIR_Coverage, 3777,
     /* 131212 */     GIR_EraseRootFromParent_Done,
     /* 131213 */   // Label 1853: @131213
     /* 131213 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(131373), // Rule ID 3780 //
     /* 131218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131230 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131234 */     // MIs[1] Operand 1
     /* 131234 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 131251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 131255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131263 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 131267 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131271 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131275 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131281 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131281 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131284 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131288 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131293 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131297 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 131300 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 131303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131305 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131308 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 131312 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131317 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131321 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131339 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131345 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131355 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131372 */     // GIR_Coverage, 3780,
     /* 131372 */     GIR_EraseRootFromParent_Done,
     /* 131373 */   // Label 1854: @131373
     /* 131373 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(131442), // Rule ID 3689 //
     /* 131378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131390 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131394 */     // MIs[1] Operand 1
     /* 131394 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131399 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131405 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 131434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131440 */     GIR_RootConstrainSelectedInstOperands,
     /* 131441 */     // GIR_Coverage, 3689,
     /* 131441 */     GIR_EraseRootFromParent_Done,
     /* 131442 */   // Label 1855: @131442
     /* 131442 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(131538), // Rule ID 3692 //
     /* 131447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131459 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131463 */     // MIs[1] Operand 1
     /* 131463 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131468 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131474 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131474 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131477 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 131481 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131486 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 131499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131504 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 131510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131520 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131537 */     // GIR_Coverage, 3692,
     /* 131537 */     GIR_EraseRootFromParent_Done,
     /* 131538 */   // Label 1856: @131538
     /* 131538 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(131645), // Rule ID 3697 //
     /* 131543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131555 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131559 */     // MIs[1] Operand 1
     /* 131559 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131564 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131570 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131570 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131573 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131577 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131582 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131600 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 131637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131643 */     GIR_RootConstrainSelectedInstOperands,
     /* 131644 */     // GIR_Coverage, 3697,
     /* 131644 */     GIR_EraseRootFromParent_Done,
     /* 131645 */   // Label 1857: @131645
     /* 131645 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(131779), // Rule ID 3700 //
     /* 131650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131662 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131666 */     // MIs[1] Operand 1
     /* 131666 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131671 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131677 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131677 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 131680 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 131684 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131689 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 131695 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 131698 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 131702 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131707 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131713 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131716 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 131720 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131725 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131728 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 131731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 131740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 131751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131761 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131778 */     // GIR_Coverage, 3700,
     /* 131778 */     GIR_EraseRootFromParent_Done,
     /* 131779 */   // Label 1858: @131779
     /* 131779 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(131831), // Rule ID 3705 //
     /* 131784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131796 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131800 */     // MIs[1] Operand 1
     /* 131800 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 131805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131811 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 131823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131829 */     GIR_RootConstrainSelectedInstOperands,
     /* 131830 */     // GIR_Coverage, 3705,
     /* 131830 */     GIR_EraseRootFromParent_Done,
     /* 131831 */   // Label 1859: @131831
     /* 131831 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(131910), // Rule ID 3708 //
     /* 131836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131848 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131852 */     // MIs[1] Operand 1
     /* 131852 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 131857 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131863 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 131870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131875 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131879 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 131882 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131892 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131909 */     // GIR_Coverage, 3708,
     /* 131909 */     GIR_EraseRootFromParent_Done,
     /* 131910 */   // Label 1860: @131910
     /* 131910 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(131983), // Rule ID 3713 //
     /* 131915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131931 */     // MIs[1] Operand 1
     /* 131931 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 131936 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131942 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 131975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131981 */     GIR_RootConstrainSelectedInstOperands,
     /* 131982 */     // GIR_Coverage, 3713,
     /* 131982 */     GIR_EraseRootFromParent_Done,
     /* 131983 */   // Label 1861: @131983
     /* 131983 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(132083), // Rule ID 3716 //
     /* 131988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132000 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132004 */     // MIs[1] Operand 1
     /* 132004 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132015 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 132022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132027 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132055 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132065 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132082 */     // GIR_Coverage, 3716,
     /* 132082 */     GIR_EraseRootFromParent_Done,
     /* 132083 */   // Label 1862: @132083
     /* 132083 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(132173), // Rule ID 3721 //
     /* 132088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132100 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132104 */     // MIs[1] Operand 1
     /* 132104 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132109 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132115 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 132122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132127 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 132140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132145 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132148 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132171 */     GIR_RootConstrainSelectedInstOperands,
     /* 132172 */     // GIR_Coverage, 3721,
     /* 132172 */     GIR_EraseRootFromParent_Done,
     /* 132173 */   // Label 1863: @132173
     /* 132173 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(132290), // Rule ID 3724 //
     /* 132178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132190 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132194 */     // MIs[1] Operand 1
     /* 132194 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132205 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132205 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132208 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 132212 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132217 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132223 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132226 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 132230 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132235 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132238 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132256 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132259 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132272 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132289 */     // GIR_Coverage, 3724,
     /* 132289 */     GIR_EraseRootFromParent_Done,
     /* 132290 */   // Label 1864: @132290
     /* 132290 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(132380), // Rule ID 3729 //
     /* 132295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132307 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132311 */     // MIs[1] Operand 1
     /* 132311 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 132316 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132322 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 132329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 132347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132352 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132356 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132378 */     GIR_RootConstrainSelectedInstOperands,
     /* 132379 */     // GIR_Coverage, 3729,
     /* 132379 */     GIR_EraseRootFromParent_Done,
     /* 132380 */   // Label 1865: @132380
     /* 132380 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(132497), // Rule ID 3732 //
     /* 132385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132397 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132401 */     // MIs[1] Operand 1
     /* 132401 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 132406 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132412 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132412 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132415 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 132419 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132424 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 132437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132442 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132446 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132466 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132469 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132479 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132496 */     // GIR_Coverage, 3732,
     /* 132496 */     GIR_EraseRootFromParent_Done,
     /* 132497 */   // Label 1866: @132497
     /* 132497 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(132590), // Rule ID 3737 //
     /* 132502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132514 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132518 */     // MIs[1] Operand 1
     /* 132518 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132523 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132529 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132529 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132532 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 132536 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132541 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132545 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 132548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 132557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132566 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132588 */     GIR_RootConstrainSelectedInstOperands,
     /* 132589 */     // GIR_Coverage, 3737,
     /* 132589 */     GIR_EraseRootFromParent_Done,
     /* 132590 */   // Label 1867: @132590
     /* 132590 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(132710), // Rule ID 3740 //
     /* 132595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132607 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132611 */     // MIs[1] Operand 1
     /* 132611 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132616 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132622 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132622 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132625 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 132629 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132634 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132638 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 132641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 132650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132655 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132659 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132676 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132679 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132682 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132692 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132709 */     // GIR_Coverage, 3740,
     /* 132709 */     GIR_EraseRootFromParent_Done,
     /* 132710 */   // Label 1868: @132710
     /* 132710 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(132803), // Rule ID 3745 //
     /* 132715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132727 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132731 */     // MIs[1] Operand 1
     /* 132731 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132736 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132742 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132742 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132745 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 132749 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132754 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132758 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 132761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 132770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132775 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132779 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132801 */     GIR_RootConstrainSelectedInstOperands,
     /* 132802 */     // GIR_Coverage, 3745,
     /* 132802 */     GIR_EraseRootFromParent_Done,
     /* 132803 */   // Label 1869: @132803
     /* 132803 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(132923), // Rule ID 3748 //
     /* 132808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132820 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132824 */     // MIs[1] Operand 1
     /* 132824 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132829 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132835 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132835 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132838 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 132842 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132847 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132851 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 132854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132856 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132859 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 132863 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132868 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132872 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132895 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132905 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132922 */     // GIR_Coverage, 3748,
     /* 132922 */     GIR_EraseRootFromParent_Done,
     /* 132923 */   // Label 1870: @132923
     /* 132923 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(132996), // Rule ID 3753 //
     /* 132928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132944 */     // MIs[1] Operand 1
     /* 132944 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132949 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132955 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 132962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132994 */     GIR_RootConstrainSelectedInstOperands,
     /* 132995 */     // GIR_Coverage, 3753,
     /* 132995 */     GIR_EraseRootFromParent_Done,
     /* 132996 */   // Label 1871: @132996
     /* 132996 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(133096), // Rule ID 3756 //
     /* 133001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133013 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133017 */     // MIs[1] Operand 1
     /* 133017 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 133022 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133028 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133028 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 133031 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 133035 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133040 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133044 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133062 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133065 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133068 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133078 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133095 */     // GIR_Coverage, 3756,
     /* 133095 */     GIR_EraseRootFromParent_Done,
     /* 133096 */   // Label 1872: @133096
     /* 133096 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(133148), // Rule ID 3761 //
     /* 133101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133113 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133117 */     // MIs[1] Operand 1
     /* 133117 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133122 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133128 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 133128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 133131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 133133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133146 */     GIR_RootConstrainSelectedInstOperands,
     /* 133147 */     // GIR_Coverage, 3761,
     /* 133147 */     GIR_EraseRootFromParent_Done,
     /* 133148 */   // Label 1873: @133148
     /* 133148 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(133227), // Rule ID 3764 //
     /* 133153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133165 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133169 */     // MIs[1] Operand 1
     /* 133169 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133174 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133180 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133196 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133209 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133226 */     // GIR_Coverage, 3764,
     /* 133226 */     GIR_EraseRootFromParent_Done,
     /* 133227 */   // Label 1874: @133227
     /* 133227 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(133330), // Rule ID 3029 //
     /* 133232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133247 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133251 */     // MIs[1] Operand 1
     /* 133251 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133264 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133268 */     // MIs[2] Operand 1
     /* 133268 */     // No operand predicates
     /* 133268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133270 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 133270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133303 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133328 */     GIR_RootConstrainSelectedInstOperands,
     /* 133329 */     // GIR_Coverage, 3029,
     /* 133329 */     GIR_EraseRootFromParent_Done,
     /* 133330 */   // Label 1875: @133330
     /* 133330 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(133433), // Rule ID 3045 //
     /* 133335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133350 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133354 */     // MIs[1] Operand 1
     /* 133354 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133367 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133371 */     // MIs[2] Operand 1
     /* 133371 */     // No operand predicates
     /* 133371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133373 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 133373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133385 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133406 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 133413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133431 */     GIR_RootConstrainSelectedInstOperands,
     /* 133432 */     // GIR_Coverage, 3045,
     /* 133432 */     GIR_EraseRootFromParent_Done,
     /* 133433 */   // Label 1876: @133433
     /* 133433 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(133536), // Rule ID 3053 //
     /* 133438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133453 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133457 */     // MIs[1] Operand 1
     /* 133457 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 133462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133470 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133474 */     // MIs[2] Operand 1
     /* 133474 */     // No operand predicates
     /* 133474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133476 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 133476 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133479 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133483 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133509 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 133516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133534 */     GIR_RootConstrainSelectedInstOperands,
     /* 133535 */     // GIR_Coverage, 3053,
     /* 133535 */     GIR_EraseRootFromParent_Done,
     /* 133536 */   // Label 1877: @133536
     /* 133536 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(133639), // Rule ID 3125 //
     /* 133541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133556 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133560 */     // MIs[1] Operand 1
     /* 133560 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133573 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 133577 */     // MIs[2] Operand 1
     /* 133577 */     // No operand predicates
     /* 133577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133579 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 133579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 133586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133591 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133612 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133637 */     GIR_RootConstrainSelectedInstOperands,
     /* 133638 */     // GIR_Coverage, 3125,
     /* 133638 */     GIR_EraseRootFromParent_Done,
     /* 133639 */   // Label 1878: @133639
     /* 133639 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(133742), // Rule ID 3141 //
     /* 133644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133659 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133663 */     // MIs[1] Operand 1
     /* 133663 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 133680 */     // MIs[2] Operand 1
     /* 133680 */     // No operand predicates
     /* 133680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133682 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 133682 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133685 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 133689 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133694 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133715 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 133722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133740 */     GIR_RootConstrainSelectedInstOperands,
     /* 133741 */     // GIR_Coverage, 3141,
     /* 133741 */     GIR_EraseRootFromParent_Done,
     /* 133742 */   // Label 1879: @133742
     /* 133742 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(133845), // Rule ID 3149 //
     /* 133747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133762 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133766 */     // MIs[1] Operand 1
     /* 133766 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 133771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 133783 */     // MIs[2] Operand 1
     /* 133783 */     // No operand predicates
     /* 133783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133785 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 133785 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133788 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 133792 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133797 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133818 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 133825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133843 */     GIR_RootConstrainSelectedInstOperands,
     /* 133844 */     // GIR_Coverage, 3149,
     /* 133844 */     GIR_EraseRootFromParent_Done,
     /* 133845 */   // Label 1880: @133845
     /* 133845 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(133988), // Rule ID 3811 //
     /* 133850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 133853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133865 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133869 */     // MIs[1] Operand 1
     /* 133869 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133886 */     // MIs[2] Operand 1
     /* 133886 */     // No operand predicates
     /* 133886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133888 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 133888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133900 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133909 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 133912 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133916 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133921 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 133924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 133929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133938 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 133941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133955 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 133975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 133983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 133986 */     GIR_RootConstrainSelectedInstOperands,
     /* 133987 */     // GIR_Coverage, 3811,
     /* 133987 */     GIR_EraseRootFromParent_Done,
     /* 133988 */   // Label 1881: @133988
     /* 133988 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(134131), // Rule ID 3827 //
     /* 133993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 133996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134008 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134012 */     // MIs[1] Operand 1
     /* 134012 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 134017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134025 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134029 */     // MIs[2] Operand 1
     /* 134029 */     // No operand predicates
     /* 134029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134031 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134043 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134052 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134055 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134059 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134064 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134069 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134072 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134076 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134081 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134098 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134129 */     GIR_RootConstrainSelectedInstOperands,
     /* 134130 */     // GIR_Coverage, 3827,
     /* 134130 */     GIR_EraseRootFromParent_Done,
     /* 134131 */   // Label 1882: @134131
     /* 134131 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(134274), // Rule ID 3835 //
     /* 134136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134151 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134155 */     // MIs[1] Operand 1
     /* 134155 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134168 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134172 */     // MIs[2] Operand 1
     /* 134172 */     // No operand predicates
     /* 134172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134174 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134174 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134177 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134181 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134186 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134195 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134198 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134202 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134207 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134212 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134215 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134219 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134224 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134241 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134272 */     GIR_RootConstrainSelectedInstOperands,
     /* 134273 */     // GIR_Coverage, 3835,
     /* 134273 */     GIR_EraseRootFromParent_Done,
     /* 134274 */   // Label 1883: @134274
     /* 134274 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(134417), // Rule ID 3907 //
     /* 134279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134294 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134298 */     // MIs[1] Operand 1
     /* 134298 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 134303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134311 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134315 */     // MIs[2] Operand 1
     /* 134315 */     // No operand predicates
     /* 134315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134317 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134317 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134320 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134324 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134338 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134341 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134345 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134350 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134355 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134358 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134362 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134367 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134384 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134415 */     GIR_RootConstrainSelectedInstOperands,
     /* 134416 */     // GIR_Coverage, 3907,
     /* 134416 */     GIR_EraseRootFromParent_Done,
     /* 134417 */   // Label 1884: @134417
     /* 134417 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(134560), // Rule ID 3923 //
     /* 134422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134437 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134441 */     // MIs[1] Operand 1
     /* 134441 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 134446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134454 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134458 */     // MIs[2] Operand 1
     /* 134458 */     // No operand predicates
     /* 134458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134460 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134460 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134463 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134467 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134472 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134481 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134484 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134488 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134493 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134498 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134501 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134505 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134510 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134527 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134558 */     GIR_RootConstrainSelectedInstOperands,
     /* 134559 */     // GIR_Coverage, 3923,
     /* 134559 */     GIR_EraseRootFromParent_Done,
     /* 134560 */   // Label 1885: @134560
     /* 134560 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(134703), // Rule ID 3931 //
     /* 134565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134580 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134584 */     // MIs[1] Operand 1
     /* 134584 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134601 */     // MIs[2] Operand 1
     /* 134601 */     // No operand predicates
     /* 134601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134603 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134603 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134606 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134610 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134624 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134627 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134631 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134636 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134641 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134644 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134648 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134653 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134670 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134701 */     GIR_RootConstrainSelectedInstOperands,
     /* 134702 */     // GIR_Coverage, 3931,
     /* 134702 */     GIR_EraseRootFromParent_Done,
     /* 134703 */   // Label 1886: @134703
     /* 134703 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(134795), // Rule ID 3173 //
     /* 134708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 134711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134723 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134727 */     // MIs[1] Operand 1
     /* 134727 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 134732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134734 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 134734 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134737 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 134741 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134746 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134768 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134793 */     GIR_RootConstrainSelectedInstOperands,
     /* 134794 */     // GIR_Coverage, 3173,
     /* 134794 */     GIR_EraseRootFromParent_Done,
     /* 134795 */   // Label 1887: @134795
     /* 134795 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(134887), // Rule ID 3189 //
     /* 134800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 134803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134815 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134819 */     // MIs[1] Operand 1
     /* 134819 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 134824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134826 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 134826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 134833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134860 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134885 */     GIR_RootConstrainSelectedInstOperands,
     /* 134886 */     // GIR_Coverage, 3189,
     /* 134886 */     GIR_EraseRootFromParent_Done,
     /* 134887 */   // Label 1888: @134887
     /* 134887 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(134979), // Rule ID 3205 //
     /* 134892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 134895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134907 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134911 */     // MIs[1] Operand 1
     /* 134911 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 134916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134918 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 134918 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134921 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 134925 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134930 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134934 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134952 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134977 */     GIR_RootConstrainSelectedInstOperands,
     /* 134978 */     // GIR_Coverage, 3205,
     /* 134978 */     GIR_EraseRootFromParent_Done,
     /* 134979 */   // Label 1889: @134979
     /* 134979 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(135071), // Rule ID 3221 //
     /* 134984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 134987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134999 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135003 */     // MIs[1] Operand 1
     /* 135003 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135010 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 135010 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135013 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135017 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135022 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135026 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135044 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135069 */     GIR_RootConstrainSelectedInstOperands,
     /* 135070 */     // GIR_Coverage, 3221,
     /* 135070 */     GIR_EraseRootFromParent_Done,
     /* 135071 */   // Label 1890: @135071
     /* 135071 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(135163), // Rule ID 3229 //
     /* 135076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135095 */     // MIs[1] Operand 1
     /* 135095 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135102 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 135102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135118 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135136 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135161 */     GIR_RootConstrainSelectedInstOperands,
     /* 135162 */     // GIR_Coverage, 3229,
     /* 135162 */     GIR_EraseRootFromParent_Done,
     /* 135163 */   // Label 1891: @135163
     /* 135163 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(135255), // Rule ID 3245 //
     /* 135168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135183 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135187 */     // MIs[1] Operand 1
     /* 135187 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135194 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 135194 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135197 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135201 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135206 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135210 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135228 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135253 */     GIR_RootConstrainSelectedInstOperands,
     /* 135254 */     // GIR_Coverage, 3245,
     /* 135254 */     GIR_EraseRootFromParent_Done,
     /* 135255 */   // Label 1892: @135255
     /* 135255 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(135347), // Rule ID 3261 //
     /* 135260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135275 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135279 */     // MIs[1] Operand 1
     /* 135279 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135286 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 135286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135302 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135320 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 135327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135345 */     GIR_RootConstrainSelectedInstOperands,
     /* 135346 */     // GIR_Coverage, 3261,
     /* 135346 */     GIR_EraseRootFromParent_Done,
     /* 135347 */   // Label 1893: @135347
     /* 135347 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(135439), // Rule ID 3277 //
     /* 135352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135367 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135371 */     // MIs[1] Operand 1
     /* 135371 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135378 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 135378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135390 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135394 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135412 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135437 */     GIR_RootConstrainSelectedInstOperands,
     /* 135438 */     // GIR_Coverage, 3277,
     /* 135438 */     GIR_EraseRootFromParent_Done,
     /* 135439 */   // Label 1894: @135439
     /* 135439 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(135531), // Rule ID 3285 //
     /* 135444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135459 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135463 */     // MIs[1] Operand 1
     /* 135463 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135470 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 135470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135473 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135477 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135482 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135486 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135504 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135529 */     GIR_RootConstrainSelectedInstOperands,
     /* 135530 */     // GIR_Coverage, 3285,
     /* 135530 */     GIR_EraseRootFromParent_Done,
     /* 135531 */   // Label 1895: @135531
     /* 135531 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(135623), // Rule ID 3301 //
     /* 135536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135551 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135555 */     // MIs[1] Operand 1
     /* 135555 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135562 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 135562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135596 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135621 */     GIR_RootConstrainSelectedInstOperands,
     /* 135622 */     // GIR_Coverage, 3301,
     /* 135622 */     GIR_EraseRootFromParent_Done,
     /* 135623 */   // Label 1896: @135623
     /* 135623 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(135715), // Rule ID 3317 //
     /* 135628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135643 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135647 */     // MIs[1] Operand 1
     /* 135647 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135654 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 135654 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135657 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135661 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135670 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135688 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 135695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135713 */     GIR_RootConstrainSelectedInstOperands,
     /* 135714 */     // GIR_Coverage, 3317,
     /* 135714 */     GIR_EraseRootFromParent_Done,
     /* 135715 */   // Label 1897: @135715
     /* 135715 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(135807), // Rule ID 3333 //
     /* 135720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135735 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135739 */     // MIs[1] Operand 1
     /* 135739 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135746 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 135746 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135749 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135753 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135758 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135762 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135780 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135805 */     GIR_RootConstrainSelectedInstOperands,
     /* 135806 */     // GIR_Coverage, 3333,
     /* 135806 */     GIR_EraseRootFromParent_Done,
     /* 135807 */   // Label 1898: @135807
     /* 135807 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(135939), // Rule ID 4012 //
     /* 135812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 135815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135827 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135831 */     // MIs[1] Operand 1
     /* 135831 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135838 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 135838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135850 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135854 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135860 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 135863 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135867 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135872 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 135875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135877 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 135880 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135884 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135889 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 135892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135906 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135937 */     GIR_RootConstrainSelectedInstOperands,
     /* 135938 */     // GIR_Coverage, 4012,
     /* 135938 */     GIR_EraseRootFromParent_Done,
     /* 135939 */   // Label 1899: @135939
     /* 135939 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(136071), // Rule ID 4044 //
     /* 135944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 135947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135963 */     // MIs[1] Operand 1
     /* 135963 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135970 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 135970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135982 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135986 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135992 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 135995 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135999 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136004 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136009 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136012 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136016 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136021 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136038 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136069 */     GIR_RootConstrainSelectedInstOperands,
     /* 136070 */     // GIR_Coverage, 4044,
     /* 136070 */     GIR_EraseRootFromParent_Done,
     /* 136071 */   // Label 1900: @136071
     /* 136071 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(136203), // Rule ID 4076 //
     /* 136076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136095 */     // MIs[1] Operand 1
     /* 136095 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 136100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136102 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136118 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136124 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136127 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136131 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136136 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136141 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136144 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136148 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136153 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136170 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136201 */     GIR_RootConstrainSelectedInstOperands,
     /* 136202 */     // GIR_Coverage, 4076,
     /* 136202 */     GIR_EraseRootFromParent_Done,
     /* 136203 */   // Label 1901: @136203
     /* 136203 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(136335), // Rule ID 4108 //
     /* 136208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136223 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136227 */     // MIs[1] Operand 1
     /* 136227 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 136232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136234 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136234 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136237 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136241 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136246 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136250 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136256 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136259 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136263 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136268 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136273 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136276 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136280 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136285 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136302 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 136309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136333 */     GIR_RootConstrainSelectedInstOperands,
     /* 136334 */     // GIR_Coverage, 4108,
     /* 136334 */     GIR_EraseRootFromParent_Done,
     /* 136335 */   // Label 1902: @136335
     /* 136335 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(136467), // Rule ID 4124 //
     /* 136340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136359 */     // MIs[1] Operand 1
     /* 136359 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 136364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136366 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136382 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136388 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136391 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136395 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136400 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136405 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136408 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136412 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136417 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136434 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136465 */     GIR_RootConstrainSelectedInstOperands,
     /* 136466 */     // GIR_Coverage, 4124,
     /* 136466 */     GIR_EraseRootFromParent_Done,
     /* 136467 */   // Label 1903: @136467
     /* 136467 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(136599), // Rule ID 4156 //
     /* 136472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136487 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136491 */     // MIs[1] Operand 1
     /* 136491 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 136496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136498 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136510 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136514 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136520 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136523 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136527 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136532 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136537 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136540 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136544 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136549 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136566 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136597 */     GIR_RootConstrainSelectedInstOperands,
     /* 136598 */     // GIR_Coverage, 4156,
     /* 136598 */     GIR_EraseRootFromParent_Done,
     /* 136599 */   // Label 1904: @136599
     /* 136599 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(136731), // Rule ID 4188 //
     /* 136604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136619 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136623 */     // MIs[1] Operand 1
     /* 136623 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 136628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136630 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136630 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136633 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136637 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136642 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136646 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136652 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136655 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136659 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136664 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136669 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136672 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136676 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136681 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136698 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136729 */     GIR_RootConstrainSelectedInstOperands,
     /* 136730 */     // GIR_Coverage, 4188,
     /* 136730 */     GIR_EraseRootFromParent_Done,
     /* 136731 */   // Label 1905: @136731
     /* 136731 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(136863), // Rule ID 4220 //
     /* 136736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136751 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136755 */     // MIs[1] Operand 1
     /* 136755 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 136760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136762 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136774 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136778 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136784 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136787 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136791 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136796 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136801 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136804 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136808 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136813 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136830 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 136837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136861 */     GIR_RootConstrainSelectedInstOperands,
     /* 136862 */     // GIR_Coverage, 4220,
     /* 136862 */     GIR_EraseRootFromParent_Done,
     /* 136863 */   // Label 1906: @136863
     /* 136863 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(136995), // Rule ID 4250 //
     /* 136868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 136883 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 136887 */     // MIs[1] Operand 1
     /* 136887 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 136892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136894 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136894 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136897 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 136901 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136906 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136910 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136916 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136919 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136923 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136928 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136933 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136936 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136940 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136945 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136962 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136993 */     GIR_RootConstrainSelectedInstOperands,
     /* 136994 */     // GIR_Coverage, 4250,
     /* 136994 */     GIR_EraseRootFromParent_Done,
     /* 136995 */   // Label 1907: @136995
     /* 136995 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(137127), // Rule ID 4282 //
     /* 137000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137019 */     // MIs[1] Operand 1
     /* 137019 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137026 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137038 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137042 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137048 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137051 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137055 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137060 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137065 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137068 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137072 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137077 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137094 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137125 */     GIR_RootConstrainSelectedInstOperands,
     /* 137126 */     // GIR_Coverage, 4282,
     /* 137126 */     GIR_EraseRootFromParent_Done,
     /* 137127 */   // Label 1908: @137127
     /* 137127 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(137259), // Rule ID 4314 //
     /* 137132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137147 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137151 */     // MIs[1] Operand 1
     /* 137151 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 137156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137158 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137174 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137180 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137183 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137187 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137192 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137197 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137200 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137204 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137209 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137226 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 137233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137257 */     GIR_RootConstrainSelectedInstOperands,
     /* 137258 */     // GIR_Coverage, 4314,
     /* 137258 */     GIR_EraseRootFromParent_Done,
     /* 137259 */   // Label 1909: @137259
     /* 137259 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(137391), // Rule ID 4346 //
     /* 137264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137279 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137283 */     // MIs[1] Operand 1
     /* 137283 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 137288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137290 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137302 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137306 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137312 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137315 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137319 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137324 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137329 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137332 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137336 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137341 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137358 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 137365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137389 */     GIR_RootConstrainSelectedInstOperands,
     /* 137390 */     // GIR_Coverage, 4346,
     /* 137390 */     GIR_EraseRootFromParent_Done,
     /* 137391 */   // Label 1910: @137391
     /* 137391 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(137523), // Rule ID 4577 //
     /* 137396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137411 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137415 */     // MIs[1] Operand 1
     /* 137415 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 137420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137422 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 137429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137434 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137444 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137447 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137451 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137456 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137461 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137464 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137468 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137473 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137490 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137521 */     GIR_RootConstrainSelectedInstOperands,
     /* 137522 */     // GIR_Coverage, 4577,
     /* 137522 */     GIR_EraseRootFromParent_Done,
     /* 137523 */   // Label 1911: @137523
     /* 137523 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(137655), // Rule ID 4609 //
     /* 137528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137543 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137547 */     // MIs[1] Operand 1
     /* 137547 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137554 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 137561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137570 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137576 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137579 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137583 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137588 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137593 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137596 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137600 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137605 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137622 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137653 */     GIR_RootConstrainSelectedInstOperands,
     /* 137654 */     // GIR_Coverage, 4609,
     /* 137654 */     GIR_EraseRootFromParent_Done,
     /* 137655 */   // Label 1912: @137655
     /* 137655 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(137787), // Rule ID 4641 //
     /* 137660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137675 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137679 */     // MIs[1] Operand 1
     /* 137679 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 137684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137686 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137686 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137689 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 137693 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137698 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137702 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137708 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137711 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137715 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137720 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137725 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137728 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137732 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137737 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137754 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137785 */     GIR_RootConstrainSelectedInstOperands,
     /* 137786 */     // GIR_Coverage, 4641,
     /* 137786 */     GIR_EraseRootFromParent_Done,
     /* 137787 */   // Label 1913: @137787
     /* 137787 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(137919), // Rule ID 4685 //
     /* 137792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137807 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137811 */     // MIs[1] Operand 1
     /* 137811 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 137816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137818 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137818 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137821 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 137825 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137830 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137834 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137840 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137843 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137847 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137852 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137857 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137860 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137864 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137869 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137886 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137917 */     GIR_RootConstrainSelectedInstOperands,
     /* 137918 */     // GIR_Coverage, 4685,
     /* 137918 */     GIR_EraseRootFromParent_Done,
     /* 137919 */   // Label 1914: @137919
     /* 137919 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(138051), // Rule ID 4717 //
     /* 137924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137939 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137943 */     // MIs[1] Operand 1
     /* 137943 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137950 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137950 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 137957 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137962 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137966 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137972 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137975 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137979 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137984 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137989 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137992 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137996 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138001 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138018 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138049 */     GIR_RootConstrainSelectedInstOperands,
     /* 138050 */     // GIR_Coverage, 4717,
     /* 138050 */     GIR_EraseRootFromParent_Done,
     /* 138051 */   // Label 1915: @138051
     /* 138051 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(138183), // Rule ID 4749 //
     /* 138056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 138059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 138067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138071 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138075 */     // MIs[1] Operand 1
     /* 138075 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 138080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138082 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138085 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 138089 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138094 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138098 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138104 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138107 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138111 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138116 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138121 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138124 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138128 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138133 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138150 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138181 */     GIR_RootConstrainSelectedInstOperands,
     /* 138182 */     // GIR_Coverage, 4749,
     /* 138182 */     GIR_EraseRootFromParent_Done,
     /* 138183 */   // Label 1916: @138183
     /* 138183 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(138275), // Rule ID 2975 //
     /* 138188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138203 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138207 */     // MIs[1] Operand 1
     /* 138207 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 138212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138214 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 138214 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138217 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 138221 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138226 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138230 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138248 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138273 */     GIR_RootConstrainSelectedInstOperands,
     /* 138274 */     // GIR_Coverage, 2975,
     /* 138274 */     GIR_EraseRootFromParent_Done,
     /* 138275 */   // Label 1917: @138275
     /* 138275 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(138367), // Rule ID 2989 //
     /* 138280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138295 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138299 */     // MIs[1] Operand 1
     /* 138299 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 138304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138306 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 138306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138322 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138340 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138365 */     GIR_RootConstrainSelectedInstOperands,
     /* 138366 */     // GIR_Coverage, 2989,
     /* 138366 */     GIR_EraseRootFromParent_Done,
     /* 138367 */   // Label 1918: @138367
     /* 138367 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(138459), // Rule ID 2997 //
     /* 138372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138391 */     // MIs[1] Operand 1
     /* 138391 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 138396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138398 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 138398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 138405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138410 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138414 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138432 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138457 */     GIR_RootConstrainSelectedInstOperands,
     /* 138458 */     // GIR_Coverage, 2997,
     /* 138458 */     GIR_EraseRootFromParent_Done,
     /* 138459 */   // Label 1919: @138459
     /* 138459 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(138551), // Rule ID 3005 //
     /* 138464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138479 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138483 */     // MIs[1] Operand 1
     /* 138483 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 138488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138490 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 138490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138502 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138506 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138524 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138549 */     GIR_RootConstrainSelectedInstOperands,
     /* 138550 */     // GIR_Coverage, 3005,
     /* 138550 */     GIR_EraseRootFromParent_Done,
     /* 138551 */   // Label 1920: @138551
     /* 138551 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(138643), // Rule ID 3013 //
     /* 138556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138571 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138575 */     // MIs[1] Operand 1
     /* 138575 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 138580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138582 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 138582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138594 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138616 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 138623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138641 */     GIR_RootConstrainSelectedInstOperands,
     /* 138642 */     // GIR_Coverage, 3013,
     /* 138642 */     GIR_EraseRootFromParent_Done,
     /* 138643 */   // Label 1921: @138643
     /* 138643 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(138735), // Rule ID 3077 //
     /* 138648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138663 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138667 */     // MIs[1] Operand 1
     /* 138667 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 138672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138674 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 138674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 138681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138686 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138708 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138733 */     GIR_RootConstrainSelectedInstOperands,
     /* 138734 */     // GIR_Coverage, 3077,
     /* 138734 */     GIR_EraseRootFromParent_Done,
     /* 138735 */   // Label 1922: @138735
     /* 138735 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(138827), // Rule ID 3085 //
     /* 138740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138755 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138759 */     // MIs[1] Operand 1
     /* 138759 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 138764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138766 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 138766 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138769 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 138773 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138778 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138782 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138800 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138825 */     GIR_RootConstrainSelectedInstOperands,
     /* 138826 */     // GIR_Coverage, 3085,
     /* 138826 */     GIR_EraseRootFromParent_Done,
     /* 138827 */   // Label 1923: @138827
     /* 138827 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(138919), // Rule ID 3093 //
     /* 138832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138847 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138851 */     // MIs[1] Operand 1
     /* 138851 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 138856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138858 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 138858 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138861 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 138865 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138870 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138874 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138892 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138917 */     GIR_RootConstrainSelectedInstOperands,
     /* 138918 */     // GIR_Coverage, 3093,
     /* 138918 */     GIR_EraseRootFromParent_Done,
     /* 138919 */   // Label 1924: @138919
     /* 138919 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(139011), // Rule ID 3101 //
     /* 138924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138939 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138943 */     // MIs[1] Operand 1
     /* 138943 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 138948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138950 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 138950 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 138957 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138962 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138966 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138984 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139009 */     GIR_RootConstrainSelectedInstOperands,
     /* 139010 */     // GIR_Coverage, 3101,
     /* 139010 */     GIR_EraseRootFromParent_Done,
     /* 139011 */   // Label 1925: @139011
     /* 139011 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(139103), // Rule ID 3109 //
     /* 139016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139031 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139035 */     // MIs[1] Operand 1
     /* 139035 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139042 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 139042 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139045 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139049 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139076 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 139083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139101 */     GIR_RootConstrainSelectedInstOperands,
     /* 139102 */     // GIR_Coverage, 3109,
     /* 139102 */     GIR_EraseRootFromParent_Done,
     /* 139103 */   // Label 1926: @139103
     /* 139103 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(139235), // Rule ID 3859 //
     /* 139108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139123 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139127 */     // MIs[1] Operand 1
     /* 139127 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 139132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139134 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 139141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139146 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139150 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139156 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139159 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139163 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139168 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139173 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139176 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139180 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139185 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139202 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139233 */     GIR_RootConstrainSelectedInstOperands,
     /* 139234 */     // GIR_Coverage, 3859,
     /* 139234 */     GIR_EraseRootFromParent_Done,
     /* 139235 */   // Label 1927: @139235
     /* 139235 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(139367), // Rule ID 3867 //
     /* 139240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139255 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139259 */     // MIs[1] Operand 1
     /* 139259 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 139264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139266 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139266 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139273 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139278 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139288 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139291 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139295 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139300 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139305 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139308 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139312 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139317 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139334 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139365 */     GIR_RootConstrainSelectedInstOperands,
     /* 139366 */     // GIR_Coverage, 3867,
     /* 139366 */     GIR_EraseRootFromParent_Done,
     /* 139367 */   // Label 1928: @139367
     /* 139367 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(139499), // Rule ID 3875 //
     /* 139372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139391 */     // MIs[1] Operand 1
     /* 139391 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 139396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139398 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 139405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139410 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139414 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139420 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139423 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139427 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139432 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139437 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139440 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139444 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139449 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139466 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139497 */     GIR_RootConstrainSelectedInstOperands,
     /* 139498 */     // GIR_Coverage, 3875,
     /* 139498 */     GIR_EraseRootFromParent_Done,
     /* 139499 */   // Label 1929: @139499
     /* 139499 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(139631), // Rule ID 3883 //
     /* 139504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139519 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139523 */     // MIs[1] Operand 1
     /* 139523 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 139528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139530 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139542 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139546 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139552 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139555 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139559 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139564 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139569 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139572 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139576 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139581 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139598 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139629 */     GIR_RootConstrainSelectedInstOperands,
     /* 139630 */     // GIR_Coverage, 3883,
     /* 139630 */     GIR_EraseRootFromParent_Done,
     /* 139631 */   // Label 1930: @139631
     /* 139631 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(139763), // Rule ID 3891 //
     /* 139636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139655 */     // MIs[1] Operand 1
     /* 139655 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139662 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139684 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139687 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139691 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139696 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139701 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139704 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139708 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139713 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139730 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 139737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139761 */     GIR_RootConstrainSelectedInstOperands,
     /* 139762 */     // GIR_Coverage, 3891,
     /* 139762 */     GIR_EraseRootFromParent_Done,
     /* 139763 */   // Label 1931: @139763
     /* 139763 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(139895), // Rule ID 3955 //
     /* 139768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139783 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139787 */     // MIs[1] Operand 1
     /* 139787 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 139792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139794 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139794 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139797 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 139801 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139806 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139810 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139816 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139819 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139823 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139828 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139833 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139836 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139840 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139845 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139862 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139893 */     GIR_RootConstrainSelectedInstOperands,
     /* 139894 */     // GIR_Coverage, 3955,
     /* 139894 */     GIR_EraseRootFromParent_Done,
     /* 139895 */   // Label 1932: @139895
     /* 139895 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(140027), // Rule ID 3963 //
     /* 139900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139915 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139919 */     // MIs[1] Operand 1
     /* 139919 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 139924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139926 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139926 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139929 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139933 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139938 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139942 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139948 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139951 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139955 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139960 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139965 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139968 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139972 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139977 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139994 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 140001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140025 */     GIR_RootConstrainSelectedInstOperands,
     /* 140026 */     // GIR_Coverage, 3963,
     /* 140026 */     GIR_EraseRootFromParent_Done,
     /* 140027 */   // Label 1933: @140027
     /* 140027 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(140159), // Rule ID 3971 //
     /* 140032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140047 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140051 */     // MIs[1] Operand 1
     /* 140051 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 140056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140058 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140058 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140061 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 140065 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140070 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140074 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140080 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140083 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140087 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140092 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140097 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140100 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140104 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140109 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140126 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 140133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140157 */     GIR_RootConstrainSelectedInstOperands,
     /* 140158 */     // GIR_Coverage, 3971,
     /* 140158 */     GIR_EraseRootFromParent_Done,
     /* 140159 */   // Label 1934: @140159
     /* 140159 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(140291), // Rule ID 3979 //
     /* 140164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140179 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140183 */     // MIs[1] Operand 1
     /* 140183 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 140188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140190 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140190 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140193 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140197 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140206 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140212 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140215 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140219 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140224 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140229 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140232 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140236 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140241 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140258 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 140265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140289 */     GIR_RootConstrainSelectedInstOperands,
     /* 140290 */     // GIR_Coverage, 3979,
     /* 140290 */     GIR_EraseRootFromParent_Done,
     /* 140291 */   // Label 1935: @140291
     /* 140291 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(140423), // Rule ID 3987 //
     /* 140296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140311 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140315 */     // MIs[1] Operand 1
     /* 140315 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140322 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140338 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140344 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140347 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140351 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140356 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140361 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140364 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140368 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140373 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140390 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 140397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140421 */     GIR_RootConstrainSelectedInstOperands,
     /* 140422 */     // GIR_Coverage, 3987,
     /* 140422 */     GIR_EraseRootFromParent_Done,
     /* 140423 */   // Label 1936: @140423
     /* 140423 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(140438), // Rule ID 2981 //
     /* 140428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 140431 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 140431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 140436 */     GIR_RootConstrainSelectedInstOperands,
     /* 140437 */     // GIR_Coverage, 2981,
     /* 140437 */     GIR_Done,
     /* 140438 */   // Label 1937: @140438
     /* 140438 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(140492), // Rule ID 3665 //
     /* 140443 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 140443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140455 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 140458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140472 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 140475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140482 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 140484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140490 */     GIR_RootConstrainSelectedInstOperands,
     /* 140491 */     // GIR_Coverage, 3665,
     /* 140491 */     GIR_EraseRootFromParent_Done,
     /* 140492 */   // Label 1938: @140492
     /* 140492 */   GIM_Reject,
     /* 140493 */ // Label 1846: @140493
     /* 140493 */ GIM_Reject,
     /* 140494 */ // Label 1844: @140494
     /* 140494 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(140610), // Rule ID 5289 //
     /* 140499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140514 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140518 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140522 */   // MIs[1] Operand 1
     /* 140522 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140527 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140531 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140535 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 140539 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140543 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140547 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140551 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 140555 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140559 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140563 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140567 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140569 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 140569 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140572 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 140576 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140581 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 140585 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 140588 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 140591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 140596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140598 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140608 */   GIR_RootConstrainSelectedInstOperands,
     /* 140609 */   // GIR_Coverage, 5289,
     /* 140609 */   GIR_EraseRootFromParent_Done,
     /* 140610 */ // Label 1939: @140610
     /* 140610 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(140780), // Rule ID 5290 //
     /* 140615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140622 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140626 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140634 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140638 */   // MIs[1] Operand 1
     /* 140638 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140643 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140647 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140651 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 140655 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 140659 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140663 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140667 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 140671 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140675 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140679 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140683 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140685 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 140685 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140688 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 140692 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140697 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 140701 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 140704 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 140707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140709 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140712 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 140716 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140721 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140725 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 140728 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140731 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 140753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140769 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140774 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 140779 */   // GIR_Coverage, 5290,
     /* 140779 */   GIR_EraseRootFromParent_Done,
     /* 140780 */ // Label 1940: @140780
     /* 140780 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(140917), // Rule ID 5297 //
     /* 140785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140792 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140800 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140804 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140808 */   // MIs[1] Operand 1
     /* 140808 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 140813 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140817 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140821 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 140825 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140829 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140833 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140837 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 140841 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140845 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140849 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140853 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140855 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 140855 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140858 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 140862 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140867 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 140871 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 140874 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 140877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 140886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140891 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140895 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 140904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140915 */   GIR_RootConstrainSelectedInstOperands,
     /* 140916 */   // GIR_Coverage, 5297,
     /* 140916 */   GIR_EraseRootFromParent_Done,
     /* 140917 */ // Label 1941: @140917
     /* 140917 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(141108), // Rule ID 5298 //
     /* 140922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140929 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140937 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140941 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140945 */   // MIs[1] Operand 1
     /* 140945 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 140950 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140954 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140958 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 140962 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 140966 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140970 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140974 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 140978 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140982 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140986 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140990 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140992 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 140992 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140995 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 140999 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141004 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141008 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 141011 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 141014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 141016 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141019 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 141023 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141028 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141032 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141038 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141041 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141045 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141050 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141053 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 141056 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141059 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141092 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141107 */   // GIR_Coverage, 5298,
     /* 141107 */   GIR_EraseRootFromParent_Done,
     /* 141108 */ // Label 1942: @141108
     /* 141108 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(141224), // Rule ID 3770 //
     /* 141113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141120 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141128 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141132 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141136 */   // MIs[1] Operand 1
     /* 141136 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 141141 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141145 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141149 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141153 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141157 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141161 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141165 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141169 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141173 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141177 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141181 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141183 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 141186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141195 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141199 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 141202 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 141205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141212 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141222 */   GIR_RootConstrainSelectedInstOperands,
     /* 141223 */   // GIR_Coverage, 3770,
     /* 141223 */   GIR_EraseRootFromParent_Done,
     /* 141224 */ // Label 1943: @141224
     /* 141224 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(141394), // Rule ID 3771 //
     /* 141229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141236 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141240 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141244 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141248 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141252 */   // MIs[1] Operand 1
     /* 141252 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 141257 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141261 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141265 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141269 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141273 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141277 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141281 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141285 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141289 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141293 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141297 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141299 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141299 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141302 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141306 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141311 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141315 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 141318 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 141321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141323 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141326 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141330 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141335 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141339 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141342 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141345 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141393 */   // GIR_Coverage, 3771,
     /* 141393 */   GIR_EraseRootFromParent_Done,
     /* 141394 */ // Label 1944: @141394
     /* 141394 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(141531), // Rule ID 3778 //
     /* 141399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141406 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141410 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141414 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141418 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141422 */   // MIs[1] Operand 1
     /* 141422 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141427 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141431 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141435 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141439 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141443 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141447 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141451 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141455 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141459 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141463 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141467 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141469 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141469 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141472 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141476 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141481 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141485 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 141488 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 141491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 141500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141505 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141529 */   GIR_RootConstrainSelectedInstOperands,
     /* 141530 */   // GIR_Coverage, 3778,
     /* 141530 */   GIR_EraseRootFromParent_Done,
     /* 141531 */ // Label 1945: @141531
     /* 141531 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(141722), // Rule ID 3779 //
     /* 141536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141551 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141555 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141559 */   // MIs[1] Operand 1
     /* 141559 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141564 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141568 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141572 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141576 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141580 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141584 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141588 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141592 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141596 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141600 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141604 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141606 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141606 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 141609 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141613 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141618 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141622 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 141625 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 141628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 141630 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141633 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 141637 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141642 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141646 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141652 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141655 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141659 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141664 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141667 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 141670 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141673 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141697 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141716 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141721 */   // GIR_Coverage, 3779,
     /* 141721 */   GIR_EraseRootFromParent_Done,
     /* 141722 */ // Label 1946: @141722
     /* 141722 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(141805), // Rule ID 3350 //
     /* 141727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 141730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 141733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 141745 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 141749 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141753 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 141757 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 141761 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141765 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 141769 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 141771 */   // (zext:{ *:[i64] } (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] }))  =>  (RLDICL_32_64:{ *:[i64] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 141771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 141774 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 141778 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141783 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // RS
     /* 141787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32_64),
     /* 141792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 141803 */   GIR_RootConstrainSelectedInstOperands,
     /* 141804 */   // GIR_Coverage, 3350,
     /* 141804 */   GIR_EraseRootFromParent_Done,
     /* 141805 */ // Label 1947: @141805
     /* 141805 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(141878), // Rule ID 3690 //
     /* 141810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141817 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141821 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141825 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141829 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141833 */   // MIs[1] Operand 1
     /* 141833 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141838 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141842 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141844 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 141844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 141851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141856 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 141865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 141873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141876 */   GIR_RootConstrainSelectedInstOperands,
     /* 141877 */   // GIR_Coverage, 3690,
     /* 141877 */   GIR_EraseRootFromParent_Done,
     /* 141878 */ // Label 1948: @141878
     /* 141878 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(142005), // Rule ID 3691 //
     /* 141883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141898 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141902 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141906 */   // MIs[1] Operand 1
     /* 141906 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141911 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141915 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141917 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141917 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141920 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 141924 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141929 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141935 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141938 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 141942 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141947 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141950 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 141953 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141956 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141994 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141999 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142004 */   // GIR_Coverage, 3691,
     /* 142004 */   GIR_EraseRootFromParent_Done,
     /* 142005 */ // Label 1949: @142005
     /* 142005 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(142116), // Rule ID 3698 //
     /* 142010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142025 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142029 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142033 */   // MIs[1] Operand 1
     /* 142033 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142038 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142042 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142044 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 142044 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142047 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142051 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142056 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142062 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 142065 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142069 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142074 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 142087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142092 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142095 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 142111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142114 */   GIR_RootConstrainSelectedInstOperands,
     /* 142115 */   // GIR_Coverage, 3698,
     /* 142115 */   GIR_EraseRootFromParent_Done,
     /* 142116 */ // Label 1950: @142116
     /* 142116 */ GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(142281), // Rule ID 3699 //
     /* 142121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142136 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142140 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142144 */   // MIs[1] Operand 1
     /* 142144 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142149 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142155 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142155 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 142158 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142162 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142167 */   GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 142173 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 142176 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142180 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142185 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142191 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142194 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 142198 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142203 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 142206 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 142209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142211 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142214 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142218 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142223 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142226 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 142229 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142232 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142237 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142240 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142244 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142256 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142275 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142280 */   // GIR_Coverage, 3699,
     /* 142280 */   GIR_EraseRootFromParent_Done,
     /* 142281 */ // Label 1951: @142281
     /* 142281 */ GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(142337), // Rule ID 3706 //
     /* 142286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142301 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142305 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142309 */   // MIs[1] Operand 1
     /* 142309 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 142314 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142320 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142325 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142335 */   GIR_RootConstrainSelectedInstOperands,
     /* 142336 */   // GIR_Coverage, 3706,
     /* 142336 */   GIR_EraseRootFromParent_Done,
     /* 142337 */ // Label 1952: @142337
     /* 142337 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(142447), // Rule ID 3707 //
     /* 142342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142349 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142353 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142357 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142361 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142365 */   // MIs[1] Operand 1
     /* 142365 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 142370 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142374 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142376 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142376 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142379 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142383 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142388 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142392 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142395 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142398 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142436 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142441 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142446 */   // GIR_Coverage, 3707,
     /* 142446 */   GIR_EraseRootFromParent_Done,
     /* 142447 */ // Label 1953: @142447
     /* 142447 */ GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(142524), // Rule ID 3714 //
     /* 142452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142467 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142471 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142475 */   // MIs[1] Operand 1
     /* 142475 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142480 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142486 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 142493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142498 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142502 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142522 */   GIR_RootConstrainSelectedInstOperands,
     /* 142523 */   // GIR_Coverage, 3714,
     /* 142523 */   GIR_EraseRootFromParent_Done,
     /* 142524 */ // Label 1954: @142524
     /* 142524 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(142655), // Rule ID 3715 //
     /* 142529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142544 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142548 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142552 */   // MIs[1] Operand 1
     /* 142552 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142557 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142561 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142563 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142563 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142566 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 142570 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142575 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142579 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142585 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142588 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142592 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142597 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142600 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142603 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142606 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142611 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142614 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142618 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142654 */   // GIR_Coverage, 3715,
     /* 142654 */   GIR_EraseRootFromParent_Done,
     /* 142655 */ // Label 1955: @142655
     /* 142655 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(142749), // Rule ID 3722 //
     /* 142660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142675 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142679 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142683 */   // MIs[1] Operand 1
     /* 142683 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 142688 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142692 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142694 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142694 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 142697 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 142701 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142706 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 142719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142724 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142727 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142747 */   GIR_RootConstrainSelectedInstOperands,
     /* 142748 */   // GIR_Coverage, 3722,
     /* 142748 */   GIR_EraseRootFromParent_Done,
     /* 142749 */ // Label 1956: @142749
     /* 142749 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(142897), // Rule ID 3723 //
     /* 142754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142761 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142769 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142773 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142777 */   // MIs[1] Operand 1
     /* 142777 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 142782 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142788 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142788 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 142791 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 142795 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142800 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142806 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142809 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 142813 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142818 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 142821 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142827 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142830 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142834 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142839 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142842 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142845 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142848 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142886 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142891 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142896 */   // GIR_Coverage, 3723,
     /* 142896 */   GIR_EraseRootFromParent_Done,
     /* 142897 */ // Label 1957: @142897
     /* 142897 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(142991), // Rule ID 3730 //
     /* 142902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142917 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142921 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142925 */   // MIs[1] Operand 1
     /* 142925 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 142930 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142934 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142936 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142936 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 142939 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 142943 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142948 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 142961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142966 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142970 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142989 */   GIR_RootConstrainSelectedInstOperands,
     /* 142990 */   // GIR_Coverage, 3730,
     /* 142990 */   GIR_EraseRootFromParent_Done,
     /* 142991 */ // Label 1958: @142991
     /* 142991 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(143139), // Rule ID 3731 //
     /* 142996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143003 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143011 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143015 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143019 */   // MIs[1] Operand 1
     /* 143019 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143024 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143030 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143030 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143033 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 143037 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143042 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143048 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143051 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 143055 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143060 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143064 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143069 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143072 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143076 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143081 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143084 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143087 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143090 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143138 */   // GIR_Coverage, 3731,
     /* 143138 */   GIR_EraseRootFromParent_Done,
     /* 143139 */ // Label 1959: @143139
     /* 143139 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(143236), // Rule ID 3738 //
     /* 143144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143159 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143163 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143167 */   // MIs[1] Operand 1
     /* 143167 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 143172 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143178 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143178 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143181 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 143185 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143190 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143194 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 143206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143211 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143215 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143234 */   GIR_RootConstrainSelectedInstOperands,
     /* 143235 */   // GIR_Coverage, 3738,
     /* 143235 */   GIR_EraseRootFromParent_Done,
     /* 143236 */ // Label 1960: @143236
     /* 143236 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(143387), // Rule ID 3739 //
     /* 143241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143256 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143260 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143264 */   // MIs[1] Operand 1
     /* 143264 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 143269 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143273 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143275 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143275 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143278 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 143282 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143287 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143291 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 143294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143296 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143299 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 143303 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143308 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143312 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143317 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143320 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143324 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143329 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143332 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143335 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143338 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143376 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143381 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143386 */   // GIR_Coverage, 3739,
     /* 143386 */   GIR_EraseRootFromParent_Done,
     /* 143387 */ // Label 1961: @143387
     /* 143387 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(143484), // Rule ID 3746 //
     /* 143392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143399 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143407 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143411 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143415 */   // MIs[1] Operand 1
     /* 143415 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 143420 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143426 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143426 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143429 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 143433 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143438 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143442 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 143454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143459 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143463 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143482 */   GIR_RootConstrainSelectedInstOperands,
     /* 143483 */   // GIR_Coverage, 3746,
     /* 143483 */   GIR_EraseRootFromParent_Done,
     /* 143484 */ // Label 1962: @143484
     /* 143484 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(143635), // Rule ID 3747 //
     /* 143489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143496 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143500 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143504 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143508 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143512 */   // MIs[1] Operand 1
     /* 143512 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 143517 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143521 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143523 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143523 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143526 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 143530 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143535 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143539 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 143542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143544 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143547 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 143551 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143556 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143560 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143565 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143568 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143572 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143577 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143580 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143583 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143586 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143619 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143624 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143629 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143634 */   // GIR_Coverage, 3747,
     /* 143634 */   GIR_EraseRootFromParent_Done,
     /* 143635 */ // Label 1963: @143635
     /* 143635 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(143712), // Rule ID 3754 //
     /* 143640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143655 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143659 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143663 */   // MIs[1] Operand 1
     /* 143663 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143668 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143672 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143674 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 143681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143686 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143690 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143710 */   GIR_RootConstrainSelectedInstOperands,
     /* 143711 */   // GIR_Coverage, 3754,
     /* 143711 */   GIR_EraseRootFromParent_Done,
     /* 143712 */ // Label 1964: @143712
     /* 143712 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(143843), // Rule ID 3755 //
     /* 143717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143724 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143728 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143732 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143736 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143740 */   // MIs[1] Operand 1
     /* 143740 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143745 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143751 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143751 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143754 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 143758 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143763 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143767 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143773 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143776 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143780 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143785 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143788 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143791 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143794 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143842 */   // GIR_Coverage, 3755,
     /* 143842 */   GIR_EraseRootFromParent_Done,
     /* 143843 */ // Label 1965: @143843
     /* 143843 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(143899), // Rule ID 3762 //
     /* 143848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143855 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143863 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143867 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143871 */   // MIs[1] Operand 1
     /* 143871 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143876 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143880 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143882 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143887 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143897 */   GIR_RootConstrainSelectedInstOperands,
     /* 143898 */   // GIR_Coverage, 3762,
     /* 143898 */   GIR_EraseRootFromParent_Done,
     /* 143899 */ // Label 1966: @143899
     /* 143899 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(144009), // Rule ID 3763 //
     /* 143904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143919 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143923 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143927 */   // MIs[1] Operand 1
     /* 143927 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143932 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143936 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143938 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143938 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143941 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143945 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143950 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143954 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143957 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143960 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143993 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 144008 */   // GIR_Coverage, 3763,
     /* 144008 */   GIR_EraseRootFromParent_Done,
     /* 144009 */ // Label 1967: @144009
     /* 144009 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(144119), // Rule ID 3030 //
     /* 144014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144032 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144036 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144040 */   // MIs[1] Operand 1
     /* 144040 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144045 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144049 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144053 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144057 */   // MIs[2] Operand 1
     /* 144057 */   // No operand predicates
     /* 144057 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144059 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 144059 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144062 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144066 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144071 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144075 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144092 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144099 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144104 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144117 */   GIR_RootConstrainSelectedInstOperands,
     /* 144118 */   // GIR_Coverage, 3030,
     /* 144118 */   GIR_EraseRootFromParent_Done,
     /* 144119 */ // Label 1968: @144119
     /* 144119 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(144229), // Rule ID 3046 //
     /* 144124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144134 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144138 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144142 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144146 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144150 */   // MIs[1] Operand 1
     /* 144150 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144155 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144159 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144163 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144167 */   // MIs[2] Operand 1
     /* 144167 */   // No operand predicates
     /* 144167 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144169 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 144169 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144172 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144176 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144181 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144185 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144202 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144209 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144214 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144227 */   GIR_RootConstrainSelectedInstOperands,
     /* 144228 */   // GIR_Coverage, 3046,
     /* 144228 */   GIR_EraseRootFromParent_Done,
     /* 144229 */ // Label 1969: @144229
     /* 144229 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(144339), // Rule ID 3054 //
     /* 144234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144244 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144252 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144256 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144260 */   // MIs[1] Operand 1
     /* 144260 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 144265 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144269 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144273 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144277 */   // MIs[2] Operand 1
     /* 144277 */   // No operand predicates
     /* 144277 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144279 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 144279 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144282 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144286 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144291 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144295 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144312 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144319 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144324 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144337 */   GIR_RootConstrainSelectedInstOperands,
     /* 144338 */   // GIR_Coverage, 3054,
     /* 144338 */   GIR_EraseRootFromParent_Done,
     /* 144339 */ // Label 1970: @144339
     /* 144339 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(144449), // Rule ID 3126 //
     /* 144344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144362 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144366 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144370 */   // MIs[1] Operand 1
     /* 144370 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144375 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144379 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144383 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144387 */   // MIs[2] Operand 1
     /* 144387 */   // No operand predicates
     /* 144387 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144389 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 144389 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144392 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144396 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144401 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144405 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144422 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144434 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144447 */   GIR_RootConstrainSelectedInstOperands,
     /* 144448 */   // GIR_Coverage, 3126,
     /* 144448 */   GIR_EraseRootFromParent_Done,
     /* 144449 */ // Label 1971: @144449
     /* 144449 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(144559), // Rule ID 3142 //
     /* 144454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144464 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144472 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144476 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144480 */   // MIs[1] Operand 1
     /* 144480 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144485 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144489 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144493 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144497 */   // MIs[2] Operand 1
     /* 144497 */   // No operand predicates
     /* 144497 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144499 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 144499 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144502 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144506 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144511 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144515 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144532 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144539 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144557 */   GIR_RootConstrainSelectedInstOperands,
     /* 144558 */   // GIR_Coverage, 3142,
     /* 144558 */   GIR_EraseRootFromParent_Done,
     /* 144559 */ // Label 1972: @144559
     /* 144559 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(144669), // Rule ID 3150 //
     /* 144564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144582 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144586 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144590 */   // MIs[1] Operand 1
     /* 144590 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 144595 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144599 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144603 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144607 */   // MIs[2] Operand 1
     /* 144607 */   // No operand predicates
     /* 144607 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144609 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 144609 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144612 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144616 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144621 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144625 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144642 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144649 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144667 */   GIR_RootConstrainSelectedInstOperands,
     /* 144668 */   // GIR_Coverage, 3150,
     /* 144668 */   GIR_EraseRootFromParent_Done,
     /* 144669 */ // Label 1973: @144669
     /* 144669 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(144819), // Rule ID 3813 //
     /* 144674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 144677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144692 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144696 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144700 */   // MIs[1] Operand 1
     /* 144700 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144705 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144709 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144713 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144717 */   // MIs[2] Operand 1
     /* 144717 */   // No operand predicates
     /* 144717 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144719 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 144719 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144722 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144726 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144731 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144735 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144740 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 144743 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144747 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144752 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 144755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 144757 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144760 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144764 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144769 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 144772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144786 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 144806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 144814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 144817 */   GIR_RootConstrainSelectedInstOperands,
     /* 144818 */   // GIR_Coverage, 3813,
     /* 144818 */   GIR_EraseRootFromParent_Done,
     /* 144819 */ // Label 1974: @144819
     /* 144819 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(144969), // Rule ID 3829 //
     /* 144824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 144827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144842 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144846 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144850 */   // MIs[1] Operand 1
     /* 144850 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144855 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144859 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144863 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144867 */   // MIs[2] Operand 1
     /* 144867 */   // No operand predicates
     /* 144867 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144869 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 144869 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144872 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144876 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144881 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144885 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144890 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 144893 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144897 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144902 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 144905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 144907 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144910 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144914 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144919 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 144922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144924 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144927 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144931 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144936 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144943 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144948 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 144956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 144964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 144967 */   GIR_RootConstrainSelectedInstOperands,
     /* 144968 */   // GIR_Coverage, 3829,
     /* 144968 */   GIR_EraseRootFromParent_Done,
     /* 144969 */ // Label 1975: @144969
     /* 144969 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(145119), // Rule ID 3837 //
     /* 144974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 144977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144984 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144988 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144992 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144996 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145000 */   // MIs[1] Operand 1
     /* 145000 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 145005 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145009 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145013 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 145017 */   // MIs[2] Operand 1
     /* 145017 */   // No operand predicates
     /* 145017 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145019 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145019 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145022 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 145026 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145031 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145035 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145040 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145043 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145047 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145052 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145057 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145060 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145064 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145069 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145086 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145093 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145117 */   GIR_RootConstrainSelectedInstOperands,
     /* 145118 */   // GIR_Coverage, 3837,
     /* 145118 */   GIR_EraseRootFromParent_Done,
     /* 145119 */ // Label 1976: @145119
     /* 145119 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(145269), // Rule ID 3909 //
     /* 145124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145134 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145138 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145142 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145146 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145150 */   // MIs[1] Operand 1
     /* 145150 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 145155 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145159 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145163 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145167 */   // MIs[2] Operand 1
     /* 145167 */   // No operand predicates
     /* 145167 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145169 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145169 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145172 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145176 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145181 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145185 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145190 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145193 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145197 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145202 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145207 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145210 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145214 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145219 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145224 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145227 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145231 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145236 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145243 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145248 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145267 */   GIR_RootConstrainSelectedInstOperands,
     /* 145268 */   // GIR_Coverage, 3909,
     /* 145268 */   GIR_EraseRootFromParent_Done,
     /* 145269 */ // Label 1977: @145269
     /* 145269 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(145419), // Rule ID 3925 //
     /* 145274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145284 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145288 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145292 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145296 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145300 */   // MIs[1] Operand 1
     /* 145300 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 145305 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145309 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145313 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145317 */   // MIs[2] Operand 1
     /* 145317 */   // No operand predicates
     /* 145317 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145319 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145319 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145322 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145326 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145331 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145335 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145340 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145343 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145347 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145352 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145357 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145360 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145364 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145369 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145374 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145377 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145381 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145386 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145393 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145398 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145417 */   GIR_RootConstrainSelectedInstOperands,
     /* 145418 */   // GIR_Coverage, 3925,
     /* 145418 */   GIR_EraseRootFromParent_Done,
     /* 145419 */ // Label 1978: @145419
     /* 145419 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(145569), // Rule ID 3933 //
     /* 145424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145442 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145446 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145450 */   // MIs[1] Operand 1
     /* 145450 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 145455 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145459 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145463 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145467 */   // MIs[2] Operand 1
     /* 145467 */   // No operand predicates
     /* 145467 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145469 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145469 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145472 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145476 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145481 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145485 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145490 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145493 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145497 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145502 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145507 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145510 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145514 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145519 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145536 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145548 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145567 */   GIR_RootConstrainSelectedInstOperands,
     /* 145568 */   // GIR_Coverage, 3933,
     /* 145568 */   GIR_EraseRootFromParent_Done,
     /* 145569 */ // Label 1979: @145569
     /* 145569 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(145668), // Rule ID 3174 //
     /* 145574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145584 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145592 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145596 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145600 */   // MIs[1] Operand 1
     /* 145600 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 145605 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145607 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 145607 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145610 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145614 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145619 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145623 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145641 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145648 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145653 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145666 */   GIR_RootConstrainSelectedInstOperands,
     /* 145667 */   // GIR_Coverage, 3174,
     /* 145667 */   GIR_EraseRootFromParent_Done,
     /* 145668 */ // Label 1980: @145668
     /* 145668 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(145767), // Rule ID 3190 //
     /* 145673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145691 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145695 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145699 */   // MIs[1] Operand 1
     /* 145699 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 145704 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145706 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 145706 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145709 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145713 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145718 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145722 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145740 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145747 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145752 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145765 */   GIR_RootConstrainSelectedInstOperands,
     /* 145766 */   // GIR_Coverage, 3190,
     /* 145766 */   GIR_EraseRootFromParent_Done,
     /* 145767 */ // Label 1981: @145767
     /* 145767 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(145866), // Rule ID 3206 //
     /* 145772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145782 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145786 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145790 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145794 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145798 */   // MIs[1] Operand 1
     /* 145798 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 145803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145805 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 145805 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145808 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145812 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145817 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145821 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145839 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145846 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145851 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145864 */   GIR_RootConstrainSelectedInstOperands,
     /* 145865 */   // GIR_Coverage, 3206,
     /* 145865 */   GIR_EraseRootFromParent_Done,
     /* 145866 */ // Label 1982: @145866
     /* 145866 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(145965), // Rule ID 3222 //
     /* 145871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145881 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145889 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145893 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145897 */   // MIs[1] Operand 1
     /* 145897 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 145902 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145904 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 145904 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145907 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145911 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145916 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145920 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145938 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 145945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145950 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145963 */   GIR_RootConstrainSelectedInstOperands,
     /* 145964 */   // GIR_Coverage, 3222,
     /* 145964 */   GIR_EraseRootFromParent_Done,
     /* 145965 */ // Label 1983: @145965
     /* 145965 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(146064), // Rule ID 3230 //
     /* 145970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145988 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145992 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145996 */   // MIs[1] Operand 1
     /* 145996 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146001 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146003 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 146003 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146006 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146010 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146015 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146019 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146037 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146044 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146049 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146062 */   GIR_RootConstrainSelectedInstOperands,
     /* 146063 */   // GIR_Coverage, 3230,
     /* 146063 */   GIR_EraseRootFromParent_Done,
     /* 146064 */ // Label 1984: @146064
     /* 146064 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(146163), // Rule ID 3246 //
     /* 146069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146087 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146091 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146095 */   // MIs[1] Operand 1
     /* 146095 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146100 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146102 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 146102 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146105 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146109 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146114 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146118 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146136 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146161 */   GIR_RootConstrainSelectedInstOperands,
     /* 146162 */   // GIR_Coverage, 3246,
     /* 146162 */   GIR_EraseRootFromParent_Done,
     /* 146163 */ // Label 1985: @146163
     /* 146163 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(146262), // Rule ID 3262 //
     /* 146168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146186 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146190 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146194 */   // MIs[1] Operand 1
     /* 146194 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146199 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146201 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 146201 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146204 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146208 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146213 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146217 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146235 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146242 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146247 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146260 */   GIR_RootConstrainSelectedInstOperands,
     /* 146261 */   // GIR_Coverage, 3262,
     /* 146261 */   GIR_EraseRootFromParent_Done,
     /* 146262 */ // Label 1986: @146262
     /* 146262 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(146361), // Rule ID 3278 //
     /* 146267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146277 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146281 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146285 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146289 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146293 */   // MIs[1] Operand 1
     /* 146293 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 146298 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146300 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 146300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146316 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146334 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 146341 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146359 */   GIR_RootConstrainSelectedInstOperands,
     /* 146360 */   // GIR_Coverage, 3278,
     /* 146360 */   GIR_EraseRootFromParent_Done,
     /* 146361 */ // Label 1987: @146361
     /* 146361 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(146460), // Rule ID 3286 //
     /* 146366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146384 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146388 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146392 */   // MIs[1] Operand 1
     /* 146392 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146399 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 146399 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146402 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146406 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146411 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146415 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146421 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146424 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146428 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146433 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146440 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146458 */   GIR_RootConstrainSelectedInstOperands,
     /* 146459 */   // GIR_Coverage, 3286,
     /* 146459 */   GIR_EraseRootFromParent_Done,
     /* 146460 */ // Label 1988: @146460
     /* 146460 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(146559), // Rule ID 3302 //
     /* 146465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146483 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146487 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146491 */   // MIs[1] Operand 1
     /* 146491 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146498 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 146498 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146501 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146505 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146510 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146514 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146532 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146539 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146557 */   GIR_RootConstrainSelectedInstOperands,
     /* 146558 */   // GIR_Coverage, 3302,
     /* 146558 */   GIR_EraseRootFromParent_Done,
     /* 146559 */ // Label 1989: @146559
     /* 146559 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(146658), // Rule ID 3318 //
     /* 146564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146582 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146586 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146590 */   // MIs[1] Operand 1
     /* 146590 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146597 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 146597 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146600 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146604 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146609 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146613 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146631 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146638 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146643 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146653 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146656 */   GIR_RootConstrainSelectedInstOperands,
     /* 146657 */   // GIR_Coverage, 3318,
     /* 146657 */   GIR_EraseRootFromParent_Done,
     /* 146658 */ // Label 1990: @146658
     /* 146658 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(146757), // Rule ID 3334 //
     /* 146663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146681 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146685 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146689 */   // MIs[1] Operand 1
     /* 146689 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 146694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146696 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 146696 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146699 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146703 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146708 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146712 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146730 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 146737 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146755 */   GIR_RootConstrainSelectedInstOperands,
     /* 146756 */   // GIR_Coverage, 3334,
     /* 146756 */   GIR_EraseRootFromParent_Done,
     /* 146757 */ // Label 1991: @146757
     /* 146757 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(146896), // Rule ID 4016 //
     /* 146762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 146765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146772 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146780 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146784 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146788 */   // MIs[1] Operand 1
     /* 146788 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146793 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146795 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146795 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146798 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146802 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146807 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146811 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146817 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146820 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146824 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146829 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146834 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146837 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146841 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146846 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146863 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146870 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146875 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 146883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 146891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 146894 */   GIR_RootConstrainSelectedInstOperands,
     /* 146895 */   // GIR_Coverage, 4016,
     /* 146895 */   GIR_EraseRootFromParent_Done,
     /* 146896 */ // Label 1992: @146896
     /* 146896 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(147035), // Rule ID 4048 //
     /* 146901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 146904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146919 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146923 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146927 */   // MIs[1] Operand 1
     /* 146927 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146932 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146934 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146934 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146937 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146941 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146946 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146950 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146956 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146959 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146963 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146968 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146973 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146976 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146980 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146985 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146990 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146993 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146997 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147002 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147014 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147033 */   GIR_RootConstrainSelectedInstOperands,
     /* 147034 */   // GIR_Coverage, 4048,
     /* 147034 */   GIR_EraseRootFromParent_Done,
     /* 147035 */ // Label 1993: @147035
     /* 147035 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(147174), // Rule ID 4080 //
     /* 147040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147050 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147054 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147058 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147062 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147066 */   // MIs[1] Operand 1
     /* 147066 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 147071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147073 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147073 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147076 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147080 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147085 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147089 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147095 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147098 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147102 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147107 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147112 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147115 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147119 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147124 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147141 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 147148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147172 */   GIR_RootConstrainSelectedInstOperands,
     /* 147173 */   // GIR_Coverage, 4080,
     /* 147173 */   GIR_EraseRootFromParent_Done,
     /* 147174 */ // Label 1994: @147174
     /* 147174 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(147313), // Rule ID 4112 //
     /* 147179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147197 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147201 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147205 */   // MIs[1] Operand 1
     /* 147205 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 147210 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147212 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147228 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147234 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147237 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147241 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147246 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147251 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147254 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147258 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147263 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147280 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 147287 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147292 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147311 */   GIR_RootConstrainSelectedInstOperands,
     /* 147312 */   // GIR_Coverage, 4112,
     /* 147312 */   GIR_EraseRootFromParent_Done,
     /* 147313 */ // Label 1995: @147313
     /* 147313 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(147452), // Rule ID 4128 //
     /* 147318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147336 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147340 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147344 */   // MIs[1] Operand 1
     /* 147344 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 147349 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147351 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147351 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147354 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147358 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147363 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147367 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147373 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147376 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147380 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147385 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147390 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147393 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147397 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147402 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147419 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147450 */   GIR_RootConstrainSelectedInstOperands,
     /* 147451 */   // GIR_Coverage, 4128,
     /* 147451 */   GIR_EraseRootFromParent_Done,
     /* 147452 */ // Label 1996: @147452
     /* 147452 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(147591), // Rule ID 4160 //
     /* 147457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147479 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147483 */   // MIs[1] Operand 1
     /* 147483 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 147488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147490 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147490 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147493 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147497 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147502 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147506 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147512 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147515 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147519 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147524 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147529 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147532 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147536 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147541 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147558 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147565 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147570 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147589 */   GIR_RootConstrainSelectedInstOperands,
     /* 147590 */   // GIR_Coverage, 4160,
     /* 147590 */   GIR_EraseRootFromParent_Done,
     /* 147591 */ // Label 1997: @147591
     /* 147591 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(147730), // Rule ID 4192 //
     /* 147596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147606 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147610 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147614 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147618 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147622 */   // MIs[1] Operand 1
     /* 147622 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 147627 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147629 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147629 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147632 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147636 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147641 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147645 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147651 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147654 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147658 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147663 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147668 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147671 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147675 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147680 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147697 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 147704 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147709 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147728 */   GIR_RootConstrainSelectedInstOperands,
     /* 147729 */   // GIR_Coverage, 4192,
     /* 147729 */   GIR_EraseRootFromParent_Done,
     /* 147730 */ // Label 1998: @147730
     /* 147730 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(147869), // Rule ID 4224 //
     /* 147735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147745 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147749 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147753 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147757 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147761 */   // MIs[1] Operand 1
     /* 147761 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 147766 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147768 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147768 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147771 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147775 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147780 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147784 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147790 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147793 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147797 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147802 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147807 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147810 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147814 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147819 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147824 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147827 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147831 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147836 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 147843 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147867 */   GIR_RootConstrainSelectedInstOperands,
     /* 147868 */   // GIR_Coverage, 4224,
     /* 147868 */   GIR_EraseRootFromParent_Done,
     /* 147869 */ // Label 1999: @147869
     /* 147869 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(148008), // Rule ID 4254 //
     /* 147874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147884 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147892 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 147896 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 147900 */   // MIs[1] Operand 1
     /* 147900 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 147905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147907 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147907 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147910 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 147914 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147919 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147923 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147929 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147932 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147936 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147941 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147946 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147949 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147953 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147958 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147975 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148006 */   GIR_RootConstrainSelectedInstOperands,
     /* 148007 */   // GIR_Coverage, 4254,
     /* 148007 */   GIR_EraseRootFromParent_Done,
     /* 148008 */ // Label 2000: @148008
     /* 148008 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(148147), // Rule ID 4286 //
     /* 148013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148023 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148027 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148031 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148035 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148039 */   // MIs[1] Operand 1
     /* 148039 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 148044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148046 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148046 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148049 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148053 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148058 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148062 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148068 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148071 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148075 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148080 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148085 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148088 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148092 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148097 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148114 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148145 */   GIR_RootConstrainSelectedInstOperands,
     /* 148146 */   // GIR_Coverage, 4286,
     /* 148146 */   GIR_EraseRootFromParent_Done,
     /* 148147 */ // Label 2001: @148147
     /* 148147 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(148286), // Rule ID 4318 //
     /* 148152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148174 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148178 */   // MIs[1] Operand 1
     /* 148178 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 148183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148185 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148185 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148188 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148192 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148197 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148201 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148207 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148210 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148214 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148219 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148224 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148227 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148231 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148236 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148253 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 148260 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148278 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148284 */   GIR_RootConstrainSelectedInstOperands,
     /* 148285 */   // GIR_Coverage, 4318,
     /* 148285 */   GIR_EraseRootFromParent_Done,
     /* 148286 */ // Label 2002: @148286
     /* 148286 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(148425), // Rule ID 4350 //
     /* 148291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148301 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148305 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148309 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148313 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148317 */   // MIs[1] Operand 1
     /* 148317 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 148322 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148324 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148324 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148327 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148331 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148336 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148340 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148346 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148349 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148353 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148358 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148363 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148366 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148370 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148375 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148392 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 148399 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148404 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148423 */   GIR_RootConstrainSelectedInstOperands,
     /* 148424 */   // GIR_Coverage, 4350,
     /* 148424 */   GIR_EraseRootFromParent_Done,
     /* 148425 */ // Label 2003: @148425
     /* 148425 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(148564), // Rule ID 4581 //
     /* 148430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148440 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148448 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148452 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148456 */   // MIs[1] Operand 1
     /* 148456 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 148461 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148463 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 148470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148479 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148485 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148488 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148492 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148497 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148502 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148505 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148509 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148514 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148531 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148538 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148556 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148562 */   GIR_RootConstrainSelectedInstOperands,
     /* 148563 */   // GIR_Coverage, 4581,
     /* 148563 */   GIR_EraseRootFromParent_Done,
     /* 148564 */ // Label 2004: @148564
     /* 148564 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(148703), // Rule ID 4613 //
     /* 148569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148579 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148591 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148595 */   // MIs[1] Operand 1
     /* 148595 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 148600 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148602 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148602 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148605 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 148609 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148614 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148618 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148624 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148627 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148631 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148636 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148641 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148644 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148648 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148653 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148670 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148677 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148701 */   GIR_RootConstrainSelectedInstOperands,
     /* 148702 */   // GIR_Coverage, 4613,
     /* 148702 */   GIR_EraseRootFromParent_Done,
     /* 148703 */ // Label 2005: @148703
     /* 148703 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(148842), // Rule ID 4645 //
     /* 148708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148718 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148726 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148730 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148734 */   // MIs[1] Operand 1
     /* 148734 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 148739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148741 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148741 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148744 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 148748 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148753 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148757 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148763 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148766 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148770 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148775 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148780 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148783 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148787 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148792 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148809 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148816 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148821 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148831 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148840 */   GIR_RootConstrainSelectedInstOperands,
     /* 148841 */   // GIR_Coverage, 4645,
     /* 148841 */   GIR_EraseRootFromParent_Done,
     /* 148842 */ // Label 2006: @148842
     /* 148842 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(148981), // Rule ID 4689 //
     /* 148847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148865 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148869 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 148873 */   // MIs[1] Operand 1
     /* 148873 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 148878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148880 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148880 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148883 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 148887 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148892 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148896 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148902 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148905 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148909 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148914 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148919 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148922 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148926 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148931 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148948 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148955 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148960 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148979 */   GIR_RootConstrainSelectedInstOperands,
     /* 148980 */   // GIR_Coverage, 4689,
     /* 148980 */   GIR_EraseRootFromParent_Done,
     /* 148981 */ // Label 2007: @148981
     /* 148981 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(149120), // Rule ID 4721 //
     /* 148986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148996 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149000 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149004 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149008 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149012 */   // MIs[1] Operand 1
     /* 149012 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 149017 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149019 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149019 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149022 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 149026 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149031 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149035 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149041 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149044 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149048 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149053 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149058 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149061 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149065 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149070 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149087 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149094 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149099 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149118 */   GIR_RootConstrainSelectedInstOperands,
     /* 149119 */   // GIR_Coverage, 4721,
     /* 149119 */   GIR_EraseRootFromParent_Done,
     /* 149120 */ // Label 2008: @149120
     /* 149120 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(149259), // Rule ID 4753 //
     /* 149125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149143 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149147 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149151 */   // MIs[1] Operand 1
     /* 149151 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 149156 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149158 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 149165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149170 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149174 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149180 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149183 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149187 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149192 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149197 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149200 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149204 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149209 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149226 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149238 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149257 */   GIR_RootConstrainSelectedInstOperands,
     /* 149258 */   // GIR_Coverage, 4753,
     /* 149258 */   GIR_EraseRootFromParent_Done,
     /* 149259 */ // Label 2009: @149259
     /* 149259 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(149358), // Rule ID 2976 //
     /* 149264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149282 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149286 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149290 */   // MIs[1] Operand 1
     /* 149290 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 149295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149297 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 149297 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149300 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 149304 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149309 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149313 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149331 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149338 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149343 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149356 */   GIR_RootConstrainSelectedInstOperands,
     /* 149357 */   // GIR_Coverage, 2976,
     /* 149357 */   GIR_EraseRootFromParent_Done,
     /* 149358 */ // Label 2010: @149358
     /* 149358 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(149457), // Rule ID 2990 //
     /* 149363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149381 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149385 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149389 */   // MIs[1] Operand 1
     /* 149389 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 149394 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149396 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 149396 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149399 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149403 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149408 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149412 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149430 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149455 */   GIR_RootConstrainSelectedInstOperands,
     /* 149456 */   // GIR_Coverage, 2990,
     /* 149456 */   GIR_EraseRootFromParent_Done,
     /* 149457 */ // Label 2011: @149457
     /* 149457 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(149556), // Rule ID 2998 //
     /* 149462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149480 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149484 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149488 */   // MIs[1] Operand 1
     /* 149488 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 149493 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149495 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 149495 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149498 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 149502 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149507 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149511 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149529 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149536 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149541 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149554 */   GIR_RootConstrainSelectedInstOperands,
     /* 149555 */   // GIR_Coverage, 2998,
     /* 149555 */   GIR_EraseRootFromParent_Done,
     /* 149556 */ // Label 2012: @149556
     /* 149556 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(149655), // Rule ID 3006 //
     /* 149561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149579 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149583 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149587 */   // MIs[1] Operand 1
     /* 149587 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 149592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149594 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 149594 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149597 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149601 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149606 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149610 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149628 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149635 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149640 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149653 */   GIR_RootConstrainSelectedInstOperands,
     /* 149654 */   // GIR_Coverage, 3006,
     /* 149654 */   GIR_EraseRootFromParent_Done,
     /* 149655 */ // Label 2013: @149655
     /* 149655 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(149754), // Rule ID 3014 //
     /* 149660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149670 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149674 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149678 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149682 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149686 */   // MIs[1] Operand 1
     /* 149686 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 149691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149693 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 149693 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149696 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149700 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149705 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149709 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149727 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 149734 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149752 */   GIR_RootConstrainSelectedInstOperands,
     /* 149753 */   // GIR_Coverage, 3014,
     /* 149753 */   GIR_EraseRootFromParent_Done,
     /* 149754 */ // Label 2014: @149754
     /* 149754 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(149853), // Rule ID 3078 //
     /* 149759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149769 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149777 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149781 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149785 */   // MIs[1] Operand 1
     /* 149785 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 149790 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149792 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 149792 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149795 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 149799 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149804 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149808 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149826 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149851 */   GIR_RootConstrainSelectedInstOperands,
     /* 149852 */   // GIR_Coverage, 3078,
     /* 149852 */   GIR_EraseRootFromParent_Done,
     /* 149853 */ // Label 2015: @149853
     /* 149853 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(149952), // Rule ID 3086 //
     /* 149858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149880 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149884 */   // MIs[1] Operand 1
     /* 149884 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 149889 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149891 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 149891 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149894 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 149898 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149903 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149907 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149925 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149932 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149937 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149950 */   GIR_RootConstrainSelectedInstOperands,
     /* 149951 */   // GIR_Coverage, 3086,
     /* 149951 */   GIR_EraseRootFromParent_Done,
     /* 149952 */ // Label 2016: @149952
     /* 149952 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(150051), // Rule ID 3094 //
     /* 149957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149967 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149975 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149979 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149983 */   // MIs[1] Operand 1
     /* 149983 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 149988 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149990 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 149990 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149993 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 149997 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150002 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150006 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150024 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150036 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150049 */   GIR_RootConstrainSelectedInstOperands,
     /* 150050 */   // GIR_Coverage, 3094,
     /* 150050 */   GIR_EraseRootFromParent_Done,
     /* 150051 */ // Label 2017: @150051
     /* 150051 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(150150), // Rule ID 3102 //
     /* 150056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150066 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150070 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150074 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150078 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150082 */   // MIs[1] Operand 1
     /* 150082 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 150087 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150089 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 150089 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150092 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150096 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150101 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150105 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150123 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150130 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150148 */   GIR_RootConstrainSelectedInstOperands,
     /* 150149 */   // GIR_Coverage, 3102,
     /* 150149 */   GIR_EraseRootFromParent_Done,
     /* 150150 */ // Label 2018: @150150
     /* 150150 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(150249), // Rule ID 3110 //
     /* 150155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150173 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150177 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150181 */   // MIs[1] Operand 1
     /* 150181 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 150186 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150188 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 150188 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150191 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150195 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150200 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150204 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150222 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 150229 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150234 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150247 */   GIR_RootConstrainSelectedInstOperands,
     /* 150248 */   // GIR_Coverage, 3110,
     /* 150248 */   GIR_EraseRootFromParent_Done,
     /* 150249 */ // Label 2019: @150249
     /* 150249 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(150388), // Rule ID 3861 //
     /* 150254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150272 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150276 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150280 */   // MIs[1] Operand 1
     /* 150280 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 150285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150287 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150287 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150290 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 150294 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150299 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150303 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150309 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150312 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150316 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150321 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150326 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150329 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150333 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150338 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150355 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150367 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150386 */   GIR_RootConstrainSelectedInstOperands,
     /* 150387 */   // GIR_Coverage, 3861,
     /* 150387 */   GIR_EraseRootFromParent_Done,
     /* 150388 */ // Label 2020: @150388
     /* 150388 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(150527), // Rule ID 3869 //
     /* 150393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150403 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150407 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150411 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150415 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150419 */   // MIs[1] Operand 1
     /* 150419 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 150424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150426 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150426 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150429 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150433 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150438 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150442 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150448 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150451 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150455 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150460 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150465 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150468 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150472 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150477 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150494 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150501 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150506 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150525 */   GIR_RootConstrainSelectedInstOperands,
     /* 150526 */   // GIR_Coverage, 3869,
     /* 150526 */   GIR_EraseRootFromParent_Done,
     /* 150527 */ // Label 2021: @150527
     /* 150527 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(150666), // Rule ID 3877 //
     /* 150532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150550 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150554 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150558 */   // MIs[1] Operand 1
     /* 150558 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 150563 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150565 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150565 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150568 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 150572 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150577 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150581 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150587 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150590 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150594 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150599 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150604 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150607 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150611 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150616 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150633 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150640 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150645 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150661 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150664 */   GIR_RootConstrainSelectedInstOperands,
     /* 150665 */   // GIR_Coverage, 3877,
     /* 150665 */   GIR_EraseRootFromParent_Done,
     /* 150666 */ // Label 2022: @150666
     /* 150666 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(150805), // Rule ID 3885 //
     /* 150671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150689 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150693 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150697 */   // MIs[1] Operand 1
     /* 150697 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 150702 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150704 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150704 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150707 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150711 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150716 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150720 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150726 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150729 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150733 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150738 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150743 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150746 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150750 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150755 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150772 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150803 */   GIR_RootConstrainSelectedInstOperands,
     /* 150804 */   // GIR_Coverage, 3885,
     /* 150804 */   GIR_EraseRootFromParent_Done,
     /* 150805 */ // Label 2023: @150805
     /* 150805 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(150944), // Rule ID 3893 //
     /* 150810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150820 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150828 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150832 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150836 */   // MIs[1] Operand 1
     /* 150836 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 150841 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150843 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150843 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150846 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150850 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150855 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150859 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150865 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150868 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150872 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150877 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150882 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150885 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150889 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150894 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150911 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 150918 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150923 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150942 */   GIR_RootConstrainSelectedInstOperands,
     /* 150943 */   // GIR_Coverage, 3893,
     /* 150943 */   GIR_EraseRootFromParent_Done,
     /* 150944 */ // Label 2024: @150944
     /* 150944 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(151083), // Rule ID 3957 //
     /* 150949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150959 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150967 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150971 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150975 */   // MIs[1] Operand 1
     /* 150975 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 150980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150982 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150982 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150985 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 150989 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150994 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150998 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151004 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151007 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151011 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151016 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151021 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151024 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151028 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151033 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151050 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151062 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151081 */   GIR_RootConstrainSelectedInstOperands,
     /* 151082 */   // GIR_Coverage, 3957,
     /* 151082 */   GIR_EraseRootFromParent_Done,
     /* 151083 */ // Label 2025: @151083
     /* 151083 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(151222), // Rule ID 3965 //
     /* 151088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151098 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151106 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151110 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151114 */   // MIs[1] Operand 1
     /* 151114 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 151119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151121 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151121 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151124 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151128 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151133 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151137 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151143 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151146 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151150 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151155 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151160 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151163 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151167 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151172 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151189 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151196 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151201 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151220 */   GIR_RootConstrainSelectedInstOperands,
     /* 151221 */   // GIR_Coverage, 3965,
     /* 151221 */   GIR_EraseRootFromParent_Done,
     /* 151222 */ // Label 2026: @151222
     /* 151222 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(151361), // Rule ID 3973 //
     /* 151227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151237 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151241 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151245 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151249 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151253 */   // MIs[1] Operand 1
     /* 151253 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 151258 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151260 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151260 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151263 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 151267 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151272 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151276 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151282 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151285 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151289 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151294 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151299 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151302 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151306 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151311 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151328 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151335 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151340 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151359 */   GIR_RootConstrainSelectedInstOperands,
     /* 151360 */   // GIR_Coverage, 3973,
     /* 151360 */   GIR_EraseRootFromParent_Done,
     /* 151361 */ // Label 2027: @151361
     /* 151361 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(151500), // Rule ID 3981 //
     /* 151366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151384 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151388 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151392 */   // MIs[1] Operand 1
     /* 151392 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 151397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151399 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151399 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151402 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151406 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151411 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151415 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151421 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151424 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151428 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151433 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151438 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151441 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151445 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151450 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151467 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151474 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151479 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151498 */   GIR_RootConstrainSelectedInstOperands,
     /* 151499 */   // GIR_Coverage, 3981,
     /* 151499 */   GIR_EraseRootFromParent_Done,
     /* 151500 */ // Label 2028: @151500
     /* 151500 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(151639), // Rule ID 3989 //
     /* 151505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151523 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151527 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151531 */   // MIs[1] Operand 1
     /* 151531 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 151536 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151538 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151538 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151541 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151545 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151550 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151554 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151560 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151563 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151567 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151572 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151577 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151580 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151584 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151589 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151606 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151613 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151618 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151637 */   GIR_RootConstrainSelectedInstOperands,
     /* 151638 */   // GIR_Coverage, 3989,
     /* 151638 */   GIR_EraseRootFromParent_Done,
     /* 151639 */ // Label 2029: @151639
     /* 151639 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(151661), // Rule ID 2982 //
     /* 151644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 151647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151654 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 151654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 151659 */   GIR_RootConstrainSelectedInstOperands,
     /* 151660 */   // GIR_Coverage, 2982,
     /* 151660 */   GIR_Done,
     /* 151661 */ // Label 2030: @151661
     /* 151661 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(151722), // Rule ID 3667 //
     /* 151666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151673 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 151673 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 151676 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151680 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151685 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 151688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 151693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151702 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 151705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151712 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 151714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 151720 */   GIR_RootConstrainSelectedInstOperands,
     /* 151721 */   // GIR_Coverage, 3667,
     /* 151721 */   GIR_EraseRootFromParent_Done,
     /* 151722 */ // Label 2031: @151722
     /* 151722 */ GIM_Reject,
     /* 151723 */ // Label 1845: @151723
     /* 151723 */ GIM_Reject,
     /* 151724 */ // Label 27: @151724
     /* 151724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2039*/ GIMT_Encode4(152079),
     /* 151735 */ /*GILLT_s32*//*Label 2032*/ GIMT_Encode4(151763),
     /* 151739 */ /*GILLT_s64*//*Label 2033*/ GIMT_Encode4(151786),
     /* 151743 */ /*GILLT_s128*//*Label 2034*/ GIMT_Encode4(151809),
     /* 151747 */ /*GILLT_v2s64*//*Label 2035*/ GIMT_Encode4(151975),
     /* 151751 */ /*GILLT_v4s32*//*Label 2036*/ GIMT_Encode4(152001),
     /* 151755 */ /*GILLT_v8s16*//*Label 2037*/ GIMT_Encode4(152027),
     /* 151759 */ /*GILLT_v16s8*//*Label 2038*/ GIMT_Encode4(152053),
     /* 151763 */ // Label 2032: @151763
     /* 151763 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(151785), // Rule ID 1251 //
     /* 151768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 151771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 151778 */   // (shl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 151778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLW),
     /* 151783 */   GIR_RootConstrainSelectedInstOperands,
     /* 151784 */   // GIR_Coverage, 1251,
     /* 151784 */   GIR_Done,
     /* 151785 */ // Label 2040: @151785
     /* 151785 */ GIM_Reject,
     /* 151786 */ // Label 2033: @151786
     /* 151786 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(151808), // Rule ID 1532 //
     /* 151791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 151794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151801 */   // (shl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 151801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLD),
     /* 151806 */   GIR_RootConstrainSelectedInstOperands,
     /* 151807 */   // GIR_Coverage, 1532,
     /* 151807 */   GIR_Done,
     /* 151808 */ // Label 2041: @151808
     /* 151808 */ GIM_Reject,
     /* 151809 */ // Label 2034: @151809
     /* 151809 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(151974),
     /* 151814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 151817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 151820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 151824 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(151909), // Rule ID 3369 //
     /* 151829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 151832 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 151832 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 151835 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151839 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151844 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 151848 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 151853 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 151856 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151860 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151865 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 151869 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 151874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 151877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 151881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 151895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLQ),
     /* 151900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 151902 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 151904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151907 */     GIR_RootConstrainSelectedInstOperands,
     /* 151908 */     // GIR_Coverage, 3369,
     /* 151908 */     GIR_EraseRootFromParent_Done,
     /* 151909 */   // Label 2043: @151909
     /* 151909 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(151973), // Rule ID 1390 //
     /* 151914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 151917 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSL:{ *:[v1i128] } (VSLO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 151917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 151924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151929 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 151932 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 151936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /* 151945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 151954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 151958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /* 151963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 151965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 151971 */     GIR_RootConstrainSelectedInstOperands,
     /* 151972 */     // GIR_Coverage, 1390,
     /* 151972 */     GIR_EraseRootFromParent_Done,
     /* 151973 */   // Label 2044: @151973
     /* 151973 */   GIM_Reject,
     /* 151974 */ // Label 2042: @151974
     /* 151974 */ GIM_Reject,
     /* 151975 */ // Label 2035: @151975
     /* 151975 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(152000), // Rule ID 1438 //
     /* 151980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 151983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 151986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 151993 */   // (shl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSLD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 151993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLD),
     /* 151998 */   GIR_RootConstrainSelectedInstOperands,
     /* 151999 */   // GIR_Coverage, 1438,
     /* 151999 */   GIR_Done,
     /* 152000 */ // Label 2045: @152000
     /* 152000 */ GIM_Reject,
     /* 152001 */ // Label 2036: @152001
     /* 152001 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(152026), // Rule ID 1389 //
     /* 152006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152019 */   // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSLW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 152024 */   GIR_RootConstrainSelectedInstOperands,
     /* 152025 */   // GIR_Coverage, 1389,
     /* 152025 */   GIR_Done,
     /* 152026 */ // Label 2046: @152026
     /* 152026 */ GIM_Reject,
     /* 152027 */ // Label 2037: @152027
     /* 152027 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(152052), // Rule ID 1388 //
     /* 152032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152045 */   // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSLH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /* 152050 */   GIR_RootConstrainSelectedInstOperands,
     /* 152051 */   // GIR_Coverage, 1388,
     /* 152051 */   GIR_Done,
     /* 152052 */ // Label 2047: @152052
     /* 152052 */ GIM_Reject,
     /* 152053 */ // Label 2038: @152053
     /* 152053 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(152078), // Rule ID 1387 //
     /* 152058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152071 */   // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSLB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /* 152076 */   GIR_RootConstrainSelectedInstOperands,
     /* 152077 */   // GIR_Coverage, 1387,
     /* 152077 */   GIR_Done,
     /* 152078 */ // Label 2048: @152078
     /* 152078 */ GIM_Reject,
     /* 152079 */ // Label 2039: @152079
     /* 152079 */ GIM_Reject,
     /* 152080 */ // Label 28: @152080
     /* 152080 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2056*/ GIMT_Encode4(152501),
     /* 152091 */ /*GILLT_s32*//*Label 2049*/ GIMT_Encode4(152119),
     /* 152095 */ /*GILLT_s64*//*Label 2050*/ GIMT_Encode4(152208),
     /* 152099 */ /*GILLT_s128*//*Label 2051*/ GIMT_Encode4(152231),
     /* 152103 */ /*GILLT_v2s64*//*Label 2052*/ GIMT_Encode4(152397),
     /* 152107 */ /*GILLT_v4s32*//*Label 2053*/ GIMT_Encode4(152423),
     /* 152111 */ /*GILLT_v8s16*//*Label 2054*/ GIMT_Encode4(152449),
     /* 152115 */ /*GILLT_v16s8*//*Label 2055*/ GIMT_Encode4(152475),
     /* 152119 */ // Label 2049: @152119
     /* 152119 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(152207),
     /* 152124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152134 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(152194), // Rule ID 3349 //
     /* 152139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 152142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 152150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 152158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152160 */     // (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] })  =>  (RLDICL_32:{ *:[i32] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 152160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 152167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // RS
     /* 152176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 152181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 152192 */     GIR_RootConstrainSelectedInstOperands,
     /* 152193 */     // GIR_Coverage, 3349,
     /* 152193 */     GIR_EraseRootFromParent_Done,
     /* 152194 */   // Label 2058: @152194
     /* 152194 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(152206), // Rule ID 1250 //
     /* 152199 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRW),
     /* 152204 */     GIR_RootConstrainSelectedInstOperands,
     /* 152205 */     // GIR_Coverage, 1250,
     /* 152205 */     GIR_Done,
     /* 152206 */   // Label 2059: @152206
     /* 152206 */   GIM_Reject,
     /* 152207 */ // Label 2057: @152207
     /* 152207 */ GIM_Reject,
     /* 152208 */ // Label 2050: @152208
     /* 152208 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(152230), // Rule ID 1531 //
     /* 152213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152223 */   // (srl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRD),
     /* 152228 */   GIR_RootConstrainSelectedInstOperands,
     /* 152229 */   // GIR_Coverage, 1531,
     /* 152229 */   GIR_Done,
     /* 152230 */ // Label 2060: @152230
     /* 152230 */ GIM_Reject,
     /* 152231 */ // Label 2051: @152231
     /* 152231 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(152396),
     /* 152236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 152239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 152242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152246 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(152331), // Rule ID 3371 //
     /* 152251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 152254 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 152254 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 152257 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152261 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152266 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152270 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152275 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 152278 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152282 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152287 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 152299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 152303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152308 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 152317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRQ),
     /* 152322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152324 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 152326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152329 */     GIR_RootConstrainSelectedInstOperands,
     /* 152330 */     // GIR_Coverage, 3371,
     /* 152330 */     GIR_EraseRootFromParent_Done,
     /* 152331 */   // Label 2062: @152331
     /* 152331 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(152395), // Rule ID 1398 //
     /* 152336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152339 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSR:{ *:[v1i128] } (VSRO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 152339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 152346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152351 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 152354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /* 152367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 152376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /* 152385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 152393 */     GIR_RootConstrainSelectedInstOperands,
     /* 152394 */     // GIR_Coverage, 1398,
     /* 152394 */     GIR_EraseRootFromParent_Done,
     /* 152395 */   // Label 2063: @152395
     /* 152395 */   GIM_Reject,
     /* 152396 */ // Label 2061: @152396
     /* 152396 */ GIM_Reject,
     /* 152397 */ // Label 2052: @152397
     /* 152397 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(152422), // Rule ID 1440 //
     /* 152402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 152405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152415 */   // (srl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 152415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRD),
     /* 152420 */   GIR_RootConstrainSelectedInstOperands,
     /* 152421 */   // GIR_Coverage, 1440,
     /* 152421 */   GIR_Done,
     /* 152422 */ // Label 2064: @152422
     /* 152422 */ GIM_Reject,
     /* 152423 */ // Label 2053: @152423
     /* 152423 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(152448), // Rule ID 1397 //
     /* 152428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152441 */   // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /* 152446 */   GIR_RootConstrainSelectedInstOperands,
     /* 152447 */   // GIR_Coverage, 1397,
     /* 152447 */   GIR_Done,
     /* 152448 */ // Label 2065: @152448
     /* 152448 */ GIM_Reject,
     /* 152449 */ // Label 2054: @152449
     /* 152449 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(152474), // Rule ID 1396 //
     /* 152454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152467 */   // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /* 152472 */   GIR_RootConstrainSelectedInstOperands,
     /* 152473 */   // GIR_Coverage, 1396,
     /* 152473 */   GIR_Done,
     /* 152474 */ // Label 2066: @152474
     /* 152474 */ GIM_Reject,
     /* 152475 */ // Label 2055: @152475
     /* 152475 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(152500), // Rule ID 1395 //
     /* 152480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152493 */   // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /* 152498 */   GIR_RootConstrainSelectedInstOperands,
     /* 152499 */   // GIR_Coverage, 1395,
     /* 152499 */   GIR_Done,
     /* 152500 */ // Label 2067: @152500
     /* 152500 */ GIM_Reject,
     /* 152501 */ // Label 2056: @152501
     /* 152501 */ GIM_Reject,
     /* 152502 */ // Label 29: @152502
     /* 152502 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2075*/ GIMT_Encode4(152871),
     /* 152513 */ /*GILLT_s32*//*Label 2068*/ GIMT_Encode4(152541),
     /* 152517 */ /*GILLT_s64*//*Label 2069*/ GIMT_Encode4(152606),
     /* 152521 */ /*GILLT_s128*//*Label 2070*/ GIMT_Encode4(152671),
     /* 152525 */ /*GILLT_v2s64*//*Label 2071*/ GIMT_Encode4(152767),
     /* 152529 */ /*GILLT_v4s32*//*Label 2072*/ GIMT_Encode4(152793),
     /* 152533 */ /*GILLT_v8s16*//*Label 2073*/ GIMT_Encode4(152819),
     /* 152537 */ /*GILLT_v16s8*//*Label 2074*/ GIMT_Encode4(152845),
     /* 152541 */ // Label 2068: @152541
     /* 152541 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(152605),
     /* 152546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152556 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(152586), // Rule ID 132 //
     /* 152561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152569 */     // MIs[1] Operand 1
     /* 152569 */     // No operand predicates
     /* 152569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152571 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)  =>  (SRAWI:{ *:[i32] }:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)
     /* 152571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRAWI),
     /* 152574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152576 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 152578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RB
     /* 152581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 152584 */     GIR_RootConstrainSelectedInstOperands,
     /* 152585 */     // GIR_Coverage, 132,
     /* 152585 */     GIR_EraseRootFromParent_Done,
     /* 152586 */   // Label 2077: @152586
     /* 152586 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(152604), // Rule ID 1249 //
     /* 152591 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAW:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAW),
     /* 152596 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 152602 */     GIR_RootConstrainSelectedInstOperands,
     /* 152603 */     // GIR_Coverage, 1249,
     /* 152603 */     GIR_Done,
     /* 152604 */   // Label 2078: @152604
     /* 152604 */   GIM_Reject,
     /* 152605 */ // Label 2076: @152605
     /* 152605 */ GIM_Reject,
     /* 152606 */ // Label 2069: @152606
     /* 152606 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(152670),
     /* 152611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152621 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(152651), // Rule ID 681 //
     /* 152626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152634 */     // MIs[1] Operand 1
     /* 152634 */     // No operand predicates
     /* 152634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152636 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)  =>  (SRADI:{ *:[i64] }:{ *:[i32] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)
     /* 152636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRADI),
     /* 152639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152641 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /* 152643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SH
     /* 152646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 152649 */     GIR_RootConstrainSelectedInstOperands,
     /* 152650 */     // GIR_Coverage, 681,
     /* 152650 */     GIR_EraseRootFromParent_Done,
     /* 152651 */   // Label 2080: @152651
     /* 152651 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(152669), // Rule ID 1530 //
     /* 152656 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAD:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAD),
     /* 152661 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 152667 */     GIR_RootConstrainSelectedInstOperands,
     /* 152668 */     // GIR_Coverage, 1530,
     /* 152668 */     GIR_Done,
     /* 152669 */   // Label 2081: @152669
     /* 152669 */   GIM_Reject,
     /* 152670 */ // Label 2079: @152670
     /* 152670 */ GIM_Reject,
     /* 152671 */ // Label 2070: @152671
     /* 152671 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(152766), // Rule ID 3373 //
     /* 152676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 152679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 152682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 152685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152689 */   // (sra:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRAQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 152689 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 152692 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152696 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152701 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152705 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152710 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 152713 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152717 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152722 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152726 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 152734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 152738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152743 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152746 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152749 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 152752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAQ),
     /* 152757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152759 */   GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 152761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152764 */   GIR_RootConstrainSelectedInstOperands,
     /* 152765 */   // GIR_Coverage, 3373,
     /* 152765 */   GIR_EraseRootFromParent_Done,
     /* 152766 */ // Label 2082: @152766
     /* 152766 */ GIM_Reject,
     /* 152767 */ // Label 2071: @152767
     /* 152767 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(152792), // Rule ID 1442 //
     /* 152772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 152775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152785 */   // (sra:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRAD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 152785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAD),
     /* 152790 */   GIR_RootConstrainSelectedInstOperands,
     /* 152791 */   // GIR_Coverage, 1442,
     /* 152791 */   GIR_Done,
     /* 152792 */ // Label 2083: @152792
     /* 152792 */ GIM_Reject,
     /* 152793 */ // Label 2072: @152793
     /* 152793 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(152818), // Rule ID 1405 //
     /* 152798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152811 */   // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRAW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /* 152816 */   GIR_RootConstrainSelectedInstOperands,
     /* 152817 */   // GIR_Coverage, 1405,
     /* 152817 */   GIR_Done,
     /* 152818 */ // Label 2084: @152818
     /* 152818 */ GIM_Reject,
     /* 152819 */ // Label 2073: @152819
     /* 152819 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(152844), // Rule ID 1404 //
     /* 152824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152837 */   // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRAH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /* 152842 */   GIR_RootConstrainSelectedInstOperands,
     /* 152843 */   // GIR_Coverage, 1404,
     /* 152843 */   GIR_Done,
     /* 152844 */ // Label 2085: @152844
     /* 152844 */ GIM_Reject,
     /* 152845 */ // Label 2074: @152845
     /* 152845 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(152870), // Rule ID 1403 //
     /* 152850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152863 */   // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRAB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /* 152868 */   GIR_RootConstrainSelectedInstOperands,
     /* 152869 */   // GIR_Coverage, 1403,
     /* 152869 */   GIR_Done,
     /* 152870 */ // Label 2086: @152870
     /* 152870 */ GIM_Reject,
     /* 152871 */ // Label 2075: @152871
     /* 152871 */ GIM_Reject,
     /* 152872 */ // Label 30: @152872
     /* 152872 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2094*/ GIMT_Encode4(153179),
     /* 152883 */ /*GILLT_s32*//*Label 2087*/ GIMT_Encode4(152911),
     /* 152887 */ /*GILLT_s64*//*Label 2088*/ GIMT_Encode4(152983),
     /* 152891 */ /*GILLT_s128*//*Label 2089*/ GIMT_Encode4(153049),
     /* 152895 */ /*GILLT_v2s64*//*Label 2090*/ GIMT_Encode4(153075),
     /* 152899 */ /*GILLT_v4s32*//*Label 2091*/ GIMT_Encode4(153101),
     /* 152903 */ /*GILLT_v8s16*//*Label 2092*/ GIMT_Encode4(153127),
     /* 152907 */ /*GILLT_v16s8*//*Label 2093*/ GIMT_Encode4(153153),
     /* 152911 */ // Label 2087: @152911
     /* 152911 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(152982),
     /* 152916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152926 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(152959), // Rule ID 1215 //
     /* 152931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152939 */     // MIs[1] Operand 1
     /* 152939 */     // No operand predicates
     /* 152939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152941 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 152941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 152944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152946 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 152948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 152951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 152957 */     GIR_RootConstrainSelectedInstOperands,
     /* 152958 */     // GIR_Coverage, 1215,
     /* 152958 */     GIR_EraseRootFromParent_Done,
     /* 152959 */   // Label 2096: @152959
     /* 152959 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(152981), // Rule ID 1214 //
     /* 152964 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 152964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 152967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152969 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 152971 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 152973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 152979 */     GIR_RootConstrainSelectedInstOperands,
     /* 152980 */     // GIR_Coverage, 1214,
     /* 152980 */     GIR_EraseRootFromParent_Done,
     /* 152981 */   // Label 2097: @152981
     /* 152981 */   GIM_Reject,
     /* 152982 */ // Label 2095: @152982
     /* 152982 */ GIM_Reject,
     /* 152983 */ // Label 2088: @152983
     /* 152983 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(153048),
     /* 152988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152998 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(153028), // Rule ID 1537 //
     /* 153003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153011 */     // MIs[1] Operand 1
     /* 153011 */     // No operand predicates
     /* 153011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153013 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] })
     /* 153013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 153016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153018 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 153023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153026 */     GIR_RootConstrainSelectedInstOperands,
     /* 153027 */     // GIR_Coverage, 1537,
     /* 153027 */     GIR_EraseRootFromParent_Done,
     /* 153028 */   // Label 2099: @153028
     /* 153028 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(153047), // Rule ID 1536 //
     /* 153033 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] })
     /* 153033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 153036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153038 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153040 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 153042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153045 */     GIR_RootConstrainSelectedInstOperands,
     /* 153046 */     // GIR_Coverage, 1536,
     /* 153046 */     GIR_EraseRootFromParent_Done,
     /* 153047 */   // Label 2100: @153047
     /* 153047 */   GIM_Reject,
     /* 153048 */ // Label 2098: @153048
     /* 153048 */ GIM_Reject,
     /* 153049 */ // Label 2089: @153049
     /* 153049 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(153074), // Rule ID 3355 //
     /* 153054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 153060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 153063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153067 */   // (rotl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VRLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)
     /* 153067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLQ),
     /* 153072 */   GIR_RootConstrainSelectedInstOperands,
     /* 153073 */   // GIR_Coverage, 3355,
     /* 153073 */   GIR_Done,
     /* 153074 */ // Label 2101: @153074
     /* 153074 */ GIM_Reject,
     /* 153075 */ // Label 2090: @153075
     /* 153075 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(153100), // Rule ID 1437 //
     /* 153080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 153083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153093 */   // (rotl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)
     /* 153093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /* 153098 */   GIR_RootConstrainSelectedInstOperands,
     /* 153099 */   // GIR_Coverage, 1437,
     /* 153099 */   GIR_Done,
     /* 153100 */ // Label 2102: @153100
     /* 153100 */ GIM_Reject,
     /* 153101 */ // Label 2091: @153101
     /* 153101 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(153126), // Rule ID 1288 //
     /* 153106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153119 */   // (rotl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)
     /* 153119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /* 153124 */   GIR_RootConstrainSelectedInstOperands,
     /* 153125 */   // GIR_Coverage, 1288,
     /* 153125 */   GIR_Done,
     /* 153126 */ // Label 2103: @153126
     /* 153126 */ GIM_Reject,
     /* 153127 */ // Label 2092: @153127
     /* 153127 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(153152), // Rule ID 1287 //
     /* 153132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153145 */   // (rotl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)
     /* 153145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /* 153150 */   GIR_RootConstrainSelectedInstOperands,
     /* 153151 */   // GIR_Coverage, 1287,
     /* 153151 */   GIR_Done,
     /* 153152 */ // Label 2104: @153152
     /* 153152 */ GIM_Reject,
     /* 153153 */ // Label 2093: @153153
     /* 153153 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(153178), // Rule ID 1286 //
     /* 153158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 153164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 153167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153171 */   // (rotl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)
     /* 153171 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /* 153176 */   GIR_RootConstrainSelectedInstOperands,
     /* 153177 */   // GIR_Coverage, 1286,
     /* 153177 */   GIR_Done,
     /* 153178 */ // Label 2105: @153178
     /* 153178 */ GIM_Reject,
     /* 153179 */ // Label 2094: @153179
     /* 153179 */ GIM_Reject,
     /* 153180 */ // Label 31: @153180
     /* 153180 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(157181),
     /* 153185 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 153188 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2109*/ GIMT_Encode4(153757),
     /* 153199 */   /*GILLT_s32*//*Label 2107*/ GIMT_Encode4(153207),
     /* 153203 */   /*GILLT_s64*//*Label 2108*/ GIMT_Encode4(153482),
     /* 153207 */   // Label 2107: @153207
     /* 153207 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(153481),
     /* 153212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153219 */     GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(153306), // Rule ID 3027 //
     /* 153224 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153227 */       // MIs[0] Operand 1
     /* 153227 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 153232 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153236 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153240 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153244 */       // MIs[1] Operand 1
     /* 153244 */       // No operand predicates
     /* 153244 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153246 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 153246 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153249 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153253 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153258 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153262 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153265 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153267 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153270 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153274 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153279 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153286 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153291 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153296 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153299 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153301 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153304 */       GIR_RootConstrainSelectedInstOperands,
     /* 153305 */       // GIR_Coverage, 3027,
     /* 153305 */       GIR_EraseRootFromParent_Done,
     /* 153306 */     // Label 2111: @153306
     /* 153306 */     GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(153393), // Rule ID 3043 //
     /* 153311 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153314 */       // MIs[0] Operand 1
     /* 153314 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 153319 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153323 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153327 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153331 */       // MIs[1] Operand 1
     /* 153331 */       // No operand predicates
     /* 153331 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153333 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 153333 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153336 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153340 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153345 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153349 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153352 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153354 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153357 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153361 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153366 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153373 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153378 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153383 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153386 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153388 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153391 */       GIR_RootConstrainSelectedInstOperands,
     /* 153392 */       // GIR_Coverage, 3043,
     /* 153392 */       GIR_EraseRootFromParent_Done,
     /* 153393 */     // Label 2112: @153393
     /* 153393 */     GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(153480), // Rule ID 3051 //
     /* 153398 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153401 */       // MIs[0] Operand 1
     /* 153401 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 153406 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153410 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153414 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153418 */       // MIs[1] Operand 1
     /* 153418 */       // No operand predicates
     /* 153418 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153420 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 153420 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153423 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153427 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153432 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153436 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153439 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153441 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153444 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153448 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153453 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153460 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153465 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153470 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153473 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153475 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153478 */       GIR_RootConstrainSelectedInstOperands,
     /* 153479 */       // GIR_Coverage, 3051,
     /* 153479 */       GIR_EraseRootFromParent_Done,
     /* 153480 */     // Label 2113: @153480
     /* 153480 */     GIM_Reject,
     /* 153481 */   // Label 2110: @153481
     /* 153481 */   GIM_Reject,
     /* 153482 */   // Label 2108: @153482
     /* 153482 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(153756),
     /* 153487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153494 */     GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(153581), // Rule ID 3123 //
     /* 153499 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153502 */       // MIs[0] Operand 1
     /* 153502 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 153507 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153511 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153515 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153519 */       // MIs[1] Operand 1
     /* 153519 */       // No operand predicates
     /* 153519 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153521 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 153521 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153524 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153528 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153533 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153537 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153540 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153542 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153545 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153549 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153554 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153561 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153566 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153571 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153574 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153576 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153579 */       GIR_RootConstrainSelectedInstOperands,
     /* 153580 */       // GIR_Coverage, 3123,
     /* 153580 */       GIR_EraseRootFromParent_Done,
     /* 153581 */     // Label 2115: @153581
     /* 153581 */     GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(153668), // Rule ID 3139 //
     /* 153586 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153589 */       // MIs[0] Operand 1
     /* 153589 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 153594 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153598 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153602 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153606 */       // MIs[1] Operand 1
     /* 153606 */       // No operand predicates
     /* 153606 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153608 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 153608 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153611 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153615 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153620 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153624 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153627 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153629 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153632 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153636 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153641 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153658 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153661 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153663 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153666 */       GIR_RootConstrainSelectedInstOperands,
     /* 153667 */       // GIR_Coverage, 3139,
     /* 153667 */       GIR_EraseRootFromParent_Done,
     /* 153668 */     // Label 2116: @153668
     /* 153668 */     GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(153755), // Rule ID 3147 //
     /* 153673 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153676 */       // MIs[0] Operand 1
     /* 153676 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 153681 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153685 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153689 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153693 */       // MIs[1] Operand 1
     /* 153693 */       // No operand predicates
     /* 153693 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153695 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 153695 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153698 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153702 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153707 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153711 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153714 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153716 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153719 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153723 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153728 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153735 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153740 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153745 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153748 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153750 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153753 */       GIR_RootConstrainSelectedInstOperands,
     /* 153754 */       // GIR_Coverage, 3147,
     /* 153754 */       GIR_EraseRootFromParent_Done,
     /* 153755 */     // Label 2117: @153755
     /* 153755 */     GIM_Reject,
     /* 153756 */   // Label 2114: @153756
     /* 153756 */   GIM_Reject,
     /* 153757 */   // Label 2109: @153757
     /* 153757 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2120*/ GIMT_Encode4(154212),
     /* 153768 */   /*GILLT_s32*//*Label 2118*/ GIMT_Encode4(153776),
     /* 153772 */   /*GILLT_s64*//*Label 2119*/ GIMT_Encode4(153994),
     /* 153776 */   // Label 2118: @153776
     /* 153776 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(153993),
     /* 153781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153788 */     GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(153856), // Rule ID 3786 //
     /* 153793 */       // MIs[0] Operand 1
     /* 153793 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 153798 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153802 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153806 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153810 */       // MIs[1] Operand 1
     /* 153810 */       // No operand predicates
     /* 153810 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153812 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /* 153812 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153815 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153819 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153824 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153828 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 153831 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153833 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153836 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153838 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153845 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153850 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153855 */       // GIR_Coverage, 3786,
     /* 153855 */       GIR_EraseRootFromParent_Done,
     /* 153856 */     // Label 2122: @153856
     /* 153856 */     GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(153924), // Rule ID 3788 //
     /* 153861 */       // MIs[0] Operand 1
     /* 153861 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 153866 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153870 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153874 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153878 */       // MIs[1] Operand 1
     /* 153878 */       // No operand predicates
     /* 153878 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153880 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /* 153880 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153883 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153887 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153892 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153896 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 153899 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153901 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153904 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153906 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153913 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153918 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153923 */       // GIR_Coverage, 3788,
     /* 153923 */       GIR_EraseRootFromParent_Done,
     /* 153924 */     // Label 2123: @153924
     /* 153924 */     GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(153992), // Rule ID 3789 //
     /* 153929 */       // MIs[0] Operand 1
     /* 153929 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 153934 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153938 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153942 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153946 */       // MIs[1] Operand 1
     /* 153946 */       // No operand predicates
     /* 153946 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153948 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /* 153948 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153951 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153955 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153960 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153964 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 153967 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153969 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153972 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153974 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153981 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153986 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153991 */       // GIR_Coverage, 3789,
     /* 153991 */       GIR_EraseRootFromParent_Done,
     /* 153992 */     // Label 2124: @153992
     /* 153992 */     GIM_Reject,
     /* 153993 */   // Label 2121: @153993
     /* 153993 */   GIM_Reject,
     /* 153994 */   // Label 2119: @153994
     /* 153994 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(154211),
     /* 153999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154006 */     GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(154074), // Rule ID 3798 //
     /* 154011 */       // MIs[0] Operand 1
     /* 154011 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 154016 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154020 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154024 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154028 */       // MIs[1] Operand 1
     /* 154028 */       // No operand predicates
     /* 154028 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154030 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /* 154030 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154033 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154037 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154042 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154046 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154049 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154051 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154054 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154056 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154063 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154068 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154073 */       // GIR_Coverage, 3798,
     /* 154073 */       GIR_EraseRootFromParent_Done,
     /* 154074 */     // Label 2126: @154074
     /* 154074 */     GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(154142), // Rule ID 3800 //
     /* 154079 */       // MIs[0] Operand 1
     /* 154079 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 154084 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154088 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154092 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154096 */       // MIs[1] Operand 1
     /* 154096 */       // No operand predicates
     /* 154096 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154098 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /* 154098 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154101 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154105 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154110 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154114 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154117 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154119 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154122 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154124 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154131 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154136 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154141 */       // GIR_Coverage, 3800,
     /* 154141 */       GIR_EraseRootFromParent_Done,
     /* 154142 */     // Label 2127: @154142
     /* 154142 */     GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(154210), // Rule ID 3801 //
     /* 154147 */       // MIs[0] Operand 1
     /* 154147 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 154152 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154156 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154160 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154164 */       // MIs[1] Operand 1
     /* 154164 */       // No operand predicates
     /* 154164 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154166 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /* 154166 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154169 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154173 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154178 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154182 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154185 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154187 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154190 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154192 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154199 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154204 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154209 */       // GIR_Coverage, 3801,
     /* 154209 */       GIR_EraseRootFromParent_Done,
     /* 154210 */     // Label 2128: @154210
     /* 154210 */     GIM_Reject,
     /* 154211 */   // Label 2125: @154211
     /* 154211 */   GIM_Reject,
     /* 154212 */   // Label 2120: @154212
     /* 154212 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2131*/ GIMT_Encode4(154781),
     /* 154223 */   /*GILLT_s32*//*Label 2129*/ GIMT_Encode4(154231),
     /* 154227 */   /*GILLT_s64*//*Label 2130*/ GIMT_Encode4(154506),
     /* 154231 */   // Label 2129: @154231
     /* 154231 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(154505),
     /* 154236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154243 */     GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(154330), // Rule ID 3809 //
     /* 154248 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154251 */       // MIs[0] Operand 1
     /* 154251 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154256 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154260 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154264 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154268 */       // MIs[1] Operand 1
     /* 154268 */       // No operand predicates
     /* 154268 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154270 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 154270 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154273 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154277 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154282 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154286 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154289 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154291 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154294 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154298 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154303 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154310 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154320 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154323 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154325 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154328 */       GIR_RootConstrainSelectedInstOperands,
     /* 154329 */       // GIR_Coverage, 3809,
     /* 154329 */       GIR_EraseRootFromParent_Done,
     /* 154330 */     // Label 2133: @154330
     /* 154330 */     GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(154417), // Rule ID 3825 //
     /* 154335 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154338 */       // MIs[0] Operand 1
     /* 154338 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154343 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154347 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154351 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154355 */       // MIs[1] Operand 1
     /* 154355 */       // No operand predicates
     /* 154355 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154357 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 154357 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154360 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154364 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154369 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154373 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154376 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154378 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154381 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154385 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154390 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154397 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154402 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154407 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154410 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154412 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154415 */       GIR_RootConstrainSelectedInstOperands,
     /* 154416 */       // GIR_Coverage, 3825,
     /* 154416 */       GIR_EraseRootFromParent_Done,
     /* 154417 */     // Label 2134: @154417
     /* 154417 */     GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(154504), // Rule ID 3833 //
     /* 154422 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154425 */       // MIs[0] Operand 1
     /* 154425 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 154430 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154434 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154438 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154442 */       // MIs[1] Operand 1
     /* 154442 */       // No operand predicates
     /* 154442 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154444 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 154444 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154447 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154451 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154456 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154460 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154463 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154465 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154468 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154472 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154477 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154484 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154489 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154494 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154497 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154499 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154502 */       GIR_RootConstrainSelectedInstOperands,
     /* 154503 */       // GIR_Coverage, 3833,
     /* 154503 */       GIR_EraseRootFromParent_Done,
     /* 154504 */     // Label 2135: @154504
     /* 154504 */     GIM_Reject,
     /* 154505 */   // Label 2132: @154505
     /* 154505 */   GIM_Reject,
     /* 154506 */   // Label 2130: @154506
     /* 154506 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(154780),
     /* 154511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154518 */     GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(154605), // Rule ID 3905 //
     /* 154523 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154526 */       // MIs[0] Operand 1
     /* 154526 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154531 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154535 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154539 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154543 */       // MIs[1] Operand 1
     /* 154543 */       // No operand predicates
     /* 154543 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154545 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 154545 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154548 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154552 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154557 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154561 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154564 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154566 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154569 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154573 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154578 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154585 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154590 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154595 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154598 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154600 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154603 */       GIR_RootConstrainSelectedInstOperands,
     /* 154604 */       // GIR_Coverage, 3905,
     /* 154604 */       GIR_EraseRootFromParent_Done,
     /* 154605 */     // Label 2137: @154605
     /* 154605 */     GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(154692), // Rule ID 3921 //
     /* 154610 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154613 */       // MIs[0] Operand 1
     /* 154613 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154618 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154622 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154626 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154630 */       // MIs[1] Operand 1
     /* 154630 */       // No operand predicates
     /* 154630 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154632 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 154632 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154635 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154639 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154644 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154648 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154651 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154653 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154656 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154660 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154665 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154672 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154677 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154682 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154685 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154687 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154690 */       GIR_RootConstrainSelectedInstOperands,
     /* 154691 */       // GIR_Coverage, 3921,
     /* 154691 */       GIR_EraseRootFromParent_Done,
     /* 154692 */     // Label 2138: @154692
     /* 154692 */     GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(154779), // Rule ID 3929 //
     /* 154697 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154700 */       // MIs[0] Operand 1
     /* 154700 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 154705 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154709 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154713 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154717 */       // MIs[1] Operand 1
     /* 154717 */       // No operand predicates
     /* 154717 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154719 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 154719 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154722 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154726 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154731 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154735 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154738 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154740 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154743 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154747 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154752 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154759 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154764 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154777 */       GIR_RootConstrainSelectedInstOperands,
     /* 154778 */       // GIR_Coverage, 3929,
     /* 154778 */       GIR_EraseRootFromParent_Done,
     /* 154779 */     // Label 2139: @154779
     /* 154779 */     GIM_Reject,
     /* 154780 */   // Label 2136: @154780
     /* 154780 */   GIM_Reject,
     /* 154781 */   // Label 2131: @154781
     /* 154781 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2143*/ GIMT_Encode4(155796),
     /* 154792 */   /*GILLT_s1*//*Label 2140*/ GIMT_Encode4(154804),
     /* 154796 */   /*GILLT_s32*//*Label 2141*/ GIMT_Encode4(155028),
     /* 154800 */   /*GILLT_s64*//*Label 2142*/ GIMT_Encode4(155412),
     /* 154804 */   // Label 2140: @154804
     /* 154804 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(155027),
     /* 154809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 154812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154816 */     GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(154837), // Rule ID 3671 //
     /* 154821 */       // MIs[0] Operand 1
     /* 154821 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 154826 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 154826 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 154829 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154831 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154833 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154835 */       GIR_RootConstrainSelectedInstOperands,
     /* 154836 */       // GIR_Coverage, 3671,
     /* 154836 */       GIR_EraseRootFromParent_Done,
     /* 154837 */     // Label 2145: @154837
     /* 154837 */     GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(154858), // Rule ID 3672 //
     /* 154842 */       // MIs[0] Operand 1
     /* 154842 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 154847 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 154847 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 154850 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154852 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154854 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154856 */       GIR_RootConstrainSelectedInstOperands,
     /* 154857 */       // GIR_Coverage, 3672,
     /* 154857 */       GIR_EraseRootFromParent_Done,
     /* 154858 */     // Label 2146: @154858
     /* 154858 */     GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(154879), // Rule ID 3673 //
     /* 154863 */       // MIs[0] Operand 1
     /* 154863 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154868 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 154868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 154871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154873 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154875 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154877 */       GIR_RootConstrainSelectedInstOperands,
     /* 154878 */       // GIR_Coverage, 3673,
     /* 154878 */       GIR_EraseRootFromParent_Done,
     /* 154879 */     // Label 2147: @154879
     /* 154879 */     GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(154900), // Rule ID 3674 //
     /* 154884 */       // MIs[0] Operand 1
     /* 154884 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 154889 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 154889 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 154892 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154894 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154896 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154898 */       GIR_RootConstrainSelectedInstOperands,
     /* 154899 */       // GIR_Coverage, 3674,
     /* 154899 */       GIR_EraseRootFromParent_Done,
     /* 154900 */     // Label 2148: @154900
     /* 154900 */     GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(154921), // Rule ID 3675 //
     /* 154905 */       // MIs[0] Operand 1
     /* 154905 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 154910 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETEQ:{ *:[Other] })  =>  (CREQV:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 154910 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /* 154913 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154915 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154917 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154919 */       GIR_RootConstrainSelectedInstOperands,
     /* 154920 */       // GIR_Coverage, 3675,
     /* 154920 */       GIR_EraseRootFromParent_Done,
     /* 154921 */     // Label 2149: @154921
     /* 154921 */     GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(154942), // Rule ID 3676 //
     /* 154926 */       // MIs[0] Operand 1
     /* 154926 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154931 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 154931 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 154934 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154936 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154938 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154940 */       GIR_RootConstrainSelectedInstOperands,
     /* 154941 */       // GIR_Coverage, 3676,
     /* 154941 */       GIR_EraseRootFromParent_Done,
     /* 154942 */     // Label 2150: @154942
     /* 154942 */     GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(154963), // Rule ID 3677 //
     /* 154947 */       // MIs[0] Operand 1
     /* 154947 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 154952 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 154952 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 154955 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154957 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154959 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154961 */       GIR_RootConstrainSelectedInstOperands,
     /* 154962 */       // GIR_Coverage, 3677,
     /* 154962 */       GIR_EraseRootFromParent_Done,
     /* 154963 */     // Label 2151: @154963
     /* 154963 */     GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(154984), // Rule ID 3678 //
     /* 154968 */       // MIs[0] Operand 1
     /* 154968 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 154973 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 154973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 154976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154978 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154980 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154982 */       GIR_RootConstrainSelectedInstOperands,
     /* 154983 */       // GIR_Coverage, 3678,
     /* 154983 */       GIR_EraseRootFromParent_Done,
     /* 154984 */     // Label 2152: @154984
     /* 154984 */     GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(155005), // Rule ID 3679 //
     /* 154989 */       // MIs[0] Operand 1
     /* 154989 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 154994 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 154994 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 154997 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154999 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155001 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155003 */       GIR_RootConstrainSelectedInstOperands,
     /* 155004 */       // GIR_Coverage, 3679,
     /* 155004 */       GIR_EraseRootFromParent_Done,
     /* 155005 */     // Label 2153: @155005
     /* 155005 */     GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(155026), // Rule ID 3680 //
     /* 155010 */       // MIs[0] Operand 1
     /* 155010 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155015 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETNE:{ *:[Other] })  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155015 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /* 155018 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155020 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155022 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155024 */       GIR_RootConstrainSelectedInstOperands,
     /* 155025 */       // GIR_Coverage, 3680,
     /* 155025 */       GIR_EraseRootFromParent_Done,
     /* 155026 */     // Label 2154: @155026
     /* 155026 */     GIM_Reject,
     /* 155027 */   // Label 2144: @155027
     /* 155027 */   GIM_Reject,
     /* 155028 */   // Label 2141: @155028
     /* 155028 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(155411),
     /* 155033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155040 */     GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(155114), // Rule ID 2973 //
     /* 155045 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155048 */       // MIs[0] Operand 1
     /* 155048 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155053 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 155053 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155056 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155060 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155065 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155069 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155073 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155075 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155078 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155082 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155087 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155094 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155099 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155104 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155107 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155109 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155112 */       GIR_RootConstrainSelectedInstOperands,
     /* 155113 */       // GIR_Coverage, 2973,
     /* 155113 */       GIR_EraseRootFromParent_Done,
     /* 155114 */     // Label 2156: @155114
     /* 155114 */     GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(155188), // Rule ID 2987 //
     /* 155119 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155122 */       // MIs[0] Operand 1
     /* 155122 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155127 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 155127 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155130 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155134 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155139 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155143 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155147 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155149 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155152 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155156 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155161 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155168 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155173 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155178 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155181 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155183 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155186 */       GIR_RootConstrainSelectedInstOperands,
     /* 155187 */       // GIR_Coverage, 2987,
     /* 155187 */       GIR_EraseRootFromParent_Done,
     /* 155188 */     // Label 2157: @155188
     /* 155188 */     GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(155262), // Rule ID 2995 //
     /* 155193 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155196 */       // MIs[0] Operand 1
     /* 155196 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155201 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 155201 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155204 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155208 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155213 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155217 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155221 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155223 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155226 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155230 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155235 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155242 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155247 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155252 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155255 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155257 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155260 */       GIR_RootConstrainSelectedInstOperands,
     /* 155261 */       // GIR_Coverage, 2995,
     /* 155261 */       GIR_EraseRootFromParent_Done,
     /* 155262 */     // Label 2158: @155262
     /* 155262 */     GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(155336), // Rule ID 3003 //
     /* 155267 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155270 */       // MIs[0] Operand 1
     /* 155270 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155275 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 155275 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155278 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155282 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155287 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155291 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155295 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155297 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155300 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155304 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155309 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155316 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155321 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155326 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155329 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155331 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155334 */       GIR_RootConstrainSelectedInstOperands,
     /* 155335 */       // GIR_Coverage, 3003,
     /* 155335 */       GIR_EraseRootFromParent_Done,
     /* 155336 */     // Label 2159: @155336
     /* 155336 */     GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(155410), // Rule ID 3011 //
     /* 155341 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155344 */       // MIs[0] Operand 1
     /* 155344 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155349 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 155349 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155352 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155356 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155361 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155365 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155369 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155371 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155374 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155378 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155383 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155390 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155395 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155400 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155403 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155405 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155408 */       GIR_RootConstrainSelectedInstOperands,
     /* 155409 */       // GIR_Coverage, 3011,
     /* 155409 */       GIR_EraseRootFromParent_Done,
     /* 155410 */     // Label 2160: @155410
     /* 155410 */     GIM_Reject,
     /* 155411 */   // Label 2155: @155411
     /* 155411 */   GIM_Reject,
     /* 155412 */   // Label 2142: @155412
     /* 155412 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(155795),
     /* 155417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155424 */     GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(155498), // Rule ID 3075 //
     /* 155429 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155432 */       // MIs[0] Operand 1
     /* 155432 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155437 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 155437 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155440 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 155444 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155449 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155453 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155457 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155459 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155462 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155466 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155471 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155478 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155483 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155488 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155491 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155493 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155496 */       GIR_RootConstrainSelectedInstOperands,
     /* 155497 */       // GIR_Coverage, 3075,
     /* 155497 */       GIR_EraseRootFromParent_Done,
     /* 155498 */     // Label 2162: @155498
     /* 155498 */     GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(155572), // Rule ID 3083 //
     /* 155503 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155506 */       // MIs[0] Operand 1
     /* 155506 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155511 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 155511 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155514 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155518 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155523 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155527 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155531 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155533 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155536 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155540 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155545 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155552 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155557 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155562 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155565 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155570 */       GIR_RootConstrainSelectedInstOperands,
     /* 155571 */       // GIR_Coverage, 3083,
     /* 155571 */       GIR_EraseRootFromParent_Done,
     /* 155572 */     // Label 2163: @155572
     /* 155572 */     GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(155646), // Rule ID 3091 //
     /* 155577 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155580 */       // MIs[0] Operand 1
     /* 155580 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155585 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 155585 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155588 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 155592 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155597 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155601 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155607 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155610 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155614 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155619 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155626 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155631 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155636 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155639 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155641 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155644 */       GIR_RootConstrainSelectedInstOperands,
     /* 155645 */       // GIR_Coverage, 3091,
     /* 155645 */       GIR_EraseRootFromParent_Done,
     /* 155646 */     // Label 2164: @155646
     /* 155646 */     GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(155720), // Rule ID 3099 //
     /* 155651 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155654 */       // MIs[0] Operand 1
     /* 155654 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155659 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 155659 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155662 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155666 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155671 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155675 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155679 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155681 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155684 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155688 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155693 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155700 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155705 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155710 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155713 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155715 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155718 */       GIR_RootConstrainSelectedInstOperands,
     /* 155719 */       // GIR_Coverage, 3099,
     /* 155719 */       GIR_EraseRootFromParent_Done,
     /* 155720 */     // Label 2165: @155720
     /* 155720 */     GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(155794), // Rule ID 3107 //
     /* 155725 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155728 */       // MIs[0] Operand 1
     /* 155728 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155733 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 155733 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155736 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155740 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155745 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155749 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155753 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155755 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155758 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155762 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155767 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155774 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155779 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155784 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155787 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155789 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155792 */       GIR_RootConstrainSelectedInstOperands,
     /* 155793 */       // GIR_Coverage, 3107,
     /* 155793 */       GIR_EraseRootFromParent_Done,
     /* 155794 */     // Label 2166: @155794
     /* 155794 */     GIM_Reject,
     /* 155795 */   // Label 2161: @155795
     /* 155795 */   GIM_Reject,
     /* 155796 */   // Label 2143: @155796
     /* 155796 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2169*/ GIMT_Encode4(156393),
     /* 155807 */   /*GILLT_s32*//*Label 2167*/ GIMT_Encode4(155815),
     /* 155811 */   /*GILLT_s64*//*Label 2168*/ GIMT_Encode4(156104),
     /* 155815 */   // Label 2167: @155815
     /* 155815 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(156103),
     /* 155820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155827 */     GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(155882), // Rule ID 3792 //
     /* 155832 */       // MIs[0] Operand 1
     /* 155832 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 155837 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 155837 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155840 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155844 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155849 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155853 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155857 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155859 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155862 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155864 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155871 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155876 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155881 */       // GIR_Coverage, 3792,
     /* 155881 */       GIR_EraseRootFromParent_Done,
     /* 155882 */     // Label 2171: @155882
     /* 155882 */     GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(155937), // Rule ID 3793 //
     /* 155887 */       // MIs[0] Operand 1
     /* 155887 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 155892 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 155892 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155895 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155899 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155904 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155908 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155912 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155914 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155917 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155919 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155926 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155931 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155936 */       // GIR_Coverage, 3793,
     /* 155936 */       GIR_EraseRootFromParent_Done,
     /* 155937 */     // Label 2172: @155937
     /* 155937 */     GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(155992), // Rule ID 3794 //
     /* 155942 */       // MIs[0] Operand 1
     /* 155942 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 155947 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 155947 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155950 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155954 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155959 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155963 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155967 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155969 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155972 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155974 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155981 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155986 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155991 */       // GIR_Coverage, 3794,
     /* 155991 */       GIR_EraseRootFromParent_Done,
     /* 155992 */     // Label 2173: @155992
     /* 155992 */     GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(156047), // Rule ID 3795 //
     /* 155997 */       // MIs[0] Operand 1
     /* 155997 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 156002 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 156002 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156005 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156009 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156014 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156018 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156022 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156024 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156027 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156029 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156036 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156041 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156046 */       // GIR_Coverage, 3795,
     /* 156046 */       GIR_EraseRootFromParent_Done,
     /* 156047 */     // Label 2174: @156047
     /* 156047 */     GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(156102), // Rule ID 3796 //
     /* 156052 */       // MIs[0] Operand 1
     /* 156052 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 156057 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /* 156057 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156060 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156064 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156069 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156073 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156077 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156079 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156082 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156084 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156091 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156096 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156101 */       // GIR_Coverage, 3796,
     /* 156101 */       GIR_EraseRootFromParent_Done,
     /* 156102 */     // Label 2175: @156102
     /* 156102 */     GIM_Reject,
     /* 156103 */   // Label 2170: @156103
     /* 156103 */   GIM_Reject,
     /* 156104 */   // Label 2168: @156104
     /* 156104 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(156392),
     /* 156109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156116 */     GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(156171), // Rule ID 3804 //
     /* 156121 */       // MIs[0] Operand 1
     /* 156121 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 156126 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 156126 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156129 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156133 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156138 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156142 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156146 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156148 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156151 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156153 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156160 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156165 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156170 */       // GIR_Coverage, 3804,
     /* 156170 */       GIR_EraseRootFromParent_Done,
     /* 156171 */     // Label 2177: @156171
     /* 156171 */     GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(156226), // Rule ID 3805 //
     /* 156176 */       // MIs[0] Operand 1
     /* 156176 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 156181 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 156181 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156184 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156188 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156193 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156197 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156201 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156203 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156206 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156208 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156215 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156220 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156225 */       // GIR_Coverage, 3805,
     /* 156225 */       GIR_EraseRootFromParent_Done,
     /* 156226 */     // Label 2178: @156226
     /* 156226 */     GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(156281), // Rule ID 3806 //
     /* 156231 */       // MIs[0] Operand 1
     /* 156231 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 156236 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 156236 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156239 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156243 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156248 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156252 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156256 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156258 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156261 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156263 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156270 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156275 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156280 */       // GIR_Coverage, 3806,
     /* 156280 */       GIR_EraseRootFromParent_Done,
     /* 156281 */     // Label 2179: @156281
     /* 156281 */     GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(156336), // Rule ID 3807 //
     /* 156286 */       // MIs[0] Operand 1
     /* 156286 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 156291 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 156291 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156294 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156298 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156303 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156307 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156311 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156313 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156316 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156318 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156325 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156330 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156335 */       // GIR_Coverage, 3807,
     /* 156335 */       GIR_EraseRootFromParent_Done,
     /* 156336 */     // Label 2180: @156336
     /* 156336 */     GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(156391), // Rule ID 3808 //
     /* 156341 */       // MIs[0] Operand 1
     /* 156341 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 156346 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /* 156346 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156349 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156353 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156358 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156362 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156366 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156368 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156371 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156373 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156380 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156385 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156390 */       // GIR_Coverage, 3808,
     /* 156390 */       GIR_EraseRootFromParent_Done,
     /* 156391 */     // Label 2181: @156391
     /* 156391 */     GIM_Reject,
     /* 156392 */   // Label 2176: @156392
     /* 156392 */   GIM_Reject,
     /* 156393 */   // Label 2169: @156393
     /* 156393 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2184*/ GIMT_Encode4(157180),
     /* 156404 */   /*GILLT_s32*//*Label 2182*/ GIMT_Encode4(156412),
     /* 156408 */   /*GILLT_s64*//*Label 2183*/ GIMT_Encode4(156796),
     /* 156412 */   // Label 2182: @156412
     /* 156412 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(156795),
     /* 156417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156424 */     GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(156498), // Rule ID 3857 //
     /* 156429 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156432 */       // MIs[0] Operand 1
     /* 156432 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 156437 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 156437 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156440 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156444 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156449 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156453 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156457 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156459 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156462 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156466 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156471 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156478 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156483 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156488 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156491 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156493 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156496 */       GIR_RootConstrainSelectedInstOperands,
     /* 156497 */       // GIR_Coverage, 3857,
     /* 156497 */       GIR_EraseRootFromParent_Done,
     /* 156498 */     // Label 2186: @156498
     /* 156498 */     GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(156572), // Rule ID 3865 //
     /* 156503 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156506 */       // MIs[0] Operand 1
     /* 156506 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 156511 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 156511 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156514 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156518 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156523 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156527 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156531 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156533 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156536 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156540 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156545 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156552 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156557 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156562 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156565 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156570 */       GIR_RootConstrainSelectedInstOperands,
     /* 156571 */       // GIR_Coverage, 3865,
     /* 156571 */       GIR_EraseRootFromParent_Done,
     /* 156572 */     // Label 2187: @156572
     /* 156572 */     GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(156646), // Rule ID 3873 //
     /* 156577 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156580 */       // MIs[0] Operand 1
     /* 156580 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 156585 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 156585 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156588 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156592 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156597 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156601 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156607 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156610 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156614 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156619 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156626 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156631 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156636 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156639 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156641 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156644 */       GIR_RootConstrainSelectedInstOperands,
     /* 156645 */       // GIR_Coverage, 3873,
     /* 156645 */       GIR_EraseRootFromParent_Done,
     /* 156646 */     // Label 2188: @156646
     /* 156646 */     GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(156720), // Rule ID 3881 //
     /* 156651 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156654 */       // MIs[0] Operand 1
     /* 156654 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 156659 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 156659 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156662 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156666 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156671 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156675 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156679 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156681 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156684 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156688 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156693 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156700 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156705 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156710 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156713 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156715 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156718 */       GIR_RootConstrainSelectedInstOperands,
     /* 156719 */       // GIR_Coverage, 3881,
     /* 156719 */       GIR_EraseRootFromParent_Done,
     /* 156720 */     // Label 2189: @156720
     /* 156720 */     GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(156794), // Rule ID 3889 //
     /* 156725 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156728 */       // MIs[0] Operand 1
     /* 156728 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 156733 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 156733 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156736 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156740 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156745 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156749 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156753 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156755 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156758 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156762 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156767 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156774 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156779 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156784 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156787 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156789 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156792 */       GIR_RootConstrainSelectedInstOperands,
     /* 156793 */       // GIR_Coverage, 3889,
     /* 156793 */       GIR_EraseRootFromParent_Done,
     /* 156794 */     // Label 2190: @156794
     /* 156794 */     GIM_Reject,
     /* 156795 */   // Label 2185: @156795
     /* 156795 */   GIM_Reject,
     /* 156796 */   // Label 2183: @156796
     /* 156796 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(157179),
     /* 156801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156808 */     GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(156882), // Rule ID 3953 //
     /* 156813 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156816 */       // MIs[0] Operand 1
     /* 156816 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 156821 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 156821 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156824 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156828 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156833 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156837 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156841 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156843 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156846 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156850 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156855 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156862 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156867 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156872 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156875 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156877 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156880 */       GIR_RootConstrainSelectedInstOperands,
     /* 156881 */       // GIR_Coverage, 3953,
     /* 156881 */       GIR_EraseRootFromParent_Done,
     /* 156882 */     // Label 2192: @156882
     /* 156882 */     GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(156956), // Rule ID 3961 //
     /* 156887 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156890 */       // MIs[0] Operand 1
     /* 156890 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 156895 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 156895 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156898 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156902 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156907 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156911 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156915 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156917 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156920 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156924 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156929 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156954 */       GIR_RootConstrainSelectedInstOperands,
     /* 156955 */       // GIR_Coverage, 3961,
     /* 156955 */       GIR_EraseRootFromParent_Done,
     /* 156956 */     // Label 2193: @156956
     /* 156956 */     GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(157030), // Rule ID 3969 //
     /* 156961 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156964 */       // MIs[0] Operand 1
     /* 156964 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 156969 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 156969 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156972 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156976 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156981 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156985 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156989 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156991 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156994 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156998 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157003 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157010 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157015 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157020 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157023 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157025 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157028 */       GIR_RootConstrainSelectedInstOperands,
     /* 157029 */       // GIR_Coverage, 3969,
     /* 157029 */       GIR_EraseRootFromParent_Done,
     /* 157030 */     // Label 2194: @157030
     /* 157030 */     GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(157104), // Rule ID 3977 //
     /* 157035 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157038 */       // MIs[0] Operand 1
     /* 157038 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 157043 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157043 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157046 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157050 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157055 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157059 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157063 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157065 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157068 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157072 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157077 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157084 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157089 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157094 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157097 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157099 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157102 */       GIR_RootConstrainSelectedInstOperands,
     /* 157103 */       // GIR_Coverage, 3977,
     /* 157103 */       GIR_EraseRootFromParent_Done,
     /* 157104 */     // Label 2195: @157104
     /* 157104 */     GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(157178), // Rule ID 3985 //
     /* 157109 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157112 */       // MIs[0] Operand 1
     /* 157112 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 157117 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 157117 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157120 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157124 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157129 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157133 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157137 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157139 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157142 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157146 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157151 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157158 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157173 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157176 */       GIR_RootConstrainSelectedInstOperands,
     /* 157177 */       // GIR_Coverage, 3985,
     /* 157177 */       GIR_EraseRootFromParent_Done,
     /* 157178 */     // Label 2196: @157178
     /* 157178 */     GIM_Reject,
     /* 157179 */   // Label 2191: @157179
     /* 157179 */   GIM_Reject,
     /* 157180 */   // Label 2184: @157180
     /* 157180 */   GIM_Reject,
     /* 157181 */ // Label 2106: @157181
     /* 157181 */ GIM_Reject,
     /* 157182 */ // Label 32: @157182
     /* 157182 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(160632),
     /* 157187 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 157190 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2201*/ GIMT_Encode4(158143),
     /* 157201 */   /*GILLT_s32*//*Label 2198*/ GIMT_Encode4(157213),
     /* 157205 */   /*GILLT_s64*//*Label 2199*/ GIMT_Encode4(157523),
     /* 157209 */   /*GILLT_s128*//*Label 2200*/ GIMT_Encode4(157833),
     /* 157213 */   // Label 2198: @157213
     /* 157213 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(157522),
     /* 157218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157225 */     GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(157299), // Rule ID 3171 //
     /* 157230 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157233 */       // MIs[0] Operand 1
     /* 157233 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157238 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 157238 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157241 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157245 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157250 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157254 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157258 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157260 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157263 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157267 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157272 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157279 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157284 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157289 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157292 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157294 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157297 */       GIR_RootConstrainSelectedInstOperands,
     /* 157298 */       // GIR_Coverage, 3171,
     /* 157298 */       GIR_EraseRootFromParent_Done,
     /* 157299 */     // Label 2203: @157299
     /* 157299 */     GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(157373), // Rule ID 3187 //
     /* 157304 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157307 */       // MIs[0] Operand 1
     /* 157307 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157312 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 157312 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157315 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157319 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157324 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157328 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157332 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157334 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157337 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157341 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157346 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157353 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157358 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157363 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157366 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157368 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157371 */       GIR_RootConstrainSelectedInstOperands,
     /* 157372 */       // GIR_Coverage, 3187,
     /* 157372 */       GIR_EraseRootFromParent_Done,
     /* 157373 */     // Label 2204: @157373
     /* 157373 */     GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(157447), // Rule ID 3203 //
     /* 157378 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157381 */       // MIs[0] Operand 1
     /* 157381 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 157386 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 157386 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157389 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157393 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157398 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157402 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157406 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157408 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157411 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157415 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157420 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157427 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157432 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157442 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157445 */       GIR_RootConstrainSelectedInstOperands,
     /* 157446 */       // GIR_Coverage, 3203,
     /* 157446 */       GIR_EraseRootFromParent_Done,
     /* 157447 */     // Label 2205: @157447
     /* 157447 */     GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(157521), // Rule ID 3219 //
     /* 157452 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157455 */       // MIs[0] Operand 1
     /* 157455 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 157460 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 157460 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157463 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157467 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157472 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157476 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157480 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157482 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157485 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157489 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157494 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 157501 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157506 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157511 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157514 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157516 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157519 */       GIR_RootConstrainSelectedInstOperands,
     /* 157520 */       // GIR_Coverage, 3219,
     /* 157520 */       GIR_EraseRootFromParent_Done,
     /* 157521 */     // Label 2206: @157521
     /* 157521 */     GIM_Reject,
     /* 157522 */   // Label 2202: @157522
     /* 157522 */   GIM_Reject,
     /* 157523 */   // Label 2199: @157523
     /* 157523 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(157832),
     /* 157528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157535 */     GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(157609), // Rule ID 3227 //
     /* 157540 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157543 */       // MIs[0] Operand 1
     /* 157543 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157548 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 157548 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157551 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157555 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157560 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157564 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157568 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157570 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157573 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157577 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157582 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157589 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157594 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157599 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157602 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157604 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157607 */       GIR_RootConstrainSelectedInstOperands,
     /* 157608 */       // GIR_Coverage, 3227,
     /* 157608 */       GIR_EraseRootFromParent_Done,
     /* 157609 */     // Label 2208: @157609
     /* 157609 */     GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(157683), // Rule ID 3243 //
     /* 157614 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157617 */       // MIs[0] Operand 1
     /* 157617 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157622 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157622 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157625 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157629 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157634 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157638 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157642 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157644 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157647 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157651 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157656 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157663 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157668 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157673 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157676 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157678 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157681 */       GIR_RootConstrainSelectedInstOperands,
     /* 157682 */       // GIR_Coverage, 3243,
     /* 157682 */       GIR_EraseRootFromParent_Done,
     /* 157683 */     // Label 2209: @157683
     /* 157683 */     GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(157757), // Rule ID 3259 //
     /* 157688 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157691 */       // MIs[0] Operand 1
     /* 157691 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 157696 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 157696 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157699 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157703 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157708 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157712 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157718 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157721 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157725 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157730 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157737 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157742 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157747 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157750 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157752 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157755 */       GIR_RootConstrainSelectedInstOperands,
     /* 157756 */       // GIR_Coverage, 3259,
     /* 157756 */       GIR_EraseRootFromParent_Done,
     /* 157757 */     // Label 2210: @157757
     /* 157757 */     GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(157831), // Rule ID 3275 //
     /* 157762 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157765 */       // MIs[0] Operand 1
     /* 157765 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 157770 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 157770 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157773 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157777 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157782 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157786 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157790 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157804 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 157811 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157816 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157821 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157824 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157826 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157829 */       GIR_RootConstrainSelectedInstOperands,
     /* 157830 */       // GIR_Coverage, 3275,
     /* 157830 */       GIR_EraseRootFromParent_Done,
     /* 157831 */     // Label 2211: @157831
     /* 157831 */     GIM_Reject,
     /* 157832 */   // Label 2207: @157832
     /* 157832 */   GIM_Reject,
     /* 157833 */   // Label 2200: @157833
     /* 157833 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(158142),
     /* 157838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 157841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157845 */     GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(157919), // Rule ID 3283 //
     /* 157850 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157853 */       // MIs[0] Operand 1
     /* 157853 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157858 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 157858 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157861 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157865 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157870 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157874 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157878 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157880 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157883 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157887 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157892 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157899 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157904 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157909 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157912 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157914 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157917 */       GIR_RootConstrainSelectedInstOperands,
     /* 157918 */       // GIR_Coverage, 3283,
     /* 157918 */       GIR_EraseRootFromParent_Done,
     /* 157919 */     // Label 2213: @157919
     /* 157919 */     GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(157993), // Rule ID 3299 //
     /* 157924 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157927 */       // MIs[0] Operand 1
     /* 157927 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157932 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 157932 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157935 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157939 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157944 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157948 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157952 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157954 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157957 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157961 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157966 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157973 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157978 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157983 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157986 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157988 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157991 */       GIR_RootConstrainSelectedInstOperands,
     /* 157992 */       // GIR_Coverage, 3299,
     /* 157992 */       GIR_EraseRootFromParent_Done,
     /* 157993 */     // Label 2214: @157993
     /* 157993 */     GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(158067), // Rule ID 3315 //
     /* 157998 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158001 */       // MIs[0] Operand 1
     /* 158001 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158006 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 158006 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158009 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158013 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158018 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158022 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158026 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158028 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158031 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158035 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158040 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158047 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158052 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158062 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158065 */       GIR_RootConstrainSelectedInstOperands,
     /* 158066 */       // GIR_Coverage, 3315,
     /* 158066 */       GIR_EraseRootFromParent_Done,
     /* 158067 */     // Label 2215: @158067
     /* 158067 */     GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(158141), // Rule ID 3331 //
     /* 158072 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158075 */       // MIs[0] Operand 1
     /* 158075 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158080 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 158080 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158083 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158087 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158092 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158096 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158100 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158102 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158105 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158109 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158114 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158121 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158126 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158131 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158134 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158136 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158139 */       GIR_RootConstrainSelectedInstOperands,
     /* 158140 */       // GIR_Coverage, 3331,
     /* 158140 */       GIR_EraseRootFromParent_Done,
     /* 158141 */     // Label 2216: @158141
     /* 158141 */     GIM_Reject,
     /* 158142 */   // Label 2212: @158142
     /* 158142 */   GIM_Reject,
     /* 158143 */   // Label 2201: @158143
     /* 158143 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2220*/ GIMT_Encode4(159792),
     /* 158154 */   /*GILLT_s32*//*Label 2217*/ GIMT_Encode4(158166),
     /* 158158 */   /*GILLT_s64*//*Label 2218*/ GIMT_Encode4(158708),
     /* 158162 */   /*GILLT_s128*//*Label 2219*/ GIMT_Encode4(159250),
     /* 158166 */   // Label 2217: @158166
     /* 158166 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(158707),
     /* 158171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158178 */     GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(158236), // Rule ID 3994 //
     /* 158183 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158186 */       // MIs[0] Operand 1
     /* 158186 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 158191 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /* 158191 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158194 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158198 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158203 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158207 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158211 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158213 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158216 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158218 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158225 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158230 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158235 */       // GIR_Coverage, 3994,
     /* 158235 */       GIR_EraseRootFromParent_Done,
     /* 158236 */     // Label 2222: @158236
     /* 158236 */     GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(158294), // Rule ID 3998 //
     /* 158241 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158244 */       // MIs[0] Operand 1
     /* 158244 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 158249 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 158249 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158252 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158256 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158261 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158265 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158269 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158271 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158274 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158276 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158283 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158288 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158293 */       // GIR_Coverage, 3998,
     /* 158293 */       GIR_EraseRootFromParent_Done,
     /* 158294 */     // Label 2223: @158294
     /* 158294 */     GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(158352), // Rule ID 4002 //
     /* 158299 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158302 */       // MIs[0] Operand 1
     /* 158302 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 158307 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /* 158307 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158310 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158314 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158319 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158323 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158327 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158329 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158332 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158334 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158341 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158346 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158351 */       // GIR_Coverage, 4002,
     /* 158351 */       GIR_EraseRootFromParent_Done,
     /* 158352 */     // Label 2224: @158352
     /* 158352 */     GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(158410), // Rule ID 4006 //
     /* 158357 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158360 */       // MIs[0] Operand 1
     /* 158360 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 158365 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /* 158365 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158368 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158372 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158377 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158381 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158385 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158387 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158390 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158392 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158399 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158404 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158409 */       // GIR_Coverage, 4006,
     /* 158409 */       GIR_EraseRootFromParent_Done,
     /* 158410 */     // Label 2225: @158410
     /* 158410 */     GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(158484), // Rule ID 4008 //
     /* 158415 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158418 */       // MIs[0] Operand 1
     /* 158418 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 158423 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 158423 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158426 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158430 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158435 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158439 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158443 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158445 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158448 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158452 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158457 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158464 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158469 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158474 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158477 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158479 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158482 */       GIR_RootConstrainSelectedInstOperands,
     /* 158483 */       // GIR_Coverage, 4008,
     /* 158483 */       GIR_EraseRootFromParent_Done,
     /* 158484 */     // Label 2226: @158484
     /* 158484 */     GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(158558), // Rule ID 4040 //
     /* 158489 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158492 */       // MIs[0] Operand 1
     /* 158492 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 158497 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 158497 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158500 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158504 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158509 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158513 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158517 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158519 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158522 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158526 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158531 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158538 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158543 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158548 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158551 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158553 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158556 */       GIR_RootConstrainSelectedInstOperands,
     /* 158557 */       // GIR_Coverage, 4040,
     /* 158557 */       GIR_EraseRootFromParent_Done,
     /* 158558 */     // Label 2227: @158558
     /* 158558 */     GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(158632), // Rule ID 4072 //
     /* 158563 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158566 */       // MIs[0] Operand 1
     /* 158566 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158571 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 158571 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158574 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158578 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158583 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158587 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158591 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158593 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158596 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158600 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158605 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158612 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158617 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158622 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158625 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158627 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158630 */       GIR_RootConstrainSelectedInstOperands,
     /* 158631 */       // GIR_Coverage, 4072,
     /* 158631 */       GIR_EraseRootFromParent_Done,
     /* 158632 */     // Label 2228: @158632
     /* 158632 */     GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(158706), // Rule ID 4104 //
     /* 158637 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158640 */       // MIs[0] Operand 1
     /* 158640 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158645 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 158645 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158648 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158652 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158657 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158661 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158665 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158667 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158670 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158674 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158679 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158686 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158691 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158696 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158699 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158701 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158704 */       GIR_RootConstrainSelectedInstOperands,
     /* 158705 */       // GIR_Coverage, 4104,
     /* 158705 */       GIR_EraseRootFromParent_Done,
     /* 158706 */     // Label 2229: @158706
     /* 158706 */     GIM_Reject,
     /* 158707 */   // Label 2221: @158707
     /* 158707 */   GIM_Reject,
     /* 158708 */   // Label 2218: @158708
     /* 158708 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(159249),
     /* 158713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158720 */     GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(158794), // Rule ID 4120 //
     /* 158725 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158728 */       // MIs[0] Operand 1
     /* 158728 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 158733 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 158733 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158736 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158740 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158745 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158749 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158753 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158755 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158758 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158762 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158767 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158774 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158779 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158784 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158787 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158789 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158792 */       GIR_RootConstrainSelectedInstOperands,
     /* 158793 */       // GIR_Coverage, 4120,
     /* 158793 */       GIR_EraseRootFromParent_Done,
     /* 158794 */     // Label 2231: @158794
     /* 158794 */     GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(158868), // Rule ID 4152 //
     /* 158799 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158802 */       // MIs[0] Operand 1
     /* 158802 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 158807 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 158807 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158810 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158814 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158819 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158823 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158827 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158829 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158832 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158836 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158841 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158848 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158853 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158858 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158861 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158863 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158866 */       GIR_RootConstrainSelectedInstOperands,
     /* 158867 */       // GIR_Coverage, 4152,
     /* 158867 */       GIR_EraseRootFromParent_Done,
     /* 158868 */     // Label 2232: @158868
     /* 158868 */     GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(158942), // Rule ID 4184 //
     /* 158873 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158876 */       // MIs[0] Operand 1
     /* 158876 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158881 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 158881 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158884 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158888 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158893 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158897 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158901 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158903 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158906 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158910 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158915 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158922 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158927 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158932 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158935 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158937 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158940 */       GIR_RootConstrainSelectedInstOperands,
     /* 158941 */       // GIR_Coverage, 4184,
     /* 158941 */       GIR_EraseRootFromParent_Done,
     /* 158942 */     // Label 2233: @158942
     /* 158942 */     GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(159016), // Rule ID 4216 //
     /* 158947 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158950 */       // MIs[0] Operand 1
     /* 158950 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158955 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 158955 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158958 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158962 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158967 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158971 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158975 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158977 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158980 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158984 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158989 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158996 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159001 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159006 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159009 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159011 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159014 */       GIR_RootConstrainSelectedInstOperands,
     /* 159015 */       // GIR_Coverage, 4216,
     /* 159015 */       GIR_EraseRootFromParent_Done,
     /* 159016 */     // Label 2234: @159016
     /* 159016 */     GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(159074), // Rule ID 4232 //
     /* 159021 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159024 */       // MIs[0] Operand 1
     /* 159024 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159029 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /* 159029 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159032 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159036 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159041 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159045 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159049 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159051 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159054 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159056 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159063 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159068 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159073 */       // GIR_Coverage, 4232,
     /* 159073 */       GIR_EraseRootFromParent_Done,
     /* 159074 */     // Label 2235: @159074
     /* 159074 */     GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(159132), // Rule ID 4236 //
     /* 159079 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159082 */       // MIs[0] Operand 1
     /* 159082 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159087 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 159087 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159090 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159094 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159099 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159103 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159109 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159112 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159114 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159121 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159126 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159131 */       // GIR_Coverage, 4236,
     /* 159131 */       GIR_EraseRootFromParent_Done,
     /* 159132 */     // Label 2236: @159132
     /* 159132 */     GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(159190), // Rule ID 4240 //
     /* 159137 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159140 */       // MIs[0] Operand 1
     /* 159140 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 159145 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /* 159145 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159148 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159152 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159157 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159161 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159165 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159167 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159170 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159172 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159179 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159184 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159189 */       // GIR_Coverage, 4240,
     /* 159189 */       GIR_EraseRootFromParent_Done,
     /* 159190 */     // Label 2237: @159190
     /* 159190 */     GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(159248), // Rule ID 4244 //
     /* 159195 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159198 */       // MIs[0] Operand 1
     /* 159198 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 159203 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /* 159203 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159206 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159210 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159215 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159219 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159223 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159225 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159228 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159230 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159237 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159242 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159247 */       // GIR_Coverage, 4244,
     /* 159247 */       GIR_EraseRootFromParent_Done,
     /* 159248 */     // Label 2238: @159248
     /* 159248 */     GIM_Reject,
     /* 159249 */   // Label 2230: @159249
     /* 159249 */   GIM_Reject,
     /* 159250 */   // Label 2219: @159250
     /* 159250 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(159791),
     /* 159255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 159258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159262 */     GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(159336), // Rule ID 4246 //
     /* 159267 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159270 */       // MIs[0] Operand 1
     /* 159270 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 159275 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 159275 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159278 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159282 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159287 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159291 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159295 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159297 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159300 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159304 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159309 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159316 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159321 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159326 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159329 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159331 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159334 */       GIR_RootConstrainSelectedInstOperands,
     /* 159335 */       // GIR_Coverage, 4246,
     /* 159335 */       GIR_EraseRootFromParent_Done,
     /* 159336 */     // Label 2240: @159336
     /* 159336 */     GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(159410), // Rule ID 4278 //
     /* 159341 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159344 */       // MIs[0] Operand 1
     /* 159344 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 159349 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 159349 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159352 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159356 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159361 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159365 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159369 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159371 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159374 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159378 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159383 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159390 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159395 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159400 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159403 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159405 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159408 */       GIR_RootConstrainSelectedInstOperands,
     /* 159409 */       // GIR_Coverage, 4278,
     /* 159409 */       GIR_EraseRootFromParent_Done,
     /* 159410 */     // Label 2241: @159410
     /* 159410 */     GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(159484), // Rule ID 4310 //
     /* 159415 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159418 */       // MIs[0] Operand 1
     /* 159418 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 159423 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 159423 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159426 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159430 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159435 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159439 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159443 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159445 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159448 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159452 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159457 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159464 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159469 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159474 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159477 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159479 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159482 */       GIR_RootConstrainSelectedInstOperands,
     /* 159483 */       // GIR_Coverage, 4310,
     /* 159483 */       GIR_EraseRootFromParent_Done,
     /* 159484 */     // Label 2242: @159484
     /* 159484 */     GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(159558), // Rule ID 4342 //
     /* 159489 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159492 */       // MIs[0] Operand 1
     /* 159492 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 159497 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 159497 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159500 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159504 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159509 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159513 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159517 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159519 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159522 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159526 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159531 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159538 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159543 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159548 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159551 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159553 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159556 */       GIR_RootConstrainSelectedInstOperands,
     /* 159557 */       // GIR_Coverage, 4342,
     /* 159557 */       GIR_EraseRootFromParent_Done,
     /* 159558 */     // Label 2243: @159558
     /* 159558 */     GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(159616), // Rule ID 4358 //
     /* 159563 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159566 */       // MIs[0] Operand 1
     /* 159566 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159571 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /* 159571 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159574 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159578 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159583 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159587 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159591 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159593 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159596 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159598 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159605 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159610 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159615 */       // GIR_Coverage, 4358,
     /* 159615 */       GIR_EraseRootFromParent_Done,
     /* 159616 */     // Label 2244: @159616
     /* 159616 */     GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(159674), // Rule ID 4362 //
     /* 159621 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159624 */       // MIs[0] Operand 1
     /* 159624 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159629 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /* 159629 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159632 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159636 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159641 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159645 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159649 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159651 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159654 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159656 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159663 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159668 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159673 */       // GIR_Coverage, 4362,
     /* 159673 */       GIR_EraseRootFromParent_Done,
     /* 159674 */     // Label 2245: @159674
     /* 159674 */     GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(159732), // Rule ID 4366 //
     /* 159679 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159682 */       // MIs[0] Operand 1
     /* 159682 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 159687 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /* 159687 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159690 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159694 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159699 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159703 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159707 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159709 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159712 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159714 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159721 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159726 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159731 */       // GIR_Coverage, 4366,
     /* 159731 */       GIR_EraseRootFromParent_Done,
     /* 159732 */     // Label 2246: @159732
     /* 159732 */     GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(159790), // Rule ID 4370 //
     /* 159737 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159740 */       // MIs[0] Operand 1
     /* 159740 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 159745 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /* 159745 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159748 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159752 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159757 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159761 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159765 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159767 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159770 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159772 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159779 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159784 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159789 */       // GIR_Coverage, 4370,
     /* 159789 */       GIR_EraseRootFromParent_Done,
     /* 159790 */     // Label 2247: @159790
     /* 159790 */     GIM_Reject,
     /* 159791 */   // Label 2239: @159791
     /* 159791 */   GIM_Reject,
     /* 159792 */   // Label 2220: @159792
     /* 159792 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2250*/ GIMT_Encode4(160631),
     /* 159803 */   /*GILLT_s32*//*Label 2248*/ GIMT_Encode4(159811),
     /* 159807 */   /*GILLT_s64*//*Label 2249*/ GIMT_Encode4(160221),
     /* 159811 */   // Label 2248: @159811
     /* 159811 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(160220),
     /* 159816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159823 */     GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(159881), // Rule ID 4561 //
     /* 159828 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 159831 */       // MIs[0] Operand 1
     /* 159831 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159836 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 159836 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159839 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 159843 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159848 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159852 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159856 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159858 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159861 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159863 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159870 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159875 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159880 */       // GIR_Coverage, 4561,
     /* 159880 */       GIR_EraseRootFromParent_Done,
     /* 159881 */     // Label 2252: @159881
     /* 159881 */     GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(159939), // Rule ID 4565 //
     /* 159886 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 159889 */       // MIs[0] Operand 1
     /* 159889 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159894 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 159894 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159897 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 159901 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159906 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159910 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159914 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159916 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159919 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159921 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159928 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159933 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159938 */       // GIR_Coverage, 4565,
     /* 159938 */       GIR_EraseRootFromParent_Done,
     /* 159939 */     // Label 2253: @159939
     /* 159939 */     GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(159997), // Rule ID 4569 //
     /* 159944 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 159947 */       // MIs[0] Operand 1
     /* 159947 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 159952 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 159952 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159955 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 159959 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159964 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159968 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159972 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159974 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159977 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159979 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159986 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159991 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159996 */       // GIR_Coverage, 4569,
     /* 159996 */       GIR_EraseRootFromParent_Done,
     /* 159997 */     // Label 2254: @159997
     /* 159997 */     GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(160071), // Rule ID 4573 //
     /* 160002 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160005 */       // MIs[0] Operand 1
     /* 160005 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 160010 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160010 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160013 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 160017 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160022 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160026 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160030 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160032 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160035 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160039 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160044 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160056 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160061 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160064 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160066 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160069 */       GIR_RootConstrainSelectedInstOperands,
     /* 160070 */       // GIR_Coverage, 4573,
     /* 160070 */       GIR_EraseRootFromParent_Done,
     /* 160071 */     // Label 2255: @160071
     /* 160071 */     GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(160145), // Rule ID 4605 //
     /* 160076 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160079 */       // MIs[0] Operand 1
     /* 160079 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 160084 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160084 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160087 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 160091 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160096 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160100 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160104 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160106 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160109 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160113 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160118 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160125 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160130 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160135 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160138 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160140 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160143 */       GIR_RootConstrainSelectedInstOperands,
     /* 160144 */       // GIR_Coverage, 4605,
     /* 160144 */       GIR_EraseRootFromParent_Done,
     /* 160145 */     // Label 2256: @160145
     /* 160145 */     GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(160219), // Rule ID 4637 //
     /* 160150 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160153 */       // MIs[0] Operand 1
     /* 160153 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 160158 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160158 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160161 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 160165 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160170 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160174 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160178 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160180 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160183 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160187 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160192 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160199 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160209 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160212 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160214 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160217 */       GIR_RootConstrainSelectedInstOperands,
     /* 160218 */       // GIR_Coverage, 4637,
     /* 160218 */       GIR_EraseRootFromParent_Done,
     /* 160219 */     // Label 2257: @160219
     /* 160219 */     GIM_Reject,
     /* 160220 */   // Label 2251: @160220
     /* 160220 */   GIM_Reject,
     /* 160221 */   // Label 2249: @160221
     /* 160221 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(160630),
     /* 160226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160233 */     GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(160291), // Rule ID 4669 //
     /* 160238 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160241 */       // MIs[0] Operand 1
     /* 160241 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 160246 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160246 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160249 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 160253 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160258 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160262 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160266 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160268 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160271 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160273 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160280 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160285 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160290 */       // GIR_Coverage, 4669,
     /* 160290 */       GIR_EraseRootFromParent_Done,
     /* 160291 */     // Label 2259: @160291
     /* 160291 */     GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(160349), // Rule ID 4673 //
     /* 160296 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160299 */       // MIs[0] Operand 1
     /* 160299 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 160304 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160304 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160307 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 160311 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160316 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160320 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160324 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160326 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160329 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160331 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160338 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160343 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160348 */       // GIR_Coverage, 4673,
     /* 160348 */       GIR_EraseRootFromParent_Done,
     /* 160349 */     // Label 2260: @160349
     /* 160349 */     GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(160407), // Rule ID 4677 //
     /* 160354 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160357 */       // MIs[0] Operand 1
     /* 160357 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 160362 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160362 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160365 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 160369 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160374 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160378 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160382 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160384 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160387 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160389 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160396 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160401 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160406 */       // GIR_Coverage, 4677,
     /* 160406 */       GIR_EraseRootFromParent_Done,
     /* 160407 */     // Label 2261: @160407
     /* 160407 */     GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(160481), // Rule ID 4681 //
     /* 160412 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160415 */       // MIs[0] Operand 1
     /* 160415 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 160420 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160420 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160423 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 160427 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160432 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160436 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160440 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160442 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160445 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160449 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160454 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160466 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160471 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160474 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160476 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160479 */       GIR_RootConstrainSelectedInstOperands,
     /* 160480 */       // GIR_Coverage, 4681,
     /* 160480 */       GIR_EraseRootFromParent_Done,
     /* 160481 */     // Label 2262: @160481
     /* 160481 */     GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(160555), // Rule ID 4713 //
     /* 160486 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160489 */       // MIs[0] Operand 1
     /* 160489 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 160494 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160494 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160497 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 160501 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160506 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160510 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160514 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160516 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160519 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160523 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160528 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160535 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160540 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160545 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160548 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160550 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160553 */       GIR_RootConstrainSelectedInstOperands,
     /* 160554 */       // GIR_Coverage, 4713,
     /* 160554 */       GIR_EraseRootFromParent_Done,
     /* 160555 */     // Label 2263: @160555
     /* 160555 */     GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(160629), // Rule ID 4745 //
     /* 160560 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160563 */       // MIs[0] Operand 1
     /* 160563 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 160568 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160568 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160571 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 160575 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160580 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160584 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160588 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160590 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160593 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160597 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160602 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160609 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160614 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160619 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160622 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160624 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160627 */       GIR_RootConstrainSelectedInstOperands,
     /* 160628 */       // GIR_Coverage, 4745,
     /* 160628 */       GIR_EraseRootFromParent_Done,
     /* 160629 */     // Label 2264: @160629
     /* 160629 */     GIM_Reject,
     /* 160630 */   // Label 2258: @160630
     /* 160630 */   GIM_Reject,
     /* 160631 */   // Label 2250: @160631
     /* 160631 */   GIM_Reject,
     /* 160632 */ // Label 2197: @160632
     /* 160632 */ GIM_Reject,
     /* 160633 */ // Label 33: @160633
     /* 160633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2273*/ GIMT_Encode4(161756),
     /* 160644 */ /*GILLT_s1*//*Label 2265*/ GIMT_Encode4(160676),
     /* 160648 */ /*GILLT_s32*//*Label 2266*/ GIMT_Encode4(160769),
     /* 160652 */ /*GILLT_s64*//*Label 2267*/ GIMT_Encode4(160858),
     /* 160656 */ /*GILLT_s128*//*Label 2268*/ GIMT_Encode4(160947),
     /* 160660 */ /*GILLT_v2s64*//*Label 2269*/ GIMT_Encode4(161131),
     /* 160664 */ /*GILLT_v4s32*//*Label 2270*/ GIMT_Encode4(161296),
     /* 160668 */ /*GILLT_v8s16*//*Label 2271*/ GIMT_Encode4(161458),
     /* 160672 */ /*GILLT_v16s8*//*Label 2272*/ GIMT_Encode4(161607),
     /* 160676 */ // Label 2265: @160676
     /* 160676 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(160768), // Rule ID 4776 //
     /* 160681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 160684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 160687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 160690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160694 */   // (select:{ *:[i1] } i1:{ *:[i1] }:$cond, i1:{ *:[i1] }:$tval, i1:{ *:[i1] }:$fval)  =>  (CROR:{ *:[i1] } (CRAND:{ *:[i1] } ?:{ *:[i1] }:$cond, ?:{ *:[i1] }:$tval), (CRAND:{ *:[i1] } (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$cond), ?:{ *:[i1] }:$fval))
     /* 160694 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 160697 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160701 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160706 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 160710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 160712 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 160715 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 160719 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160724 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 160727 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // fval
     /* 160731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 160740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160745 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 160749 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // tval
     /* 160753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /* 160758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 160766 */   GIR_RootConstrainSelectedInstOperands,
     /* 160767 */   // GIR_Coverage, 4776,
     /* 160767 */   GIR_EraseRootFromParent_Done,
     /* 160768 */ // Label 2274: @160768
     /* 160768 */ GIM_Reject,
     /* 160769 */ // Label 2266: @160769
     /* 160769 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(160857),
     /* 160774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 160777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160780 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160783 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(160802), // Rule ID 1051 //
     /* 160788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 160795 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_VSSRC:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 160795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSSRC),
     /* 160800 */     GIR_RootConstrainSelectedInstOperands,
     /* 160801 */     // GIR_Coverage, 1051,
     /* 160801 */     GIR_Done,
     /* 160802 */   // Label 2276: @160802
     /* 160802 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(160818), // Rule ID 5 //
     /* 160807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 160811 */     // (select:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)  =>  (SELECT_I4:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)
     /* 160811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 160816 */     GIR_RootConstrainSelectedInstOperands,
     /* 160817 */     // GIR_Coverage, 5,
     /* 160817 */     GIR_Done,
     /* 160818 */   // Label 2277: @160818
     /* 160818 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(160837), // Rule ID 7 //
     /* 160823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 160830 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_F4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 160830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F4),
     /* 160835 */     GIR_RootConstrainSelectedInstOperands,
     /* 160836 */     // GIR_Coverage, 7,
     /* 160836 */     GIR_Done,
     /* 160837 */   // Label 2278: @160837
     /* 160837 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(160856), // Rule ID 606 //
     /* 160842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 160849 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_SPE4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 160849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE4),
     /* 160854 */     GIR_RootConstrainSelectedInstOperands,
     /* 160855 */     // GIR_Coverage, 606,
     /* 160855 */     GIR_Done,
     /* 160856 */   // Label 2279: @160856
     /* 160856 */   GIM_Reject,
     /* 160857 */ // Label 2275: @160857
     /* 160857 */ GIM_Reject,
     /* 160858 */ // Label 2267: @160858
     /* 160858 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(160946),
     /* 160863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 160866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160872 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(160891), // Rule ID 1050 //
     /* 160877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 160884 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_VSFRC:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 160884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSFRC),
     /* 160889 */     GIR_RootConstrainSelectedInstOperands,
     /* 160890 */     // GIR_Coverage, 1050,
     /* 160890 */     GIR_Done,
     /* 160891 */   // Label 2281: @160891
     /* 160891 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(160907), // Rule ID 6 //
     /* 160896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 160900 */     // (select:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)  =>  (SELECT_I8:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)
     /* 160900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 160905 */     GIR_RootConstrainSelectedInstOperands,
     /* 160906 */     // GIR_Coverage, 6,
     /* 160906 */     GIR_Done,
     /* 160907 */   // Label 2282: @160907
     /* 160907 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(160926), // Rule ID 8 //
     /* 160912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 160919 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_F8:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 160919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F8),
     /* 160924 */     GIR_RootConstrainSelectedInstOperands,
     /* 160925 */     // GIR_Coverage, 8,
     /* 160925 */     GIR_Done,
     /* 160926 */   // Label 2283: @160926
     /* 160926 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(160945), // Rule ID 607 //
     /* 160931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 160938 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_SPE:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 160938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE),
     /* 160943 */     GIR_RootConstrainSelectedInstOperands,
     /* 160944 */     // GIR_Coverage, 607,
     /* 160944 */     GIR_Done,
     /* 160945 */   // Label 2284: @160945
     /* 160945 */   GIM_Reject,
     /* 160946 */ // Label 2280: @160946
     /* 160946 */ GIM_Reject,
     /* 160947 */ // Label 2268: @160947
     /* 160947 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(161068), // Rule ID 1668 //
     /* 160952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 160958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 160961 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 160964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 160968 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 160968 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 160971 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160975 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160980 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 160984 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 160989 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 160992 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160996 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161001 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161005 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161022 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161026 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161043 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161046 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161049 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161062 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161067 */   // GIR_Coverage, 1668,
     /* 161067 */   GIR_EraseRootFromParent_Done,
     /* 161068 */ // Label 2285: @161068
     /* 161068 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(161096), // Rule ID 9 //
     /* 161073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161089 */   // (select:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)  =>  (SELECT_F16:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)
     /* 161089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F16),
     /* 161094 */   GIR_RootConstrainSelectedInstOperands,
     /* 161095 */   // GIR_Coverage, 9,
     /* 161095 */   GIR_Done,
     /* 161096 */ // Label 2286: @161096
     /* 161096 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(161130), // Rule ID 1423 //
     /* 161101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 161107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161117 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (VSEL:{ *:[v1i128] } ?:{ *:[v1i128] }:$vC, ?:{ *:[v1i128] }:$vB, ?:{ *:[v1i128] }:$vA)
     /* 161117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161122 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161124 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161126 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161128 */   GIR_RootConstrainSelectedInstOperands,
     /* 161129 */   // GIR_Coverage, 1423,
     /* 161129 */   GIR_EraseRootFromParent_Done,
     /* 161130 */ // Label 2287: @161130
     /* 161130 */ GIM_Reject,
     /* 161131 */ // Label 2269: @161131
     /* 161131 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(161159), // Rule ID 1049 //
     /* 161136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161152 */   // (select:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)  =>  (SELECT_VSRC:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)
     /* 161152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSRC),
     /* 161157 */   GIR_RootConstrainSelectedInstOperands,
     /* 161158 */   // GIR_Coverage, 1049,
     /* 161158 */   GIR_Done,
     /* 161159 */ // Label 2288: @161159
     /* 161159 */ GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(161193), // Rule ID 1665 //
     /* 161164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161173 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161180 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (XXSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161185 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161187 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161189 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161191 */   GIR_RootConstrainSelectedInstOperands,
     /* 161192 */   // GIR_Coverage, 1665,
     /* 161192 */   GIR_EraseRootFromParent_Done,
     /* 161193 */ // Label 2289: @161193
     /* 161193 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(161227), // Rule ID 1667 //
     /* 161198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161214 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (XXSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161219 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161221 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161223 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161225 */   GIR_RootConstrainSelectedInstOperands,
     /* 161226 */   // GIR_Coverage, 1667,
     /* 161226 */   GIR_EraseRootFromParent_Done,
     /* 161227 */ // Label 2290: @161227
     /* 161227 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(161261), // Rule ID 1420 //
     /* 161232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161241 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161248 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (VSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161253 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161255 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161257 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161259 */   GIR_RootConstrainSelectedInstOperands,
     /* 161260 */   // GIR_Coverage, 1420,
     /* 161260 */   GIR_EraseRootFromParent_Done,
     /* 161261 */ // Label 2291: @161261
     /* 161261 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(161295), // Rule ID 1422 //
     /* 161266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161275 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161282 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (VSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161287 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161289 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161291 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161293 */   GIR_RootConstrainSelectedInstOperands,
     /* 161294 */   // GIR_Coverage, 1422,
     /* 161294 */   GIR_EraseRootFromParent_Done,
     /* 161295 */ // Label 2292: @161295
     /* 161295 */ GIM_Reject,
     /* 161296 */ // Label 2270: @161296
     /* 161296 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(161330), // Rule ID 1664 //
     /* 161301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161310 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161317 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161322 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161324 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161326 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161328 */   GIR_RootConstrainSelectedInstOperands,
     /* 161329 */   // GIR_Coverage, 1664,
     /* 161329 */   GIR_EraseRootFromParent_Done,
     /* 161330 */ // Label 2293: @161330
     /* 161330 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(161364), // Rule ID 1666 //
     /* 161335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161344 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161351 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (XXSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161356 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161358 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161360 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161362 */   GIR_RootConstrainSelectedInstOperands,
     /* 161363 */   // GIR_Coverage, 1666,
     /* 161363 */   GIR_EraseRootFromParent_Done,
     /* 161364 */ // Label 2294: @161364
     /* 161364 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(161389), // Rule ID 10 //
     /* 161369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161382 */   // (select:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)  =>  (SELECT_VRRC:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)
     /* 161382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VRRC),
     /* 161387 */   GIR_RootConstrainSelectedInstOperands,
     /* 161388 */   // GIR_Coverage, 10,
     /* 161388 */   GIR_Done,
     /* 161389 */ // Label 2295: @161389
     /* 161389 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(161423), // Rule ID 1419 //
     /* 161394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161403 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161410 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (VSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161415 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161417 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161419 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161421 */   GIR_RootConstrainSelectedInstOperands,
     /* 161422 */   // GIR_Coverage, 1419,
     /* 161422 */   GIR_EraseRootFromParent_Done,
     /* 161423 */ // Label 2296: @161423
     /* 161423 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(161457), // Rule ID 1421 //
     /* 161428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161444 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (VSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161449 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161451 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161453 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161455 */   GIR_RootConstrainSelectedInstOperands,
     /* 161456 */   // GIR_Coverage, 1421,
     /* 161456 */   GIR_EraseRootFromParent_Done,
     /* 161457 */ // Label 2297: @161457
     /* 161457 */ GIM_Reject,
     /* 161458 */ // Label 2271: @161458
     /* 161458 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(161606),
     /* 161463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161476 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(161584), // Rule ID 1663 //
     /* 161481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161484 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161484 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161487 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161491 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161496 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161500 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161505 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161508 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161512 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161517 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161521 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161526 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161529 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161533 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161538 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161565 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161583 */     // GIR_Coverage, 1663,
     /* 161583 */     GIR_EraseRootFromParent_Done,
     /* 161584 */   // Label 2299: @161584
     /* 161584 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(161605), // Rule ID 1418 //
     /* 161589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161592 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (VSEL:{ *:[v8i16] } ?:{ *:[v8i16] }:$vC, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vA)
     /* 161592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161597 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161599 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161601 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161603 */     GIR_RootConstrainSelectedInstOperands,
     /* 161604 */     // GIR_Coverage, 1418,
     /* 161604 */     GIR_EraseRootFromParent_Done,
     /* 161605 */   // Label 2300: @161605
     /* 161605 */   GIM_Reject,
     /* 161606 */ // Label 2298: @161606
     /* 161606 */ GIM_Reject,
     /* 161607 */ // Label 2272: @161607
     /* 161607 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(161755),
     /* 161612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 161615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161625 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(161733), // Rule ID 1662 //
     /* 161630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161633 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161633 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161636 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161640 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161645 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161649 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161654 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161657 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161661 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161666 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161670 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161714 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161732 */     // GIR_Coverage, 1662,
     /* 161732 */     GIR_EraseRootFromParent_Done,
     /* 161733 */   // Label 2302: @161733
     /* 161733 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(161754), // Rule ID 1417 //
     /* 161738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161741 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (VSEL:{ *:[v16i8] } ?:{ *:[v16i8] }:$vC, ?:{ *:[v16i8] }:$vB, ?:{ *:[v16i8] }:$vA)
     /* 161741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161746 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161748 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161750 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161752 */     GIR_RootConstrainSelectedInstOperands,
     /* 161753 */     // GIR_Coverage, 1417,
     /* 161753 */     GIR_EraseRootFromParent_Done,
     /* 161754 */   // Label 2303: @161754
     /* 161754 */   GIM_Reject,
     /* 161755 */ // Label 2301: @161755
     /* 161755 */ GIM_Reject,
     /* 161756 */ // Label 2273: @161756
     /* 161756 */ GIM_Reject,
     /* 161757 */ // Label 34: @161757
     /* 161757 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2308*/ GIMT_Encode4(161886),
     /* 161768 */ /*GILLT_s32*//*Label 2304*/ GIMT_Encode4(161788),
     /* 161772 */ /*GILLT_s64*//*Label 2305*/ GIMT_Encode4(161811), GIMT_Encode4(0),
     /* 161780 */ /*GILLT_v2s64*//*Label 2306*/ GIMT_Encode4(161834),
     /* 161784 */ /*GILLT_v4s32*//*Label 2307*/ GIMT_Encode4(161860),
     /* 161788 */ // Label 2304: @161788
     /* 161788 */ GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(161810), // Rule ID 207 //
     /* 161793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 161796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 161803 */   // (mulhu:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 161803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /* 161808 */   GIR_RootConstrainSelectedInstOperands,
     /* 161809 */   // GIR_Coverage, 207,
     /* 161809 */   GIR_Done,
     /* 161810 */ // Label 2309: @161810
     /* 161810 */ GIM_Reject,
     /* 161811 */ // Label 2305: @161811
     /* 161811 */ GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(161833), // Rule ID 673 //
     /* 161816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 161819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 161826 */   // (mulhu:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 161826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /* 161831 */   GIR_RootConstrainSelectedInstOperands,
     /* 161832 */   // GIR_Coverage, 673,
     /* 161832 */   GIR_Done,
     /* 161833 */ // Label 2310: @161833
     /* 161833 */ GIM_Reject,
     /* 161834 */ // Label 2306: @161834
     /* 161834 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(161859), // Rule ID 1124 //
     /* 161839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 161842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161852 */   // (mulhu:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 161852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /* 161857 */   GIR_RootConstrainSelectedInstOperands,
     /* 161858 */   // GIR_Coverage, 1124,
     /* 161858 */   GIR_Done,
     /* 161859 */ // Label 2311: @161859
     /* 161859 */ GIM_Reject,
     /* 161860 */ // Label 2307: @161860
     /* 161860 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(161885), // Rule ID 1122 //
     /* 161865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 161868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161878 */   // (mulhu:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 161878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /* 161883 */   GIR_RootConstrainSelectedInstOperands,
     /* 161884 */   // GIR_Coverage, 1122,
     /* 161884 */   GIR_Done,
     /* 161885 */ // Label 2312: @161885
     /* 161885 */ GIM_Reject,
     /* 161886 */ // Label 2308: @161886
     /* 161886 */ GIM_Reject,
     /* 161887 */ // Label 35: @161887
     /* 161887 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2317*/ GIMT_Encode4(162016),
     /* 161898 */ /*GILLT_s32*//*Label 2313*/ GIMT_Encode4(161918),
     /* 161902 */ /*GILLT_s64*//*Label 2314*/ GIMT_Encode4(161941), GIMT_Encode4(0),
     /* 161910 */ /*GILLT_v2s64*//*Label 2315*/ GIMT_Encode4(161964),
     /* 161914 */ /*GILLT_v4s32*//*Label 2316*/ GIMT_Encode4(161990),
     /* 161918 */ // Label 2313: @161918
     /* 161918 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(161940), // Rule ID 206 //
     /* 161923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 161926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 161933 */   // (mulhs:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 161933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /* 161938 */   GIR_RootConstrainSelectedInstOperands,
     /* 161939 */   // GIR_Coverage, 206,
     /* 161939 */   GIR_Done,
     /* 161940 */ // Label 2318: @161940
     /* 161940 */ GIM_Reject,
     /* 161941 */ // Label 2314: @161941
     /* 161941 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(161963), // Rule ID 672 //
     /* 161946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 161949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 161956 */   // (mulhs:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 161956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /* 161961 */   GIR_RootConstrainSelectedInstOperands,
     /* 161962 */   // GIR_Coverage, 672,
     /* 161962 */   GIR_Done,
     /* 161963 */ // Label 2319: @161963
     /* 161963 */ GIM_Reject,
     /* 161964 */ // Label 2315: @161964
     /* 161964 */ GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(161989), // Rule ID 1123 //
     /* 161969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 161972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161982 */   // (mulhs:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 161982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /* 161987 */   GIR_RootConstrainSelectedInstOperands,
     /* 161988 */   // GIR_Coverage, 1123,
     /* 161988 */   GIR_Done,
     /* 161989 */ // Label 2320: @161989
     /* 161989 */ GIM_Reject,
     /* 161990 */ // Label 2316: @161990
     /* 161990 */ GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(162015), // Rule ID 1121 //
     /* 161995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 161998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162008 */   // (mulhs:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 162008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /* 162013 */   GIR_RootConstrainSelectedInstOperands,
     /* 162014 */   // GIR_Coverage, 1121,
     /* 162014 */   GIR_Done,
     /* 162015 */ // Label 2321: @162015
     /* 162015 */ GIM_Reject,
     /* 162016 */ // Label 2317: @162016
     /* 162016 */ GIM_Reject,
     /* 162017 */ // Label 36: @162017
     /* 162017 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2325*/ GIMT_Encode4(162118),
     /* 162028 */ /*GILLT_v4s32*//*Label 2322*/ GIMT_Encode4(162040),
     /* 162032 */ /*GILLT_v8s16*//*Label 2323*/ GIMT_Encode4(162066),
     /* 162036 */ /*GILLT_v16s8*//*Label 2324*/ GIMT_Encode4(162092),
     /* 162040 */ // Label 2322: @162040
     /* 162040 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(162065), // Rule ID 1296 //
     /* 162045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162058 */   // (uaddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /* 162063 */   GIR_RootConstrainSelectedInstOperands,
     /* 162064 */   // GIR_Coverage, 1296,
     /* 162064 */   GIR_Done,
     /* 162065 */ // Label 2326: @162065
     /* 162065 */ GIM_Reject,
     /* 162066 */ // Label 2323: @162066
     /* 162066 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(162091), // Rule ID 1294 //
     /* 162071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162084 */   // (uaddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /* 162089 */   GIR_RootConstrainSelectedInstOperands,
     /* 162090 */   // GIR_Coverage, 1294,
     /* 162090 */   GIR_Done,
     /* 162091 */ // Label 2327: @162091
     /* 162091 */ GIM_Reject,
     /* 162092 */ // Label 2324: @162092
     /* 162092 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(162117), // Rule ID 1292 //
     /* 162097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162110 */   // (uaddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /* 162115 */   GIR_RootConstrainSelectedInstOperands,
     /* 162116 */   // GIR_Coverage, 1292,
     /* 162116 */   GIR_Done,
     /* 162117 */ // Label 2328: @162117
     /* 162117 */ GIM_Reject,
     /* 162118 */ // Label 2325: @162118
     /* 162118 */ GIM_Reject,
     /* 162119 */ // Label 37: @162119
     /* 162119 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2332*/ GIMT_Encode4(162220),
     /* 162130 */ /*GILLT_v4s32*//*Label 2329*/ GIMT_Encode4(162142),
     /* 162134 */ /*GILLT_v8s16*//*Label 2330*/ GIMT_Encode4(162168),
     /* 162138 */ /*GILLT_v16s8*//*Label 2331*/ GIMT_Encode4(162194),
     /* 162142 */ // Label 2329: @162142
     /* 162142 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(162167), // Rule ID 1295 //
     /* 162147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162160 */   // (saddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /* 162165 */   GIR_RootConstrainSelectedInstOperands,
     /* 162166 */   // GIR_Coverage, 1295,
     /* 162166 */   GIR_Done,
     /* 162167 */ // Label 2333: @162167
     /* 162167 */ GIM_Reject,
     /* 162168 */ // Label 2330: @162168
     /* 162168 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(162193), // Rule ID 1293 //
     /* 162173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162186 */   // (saddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /* 162191 */   GIR_RootConstrainSelectedInstOperands,
     /* 162192 */   // GIR_Coverage, 1293,
     /* 162192 */   GIR_Done,
     /* 162193 */ // Label 2334: @162193
     /* 162193 */ GIM_Reject,
     /* 162194 */ // Label 2331: @162194
     /* 162194 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(162219), // Rule ID 1291 //
     /* 162199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162212 */   // (saddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /* 162217 */   GIR_RootConstrainSelectedInstOperands,
     /* 162218 */   // GIR_Coverage, 1291,
     /* 162218 */   GIR_Done,
     /* 162219 */ // Label 2335: @162219
     /* 162219 */ GIM_Reject,
     /* 162220 */ // Label 2332: @162220
     /* 162220 */ GIM_Reject,
     /* 162221 */ // Label 38: @162221
     /* 162221 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2339*/ GIMT_Encode4(162322),
     /* 162232 */ /*GILLT_v4s32*//*Label 2336*/ GIMT_Encode4(162244),
     /* 162236 */ /*GILLT_v8s16*//*Label 2337*/ GIMT_Encode4(162270),
     /* 162240 */ /*GILLT_v16s8*//*Label 2338*/ GIMT_Encode4(162296),
     /* 162244 */ // Label 2336: @162244
     /* 162244 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(162269), // Rule ID 1302 //
     /* 162249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162262 */   // (usubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /* 162267 */   GIR_RootConstrainSelectedInstOperands,
     /* 162268 */   // GIR_Coverage, 1302,
     /* 162268 */   GIR_Done,
     /* 162269 */ // Label 2340: @162269
     /* 162269 */ GIM_Reject,
     /* 162270 */ // Label 2337: @162270
     /* 162270 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(162295), // Rule ID 1300 //
     /* 162275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162288 */   // (usubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /* 162293 */   GIR_RootConstrainSelectedInstOperands,
     /* 162294 */   // GIR_Coverage, 1300,
     /* 162294 */   GIR_Done,
     /* 162295 */ // Label 2341: @162295
     /* 162295 */ GIM_Reject,
     /* 162296 */ // Label 2338: @162296
     /* 162296 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(162321), // Rule ID 1298 //
     /* 162301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162314 */   // (usubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /* 162319 */   GIR_RootConstrainSelectedInstOperands,
     /* 162320 */   // GIR_Coverage, 1298,
     /* 162320 */   GIR_Done,
     /* 162321 */ // Label 2342: @162321
     /* 162321 */ GIM_Reject,
     /* 162322 */ // Label 2339: @162322
     /* 162322 */ GIM_Reject,
     /* 162323 */ // Label 39: @162323
     /* 162323 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2346*/ GIMT_Encode4(162424),
     /* 162334 */ /*GILLT_v4s32*//*Label 2343*/ GIMT_Encode4(162346),
     /* 162338 */ /*GILLT_v8s16*//*Label 2344*/ GIMT_Encode4(162372),
     /* 162342 */ /*GILLT_v16s8*//*Label 2345*/ GIMT_Encode4(162398),
     /* 162346 */ // Label 2343: @162346
     /* 162346 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(162371), // Rule ID 1301 //
     /* 162351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162364 */   // (ssubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /* 162369 */   GIR_RootConstrainSelectedInstOperands,
     /* 162370 */   // GIR_Coverage, 1301,
     /* 162370 */   GIR_Done,
     /* 162371 */ // Label 2347: @162371
     /* 162371 */ GIM_Reject,
     /* 162372 */ // Label 2344: @162372
     /* 162372 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(162397), // Rule ID 1299 //
     /* 162377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162390 */   // (ssubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /* 162395 */   GIR_RootConstrainSelectedInstOperands,
     /* 162396 */   // GIR_Coverage, 1299,
     /* 162396 */   GIR_Done,
     /* 162397 */ // Label 2348: @162397
     /* 162397 */ GIM_Reject,
     /* 162398 */ // Label 2345: @162398
     /* 162398 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(162423), // Rule ID 1297 //
     /* 162403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162416 */   // (ssubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /* 162421 */   GIR_RootConstrainSelectedInstOperands,
     /* 162422 */   // GIR_Coverage, 1297,
     /* 162422 */   GIR_Done,
     /* 162423 */ // Label 2349: @162423
     /* 162423 */ GIM_Reject,
     /* 162424 */ // Label 2346: @162424
     /* 162424 */ GIM_Reject,
     /* 162425 */ // Label 40: @162425
     /* 162425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2355*/ GIMT_Encode4(162719),
     /* 162436 */ /*GILLT_s32*//*Label 2350*/ GIMT_Encode4(162456),
     /* 162440 */ /*GILLT_s64*//*Label 2351*/ GIMT_Encode4(162530),
     /* 162444 */ /*GILLT_s128*//*Label 2352*/ GIMT_Encode4(162608),
     /* 162448 */ /*GILLT_v2s64*//*Label 2353*/ GIMT_Encode4(162634),
     /* 162452 */ /*GILLT_v4s32*//*Label 2354*/ GIMT_Encode4(162664),
     /* 162456 */ // Label 2350: @162456
     /* 162456 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(162529),
     /* 162461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162467 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(162486), // Rule ID 949 //
     /* 162472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 162475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162479 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 162479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 162484 */     GIR_RootConstrainSelectedInstOperands,
     /* 162485 */     // GIR_Coverage, 949,
     /* 162485 */     GIR_Done,
     /* 162486 */   // Label 2357: @162486
     /* 162486 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(162509), // Rule ID 239 //
     /* 162491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162498 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 162498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 162503 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162507 */     GIR_RootConstrainSelectedInstOperands,
     /* 162508 */     // GIR_Coverage, 239,
     /* 162508 */     GIR_Done,
     /* 162509 */   // Label 2358: @162509
     /* 162509 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(162528), // Rule ID 579 //
     /* 162514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162521 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 162521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 162526 */     GIR_RootConstrainSelectedInstOperands,
     /* 162527 */     // GIR_Coverage, 579,
     /* 162527 */     GIR_Done,
     /* 162528 */   // Label 2359: @162528
     /* 162528 */   GIM_Reject,
     /* 162529 */ // Label 2356: @162529
     /* 162529 */ GIM_Reject,
     /* 162530 */ // Label 2351: @162530
     /* 162530 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(162607),
     /* 162535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162541 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(162564), // Rule ID 766 //
     /* 162546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162553 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 162558 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162562 */     GIR_RootConstrainSelectedInstOperands,
     /* 162563 */     // GIR_Coverage, 766,
     /* 162563 */     GIR_Done,
     /* 162564 */   // Label 2361: @162564
     /* 162564 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(162587), // Rule ID 237 //
     /* 162569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 162576 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 162576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 162581 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162585 */     GIR_RootConstrainSelectedInstOperands,
     /* 162586 */     // GIR_Coverage, 237,
     /* 162586 */     GIR_Done,
     /* 162587 */   // Label 2362: @162587
     /* 162587 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(162606), // Rule ID 558 //
     /* 162592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 162599 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 162599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 162604 */     GIR_RootConstrainSelectedInstOperands,
     /* 162605 */     // GIR_Coverage, 558,
     /* 162605 */     GIR_Done,
     /* 162606 */   // Label 2363: @162606
     /* 162606 */   GIM_Reject,
     /* 162607 */ // Label 2360: @162607
     /* 162607 */ GIM_Reject,
     /* 162608 */ // Label 2352: @162608
     /* 162608 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(162633), // Rule ID 984 //
     /* 162613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 162616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 162619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 162622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162626 */   // (fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 162626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 162631 */   GIR_RootConstrainSelectedInstOperands,
     /* 162632 */   // GIR_Coverage, 984,
     /* 162632 */   GIR_Done,
     /* 162633 */ // Label 2364: @162633
     /* 162633 */ GIM_Reject,
     /* 162634 */ // Label 2353: @162634
     /* 162634 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(162663), // Rule ID 770 //
     /* 162639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162652 */   // (fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 162652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 162657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162661 */   GIR_RootConstrainSelectedInstOperands,
     /* 162662 */   // GIR_Coverage, 770,
     /* 162662 */   GIR_Done,
     /* 162663 */ // Label 2365: @162663
     /* 162663 */ GIM_Reject,
     /* 162664 */ // Label 2354: @162664
     /* 162664 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(162718),
     /* 162669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162675 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(162698), // Rule ID 772 //
     /* 162680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162687 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 162687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 162692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162696 */     GIR_RootConstrainSelectedInstOperands,
     /* 162697 */     // GIR_Coverage, 772,
     /* 162697 */     GIR_Done,
     /* 162698 */   // Label 2367: @162698
     /* 162698 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(162717), // Rule ID 300 //
     /* 162703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162710 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 162710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDFP),
     /* 162715 */     GIR_RootConstrainSelectedInstOperands,
     /* 162716 */     // GIR_Coverage, 300,
     /* 162716 */     GIR_Done,
     /* 162717 */   // Label 2368: @162717
     /* 162717 */   GIM_Reject,
     /* 162718 */ // Label 2366: @162718
     /* 162718 */ GIM_Reject,
     /* 162719 */ // Label 2355: @162719
     /* 162719 */ GIM_Reject,
     /* 162720 */ // Label 41: @162720
     /* 162720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2374*/ GIMT_Encode4(163014),
     /* 162731 */ /*GILLT_s32*//*Label 2369*/ GIMT_Encode4(162751),
     /* 162735 */ /*GILLT_s64*//*Label 2370*/ GIMT_Encode4(162825),
     /* 162739 */ /*GILLT_s128*//*Label 2371*/ GIMT_Encode4(162903),
     /* 162743 */ /*GILLT_v2s64*//*Label 2372*/ GIMT_Encode4(162929),
     /* 162747 */ /*GILLT_v4s32*//*Label 2373*/ GIMT_Encode4(162959),
     /* 162751 */ // Label 2369: @162751
     /* 162751 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(162824),
     /* 162756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162762 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(162781), // Rule ID 953 //
     /* 162767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 162770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162774 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 162774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 162779 */     GIR_RootConstrainSelectedInstOperands,
     /* 162780 */     // GIR_Coverage, 953,
     /* 162780 */     GIR_Done,
     /* 162781 */   // Label 2376: @162781
     /* 162781 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(162804), // Rule ID 251 //
     /* 162786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162793 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 162793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 162798 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162802 */     GIR_RootConstrainSelectedInstOperands,
     /* 162803 */     // GIR_Coverage, 251,
     /* 162803 */     GIR_Done,
     /* 162804 */   // Label 2377: @162804
     /* 162804 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(162823), // Rule ID 597 //
     /* 162809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162816 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 162816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 162821 */     GIR_RootConstrainSelectedInstOperands,
     /* 162822 */     // GIR_Coverage, 597,
     /* 162822 */     GIR_Done,
     /* 162823 */   // Label 2378: @162823
     /* 162823 */   GIM_Reject,
     /* 162824 */ // Label 2375: @162824
     /* 162824 */ GIM_Reject,
     /* 162825 */ // Label 2370: @162825
     /* 162825 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(162902),
     /* 162830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162836 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(162859), // Rule ID 778 //
     /* 162841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162848 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 162853 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162857 */     GIR_RootConstrainSelectedInstOperands,
     /* 162858 */     // GIR_Coverage, 778,
     /* 162858 */     GIR_Done,
     /* 162859 */   // Label 2380: @162859
     /* 162859 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(162882), // Rule ID 249 //
     /* 162864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 162871 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 162871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 162876 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162880 */     GIR_RootConstrainSelectedInstOperands,
     /* 162881 */     // GIR_Coverage, 249,
     /* 162881 */     GIR_Done,
     /* 162882 */   // Label 2381: @162882
     /* 162882 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(162901), // Rule ID 576 //
     /* 162887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 162894 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 162894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 162899 */     GIR_RootConstrainSelectedInstOperands,
     /* 162900 */     // GIR_Coverage, 576,
     /* 162900 */     GIR_Done,
     /* 162901 */   // Label 2382: @162901
     /* 162901 */   GIM_Reject,
     /* 162902 */ // Label 2379: @162902
     /* 162902 */ GIM_Reject,
     /* 162903 */ // Label 2371: @162903
     /* 162903 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(162928), // Rule ID 988 //
     /* 162908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 162911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 162914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 162917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162921 */   // (fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 162921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 162926 */   GIR_RootConstrainSelectedInstOperands,
     /* 162927 */   // GIR_Coverage, 988,
     /* 162927 */   GIR_Done,
     /* 162928 */ // Label 2383: @162928
     /* 162928 */ GIM_Reject,
     /* 162929 */ // Label 2372: @162929
     /* 162929 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(162958), // Rule ID 780 //
     /* 162934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162947 */   // (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 162947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 162952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162956 */   GIR_RootConstrainSelectedInstOperands,
     /* 162957 */   // GIR_Coverage, 780,
     /* 162957 */   GIR_Done,
     /* 162958 */ // Label 2384: @162958
     /* 162958 */ GIM_Reject,
     /* 162959 */ // Label 2373: @162959
     /* 162959 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(163013),
     /* 162964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162970 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(162993), // Rule ID 782 //
     /* 162975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162982 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 162982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 162987 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162991 */     GIR_RootConstrainSelectedInstOperands,
     /* 162992 */     // GIR_Coverage, 782,
     /* 162992 */     GIR_Done,
     /* 162993 */   // Label 2386: @162993
     /* 162993 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(163012), // Rule ID 370 //
     /* 162998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163005 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 163005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBFP),
     /* 163010 */     GIR_RootConstrainSelectedInstOperands,
     /* 163011 */     // GIR_Coverage, 370,
     /* 163011 */     GIR_Done,
     /* 163012 */   // Label 2387: @163012
     /* 163012 */   GIM_Reject,
     /* 163013 */ // Label 2385: @163013
     /* 163013 */ GIM_Reject,
     /* 163014 */ // Label 2374: @163014
     /* 163014 */ GIM_Reject,
     /* 163015 */ // Label 42: @163015
     /* 163015 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2393*/ GIMT_Encode4(163364),
     /* 163026 */ /*GILLT_s32*//*Label 2388*/ GIMT_Encode4(163046),
     /* 163030 */ /*GILLT_s64*//*Label 2389*/ GIMT_Encode4(163120),
     /* 163034 */ /*GILLT_s128*//*Label 2390*/ GIMT_Encode4(163198),
     /* 163038 */ /*GILLT_v2s64*//*Label 2391*/ GIMT_Encode4(163224),
     /* 163042 */ /*GILLT_v4s32*//*Label 2392*/ GIMT_Encode4(163254),
     /* 163046 */ // Label 2388: @163046
     /* 163046 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(163119),
     /* 163051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163057 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(163076), // Rule ID 951 //
     /* 163062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163069 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 163074 */     GIR_RootConstrainSelectedInstOperands,
     /* 163075 */     // GIR_Coverage, 951,
     /* 163075 */     GIR_Done,
     /* 163076 */   // Label 2395: @163076
     /* 163076 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(163099), // Rule ID 247 //
     /* 163081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163088 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 163088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 163093 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163097 */     GIR_RootConstrainSelectedInstOperands,
     /* 163098 */     // GIR_Coverage, 247,
     /* 163098 */     GIR_Done,
     /* 163099 */   // Label 2396: @163099
     /* 163099 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(163118), // Rule ID 593 //
     /* 163104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 163111 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 163111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 163116 */     GIR_RootConstrainSelectedInstOperands,
     /* 163117 */     // GIR_Coverage, 593,
     /* 163117 */     GIR_Done,
     /* 163118 */   // Label 2397: @163118
     /* 163118 */   GIM_Reject,
     /* 163119 */ // Label 2394: @163119
     /* 163119 */ GIM_Reject,
     /* 163120 */ // Label 2389: @163120
     /* 163120 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(163197),
     /* 163125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163131 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(163154), // Rule ID 768 //
     /* 163136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163143 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 163148 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163152 */     GIR_RootConstrainSelectedInstOperands,
     /* 163153 */     // GIR_Coverage, 768,
     /* 163153 */     GIR_Done,
     /* 163154 */   // Label 2399: @163154
     /* 163154 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(163177), // Rule ID 245 //
     /* 163159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163166 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 163166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 163171 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163175 */     GIR_RootConstrainSelectedInstOperands,
     /* 163176 */     // GIR_Coverage, 245,
     /* 163176 */     GIR_Done,
     /* 163177 */   // Label 2400: @163177
     /* 163177 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(163196), // Rule ID 572 //
     /* 163182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 163189 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 163189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 163194 */     GIR_RootConstrainSelectedInstOperands,
     /* 163195 */     // GIR_Coverage, 572,
     /* 163195 */     GIR_Done,
     /* 163196 */   // Label 2401: @163196
     /* 163196 */   GIM_Reject,
     /* 163197 */ // Label 2398: @163197
     /* 163197 */ GIM_Reject,
     /* 163198 */ // Label 2390: @163198
     /* 163198 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(163223), // Rule ID 986 //
     /* 163203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 163209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 163212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163216 */   // (fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 163221 */   GIR_RootConstrainSelectedInstOperands,
     /* 163222 */   // GIR_Coverage, 986,
     /* 163222 */   GIR_Done,
     /* 163223 */ // Label 2402: @163223
     /* 163223 */ GIM_Reject,
     /* 163224 */ // Label 2391: @163224
     /* 163224 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(163253), // Rule ID 774 //
     /* 163229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163242 */   // (fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 163247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163251 */   GIR_RootConstrainSelectedInstOperands,
     /* 163252 */   // GIR_Coverage, 774,
     /* 163252 */   GIR_Done,
     /* 163253 */ // Label 2403: @163253
     /* 163253 */ GIM_Reject,
     /* 163254 */ // Label 2392: @163254
     /* 163254 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(163363),
     /* 163259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163265 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(163288), // Rule ID 776 //
     /* 163270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163277 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 163282 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163286 */     GIR_RootConstrainSelectedInstOperands,
     /* 163287 */     // GIR_Coverage, 776,
     /* 163287 */     GIR_Done,
     /* 163288 */   // Label 2405: @163288
     /* 163288 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(163362), // Rule ID 1379 //
     /* 163293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163300 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA, v4f32:{ *:[v4f32] }:$vB)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA, ?:{ *:[v4f32] }:$vB, (VSLW:{ *:[v4i32] } (V_SETALLONES:{ *:[v4i32] }), (V_SETALLONES:{ *:[v4i32] })))
     /* 163300 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 163303 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 163307 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 163314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 163317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 163321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 163331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 163335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163340 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 163343 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 163346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 163351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 163353 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 163355 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 163357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163360 */     GIR_RootConstrainSelectedInstOperands,
     /* 163361 */     // GIR_Coverage, 1379,
     /* 163361 */     GIR_EraseRootFromParent_Done,
     /* 163362 */   // Label 2406: @163362
     /* 163362 */   GIM_Reject,
     /* 163363 */ // Label 2404: @163363
     /* 163363 */ GIM_Reject,
     /* 163364 */ // Label 2393: @163364
     /* 163364 */ GIM_Reject,
     /* 163365 */ // Label 43: @163365
     /* 163365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2412*/ GIMT_Encode4(163945),
     /* 163376 */ /*GILLT_s32*//*Label 2407*/ GIMT_Encode4(163396),
     /* 163380 */ /*GILLT_s64*//*Label 2408*/ GIMT_Encode4(163542),
     /* 163384 */ /*GILLT_s128*//*Label 2409*/ GIMT_Encode4(163688),
     /* 163388 */ /*GILLT_v2s64*//*Label 2410*/ GIMT_Encode4(163766),
     /* 163392 */ /*GILLT_v4s32*//*Label 2411*/ GIMT_Encode4(163844),
     /* 163396 */ // Label 2407: @163396
     /* 163396 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(163541),
     /* 163401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163410 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(163451), // Rule ID 965 //
     /* 163415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 163434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163436 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 163439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163445 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163447 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163449 */     GIR_RootConstrainSelectedInstOperands,
     /* 163450 */     // GIR_Coverage, 965,
     /* 163450 */     GIR_EraseRootFromParent_Done,
     /* 163451 */   // Label 2414: @163451
     /* 163451 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(163476), // Rule ID 963 //
     /* 163456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163463 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 163466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163468 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163470 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163472 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163474 */     GIR_RootConstrainSelectedInstOperands,
     /* 163475 */     // GIR_Coverage, 963,
     /* 163475 */     GIR_EraseRootFromParent_Done,
     /* 163476 */   // Label 2415: @163476
     /* 163476 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(163517), // Rule ID 225 //
     /* 163481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 163500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163502 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 163502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 163505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163507 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 163509 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 163511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 163515 */     GIR_RootConstrainSelectedInstOperands,
     /* 163516 */     // GIR_Coverage, 225,
     /* 163516 */     GIR_EraseRootFromParent_Done,
     /* 163517 */   // Label 2416: @163517
     /* 163517 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(163540), // Rule ID 221 //
     /* 163522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163529 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 163529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 163534 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163538 */     GIR_RootConstrainSelectedInstOperands,
     /* 163539 */     // GIR_Coverage, 221,
     /* 163539 */     GIR_Done,
     /* 163540 */   // Label 2417: @163540
     /* 163540 */   GIM_Reject,
     /* 163541 */ // Label 2413: @163541
     /* 163541 */ GIM_Reject,
     /* 163542 */ // Label 2408: @163542
     /* 163542 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(163687),
     /* 163547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163556 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(163597), // Rule ID 786 //
     /* 163561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163582 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 163585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163591 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163593 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163595 */     GIR_RootConstrainSelectedInstOperands,
     /* 163596 */     // GIR_Coverage, 786,
     /* 163596 */     GIR_EraseRootFromParent_Done,
     /* 163597 */   // Label 2419: @163597
     /* 163597 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(163622), // Rule ID 784 //
     /* 163602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163609 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 163612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163614 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163616 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163618 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163620 */     GIR_RootConstrainSelectedInstOperands,
     /* 163621 */     // GIR_Coverage, 784,
     /* 163621 */     GIR_EraseRootFromParent_Done,
     /* 163622 */   // Label 2420: @163622
     /* 163622 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(163663), // Rule ID 223 //
     /* 163627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163648 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 163651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163653 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 163655 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 163657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 163661 */     GIR_RootConstrainSelectedInstOperands,
     /* 163662 */     // GIR_Coverage, 223,
     /* 163662 */     GIR_EraseRootFromParent_Done,
     /* 163663 */   // Label 2421: @163663
     /* 163663 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(163686), // Rule ID 219 //
     /* 163668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163675 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 163680 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163684 */     GIR_RootConstrainSelectedInstOperands,
     /* 163685 */     // GIR_Coverage, 219,
     /* 163685 */     GIR_Done,
     /* 163686 */   // Label 2422: @163686
     /* 163686 */   GIM_Reject,
     /* 163687 */ // Label 2418: @163687
     /* 163687 */ GIM_Reject,
     /* 163688 */ // Label 2409: @163688
     /* 163688 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(163765),
     /* 163693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 163696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 163699 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 163702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163706 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(163743), // Rule ID 996 //
     /* 163711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 163726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163728 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 163731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 163737 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 163739 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 163741 */     GIR_RootConstrainSelectedInstOperands,
     /* 163742 */     // GIR_Coverage, 996,
     /* 163742 */     GIR_EraseRootFromParent_Done,
     /* 163743 */   // Label 2424: @163743
     /* 163743 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(163764), // Rule ID 994 //
     /* 163748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163751 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 163754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163756 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 163758 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 163760 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 163762 */     GIR_RootConstrainSelectedInstOperands,
     /* 163763 */     // GIR_Coverage, 994,
     /* 163763 */     GIR_EraseRootFromParent_Done,
     /* 163764 */   // Label 2425: @163764
     /* 163764 */   GIM_Reject,
     /* 163765 */ // Label 2423: @163765
     /* 163765 */ GIM_Reject,
     /* 163766 */ // Label 2410: @163766
     /* 163766 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(163843),
     /* 163771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163777 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163784 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(163821), // Rule ID 796 //
     /* 163789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163806 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 163809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163815 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163817 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163819 */     GIR_RootConstrainSelectedInstOperands,
     /* 163820 */     // GIR_Coverage, 796,
     /* 163820 */     GIR_EraseRootFromParent_Done,
     /* 163821 */   // Label 2427: @163821
     /* 163821 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(163842), // Rule ID 792 //
     /* 163826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163829 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 163832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163834 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163836 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163838 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163840 */     GIR_RootConstrainSelectedInstOperands,
     /* 163841 */     // GIR_Coverage, 792,
     /* 163841 */     GIR_EraseRootFromParent_Done,
     /* 163842 */   // Label 2428: @163842
     /* 163842 */   GIM_Reject,
     /* 163843 */ // Label 2426: @163843
     /* 163843 */ GIM_Reject,
     /* 163844 */ // Label 2411: @163844
     /* 163844 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(163944),
     /* 163849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163855 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163858 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(163899), // Rule ID 798 //
     /* 163863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163884 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 163887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163893 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163895 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163897 */     GIR_RootConstrainSelectedInstOperands,
     /* 163898 */     // GIR_Coverage, 798,
     /* 163898 */     GIR_EraseRootFromParent_Done,
     /* 163899 */   // Label 2430: @163899
     /* 163899 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(163924), // Rule ID 794 //
     /* 163904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163911 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 163914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163916 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163918 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163920 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163922 */     GIR_RootConstrainSelectedInstOperands,
     /* 163923 */     // GIR_Coverage, 794,
     /* 163923 */     GIR_EraseRootFromParent_Done,
     /* 163924 */   // Label 2431: @163924
     /* 163924 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(163943), // Rule ID 292 //
     /* 163929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163936 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)  =>  (VMADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 163936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 163941 */     GIR_RootConstrainSelectedInstOperands,
     /* 163942 */     // GIR_Coverage, 292,
     /* 163942 */     GIR_Done,
     /* 163943 */   // Label 2432: @163943
     /* 163943 */   GIM_Reject,
     /* 163944 */ // Label 2429: @163944
     /* 163944 */ GIM_Reject,
     /* 163945 */ // Label 2412: @163945
     /* 163945 */ GIM_Reject,
     /* 163946 */ // Label 44: @163946
     /* 163946 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2438*/ GIMT_Encode4(164215),
     /* 163957 */ /*GILLT_s32*//*Label 2433*/ GIMT_Encode4(163977),
     /* 163961 */ /*GILLT_s64*//*Label 2434*/ GIMT_Encode4(164051),
     /* 163965 */ /*GILLT_s128*//*Label 2435*/ GIMT_Encode4(164129),
     /* 163969 */ /*GILLT_v2s64*//*Label 2436*/ GIMT_Encode4(164155),
     /* 163973 */ /*GILLT_v4s32*//*Label 2437*/ GIMT_Encode4(164185),
     /* 163977 */ // Label 2433: @163977
     /* 163977 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(164050),
     /* 163982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163988 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(164007), // Rule ID 955 //
     /* 163993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164000 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 164005 */     GIR_RootConstrainSelectedInstOperands,
     /* 164006 */     // GIR_Coverage, 955,
     /* 164006 */     GIR_Done,
     /* 164007 */   // Label 2440: @164007
     /* 164007 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(164030), // Rule ID 243 //
     /* 164012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164019 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 164019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 164024 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164028 */     GIR_RootConstrainSelectedInstOperands,
     /* 164029 */     // GIR_Coverage, 243,
     /* 164029 */     GIR_Done,
     /* 164030 */   // Label 2441: @164030
     /* 164030 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(164049), // Rule ID 591 //
     /* 164035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164042 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 164042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 164047 */     GIR_RootConstrainSelectedInstOperands,
     /* 164048 */     // GIR_Coverage, 591,
     /* 164048 */     GIR_Done,
     /* 164049 */   // Label 2442: @164049
     /* 164049 */   GIM_Reject,
     /* 164050 */ // Label 2439: @164050
     /* 164050 */ GIM_Reject,
     /* 164051 */ // Label 2434: @164051
     /* 164051 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(164128),
     /* 164056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164062 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(164085), // Rule ID 807 //
     /* 164067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164074 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 164074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 164079 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164083 */     GIR_RootConstrainSelectedInstOperands,
     /* 164084 */     // GIR_Coverage, 807,
     /* 164084 */     GIR_Done,
     /* 164085 */   // Label 2444: @164085
     /* 164085 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(164108), // Rule ID 241 //
     /* 164090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 164097 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 164097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 164102 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164106 */     GIR_RootConstrainSelectedInstOperands,
     /* 164107 */     // GIR_Coverage, 241,
     /* 164107 */     GIR_Done,
     /* 164108 */   // Label 2445: @164108
     /* 164108 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(164127), // Rule ID 570 //
     /* 164113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 164120 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 164120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 164125 */     GIR_RootConstrainSelectedInstOperands,
     /* 164126 */     // GIR_Coverage, 570,
     /* 164126 */     GIR_Done,
     /* 164127 */   // Label 2446: @164127
     /* 164127 */   GIM_Reject,
     /* 164128 */ // Label 2443: @164128
     /* 164128 */ GIM_Reject,
     /* 164129 */ // Label 2435: @164129
     /* 164129 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(164154), // Rule ID 990 //
     /* 164134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 164143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164147 */   // (fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 164147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 164152 */   GIR_RootConstrainSelectedInstOperands,
     /* 164153 */   // GIR_Coverage, 990,
     /* 164153 */   GIR_Done,
     /* 164154 */ // Label 2447: @164154
     /* 164154 */ GIM_Reject,
     /* 164155 */ // Label 2436: @164155
     /* 164155 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(164184), // Rule ID 816 //
     /* 164160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 164166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164173 */   // (fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 164173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 164178 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164182 */   GIR_RootConstrainSelectedInstOperands,
     /* 164183 */   // GIR_Coverage, 816,
     /* 164183 */   GIR_Done,
     /* 164184 */ // Label 2448: @164184
     /* 164184 */ GIM_Reject,
     /* 164185 */ // Label 2437: @164185
     /* 164185 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(164214), // Rule ID 818 //
     /* 164190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164203 */   // (fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 164208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164212 */   GIR_RootConstrainSelectedInstOperands,
     /* 164213 */   // GIR_Coverage, 818,
     /* 164213 */   GIR_Done,
     /* 164214 */ // Label 2449: @164214
     /* 164214 */ GIM_Reject,
     /* 164215 */ // Label 2438: @164215
     /* 164215 */ GIM_Reject,
     /* 164216 */ // Label 45: @164216
     /* 164216 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2455*/ GIMT_Encode4(166686),
     /* 164227 */ /*GILLT_s32*//*Label 2450*/ GIMT_Encode4(164247),
     /* 164231 */ /*GILLT_s64*//*Label 2451*/ GIMT_Encode4(165020),
     /* 164235 */ /*GILLT_s128*//*Label 2452*/ GIMT_Encode4(165674),
     /* 164239 */ /*GILLT_v2s64*//*Label 2453*/ GIMT_Encode4(166082),
     /* 164243 */ /*GILLT_v4s32*//*Label 2454*/ GIMT_Encode4(166368),
     /* 164247 */ // Label 2450: @164247
     /* 164247 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(165019),
     /* 164252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164255 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(164320), // Rule ID 969 //
     /* 164260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164283 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164301 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 164304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164318 */     GIR_RootConstrainSelectedInstOperands,
     /* 164319 */     // GIR_Coverage, 969,
     /* 164319 */     GIR_EraseRootFromParent_Done,
     /* 164320 */   // Label 2457: @164320
     /* 164320 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(164385), // Rule ID 968 //
     /* 164325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164348 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164366 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 164369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164383 */     GIR_RootConstrainSelectedInstOperands,
     /* 164384 */     // GIR_Coverage, 968,
     /* 164384 */     GIR_EraseRootFromParent_Done,
     /* 164385 */   // Label 2458: @164385
     /* 164385 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(164438), // Rule ID 967 //
     /* 164390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164413 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164419 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 164422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 164428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164436 */     GIR_RootConstrainSelectedInstOperands,
     /* 164437 */     // GIR_Coverage, 967,
     /* 164437 */     GIR_EraseRootFromParent_Done,
     /* 164438 */   // Label 2459: @164438
     /* 164438 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(164491), // Rule ID 966 //
     /* 164443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164466 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164472 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 164475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 164481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164489 */     GIR_RootConstrainSelectedInstOperands,
     /* 164490 */     // GIR_Coverage, 966,
     /* 164490 */     GIR_EraseRootFromParent_Done,
     /* 164491 */   // Label 2460: @164491
     /* 164491 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(164528), // Rule ID 841 //
     /* 164496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164517 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$XB))  =>  (XSNABSDPs:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 164517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /* 164520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 164526 */     GIR_RootConstrainSelectedInstOperands,
     /* 164527 */     // GIR_Coverage, 841,
     /* 164527 */     GIR_EraseRootFromParent_Done,
     /* 164528 */   // Label 2461: @164528
     /* 164528 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(164606), // Rule ID 1678 //
     /* 164533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164554 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$S))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 164554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 164557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // S
     /* 164570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 164582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164605 */     // GIR_Coverage, 1678,
     /* 164605 */     GIR_EraseRootFromParent_Done,
     /* 164606 */   // Label 2462: @164606
     /* 164606 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(164670), // Rule ID 1919 //
     /* 164611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164618 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNEGDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 164618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 164621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164630 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 164634 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 164646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164669 */     // GIR_Coverage, 1919,
     /* 164669 */     GIR_EraseRootFromParent_Done,
     /* 164670 */   // Label 2463: @164670
     /* 164670 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(164735), // Rule ID 233 //
     /* 164675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164698 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164716 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 164716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 164719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 164721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 164725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 164729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 164733 */     GIR_RootConstrainSelectedInstOperands,
     /* 164734 */     // GIR_Coverage, 233,
     /* 164734 */     GIR_EraseRootFromParent_Done,
     /* 164735 */   // Label 2464: @164735
     /* 164735 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(164800), // Rule ID 232 //
     /* 164740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164763 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164781 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 164781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 164784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 164786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 164790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 164794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 164798 */     GIR_RootConstrainSelectedInstOperands,
     /* 164799 */     // GIR_Coverage, 232,
     /* 164799 */     GIR_EraseRootFromParent_Done,
     /* 164800 */   // Label 2465: @164800
     /* 164800 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(164853), // Rule ID 229 //
     /* 164805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164834 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 164834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 164837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 164839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 164843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 164847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 164851 */     GIR_RootConstrainSelectedInstOperands,
     /* 164852 */     // GIR_Coverage, 229,
     /* 164852 */     GIR_EraseRootFromParent_Done,
     /* 164853 */   // Label 2466: @164853
     /* 164853 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(164906), // Rule ID 228 //
     /* 164858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164881 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164887 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 164887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 164890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 164892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 164896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 164900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 164904 */     GIR_RootConstrainSelectedInstOperands,
     /* 164905 */     // GIR_Coverage, 228,
     /* 164905 */     GIR_EraseRootFromParent_Done,
     /* 164906 */   // Label 2467: @164906
     /* 164906 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(164943), // Rule ID 165 //
     /* 164911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164932 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB))  =>  (FNABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 164932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /* 164935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 164937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 164941 */     GIR_RootConstrainSelectedInstOperands,
     /* 164942 */     // GIR_Coverage, 165,
     /* 164942 */     GIR_EraseRootFromParent_Done,
     /* 164943 */   // Label 2468: @164943
     /* 164943 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(164980), // Rule ID 594 //
     /* 164948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164969 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA))  =>  (EFSNABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 164969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFSNABS),
     /* 164972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 164974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 164978 */     GIR_RootConstrainSelectedInstOperands,
     /* 164979 */     // GIR_Coverage, 594,
     /* 164979 */     GIR_EraseRootFromParent_Done,
     /* 164980 */   // Label 2469: @164980
     /* 164980 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(164999), // Rule ID 167 //
     /* 164985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164992 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FNEGS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 164992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGS),
     /* 164997 */     GIR_RootConstrainSelectedInstOperands,
     /* 164998 */     // GIR_Coverage, 167,
     /* 164998 */     GIR_Done,
     /* 164999 */   // Label 2470: @164999
     /* 164999 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(165018), // Rule ID 595 //
     /* 165004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 165011 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSNEG:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 165011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSNEG),
     /* 165016 */     GIR_RootConstrainSelectedInstOperands,
     /* 165017 */     // GIR_Coverage, 595,
     /* 165017 */     GIR_Done,
     /* 165018 */   // Label 2471: @165018
     /* 165018 */   GIM_Reject,
     /* 165019 */ // Label 2456: @165019
     /* 165019 */ GIM_Reject,
     /* 165020 */ // Label 2451: @165020
     /* 165020 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(165673),
     /* 165025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 165028 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(165093), // Rule ID 790 //
     /* 165033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165056 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165074 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 165077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 165083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165091 */     GIR_RootConstrainSelectedInstOperands,
     /* 165092 */     // GIR_Coverage, 790,
     /* 165092 */     GIR_EraseRootFromParent_Done,
     /* 165093 */   // Label 2473: @165093
     /* 165093 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(165158), // Rule ID 789 //
     /* 165098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165121 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165139 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 165142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 165148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165156 */     GIR_RootConstrainSelectedInstOperands,
     /* 165157 */     // GIR_Coverage, 789,
     /* 165157 */     GIR_EraseRootFromParent_Done,
     /* 165158 */   // Label 2474: @165158
     /* 165158 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(165211), // Rule ID 788 //
     /* 165163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165186 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165192 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 165195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 165201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165209 */     GIR_RootConstrainSelectedInstOperands,
     /* 165210 */     // GIR_Coverage, 788,
     /* 165210 */     GIR_EraseRootFromParent_Done,
     /* 165211 */   // Label 2475: @165211
     /* 165211 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(165264), // Rule ID 787 //
     /* 165216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165239 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165245 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 165248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 165254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165262 */     GIR_RootConstrainSelectedInstOperands,
     /* 165263 */     // GIR_Coverage, 787,
     /* 165263 */     GIR_EraseRootFromParent_Done,
     /* 165264 */   // Label 2476: @165264
     /* 165264 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(165301), // Rule ID 840 //
     /* 165269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165290 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB))  =>  (XSNABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 165290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 165293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 165299 */     GIR_RootConstrainSelectedInstOperands,
     /* 165300 */     // GIR_Coverage, 840,
     /* 165300 */     GIR_EraseRootFromParent_Done,
     /* 165301 */   // Label 2477: @165301
     /* 165301 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(165324), // Rule ID 842 //
     /* 165306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165313 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSNEGDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 165313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 165318 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165322 */     GIR_RootConstrainSelectedInstOperands,
     /* 165323 */     // GIR_Coverage, 842,
     /* 165323 */     GIR_Done,
     /* 165324 */   // Label 2478: @165324
     /* 165324 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(165389), // Rule ID 231 //
     /* 165329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165352 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165370 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 165373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165387 */     GIR_RootConstrainSelectedInstOperands,
     /* 165388 */     // GIR_Coverage, 231,
     /* 165388 */     GIR_EraseRootFromParent_Done,
     /* 165389 */   // Label 2479: @165389
     /* 165389 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(165454), // Rule ID 230 //
     /* 165394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165417 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165435 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 165438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165452 */     GIR_RootConstrainSelectedInstOperands,
     /* 165453 */     // GIR_Coverage, 230,
     /* 165453 */     GIR_EraseRootFromParent_Done,
     /* 165454 */   // Label 2480: @165454
     /* 165454 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(165507), // Rule ID 227 //
     /* 165459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165482 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165488 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 165491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165505 */     GIR_RootConstrainSelectedInstOperands,
     /* 165506 */     // GIR_Coverage, 227,
     /* 165506 */     GIR_EraseRootFromParent_Done,
     /* 165507 */   // Label 2481: @165507
     /* 165507 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(165560), // Rule ID 226 //
     /* 165512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165535 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165541 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 165544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165558 */     GIR_RootConstrainSelectedInstOperands,
     /* 165559 */     // GIR_Coverage, 226,
     /* 165559 */     GIR_EraseRootFromParent_Done,
     /* 165560 */   // Label 2482: @165560
     /* 165560 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(165597), // Rule ID 166 //
     /* 165565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165586 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB))  =>  (FNABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 165586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /* 165589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 165595 */     GIR_RootConstrainSelectedInstOperands,
     /* 165596 */     // GIR_Coverage, 166,
     /* 165596 */     GIR_EraseRootFromParent_Done,
     /* 165597 */   // Label 2483: @165597
     /* 165597 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(165634), // Rule ID 573 //
     /* 165602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165623 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA))  =>  (EFDNABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 165623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFDNABS),
     /* 165626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 165628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165632 */     GIR_RootConstrainSelectedInstOperands,
     /* 165633 */     // GIR_Coverage, 573,
     /* 165633 */     GIR_EraseRootFromParent_Done,
     /* 165634 */   // Label 2484: @165634
     /* 165634 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(165653), // Rule ID 168 //
     /* 165639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165646 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FNEGD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 165646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGD),
     /* 165651 */     GIR_RootConstrainSelectedInstOperands,
     /* 165652 */     // GIR_Coverage, 168,
     /* 165652 */     GIR_Done,
     /* 165653 */   // Label 2485: @165653
     /* 165653 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(165672), // Rule ID 574 //
     /* 165658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165665 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDNEG:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 165665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDNEG),
     /* 165670 */     GIR_RootConstrainSelectedInstOperands,
     /* 165671 */     // GIR_Coverage, 574,
     /* 165671 */     GIR_Done,
     /* 165672 */   // Label 2486: @165672
     /* 165672 */   GIM_Reject,
     /* 165673 */ // Label 2472: @165673
     /* 165673 */ GIM_Reject,
     /* 165674 */ // Label 2452: @165674
     /* 165674 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(166081),
     /* 165679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 165682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165686 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(165755), // Rule ID 1009 //
     /* 165691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 165702 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 165705 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 165710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165714 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165718 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 165722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/4, // MIs[2]
     /* 165726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 165734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165736 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10581:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQPO),
     /* 165739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 165745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 165749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 165753 */     GIR_RootConstrainSelectedInstOperands,
     /* 165754 */     // GIR_Coverage, 1009,
     /* 165754 */     GIR_EraseRootFromParent_Done,
     /* 165755 */   // Label 2488: @165755
     /* 165755 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(165812), // Rule ID 1008 //
     /* 165760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 165771 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 165774 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 165779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165783 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165787 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 165791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165793 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10581:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQPO),
     /* 165796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/4, // RSTi
     /* 165802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 165806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 165810 */     GIR_RootConstrainSelectedInstOperands,
     /* 165811 */     // GIR_Coverage, 1008,
     /* 165811 */     GIR_EraseRootFromParent_Done,
     /* 165812 */   // Label 2489: @165812
     /* 165812 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(165873), // Rule ID 1000 //
     /* 165817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 165832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 165852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165854 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 165857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 165863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 165871 */     GIR_RootConstrainSelectedInstOperands,
     /* 165872 */     // GIR_Coverage, 1000,
     /* 165872 */     GIR_EraseRootFromParent_Done,
     /* 165873 */   // Label 2490: @165873
     /* 165873 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(165934), // Rule ID 999 //
     /* 165878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 165893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165897 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 165913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165915 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 165918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 165924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 165932 */     GIR_RootConstrainSelectedInstOperands,
     /* 165933 */     // GIR_Coverage, 999,
     /* 165933 */     GIR_EraseRootFromParent_Done,
     /* 165934 */   // Label 2491: @165934
     /* 165934 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(165983), // Rule ID 998 //
     /* 165939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 165954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165958 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165964 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 165967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 165973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 165981 */     GIR_RootConstrainSelectedInstOperands,
     /* 165982 */     // GIR_Coverage, 998,
     /* 165982 */     GIR_EraseRootFromParent_Done,
     /* 165983 */   // Label 2492: @165983
     /* 165983 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(166032), // Rule ID 997 //
     /* 165988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166007 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166013 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 166016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 166022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166030 */     GIR_RootConstrainSelectedInstOperands,
     /* 166031 */     // GIR_Coverage, 997,
     /* 166031 */     GIR_EraseRootFromParent_Done,
     /* 166032 */   // Label 2493: @166032
     /* 166032 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(166065), // Rule ID 981 //
     /* 166037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166054 */     // (fneg:{ *:[f128] } (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB))  =>  (XSNABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 166054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSQP),
     /* 166057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 166063 */     GIR_RootConstrainSelectedInstOperands,
     /* 166064 */     // GIR_Coverage, 981,
     /* 166064 */     GIR_EraseRootFromParent_Done,
     /* 166065 */   // Label 2494: @166065
     /* 166065 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(166080), // Rule ID 982 //
     /* 166070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166073 */     // (fneg:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSNEGQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 166073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGQP),
     /* 166078 */     GIR_RootConstrainSelectedInstOperands,
     /* 166079 */     // GIR_Coverage, 982,
     /* 166079 */     GIR_Done,
     /* 166080 */   // Label 2495: @166080
     /* 166080 */   GIM_Reject,
     /* 166081 */ // Label 2487: @166081
     /* 166081 */ GIM_Reject,
     /* 166082 */ // Label 2453: @166082
     /* 166082 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(166367),
     /* 166087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166094 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(166155), // Rule ID 803 //
     /* 166099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166118 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166136 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 166139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166153 */     GIR_RootConstrainSelectedInstOperands,
     /* 166154 */     // GIR_Coverage, 803,
     /* 166154 */     GIR_EraseRootFromParent_Done,
     /* 166155 */   // Label 2497: @166155
     /* 166155 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(166216), // Rule ID 802 //
     /* 166160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166179 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166197 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 166200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166214 */     GIR_RootConstrainSelectedInstOperands,
     /* 166215 */     // GIR_Coverage, 802,
     /* 166215 */     GIR_EraseRootFromParent_Done,
     /* 166216 */   // Label 2498: @166216
     /* 166216 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(166265), // Rule ID 800 //
     /* 166221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166240 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166246 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 166249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166263 */     GIR_RootConstrainSelectedInstOperands,
     /* 166264 */     // GIR_Coverage, 800,
     /* 166264 */     GIR_EraseRootFromParent_Done,
     /* 166265 */   // Label 2499: @166265
     /* 166265 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(166314), // Rule ID 799 //
     /* 166270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166289 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166295 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 166298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166312 */     GIR_RootConstrainSelectedInstOperands,
     /* 166313 */     // GIR_Coverage, 799,
     /* 166313 */     GIR_EraseRootFromParent_Done,
     /* 166314 */   // Label 2500: @166314
     /* 166314 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(166347), // Rule ID 848 //
     /* 166319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166336 */     // (fneg:{ *:[v2f64] } (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB))  =>  (XVNABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 166336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSDP),
     /* 166339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 166345 */     GIR_RootConstrainSelectedInstOperands,
     /* 166346 */     // GIR_Coverage, 848,
     /* 166346 */     GIR_EraseRootFromParent_Done,
     /* 166347 */   // Label 2501: @166347
     /* 166347 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(166366), // Rule ID 850 //
     /* 166352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166355 */     // (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVNEGDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 166355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGDP),
     /* 166360 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166364 */     GIR_RootConstrainSelectedInstOperands,
     /* 166365 */     // GIR_Coverage, 850,
     /* 166365 */     GIR_Done,
     /* 166366 */   // Label 2502: @166366
     /* 166366 */   GIM_Reject,
     /* 166367 */ // Label 2496: @166367
     /* 166367 */ GIM_Reject,
     /* 166368 */ // Label 2454: @166368
     /* 166368 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(166685),
     /* 166373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166376 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(166441), // Rule ID 805 //
     /* 166381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166404 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166422 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 166425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166439 */     GIR_RootConstrainSelectedInstOperands,
     /* 166440 */     // GIR_Coverage, 805,
     /* 166440 */     GIR_EraseRootFromParent_Done,
     /* 166441 */   // Label 2504: @166441
     /* 166441 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(166506), // Rule ID 804 //
     /* 166446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166469 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166487 */     // (fneg:{ *:[v4f32] } (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 166490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166504 */     GIR_RootConstrainSelectedInstOperands,
     /* 166505 */     // GIR_Coverage, 804,
     /* 166505 */     GIR_EraseRootFromParent_Done,
     /* 166506 */   // Label 2505: @166506
     /* 166506 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(166559), // Rule ID 801 //
     /* 166511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166534 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166540 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi))  =>  (XVNMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDASP),
     /* 166543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166557 */     GIR_RootConstrainSelectedInstOperands,
     /* 166558 */     // GIR_Coverage, 801,
     /* 166558 */     GIR_EraseRootFromParent_Done,
     /* 166559 */   // Label 2506: @166559
     /* 166559 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(166596), // Rule ID 849 //
     /* 166564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166585 */     // (fneg:{ *:[v4f32] } (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB))  =>  (XVNABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 166585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSSP),
     /* 166588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 166594 */     GIR_RootConstrainSelectedInstOperands,
     /* 166595 */     // GIR_Coverage, 849,
     /* 166595 */     GIR_EraseRootFromParent_Done,
     /* 166596 */   // Label 2507: @166596
     /* 166596 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(166619), // Rule ID 851 //
     /* 166601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166608 */     // (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVNEGSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 166608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGSP),
     /* 166613 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166617 */     GIR_RootConstrainSelectedInstOperands,
     /* 166618 */     // GIR_Coverage, 851,
     /* 166618 */     GIR_Done,
     /* 166619 */   // Label 2508: @166619
     /* 166619 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(166684), // Rule ID 293 //
     /* 166624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 166627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166665 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RB)))  =>  (VNMSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 166665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /* 166668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 166670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RC
     /* 166678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RB
     /* 166682 */     GIR_RootConstrainSelectedInstOperands,
     /* 166683 */     // GIR_Coverage, 293,
     /* 166683 */     GIR_EraseRootFromParent_Done,
     /* 166684 */   // Label 2509: @166684
     /* 166684 */   GIM_Reject,
     /* 166685 */ // Label 2503: @166685
     /* 166685 */ GIM_Reject,
     /* 166686 */ // Label 2455: @166686
     /* 166686 */ GIM_Reject,
     /* 166687 */ // Label 46: @166687
     /* 166687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2512*/ GIMT_Encode4(166850),
     /* 166698 */ /*GILLT_s64*//*Label 2510*/ GIMT_Encode4(166706),
     /* 166702 */ /*GILLT_s128*//*Label 2511*/ GIMT_Encode4(166781),
     /* 166706 */ // Label 2510: @166706
     /* 166706 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(166780),
     /* 166711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 166714 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(166737), // Rule ID 1903 //
     /* 166719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 166722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166726 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VSFRC:{ *:[i32] })
     /* 166726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166736 */     // GIR_Coverage, 1903,
     /* 166736 */     GIR_Done,
     /* 166737 */   // Label 2514: @166737
     /* 166737 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(166756), // Rule ID 560 //
     /* 166742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 166745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 166749 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$RB)  =>  (EFDCFS:{ *:[f64] } f32:{ *:[f32] }:$RB)
     /* 166749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFS),
     /* 166754 */     GIR_RootConstrainSelectedInstOperands,
     /* 166755 */     // GIR_Coverage, 560,
     /* 166755 */     GIR_Done,
     /* 166756 */   // Label 2515: @166756
     /* 166756 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(166779), // Rule ID 1263 //
     /* 166761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 166764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 166768 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, F8RC:{ *:[i32] })
     /* 166768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 166778 */     // GIR_Coverage, 1263,
     /* 166778 */     GIR_Done,
     /* 166779 */   // Label 2516: @166779
     /* 166779 */   GIM_Reject,
     /* 166780 */ // Label 2513: @166780
     /* 166780 */ GIM_Reject,
     /* 166781 */ // Label 2511: @166781
     /* 166781 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(166803), // Rule ID 1011 //
     /* 166786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166796 */   // (fpextend:{ *:[f128] } f64:{ *:[f64] }:$RB)  =>  (XSCVDPQP:{ *:[f128] } f64:{ *:[f64] }:$RB)
     /* 166796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 166801 */   GIR_RootConstrainSelectedInstOperands,
     /* 166802 */   // GIR_Coverage, 1011,
     /* 166802 */   GIR_Done,
     /* 166803 */ // Label 2517: @166803
     /* 166803 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(166849), // Rule ID 2257 //
     /* 166808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 166814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166818 */   // (fpextend:{ *:[f128] } f32:{ *:[f32] }:$src)  =>  (XSCVDPQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VFRC:{ *:[i32] }))
     /* 166818 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166821 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166825 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166830 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 166834 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 166839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 166842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166847 */   GIR_RootConstrainSelectedInstOperands,
     /* 166848 */   // GIR_Coverage, 2257,
     /* 166848 */   GIR_EraseRootFromParent_Done,
     /* 166849 */ // Label 2518: @166849
     /* 166849 */ GIM_Reject,
     /* 166850 */ // Label 2512: @166850
     /* 166850 */ GIM_Reject,
     /* 166851 */ // Label 47: @166851
     /* 166851 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2521*/ GIMT_Encode4(167007),
     /* 166862 */ /*GILLT_s32*//*Label 2519*/ GIMT_Encode4(166870),
     /* 166866 */ /*GILLT_s64*//*Label 2520*/ GIMT_Encode4(166984),
     /* 166870 */ // Label 2519: @166870
     /* 166870 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(166892), // Rule ID 958 //
     /* 166875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 166878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166885 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$XB)  =>  (XSRSP:{ *:[f32] } f64:{ *:[f64] }:$XB)
     /* 166885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 166890 */   GIR_RootConstrainSelectedInstOperands,
     /* 166891 */   // GIR_Coverage, 958,
     /* 166891 */   GIR_Done,
     /* 166892 */ // Label 2522: @166892
     /* 166892 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(166935), // Rule ID 2255 //
     /* 166897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 166903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166907 */   // (fpround:{ *:[f32] } f128:{ *:[f128] }:$src)  =>  (XSRSP:{ *:[f32] } (XSCVQPDPO:{ *:[f64] } ?:{ *:[f128] }:$src))
     /* 166907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /* 166914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166919 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 166923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 166928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166933 */   GIR_RootConstrainSelectedInstOperands,
     /* 166934 */   // GIR_Coverage, 2255,
     /* 166934 */   GIR_EraseRootFromParent_Done,
     /* 166935 */ // Label 2523: @166935
     /* 166935 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(166961), // Rule ID 158 //
     /* 166940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 166943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 166950 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (FRSP:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 166950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRSP),
     /* 166955 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166959 */   GIR_RootConstrainSelectedInstOperands,
     /* 166960 */   // GIR_Coverage, 158,
     /* 166960 */   GIR_Done,
     /* 166961 */ // Label 2524: @166961
     /* 166961 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(166983), // Rule ID 581 //
     /* 166966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 166969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 166976 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (EFSCFD:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 166976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFD),
     /* 166981 */   GIR_RootConstrainSelectedInstOperands,
     /* 166982 */   // GIR_Coverage, 581,
     /* 166982 */   GIR_Done,
     /* 166983 */ // Label 2525: @166983
     /* 166983 */ GIM_Reject,
     /* 166984 */ // Label 2520: @166984
     /* 166984 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(167006), // Rule ID 2253 //
     /* 166989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 166995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /* 166999 */   // (fpround:{ *:[f64] } f128:{ *:[f128] }:$src)  =>  (XSCVQPDP:{ *:[f64] } ?:{ *:[f128] }:$src)
     /* 166999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDP),
     /* 167004 */   GIR_RootConstrainSelectedInstOperands,
     /* 167005 */   // GIR_Coverage, 2253,
     /* 167005 */   GIR_Done,
     /* 167006 */ // Label 2526: @167006
     /* 167006 */ GIM_Reject,
     /* 167007 */ // Label 2521: @167007
     /* 167007 */ GIM_Reject,
     /* 167008 */ // Label 48: @167008
     /* 167008 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2531*/ GIMT_Encode4(167270),
     /* 167019 */ /*GILLT_s32*//*Label 2527*/ GIMT_Encode4(167039),
     /* 167023 */ /*GILLT_s64*//*Label 2528*/ GIMT_Encode4(167147), GIMT_Encode4(0),
     /* 167031 */ /*GILLT_v2s64*//*Label 2529*/ GIMT_Encode4(167191),
     /* 167035 */ /*GILLT_v4s32*//*Label 2530*/ GIMT_Encode4(167218),
     /* 167039 */ // Label 2527: @167039
     /* 167039 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(167102), // Rule ID 2243 //
     /* 167044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167054 */   // (fp_to_sint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPSWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 167054 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167057 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSWZ),
     /* 167061 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167066 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167084 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167087 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 167095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167100 */   GIR_RootConstrainSelectedInstOperands,
     /* 167101 */   // GIR_Coverage, 2243,
     /* 167101 */   GIR_EraseRootFromParent_Done,
     /* 167102 */ // Label 2532: @167102
     /* 167102 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(167124), // Rule ID 566 //
     /* 167107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167117 */   // (fp_to_sint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTSIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 167117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTSIZ),
     /* 167122 */   GIR_RootConstrainSelectedInstOperands,
     /* 167123 */   // GIR_Coverage, 566,
     /* 167123 */   GIR_Done,
     /* 167124 */ // Label 2533: @167124
     /* 167124 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(167146), // Rule ID 587 //
     /* 167129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167139 */   // (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTSIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 167139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTSIZ),
     /* 167144 */   GIR_RootConstrainSelectedInstOperands,
     /* 167145 */   // GIR_Coverage, 587,
     /* 167145 */   GIR_Done,
     /* 167146 */ // Label 2534: @167146
     /* 167146 */ GIM_Reject,
     /* 167147 */ // Label 2528: @167147
     /* 167147 */ GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(167190), // Rule ID 2239 //
     /* 167152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 167162 */   // (fp_to_sint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPSDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 167162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 167165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSDZ),
     /* 167169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167174 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 167183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167188 */   GIR_RootConstrainSelectedInstOperands,
     /* 167189 */   // GIR_Coverage, 2239,
     /* 167189 */   GIR_EraseRootFromParent_Done,
     /* 167190 */ // Label 2535: @167190
     /* 167190 */ GIM_Reject,
     /* 167191 */ // Label 2529: @167191
     /* 167191 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(167217), // Rule ID 874 //
     /* 167196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167206 */   // (fp_to_sint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 167206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXDS),
     /* 167211 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167215 */   GIR_RootConstrainSelectedInstOperands,
     /* 167216 */   // GIR_Coverage, 874,
     /* 167216 */   GIR_Done,
     /* 167217 */ // Label 2536: @167217
     /* 167217 */ GIM_Reject,
     /* 167218 */ // Label 2530: @167218
     /* 167218 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(167269),
     /* 167223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167226 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(167249), // Rule ID 882 //
     /* 167231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167238 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 167238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXWS),
     /* 167243 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167247 */     GIR_RootConstrainSelectedInstOperands,
     /* 167248 */     // GIR_Coverage, 882,
     /* 167248 */     GIR_Done,
     /* 167249 */   // Label 2538: @167249
     /* 167249 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(167268), // Rule ID 1409 //
     /* 167254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167261 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTSXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 167261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /* 167266 */     GIR_RootConstrainSelectedInstOperands,
     /* 167267 */     // GIR_Coverage, 1409,
     /* 167267 */     GIR_Done,
     /* 167268 */   // Label 2539: @167268
     /* 167268 */   GIM_Reject,
     /* 167269 */ // Label 2537: @167269
     /* 167269 */ GIM_Reject,
     /* 167270 */ // Label 2531: @167270
     /* 167270 */ GIM_Reject,
     /* 167271 */ // Label 49: @167271
     /* 167271 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2544*/ GIMT_Encode4(167533),
     /* 167282 */ /*GILLT_s32*//*Label 2540*/ GIMT_Encode4(167302),
     /* 167286 */ /*GILLT_s64*//*Label 2541*/ GIMT_Encode4(167410), GIMT_Encode4(0),
     /* 167294 */ /*GILLT_v2s64*//*Label 2542*/ GIMT_Encode4(167454),
     /* 167298 */ /*GILLT_v4s32*//*Label 2543*/ GIMT_Encode4(167481),
     /* 167302 */ // Label 2540: @167302
     /* 167302 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(167365), // Rule ID 2245 //
     /* 167307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167317 */   // (fp_to_uint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPUWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 167317 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167320 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUWZ),
     /* 167324 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167329 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167347 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167350 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 167358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167363 */   GIR_RootConstrainSelectedInstOperands,
     /* 167364 */   // GIR_Coverage, 2245,
     /* 167364 */   GIR_EraseRootFromParent_Done,
     /* 167365 */ // Label 2545: @167365
     /* 167365 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(167387), // Rule ID 568 //
     /* 167370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167380 */   // (fp_to_uint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTUIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 167380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTUIZ),
     /* 167385 */   GIR_RootConstrainSelectedInstOperands,
     /* 167386 */   // GIR_Coverage, 568,
     /* 167386 */   GIR_Done,
     /* 167387 */ // Label 2546: @167387
     /* 167387 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(167409), // Rule ID 589 //
     /* 167392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167402 */   // (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTUIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 167402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTUIZ),
     /* 167407 */   GIR_RootConstrainSelectedInstOperands,
     /* 167408 */   // GIR_Coverage, 589,
     /* 167408 */   GIR_Done,
     /* 167409 */ // Label 2547: @167409
     /* 167409 */ GIM_Reject,
     /* 167410 */ // Label 2541: @167410
     /* 167410 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(167453), // Rule ID 2241 //
     /* 167415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 167425 */   // (fp_to_uint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPUDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 167425 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 167428 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUDZ),
     /* 167432 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167437 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 167446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167451 */   GIR_RootConstrainSelectedInstOperands,
     /* 167452 */   // GIR_Coverage, 2241,
     /* 167452 */   GIR_EraseRootFromParent_Done,
     /* 167453 */ // Label 2548: @167453
     /* 167453 */ GIM_Reject,
     /* 167454 */ // Label 2542: @167454
     /* 167454 */ GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(167480), // Rule ID 877 //
     /* 167459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167469 */   // (fp_to_uint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 167469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXDS),
     /* 167474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167478 */   GIR_RootConstrainSelectedInstOperands,
     /* 167479 */   // GIR_Coverage, 877,
     /* 167479 */   GIR_Done,
     /* 167480 */ // Label 2549: @167480
     /* 167480 */ GIM_Reject,
     /* 167481 */ // Label 2543: @167481
     /* 167481 */ GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(167532),
     /* 167486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167489 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(167512), // Rule ID 885 //
     /* 167494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167501 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 167501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXWS),
     /* 167506 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167510 */     GIR_RootConstrainSelectedInstOperands,
     /* 167511 */     // GIR_Coverage, 885,
     /* 167511 */     GIR_Done,
     /* 167512 */   // Label 2551: @167512
     /* 167512 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(167531), // Rule ID 1410 //
     /* 167517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167524 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTUXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 167524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /* 167529 */     GIR_RootConstrainSelectedInstOperands,
     /* 167530 */     // GIR_Coverage, 1410,
     /* 167530 */     GIR_Done,
     /* 167531 */   // Label 2552: @167531
     /* 167531 */   GIM_Reject,
     /* 167532 */ // Label 2550: @167532
     /* 167532 */ GIM_Reject,
     /* 167533 */ // Label 2544: @167533
     /* 167533 */ GIM_Reject,
     /* 167534 */ // Label 50: @167534
     /* 167534 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2558*/ GIMT_Encode4(167780),
     /* 167545 */ /*GILLT_s32*//*Label 2553*/ GIMT_Encode4(167565),
     /* 167549 */ /*GILLT_s64*//*Label 2554*/ GIMT_Encode4(167588),
     /* 167553 */ /*GILLT_s128*//*Label 2555*/ GIMT_Encode4(167611),
     /* 167557 */ /*GILLT_v2s64*//*Label 2556*/ GIMT_Encode4(167701),
     /* 167561 */ /*GILLT_v4s32*//*Label 2557*/ GIMT_Encode4(167728),
     /* 167565 */ // Label 2553: @167565
     /* 167565 */ GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(167587), // Rule ID 583 //
     /* 167570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167580 */   // (sint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFSI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 167580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFSI),
     /* 167585 */   GIR_RootConstrainSelectedInstOperands,
     /* 167586 */   // GIR_Coverage, 583,
     /* 167586 */   GIR_Done,
     /* 167587 */ // Label 2559: @167587
     /* 167587 */ GIM_Reject,
     /* 167588 */ // Label 2554: @167588
     /* 167588 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(167610), // Rule ID 562 //
     /* 167593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 167603 */   // (sint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFSI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 167603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFSI),
     /* 167608 */   GIR_RootConstrainSelectedInstOperands,
     /* 167609 */   // GIR_Coverage, 562,
     /* 167609 */   GIR_Done,
     /* 167610 */ // Label 2560: @167610
     /* 167610 */ GIM_Reject,
     /* 167611 */ // Label 2555: @167611
     /* 167611 */ GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(167657), // Rule ID 2134 //
     /* 167616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167626 */   // (sint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 167626 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167629 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167633 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167638 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167642 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 167650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167655 */   GIR_RootConstrainSelectedInstOperands,
     /* 167656 */   // GIR_Coverage, 2134,
     /* 167656 */   GIR_EraseRootFromParent_Done,
     /* 167657 */ // Label 2561: @167657
     /* 167657 */ GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(167700), // Rule ID 2144 //
     /* 167662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167672 */   // (sint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (MTVSRWA:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 167672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWA),
     /* 167679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167684 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 167693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167698 */   GIR_RootConstrainSelectedInstOperands,
     /* 167699 */   // GIR_Coverage, 2144,
     /* 167699 */   GIR_EraseRootFromParent_Done,
     /* 167700 */ // Label 2562: @167700
     /* 167700 */ GIM_Reject,
     /* 167701 */ // Label 2556: @167701
     /* 167701 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(167727), // Rule ID 887 //
     /* 167706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167716 */   // (sint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 167716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDDP),
     /* 167721 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167725 */   GIR_RootConstrainSelectedInstOperands,
     /* 167726 */   // GIR_Coverage, 887,
     /* 167726 */   GIR_Done,
     /* 167727 */ // Label 2563: @167727
     /* 167727 */ GIM_Reject,
     /* 167728 */ // Label 2557: @167728
     /* 167728 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(167779),
     /* 167733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167736 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(167759), // Rule ID 890 //
     /* 167741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167748 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 167748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWSP),
     /* 167753 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167757 */     GIR_RootConstrainSelectedInstOperands,
     /* 167758 */     // GIR_Coverage, 890,
     /* 167758 */     GIR_Done,
     /* 167759 */   // Label 2565: @167759
     /* 167759 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(167778), // Rule ID 1411 //
     /* 167764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167771 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFSX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 167771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /* 167776 */     GIR_RootConstrainSelectedInstOperands,
     /* 167777 */     // GIR_Coverage, 1411,
     /* 167777 */     GIR_Done,
     /* 167778 */   // Label 2566: @167778
     /* 167778 */   GIM_Reject,
     /* 167779 */ // Label 2564: @167779
     /* 167779 */ GIM_Reject,
     /* 167780 */ // Label 2558: @167780
     /* 167780 */ GIM_Reject,
     /* 167781 */ // Label 51: @167781
     /* 167781 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2572*/ GIMT_Encode4(168027),
     /* 167792 */ /*GILLT_s32*//*Label 2567*/ GIMT_Encode4(167812),
     /* 167796 */ /*GILLT_s64*//*Label 2568*/ GIMT_Encode4(167835),
     /* 167800 */ /*GILLT_s128*//*Label 2569*/ GIMT_Encode4(167858),
     /* 167804 */ /*GILLT_v2s64*//*Label 2570*/ GIMT_Encode4(167948),
     /* 167808 */ /*GILLT_v4s32*//*Label 2571*/ GIMT_Encode4(167975),
     /* 167812 */ // Label 2567: @167812
     /* 167812 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(167834), // Rule ID 585 //
     /* 167817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167827 */   // (uint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFUI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 167827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFUI),
     /* 167832 */   GIR_RootConstrainSelectedInstOperands,
     /* 167833 */   // GIR_Coverage, 585,
     /* 167833 */   GIR_Done,
     /* 167834 */ // Label 2573: @167834
     /* 167834 */ GIM_Reject,
     /* 167835 */ // Label 2568: @167835
     /* 167835 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(167857), // Rule ID 564 //
     /* 167840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 167850 */   // (uint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFUI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 167850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFUI),
     /* 167855 */   GIR_RootConstrainSelectedInstOperands,
     /* 167856 */   // GIR_Coverage, 564,
     /* 167856 */   GIR_Done,
     /* 167857 */ // Label 2574: @167857
     /* 167857 */ GIM_Reject,
     /* 167858 */ // Label 2569: @167858
     /* 167858 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(167904), // Rule ID 2140 //
     /* 167863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167873 */   // (uint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 167873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167885 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 167897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167902 */   GIR_RootConstrainSelectedInstOperands,
     /* 167903 */   // GIR_Coverage, 2140,
     /* 167903 */   GIR_EraseRootFromParent_Done,
     /* 167904 */ // Label 2575: @167904
     /* 167904 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(167947), // Rule ID 2148 //
     /* 167909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167919 */   // (uint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 167919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /* 167926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167931 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 167940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167945 */   GIR_RootConstrainSelectedInstOperands,
     /* 167946 */   // GIR_Coverage, 2148,
     /* 167946 */   GIR_EraseRootFromParent_Done,
     /* 167947 */ // Label 2576: @167947
     /* 167947 */ GIM_Reject,
     /* 167948 */ // Label 2570: @167948
     /* 167948 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(167974), // Rule ID 892 //
     /* 167953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167963 */   // (uint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 167963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDDP),
     /* 167968 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167972 */   GIR_RootConstrainSelectedInstOperands,
     /* 167973 */   // GIR_Coverage, 892,
     /* 167973 */   GIR_Done,
     /* 167974 */ // Label 2577: @167974
     /* 167974 */ GIM_Reject,
     /* 167975 */ // Label 2571: @167975
     /* 167975 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(168026),
     /* 167980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167983 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(168006), // Rule ID 895 //
     /* 167988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167995 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 167995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWSP),
     /* 168000 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168004 */     GIR_RootConstrainSelectedInstOperands,
     /* 168005 */     // GIR_Coverage, 895,
     /* 168005 */     GIR_Done,
     /* 168006 */   // Label 2579: @168006
     /* 168006 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(168025), // Rule ID 1412 //
     /* 168011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168018 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFUX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 168018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /* 168023 */     GIR_RootConstrainSelectedInstOperands,
     /* 168024 */     // GIR_Coverage, 1412,
     /* 168024 */     GIR_Done,
     /* 168025 */   // Label 2580: @168025
     /* 168025 */   GIM_Reject,
     /* 168026 */ // Label 2578: @168026
     /* 168026 */ GIM_Reject,
     /* 168027 */ // Label 2572: @168027
     /* 168027 */ GIM_Reject,
     /* 168028 */ // Label 52: @168028
     /* 168028 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2586*/ GIMT_Encode4(168319),
     /* 168039 */ /*GILLT_s32*//*Label 2581*/ GIMT_Encode4(168059),
     /* 168043 */ /*GILLT_s64*//*Label 2582*/ GIMT_Encode4(168171),
     /* 168047 */ /*GILLT_s128*//*Label 2583*/ GIMT_Encode4(168242),
     /* 168051 */ /*GILLT_v2s64*//*Label 2584*/ GIMT_Encode4(168265),
     /* 168055 */ /*GILLT_v4s32*//*Label 2585*/ GIMT_Encode4(168292),
     /* 168059 */ // Label 2581: @168059
     /* 168059 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(168170),
     /* 168064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168067 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(168131), // Rule ID 1677 //
     /* 168072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168079 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 168079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168091 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 168107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168130 */     // GIR_Coverage, 1677,
     /* 168130 */     GIR_EraseRootFromParent_Done,
     /* 168131 */   // Label 2588: @168131
     /* 168131 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(168150), // Rule ID 163 //
     /* 168136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168143 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 168143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSS),
     /* 168148 */     GIR_RootConstrainSelectedInstOperands,
     /* 168149 */     // GIR_Coverage, 163,
     /* 168149 */     GIR_Done,
     /* 168150 */   // Label 2589: @168150
     /* 168150 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(168169), // Rule ID 577 //
     /* 168155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 168162 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 168162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSABS),
     /* 168167 */     GIR_RootConstrainSelectedInstOperands,
     /* 168168 */     // GIR_Coverage, 577,
     /* 168168 */     GIR_Done,
     /* 168169 */   // Label 2590: @168169
     /* 168169 */   GIM_Reject,
     /* 168170 */ // Label 2587: @168170
     /* 168170 */ GIM_Reject,
     /* 168171 */ // Label 2582: @168171
     /* 168171 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(168241),
     /* 168176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168179 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(168202), // Rule ID 839 //
     /* 168184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168191 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 168191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 168196 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168200 */     GIR_RootConstrainSelectedInstOperands,
     /* 168201 */     // GIR_Coverage, 839,
     /* 168201 */     GIR_Done,
     /* 168202 */   // Label 2592: @168202
     /* 168202 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(168221), // Rule ID 164 //
     /* 168207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168214 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 168214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSD),
     /* 168219 */     GIR_RootConstrainSelectedInstOperands,
     /* 168220 */     // GIR_Coverage, 164,
     /* 168220 */     GIR_Done,
     /* 168221 */   // Label 2593: @168221
     /* 168221 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(168240), // Rule ID 556 //
     /* 168226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 168233 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 168233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDABS),
     /* 168238 */     GIR_RootConstrainSelectedInstOperands,
     /* 168239 */     // GIR_Coverage, 556,
     /* 168239 */     GIR_Done,
     /* 168240 */   // Label 2594: @168240
     /* 168240 */   GIM_Reject,
     /* 168241 */ // Label 2591: @168241
     /* 168241 */ GIM_Reject,
     /* 168242 */ // Label 2583: @168242
     /* 168242 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(168264), // Rule ID 980 //
     /* 168247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 168253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168257 */   // (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 168257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSQP),
     /* 168262 */   GIR_RootConstrainSelectedInstOperands,
     /* 168263 */   // GIR_Coverage, 980,
     /* 168263 */   GIR_Done,
     /* 168264 */ // Label 2595: @168264
     /* 168264 */ GIM_Reject,
     /* 168265 */ // Label 2584: @168265
     /* 168265 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(168291), // Rule ID 844 //
     /* 168270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168280 */   // (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 168280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSDP),
     /* 168285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168289 */   GIR_RootConstrainSelectedInstOperands,
     /* 168290 */   // GIR_Coverage, 844,
     /* 168290 */   GIR_Done,
     /* 168291 */ // Label 2596: @168291
     /* 168291 */ GIM_Reject,
     /* 168292 */ // Label 2585: @168292
     /* 168292 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(168318), // Rule ID 845 //
     /* 168297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168307 */   // (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 168307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSSP),
     /* 168312 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168316 */   GIR_RootConstrainSelectedInstOperands,
     /* 168317 */   // GIR_Coverage, 845,
     /* 168317 */   GIR_Done,
     /* 168318 */ // Label 2597: @168318
     /* 168318 */ GIM_Reject,
     /* 168319 */ // Label 2586: @168319
     /* 168319 */ GIM_Reject,
     /* 168320 */ // Label 53: @168320
     /* 168320 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2603*/ GIMT_Encode4(168635),
     /* 168331 */ /*GILLT_s32*//*Label 2598*/ GIMT_Encode4(168351),
     /* 168335 */ /*GILLT_s64*//*Label 2599*/ GIMT_Encode4(168435),
     /* 168339 */ /*GILLT_s128*//*Label 2600*/ GIMT_Encode4(168545),
     /* 168343 */ /*GILLT_v2s64*//*Label 2601*/ GIMT_Encode4(168575),
     /* 168347 */ /*GILLT_v4s32*//*Label 2602*/ GIMT_Encode4(168605),
     /* 168351 */ // Label 2598: @168351
     /* 168351 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(168434),
     /* 168356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168359 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(168385), // Rule ID 169 //
     /* 168364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168374 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$RB, f32:{ *:[f32] }:$RA)  =>  (FCPSGNS:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 168374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 168377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168379 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168381 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168383 */     GIR_RootConstrainSelectedInstOperands,
     /* 168384 */     // GIR_Coverage, 169,
     /* 168384 */     GIR_EraseRootFromParent_Done,
     /* 168385 */   // Label 2605: @168385
     /* 168385 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(168433), // Rule ID 1275 //
     /* 168390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168400 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$frB, f64:{ *:[f64] }:$frA)  =>  (FCPSGNS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } ?:{ *:[f64] }:$frA, F4RC:{ *:[i32] }), ?:{ *:[f32] }:$frB)
     /* 168400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 168403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 168416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 168424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168429 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 168431 */     GIR_RootConstrainSelectedInstOperands,
     /* 168432 */     // GIR_Coverage, 1275,
     /* 168432 */     GIR_EraseRootFromParent_Done,
     /* 168433 */   // Label 2606: @168433
     /* 168433 */   GIM_Reject,
     /* 168434 */ // Label 2604: @168434
     /* 168434 */ GIM_Reject,
     /* 168435 */ // Label 2599: @168435
     /* 168435 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(168544),
     /* 168440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168443 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(168469), // Rule ID 843 //
     /* 168448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168458 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XA)  =>  (XSCPSGNDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 168458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNDP),
     /* 168461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168463 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168465 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168467 */     GIR_RootConstrainSelectedInstOperands,
     /* 168468 */     // GIR_Coverage, 843,
     /* 168468 */     GIR_EraseRootFromParent_Done,
     /* 168469 */   // Label 2608: @168469
     /* 168469 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(168495), // Rule ID 170 //
     /* 168474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168484 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$RB, f64:{ *:[f64] }:$RA)  =>  (FCPSGND:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 168484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 168487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168489 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168491 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168493 */     GIR_RootConstrainSelectedInstOperands,
     /* 168494 */     // GIR_Coverage, 170,
     /* 168494 */     GIR_EraseRootFromParent_Done,
     /* 168495 */   // Label 2609: @168495
     /* 168495 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(168543), // Rule ID 1274 //
     /* 168500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168510 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$frB, f32:{ *:[f32] }:$frA)  =>  (FCPSGND:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$frA, F8RC:{ *:[i32] }), ?:{ *:[f64] }:$frB)
     /* 168510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 168526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 168534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168539 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 168541 */     GIR_RootConstrainSelectedInstOperands,
     /* 168542 */     // GIR_Coverage, 1274,
     /* 168542 */     GIR_EraseRootFromParent_Done,
     /* 168543 */   // Label 2610: @168543
     /* 168543 */   GIM_Reject,
     /* 168544 */ // Label 2607: @168544
     /* 168544 */ GIM_Reject,
     /* 168545 */ // Label 2600: @168545
     /* 168545 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(168574), // Rule ID 979 //
     /* 168550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 168556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 168559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168563 */   // (fcopysign:{ *:[f128] } f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RA)  =>  (XSCPSGNQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 168563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNQP),
     /* 168566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168568 */   GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168570 */   GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168572 */   GIR_RootConstrainSelectedInstOperands,
     /* 168573 */   // GIR_Coverage, 979,
     /* 168573 */   GIR_EraseRootFromParent_Done,
     /* 168574 */ // Label 2611: @168574
     /* 168574 */ GIM_Reject,
     /* 168575 */ // Label 2601: @168575
     /* 168575 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(168604), // Rule ID 846 //
     /* 168580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168593 */   // (fcopysign:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XA)  =>  (XVCPSGNDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 168593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNDP),
     /* 168596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168598 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168600 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168602 */   GIR_RootConstrainSelectedInstOperands,
     /* 168603 */   // GIR_Coverage, 846,
     /* 168603 */   GIR_EraseRootFromParent_Done,
     /* 168604 */ // Label 2612: @168604
     /* 168604 */ GIM_Reject,
     /* 168605 */ // Label 2602: @168605
     /* 168605 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(168634), // Rule ID 847 //
     /* 168610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168623 */   // (fcopysign:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XA)  =>  (XVCPSGNSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 168623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNSP),
     /* 168626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168628 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168630 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168632 */   GIR_RootConstrainSelectedInstOperands,
     /* 168633 */   // GIR_Coverage, 847,
     /* 168633 */   GIR_EraseRootFromParent_Done,
     /* 168634 */ // Label 2613: @168634
     /* 168634 */ GIM_Reject,
     /* 168635 */ // Label 2603: @168635
     /* 168635 */ GIM_Reject,
     /* 168636 */ // Label 54: @168636
     /* 168636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2616*/ GIMT_Encode4(168715),
     /* 168647 */ /*GILLT_v2s64*//*Label 2614*/ GIMT_Encode4(168655),
     /* 168651 */ /*GILLT_v4s32*//*Label 2615*/ GIMT_Encode4(168685),
     /* 168655 */ // Label 2614: @168655
     /* 168655 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(168684), // Rule ID 1676 //
     /* 168660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168673 */   // (fminnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMINDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 168673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /* 168678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168682 */   GIR_RootConstrainSelectedInstOperands,
     /* 168683 */   // GIR_Coverage, 1676,
     /* 168683 */   GIR_Done,
     /* 168684 */ // Label 2617: @168684
     /* 168684 */ GIM_Reject,
     /* 168685 */ // Label 2615: @168685
     /* 168685 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(168714), // Rule ID 1672 //
     /* 168690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168703 */   // (fminnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMINSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 168703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /* 168708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168712 */   GIR_RootConstrainSelectedInstOperands,
     /* 168713 */   // GIR_Coverage, 1672,
     /* 168713 */   GIR_Done,
     /* 168714 */ // Label 2618: @168714
     /* 168714 */ GIM_Reject,
     /* 168715 */ // Label 2616: @168715
     /* 168715 */ GIM_Reject,
     /* 168716 */ // Label 55: @168716
     /* 168716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2621*/ GIMT_Encode4(168795),
     /* 168727 */ /*GILLT_v2s64*//*Label 2619*/ GIMT_Encode4(168735),
     /* 168731 */ /*GILLT_v4s32*//*Label 2620*/ GIMT_Encode4(168765),
     /* 168735 */ // Label 2619: @168735
     /* 168735 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(168764), // Rule ID 1674 //
     /* 168740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168753 */   // (fmaxnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMAXDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 168753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /* 168758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168762 */   GIR_RootConstrainSelectedInstOperands,
     /* 168763 */   // GIR_Coverage, 1674,
     /* 168763 */   GIR_Done,
     /* 168764 */ // Label 2622: @168764
     /* 168764 */ GIM_Reject,
     /* 168765 */ // Label 2620: @168765
     /* 168765 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(168794), // Rule ID 1670 //
     /* 168770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168783 */   // (fmaxnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMAXSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 168783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /* 168788 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168792 */   GIR_RootConstrainSelectedInstOperands,
     /* 168793 */   // GIR_Coverage, 1670,
     /* 168793 */   GIR_Done,
     /* 168794 */ // Label 2623: @168794
     /* 168794 */ GIM_Reject,
     /* 168795 */ // Label 2621: @168795
     /* 168795 */ GIM_Reject,
     /* 168796 */ // Label 56: @168796
     /* 168796 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2626*/ GIMT_Encode4(169377),
     /* 168807 */ /*GILLT_s32*//*Label 2624*/ GIMT_Encode4(168815),
     /* 168811 */ /*GILLT_s64*//*Label 2625*/ GIMT_Encode4(169222),
     /* 168815 */ // Label 2624: @168815
     /* 168815 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(169221),
     /* 168820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168830 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(168940), // Rule ID 1682 //
     /* 168835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 168846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 168850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 168854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 168858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 168862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 168864 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 168864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168876 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 168880 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168885 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168888 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168892 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168897 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 168901 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 168913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168939 */     // GIR_Coverage, 1682,
     /* 168939 */     GIR_EraseRootFromParent_Done,
     /* 168940 */   // Label 2628: @168940
     /* 168940 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(169038), // Rule ID 1680 //
     /* 168945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 168956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 168960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168962 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 168962 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168965 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168969 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168974 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 168978 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168995 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 168999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169019 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169037 */     // GIR_Coverage, 1680,
     /* 169037 */     GIR_EraseRootFromParent_Done,
     /* 169038 */   // Label 2629: @169038
     /* 169038 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(169136), // Rule ID 1681 //
     /* 169043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169060 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169060 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169063 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169067 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169072 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169076 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169081 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169084 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169088 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169097 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169114 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169135 */     // GIR_Coverage, 1681,
     /* 169135 */     GIR_EraseRootFromParent_Done,
     /* 169136 */   // Label 2630: @169136
     /* 169136 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(169220), // Rule ID 1679 //
     /* 169141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169144 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169144 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169147 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169151 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169156 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169160 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169165 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169168 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169172 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169177 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169201 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169219 */     // GIR_Coverage, 1679,
     /* 169219 */     GIR_EraseRootFromParent_Done,
     /* 169220 */   // Label 2631: @169220
     /* 169220 */   GIM_Reject,
     /* 169221 */ // Label 2627: @169221
     /* 169221 */ GIM_Reject,
     /* 169222 */ // Label 2625: @169222
     /* 169222 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(169376),
     /* 169227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 169230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169237 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(169286), // Rule ID 1690 //
     /* 169242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 169269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169271 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169284 */     GIR_RootConstrainSelectedInstOperands,
     /* 169285 */     // GIR_Coverage, 1690,
     /* 169285 */     GIR_EraseRootFromParent_Done,
     /* 169286 */   // Label 2633: @169286
     /* 169286 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(169321), // Rule ID 1688 //
     /* 169291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169308 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169317 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 169319 */     GIR_RootConstrainSelectedInstOperands,
     /* 169320 */     // GIR_Coverage, 1688,
     /* 169320 */     GIR_EraseRootFromParent_Done,
     /* 169321 */   // Label 2634: @169321
     /* 169321 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(169356), // Rule ID 1689 //
     /* 169326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169343 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169348 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 169350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169354 */     GIR_RootConstrainSelectedInstOperands,
     /* 169355 */     // GIR_Coverage, 1689,
     /* 169355 */     GIR_EraseRootFromParent_Done,
     /* 169356 */   // Label 2635: @169356
     /* 169356 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(169375), // Rule ID 1687 //
     /* 169361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169364 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169369 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169373 */     GIR_RootConstrainSelectedInstOperands,
     /* 169374 */     // GIR_Coverage, 1687,
     /* 169374 */     GIR_Done,
     /* 169375 */   // Label 2636: @169375
     /* 169375 */   GIM_Reject,
     /* 169376 */ // Label 2632: @169376
     /* 169376 */ GIM_Reject,
     /* 169377 */ // Label 2626: @169377
     /* 169377 */ GIM_Reject,
     /* 169378 */ // Label 57: @169378
     /* 169378 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2639*/ GIMT_Encode4(169959),
     /* 169389 */ /*GILLT_s32*//*Label 2637*/ GIMT_Encode4(169397),
     /* 169393 */ /*GILLT_s64*//*Label 2638*/ GIMT_Encode4(169804),
     /* 169397 */ // Label 2637: @169397
     /* 169397 */ GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(169803),
     /* 169402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169412 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(169522), // Rule ID 1686 //
     /* 169417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 169444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169446 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169446 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169449 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169453 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169458 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169462 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169479 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169483 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169500 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169521 */     // GIR_Coverage, 1686,
     /* 169521 */     GIR_EraseRootFromParent_Done,
     /* 169522 */   // Label 2641: @169522
     /* 169522 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(169620), // Rule ID 1684 //
     /* 169527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169544 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169544 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169547 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169551 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169556 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169560 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169572 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169577 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169619 */     // GIR_Coverage, 1684,
     /* 169619 */     GIR_EraseRootFromParent_Done,
     /* 169620 */   // Label 2642: @169620
     /* 169620 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(169718), // Rule ID 1685 //
     /* 169625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169642 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169642 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169645 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169649 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169654 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169658 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169696 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169699 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169717 */     // GIR_Coverage, 1685,
     /* 169717 */     GIR_EraseRootFromParent_Done,
     /* 169718 */   // Label 2643: @169718
     /* 169718 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(169802), // Rule ID 1683 //
     /* 169723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169726 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169738 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169742 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169763 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169780 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169801 */     // GIR_Coverage, 1683,
     /* 169801 */     GIR_EraseRootFromParent_Done,
     /* 169802 */   // Label 2644: @169802
     /* 169802 */   GIM_Reject,
     /* 169803 */ // Label 2640: @169803
     /* 169803 */ GIM_Reject,
     /* 169804 */ // Label 2638: @169804
     /* 169804 */ GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(169958),
     /* 169809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 169812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169819 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(169868), // Rule ID 1694 //
     /* 169824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 169851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169853 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169866 */     GIR_RootConstrainSelectedInstOperands,
     /* 169867 */     // GIR_Coverage, 1694,
     /* 169867 */     GIR_EraseRootFromParent_Done,
     /* 169868 */   // Label 2646: @169868
     /* 169868 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(169903), // Rule ID 1692 //
     /* 169873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169890 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169899 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 169901 */     GIR_RootConstrainSelectedInstOperands,
     /* 169902 */     // GIR_Coverage, 1692,
     /* 169902 */     GIR_EraseRootFromParent_Done,
     /* 169903 */   // Label 2647: @169903
     /* 169903 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(169938), // Rule ID 1693 //
     /* 169908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169925 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169930 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 169932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169936 */     GIR_RootConstrainSelectedInstOperands,
     /* 169937 */     // GIR_Coverage, 1693,
     /* 169937 */     GIR_EraseRootFromParent_Done,
     /* 169938 */   // Label 2648: @169938
     /* 169938 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(169957), // Rule ID 1691 //
     /* 169943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169946 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169951 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169955 */     GIR_RootConstrainSelectedInstOperands,
     /* 169956 */     // GIR_Coverage, 1691,
     /* 169956 */     GIR_Done,
     /* 169957 */   // Label 2649: @169957
     /* 169957 */   GIM_Reject,
     /* 169958 */ // Label 2645: @169958
     /* 169958 */ GIM_Reject,
     /* 169959 */ // Label 2639: @169959
     /* 169959 */ GIM_Reject,
     /* 169960 */ // Label 58: @169960
     /* 169960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(170139),
     /* 169971 */ /*GILLT_v2s64*//*Label 2650*/ GIMT_Encode4(169987),
     /* 169975 */ /*GILLT_v4s32*//*Label 2651*/ GIMT_Encode4(170061),
     /* 169979 */ /*GILLT_v8s16*//*Label 2652*/ GIMT_Encode4(170087),
     /* 169983 */ /*GILLT_v16s8*//*Label 2653*/ GIMT_Encode4(170113),
     /* 169987 */ // Label 2650: @169987
     /* 169987 */ GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(170060), // Rule ID 1926 //
     /* 169992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 169995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 169998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170005 */   // (smin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170005 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170008 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170012 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170017 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170021 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170038 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170042 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /* 170050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170058 */   GIR_RootConstrainSelectedInstOperands,
     /* 170059 */   // GIR_Coverage, 1926,
     /* 170059 */   GIR_EraseRootFromParent_Done,
     /* 170060 */ // Label 2655: @170060
     /* 170060 */ GIM_Reject,
     /* 170061 */ // Label 2651: @170061
     /* 170061 */ GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(170086), // Rule ID 1356 //
     /* 170066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170079 */   // (smin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /* 170084 */   GIR_RootConstrainSelectedInstOperands,
     /* 170085 */   // GIR_Coverage, 1356,
     /* 170085 */   GIR_Done,
     /* 170086 */ // Label 2656: @170086
     /* 170086 */ GIM_Reject,
     /* 170087 */ // Label 2652: @170087
     /* 170087 */ GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(170112), // Rule ID 1354 //
     /* 170092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170105 */   // (smin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /* 170110 */   GIR_RootConstrainSelectedInstOperands,
     /* 170111 */   // GIR_Coverage, 1354,
     /* 170111 */   GIR_Done,
     /* 170112 */ // Label 2657: @170112
     /* 170112 */ GIM_Reject,
     /* 170113 */ // Label 2653: @170113
     /* 170113 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(170138), // Rule ID 1352 //
     /* 170118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170131 */   // (smin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /* 170136 */   GIR_RootConstrainSelectedInstOperands,
     /* 170137 */   // GIR_Coverage, 1352,
     /* 170137 */   GIR_Done,
     /* 170138 */ // Label 2658: @170138
     /* 170138 */ GIM_Reject,
     /* 170139 */ // Label 2654: @170139
     /* 170139 */ GIM_Reject,
     /* 170140 */ // Label 59: @170140
     /* 170140 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2663*/ GIMT_Encode4(170319),
     /* 170151 */ /*GILLT_v2s64*//*Label 2659*/ GIMT_Encode4(170167),
     /* 170155 */ /*GILLT_v4s32*//*Label 2660*/ GIMT_Encode4(170241),
     /* 170159 */ /*GILLT_v8s16*//*Label 2661*/ GIMT_Encode4(170267),
     /* 170163 */ /*GILLT_v16s8*//*Label 2662*/ GIMT_Encode4(170293),
     /* 170167 */ // Label 2659: @170167
     /* 170167 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(170240), // Rule ID 1924 //
     /* 170172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170185 */   // (smax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170185 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170188 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170192 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170197 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170201 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170206 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170213 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170218 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /* 170230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170238 */   GIR_RootConstrainSelectedInstOperands,
     /* 170239 */   // GIR_Coverage, 1924,
     /* 170239 */   GIR_EraseRootFromParent_Done,
     /* 170240 */ // Label 2664: @170240
     /* 170240 */ GIM_Reject,
     /* 170241 */ // Label 2660: @170241
     /* 170241 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(170266), // Rule ID 1350 //
     /* 170246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170259 */   // (smax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /* 170264 */   GIR_RootConstrainSelectedInstOperands,
     /* 170265 */   // GIR_Coverage, 1350,
     /* 170265 */   GIR_Done,
     /* 170266 */ // Label 2665: @170266
     /* 170266 */ GIM_Reject,
     /* 170267 */ // Label 2661: @170267
     /* 170267 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(170292), // Rule ID 1348 //
     /* 170272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170285 */   // (smax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /* 170290 */   GIR_RootConstrainSelectedInstOperands,
     /* 170291 */   // GIR_Coverage, 1348,
     /* 170291 */   GIR_Done,
     /* 170292 */ // Label 2666: @170292
     /* 170292 */ GIM_Reject,
     /* 170293 */ // Label 2662: @170293
     /* 170293 */ GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(170318), // Rule ID 1346 //
     /* 170298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170311 */   // (smax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /* 170316 */   GIR_RootConstrainSelectedInstOperands,
     /* 170317 */   // GIR_Coverage, 1346,
     /* 170317 */   GIR_Done,
     /* 170318 */ // Label 2667: @170318
     /* 170318 */ GIM_Reject,
     /* 170319 */ // Label 2663: @170319
     /* 170319 */ GIM_Reject,
     /* 170320 */ // Label 60: @170320
     /* 170320 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2672*/ GIMT_Encode4(170499),
     /* 170331 */ /*GILLT_v2s64*//*Label 2668*/ GIMT_Encode4(170347),
     /* 170335 */ /*GILLT_v4s32*//*Label 2669*/ GIMT_Encode4(170421),
     /* 170339 */ /*GILLT_v8s16*//*Label 2670*/ GIMT_Encode4(170447),
     /* 170343 */ /*GILLT_v16s8*//*Label 2671*/ GIMT_Encode4(170473),
     /* 170347 */ // Label 2668: @170347
     /* 170347 */ GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(170420), // Rule ID 1927 //
     /* 170352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170365 */   // (umin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170365 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170368 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170372 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170377 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170381 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170402 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /* 170410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170418 */   GIR_RootConstrainSelectedInstOperands,
     /* 170419 */   // GIR_Coverage, 1927,
     /* 170419 */   GIR_EraseRootFromParent_Done,
     /* 170420 */ // Label 2673: @170420
     /* 170420 */ GIM_Reject,
     /* 170421 */ // Label 2669: @170421
     /* 170421 */ GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(170446), // Rule ID 1355 //
     /* 170426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170439 */   // (umin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /* 170444 */   GIR_RootConstrainSelectedInstOperands,
     /* 170445 */   // GIR_Coverage, 1355,
     /* 170445 */   GIR_Done,
     /* 170446 */ // Label 2674: @170446
     /* 170446 */ GIM_Reject,
     /* 170447 */ // Label 2670: @170447
     /* 170447 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(170472), // Rule ID 1353 //
     /* 170452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170465 */   // (umin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /* 170470 */   GIR_RootConstrainSelectedInstOperands,
     /* 170471 */   // GIR_Coverage, 1353,
     /* 170471 */   GIR_Done,
     /* 170472 */ // Label 2675: @170472
     /* 170472 */ GIM_Reject,
     /* 170473 */ // Label 2671: @170473
     /* 170473 */ GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(170498), // Rule ID 1351 //
     /* 170478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170491 */   // (umin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /* 170496 */   GIR_RootConstrainSelectedInstOperands,
     /* 170497 */   // GIR_Coverage, 1351,
     /* 170497 */   GIR_Done,
     /* 170498 */ // Label 2676: @170498
     /* 170498 */ GIM_Reject,
     /* 170499 */ // Label 2672: @170499
     /* 170499 */ GIM_Reject,
     /* 170500 */ // Label 61: @170500
     /* 170500 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2681*/ GIMT_Encode4(170679),
     /* 170511 */ /*GILLT_v2s64*//*Label 2677*/ GIMT_Encode4(170527),
     /* 170515 */ /*GILLT_v4s32*//*Label 2678*/ GIMT_Encode4(170601),
     /* 170519 */ /*GILLT_v8s16*//*Label 2679*/ GIMT_Encode4(170627),
     /* 170523 */ /*GILLT_v16s8*//*Label 2680*/ GIMT_Encode4(170653),
     /* 170527 */ // Label 2677: @170527
     /* 170527 */ GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(170600), // Rule ID 1925 //
     /* 170532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170545 */   // (umax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170545 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170548 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170552 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170557 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170561 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170578 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170582 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /* 170590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170595 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170598 */   GIR_RootConstrainSelectedInstOperands,
     /* 170599 */   // GIR_Coverage, 1925,
     /* 170599 */   GIR_EraseRootFromParent_Done,
     /* 170600 */ // Label 2682: @170600
     /* 170600 */ GIM_Reject,
     /* 170601 */ // Label 2678: @170601
     /* 170601 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(170626), // Rule ID 1349 //
     /* 170606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170619 */   // (umax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /* 170624 */   GIR_RootConstrainSelectedInstOperands,
     /* 170625 */   // GIR_Coverage, 1349,
     /* 170625 */   GIR_Done,
     /* 170626 */ // Label 2683: @170626
     /* 170626 */ GIM_Reject,
     /* 170627 */ // Label 2679: @170627
     /* 170627 */ GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(170652), // Rule ID 1347 //
     /* 170632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170645 */   // (umax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /* 170650 */   GIR_RootConstrainSelectedInstOperands,
     /* 170651 */   // GIR_Coverage, 1347,
     /* 170651 */   GIR_Done,
     /* 170652 */ // Label 2684: @170652
     /* 170652 */ GIM_Reject,
     /* 170653 */ // Label 2680: @170653
     /* 170653 */ GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(170678), // Rule ID 1345 //
     /* 170658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170671 */   // (umax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /* 170676 */   GIR_RootConstrainSelectedInstOperands,
     /* 170677 */   // GIR_Coverage, 1345,
     /* 170677 */   GIR_Done,
     /* 170678 */ // Label 2685: @170678
     /* 170678 */ GIM_Reject,
     /* 170679 */ // Label 2681: @170679
     /* 170679 */ GIM_Reject,
     /* 170680 */ // Label 62: @170680
     /* 170680 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2688*/ GIMT_Encode4(170981),
     /* 170691 */ /*GILLT_s32*//*Label 2686*/ GIMT_Encode4(170699),
     /* 170695 */ /*GILLT_s64*//*Label 2687*/ GIMT_Encode4(170840),
     /* 170699 */ // Label 2686: @170699
     /* 170699 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(170759), // Rule ID 2032 //
     /* 170704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 170707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 170714 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 170714 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170717 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 170721 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170726 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 170730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170735 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 170739 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170744 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 170752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 170754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170757 */   GIR_RootConstrainSelectedInstOperands,
     /* 170758 */   // GIR_Coverage, 2032,
     /* 170758 */   GIR_EraseRootFromParent_Done,
     /* 170759 */ // Label 2689: @170759
     /* 170759 */ GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(170839), // Rule ID 2033 //
     /* 170764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 170767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 170774 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 170774 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170777 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170781 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170786 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 170790 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170795 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170798 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 170802 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170807 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 170810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 170819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170824 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 170832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 170834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170837 */   GIR_RootConstrainSelectedInstOperands,
     /* 170838 */   // GIR_Coverage, 2033,
     /* 170838 */   GIR_EraseRootFromParent_Done,
     /* 170839 */ // Label 2690: @170839
     /* 170839 */ GIM_Reject,
     /* 170840 */ // Label 2687: @170840
     /* 170840 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(170900), // Rule ID 2030 //
     /* 170845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 170848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 170855 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 170855 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170858 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 170862 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170867 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 170871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 170880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170885 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 170893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 170895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170898 */   GIR_RootConstrainSelectedInstOperands,
     /* 170899 */   // GIR_Coverage, 2030,
     /* 170899 */   GIR_EraseRootFromParent_Done,
     /* 170900 */ // Label 2691: @170900
     /* 170900 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(170980), // Rule ID 2031 //
     /* 170905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 170908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 170915 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 170915 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170918 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170922 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170927 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 170931 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170936 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170939 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 170943 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170948 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 170951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 170960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170965 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 170973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 170975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170978 */   GIR_RootConstrainSelectedInstOperands,
     /* 170979 */   // GIR_Coverage, 2031,
     /* 170979 */   GIR_EraseRootFromParent_Done,
     /* 170980 */ // Label 2692: @170980
     /* 170980 */ GIM_Reject,
     /* 170981 */ // Label 2688: @170981
     /* 170981 */ GIM_Reject,
     /* 170982 */ // Label 63: @170982
     /* 170982 */ GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(171146),
     /* 170987 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170990 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2696*/ GIMT_Encode4(171145),
     /* 171001 */   /*GILLT_s32*//*Label 2694*/ GIMT_Encode4(171009),
     /* 171005 */   /*GILLT_s64*//*Label 2695*/ GIMT_Encode4(171087),
     /* 171009 */   // Label 2694: @171009
     /* 171009 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(171086), // Rule ID 2035 //
     /* 171014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171021 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 171021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171033 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171037 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 171042 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171045 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171049 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171054 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 171057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171084 */     GIR_RootConstrainSelectedInstOperands,
     /* 171085 */     // GIR_Coverage, 2035,
     /* 171085 */     GIR_EraseRootFromParent_Done,
     /* 171086 */   // Label 2697: @171086
     /* 171086 */   GIM_Reject,
     /* 171087 */   // Label 2695: @171087
     /* 171087 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(171144), // Rule ID 2034 //
     /* 171092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171099 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 171099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171111 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171129 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171142 */     GIR_RootConstrainSelectedInstOperands,
     /* 171143 */     // GIR_Coverage, 2034,
     /* 171143 */     GIR_EraseRootFromParent_Done,
     /* 171144 */   // Label 2698: @171144
     /* 171144 */   GIM_Reject,
     /* 171145 */   // Label 2696: @171145
     /* 171145 */   GIM_Reject,
     /* 171146 */ // Label 2693: @171146
     /* 171146 */ GIM_Reject,
     /* 171147 */ // Label 64: @171147
     /* 171147 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(171162), // Rule ID 15 //
     /* 171152 */   // MIs[0] LI
     /* 171152 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 171155 */   // (br (bb:{ *:[Other] }):$LI)  =>  (B (bb:{ *:[Other] }):$LI)
     /* 171155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::B),
     /* 171160 */   GIR_RootConstrainSelectedInstOperands,
     /* 171161 */   // GIR_Coverage, 15,
     /* 171161 */   GIR_Done,
     /* 171162 */ // Label 2699: @171162
     /* 171162 */ GIM_Reject,
     /* 171163 */ // Label 65: @171163
     /* 171163 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(8), /*)*//*default:*//*Label 2702*/ GIMT_Encode4(171280),
     /* 171174 */ /*GILLT_v8s16*//*Label 2700*/ GIMT_Encode4(171182),
     /* 171178 */ /*GILLT_v16s8*//*Label 2701*/ GIMT_Encode4(171245),
     /* 171182 */ // Label 2700: @171182
     /* 171182 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(171244), // Rule ID 3487 //
     /* 171187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 171190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171196 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171203 */   // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSHLX:{ *:[v8i16] } ?:{ *:[v8i16] }:$vDi, (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$rB, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), ?:{ *:[i32] }:$rA)
     /* 171203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rB
     /* 171219 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 171222 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 171225 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/30,
     /* 171228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /* 171233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 171235 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 171237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171240 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 171242 */   GIR_RootConstrainSelectedInstOperands,
     /* 171243 */   // GIR_Coverage, 3487,
     /* 171243 */   GIR_EraseRootFromParent_Done,
     /* 171244 */ // Label 2703: @171244
     /* 171244 */ GIM_Reject,
     /* 171245 */ // Label 2701: @171245
     /* 171245 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(171279), // Rule ID 3486 //
     /* 171250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 171253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171266 */   // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSBLX:{ *:[v16i8] } ?:{ *:[v16i8] }:$vDi, ?:{ *:[i32] }:$rB, ?:{ *:[i32] }:$rA)
     /* 171266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /* 171269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 171271 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 171273 */   GIR_RootToRootCopy, /*OpIdx*/3, // rB
     /* 171275 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 171277 */   GIR_RootConstrainSelectedInstOperands,
     /* 171278 */   // GIR_Coverage, 3486,
     /* 171278 */   GIR_EraseRootFromParent_Done,
     /* 171279 */ // Label 2704: @171279
     /* 171279 */ GIM_Reject,
     /* 171280 */ // Label 2702: @171280
     /* 171280 */ GIM_Reject,
     /* 171281 */ // Label 66: @171281
     /* 171281 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2711*/ GIMT_Encode4(171458),
     /* 171292 */ /*GILLT_s32*//*Label 2705*/ GIMT_Encode4(171320),
     /* 171296 */ /*GILLT_s64*//*Label 2706*/ GIMT_Encode4(171343), GIMT_Encode4(0),
     /* 171304 */ /*GILLT_v2s64*//*Label 2707*/ GIMT_Encode4(171366),
     /* 171308 */ /*GILLT_v4s32*//*Label 2708*/ GIMT_Encode4(171389),
     /* 171312 */ /*GILLT_v8s16*//*Label 2709*/ GIMT_Encode4(171412),
     /* 171316 */ /*GILLT_v16s8*//*Label 2710*/ GIMT_Encode4(171435),
     /* 171320 */ // Label 2705: @171320
     /* 171320 */ GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(171342), // Rule ID 134 //
     /* 171325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 171328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171335 */   // (cttz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTTZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZW),
     /* 171340 */   GIR_RootConstrainSelectedInstOperands,
     /* 171341 */   // GIR_Coverage, 134,
     /* 171341 */   GIR_Done,
     /* 171342 */ // Label 2712: @171342
     /* 171342 */ GIM_Reject,
     /* 171343 */ // Label 2706: @171343
     /* 171343 */ GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(171365), // Rule ID 684 //
     /* 171348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 171351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171358 */   // (cttz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTTZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZD),
     /* 171363 */   GIR_RootConstrainSelectedInstOperands,
     /* 171364 */   // GIR_Coverage, 684,
     /* 171364 */   GIR_Done,
     /* 171365 */ // Label 2713: @171365
     /* 171365 */ GIM_Reject,
     /* 171366 */ // Label 2707: @171366
     /* 171366 */ GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(171388), // Rule ID 535 //
     /* 171371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171381 */   // (cttz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZD),
     /* 171386 */   GIR_RootConstrainSelectedInstOperands,
     /* 171387 */   // GIR_Coverage, 535,
     /* 171387 */   GIR_Done,
     /* 171388 */ // Label 2714: @171388
     /* 171388 */ GIM_Reject,
     /* 171389 */ // Label 2708: @171389
     /* 171389 */ GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(171411), // Rule ID 534 //
     /* 171394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171404 */   // (cttz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCTZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZW),
     /* 171409 */   GIR_RootConstrainSelectedInstOperands,
     /* 171410 */   // GIR_Coverage, 534,
     /* 171410 */   GIR_Done,
     /* 171411 */ // Label 2715: @171411
     /* 171411 */ GIM_Reject,
     /* 171412 */ // Label 2709: @171412
     /* 171412 */ GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(171434), // Rule ID 533 //
     /* 171417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171427 */   // (cttz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCTZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZH),
     /* 171432 */   GIR_RootConstrainSelectedInstOperands,
     /* 171433 */   // GIR_Coverage, 533,
     /* 171433 */   GIR_Done,
     /* 171434 */ // Label 2716: @171434
     /* 171434 */ GIM_Reject,
     /* 171435 */ // Label 2710: @171435
     /* 171435 */ GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(171457), // Rule ID 532 //
     /* 171440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171450 */   // (cttz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZB),
     /* 171455 */   GIR_RootConstrainSelectedInstOperands,
     /* 171456 */   // GIR_Coverage, 532,
     /* 171456 */   GIR_Done,
     /* 171457 */ // Label 2717: @171457
     /* 171457 */ GIM_Reject,
     /* 171458 */ // Label 2711: @171458
     /* 171458 */ GIM_Reject,
     /* 171459 */ // Label 67: @171459
     /* 171459 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2724*/ GIMT_Encode4(171630),
     /* 171470 */ /*GILLT_s32*//*Label 2718*/ GIMT_Encode4(171498),
     /* 171474 */ /*GILLT_s64*//*Label 2719*/ GIMT_Encode4(171518), GIMT_Encode4(0),
     /* 171482 */ /*GILLT_v2s64*//*Label 2720*/ GIMT_Encode4(171538),
     /* 171486 */ /*GILLT_v4s32*//*Label 2721*/ GIMT_Encode4(171561),
     /* 171490 */ /*GILLT_v8s16*//*Label 2722*/ GIMT_Encode4(171584),
     /* 171494 */ /*GILLT_v16s8*//*Label 2723*/ GIMT_Encode4(171607),
     /* 171498 */ // Label 2718: @171498
     /* 171498 */ GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(171517), // Rule ID 133 //
     /* 171503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171510 */   // (ctlz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTLZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 171515 */   GIR_RootConstrainSelectedInstOperands,
     /* 171516 */   // GIR_Coverage, 133,
     /* 171516 */   GIR_Done,
     /* 171517 */ // Label 2725: @171517
     /* 171517 */ GIM_Reject,
     /* 171518 */ // Label 2719: @171518
     /* 171518 */ GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(171537), // Rule ID 683 //
     /* 171523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171530 */   // (ctlz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTLZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 171535 */   GIR_RootConstrainSelectedInstOperands,
     /* 171536 */   // GIR_Coverage, 683,
     /* 171536 */   GIR_Done,
     /* 171537 */ // Label 2726: @171537
     /* 171537 */ GIM_Reject,
     /* 171538 */ // Label 2720: @171538
     /* 171538 */ GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(171560), // Rule ID 482 //
     /* 171543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171553 */   // (ctlz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZD),
     /* 171558 */   GIR_RootConstrainSelectedInstOperands,
     /* 171559 */   // GIR_Coverage, 482,
     /* 171559 */   GIR_Done,
     /* 171560 */ // Label 2727: @171560
     /* 171560 */ GIM_Reject,
     /* 171561 */ // Label 2721: @171561
     /* 171561 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(171583), // Rule ID 481 //
     /* 171566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171576 */   // (ctlz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCLZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZW),
     /* 171581 */   GIR_RootConstrainSelectedInstOperands,
     /* 171582 */   // GIR_Coverage, 481,
     /* 171582 */   GIR_Done,
     /* 171583 */ // Label 2728: @171583
     /* 171583 */ GIM_Reject,
     /* 171584 */ // Label 2722: @171584
     /* 171584 */ GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(171606), // Rule ID 480 //
     /* 171589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171599 */   // (ctlz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCLZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZH),
     /* 171604 */   GIR_RootConstrainSelectedInstOperands,
     /* 171605 */   // GIR_Coverage, 480,
     /* 171605 */   GIR_Done,
     /* 171606 */ // Label 2729: @171606
     /* 171606 */ GIM_Reject,
     /* 171607 */ // Label 2723: @171607
     /* 171607 */ GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(171629), // Rule ID 479 //
     /* 171612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171622 */   // (ctlz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZB),
     /* 171627 */   GIR_RootConstrainSelectedInstOperands,
     /* 171628 */   // GIR_Coverage, 479,
     /* 171628 */   GIR_Done,
     /* 171629 */ // Label 2730: @171629
     /* 171629 */ GIM_Reject,
     /* 171630 */ // Label 2724: @171630
     /* 171630 */ GIM_Reject,
     /* 171631 */ // Label 68: @171631
     /* 171631 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2737*/ GIMT_Encode4(171802),
     /* 171642 */ /*GILLT_s32*//*Label 2731*/ GIMT_Encode4(171670),
     /* 171646 */ /*GILLT_s64*//*Label 2732*/ GIMT_Encode4(171690), GIMT_Encode4(0),
     /* 171654 */ /*GILLT_v2s64*//*Label 2733*/ GIMT_Encode4(171710),
     /* 171658 */ /*GILLT_v4s32*//*Label 2734*/ GIMT_Encode4(171733),
     /* 171662 */ /*GILLT_v8s16*//*Label 2735*/ GIMT_Encode4(171756),
     /* 171666 */ /*GILLT_v16s8*//*Label 2736*/ GIMT_Encode4(171779),
     /* 171670 */ // Label 2731: @171670
     /* 171670 */ GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(171689), // Rule ID 688 //
     /* 171675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171682 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (POPCNTW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTW),
     /* 171687 */   GIR_RootConstrainSelectedInstOperands,
     /* 171688 */   // GIR_Coverage, 688,
     /* 171688 */   GIR_Done,
     /* 171689 */ // Label 2738: @171689
     /* 171689 */ GIM_Reject,
     /* 171690 */ // Label 2732: @171690
     /* 171690 */ GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(171709), // Rule ID 685 //
     /* 171695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171702 */   // (ctpop:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (POPCNTD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTD),
     /* 171707 */   GIR_RootConstrainSelectedInstOperands,
     /* 171708 */   // GIR_Coverage, 685,
     /* 171708 */   GIR_Done,
     /* 171709 */ // Label 2739: @171709
     /* 171709 */ GIM_Reject,
     /* 171710 */ // Label 2733: @171710
     /* 171710 */ GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(171732), // Rule ID 486 //
     /* 171715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171725 */   // (ctpop:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VPOPCNTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTD),
     /* 171730 */   GIR_RootConstrainSelectedInstOperands,
     /* 171731 */   // GIR_Coverage, 486,
     /* 171731 */   GIR_Done,
     /* 171732 */ // Label 2740: @171732
     /* 171732 */ GIM_Reject,
     /* 171733 */ // Label 2734: @171733
     /* 171733 */ GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(171755), // Rule ID 485 //
     /* 171738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171748 */   // (ctpop:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VPOPCNTW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTW),
     /* 171753 */   GIR_RootConstrainSelectedInstOperands,
     /* 171754 */   // GIR_Coverage, 485,
     /* 171754 */   GIR_Done,
     /* 171755 */ // Label 2741: @171755
     /* 171755 */ GIM_Reject,
     /* 171756 */ // Label 2735: @171756
     /* 171756 */ GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(171778), // Rule ID 484 //
     /* 171761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171771 */   // (ctpop:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VPOPCNTH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTH),
     /* 171776 */   GIR_RootConstrainSelectedInstOperands,
     /* 171777 */   // GIR_Coverage, 484,
     /* 171777 */   GIR_Done,
     /* 171778 */ // Label 2742: @171778
     /* 171778 */ GIM_Reject,
     /* 171779 */ // Label 2736: @171779
     /* 171779 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(171801), // Rule ID 483 //
     /* 171784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171794 */   // (ctpop:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VPOPCNTB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTB),
     /* 171799 */   GIR_RootConstrainSelectedInstOperands,
     /* 171800 */   // GIR_Coverage, 483,
     /* 171800 */   GIR_Done,
     /* 171801 */ // Label 2743: @171801
     /* 171801 */ GIM_Reject,
     /* 171802 */ // Label 2737: @171802
     /* 171802 */ GIM_Reject,
     /* 171803 */ // Label 69: @171803
     /* 171803 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 2750*/ GIMT_Encode4(172066),
     /* 171814 */ /*GILLT_s32*//*Label 2744*/ GIMT_Encode4(171838),
     /* 171818 */ /*GILLT_s64*//*Label 2745*/ GIMT_Encode4(171861),
     /* 171822 */ /*GILLT_s128*//*Label 2746*/ GIMT_Encode4(171884),
     /* 171826 */ /*GILLT_v2s64*//*Label 2747*/ GIMT_Encode4(171952),
     /* 171830 */ /*GILLT_v4s32*//*Label 2748*/ GIMT_Encode4(171975),
     /* 171834 */ /*GILLT_v8s16*//*Label 2749*/ GIMT_Encode4(171998),
     /* 171838 */ // Label 2744: @171838
     /* 171838 */ GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(171860), // Rule ID 1137 //
     /* 171843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 171846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171853 */   // (bswap:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (BRW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRW),
     /* 171858 */   GIR_RootConstrainSelectedInstOperands,
     /* 171859 */   // GIR_Coverage, 1137,
     /* 171859 */   GIR_Done,
     /* 171860 */ // Label 2751: @171860
     /* 171860 */ GIM_Reject,
     /* 171861 */ // Label 2745: @171861
     /* 171861 */ GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(171883), // Rule ID 1138 //
     /* 171866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 171869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171876 */   // (bswap:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (BRD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRD),
     /* 171881 */   GIR_RootConstrainSelectedInstOperands,
     /* 171882 */   // GIR_Coverage, 1138,
     /* 171882 */   GIR_Done,
     /* 171883 */ // Label 2752: @171883
     /* 171883 */ GIM_Reject,
     /* 171884 */ // Label 2746: @171884
     /* 171884 */ GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(171951), // Rule ID 2169 //
     /* 171889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 171892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 171895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171899 */   // (bswap:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXBRQ:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 171899 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 171902 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171906 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171911 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 171915 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 171920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 171923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRQ),
     /* 171927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171932 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171950 */   // GIR_Coverage, 2169,
     /* 171950 */   GIR_EraseRootFromParent_Done,
     /* 171951 */ // Label 2753: @171951
     /* 171951 */ GIM_Reject,
     /* 171952 */ // Label 2747: @171952
     /* 171952 */ GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(171974), // Rule ID 1034 //
     /* 171957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 171960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 171967 */   // (bswap:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XXBRD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)
     /* 171967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRD),
     /* 171972 */   GIR_RootConstrainSelectedInstOperands,
     /* 171973 */   // GIR_Coverage, 1034,
     /* 171973 */   GIR_Done,
     /* 171974 */ // Label 2754: @171974
     /* 171974 */ GIM_Reject,
     /* 171975 */ // Label 2748: @171975
     /* 171975 */ GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(171997), // Rule ID 1033 //
     /* 171980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 171983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 171990 */   // (bswap:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XXBRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)
     /* 171990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRW),
     /* 171995 */   GIR_RootConstrainSelectedInstOperands,
     /* 171996 */   // GIR_Coverage, 1033,
     /* 171996 */   GIR_Done,
     /* 171997 */ // Label 2755: @171997
     /* 171997 */ GIM_Reject,
     /* 171998 */ // Label 2749: @171998
     /* 171998 */ GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(172065), // Rule ID 2168 //
     /* 172003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172013 */   // (bswap:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBRH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 172013 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 172016 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172020 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172025 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172029 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 172037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRH),
     /* 172041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172046 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 172049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172064 */   // GIR_Coverage, 2168,
     /* 172064 */   GIR_EraseRootFromParent_Done,
     /* 172065 */ // Label 2756: @172065
     /* 172065 */ GIM_Reject,
     /* 172066 */ // Label 2750: @172066
     /* 172066 */ GIM_Reject,
     /* 172067 */ // Label 70: @172067
     /* 172067 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2759*/ GIMT_Encode4(208072),
     /* 172078 */ /*GILLT_s32*//*Label 2757*/ GIMT_Encode4(172086),
     /* 172082 */ /*GILLT_s64*//*Label 2758*/ GIMT_Encode4(182381),
     /* 172086 */ // Label 2757: @172086
     /* 172086 */ GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(182380),
     /* 172091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 172098 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(177254), // Rule ID 4881 //
     /* 172103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 172106 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLDICL_32:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), 0:{ *:[i32] }, 32:{ *:[i32] })
     /* 172106 */     GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172110 */     GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172115 */     GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172122 */     GIR_AddImm, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 172133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 172136 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172140 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172145 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172152 */     GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 172157 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 172168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 172171 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172175 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172180 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172187 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 172198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 172201 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172205 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172210 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172217 */     GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 172222 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 172233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 172236 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172240 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172245 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172252 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 172266 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172270 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172275 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172282 */     GIR_AddSimpleTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 172287 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 172301 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172305 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172310 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172317 */     GIR_Copy, /*NewInsnID*//* 186(*/0xBA, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172322 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/1,
     /* 172326 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/0,
     /* 172330 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/30,
     /* 172334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 172337 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172341 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172346 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172353 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 172358 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 172363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 172366 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172370 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172375 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172382 */     GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 172396 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172400 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172405 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172412 */     GIR_AddSimpleTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 172417 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 172431 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172435 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172440 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172447 */     GIR_Copy, /*NewInsnID*//* 182(*/0xB6, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172452 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 172456 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 172460 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 172464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 172467 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172471 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172476 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172483 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 172488 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 172493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 172496 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172500 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172505 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172512 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 172517 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 172522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 172525 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172529 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172534 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172541 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 172546 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/2,
     /* 172550 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/0,
     /* 172554 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/29,
     /* 172558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 172561 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172565 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172570 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172577 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 172582 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 172587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 172590 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172594 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172599 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172606 */     GIR_AddImm, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 172617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 172620 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172624 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172629 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172636 */     GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 172641 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 172652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 172655 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172659 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172664 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172671 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 172685 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172689 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172694 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172701 */     GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 172706 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 172720 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172724 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172729 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172736 */     GIR_Copy, /*NewInsnID*//* 173(*/0xAD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172741 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/1,
     /* 172745 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/0,
     /* 172749 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/30,
     /* 172753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 172756 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172760 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172765 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172772 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 172777 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 172782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 172785 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172789 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172794 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172801 */     GIR_AddImm, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 172815 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172819 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172824 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172831 */     GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 172836 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 172850 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172854 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172859 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172866 */     GIR_Copy, /*NewInsnID*//* 169(*/0xA9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172871 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 172875 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/1,
     /* 172879 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 172883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 172886 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172890 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172895 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172902 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 172907 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 172912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 172915 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172919 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172924 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172931 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 172936 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 172941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 172944 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172948 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172953 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172960 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 172965 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/30,
     /* 172969 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/2,
     /* 172973 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/31,
     /* 172977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 172980 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172984 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172989 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172996 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 173001 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 173006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 173009 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173013 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173018 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173025 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 173030 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 173035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 173038 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173042 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173047 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173054 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 173059 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/4,
     /* 173063 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/0,
     /* 173067 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/27,
     /* 173071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 173074 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173078 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173083 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173090 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 173095 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 173100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 173103 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173107 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173112 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173119 */     GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 173130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 173133 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173137 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173142 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173149 */     GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 173154 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 173165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 173168 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173172 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173177 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173184 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 173195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 173198 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173202 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173207 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173214 */     GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 173219 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 173230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 173233 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173237 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173242 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173249 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 173263 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173267 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173272 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173279 */     GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 173284 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 173298 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173302 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173307 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173314 */     GIR_Copy, /*NewInsnID*//* 155(*/0x9B, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173319 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/1,
     /* 173323 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/0,
     /* 173327 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/30,
     /* 173331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 173334 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173338 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173343 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173350 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 173355 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 173360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 173363 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173367 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173372 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173379 */     GIR_AddImm, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 173393 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173397 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173402 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173409 */     GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 173414 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 173428 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173432 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173437 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173444 */     GIR_Copy, /*NewInsnID*//* 151(*/0x97, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173449 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 173453 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/1,
     /* 173457 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 173461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 173464 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173468 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173473 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173480 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 173485 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 173490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 173493 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173497 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173502 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173509 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 173514 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 173519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 173522 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173526 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173531 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173538 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 173543 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/2,
     /* 173547 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/0,
     /* 173551 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/29,
     /* 173555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 173558 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173562 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173567 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173574 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 173579 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 173584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 173587 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173591 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173596 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173603 */     GIR_AddImm, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 173614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 173617 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173621 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173626 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173633 */     GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 173638 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 173649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 173652 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173656 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173661 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173668 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 173682 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173686 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173691 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173698 */     GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 173703 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 173717 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173721 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173726 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173733 */     GIR_Copy, /*NewInsnID*//* 142(*/0x8E, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173738 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/1,
     /* 173742 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/0,
     /* 173746 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/30,
     /* 173750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 173753 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173757 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173762 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173769 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 173774 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 173779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 173782 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173786 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173791 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173798 */     GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 173812 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173816 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173821 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173828 */     GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 173833 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 173847 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173851 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173856 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173863 */     GIR_Copy, /*NewInsnID*//* 138(*/0x8A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173868 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 173872 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/1,
     /* 173876 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 173880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 173883 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173887 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173892 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173899 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 173904 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 173909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 173912 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173916 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173921 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173928 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 173933 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 173938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 173941 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173945 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173950 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173957 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 173962 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/30,
     /* 173966 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/2,
     /* 173970 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/31,
     /* 173974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 173977 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173981 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173986 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173993 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 173998 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 174003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 174006 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174010 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174015 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174022 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 174027 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 174032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 174035 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174039 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174044 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174051 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 174056 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/28,
     /* 174060 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/4,
     /* 174064 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/31,
     /* 174068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 174071 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174075 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174080 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174087 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 174092 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 174097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 174100 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174104 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174109 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174116 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 174121 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 174126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 174129 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174133 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174138 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174145 */     GIR_AddImm, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 174159 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 174162 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174167 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174173 */     GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 174178 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 174192 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 174195 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174199 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174204 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 174214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 174216 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 174219 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174223 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174228 */     GIR_AddSimpleTempRegister, /*InsnID*/126, /*TempRegID*/126,
     /* 174231 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 174241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 174243 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 174246 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174250 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174255 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 174265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 174267 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 174270 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174274 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174279 */     GIR_AddSimpleTempRegister, /*InsnID*/124, /*TempRegID*/124,
     /* 174282 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 174292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 174294 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 174297 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174301 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174306 */     GIR_Copy, /*NewInsnID*/123, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174310 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 174313 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/0,
     /* 174316 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/30,
     /* 174319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 174321 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 174324 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174328 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174333 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 174336 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/123,
     /* 174339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 174341 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 174344 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174348 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174353 */     GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(21845),
     /* 174363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 174365 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 174368 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174372 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174377 */     GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 174380 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 174390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 174392 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 174395 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174399 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174404 */     GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174408 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 174411 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 174414 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 174417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 174419 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 174422 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174426 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174431 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 174434 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 174437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 174439 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 174442 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174446 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174451 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 174454 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/121,
     /* 174457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 174459 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 174462 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174466 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174471 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 174474 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/2,
     /* 174477 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/0,
     /* 174480 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/29,
     /* 174483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 174485 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 174488 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174492 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174497 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 174500 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/125,
     /* 174503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 174505 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 174508 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174512 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174517 */     GIR_AddImm, /*InsnID*/114, /*Imm*/GIMT_Encode8(13107),
     /* 174527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 174529 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 174532 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174536 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174541 */     GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 174544 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 174554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 174556 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 174559 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174563 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174568 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(43690),
     /* 174578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 174580 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 174583 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174587 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174592 */     GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 174595 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 174605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 174607 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 174610 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174614 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174619 */     GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174623 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 174626 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/0,
     /* 174629 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/30,
     /* 174632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 174634 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 174637 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174641 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174646 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 174649 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 174652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 174654 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 174657 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174661 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174666 */     GIR_AddImm, /*InsnID*/108, /*Imm*/GIMT_Encode8(21845),
     /* 174676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 174678 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 174681 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174685 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174690 */     GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 174693 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 174703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 174705 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 174708 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174712 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174717 */     GIR_Copy, /*NewInsnID*/106, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174721 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 174724 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/1,
     /* 174727 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 174730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 174732 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 174735 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174739 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174744 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/105,
     /* 174747 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/106,
     /* 174750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 174752 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 174755 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174759 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174764 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 174767 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/108,
     /* 174770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 174772 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 174775 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174779 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174784 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 174787 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/30,
     /* 174790 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/2,
     /* 174793 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/31,
     /* 174796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 174798 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 174801 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174805 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174810 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 174813 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/112,
     /* 174816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 174818 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 174821 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174825 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174830 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 174833 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/114,
     /* 174836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 174838 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 174841 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174845 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174850 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 174853 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/4,
     /* 174856 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/0,
     /* 174859 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/27,
     /* 174862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 174864 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 174867 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174871 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174876 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 174879 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/127,
     /* 174882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 174884 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 174887 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174891 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174896 */     GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(3855),
     /* 174906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 174908 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 174911 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174915 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174920 */     GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 174923 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 174933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 174935 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 174938 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174942 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174947 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(52428),
     /* 174957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 174959 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 174962 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174966 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174971 */     GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 174974 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 174984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 174986 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 174989 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174993 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174998 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(43690),
     /* 175008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 175010 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 175013 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175017 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175022 */     GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 175025 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 175035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 175037 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 175040 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175044 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175049 */     GIR_Copy, /*NewInsnID*/92, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175053 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/1,
     /* 175056 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/0,
     /* 175059 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/30,
     /* 175062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 175064 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 175067 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175071 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175076 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/91,
     /* 175079 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/92,
     /* 175082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 175084 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 175087 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175091 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175096 */     GIR_AddImm, /*InsnID*/90, /*Imm*/GIMT_Encode8(21845),
     /* 175106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 175108 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 175111 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175115 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175120 */     GIR_AddSimpleTempRegister, /*InsnID*/89, /*TempRegID*/89,
     /* 175123 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 175133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 175135 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 175138 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175142 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175147 */     GIR_Copy, /*NewInsnID*/88, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175151 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 175154 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/1,
     /* 175157 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 175160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 175162 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 175165 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175169 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175174 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/87,
     /* 175177 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/88,
     /* 175180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 175182 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 175185 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175189 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175194 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 175197 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/90,
     /* 175200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 175202 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 175205 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175209 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175214 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 175217 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/2,
     /* 175220 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/0,
     /* 175223 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/29,
     /* 175226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 175228 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 175231 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175235 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175240 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 175243 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/94,
     /* 175246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 175248 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 175251 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175255 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175260 */     GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(13107),
     /* 175270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 175272 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 175275 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175279 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175284 */     GIR_AddSimpleTempRegister, /*InsnID*/82, /*TempRegID*/82,
     /* 175287 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 175297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 175299 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 175302 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175306 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175311 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(43690),
     /* 175321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 175323 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 175326 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175330 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175335 */     GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 175338 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 175348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 175350 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 175353 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175357 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175362 */     GIR_Copy, /*NewInsnID*/79, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175366 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/1,
     /* 175369 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/0,
     /* 175372 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/30,
     /* 175375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 175377 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 175380 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175384 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175389 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 175392 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/79,
     /* 175395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 175397 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 175400 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175404 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175409 */     GIR_AddImm, /*InsnID*/77, /*Imm*/GIMT_Encode8(21845),
     /* 175419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 175421 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 175424 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175428 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175433 */     GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 175436 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 175446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 175448 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 175451 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175455 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175460 */     GIR_Copy, /*NewInsnID*/75, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175464 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 175467 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/1,
     /* 175470 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 175473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 175475 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 175478 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175482 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175487 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/74,
     /* 175490 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/75,
     /* 175493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 175495 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 175498 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175502 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175507 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 175510 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/77,
     /* 175513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 175515 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 175518 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175522 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175527 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 175530 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/30,
     /* 175533 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/2,
     /* 175536 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/31,
     /* 175539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 175541 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 175544 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175548 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175553 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 175556 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/81,
     /* 175559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 175561 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 175564 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175568 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175573 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 175576 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/83,
     /* 175579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 175581 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 175584 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175588 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175593 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 175596 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/28,
     /* 175599 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/4,
     /* 175602 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/31,
     /* 175605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 175607 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 175610 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175614 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175619 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 175622 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/96,
     /* 175625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 175627 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 175630 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175634 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175639 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 175642 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/98,
     /* 175645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 175647 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 175650 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175654 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175659 */     GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(61680),
     /* 175669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 175671 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 175674 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175678 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175683 */     GIR_AddSimpleTempRegister, /*InsnID*/65, /*TempRegID*/65,
     /* 175686 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 175696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 175698 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 175701 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175705 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175710 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(52428),
     /* 175720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 175722 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 175725 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175729 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175734 */     GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 175737 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 175747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 175749 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 175752 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175756 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175761 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(43690),
     /* 175771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 175773 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 175776 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175780 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175785 */     GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 175788 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 175798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 175800 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 175803 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175807 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175812 */     GIR_Copy, /*NewInsnID*/60, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175816 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/1,
     /* 175819 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/0,
     /* 175822 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/30,
     /* 175825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 175827 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 175830 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175834 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175839 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 175842 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/60,
     /* 175845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 175847 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 175850 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175854 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175859 */     GIR_AddImm, /*InsnID*/58, /*Imm*/GIMT_Encode8(21845),
     /* 175869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 175871 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 175874 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175878 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175883 */     GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 175886 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 175896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 175898 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 175901 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175905 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175910 */     GIR_Copy, /*NewInsnID*/56, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175914 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 175917 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/1,
     /* 175920 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 175923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 175925 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 175928 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175932 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175937 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 175940 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/56,
     /* 175943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 175945 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 175948 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175952 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175957 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 175960 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/58,
     /* 175963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 175965 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 175968 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175972 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175977 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 175980 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/2,
     /* 175983 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/0,
     /* 175986 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/29,
     /* 175989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 175991 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 175994 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175998 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176003 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 176006 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/62,
     /* 176009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 176011 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 176014 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176018 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176023 */     GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(13107),
     /* 176033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 176035 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 176038 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176042 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176047 */     GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 176050 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 176060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 176062 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 176065 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176069 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176074 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(43690),
     /* 176084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 176086 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 176089 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176093 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176098 */     GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 176101 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 176111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 176113 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 176116 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176120 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176125 */     GIR_Copy, /*NewInsnID*/47, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176129 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/1,
     /* 176132 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/0,
     /* 176135 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/30,
     /* 176138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 176140 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 176143 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176147 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176152 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 176155 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/47,
     /* 176158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 176160 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 176163 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176167 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176172 */     GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 176182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 176184 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 176187 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176191 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176196 */     GIR_AddSimpleTempRegister, /*InsnID*/44, /*TempRegID*/44,
     /* 176199 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 176209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 176211 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 176214 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176218 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176223 */     GIR_Copy, /*NewInsnID*/43, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176227 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 176230 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/1,
     /* 176233 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 176236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 176238 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 176241 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176245 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176250 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 176253 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/43,
     /* 176256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 176258 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 176261 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176265 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176270 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 176273 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/45,
     /* 176276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 176278 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 176281 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176285 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176290 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 176293 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/30,
     /* 176296 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/2,
     /* 176299 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/31,
     /* 176302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 176304 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 176307 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176311 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176316 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 176319 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/49,
     /* 176322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 176324 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 176327 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176331 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176336 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 176339 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/51,
     /* 176342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 176344 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 176347 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176351 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176356 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 176359 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/4,
     /* 176362 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/0,
     /* 176365 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/27,
     /* 176368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 176370 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 176373 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176377 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176382 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 176385 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/64,
     /* 176388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 176390 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 176393 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176397 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176402 */     GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(3855),
     /* 176412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 176414 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 176417 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176421 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176426 */     GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 176429 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 176439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 176441 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 176444 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176448 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176453 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(52428),
     /* 176463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 176465 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 176468 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176472 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176477 */     GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
     /* 176480 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 176490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 176492 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 176495 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176499 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176504 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 176514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 176516 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 176519 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176523 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176528 */     GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
     /* 176531 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 176541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 176543 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 176546 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176550 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176555 */     GIR_Copy, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176559 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 176562 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/0,
     /* 176565 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/30,
     /* 176568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 176570 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 176573 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176577 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176582 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 176585 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/29,
     /* 176588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 176590 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 176593 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176597 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176602 */     GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(21845),
     /* 176612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 176614 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 176617 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176621 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176626 */     GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 176629 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 176639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 176641 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 176644 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176648 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176653 */     GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176657 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 176660 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 176663 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 176666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 176668 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 176671 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176675 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176680 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 176683 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 176686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 176688 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 176691 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176695 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176700 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 176703 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/27,
     /* 176706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 176708 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 176711 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176715 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176720 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 176723 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/2,
     /* 176726 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
     /* 176729 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/29,
     /* 176732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 176734 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 176737 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176741 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176746 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 176749 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/31,
     /* 176752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 176754 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 176757 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176761 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176766 */     GIR_AddImm, /*InsnID*/20, /*Imm*/GIMT_Encode8(13107),
     /* 176776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 176778 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 176781 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176785 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176790 */     GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 176793 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 176803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 176805 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 176808 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176812 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176817 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(43690),
     /* 176827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 176829 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 176832 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176836 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176841 */     GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 176844 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 176854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 176856 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 176859 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176863 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176868 */     GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176872 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 176875 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
     /* 176878 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/30,
     /* 176881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 176883 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 176886 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176890 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176895 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 176898 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 176901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 176903 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 176906 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176910 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176915 */     GIR_AddImm, /*InsnID*/14, /*Imm*/GIMT_Encode8(21845),
     /* 176925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 176927 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 176930 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176934 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176939 */     GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 176942 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 176952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 176954 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 176957 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176961 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176966 */     GIR_Copy, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176970 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 176973 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/1,
     /* 176976 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 176979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 176981 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 176984 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176988 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176993 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 176996 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 176999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 177001 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 177004 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177008 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177013 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 177016 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/14,
     /* 177019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 177021 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 177024 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177028 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177033 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 177036 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/30,
     /* 177039 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/2,
     /* 177042 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/31,
     /* 177045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 177047 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 177050 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177054 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177059 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 177062 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/18,
     /* 177065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 177067 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 177070 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177074 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177079 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 177082 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/20,
     /* 177085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 177087 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 177090 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177094 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177099 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 177102 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/28,
     /* 177105 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/4,
     /* 177108 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 177111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 177113 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 177116 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177120 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177125 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 177128 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/33,
     /* 177131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 177133 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 177136 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177140 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177145 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 177148 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/35,
     /* 177151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 177153 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 177156 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177160 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177165 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 177168 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 177171 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 177174 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/31,
     /* 177177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 177179 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177182 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 177186 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177191 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 177194 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/66,
     /* 177197 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 177200 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 177203 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 177206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 177208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 177215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177220 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 177223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 177227 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 177230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 177233 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 177236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 177241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 177243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 177252 */     GIR_RootConstrainSelectedInstOperands,
     /* 177253 */     // GIR_Coverage, 4881,
     /* 177253 */     GIR_EraseRootFromParent_Done,
     /* 177254 */   // Label 2761: @177254
     /* 177254 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(182379), // Rule ID 4882 //
     /* 177259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In32BitMode),
     /* 177262 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] })
     /* 177262 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177266 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177271 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177278 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 177289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 177292 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177296 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177301 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177308 */     GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 177313 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 177324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 177327 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177331 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177336 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177343 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 177354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 177357 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177361 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177366 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177373 */     GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 177378 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 177389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 177392 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177396 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177401 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177408 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 177422 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177426 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177431 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177438 */     GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 177443 */     GIR_AddImm, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 177457 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177461 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177466 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177473 */     GIR_Copy, /*NewInsnID*//* 185(*/0xB9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177478 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/1,
     /* 177482 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/0,
     /* 177486 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/30,
     /* 177490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 177493 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177497 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177502 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177509 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 177514 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 177519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 177522 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177526 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177531 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177538 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 177552 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177556 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177561 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177568 */     GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 177573 */     GIR_AddImm, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 177587 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177591 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177596 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177603 */     GIR_Copy, /*NewInsnID*//* 181(*/0xB5, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177608 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 177612 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/1,
     /* 177616 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 177620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 177623 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177627 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177632 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177639 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 177644 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 177649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 177652 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177656 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177661 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177668 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 177673 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 177678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 177681 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177685 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177690 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177697 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 177702 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/2,
     /* 177706 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/0,
     /* 177710 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/29,
     /* 177714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 177717 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177721 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177726 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177733 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 177738 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 177743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 177746 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177750 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177755 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177762 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 177773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 177776 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177780 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177785 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177792 */     GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 177797 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 177808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 177811 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177815 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177820 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177827 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 177841 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177845 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177850 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177857 */     GIR_AddSimpleTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 177862 */     GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 177876 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177880 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177885 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177892 */     GIR_Copy, /*NewInsnID*//* 172(*/0xAC, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177897 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/1,
     /* 177901 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/0,
     /* 177905 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/30,
     /* 177909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 177912 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177916 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177921 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177928 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 177933 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 177938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 177941 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177945 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177950 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177957 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 177971 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177975 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177980 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177987 */     GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 177992 */     GIR_AddImm, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 178006 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178010 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178015 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178022 */     GIR_Copy, /*NewInsnID*//* 168(*/0xA8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178027 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 178031 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/1,
     /* 178035 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 178039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 178042 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178046 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178051 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178058 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 178063 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 178068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 178071 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178075 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178080 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178087 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 178092 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 178097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 178100 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178104 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178109 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178116 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 178121 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/30,
     /* 178125 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/2,
     /* 178129 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/31,
     /* 178133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 178136 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178140 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178145 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178152 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 178157 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 178162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 178165 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178169 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178174 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178181 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 178186 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 178191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 178194 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178198 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178203 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178210 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 178215 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/4,
     /* 178219 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/0,
     /* 178223 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/27,
     /* 178227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 178230 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178234 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178239 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178246 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 178251 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 178256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 178259 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178263 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178268 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178275 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 178286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 178289 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178293 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178298 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178305 */     GIR_AddSimpleTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 178310 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 178321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 178324 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178328 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178333 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178340 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 178351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 178354 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178358 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178363 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178370 */     GIR_AddSimpleTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 178375 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 178386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 178389 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178393 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178398 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178405 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 178419 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178423 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178428 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178435 */     GIR_AddSimpleTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 178440 */     GIR_AddImm, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 178454 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178458 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178463 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178470 */     GIR_Copy, /*NewInsnID*//* 154(*/0x9A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178475 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 178479 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/0,
     /* 178483 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/30,
     /* 178487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 178490 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178494 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178499 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178506 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 178511 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 178516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 178519 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178523 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178528 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178535 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 178549 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178553 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178558 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178565 */     GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 178570 */     GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 178584 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178588 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178593 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178600 */     GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178605 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 178609 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 178613 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 178617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 178620 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178624 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178629 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178636 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 178641 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 178646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 178649 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178653 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178658 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178665 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 178670 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 178675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 178678 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178682 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178687 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178694 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 178699 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 178703 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/0,
     /* 178707 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/29,
     /* 178711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 178714 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178718 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178723 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178730 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 178735 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 178740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 178743 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178747 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178752 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178759 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 178770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 178773 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178777 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178782 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178789 */     GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 178794 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 178805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 178808 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178812 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178817 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178824 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 178838 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178842 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178847 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178854 */     GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 178859 */     GIR_AddImm, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 178873 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178877 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178882 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178889 */     GIR_Copy, /*NewInsnID*//* 141(*/0x8D, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178894 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/1,
     /* 178898 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/0,
     /* 178902 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/30,
     /* 178906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 178909 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178913 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178918 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178925 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 178930 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 178935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 178938 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178942 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178947 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178954 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 178968 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178972 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178977 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178984 */     GIR_AddSimpleTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 178989 */     GIR_AddImm, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 179000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 179003 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179007 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179012 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179019 */     GIR_Copy, /*NewInsnID*//* 137(*/0x89, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179024 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 179028 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 179032 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 179036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 179039 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179043 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179048 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179055 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 179060 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 179065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 179068 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179072 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179077 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179084 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 179089 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 179094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 179097 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179101 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179106 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179113 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 179118 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/30,
     /* 179122 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/2,
     /* 179126 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/31,
     /* 179130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 179133 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179137 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179142 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179149 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 179154 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 179159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 179162 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179166 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179171 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179178 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 179183 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 179188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 179191 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179195 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179200 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179207 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 179212 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/28,
     /* 179216 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/4,
     /* 179220 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/31,
     /* 179224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 179227 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179231 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179236 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179243 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 179248 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 179253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 179256 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179260 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179265 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179272 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 179277 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 179282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 179285 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 179288 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179293 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179299 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 179310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 179313 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 179316 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179320 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179325 */     GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 179328 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(61680),
     /* 179338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 179340 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 179343 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179347 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179352 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 179362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 179364 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 179367 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179371 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179376 */     GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 179379 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(52428),
     /* 179389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 179391 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 179394 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179398 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179403 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 179413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 179415 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 179418 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179422 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179427 */     GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 179430 */     GIR_AddImm, /*InsnID*/123, /*Imm*/GIMT_Encode8(43690),
     /* 179440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 179442 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 179445 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179449 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179454 */     GIR_Copy, /*NewInsnID*/122, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179458 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/1,
     /* 179461 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/0,
     /* 179464 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/30,
     /* 179467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 179469 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 179472 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179476 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179481 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 179484 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/122,
     /* 179487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 179489 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 179492 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179496 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179501 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 179511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 179513 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 179516 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179520 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179525 */     GIR_AddSimpleTempRegister, /*InsnID*/119, /*TempRegID*/119,
     /* 179528 */     GIR_AddImm, /*InsnID*/119, /*Imm*/GIMT_Encode8(21845),
     /* 179538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 179540 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 179543 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179547 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179552 */     GIR_Copy, /*NewInsnID*/118, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179556 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 179559 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/1,
     /* 179562 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 179565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 179567 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 179570 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179574 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179579 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 179582 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/118,
     /* 179585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 179587 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 179590 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179594 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179599 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 179602 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/120,
     /* 179605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 179607 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 179610 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179614 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179619 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 179622 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/2,
     /* 179625 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/0,
     /* 179628 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/29,
     /* 179631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 179633 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 179636 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179640 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179645 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 179648 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/124,
     /* 179651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 179653 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 179656 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179660 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179665 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 179675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 179677 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 179680 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179684 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179689 */     GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 179692 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(13107),
     /* 179702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 179704 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 179707 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179711 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179716 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 179726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 179728 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 179731 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179735 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179740 */     GIR_AddSimpleTempRegister, /*InsnID*/110, /*TempRegID*/110,
     /* 179743 */     GIR_AddImm, /*InsnID*/110, /*Imm*/GIMT_Encode8(43690),
     /* 179753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 179755 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 179758 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179762 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179767 */     GIR_Copy, /*NewInsnID*/109, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179771 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/1,
     /* 179774 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/0,
     /* 179777 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/30,
     /* 179780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 179782 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 179785 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179789 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179794 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 179797 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/109,
     /* 179800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 179802 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 179805 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179809 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179814 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 179824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 179826 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 179829 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179833 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179838 */     GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 179841 */     GIR_AddImm, /*InsnID*/106, /*Imm*/GIMT_Encode8(21845),
     /* 179851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 179853 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 179856 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179860 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179865 */     GIR_Copy, /*NewInsnID*/105, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179869 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 179872 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/1,
     /* 179875 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 179878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 179880 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 179883 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179887 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179892 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 179895 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/105,
     /* 179898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 179900 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 179903 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179907 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179912 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 179915 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/107,
     /* 179918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 179920 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 179923 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179927 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179932 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 179935 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/30,
     /* 179938 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/2,
     /* 179941 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/31,
     /* 179944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 179946 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 179949 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179953 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179958 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 179961 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/111,
     /* 179964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 179966 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 179969 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179973 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179978 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 179981 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/113,
     /* 179984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 179986 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 179989 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179993 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179998 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 180001 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/4,
     /* 180004 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/0,
     /* 180007 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/27,
     /* 180010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 180012 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 180015 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180019 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180024 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/98,
     /* 180027 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/126,
     /* 180030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 180032 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 180035 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180039 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180044 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 180054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 180056 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 180059 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180063 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180068 */     GIR_AddSimpleTempRegister, /*InsnID*/96, /*TempRegID*/96,
     /* 180071 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(3855),
     /* 180081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 180083 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 180086 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180090 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180095 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 180105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 180107 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 180110 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180114 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180119 */     GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 180122 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(52428),
     /* 180132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 180134 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 180137 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180141 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180146 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 180156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 180158 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 180161 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180165 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180170 */     GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 180173 */     GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 180183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 180185 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 180188 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180192 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180197 */     GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180201 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 180204 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/0,
     /* 180207 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/30,
     /* 180210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 180212 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 180215 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180219 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180224 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 180227 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 180230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 180232 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 180235 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180239 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180244 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 180254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 180256 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 180259 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180263 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180268 */     GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 180271 */     GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 180281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 180283 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 180286 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180290 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180295 */     GIR_Copy, /*NewInsnID*/87, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180299 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 180302 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/1,
     /* 180305 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 180308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 180310 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 180313 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180317 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180322 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 180325 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 180328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 180330 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 180333 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180337 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180342 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 180345 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/89,
     /* 180348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 180350 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 180353 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180357 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180362 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 180365 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/2,
     /* 180368 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/0,
     /* 180371 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/29,
     /* 180374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 180376 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 180379 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180383 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180388 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 180391 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/93,
     /* 180394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 180396 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 180399 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180403 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180408 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 180418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 180420 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 180423 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180427 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180432 */     GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 180435 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(13107),
     /* 180445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 180447 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 180450 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180454 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180459 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 180469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 180471 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 180474 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180478 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180483 */     GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 180486 */     GIR_AddImm, /*InsnID*/79, /*Imm*/GIMT_Encode8(43690),
     /* 180496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 180498 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 180501 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180505 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180510 */     GIR_Copy, /*NewInsnID*/78, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180514 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/1,
     /* 180517 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/0,
     /* 180520 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/30,
     /* 180523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 180525 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 180528 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180532 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180537 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 180540 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/78,
     /* 180543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 180545 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 180548 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180552 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180557 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 180567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 180569 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 180572 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180576 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180581 */     GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 180584 */     GIR_AddImm, /*InsnID*/75, /*Imm*/GIMT_Encode8(21845),
     /* 180594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 180596 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 180599 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180603 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180608 */     GIR_Copy, /*NewInsnID*/74, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180612 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 180615 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/1,
     /* 180618 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 180621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 180623 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 180626 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180630 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180635 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 180638 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/74,
     /* 180641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 180643 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 180646 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180650 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180655 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 180658 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/76,
     /* 180661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 180663 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 180666 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180670 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180675 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 180678 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/30,
     /* 180681 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/2,
     /* 180684 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/31,
     /* 180687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 180689 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 180692 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180696 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180701 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 180704 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/80,
     /* 180707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 180709 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 180712 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180716 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180721 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 180724 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/82,
     /* 180727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 180729 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 180732 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180736 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180741 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 180744 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/28,
     /* 180747 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/4,
     /* 180750 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/31,
     /* 180753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 180755 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 180758 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180762 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180767 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 180770 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/95,
     /* 180773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 180775 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 180778 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180782 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180787 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 180790 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/97,
     /* 180793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 180795 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 180798 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180802 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180807 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 180817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 180819 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 180822 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180826 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180831 */     GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 180834 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(61680),
     /* 180844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 180846 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 180849 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180853 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180858 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 180868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 180870 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 180873 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180877 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180882 */     GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 180885 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 180895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 180897 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 180900 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180904 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180909 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 180919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 180921 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 180924 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180928 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180933 */     GIR_AddSimpleTempRegister, /*InsnID*/60, /*TempRegID*/60,
     /* 180936 */     GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 180946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 180948 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 180951 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180955 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180960 */     GIR_Copy, /*NewInsnID*/59, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180964 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/1,
     /* 180967 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/0,
     /* 180970 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/30,
     /* 180973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 180975 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 180978 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180982 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180987 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/58,
     /* 180990 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/59,
     /* 180993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 180995 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 180998 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181002 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181007 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 181017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 181019 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 181022 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181026 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181031 */     GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 181034 */     GIR_AddImm, /*InsnID*/56, /*Imm*/GIMT_Encode8(21845),
     /* 181044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 181046 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 181049 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181053 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181058 */     GIR_Copy, /*NewInsnID*/55, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181062 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 181065 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/1,
     /* 181068 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 181071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 181073 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 181076 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181080 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181085 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 181088 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/55,
     /* 181091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 181093 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 181096 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181100 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181105 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 181108 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/57,
     /* 181111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 181113 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 181116 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181120 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181125 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 181128 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/2,
     /* 181131 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/0,
     /* 181134 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/29,
     /* 181137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 181139 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 181142 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181146 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181151 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/51,
     /* 181154 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/61,
     /* 181157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 181159 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 181162 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181166 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181171 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 181181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 181183 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 181186 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181190 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181195 */     GIR_AddSimpleTempRegister, /*InsnID*/49, /*TempRegID*/49,
     /* 181198 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(13107),
     /* 181208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 181210 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 181213 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181217 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181222 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 181232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 181234 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 181237 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181241 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181246 */     GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 181249 */     GIR_AddImm, /*InsnID*/47, /*Imm*/GIMT_Encode8(43690),
     /* 181259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 181261 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 181264 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181268 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181273 */     GIR_Copy, /*NewInsnID*/46, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181277 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/1,
     /* 181280 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/0,
     /* 181283 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/30,
     /* 181286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 181288 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 181291 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181295 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181300 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 181303 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/46,
     /* 181306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 181308 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 181311 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181315 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181320 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 181330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 181332 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 181335 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181339 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181344 */     GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 181347 */     GIR_AddImm, /*InsnID*/43, /*Imm*/GIMT_Encode8(21845),
     /* 181357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 181359 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 181362 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181366 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181371 */     GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181375 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 181378 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/1,
     /* 181381 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 181384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 181386 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 181389 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181393 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181398 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 181401 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/42,
     /* 181404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 181406 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 181409 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181413 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181418 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 181421 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/44,
     /* 181424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 181426 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 181429 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181433 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181438 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 181441 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/30,
     /* 181444 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/2,
     /* 181447 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/31,
     /* 181450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 181452 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 181455 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181459 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181464 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 181467 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/48,
     /* 181470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 181472 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 181475 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181479 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181484 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 181487 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/50,
     /* 181490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 181492 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 181495 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181499 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181504 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 181507 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/4,
     /* 181510 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/0,
     /* 181513 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/27,
     /* 181516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 181518 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 181521 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181525 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181530 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 181533 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/63,
     /* 181536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 181538 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 181541 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181545 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181550 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 181560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 181562 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 181565 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181569 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181574 */     GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 181577 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(3855),
     /* 181587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 181589 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 181592 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181596 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181601 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 181611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 181613 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 181616 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181620 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181625 */     GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 181628 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(52428),
     /* 181638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 181640 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 181643 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181647 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181652 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 181662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 181664 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 181667 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181671 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181676 */     GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 181679 */     GIR_AddImm, /*InsnID*/29, /*Imm*/GIMT_Encode8(43690),
     /* 181689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 181691 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 181694 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181698 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181703 */     GIR_Copy, /*NewInsnID*/28, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181707 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/1,
     /* 181710 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/0,
     /* 181713 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/30,
     /* 181716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 181718 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 181721 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181725 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181730 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 181733 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/28,
     /* 181736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 181738 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 181741 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181745 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181750 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 181760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 181762 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 181765 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181769 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181774 */     GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
     /* 181777 */     GIR_AddImm, /*InsnID*/25, /*Imm*/GIMT_Encode8(21845),
     /* 181787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 181789 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 181792 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181796 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181801 */     GIR_Copy, /*NewInsnID*/24, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181805 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 181808 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/1,
     /* 181811 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 181814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 181816 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 181819 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181823 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181828 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 181831 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/24,
     /* 181834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 181836 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 181839 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181843 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181848 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 181851 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/26,
     /* 181854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 181856 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 181859 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181863 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181868 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 181871 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/2,
     /* 181874 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/0,
     /* 181877 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/29,
     /* 181880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 181882 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 181885 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181889 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181894 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 181897 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/30,
     /* 181900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 181902 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 181905 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181909 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181914 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 181924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 181926 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 181929 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181933 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181938 */     GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 181941 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(13107),
     /* 181951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 181953 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 181956 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181960 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181965 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 181975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 181977 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 181980 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181984 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181989 */     GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
     /* 181992 */     GIR_AddImm, /*InsnID*/16, /*Imm*/GIMT_Encode8(43690),
     /* 182002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 182004 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 182007 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182011 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182016 */     GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182020 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/1,
     /* 182023 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/0,
     /* 182026 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/30,
     /* 182029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 182031 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 182034 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182038 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182043 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 182046 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 182049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 182051 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 182054 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182058 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182063 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 182073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 182075 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 182078 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182082 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182087 */     GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 182090 */     GIR_AddImm, /*InsnID*/12, /*Imm*/GIMT_Encode8(21845),
     /* 182100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 182102 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 182105 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182109 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182114 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182118 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 182121 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/1,
     /* 182124 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 182127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 182129 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 182132 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182136 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182141 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 182144 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/11,
     /* 182147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 182149 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 182152 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182156 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182161 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 182164 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 182167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 182169 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 182172 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182176 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182181 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 182184 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/30,
     /* 182187 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/2,
     /* 182190 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/31,
     /* 182193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 182195 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 182198 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182202 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182207 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 182210 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/17,
     /* 182213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 182215 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 182218 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182222 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182227 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 182230 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/19,
     /* 182233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 182235 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 182238 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182242 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182247 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 182250 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/28,
     /* 182253 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/4,
     /* 182256 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/31,
     /* 182259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 182261 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 182264 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182268 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182273 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 182276 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/32,
     /* 182279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 182281 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 182284 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182288 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182293 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 182296 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/34,
     /* 182299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 182301 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 182304 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182308 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182313 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 182316 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 182319 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 182322 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 182325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 182334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182339 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 182342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/65,
     /* 182345 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 182348 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 182351 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 182354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 182359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 182361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 182368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 182371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/24,
     /* 182374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 182377 */     GIR_RootConstrainSelectedInstOperands,
     /* 182378 */     // GIR_Coverage, 4882,
     /* 182378 */     GIR_EraseRootFromParent_Done,
     /* 182379 */   // Label 2762: @182379
     /* 182379 */   GIM_Reject,
     /* 182380 */ // Label 2760: @182380
     /* 182380 */ GIM_Reject,
     /* 182381 */ // Label 2758: @182381
     /* 182381 */ GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(208071), // Rule ID 4883 //
     /* 182386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 182389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182393 */   // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$A)  =>  (OR8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }))
     /* 182393 */   GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182397 */   GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182402 */   GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182409 */   GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 182423 */   GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182427 */   GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182432 */   GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182439 */   GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 182444 */   GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 182458 */   GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182462 */   GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182467 */   GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 182477 */   GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182481 */   GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182486 */   GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182493 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 182498 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 182503 */   GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 182507 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182513 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182519 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182525 */   GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182529 */   GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182534 */   GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182541 */   GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 182546 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/32,
     /* 182550 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/31,
     /* 182554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 182557 */   GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182561 */   GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182566 */   GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182573 */   GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 182578 */   GIR_AddImm, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 182592 */   GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182596 */   GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182601 */   GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182608 */   GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 182613 */   GIR_AddImm, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 182627 */   GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182631 */   GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182636 */   GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182643 */   GIR_AddImm, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 182654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 182657 */   GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182661 */   GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182666 */   GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182673 */   GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 182678 */   GIR_AddImm, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 182689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 182692 */   GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182696 */   GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182701 */   GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 182711 */   GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182715 */   GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182720 */   GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182727 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 182732 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 182737 */   GIR_AddImm8, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Imm*/1,
     /* 182741 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182747 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182753 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182759 */   GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182763 */   GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182768 */   GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182775 */   GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 182780 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/32,
     /* 182784 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/31,
     /* 182788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 182791 */   GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s64,
     /* 182794 */   GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182799 */   GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182805 */   GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 182810 */   GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 182821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 182824 */   GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s64,
     /* 182827 */   GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182831 */   GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182836 */   GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 182839 */   GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 182849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 182851 */   GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 182854 */   GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182858 */   GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182863 */   GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(43690),
     /* 182873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 182875 */   GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 182878 */   GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182882 */   GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182887 */   GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 182890 */   GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 182900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 182902 */   GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s64,
     /* 182905 */   GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182909 */   GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 182916 */   GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s64,
     /* 182919 */   GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182923 */   GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182928 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 182931 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/124,
     /* 182934 */   GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 182937 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182942 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182947 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182952 */   GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s64,
     /* 182955 */   GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182959 */   GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182964 */   GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 182967 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/32,
     /* 182970 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/31,
     /* 182973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 182975 */   GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s64,
     /* 182978 */   GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182982 */   GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182987 */   GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 182990 */   GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(43690),
     /* 183000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 183002 */   GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s64,
     /* 183005 */   GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183009 */   GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183014 */   GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 183017 */   GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(43690),
     /* 183027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 183029 */   GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s64,
     /* 183032 */   GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183036 */   GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183041 */   GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183045 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 183048 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/62,
     /* 183051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 183053 */   GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s64,
     /* 183056 */   GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183060 */   GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183065 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 183068 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 183071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 183073 */   GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 183076 */   GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183080 */   GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183085 */   GIR_AddImm, /*InsnID*/117, /*Imm*/GIMT_Encode8(21845),
     /* 183095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 183097 */   GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 183100 */   GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183104 */   GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183109 */   GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 183112 */   GIR_AddImm, /*InsnID*/116, /*Imm*/GIMT_Encode8(21845),
     /* 183122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 183124 */   GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s64,
     /* 183127 */   GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183131 */   GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 183138 */   GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s64,
     /* 183141 */   GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183145 */   GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183150 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 183153 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/115,
     /* 183156 */   GIR_AddImm8, /*InsnID*/114, /*Imm*/1,
     /* 183159 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183164 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183169 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183174 */   GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s64,
     /* 183177 */   GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183181 */   GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183186 */   GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 183189 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/32,
     /* 183192 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/31,
     /* 183195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 183197 */   GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s64,
     /* 183200 */   GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183204 */   GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183209 */   GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 183212 */   GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(21845),
     /* 183222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 183224 */   GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s64,
     /* 183227 */   GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183231 */   GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183236 */   GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 183239 */   GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(21845),
     /* 183249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 183251 */   GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s64,
     /* 183254 */   GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 183258 */   GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183263 */   GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183267 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/63,
     /* 183270 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 183273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 183275 */   GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s64,
     /* 183278 */   GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183282 */   GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183287 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 183290 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 183293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 183295 */   GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s64,
     /* 183298 */   GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 183302 */   GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183307 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 183310 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/117,
     /* 183313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 183315 */   GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s64,
     /* 183318 */   GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183322 */   GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183327 */   GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 183330 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/2,
     /* 183333 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/61,
     /* 183336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 183338 */   GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s64,
     /* 183341 */   GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183345 */   GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183350 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 183353 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/126,
     /* 183356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 183358 */   GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 183361 */   GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183365 */   GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183370 */   GIR_AddImm, /*InsnID*/105, /*Imm*/GIMT_Encode8(13107),
     /* 183380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 183382 */   GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 183385 */   GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183389 */   GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183394 */   GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 183397 */   GIR_AddImm, /*InsnID*/104, /*Imm*/GIMT_Encode8(13107),
     /* 183407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 183409 */   GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s64,
     /* 183412 */   GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183416 */   GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 183423 */   GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s64,
     /* 183426 */   GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183430 */   GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183435 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 183438 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/103,
     /* 183441 */   GIR_AddImm8, /*InsnID*/102, /*Imm*/1,
     /* 183444 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183449 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183454 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183459 */   GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s64,
     /* 183462 */   GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183466 */   GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183471 */   GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 183474 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/32,
     /* 183477 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/31,
     /* 183480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 183482 */   GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s64,
     /* 183485 */   GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183489 */   GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183494 */   GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 183497 */   GIR_AddImm, /*InsnID*/100, /*Imm*/GIMT_Encode8(13107),
     /* 183507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 183509 */   GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s64,
     /* 183512 */   GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183516 */   GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183521 */   GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 183524 */   GIR_AddImm, /*InsnID*/99, /*Imm*/GIMT_Encode8(13107),
     /* 183534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 183536 */   GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 183539 */   GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183543 */   GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183548 */   GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(43690),
     /* 183558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 183560 */   GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 183563 */   GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183567 */   GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183572 */   GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 183575 */   GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(43690),
     /* 183585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 183587 */   GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s64,
     /* 183590 */   GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183594 */   GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 183601 */   GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s64,
     /* 183604 */   GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183608 */   GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183613 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 183616 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/96,
     /* 183619 */   GIR_AddImm8, /*InsnID*/95, /*Imm*/1,
     /* 183622 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183627 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183632 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183637 */   GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s64,
     /* 183640 */   GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183644 */   GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183649 */   GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 183652 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/32,
     /* 183655 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/31,
     /* 183658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 183660 */   GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s64,
     /* 183663 */   GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183667 */   GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183672 */   GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 183675 */   GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 183685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 183687 */   GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s64,
     /* 183690 */   GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183694 */   GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183699 */   GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 183702 */   GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 183712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 183714 */   GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s64,
     /* 183717 */   GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183721 */   GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183726 */   GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183730 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 183733 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/62,
     /* 183736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 183738 */   GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s64,
     /* 183741 */   GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183745 */   GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183750 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 183753 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 183756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 183758 */   GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 183761 */   GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183765 */   GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183770 */   GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 183780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 183782 */   GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 183785 */   GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183789 */   GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183794 */   GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 183797 */   GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 183807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 183809 */   GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s64,
     /* 183812 */   GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183816 */   GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 183823 */   GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s64,
     /* 183826 */   GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183830 */   GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183835 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 183838 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 183841 */   GIR_AddImm8, /*InsnID*/86, /*Imm*/1,
     /* 183844 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183849 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183854 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183859 */   GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s64,
     /* 183862 */   GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183866 */   GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183871 */   GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 183874 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/32,
     /* 183877 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/31,
     /* 183880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 183882 */   GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s64,
     /* 183885 */   GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183889 */   GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183894 */   GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 183897 */   GIR_AddImm, /*InsnID*/84, /*Imm*/GIMT_Encode8(21845),
     /* 183907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 183909 */   GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s64,
     /* 183912 */   GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183916 */   GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183921 */   GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 183924 */   GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(21845),
     /* 183934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 183936 */   GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s64,
     /* 183939 */   GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 183943 */   GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183948 */   GIR_Copy, /*NewInsnID*/82, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183952 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/63,
     /* 183955 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/1,
     /* 183958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 183960 */   GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s64,
     /* 183963 */   GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183967 */   GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183972 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 183975 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/82,
     /* 183978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 183980 */   GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s64,
     /* 183983 */   GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 183987 */   GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183992 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 183995 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/89,
     /* 183998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 184000 */   GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s64,
     /* 184003 */   GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 184007 */   GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184012 */   GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 184015 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/62,
     /* 184018 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/2,
     /* 184021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 184023 */   GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s64,
     /* 184026 */   GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184030 */   GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184035 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 184038 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/98,
     /* 184041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 184043 */   GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s64,
     /* 184046 */   GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 184050 */   GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184055 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 184058 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/105,
     /* 184061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 184063 */   GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s64,
     /* 184066 */   GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184070 */   GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184075 */   GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 184078 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/4,
     /* 184081 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/59,
     /* 184084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 184086 */   GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s64,
     /* 184089 */   GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184093 */   GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184098 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 184101 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 184105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 184107 */   GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 184110 */   GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184114 */   GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184119 */   GIR_AddImm, /*InsnID*/74, /*Imm*/GIMT_Encode8(3855),
     /* 184129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 184131 */   GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 184134 */   GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184138 */   GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184143 */   GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 184146 */   GIR_AddImm, /*InsnID*/73, /*Imm*/GIMT_Encode8(3855),
     /* 184156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 184158 */   GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s64,
     /* 184161 */   GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184165 */   GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 184172 */   GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s64,
     /* 184175 */   GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184179 */   GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184184 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 184187 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/72,
     /* 184190 */   GIR_AddImm8, /*InsnID*/71, /*Imm*/1,
     /* 184193 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184198 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184203 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184208 */   GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s64,
     /* 184211 */   GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184215 */   GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184220 */   GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 184223 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/32,
     /* 184226 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/31,
     /* 184229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 184231 */   GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s64,
     /* 184234 */   GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184238 */   GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184243 */   GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 184246 */   GIR_AddImm, /*InsnID*/69, /*Imm*/GIMT_Encode8(3855),
     /* 184256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 184258 */   GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s64,
     /* 184261 */   GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184265 */   GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184270 */   GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 184273 */   GIR_AddImm, /*InsnID*/68, /*Imm*/GIMT_Encode8(3855),
     /* 184283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 184285 */   GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 184288 */   GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184292 */   GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184297 */   GIR_AddImm, /*InsnID*/67, /*Imm*/GIMT_Encode8(52428),
     /* 184307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 184309 */   GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 184312 */   GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184316 */   GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184321 */   GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 184324 */   GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(52428),
     /* 184334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 184336 */   GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s64,
     /* 184339 */   GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184343 */   GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 184350 */   GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s64,
     /* 184353 */   GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184357 */   GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184362 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 184365 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/65,
     /* 184368 */   GIR_AddImm8, /*InsnID*/64, /*Imm*/1,
     /* 184371 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184376 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184381 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184386 */   GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s64,
     /* 184389 */   GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184393 */   GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184398 */   GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 184401 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/32,
     /* 184404 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/31,
     /* 184407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 184409 */   GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s64,
     /* 184412 */   GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184416 */   GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184421 */   GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 184424 */   GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 184434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 184436 */   GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s64,
     /* 184439 */   GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184443 */   GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184448 */   GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 184451 */   GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(52428),
     /* 184461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 184463 */   GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 184466 */   GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184470 */   GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184475 */   GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 184485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 184487 */   GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 184490 */   GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184494 */   GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184499 */   GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 184502 */   GIR_AddImm, /*InsnID*/59, /*Imm*/GIMT_Encode8(43690),
     /* 184512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 184514 */   GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s64,
     /* 184517 */   GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184521 */   GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 184528 */   GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s64,
     /* 184531 */   GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184535 */   GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184540 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 184543 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/58,
     /* 184546 */   GIR_AddImm8, /*InsnID*/57, /*Imm*/1,
     /* 184549 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184554 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184559 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184564 */   GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s64,
     /* 184567 */   GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184571 */   GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184576 */   GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 184579 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/32,
     /* 184582 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 184585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 184587 */   GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s64,
     /* 184590 */   GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184594 */   GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184599 */   GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 184602 */   GIR_AddImm, /*InsnID*/55, /*Imm*/GIMT_Encode8(43690),
     /* 184612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 184614 */   GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s64,
     /* 184617 */   GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184621 */   GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184626 */   GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 184629 */   GIR_AddImm, /*InsnID*/54, /*Imm*/GIMT_Encode8(43690),
     /* 184639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 184641 */   GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s64,
     /* 184644 */   GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184648 */   GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184653 */   GIR_Copy, /*NewInsnID*/53, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184657 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/1,
     /* 184660 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/62,
     /* 184663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 184665 */   GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s64,
     /* 184668 */   GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184672 */   GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184677 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 184680 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/53,
     /* 184683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 184685 */   GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 184688 */   GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184692 */   GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184697 */   GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(21845),
     /* 184707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 184709 */   GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 184712 */   GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184716 */   GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184721 */   GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 184724 */   GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(21845),
     /* 184734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 184736 */   GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s64,
     /* 184739 */   GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184743 */   GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 184750 */   GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s64,
     /* 184753 */   GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184757 */   GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184762 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 184765 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
     /* 184768 */   GIR_AddImm8, /*InsnID*/48, /*Imm*/1,
     /* 184771 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184776 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184781 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184786 */   GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s64,
     /* 184789 */   GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184793 */   GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184798 */   GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 184801 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/32,
     /* 184804 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/31,
     /* 184807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 184809 */   GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s64,
     /* 184812 */   GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184816 */   GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184821 */   GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 184824 */   GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(21845),
     /* 184834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 184836 */   GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s64,
     /* 184839 */   GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184843 */   GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184848 */   GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 184851 */   GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 184861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 184863 */   GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s64,
     /* 184866 */   GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 184870 */   GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184875 */   GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184879 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/63,
     /* 184882 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/1,
     /* 184885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 184887 */   GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s64,
     /* 184890 */   GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184894 */   GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184899 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 184902 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
     /* 184905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 184907 */   GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s64,
     /* 184910 */   GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 184914 */   GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184919 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 184922 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/51,
     /* 184925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 184927 */   GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s64,
     /* 184930 */   GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184934 */   GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184939 */   GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 184942 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/2,
     /* 184945 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/61,
     /* 184948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 184950 */   GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s64,
     /* 184953 */   GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184957 */   GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184962 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 184965 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/60,
     /* 184968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 184970 */   GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 184973 */   GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184977 */   GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184982 */   GIR_AddImm, /*InsnID*/39, /*Imm*/GIMT_Encode8(13107),
     /* 184992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 184994 */   GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 184997 */   GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185001 */   GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185006 */   GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 185009 */   GIR_AddImm, /*InsnID*/38, /*Imm*/GIMT_Encode8(13107),
     /* 185019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 185021 */   GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s64,
     /* 185024 */   GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185028 */   GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 185035 */   GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s64,
     /* 185038 */   GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185042 */   GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185047 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 185050 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/37,
     /* 185053 */   GIR_AddImm8, /*InsnID*/36, /*Imm*/1,
     /* 185056 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185061 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185066 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185071 */   GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s64,
     /* 185074 */   GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185078 */   GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185083 */   GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 185086 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/32,
     /* 185089 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/31,
     /* 185092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 185094 */   GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s64,
     /* 185097 */   GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185101 */   GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185106 */   GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 185109 */   GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(13107),
     /* 185119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 185121 */   GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s64,
     /* 185124 */   GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185128 */   GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185133 */   GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 185136 */   GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(13107),
     /* 185146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 185148 */   GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 185151 */   GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185155 */   GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185160 */   GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(43690),
     /* 185170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 185172 */   GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 185175 */   GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185179 */   GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185184 */   GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 185187 */   GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 185197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 185199 */   GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s64,
     /* 185202 */   GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185206 */   GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 185213 */   GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s64,
     /* 185216 */   GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185220 */   GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185225 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 185228 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/30,
     /* 185231 */   GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 185234 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185239 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185244 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185249 */   GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s64,
     /* 185252 */   GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185256 */   GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185261 */   GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 185264 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/32,
     /* 185267 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/31,
     /* 185270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 185272 */   GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s64,
     /* 185275 */   GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185279 */   GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185284 */   GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 185287 */   GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(43690),
     /* 185297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 185299 */   GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s64,
     /* 185302 */   GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185306 */   GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185311 */   GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 185314 */   GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(43690),
     /* 185324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 185326 */   GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s64,
     /* 185329 */   GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185333 */   GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185338 */   GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185342 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 185345 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/62,
     /* 185348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 185350 */   GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s64,
     /* 185353 */   GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185357 */   GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185362 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 185365 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 185368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 185370 */   GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 185373 */   GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185377 */   GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185382 */   GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(21845),
     /* 185392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 185394 */   GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 185397 */   GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185401 */   GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185406 */   GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 185409 */   GIR_AddImm, /*InsnID*/22, /*Imm*/GIMT_Encode8(21845),
     /* 185419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 185421 */   GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s64,
     /* 185424 */   GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185428 */   GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 185435 */   GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s64,
     /* 185438 */   GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185442 */   GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185447 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 185450 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
     /* 185453 */   GIR_AddImm8, /*InsnID*/20, /*Imm*/1,
     /* 185456 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185461 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185466 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185471 */   GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s64,
     /* 185474 */   GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185478 */   GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185483 */   GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 185486 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/32,
     /* 185489 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/31,
     /* 185492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 185494 */   GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s64,
     /* 185497 */   GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185501 */   GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185506 */   GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 185509 */   GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(21845),
     /* 185519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 185521 */   GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s64,
     /* 185524 */   GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185528 */   GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185533 */   GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 185536 */   GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(21845),
     /* 185546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 185548 */   GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s64,
     /* 185551 */   GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185555 */   GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185560 */   GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185564 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/63,
     /* 185567 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 185570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 185572 */   GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s64,
     /* 185575 */   GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185579 */   GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185584 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 185587 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 185590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 185592 */   GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s64,
     /* 185595 */   GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185599 */   GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185604 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 185607 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/23,
     /* 185610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 185612 */   GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s64,
     /* 185615 */   GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185619 */   GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185624 */   GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 185627 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/62,
     /* 185630 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/2,
     /* 185633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 185635 */   GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s64,
     /* 185638 */   GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185642 */   GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185647 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 185650 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/32,
     /* 185653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 185655 */   GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s64,
     /* 185658 */   GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185662 */   GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185667 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 185670 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/39,
     /* 185673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 185675 */   GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s64,
     /* 185678 */   GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185682 */   GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185687 */   GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 185690 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/60,
     /* 185693 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/4,
     /* 185696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 185698 */   GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s64,
     /* 185701 */   GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185705 */   GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185710 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 185713 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/67,
     /* 185716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 185718 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s64,
     /* 185721 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185725 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185730 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 185733 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/74,
     /* 185736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 185738 */   GIR_MakeTempReg, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 185742 */   GIR_BuildMI, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185747 */   GIR_AddTempRegister, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185754 */   GIR_AddImm, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 185765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 274(*/0x92, 0x02/*)*/,
     /* 185768 */   GIR_MakeTempReg, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 185772 */   GIR_BuildMI, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185777 */   GIR_AddTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185784 */   GIR_AddSimpleTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/,
     /* 185789 */   GIR_AddImm, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 185800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 273(*/0x91, 0x02/*)*/,
     /* 185803 */   GIR_MakeTempReg, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185807 */   GIR_BuildMI, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185812 */   GIR_AddTempRegister, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 272(*/0x90, 0x02/*)*/,
     /* 185822 */   GIR_MakeTempReg, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185826 */   GIR_BuildMI, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185831 */   GIR_AddTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185838 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/,
     /* 185843 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/,
     /* 185848 */   GIR_AddImm8, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Imm*/1,
     /* 185852 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185858 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185864 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185870 */   GIR_MakeTempReg, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185874 */   GIR_BuildMI, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185879 */   GIR_AddTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185886 */   GIR_AddSimpleTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/,
     /* 185891 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/32,
     /* 185895 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/31,
     /* 185899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 270(*/0x8E, 0x02/*)*/,
     /* 185902 */   GIR_MakeTempReg, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185906 */   GIR_BuildMI, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185911 */   GIR_AddTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185918 */   GIR_AddSimpleTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/,
     /* 185923 */   GIR_AddImm, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 185934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 269(*/0x8D, 0x02/*)*/,
     /* 185937 */   GIR_MakeTempReg, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185941 */   GIR_BuildMI, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185946 */   GIR_AddTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185953 */   GIR_AddSimpleTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/,
     /* 185958 */   GIR_AddImm, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 185969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 268(*/0x8C, 0x02/*)*/,
     /* 185972 */   GIR_MakeTempReg, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 185976 */   GIR_BuildMI, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185981 */   GIR_AddTempRegister, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185988 */   GIR_AddImm, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 185999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 267(*/0x8B, 0x02/*)*/,
     /* 186002 */   GIR_MakeTempReg, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186006 */   GIR_BuildMI, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186011 */   GIR_AddTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186018 */   GIR_AddSimpleTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/,
     /* 186023 */   GIR_AddImm, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 266(*/0x8A, 0x02/*)*/,
     /* 186037 */   GIR_MakeTempReg, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186041 */   GIR_BuildMI, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186046 */   GIR_AddTempRegister, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 265(*/0x89, 0x02/*)*/,
     /* 186056 */   GIR_MakeTempReg, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186060 */   GIR_BuildMI, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186065 */   GIR_AddTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186072 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/,
     /* 186077 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/,
     /* 186082 */   GIR_AddImm8, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Imm*/1,
     /* 186086 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186092 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186098 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186104 */   GIR_MakeTempReg, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186108 */   GIR_BuildMI, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186113 */   GIR_AddTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186120 */   GIR_AddSimpleTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/,
     /* 186125 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/32,
     /* 186129 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/31,
     /* 186133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 263(*/0x87, 0x02/*)*/,
     /* 186136 */   GIR_MakeTempReg, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186140 */   GIR_BuildMI, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186145 */   GIR_AddTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186152 */   GIR_AddSimpleTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/,
     /* 186157 */   GIR_AddImm, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 262(*/0x86, 0x02/*)*/,
     /* 186171 */   GIR_MakeTempReg, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186175 */   GIR_BuildMI, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186180 */   GIR_AddTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186187 */   GIR_AddSimpleTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/,
     /* 186192 */   GIR_AddImm, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 261(*/0x85, 0x02/*)*/,
     /* 186206 */   GIR_MakeTempReg, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186210 */   GIR_BuildMI, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186215 */   GIR_AddTempRegister, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186222 */   GIR_AddImm, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 260(*/0x84, 0x02/*)*/,
     /* 186236 */   GIR_MakeTempReg, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186240 */   GIR_BuildMI, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186245 */   GIR_AddTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186252 */   GIR_AddSimpleTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/,
     /* 186257 */   GIR_AddImm, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 259(*/0x83, 0x02/*)*/,
     /* 186271 */   GIR_MakeTempReg, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186275 */   GIR_BuildMI, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186280 */   GIR_AddTempRegister, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 258(*/0x82, 0x02/*)*/,
     /* 186290 */   GIR_MakeTempReg, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186294 */   GIR_BuildMI, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186299 */   GIR_AddTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186306 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/,
     /* 186311 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/,
     /* 186316 */   GIR_AddImm8, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Imm*/1,
     /* 186320 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186326 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186332 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186338 */   GIR_MakeTempReg, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186342 */   GIR_BuildMI, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186347 */   GIR_AddTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186354 */   GIR_AddSimpleTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/,
     /* 186359 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/32,
     /* 186363 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/31,
     /* 186367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 256(*/0x80, 0x02/*)*/,
     /* 186370 */   GIR_MakeTempReg, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186374 */   GIR_BuildMI, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186379 */   GIR_AddTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186386 */   GIR_AddSimpleTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/,
     /* 186391 */   GIR_AddImm, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 255(*/0xFF, 0x01/*)*/,
     /* 186405 */   GIR_MakeTempReg, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186409 */   GIR_BuildMI, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186414 */   GIR_AddTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186421 */   GIR_AddSimpleTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/,
     /* 186426 */   GIR_AddImm, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 254(*/0xFE, 0x01/*)*/,
     /* 186440 */   GIR_MakeTempReg, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186444 */   GIR_BuildMI, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186449 */   GIR_AddTempRegister, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186456 */   GIR_Copy, /*NewInsnID*//* 253(*/0xFD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 186461 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/1,
     /* 186465 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/62,
     /* 186469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 253(*/0xFD, 0x01/*)*/,
     /* 186472 */   GIR_MakeTempReg, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186476 */   GIR_BuildMI, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186481 */   GIR_AddTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186488 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/,
     /* 186493 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/,
     /* 186498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 252(*/0xFC, 0x01/*)*/,
     /* 186501 */   GIR_MakeTempReg, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186505 */   GIR_BuildMI, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186510 */   GIR_AddTempRegister, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186517 */   GIR_AddImm, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 251(*/0xFB, 0x01/*)*/,
     /* 186531 */   GIR_MakeTempReg, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186535 */   GIR_BuildMI, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186540 */   GIR_AddTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186547 */   GIR_AddSimpleTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/,
     /* 186552 */   GIR_AddImm, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 250(*/0xFA, 0x01/*)*/,
     /* 186566 */   GIR_MakeTempReg, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186570 */   GIR_BuildMI, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186575 */   GIR_AddTempRegister, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 249(*/0xF9, 0x01/*)*/,
     /* 186585 */   GIR_MakeTempReg, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186589 */   GIR_BuildMI, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186594 */   GIR_AddTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186601 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/,
     /* 186606 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/,
     /* 186611 */   GIR_AddImm8, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Imm*/1,
     /* 186615 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186621 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186627 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186633 */   GIR_MakeTempReg, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186637 */   GIR_BuildMI, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186642 */   GIR_AddTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186649 */   GIR_AddSimpleTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/,
     /* 186654 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/32,
     /* 186658 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/31,
     /* 186662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 247(*/0xF7, 0x01/*)*/,
     /* 186665 */   GIR_MakeTempReg, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186669 */   GIR_BuildMI, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186674 */   GIR_AddTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186681 */   GIR_AddSimpleTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/,
     /* 186686 */   GIR_AddImm, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 246(*/0xF6, 0x01/*)*/,
     /* 186700 */   GIR_MakeTempReg, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186704 */   GIR_BuildMI, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186709 */   GIR_AddTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186716 */   GIR_AddSimpleTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/,
     /* 186721 */   GIR_AddImm, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 245(*/0xF5, 0x01/*)*/,
     /* 186735 */   GIR_MakeTempReg, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186739 */   GIR_BuildMI, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 186744 */   GIR_AddTempRegister, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186751 */   GIR_Copy, /*NewInsnID*//* 244(*/0xF4, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 186756 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/63,
     /* 186760 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/1,
     /* 186764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 244(*/0xF4, 0x01/*)*/,
     /* 186767 */   GIR_MakeTempReg, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186771 */   GIR_BuildMI, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186776 */   GIR_AddTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186783 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/,
     /* 186788 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/,
     /* 186793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 243(*/0xF3, 0x01/*)*/,
     /* 186796 */   GIR_MakeTempReg, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186800 */   GIR_BuildMI, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 186805 */   GIR_AddTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186812 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/,
     /* 186817 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/,
     /* 186822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 242(*/0xF2, 0x01/*)*/,
     /* 186825 */   GIR_MakeTempReg, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186829 */   GIR_BuildMI, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186834 */   GIR_AddTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186841 */   GIR_AddSimpleTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/,
     /* 186846 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/2,
     /* 186850 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/61,
     /* 186854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 241(*/0xF1, 0x01/*)*/,
     /* 186857 */   GIR_MakeTempReg, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186861 */   GIR_BuildMI, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186866 */   GIR_AddTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186873 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/,
     /* 186878 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/,
     /* 186883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 240(*/0xF0, 0x01/*)*/,
     /* 186886 */   GIR_MakeTempReg, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186890 */   GIR_BuildMI, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186895 */   GIR_AddTempRegister, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186902 */   GIR_AddImm, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 186913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 239(*/0xEF, 0x01/*)*/,
     /* 186916 */   GIR_MakeTempReg, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186920 */   GIR_BuildMI, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186925 */   GIR_AddTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186932 */   GIR_AddSimpleTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/,
     /* 186937 */   GIR_AddImm, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 186948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 238(*/0xEE, 0x01/*)*/,
     /* 186951 */   GIR_MakeTempReg, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186955 */   GIR_BuildMI, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186960 */   GIR_AddTempRegister, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 237(*/0xED, 0x01/*)*/,
     /* 186970 */   GIR_MakeTempReg, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186974 */   GIR_BuildMI, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186979 */   GIR_AddTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186986 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/,
     /* 186991 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/,
     /* 186996 */   GIR_AddImm8, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Imm*/1,
     /* 187000 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187006 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187012 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187018 */   GIR_MakeTempReg, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187022 */   GIR_BuildMI, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187027 */   GIR_AddTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187034 */   GIR_AddSimpleTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/,
     /* 187039 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/32,
     /* 187043 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/31,
     /* 187047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 235(*/0xEB, 0x01/*)*/,
     /* 187050 */   GIR_MakeTempReg, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187054 */   GIR_BuildMI, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187059 */   GIR_AddTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187066 */   GIR_AddSimpleTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/,
     /* 187071 */   GIR_AddImm, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 234(*/0xEA, 0x01/*)*/,
     /* 187085 */   GIR_MakeTempReg, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187089 */   GIR_BuildMI, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187094 */   GIR_AddTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187101 */   GIR_AddSimpleTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/,
     /* 187106 */   GIR_AddImm, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 233(*/0xE9, 0x01/*)*/,
     /* 187120 */   GIR_MakeTempReg, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187124 */   GIR_BuildMI, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187129 */   GIR_AddTempRegister, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187136 */   GIR_AddImm, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 232(*/0xE8, 0x01/*)*/,
     /* 187150 */   GIR_MakeTempReg, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187154 */   GIR_BuildMI, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187159 */   GIR_AddTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187166 */   GIR_AddSimpleTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/,
     /* 187171 */   GIR_AddImm, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 231(*/0xE7, 0x01/*)*/,
     /* 187185 */   GIR_MakeTempReg, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187189 */   GIR_BuildMI, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187194 */   GIR_AddTempRegister, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 230(*/0xE6, 0x01/*)*/,
     /* 187204 */   GIR_MakeTempReg, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187208 */   GIR_BuildMI, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187213 */   GIR_AddTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187220 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/,
     /* 187225 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/,
     /* 187230 */   GIR_AddImm8, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Imm*/1,
     /* 187234 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187240 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187246 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187252 */   GIR_MakeTempReg, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187256 */   GIR_BuildMI, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187261 */   GIR_AddTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187268 */   GIR_AddSimpleTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/,
     /* 187273 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/32,
     /* 187277 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/31,
     /* 187281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 228(*/0xE4, 0x01/*)*/,
     /* 187284 */   GIR_MakeTempReg, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187288 */   GIR_BuildMI, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187293 */   GIR_AddTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187300 */   GIR_AddSimpleTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/,
     /* 187305 */   GIR_AddImm, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 227(*/0xE3, 0x01/*)*/,
     /* 187319 */   GIR_MakeTempReg, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187323 */   GIR_BuildMI, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187328 */   GIR_AddTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187335 */   GIR_AddSimpleTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/,
     /* 187340 */   GIR_AddImm, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 226(*/0xE2, 0x01/*)*/,
     /* 187354 */   GIR_MakeTempReg, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187358 */   GIR_BuildMI, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187363 */   GIR_AddTempRegister, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187370 */   GIR_Copy, /*NewInsnID*//* 225(*/0xE1, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187375 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/1,
     /* 187379 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/62,
     /* 187383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 225(*/0xE1, 0x01/*)*/,
     /* 187386 */   GIR_MakeTempReg, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187390 */   GIR_BuildMI, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187395 */   GIR_AddTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187402 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/,
     /* 187407 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/,
     /* 187412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 224(*/0xE0, 0x01/*)*/,
     /* 187415 */   GIR_MakeTempReg, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187419 */   GIR_BuildMI, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187424 */   GIR_AddTempRegister, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187431 */   GIR_AddImm, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 223(*/0xDF, 0x01/*)*/,
     /* 187445 */   GIR_MakeTempReg, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187449 */   GIR_BuildMI, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187454 */   GIR_AddTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187461 */   GIR_AddSimpleTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/,
     /* 187466 */   GIR_AddImm, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 222(*/0xDE, 0x01/*)*/,
     /* 187480 */   GIR_MakeTempReg, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187484 */   GIR_BuildMI, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187489 */   GIR_AddTempRegister, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 221(*/0xDD, 0x01/*)*/,
     /* 187499 */   GIR_MakeTempReg, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187503 */   GIR_BuildMI, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187508 */   GIR_AddTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187515 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/,
     /* 187520 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/,
     /* 187525 */   GIR_AddImm8, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Imm*/1,
     /* 187529 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187535 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187541 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187547 */   GIR_MakeTempReg, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187551 */   GIR_BuildMI, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187556 */   GIR_AddTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187563 */   GIR_AddSimpleTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/,
     /* 187568 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/32,
     /* 187572 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/31,
     /* 187576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 219(*/0xDB, 0x01/*)*/,
     /* 187579 */   GIR_MakeTempReg, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187583 */   GIR_BuildMI, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187588 */   GIR_AddTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187595 */   GIR_AddSimpleTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/,
     /* 187600 */   GIR_AddImm, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 218(*/0xDA, 0x01/*)*/,
     /* 187614 */   GIR_MakeTempReg, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187618 */   GIR_BuildMI, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187623 */   GIR_AddTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187630 */   GIR_AddSimpleTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/,
     /* 187635 */   GIR_AddImm, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 217(*/0xD9, 0x01/*)*/,
     /* 187649 */   GIR_MakeTempReg, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187653 */   GIR_BuildMI, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187658 */   GIR_AddTempRegister, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187665 */   GIR_Copy, /*NewInsnID*//* 216(*/0xD8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187670 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/63,
     /* 187674 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/1,
     /* 187678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 216(*/0xD8, 0x01/*)*/,
     /* 187681 */   GIR_MakeTempReg, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187685 */   GIR_BuildMI, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187690 */   GIR_AddTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187697 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/,
     /* 187702 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/,
     /* 187707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 215(*/0xD7, 0x01/*)*/,
     /* 187710 */   GIR_MakeTempReg, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187714 */   GIR_BuildMI, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 187719 */   GIR_AddTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187726 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/,
     /* 187731 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/,
     /* 187736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 214(*/0xD6, 0x01/*)*/,
     /* 187739 */   GIR_MakeTempReg, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187743 */   GIR_BuildMI, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187748 */   GIR_AddTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187755 */   GIR_AddSimpleTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/,
     /* 187760 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/62,
     /* 187764 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/2,
     /* 187768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 213(*/0xD5, 0x01/*)*/,
     /* 187771 */   GIR_MakeTempReg, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187775 */   GIR_BuildMI, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187780 */   GIR_AddTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187787 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/,
     /* 187792 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/,
     /* 187797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 212(*/0xD4, 0x01/*)*/,
     /* 187800 */   GIR_MakeTempReg, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187804 */   GIR_BuildMI, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 187809 */   GIR_AddTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187816 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/,
     /* 187821 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/,
     /* 187826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 211(*/0xD3, 0x01/*)*/,
     /* 187829 */   GIR_MakeTempReg, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187833 */   GIR_BuildMI, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187838 */   GIR_AddTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187845 */   GIR_AddSimpleTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/,
     /* 187850 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/4,
     /* 187854 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/59,
     /* 187858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 210(*/0xD2, 0x01/*)*/,
     /* 187861 */   GIR_MakeTempReg, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187865 */   GIR_BuildMI, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187870 */   GIR_AddTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187877 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/,
     /* 187882 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/,
     /* 187887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 209(*/0xD1, 0x01/*)*/,
     /* 187890 */   GIR_MakeTempReg, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187894 */   GIR_BuildMI, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187899 */   GIR_AddTempRegister, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187906 */   GIR_AddImm, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 187917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 208(*/0xD0, 0x01/*)*/,
     /* 187920 */   GIR_MakeTempReg, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187924 */   GIR_BuildMI, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187929 */   GIR_AddTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187936 */   GIR_AddSimpleTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/,
     /* 187941 */   GIR_AddImm, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 187952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 207(*/0xCF, 0x01/*)*/,
     /* 187955 */   GIR_MakeTempReg, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187959 */   GIR_BuildMI, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187964 */   GIR_AddTempRegister, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 206(*/0xCE, 0x01/*)*/,
     /* 187974 */   GIR_MakeTempReg, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187978 */   GIR_BuildMI, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187983 */   GIR_AddTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187990 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/,
     /* 187995 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/,
     /* 188000 */   GIR_AddImm8, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Imm*/1,
     /* 188004 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188010 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188016 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188022 */   GIR_MakeTempReg, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188026 */   GIR_BuildMI, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188031 */   GIR_AddTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188038 */   GIR_AddSimpleTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/,
     /* 188043 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/32,
     /* 188047 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/31,
     /* 188051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 204(*/0xCC, 0x01/*)*/,
     /* 188054 */   GIR_MakeTempReg, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188058 */   GIR_BuildMI, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188063 */   GIR_AddTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188070 */   GIR_AddSimpleTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/,
     /* 188075 */   GIR_AddImm, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 203(*/0xCB, 0x01/*)*/,
     /* 188089 */   GIR_MakeTempReg, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188093 */   GIR_BuildMI, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188098 */   GIR_AddTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188105 */   GIR_AddSimpleTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/,
     /* 188110 */   GIR_AddImm, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 202(*/0xCA, 0x01/*)*/,
     /* 188124 */   GIR_MakeTempReg, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188128 */   GIR_BuildMI, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188133 */   GIR_AddTempRegister, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188140 */   GIR_AddImm, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 201(*/0xC9, 0x01/*)*/,
     /* 188154 */   GIR_MakeTempReg, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188158 */   GIR_BuildMI, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188163 */   GIR_AddTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188170 */   GIR_AddSimpleTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/,
     /* 188175 */   GIR_AddImm, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 200(*/0xC8, 0x01/*)*/,
     /* 188189 */   GIR_MakeTempReg, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188193 */   GIR_BuildMI, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188198 */   GIR_AddTempRegister, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 199(*/0xC7, 0x01/*)*/,
     /* 188208 */   GIR_MakeTempReg, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188212 */   GIR_BuildMI, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188217 */   GIR_AddTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188224 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/,
     /* 188229 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/,
     /* 188234 */   GIR_AddImm8, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Imm*/1,
     /* 188238 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188244 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188250 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188256 */   GIR_MakeTempReg, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188260 */   GIR_BuildMI, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188265 */   GIR_AddTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188272 */   GIR_AddSimpleTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/,
     /* 188277 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/32,
     /* 188281 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/31,
     /* 188285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 197(*/0xC5, 0x01/*)*/,
     /* 188288 */   GIR_MakeTempReg, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188292 */   GIR_BuildMI, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188297 */   GIR_AddTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188304 */   GIR_AddSimpleTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/,
     /* 188309 */   GIR_AddImm, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 196(*/0xC4, 0x01/*)*/,
     /* 188323 */   GIR_MakeTempReg, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188327 */   GIR_BuildMI, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188332 */   GIR_AddTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188339 */   GIR_AddSimpleTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/,
     /* 188344 */   GIR_AddImm, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 195(*/0xC3, 0x01/*)*/,
     /* 188358 */   GIR_MakeTempReg, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188362 */   GIR_BuildMI, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188367 */   GIR_AddTempRegister, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188374 */   GIR_AddImm, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 194(*/0xC2, 0x01/*)*/,
     /* 188388 */   GIR_MakeTempReg, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188392 */   GIR_BuildMI, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188397 */   GIR_AddTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188404 */   GIR_AddSimpleTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/,
     /* 188409 */   GIR_AddImm, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 193(*/0xC1, 0x01/*)*/,
     /* 188423 */   GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188427 */   GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188432 */   GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 188442 */   GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188446 */   GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188451 */   GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188458 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 188463 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/,
     /* 188468 */   GIR_AddImm8, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/1,
     /* 188472 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188478 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188484 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188490 */   GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188494 */   GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188499 */   GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188506 */   GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 188511 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/32,
     /* 188515 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/31,
     /* 188519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 188522 */   GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188526 */   GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188531 */   GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188538 */   GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 188543 */   GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 188557 */   GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188561 */   GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188566 */   GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188573 */   GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 188578 */   GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 188592 */   GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188596 */   GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188601 */   GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188608 */   GIR_Copy, /*NewInsnID*//* 187(*/0xBB, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 188613 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/1,
     /* 188617 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/62,
     /* 188621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 188624 */   GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188628 */   GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188633 */   GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188640 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 188645 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 188650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 188653 */   GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188657 */   GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188662 */   GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188669 */   GIR_AddImm, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 188683 */   GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188687 */   GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188692 */   GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188699 */   GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 188704 */   GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 188718 */   GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188722 */   GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188727 */   GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 188737 */   GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188741 */   GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188746 */   GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188753 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 188758 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 188763 */   GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 188767 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188773 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188779 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188785 */   GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188789 */   GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188794 */   GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188801 */   GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 188806 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/32,
     /* 188810 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 188814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 188817 */   GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188821 */   GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188826 */   GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188833 */   GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 188838 */   GIR_AddImm, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 188852 */   GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188856 */   GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188861 */   GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188868 */   GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 188873 */   GIR_AddImm, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 188887 */   GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188891 */   GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 188896 */   GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188903 */   GIR_Copy, /*NewInsnID*//* 178(*/0xB2, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 188908 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/63,
     /* 188912 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/1,
     /* 188916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 188919 */   GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188923 */   GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188928 */   GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188935 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 188940 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 188945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 188948 */   GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188952 */   GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 188957 */   GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188964 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 188969 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 188974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 188977 */   GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188981 */   GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188986 */   GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188993 */   GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 188998 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/2,
     /* 189002 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/61,
     /* 189006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 189009 */   GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189013 */   GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189018 */   GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189025 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 189030 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/,
     /* 189035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 189038 */   GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189042 */   GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189047 */   GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189054 */   GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 189068 */   GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189072 */   GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189077 */   GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189084 */   GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 189089 */   GIR_AddImm, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 189103 */   GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189107 */   GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189112 */   GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 189122 */   GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189126 */   GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189131 */   GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189138 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 189143 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 189148 */   GIR_AddImm8, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/1,
     /* 189152 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189158 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189164 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189170 */   GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189174 */   GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189179 */   GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189186 */   GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 189191 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/32,
     /* 189195 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 189199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 189202 */   GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189206 */   GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189211 */   GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189218 */   GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 189223 */   GIR_AddImm, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 189237 */   GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189241 */   GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189246 */   GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189253 */   GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 189258 */   GIR_AddImm, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 189272 */   GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189276 */   GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189281 */   GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189288 */   GIR_AddImm, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 189302 */   GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189306 */   GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189311 */   GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189318 */   GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 189323 */   GIR_AddImm, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 189337 */   GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189341 */   GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189346 */   GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 189356 */   GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189360 */   GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189365 */   GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189372 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 189377 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 189382 */   GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/1,
     /* 189386 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189392 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189398 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189404 */   GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189408 */   GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189413 */   GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189420 */   GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 189425 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/32,
     /* 189429 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/31,
     /* 189433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 189436 */   GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189440 */   GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189445 */   GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189452 */   GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 189457 */   GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 189471 */   GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189475 */   GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189480 */   GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189487 */   GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 189492 */   GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 189506 */   GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189510 */   GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189515 */   GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189522 */   GIR_Copy, /*NewInsnID*//* 159(*/0x9F, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189527 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/1,
     /* 189531 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/62,
     /* 189535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 189538 */   GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189542 */   GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189547 */   GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189554 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 189559 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 189564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 189567 */   GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189571 */   GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189576 */   GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189583 */   GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 189597 */   GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189601 */   GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189606 */   GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189613 */   GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 189618 */   GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 189632 */   GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189636 */   GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189641 */   GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 189651 */   GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189655 */   GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189660 */   GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189667 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 189672 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 189677 */   GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 189681 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189687 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189693 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189699 */   GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189703 */   GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189708 */   GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189715 */   GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 189720 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/32,
     /* 189724 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/31,
     /* 189728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 189731 */   GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189735 */   GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189740 */   GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189747 */   GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 189752 */   GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 189766 */   GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189770 */   GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189775 */   GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189782 */   GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 189787 */   GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 189801 */   GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189805 */   GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189810 */   GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189817 */   GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189822 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/63,
     /* 189826 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 189830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 189833 */   GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189837 */   GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189842 */   GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189849 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 189854 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 189859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 189862 */   GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189866 */   GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 189871 */   GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189878 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 189883 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 189888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 189891 */   GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189895 */   GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189900 */   GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189907 */   GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 189912 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/62,
     /* 189916 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 189920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 189923 */   GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189927 */   GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189932 */   GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189939 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 189944 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 189949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 189952 */   GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189956 */   GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 189961 */   GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189968 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 189973 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 189978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 189981 */   GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189985 */   GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189990 */   GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189997 */   GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 190002 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/60,
     /* 190006 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/4,
     /* 190010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 190013 */   GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190017 */   GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190022 */   GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190029 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 190034 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/,
     /* 190039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 190042 */   GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190046 */   GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 190051 */   GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190058 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 190063 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/,
     /* 190068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 190071 */   GIR_MakeTempReg, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190075 */   GIR_BuildMI, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190080 */   GIR_AddTempRegister, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190087 */   GIR_AddImm, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 408(*/0x98, 0x03/*)*/,
     /* 190101 */   GIR_MakeTempReg, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190105 */   GIR_BuildMI, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190110 */   GIR_AddTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190117 */   GIR_AddSimpleTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/,
     /* 190122 */   GIR_AddImm, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 407(*/0x97, 0x03/*)*/,
     /* 190136 */   GIR_MakeTempReg, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190140 */   GIR_BuildMI, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190145 */   GIR_AddTempRegister, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 406(*/0x96, 0x03/*)*/,
     /* 190155 */   GIR_MakeTempReg, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190159 */   GIR_BuildMI, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190164 */   GIR_AddTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190171 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/,
     /* 190176 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/,
     /* 190181 */   GIR_AddImm8, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Imm*/1,
     /* 190185 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190191 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190197 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190203 */   GIR_MakeTempReg, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190207 */   GIR_BuildMI, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190212 */   GIR_AddTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190219 */   GIR_AddSimpleTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/,
     /* 190224 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/32,
     /* 190228 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/31,
     /* 190232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 404(*/0x94, 0x03/*)*/,
     /* 190235 */   GIR_MakeTempReg, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190239 */   GIR_BuildMI, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190244 */   GIR_AddTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190251 */   GIR_AddSimpleTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/,
     /* 190256 */   GIR_AddImm, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 403(*/0x93, 0x03/*)*/,
     /* 190270 */   GIR_MakeTempReg, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190274 */   GIR_BuildMI, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190279 */   GIR_AddTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190286 */   GIR_AddSimpleTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/,
     /* 190291 */   GIR_AddImm, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 402(*/0x92, 0x03/*)*/,
     /* 190305 */   GIR_MakeTempReg, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190309 */   GIR_BuildMI, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190314 */   GIR_AddTempRegister, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190321 */   GIR_AddImm, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 401(*/0x91, 0x03/*)*/,
     /* 190335 */   GIR_MakeTempReg, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190339 */   GIR_BuildMI, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190344 */   GIR_AddTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190351 */   GIR_AddSimpleTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/,
     /* 190356 */   GIR_AddImm, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 400(*/0x90, 0x03/*)*/,
     /* 190370 */   GIR_MakeTempReg, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190374 */   GIR_BuildMI, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190379 */   GIR_AddTempRegister, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 399(*/0x8F, 0x03/*)*/,
     /* 190389 */   GIR_MakeTempReg, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190393 */   GIR_BuildMI, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190398 */   GIR_AddTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190405 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/,
     /* 190410 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/,
     /* 190415 */   GIR_AddImm8, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Imm*/1,
     /* 190419 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190425 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190431 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190437 */   GIR_MakeTempReg, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190441 */   GIR_BuildMI, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190446 */   GIR_AddTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190453 */   GIR_AddSimpleTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/,
     /* 190458 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/32,
     /* 190462 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/31,
     /* 190466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 397(*/0x8D, 0x03/*)*/,
     /* 190469 */   GIR_MakeTempReg, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190473 */   GIR_BuildMI, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190478 */   GIR_AddTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190485 */   GIR_AddSimpleTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/,
     /* 190490 */   GIR_AddImm, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 396(*/0x8C, 0x03/*)*/,
     /* 190504 */   GIR_MakeTempReg, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190508 */   GIR_BuildMI, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190513 */   GIR_AddTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190520 */   GIR_AddSimpleTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/,
     /* 190525 */   GIR_AddImm, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 395(*/0x8B, 0x03/*)*/,
     /* 190539 */   GIR_MakeTempReg, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190543 */   GIR_BuildMI, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190548 */   GIR_AddTempRegister, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190555 */   GIR_AddImm, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 394(*/0x8A, 0x03/*)*/,
     /* 190569 */   GIR_MakeTempReg, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190573 */   GIR_BuildMI, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190578 */   GIR_AddTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190585 */   GIR_AddSimpleTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/,
     /* 190590 */   GIR_AddImm, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 393(*/0x89, 0x03/*)*/,
     /* 190604 */   GIR_MakeTempReg, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190608 */   GIR_BuildMI, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190613 */   GIR_AddTempRegister, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 392(*/0x88, 0x03/*)*/,
     /* 190623 */   GIR_MakeTempReg, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190627 */   GIR_BuildMI, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190632 */   GIR_AddTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190639 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/,
     /* 190644 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/,
     /* 190649 */   GIR_AddImm8, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Imm*/1,
     /* 190653 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190659 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190665 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190671 */   GIR_MakeTempReg, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190675 */   GIR_BuildMI, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190680 */   GIR_AddTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190687 */   GIR_AddSimpleTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/,
     /* 190692 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/32,
     /* 190696 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/31,
     /* 190700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 390(*/0x86, 0x03/*)*/,
     /* 190703 */   GIR_MakeTempReg, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190707 */   GIR_BuildMI, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190712 */   GIR_AddTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190719 */   GIR_AddSimpleTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/,
     /* 190724 */   GIR_AddImm, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 389(*/0x85, 0x03/*)*/,
     /* 190738 */   GIR_MakeTempReg, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190742 */   GIR_BuildMI, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190747 */   GIR_AddTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190754 */   GIR_AddSimpleTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/,
     /* 190759 */   GIR_AddImm, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 388(*/0x84, 0x03/*)*/,
     /* 190773 */   GIR_MakeTempReg, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190777 */   GIR_BuildMI, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190782 */   GIR_AddTempRegister, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190789 */   GIR_Copy, /*NewInsnID*//* 387(*/0x83, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 190794 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/1,
     /* 190798 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/62,
     /* 190802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 387(*/0x83, 0x03/*)*/,
     /* 190805 */   GIR_MakeTempReg, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190809 */   GIR_BuildMI, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190814 */   GIR_AddTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190821 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/,
     /* 190826 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/,
     /* 190831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 386(*/0x82, 0x03/*)*/,
     /* 190834 */   GIR_MakeTempReg, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190838 */   GIR_BuildMI, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190843 */   GIR_AddTempRegister, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190850 */   GIR_AddImm, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 385(*/0x81, 0x03/*)*/,
     /* 190864 */   GIR_MakeTempReg, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190868 */   GIR_BuildMI, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190873 */   GIR_AddTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190880 */   GIR_AddSimpleTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/,
     /* 190885 */   GIR_AddImm, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 384(*/0x80, 0x03/*)*/,
     /* 190899 */   GIR_MakeTempReg, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190903 */   GIR_BuildMI, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190908 */   GIR_AddTempRegister, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 383(*/0xFF, 0x02/*)*/,
     /* 190918 */   GIR_MakeTempReg, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190922 */   GIR_BuildMI, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190927 */   GIR_AddTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190934 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/,
     /* 190939 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/,
     /* 190944 */   GIR_AddImm8, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Imm*/1,
     /* 190948 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190954 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190960 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190966 */   GIR_MakeTempReg, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190970 */   GIR_BuildMI, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190975 */   GIR_AddTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190982 */   GIR_AddSimpleTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/,
     /* 190987 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/32,
     /* 190991 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/31,
     /* 190995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 381(*/0xFD, 0x02/*)*/,
     /* 190998 */   GIR_MakeTempReg, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191002 */   GIR_BuildMI, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191007 */   GIR_AddTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191014 */   GIR_AddSimpleTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/,
     /* 191019 */   GIR_AddImm, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 380(*/0xFC, 0x02/*)*/,
     /* 191033 */   GIR_MakeTempReg, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191037 */   GIR_BuildMI, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191042 */   GIR_AddTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191049 */   GIR_AddSimpleTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/,
     /* 191054 */   GIR_AddImm, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 379(*/0xFB, 0x02/*)*/,
     /* 191068 */   GIR_MakeTempReg, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191072 */   GIR_BuildMI, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 191077 */   GIR_AddTempRegister, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191084 */   GIR_Copy, /*NewInsnID*//* 378(*/0xFA, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191089 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/63,
     /* 191093 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/1,
     /* 191097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 378(*/0xFA, 0x02/*)*/,
     /* 191100 */   GIR_MakeTempReg, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191104 */   GIR_BuildMI, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191109 */   GIR_AddTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191116 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/,
     /* 191121 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/,
     /* 191126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 377(*/0xF9, 0x02/*)*/,
     /* 191129 */   GIR_MakeTempReg, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191133 */   GIR_BuildMI, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 191138 */   GIR_AddTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191145 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/,
     /* 191150 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/,
     /* 191155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 376(*/0xF8, 0x02/*)*/,
     /* 191158 */   GIR_MakeTempReg, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191162 */   GIR_BuildMI, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191167 */   GIR_AddTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191174 */   GIR_AddSimpleTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/,
     /* 191179 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/2,
     /* 191183 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/61,
     /* 191187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 375(*/0xF7, 0x02/*)*/,
     /* 191190 */   GIR_MakeTempReg, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191194 */   GIR_BuildMI, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191199 */   GIR_AddTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191206 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/,
     /* 191211 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/,
     /* 191216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 374(*/0xF6, 0x02/*)*/,
     /* 191219 */   GIR_MakeTempReg, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191223 */   GIR_BuildMI, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191228 */   GIR_AddTempRegister, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191235 */   GIR_AddImm, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 373(*/0xF5, 0x02/*)*/,
     /* 191249 */   GIR_MakeTempReg, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191253 */   GIR_BuildMI, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191258 */   GIR_AddTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191265 */   GIR_AddSimpleTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/,
     /* 191270 */   GIR_AddImm, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 372(*/0xF4, 0x02/*)*/,
     /* 191284 */   GIR_MakeTempReg, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191288 */   GIR_BuildMI, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191293 */   GIR_AddTempRegister, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 371(*/0xF3, 0x02/*)*/,
     /* 191303 */   GIR_MakeTempReg, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191307 */   GIR_BuildMI, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191312 */   GIR_AddTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191319 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/,
     /* 191324 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/,
     /* 191329 */   GIR_AddImm8, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Imm*/1,
     /* 191333 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191339 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191345 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191351 */   GIR_MakeTempReg, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191355 */   GIR_BuildMI, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191360 */   GIR_AddTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191367 */   GIR_AddSimpleTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/,
     /* 191372 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/32,
     /* 191376 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/31,
     /* 191380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 369(*/0xF1, 0x02/*)*/,
     /* 191383 */   GIR_MakeTempReg, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191387 */   GIR_BuildMI, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191392 */   GIR_AddTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191399 */   GIR_AddSimpleTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/,
     /* 191404 */   GIR_AddImm, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 368(*/0xF0, 0x02/*)*/,
     /* 191418 */   GIR_MakeTempReg, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191422 */   GIR_BuildMI, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191427 */   GIR_AddTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191434 */   GIR_AddSimpleTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/,
     /* 191439 */   GIR_AddImm, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 367(*/0xEF, 0x02/*)*/,
     /* 191453 */   GIR_MakeTempReg, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191457 */   GIR_BuildMI, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191462 */   GIR_AddTempRegister, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191469 */   GIR_AddImm, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 366(*/0xEE, 0x02/*)*/,
     /* 191483 */   GIR_MakeTempReg, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191487 */   GIR_BuildMI, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191492 */   GIR_AddTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191499 */   GIR_AddSimpleTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/,
     /* 191504 */   GIR_AddImm, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 365(*/0xED, 0x02/*)*/,
     /* 191518 */   GIR_MakeTempReg, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191522 */   GIR_BuildMI, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191527 */   GIR_AddTempRegister, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 364(*/0xEC, 0x02/*)*/,
     /* 191537 */   GIR_MakeTempReg, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191541 */   GIR_BuildMI, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191546 */   GIR_AddTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191553 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/,
     /* 191558 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/,
     /* 191563 */   GIR_AddImm8, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Imm*/1,
     /* 191567 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191573 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191579 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191585 */   GIR_MakeTempReg, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191589 */   GIR_BuildMI, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191594 */   GIR_AddTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191601 */   GIR_AddSimpleTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/,
     /* 191606 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/32,
     /* 191610 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/31,
     /* 191614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 362(*/0xEA, 0x02/*)*/,
     /* 191617 */   GIR_MakeTempReg, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191621 */   GIR_BuildMI, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191626 */   GIR_AddTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191633 */   GIR_AddSimpleTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/,
     /* 191638 */   GIR_AddImm, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 361(*/0xE9, 0x02/*)*/,
     /* 191652 */   GIR_MakeTempReg, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191656 */   GIR_BuildMI, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191661 */   GIR_AddTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191668 */   GIR_AddSimpleTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/,
     /* 191673 */   GIR_AddImm, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 360(*/0xE8, 0x02/*)*/,
     /* 191687 */   GIR_MakeTempReg, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191691 */   GIR_BuildMI, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191696 */   GIR_AddTempRegister, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191703 */   GIR_Copy, /*NewInsnID*//* 359(*/0xE7, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191708 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/1,
     /* 191712 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/62,
     /* 191716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 359(*/0xE7, 0x02/*)*/,
     /* 191719 */   GIR_MakeTempReg, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191723 */   GIR_BuildMI, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191728 */   GIR_AddTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191735 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/,
     /* 191740 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/,
     /* 191745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 358(*/0xE6, 0x02/*)*/,
     /* 191748 */   GIR_MakeTempReg, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191752 */   GIR_BuildMI, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191757 */   GIR_AddTempRegister, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191764 */   GIR_AddImm, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 357(*/0xE5, 0x02/*)*/,
     /* 191778 */   GIR_MakeTempReg, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191782 */   GIR_BuildMI, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191787 */   GIR_AddTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191794 */   GIR_AddSimpleTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/,
     /* 191799 */   GIR_AddImm, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 356(*/0xE4, 0x02/*)*/,
     /* 191813 */   GIR_MakeTempReg, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191817 */   GIR_BuildMI, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191822 */   GIR_AddTempRegister, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 355(*/0xE3, 0x02/*)*/,
     /* 191832 */   GIR_MakeTempReg, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191836 */   GIR_BuildMI, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191841 */   GIR_AddTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191848 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/,
     /* 191853 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/,
     /* 191858 */   GIR_AddImm8, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Imm*/1,
     /* 191862 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191868 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191874 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191880 */   GIR_MakeTempReg, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191884 */   GIR_BuildMI, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191889 */   GIR_AddTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191896 */   GIR_AddSimpleTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/,
     /* 191901 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/32,
     /* 191905 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/31,
     /* 191909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 353(*/0xE1, 0x02/*)*/,
     /* 191912 */   GIR_MakeTempReg, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191916 */   GIR_BuildMI, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191921 */   GIR_AddTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191928 */   GIR_AddSimpleTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/,
     /* 191933 */   GIR_AddImm, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 352(*/0xE0, 0x02/*)*/,
     /* 191947 */   GIR_MakeTempReg, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191951 */   GIR_BuildMI, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191956 */   GIR_AddTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191963 */   GIR_AddSimpleTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/,
     /* 191968 */   GIR_AddImm, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 351(*/0xDF, 0x02/*)*/,
     /* 191982 */   GIR_MakeTempReg, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191986 */   GIR_BuildMI, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 191991 */   GIR_AddTempRegister, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191998 */   GIR_Copy, /*NewInsnID*//* 350(*/0xDE, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192003 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/63,
     /* 192007 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/1,
     /* 192011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 350(*/0xDE, 0x02/*)*/,
     /* 192014 */   GIR_MakeTempReg, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192018 */   GIR_BuildMI, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192023 */   GIR_AddTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192030 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/,
     /* 192035 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/,
     /* 192040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 349(*/0xDD, 0x02/*)*/,
     /* 192043 */   GIR_MakeTempReg, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192047 */   GIR_BuildMI, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 192052 */   GIR_AddTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192059 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/,
     /* 192064 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/,
     /* 192069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 348(*/0xDC, 0x02/*)*/,
     /* 192072 */   GIR_MakeTempReg, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192076 */   GIR_BuildMI, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 192081 */   GIR_AddTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192088 */   GIR_AddSimpleTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/,
     /* 192093 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/62,
     /* 192097 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/2,
     /* 192101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 347(*/0xDB, 0x02/*)*/,
     /* 192104 */   GIR_MakeTempReg, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192108 */   GIR_BuildMI, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192113 */   GIR_AddTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192120 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/,
     /* 192125 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/,
     /* 192130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 346(*/0xDA, 0x02/*)*/,
     /* 192133 */   GIR_MakeTempReg, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192137 */   GIR_BuildMI, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 192142 */   GIR_AddTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192149 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/,
     /* 192154 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/,
     /* 192159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 345(*/0xD9, 0x02/*)*/,
     /* 192162 */   GIR_MakeTempReg, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192166 */   GIR_BuildMI, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192171 */   GIR_AddTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192178 */   GIR_AddSimpleTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/,
     /* 192183 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/4,
     /* 192187 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/59,
     /* 192191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 344(*/0xD8, 0x02/*)*/,
     /* 192194 */   GIR_MakeTempReg, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192198 */   GIR_BuildMI, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192203 */   GIR_AddTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192210 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/,
     /* 192215 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/,
     /* 192220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 343(*/0xD7, 0x02/*)*/,
     /* 192223 */   GIR_MakeTempReg, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192227 */   GIR_BuildMI, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192232 */   GIR_AddTempRegister, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192239 */   GIR_AddImm, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 342(*/0xD6, 0x02/*)*/,
     /* 192253 */   GIR_MakeTempReg, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192257 */   GIR_BuildMI, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192262 */   GIR_AddTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192269 */   GIR_AddSimpleTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/,
     /* 192274 */   GIR_AddImm, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 341(*/0xD5, 0x02/*)*/,
     /* 192288 */   GIR_MakeTempReg, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192292 */   GIR_BuildMI, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192297 */   GIR_AddTempRegister, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 340(*/0xD4, 0x02/*)*/,
     /* 192307 */   GIR_MakeTempReg, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192311 */   GIR_BuildMI, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192316 */   GIR_AddTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192323 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/,
     /* 192328 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/,
     /* 192333 */   GIR_AddImm8, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Imm*/1,
     /* 192337 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192343 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192349 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192355 */   GIR_MakeTempReg, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192359 */   GIR_BuildMI, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192364 */   GIR_AddTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192371 */   GIR_AddSimpleTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/,
     /* 192376 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/32,
     /* 192380 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/31,
     /* 192384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 338(*/0xD2, 0x02/*)*/,
     /* 192387 */   GIR_MakeTempReg, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192391 */   GIR_BuildMI, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192396 */   GIR_AddTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192403 */   GIR_AddSimpleTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/,
     /* 192408 */   GIR_AddImm, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 337(*/0xD1, 0x02/*)*/,
     /* 192422 */   GIR_MakeTempReg, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192426 */   GIR_BuildMI, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192431 */   GIR_AddTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192438 */   GIR_AddSimpleTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/,
     /* 192443 */   GIR_AddImm, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 336(*/0xD0, 0x02/*)*/,
     /* 192457 */   GIR_MakeTempReg, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192461 */   GIR_BuildMI, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192466 */   GIR_AddTempRegister, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192473 */   GIR_AddImm, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 335(*/0xCF, 0x02/*)*/,
     /* 192487 */   GIR_MakeTempReg, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192491 */   GIR_BuildMI, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192496 */   GIR_AddTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192503 */   GIR_AddSimpleTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/,
     /* 192508 */   GIR_AddImm, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 334(*/0xCE, 0x02/*)*/,
     /* 192522 */   GIR_MakeTempReg, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192526 */   GIR_BuildMI, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192531 */   GIR_AddTempRegister, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 333(*/0xCD, 0x02/*)*/,
     /* 192541 */   GIR_MakeTempReg, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192545 */   GIR_BuildMI, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192550 */   GIR_AddTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192557 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/,
     /* 192562 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/,
     /* 192567 */   GIR_AddImm8, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Imm*/1,
     /* 192571 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192577 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192583 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192589 */   GIR_MakeTempReg, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192593 */   GIR_BuildMI, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192598 */   GIR_AddTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192605 */   GIR_AddSimpleTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/,
     /* 192610 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/32,
     /* 192614 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/31,
     /* 192618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 331(*/0xCB, 0x02/*)*/,
     /* 192621 */   GIR_MakeTempReg, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192625 */   GIR_BuildMI, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192630 */   GIR_AddTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192637 */   GIR_AddSimpleTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/,
     /* 192642 */   GIR_AddImm, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 330(*/0xCA, 0x02/*)*/,
     /* 192656 */   GIR_MakeTempReg, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192660 */   GIR_BuildMI, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192665 */   GIR_AddTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192672 */   GIR_AddSimpleTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/,
     /* 192677 */   GIR_AddImm, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 329(*/0xC9, 0x02/*)*/,
     /* 192691 */   GIR_MakeTempReg, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192695 */   GIR_BuildMI, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192700 */   GIR_AddTempRegister, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192707 */   GIR_AddImm, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 328(*/0xC8, 0x02/*)*/,
     /* 192721 */   GIR_MakeTempReg, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192725 */   GIR_BuildMI, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192730 */   GIR_AddTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192737 */   GIR_AddSimpleTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/,
     /* 192742 */   GIR_AddImm, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 327(*/0xC7, 0x02/*)*/,
     /* 192756 */   GIR_MakeTempReg, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192760 */   GIR_BuildMI, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192765 */   GIR_AddTempRegister, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 326(*/0xC6, 0x02/*)*/,
     /* 192775 */   GIR_MakeTempReg, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192779 */   GIR_BuildMI, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192784 */   GIR_AddTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192791 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/,
     /* 192796 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/,
     /* 192801 */   GIR_AddImm8, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Imm*/1,
     /* 192805 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192811 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192817 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192823 */   GIR_MakeTempReg, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192827 */   GIR_BuildMI, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192832 */   GIR_AddTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192839 */   GIR_AddSimpleTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/,
     /* 192844 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/32,
     /* 192848 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/31,
     /* 192852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 324(*/0xC4, 0x02/*)*/,
     /* 192855 */   GIR_MakeTempReg, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192859 */   GIR_BuildMI, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192864 */   GIR_AddTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192871 */   GIR_AddSimpleTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/,
     /* 192876 */   GIR_AddImm, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 323(*/0xC3, 0x02/*)*/,
     /* 192890 */   GIR_MakeTempReg, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192894 */   GIR_BuildMI, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192899 */   GIR_AddTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192906 */   GIR_AddSimpleTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/,
     /* 192911 */   GIR_AddImm, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 322(*/0xC2, 0x02/*)*/,
     /* 192925 */   GIR_MakeTempReg, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192929 */   GIR_BuildMI, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192934 */   GIR_AddTempRegister, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192941 */   GIR_Copy, /*NewInsnID*//* 321(*/0xC1, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192946 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/1,
     /* 192950 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/62,
     /* 192954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 321(*/0xC1, 0x02/*)*/,
     /* 192957 */   GIR_MakeTempReg, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192961 */   GIR_BuildMI, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192966 */   GIR_AddTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192973 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/,
     /* 192978 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/,
     /* 192983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 320(*/0xC0, 0x02/*)*/,
     /* 192986 */   GIR_MakeTempReg, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192990 */   GIR_BuildMI, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192995 */   GIR_AddTempRegister, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193002 */   GIR_AddImm, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 319(*/0xBF, 0x02/*)*/,
     /* 193016 */   GIR_MakeTempReg, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193020 */   GIR_BuildMI, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193025 */   GIR_AddTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193032 */   GIR_AddSimpleTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/,
     /* 193037 */   GIR_AddImm, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 318(*/0xBE, 0x02/*)*/,
     /* 193051 */   GIR_MakeTempReg, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193055 */   GIR_BuildMI, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193060 */   GIR_AddTempRegister, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 317(*/0xBD, 0x02/*)*/,
     /* 193070 */   GIR_MakeTempReg, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193074 */   GIR_BuildMI, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193079 */   GIR_AddTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193086 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/,
     /* 193091 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/,
     /* 193096 */   GIR_AddImm8, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Imm*/1,
     /* 193100 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193106 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193112 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193118 */   GIR_MakeTempReg, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193122 */   GIR_BuildMI, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193127 */   GIR_AddTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193134 */   GIR_AddSimpleTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/,
     /* 193139 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/32,
     /* 193143 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/31,
     /* 193147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 315(*/0xBB, 0x02/*)*/,
     /* 193150 */   GIR_MakeTempReg, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193154 */   GIR_BuildMI, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193159 */   GIR_AddTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193166 */   GIR_AddSimpleTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/,
     /* 193171 */   GIR_AddImm, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 314(*/0xBA, 0x02/*)*/,
     /* 193185 */   GIR_MakeTempReg, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193189 */   GIR_BuildMI, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193194 */   GIR_AddTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193201 */   GIR_AddSimpleTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/,
     /* 193206 */   GIR_AddImm, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 313(*/0xB9, 0x02/*)*/,
     /* 193220 */   GIR_MakeTempReg, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193224 */   GIR_BuildMI, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 193229 */   GIR_AddTempRegister, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193236 */   GIR_Copy, /*NewInsnID*//* 312(*/0xB8, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193241 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/63,
     /* 193245 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/1,
     /* 193249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 312(*/0xB8, 0x02/*)*/,
     /* 193252 */   GIR_MakeTempReg, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193256 */   GIR_BuildMI, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193261 */   GIR_AddTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193268 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/,
     /* 193273 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/,
     /* 193278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 311(*/0xB7, 0x02/*)*/,
     /* 193281 */   GIR_MakeTempReg, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193285 */   GIR_BuildMI, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 193290 */   GIR_AddTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193297 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/,
     /* 193302 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/,
     /* 193307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 310(*/0xB6, 0x02/*)*/,
     /* 193310 */   GIR_MakeTempReg, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193314 */   GIR_BuildMI, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193319 */   GIR_AddTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193326 */   GIR_AddSimpleTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/,
     /* 193331 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/2,
     /* 193335 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/61,
     /* 193339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 309(*/0xB5, 0x02/*)*/,
     /* 193342 */   GIR_MakeTempReg, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193346 */   GIR_BuildMI, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193351 */   GIR_AddTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193358 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/,
     /* 193363 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/,
     /* 193368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 308(*/0xB4, 0x02/*)*/,
     /* 193371 */   GIR_MakeTempReg, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193375 */   GIR_BuildMI, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193380 */   GIR_AddTempRegister, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193387 */   GIR_AddImm, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 307(*/0xB3, 0x02/*)*/,
     /* 193401 */   GIR_MakeTempReg, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193405 */   GIR_BuildMI, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193410 */   GIR_AddTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193417 */   GIR_AddSimpleTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/,
     /* 193422 */   GIR_AddImm, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 306(*/0xB2, 0x02/*)*/,
     /* 193436 */   GIR_MakeTempReg, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193440 */   GIR_BuildMI, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193445 */   GIR_AddTempRegister, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 305(*/0xB1, 0x02/*)*/,
     /* 193455 */   GIR_MakeTempReg, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193459 */   GIR_BuildMI, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193464 */   GIR_AddTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193471 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/,
     /* 193476 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/,
     /* 193481 */   GIR_AddImm8, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Imm*/1,
     /* 193485 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193491 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193497 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193503 */   GIR_MakeTempReg, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193507 */   GIR_BuildMI, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193512 */   GIR_AddTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193519 */   GIR_AddSimpleTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/,
     /* 193524 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/32,
     /* 193528 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/31,
     /* 193532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 303(*/0xAF, 0x02/*)*/,
     /* 193535 */   GIR_MakeTempReg, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193539 */   GIR_BuildMI, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193544 */   GIR_AddTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193551 */   GIR_AddSimpleTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/,
     /* 193556 */   GIR_AddImm, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 302(*/0xAE, 0x02/*)*/,
     /* 193570 */   GIR_MakeTempReg, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193574 */   GIR_BuildMI, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193579 */   GIR_AddTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193586 */   GIR_AddSimpleTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/,
     /* 193591 */   GIR_AddImm, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 301(*/0xAD, 0x02/*)*/,
     /* 193605 */   GIR_MakeTempReg, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193609 */   GIR_BuildMI, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193614 */   GIR_AddTempRegister, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193621 */   GIR_AddImm, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 300(*/0xAC, 0x02/*)*/,
     /* 193635 */   GIR_MakeTempReg, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193639 */   GIR_BuildMI, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193644 */   GIR_AddTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193651 */   GIR_AddSimpleTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/,
     /* 193656 */   GIR_AddImm, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 299(*/0xAB, 0x02/*)*/,
     /* 193670 */   GIR_MakeTempReg, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193674 */   GIR_BuildMI, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193679 */   GIR_AddTempRegister, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 298(*/0xAA, 0x02/*)*/,
     /* 193689 */   GIR_MakeTempReg, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193693 */   GIR_BuildMI, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193698 */   GIR_AddTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193705 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/,
     /* 193710 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/,
     /* 193715 */   GIR_AddImm8, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Imm*/1,
     /* 193719 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193725 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193731 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193737 */   GIR_MakeTempReg, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193741 */   GIR_BuildMI, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193746 */   GIR_AddTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193753 */   GIR_AddSimpleTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/,
     /* 193758 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/32,
     /* 193762 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/31,
     /* 193766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 296(*/0xA8, 0x02/*)*/,
     /* 193769 */   GIR_MakeTempReg, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193773 */   GIR_BuildMI, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193778 */   GIR_AddTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193785 */   GIR_AddSimpleTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/,
     /* 193790 */   GIR_AddImm, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 295(*/0xA7, 0x02/*)*/,
     /* 193804 */   GIR_MakeTempReg, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193808 */   GIR_BuildMI, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193813 */   GIR_AddTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193820 */   GIR_AddSimpleTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/,
     /* 193825 */   GIR_AddImm, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 294(*/0xA6, 0x02/*)*/,
     /* 193839 */   GIR_MakeTempReg, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193843 */   GIR_BuildMI, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193848 */   GIR_AddTempRegister, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193855 */   GIR_Copy, /*NewInsnID*//* 293(*/0xA5, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193860 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/1,
     /* 193864 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/62,
     /* 193868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 293(*/0xA5, 0x02/*)*/,
     /* 193871 */   GIR_MakeTempReg, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193875 */   GIR_BuildMI, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193880 */   GIR_AddTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193887 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/,
     /* 193892 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/,
     /* 193897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 292(*/0xA4, 0x02/*)*/,
     /* 193900 */   GIR_MakeTempReg, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193904 */   GIR_BuildMI, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193909 */   GIR_AddTempRegister, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193916 */   GIR_AddImm, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 291(*/0xA3, 0x02/*)*/,
     /* 193930 */   GIR_MakeTempReg, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193934 */   GIR_BuildMI, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193939 */   GIR_AddTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193946 */   GIR_AddSimpleTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/,
     /* 193951 */   GIR_AddImm, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 290(*/0xA2, 0x02/*)*/,
     /* 193965 */   GIR_MakeTempReg, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193969 */   GIR_BuildMI, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193974 */   GIR_AddTempRegister, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 289(*/0xA1, 0x02/*)*/,
     /* 193984 */   GIR_MakeTempReg, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193988 */   GIR_BuildMI, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193993 */   GIR_AddTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194000 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/,
     /* 194005 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/,
     /* 194010 */   GIR_AddImm8, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Imm*/1,
     /* 194014 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194020 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194026 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194032 */   GIR_MakeTempReg, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194036 */   GIR_BuildMI, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194041 */   GIR_AddTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194048 */   GIR_AddSimpleTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/,
     /* 194053 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/32,
     /* 194057 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/31,
     /* 194061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 287(*/0x9F, 0x02/*)*/,
     /* 194064 */   GIR_MakeTempReg, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194068 */   GIR_BuildMI, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194073 */   GIR_AddTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194080 */   GIR_AddSimpleTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/,
     /* 194085 */   GIR_AddImm, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 286(*/0x9E, 0x02/*)*/,
     /* 194099 */   GIR_MakeTempReg, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194103 */   GIR_BuildMI, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194108 */   GIR_AddTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194115 */   GIR_AddSimpleTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/,
     /* 194120 */   GIR_AddImm, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 285(*/0x9D, 0x02/*)*/,
     /* 194134 */   GIR_MakeTempReg, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194138 */   GIR_BuildMI, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194143 */   GIR_AddTempRegister, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194150 */   GIR_Copy, /*NewInsnID*//* 284(*/0x9C, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 194155 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/63,
     /* 194159 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/1,
     /* 194163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 284(*/0x9C, 0x02/*)*/,
     /* 194166 */   GIR_MakeTempReg, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194170 */   GIR_BuildMI, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194175 */   GIR_AddTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194182 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/,
     /* 194187 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/,
     /* 194192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 283(*/0x9B, 0x02/*)*/,
     /* 194195 */   GIR_MakeTempReg, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194199 */   GIR_BuildMI, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194204 */   GIR_AddTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194211 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/,
     /* 194216 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/,
     /* 194221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 282(*/0x9A, 0x02/*)*/,
     /* 194224 */   GIR_MakeTempReg, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194228 */   GIR_BuildMI, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194233 */   GIR_AddTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194240 */   GIR_AddSimpleTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/,
     /* 194245 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/62,
     /* 194249 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/2,
     /* 194253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 281(*/0x99, 0x02/*)*/,
     /* 194256 */   GIR_MakeTempReg, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194260 */   GIR_BuildMI, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194265 */   GIR_AddTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194272 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/,
     /* 194277 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/,
     /* 194282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 280(*/0x98, 0x02/*)*/,
     /* 194285 */   GIR_MakeTempReg, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194289 */   GIR_BuildMI, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194294 */   GIR_AddTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194301 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/,
     /* 194306 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/,
     /* 194311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 279(*/0x97, 0x02/*)*/,
     /* 194314 */   GIR_MakeTempReg, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194318 */   GIR_BuildMI, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194323 */   GIR_AddTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194330 */   GIR_AddSimpleTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/,
     /* 194335 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/60,
     /* 194339 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/4,
     /* 194343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 278(*/0x96, 0x02/*)*/,
     /* 194346 */   GIR_MakeTempReg, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194350 */   GIR_BuildMI, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194355 */   GIR_AddTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194362 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/,
     /* 194367 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/,
     /* 194372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 277(*/0x95, 0x02/*)*/,
     /* 194375 */   GIR_MakeTempReg, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194379 */   GIR_BuildMI, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194384 */   GIR_AddTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194391 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/,
     /* 194396 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/,
     /* 194401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 276(*/0x94, 0x02/*)*/,
     /* 194404 */   GIR_MakeTempReg, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194408 */   GIR_BuildMI, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194413 */   GIR_AddTempRegister, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194420 */   GIR_AddImm, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 548(*/0xA4, 0x04/*)*/,
     /* 194434 */   GIR_MakeTempReg, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194438 */   GIR_BuildMI, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194443 */   GIR_AddTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194450 */   GIR_AddSimpleTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/,
     /* 194455 */   GIR_AddImm, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 547(*/0xA3, 0x04/*)*/,
     /* 194469 */   GIR_MakeTempReg, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194473 */   GIR_BuildMI, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194478 */   GIR_AddTempRegister, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 546(*/0xA2, 0x04/*)*/,
     /* 194488 */   GIR_MakeTempReg, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194492 */   GIR_BuildMI, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194497 */   GIR_AddTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194504 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/,
     /* 194509 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/,
     /* 194514 */   GIR_AddImm8, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Imm*/1,
     /* 194518 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194524 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194530 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194536 */   GIR_MakeTempReg, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194540 */   GIR_BuildMI, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194545 */   GIR_AddTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194552 */   GIR_AddSimpleTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/,
     /* 194557 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/32,
     /* 194561 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/31,
     /* 194565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 544(*/0xA0, 0x04/*)*/,
     /* 194568 */   GIR_MakeTempReg, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194572 */   GIR_BuildMI, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194577 */   GIR_AddTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194584 */   GIR_AddSimpleTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/,
     /* 194589 */   GIR_AddImm, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 543(*/0x9F, 0x04/*)*/,
     /* 194603 */   GIR_MakeTempReg, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194607 */   GIR_BuildMI, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194612 */   GIR_AddTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194619 */   GIR_AddSimpleTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/,
     /* 194624 */   GIR_AddImm, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 542(*/0x9E, 0x04/*)*/,
     /* 194638 */   GIR_MakeTempReg, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194642 */   GIR_BuildMI, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194647 */   GIR_AddTempRegister, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194654 */   GIR_AddImm, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 541(*/0x9D, 0x04/*)*/,
     /* 194668 */   GIR_MakeTempReg, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194672 */   GIR_BuildMI, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194677 */   GIR_AddTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194684 */   GIR_AddSimpleTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/,
     /* 194689 */   GIR_AddImm, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 540(*/0x9C, 0x04/*)*/,
     /* 194703 */   GIR_MakeTempReg, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194707 */   GIR_BuildMI, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194712 */   GIR_AddTempRegister, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 539(*/0x9B, 0x04/*)*/,
     /* 194722 */   GIR_MakeTempReg, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194726 */   GIR_BuildMI, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194731 */   GIR_AddTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194738 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/,
     /* 194743 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/,
     /* 194748 */   GIR_AddImm8, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Imm*/1,
     /* 194752 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194758 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194764 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194770 */   GIR_MakeTempReg, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194774 */   GIR_BuildMI, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194779 */   GIR_AddTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194786 */   GIR_AddSimpleTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/,
     /* 194791 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/32,
     /* 194795 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/31,
     /* 194799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 537(*/0x99, 0x04/*)*/,
     /* 194802 */   GIR_MakeTempReg, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194806 */   GIR_BuildMI, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194811 */   GIR_AddTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194818 */   GIR_AddSimpleTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/,
     /* 194823 */   GIR_AddImm, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 536(*/0x98, 0x04/*)*/,
     /* 194837 */   GIR_MakeTempReg, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194841 */   GIR_BuildMI, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194846 */   GIR_AddTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194853 */   GIR_AddSimpleTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/,
     /* 194858 */   GIR_AddImm, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 535(*/0x97, 0x04/*)*/,
     /* 194872 */   GIR_MakeTempReg, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194876 */   GIR_BuildMI, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194881 */   GIR_AddTempRegister, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194888 */   GIR_AddImm, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 534(*/0x96, 0x04/*)*/,
     /* 194902 */   GIR_MakeTempReg, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194906 */   GIR_BuildMI, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194911 */   GIR_AddTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194918 */   GIR_AddSimpleTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/,
     /* 194923 */   GIR_AddImm, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 533(*/0x95, 0x04/*)*/,
     /* 194937 */   GIR_MakeTempReg, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194941 */   GIR_BuildMI, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194946 */   GIR_AddTempRegister, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 532(*/0x94, 0x04/*)*/,
     /* 194956 */   GIR_MakeTempReg, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194960 */   GIR_BuildMI, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194965 */   GIR_AddTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194972 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/,
     /* 194977 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/,
     /* 194982 */   GIR_AddImm8, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Imm*/1,
     /* 194986 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194992 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194998 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195004 */   GIR_MakeTempReg, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195008 */   GIR_BuildMI, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195013 */   GIR_AddTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195020 */   GIR_AddSimpleTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/,
     /* 195025 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/32,
     /* 195029 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/31,
     /* 195033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 530(*/0x92, 0x04/*)*/,
     /* 195036 */   GIR_MakeTempReg, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195040 */   GIR_BuildMI, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195045 */   GIR_AddTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195052 */   GIR_AddSimpleTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/,
     /* 195057 */   GIR_AddImm, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 529(*/0x91, 0x04/*)*/,
     /* 195071 */   GIR_MakeTempReg, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195075 */   GIR_BuildMI, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195080 */   GIR_AddTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195087 */   GIR_AddSimpleTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/,
     /* 195092 */   GIR_AddImm, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 528(*/0x90, 0x04/*)*/,
     /* 195106 */   GIR_MakeTempReg, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195110 */   GIR_BuildMI, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195115 */   GIR_AddTempRegister, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195122 */   GIR_Copy, /*NewInsnID*//* 527(*/0x8F, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195127 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/1,
     /* 195131 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/62,
     /* 195135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 527(*/0x8F, 0x04/*)*/,
     /* 195138 */   GIR_MakeTempReg, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195142 */   GIR_BuildMI, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195147 */   GIR_AddTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195154 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/,
     /* 195159 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/,
     /* 195164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 526(*/0x8E, 0x04/*)*/,
     /* 195167 */   GIR_MakeTempReg, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195171 */   GIR_BuildMI, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195176 */   GIR_AddTempRegister, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195183 */   GIR_AddImm, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 525(*/0x8D, 0x04/*)*/,
     /* 195197 */   GIR_MakeTempReg, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195201 */   GIR_BuildMI, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195206 */   GIR_AddTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195213 */   GIR_AddSimpleTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/,
     /* 195218 */   GIR_AddImm, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 524(*/0x8C, 0x04/*)*/,
     /* 195232 */   GIR_MakeTempReg, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195236 */   GIR_BuildMI, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195241 */   GIR_AddTempRegister, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 523(*/0x8B, 0x04/*)*/,
     /* 195251 */   GIR_MakeTempReg, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195255 */   GIR_BuildMI, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195260 */   GIR_AddTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195267 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/,
     /* 195272 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/,
     /* 195277 */   GIR_AddImm8, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Imm*/1,
     /* 195281 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195287 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195293 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195299 */   GIR_MakeTempReg, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195303 */   GIR_BuildMI, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195308 */   GIR_AddTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195315 */   GIR_AddSimpleTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/,
     /* 195320 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/32,
     /* 195324 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/31,
     /* 195328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 521(*/0x89, 0x04/*)*/,
     /* 195331 */   GIR_MakeTempReg, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195335 */   GIR_BuildMI, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195340 */   GIR_AddTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195347 */   GIR_AddSimpleTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/,
     /* 195352 */   GIR_AddImm, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 520(*/0x88, 0x04/*)*/,
     /* 195366 */   GIR_MakeTempReg, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195370 */   GIR_BuildMI, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195375 */   GIR_AddTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195382 */   GIR_AddSimpleTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/,
     /* 195387 */   GIR_AddImm, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 519(*/0x87, 0x04/*)*/,
     /* 195401 */   GIR_MakeTempReg, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195405 */   GIR_BuildMI, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 195410 */   GIR_AddTempRegister, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195417 */   GIR_Copy, /*NewInsnID*//* 518(*/0x86, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195422 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/63,
     /* 195426 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/1,
     /* 195430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 518(*/0x86, 0x04/*)*/,
     /* 195433 */   GIR_MakeTempReg, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195437 */   GIR_BuildMI, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195442 */   GIR_AddTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195449 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/,
     /* 195454 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/,
     /* 195459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 517(*/0x85, 0x04/*)*/,
     /* 195462 */   GIR_MakeTempReg, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195466 */   GIR_BuildMI, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 195471 */   GIR_AddTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195478 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/,
     /* 195483 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/,
     /* 195488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 516(*/0x84, 0x04/*)*/,
     /* 195491 */   GIR_MakeTempReg, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195495 */   GIR_BuildMI, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195500 */   GIR_AddTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195507 */   GIR_AddSimpleTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/,
     /* 195512 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/2,
     /* 195516 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/61,
     /* 195520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 515(*/0x83, 0x04/*)*/,
     /* 195523 */   GIR_MakeTempReg, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195527 */   GIR_BuildMI, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195532 */   GIR_AddTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195539 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/,
     /* 195544 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/,
     /* 195549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 514(*/0x82, 0x04/*)*/,
     /* 195552 */   GIR_MakeTempReg, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195556 */   GIR_BuildMI, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195561 */   GIR_AddTempRegister, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195568 */   GIR_AddImm, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 513(*/0x81, 0x04/*)*/,
     /* 195582 */   GIR_MakeTempReg, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195586 */   GIR_BuildMI, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195591 */   GIR_AddTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195598 */   GIR_AddSimpleTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/,
     /* 195603 */   GIR_AddImm, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 512(*/0x80, 0x04/*)*/,
     /* 195617 */   GIR_MakeTempReg, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195621 */   GIR_BuildMI, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195626 */   GIR_AddTempRegister, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 511(*/0xFF, 0x03/*)*/,
     /* 195636 */   GIR_MakeTempReg, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195640 */   GIR_BuildMI, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195645 */   GIR_AddTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195652 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/,
     /* 195657 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/,
     /* 195662 */   GIR_AddImm8, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Imm*/1,
     /* 195666 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195672 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195678 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195684 */   GIR_MakeTempReg, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195688 */   GIR_BuildMI, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195693 */   GIR_AddTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195700 */   GIR_AddSimpleTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/,
     /* 195705 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/32,
     /* 195709 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/31,
     /* 195713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 509(*/0xFD, 0x03/*)*/,
     /* 195716 */   GIR_MakeTempReg, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195720 */   GIR_BuildMI, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195725 */   GIR_AddTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195732 */   GIR_AddSimpleTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/,
     /* 195737 */   GIR_AddImm, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 508(*/0xFC, 0x03/*)*/,
     /* 195751 */   GIR_MakeTempReg, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195755 */   GIR_BuildMI, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195760 */   GIR_AddTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195767 */   GIR_AddSimpleTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/,
     /* 195772 */   GIR_AddImm, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 507(*/0xFB, 0x03/*)*/,
     /* 195786 */   GIR_MakeTempReg, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195790 */   GIR_BuildMI, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195795 */   GIR_AddTempRegister, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195802 */   GIR_AddImm, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 506(*/0xFA, 0x03/*)*/,
     /* 195816 */   GIR_MakeTempReg, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195820 */   GIR_BuildMI, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195825 */   GIR_AddTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195832 */   GIR_AddSimpleTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/,
     /* 195837 */   GIR_AddImm, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 505(*/0xF9, 0x03/*)*/,
     /* 195851 */   GIR_MakeTempReg, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195855 */   GIR_BuildMI, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195860 */   GIR_AddTempRegister, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 504(*/0xF8, 0x03/*)*/,
     /* 195870 */   GIR_MakeTempReg, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195874 */   GIR_BuildMI, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195879 */   GIR_AddTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195886 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/,
     /* 195891 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/,
     /* 195896 */   GIR_AddImm8, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Imm*/1,
     /* 195900 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195906 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195912 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195918 */   GIR_MakeTempReg, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195922 */   GIR_BuildMI, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195927 */   GIR_AddTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195934 */   GIR_AddSimpleTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/,
     /* 195939 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/32,
     /* 195943 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/31,
     /* 195947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 502(*/0xF6, 0x03/*)*/,
     /* 195950 */   GIR_MakeTempReg, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195954 */   GIR_BuildMI, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195959 */   GIR_AddTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195966 */   GIR_AddSimpleTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/,
     /* 195971 */   GIR_AddImm, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 501(*/0xF5, 0x03/*)*/,
     /* 195985 */   GIR_MakeTempReg, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195989 */   GIR_BuildMI, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195994 */   GIR_AddTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196001 */   GIR_AddSimpleTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/,
     /* 196006 */   GIR_AddImm, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 500(*/0xF4, 0x03/*)*/,
     /* 196020 */   GIR_MakeTempReg, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196024 */   GIR_BuildMI, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196029 */   GIR_AddTempRegister, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196036 */   GIR_Copy, /*NewInsnID*//* 499(*/0xF3, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 196041 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/1,
     /* 196045 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/62,
     /* 196049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 499(*/0xF3, 0x03/*)*/,
     /* 196052 */   GIR_MakeTempReg, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196056 */   GIR_BuildMI, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196061 */   GIR_AddTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196068 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/,
     /* 196073 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/,
     /* 196078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 498(*/0xF2, 0x03/*)*/,
     /* 196081 */   GIR_MakeTempReg, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196085 */   GIR_BuildMI, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196090 */   GIR_AddTempRegister, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196097 */   GIR_AddImm, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 497(*/0xF1, 0x03/*)*/,
     /* 196111 */   GIR_MakeTempReg, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196115 */   GIR_BuildMI, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196120 */   GIR_AddTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196127 */   GIR_AddSimpleTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/,
     /* 196132 */   GIR_AddImm, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 496(*/0xF0, 0x03/*)*/,
     /* 196146 */   GIR_MakeTempReg, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196150 */   GIR_BuildMI, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196155 */   GIR_AddTempRegister, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 495(*/0xEF, 0x03/*)*/,
     /* 196165 */   GIR_MakeTempReg, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196169 */   GIR_BuildMI, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196174 */   GIR_AddTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196181 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/,
     /* 196186 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/,
     /* 196191 */   GIR_AddImm8, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Imm*/1,
     /* 196195 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196201 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196207 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196213 */   GIR_MakeTempReg, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196217 */   GIR_BuildMI, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196222 */   GIR_AddTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196229 */   GIR_AddSimpleTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/,
     /* 196234 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/32,
     /* 196238 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/31,
     /* 196242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 493(*/0xED, 0x03/*)*/,
     /* 196245 */   GIR_MakeTempReg, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196249 */   GIR_BuildMI, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196254 */   GIR_AddTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196261 */   GIR_AddSimpleTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/,
     /* 196266 */   GIR_AddImm, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 492(*/0xEC, 0x03/*)*/,
     /* 196280 */   GIR_MakeTempReg, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196284 */   GIR_BuildMI, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196289 */   GIR_AddTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196296 */   GIR_AddSimpleTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/,
     /* 196301 */   GIR_AddImm, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 491(*/0xEB, 0x03/*)*/,
     /* 196315 */   GIR_MakeTempReg, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196319 */   GIR_BuildMI, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196324 */   GIR_AddTempRegister, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196331 */   GIR_Copy, /*NewInsnID*//* 490(*/0xEA, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 196336 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/63,
     /* 196340 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/1,
     /* 196344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 490(*/0xEA, 0x03/*)*/,
     /* 196347 */   GIR_MakeTempReg, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196351 */   GIR_BuildMI, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196356 */   GIR_AddTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196363 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/,
     /* 196368 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/,
     /* 196373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 489(*/0xE9, 0x03/*)*/,
     /* 196376 */   GIR_MakeTempReg, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196380 */   GIR_BuildMI, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196385 */   GIR_AddTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196392 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/,
     /* 196397 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/,
     /* 196402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 488(*/0xE8, 0x03/*)*/,
     /* 196405 */   GIR_MakeTempReg, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196409 */   GIR_BuildMI, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196414 */   GIR_AddTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196421 */   GIR_AddSimpleTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/,
     /* 196426 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/62,
     /* 196430 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/2,
     /* 196434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 487(*/0xE7, 0x03/*)*/,
     /* 196437 */   GIR_MakeTempReg, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196441 */   GIR_BuildMI, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196446 */   GIR_AddTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196453 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/,
     /* 196458 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/,
     /* 196463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 486(*/0xE6, 0x03/*)*/,
     /* 196466 */   GIR_MakeTempReg, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196470 */   GIR_BuildMI, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196475 */   GIR_AddTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196482 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/,
     /* 196487 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/,
     /* 196492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 485(*/0xE5, 0x03/*)*/,
     /* 196495 */   GIR_MakeTempReg, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196499 */   GIR_BuildMI, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196504 */   GIR_AddTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196511 */   GIR_AddSimpleTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/,
     /* 196516 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/4,
     /* 196520 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/59,
     /* 196524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 484(*/0xE4, 0x03/*)*/,
     /* 196527 */   GIR_MakeTempReg, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196531 */   GIR_BuildMI, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196536 */   GIR_AddTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196543 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/,
     /* 196548 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/,
     /* 196553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 483(*/0xE3, 0x03/*)*/,
     /* 196556 */   GIR_MakeTempReg, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196560 */   GIR_BuildMI, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196565 */   GIR_AddTempRegister, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196572 */   GIR_AddImm, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 482(*/0xE2, 0x03/*)*/,
     /* 196586 */   GIR_MakeTempReg, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196590 */   GIR_BuildMI, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196595 */   GIR_AddTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196602 */   GIR_AddSimpleTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/,
     /* 196607 */   GIR_AddImm, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 481(*/0xE1, 0x03/*)*/,
     /* 196621 */   GIR_MakeTempReg, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196625 */   GIR_BuildMI, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196630 */   GIR_AddTempRegister, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 480(*/0xE0, 0x03/*)*/,
     /* 196640 */   GIR_MakeTempReg, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196644 */   GIR_BuildMI, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196649 */   GIR_AddTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196656 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/,
     /* 196661 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/,
     /* 196666 */   GIR_AddImm8, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Imm*/1,
     /* 196670 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196676 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196682 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196688 */   GIR_MakeTempReg, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196692 */   GIR_BuildMI, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196697 */   GIR_AddTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196704 */   GIR_AddSimpleTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/,
     /* 196709 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/32,
     /* 196713 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/31,
     /* 196717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 478(*/0xDE, 0x03/*)*/,
     /* 196720 */   GIR_MakeTempReg, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196724 */   GIR_BuildMI, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196729 */   GIR_AddTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196736 */   GIR_AddSimpleTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/,
     /* 196741 */   GIR_AddImm, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 477(*/0xDD, 0x03/*)*/,
     /* 196755 */   GIR_MakeTempReg, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196759 */   GIR_BuildMI, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196764 */   GIR_AddTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196771 */   GIR_AddSimpleTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/,
     /* 196776 */   GIR_AddImm, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 476(*/0xDC, 0x03/*)*/,
     /* 196790 */   GIR_MakeTempReg, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196794 */   GIR_BuildMI, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196799 */   GIR_AddTempRegister, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196806 */   GIR_AddImm, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 475(*/0xDB, 0x03/*)*/,
     /* 196820 */   GIR_MakeTempReg, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196824 */   GIR_BuildMI, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196829 */   GIR_AddTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196836 */   GIR_AddSimpleTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/,
     /* 196841 */   GIR_AddImm, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 474(*/0xDA, 0x03/*)*/,
     /* 196855 */   GIR_MakeTempReg, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196859 */   GIR_BuildMI, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196864 */   GIR_AddTempRegister, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 473(*/0xD9, 0x03/*)*/,
     /* 196874 */   GIR_MakeTempReg, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196878 */   GIR_BuildMI, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196883 */   GIR_AddTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196890 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/,
     /* 196895 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/,
     /* 196900 */   GIR_AddImm8, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Imm*/1,
     /* 196904 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196910 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196916 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196922 */   GIR_MakeTempReg, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196926 */   GIR_BuildMI, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196931 */   GIR_AddTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196938 */   GIR_AddSimpleTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/,
     /* 196943 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/32,
     /* 196947 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/31,
     /* 196951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 471(*/0xD7, 0x03/*)*/,
     /* 196954 */   GIR_MakeTempReg, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196958 */   GIR_BuildMI, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196963 */   GIR_AddTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196970 */   GIR_AddSimpleTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/,
     /* 196975 */   GIR_AddImm, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 470(*/0xD6, 0x03/*)*/,
     /* 196989 */   GIR_MakeTempReg, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196993 */   GIR_BuildMI, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196998 */   GIR_AddTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197005 */   GIR_AddSimpleTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/,
     /* 197010 */   GIR_AddImm, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 469(*/0xD5, 0x03/*)*/,
     /* 197024 */   GIR_MakeTempReg, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197028 */   GIR_BuildMI, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197033 */   GIR_AddTempRegister, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197040 */   GIR_AddImm, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 468(*/0xD4, 0x03/*)*/,
     /* 197054 */   GIR_MakeTempReg, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197058 */   GIR_BuildMI, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197063 */   GIR_AddTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197070 */   GIR_AddSimpleTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/,
     /* 197075 */   GIR_AddImm, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 467(*/0xD3, 0x03/*)*/,
     /* 197089 */   GIR_MakeTempReg, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197093 */   GIR_BuildMI, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197098 */   GIR_AddTempRegister, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 466(*/0xD2, 0x03/*)*/,
     /* 197108 */   GIR_MakeTempReg, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197112 */   GIR_BuildMI, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197117 */   GIR_AddTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197124 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/,
     /* 197129 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/,
     /* 197134 */   GIR_AddImm8, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Imm*/1,
     /* 197138 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197144 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197150 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197156 */   GIR_MakeTempReg, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197160 */   GIR_BuildMI, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197165 */   GIR_AddTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197172 */   GIR_AddSimpleTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/,
     /* 197177 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/32,
     /* 197181 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/31,
     /* 197185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 464(*/0xD0, 0x03/*)*/,
     /* 197188 */   GIR_MakeTempReg, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197192 */   GIR_BuildMI, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197197 */   GIR_AddTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197204 */   GIR_AddSimpleTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/,
     /* 197209 */   GIR_AddImm, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 463(*/0xCF, 0x03/*)*/,
     /* 197223 */   GIR_MakeTempReg, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197227 */   GIR_BuildMI, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197232 */   GIR_AddTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197239 */   GIR_AddSimpleTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/,
     /* 197244 */   GIR_AddImm, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 462(*/0xCE, 0x03/*)*/,
     /* 197258 */   GIR_MakeTempReg, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197262 */   GIR_BuildMI, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197267 */   GIR_AddTempRegister, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197274 */   GIR_Copy, /*NewInsnID*//* 461(*/0xCD, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197279 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/1,
     /* 197283 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/62,
     /* 197287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 461(*/0xCD, 0x03/*)*/,
     /* 197290 */   GIR_MakeTempReg, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197294 */   GIR_BuildMI, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197299 */   GIR_AddTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197306 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/,
     /* 197311 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/,
     /* 197316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 460(*/0xCC, 0x03/*)*/,
     /* 197319 */   GIR_MakeTempReg, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197323 */   GIR_BuildMI, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197328 */   GIR_AddTempRegister, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197335 */   GIR_AddImm, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 459(*/0xCB, 0x03/*)*/,
     /* 197349 */   GIR_MakeTempReg, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197353 */   GIR_BuildMI, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197358 */   GIR_AddTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197365 */   GIR_AddSimpleTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/,
     /* 197370 */   GIR_AddImm, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 458(*/0xCA, 0x03/*)*/,
     /* 197384 */   GIR_MakeTempReg, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197388 */   GIR_BuildMI, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197393 */   GIR_AddTempRegister, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 457(*/0xC9, 0x03/*)*/,
     /* 197403 */   GIR_MakeTempReg, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197407 */   GIR_BuildMI, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197412 */   GIR_AddTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197419 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/,
     /* 197424 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/,
     /* 197429 */   GIR_AddImm8, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Imm*/1,
     /* 197433 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197439 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197445 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197451 */   GIR_MakeTempReg, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197455 */   GIR_BuildMI, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197460 */   GIR_AddTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197467 */   GIR_AddSimpleTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/,
     /* 197472 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/32,
     /* 197476 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/31,
     /* 197480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 455(*/0xC7, 0x03/*)*/,
     /* 197483 */   GIR_MakeTempReg, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197487 */   GIR_BuildMI, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197492 */   GIR_AddTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197499 */   GIR_AddSimpleTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/,
     /* 197504 */   GIR_AddImm, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 454(*/0xC6, 0x03/*)*/,
     /* 197518 */   GIR_MakeTempReg, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197522 */   GIR_BuildMI, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197527 */   GIR_AddTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197534 */   GIR_AddSimpleTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/,
     /* 197539 */   GIR_AddImm, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 453(*/0xC5, 0x03/*)*/,
     /* 197553 */   GIR_MakeTempReg, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197557 */   GIR_BuildMI, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 197562 */   GIR_AddTempRegister, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197569 */   GIR_Copy, /*NewInsnID*//* 452(*/0xC4, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197574 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/63,
     /* 197578 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/1,
     /* 197582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 452(*/0xC4, 0x03/*)*/,
     /* 197585 */   GIR_MakeTempReg, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197589 */   GIR_BuildMI, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197594 */   GIR_AddTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197601 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/,
     /* 197606 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/,
     /* 197611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 451(*/0xC3, 0x03/*)*/,
     /* 197614 */   GIR_MakeTempReg, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197618 */   GIR_BuildMI, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 197623 */   GIR_AddTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197630 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/,
     /* 197635 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/,
     /* 197640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 450(*/0xC2, 0x03/*)*/,
     /* 197643 */   GIR_MakeTempReg, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197647 */   GIR_BuildMI, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197652 */   GIR_AddTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197659 */   GIR_AddSimpleTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/,
     /* 197664 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/2,
     /* 197668 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/61,
     /* 197672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 449(*/0xC1, 0x03/*)*/,
     /* 197675 */   GIR_MakeTempReg, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197679 */   GIR_BuildMI, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197684 */   GIR_AddTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197691 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/,
     /* 197696 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/,
     /* 197701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 448(*/0xC0, 0x03/*)*/,
     /* 197704 */   GIR_MakeTempReg, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197708 */   GIR_BuildMI, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197713 */   GIR_AddTempRegister, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197720 */   GIR_AddImm, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 447(*/0xBF, 0x03/*)*/,
     /* 197734 */   GIR_MakeTempReg, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197738 */   GIR_BuildMI, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197743 */   GIR_AddTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197750 */   GIR_AddSimpleTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/,
     /* 197755 */   GIR_AddImm, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 446(*/0xBE, 0x03/*)*/,
     /* 197769 */   GIR_MakeTempReg, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197773 */   GIR_BuildMI, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197778 */   GIR_AddTempRegister, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 445(*/0xBD, 0x03/*)*/,
     /* 197788 */   GIR_MakeTempReg, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197792 */   GIR_BuildMI, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197797 */   GIR_AddTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197804 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/,
     /* 197809 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/,
     /* 197814 */   GIR_AddImm8, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Imm*/1,
     /* 197818 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197824 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197830 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197836 */   GIR_MakeTempReg, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197840 */   GIR_BuildMI, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197845 */   GIR_AddTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197852 */   GIR_AddSimpleTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/,
     /* 197857 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/32,
     /* 197861 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/31,
     /* 197865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 443(*/0xBB, 0x03/*)*/,
     /* 197868 */   GIR_MakeTempReg, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197872 */   GIR_BuildMI, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197877 */   GIR_AddTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197884 */   GIR_AddSimpleTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/,
     /* 197889 */   GIR_AddImm, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 442(*/0xBA, 0x03/*)*/,
     /* 197903 */   GIR_MakeTempReg, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197907 */   GIR_BuildMI, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197912 */   GIR_AddTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197919 */   GIR_AddSimpleTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/,
     /* 197924 */   GIR_AddImm, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 441(*/0xB9, 0x03/*)*/,
     /* 197938 */   GIR_MakeTempReg, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197942 */   GIR_BuildMI, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197947 */   GIR_AddTempRegister, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197954 */   GIR_AddImm, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 440(*/0xB8, 0x03/*)*/,
     /* 197968 */   GIR_MakeTempReg, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197972 */   GIR_BuildMI, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197977 */   GIR_AddTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197984 */   GIR_AddSimpleTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/,
     /* 197989 */   GIR_AddImm, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 439(*/0xB7, 0x03/*)*/,
     /* 198003 */   GIR_MakeTempReg, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198007 */   GIR_BuildMI, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198012 */   GIR_AddTempRegister, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 438(*/0xB6, 0x03/*)*/,
     /* 198022 */   GIR_MakeTempReg, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198026 */   GIR_BuildMI, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198031 */   GIR_AddTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198038 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/,
     /* 198043 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/,
     /* 198048 */   GIR_AddImm8, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Imm*/1,
     /* 198052 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198058 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198064 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198070 */   GIR_MakeTempReg, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198074 */   GIR_BuildMI, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198079 */   GIR_AddTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198086 */   GIR_AddSimpleTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/,
     /* 198091 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/32,
     /* 198095 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/31,
     /* 198099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 436(*/0xB4, 0x03/*)*/,
     /* 198102 */   GIR_MakeTempReg, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198106 */   GIR_BuildMI, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198111 */   GIR_AddTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198118 */   GIR_AddSimpleTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/,
     /* 198123 */   GIR_AddImm, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 435(*/0xB3, 0x03/*)*/,
     /* 198137 */   GIR_MakeTempReg, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198141 */   GIR_BuildMI, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198146 */   GIR_AddTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198153 */   GIR_AddSimpleTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/,
     /* 198158 */   GIR_AddImm, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 434(*/0xB2, 0x03/*)*/,
     /* 198172 */   GIR_MakeTempReg, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198176 */   GIR_BuildMI, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198181 */   GIR_AddTempRegister, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198188 */   GIR_Copy, /*NewInsnID*//* 433(*/0xB1, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 198193 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/1,
     /* 198197 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/62,
     /* 198201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 433(*/0xB1, 0x03/*)*/,
     /* 198204 */   GIR_MakeTempReg, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198208 */   GIR_BuildMI, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198213 */   GIR_AddTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198220 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/,
     /* 198225 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/,
     /* 198230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 432(*/0xB0, 0x03/*)*/,
     /* 198233 */   GIR_MakeTempReg, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198237 */   GIR_BuildMI, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198242 */   GIR_AddTempRegister, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198249 */   GIR_AddImm, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 431(*/0xAF, 0x03/*)*/,
     /* 198263 */   GIR_MakeTempReg, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198267 */   GIR_BuildMI, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198272 */   GIR_AddTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198279 */   GIR_AddSimpleTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/,
     /* 198284 */   GIR_AddImm, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 430(*/0xAE, 0x03/*)*/,
     /* 198298 */   GIR_MakeTempReg, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198302 */   GIR_BuildMI, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198307 */   GIR_AddTempRegister, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 429(*/0xAD, 0x03/*)*/,
     /* 198317 */   GIR_MakeTempReg, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198321 */   GIR_BuildMI, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198326 */   GIR_AddTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198333 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/,
     /* 198338 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/,
     /* 198343 */   GIR_AddImm8, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Imm*/1,
     /* 198347 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198353 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198359 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198365 */   GIR_MakeTempReg, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198369 */   GIR_BuildMI, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198374 */   GIR_AddTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198381 */   GIR_AddSimpleTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/,
     /* 198386 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/32,
     /* 198390 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/31,
     /* 198394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 427(*/0xAB, 0x03/*)*/,
     /* 198397 */   GIR_MakeTempReg, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198401 */   GIR_BuildMI, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198406 */   GIR_AddTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198413 */   GIR_AddSimpleTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/,
     /* 198418 */   GIR_AddImm, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 426(*/0xAA, 0x03/*)*/,
     /* 198432 */   GIR_MakeTempReg, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198436 */   GIR_BuildMI, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198441 */   GIR_AddTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198448 */   GIR_AddSimpleTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/,
     /* 198453 */   GIR_AddImm, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 425(*/0xA9, 0x03/*)*/,
     /* 198467 */   GIR_MakeTempReg, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198471 */   GIR_BuildMI, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198476 */   GIR_AddTempRegister, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198483 */   GIR_Copy, /*NewInsnID*//* 424(*/0xA8, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 198488 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/63,
     /* 198492 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/1,
     /* 198496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 424(*/0xA8, 0x03/*)*/,
     /* 198499 */   GIR_MakeTempReg, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198503 */   GIR_BuildMI, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198508 */   GIR_AddTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198515 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/,
     /* 198520 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/,
     /* 198525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 423(*/0xA7, 0x03/*)*/,
     /* 198528 */   GIR_MakeTempReg, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198532 */   GIR_BuildMI, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198537 */   GIR_AddTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198544 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/,
     /* 198549 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/,
     /* 198554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 422(*/0xA6, 0x03/*)*/,
     /* 198557 */   GIR_MakeTempReg, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198561 */   GIR_BuildMI, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198566 */   GIR_AddTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198573 */   GIR_AddSimpleTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/,
     /* 198578 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/62,
     /* 198582 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/2,
     /* 198586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 421(*/0xA5, 0x03/*)*/,
     /* 198589 */   GIR_MakeTempReg, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198593 */   GIR_BuildMI, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198598 */   GIR_AddTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198605 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/,
     /* 198610 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/,
     /* 198615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 420(*/0xA4, 0x03/*)*/,
     /* 198618 */   GIR_MakeTempReg, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198622 */   GIR_BuildMI, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198627 */   GIR_AddTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198634 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/,
     /* 198639 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/,
     /* 198644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 419(*/0xA3, 0x03/*)*/,
     /* 198647 */   GIR_MakeTempReg, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198651 */   GIR_BuildMI, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198656 */   GIR_AddTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198663 */   GIR_AddSimpleTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/,
     /* 198668 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/60,
     /* 198672 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/4,
     /* 198676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 418(*/0xA2, 0x03/*)*/,
     /* 198679 */   GIR_MakeTempReg, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198683 */   GIR_BuildMI, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198688 */   GIR_AddTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198695 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/,
     /* 198700 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/,
     /* 198705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 417(*/0xA1, 0x03/*)*/,
     /* 198708 */   GIR_MakeTempReg, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198712 */   GIR_BuildMI, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198717 */   GIR_AddTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198724 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/,
     /* 198729 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/,
     /* 198734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 416(*/0xA0, 0x03/*)*/,
     /* 198737 */   GIR_MakeTempReg, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198741 */   GIR_BuildMI, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198746 */   GIR_AddTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198753 */   GIR_AddSimpleTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/,
     /* 198758 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 198762 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 198766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 415(*/0x9F, 0x03/*)*/,
     /* 198769 */   GIR_MakeTempReg, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 198773 */   GIR_BuildMI, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198778 */   GIR_AddTempRegister, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198785 */   GIR_AddImm, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 198796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 683(*/0xAB, 0x05/*)*/,
     /* 198799 */   GIR_MakeTempReg, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 198803 */   GIR_BuildMI, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198808 */   GIR_AddTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198815 */   GIR_AddSimpleTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/,
     /* 198820 */   GIR_AddImm, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 198831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 682(*/0xAA, 0x05/*)*/,
     /* 198834 */   GIR_MakeTempReg, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198838 */   GIR_BuildMI, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198843 */   GIR_AddTempRegister, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 681(*/0xA9, 0x05/*)*/,
     /* 198853 */   GIR_MakeTempReg, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198857 */   GIR_BuildMI, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198862 */   GIR_AddTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198869 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/,
     /* 198874 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/,
     /* 198879 */   GIR_AddImm8, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Imm*/1,
     /* 198883 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198889 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198895 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198901 */   GIR_MakeTempReg, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198905 */   GIR_BuildMI, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198910 */   GIR_AddTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198917 */   GIR_AddSimpleTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/,
     /* 198922 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/32,
     /* 198926 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/31,
     /* 198930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 679(*/0xA7, 0x05/*)*/,
     /* 198933 */   GIR_MakeTempReg, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198937 */   GIR_BuildMI, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198942 */   GIR_AddTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198949 */   GIR_AddSimpleTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/,
     /* 198954 */   GIR_AddImm, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 198965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 678(*/0xA6, 0x05/*)*/,
     /* 198968 */   GIR_MakeTempReg, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198972 */   GIR_BuildMI, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198977 */   GIR_AddTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198984 */   GIR_AddSimpleTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/,
     /* 198989 */   GIR_AddImm, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 677(*/0xA5, 0x05/*)*/,
     /* 199003 */   GIR_MakeTempReg, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199007 */   GIR_BuildMI, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199012 */   GIR_AddTempRegister, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199019 */   GIR_AddImm, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 676(*/0xA4, 0x05/*)*/,
     /* 199033 */   GIR_MakeTempReg, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199037 */   GIR_BuildMI, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199042 */   GIR_AddTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199049 */   GIR_AddSimpleTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/,
     /* 199054 */   GIR_AddImm, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 675(*/0xA3, 0x05/*)*/,
     /* 199068 */   GIR_MakeTempReg, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199072 */   GIR_BuildMI, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199077 */   GIR_AddTempRegister, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 674(*/0xA2, 0x05/*)*/,
     /* 199087 */   GIR_MakeTempReg, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199091 */   GIR_BuildMI, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199096 */   GIR_AddTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199103 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/,
     /* 199108 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/,
     /* 199113 */   GIR_AddImm8, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Imm*/1,
     /* 199117 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199123 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199129 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199135 */   GIR_MakeTempReg, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199139 */   GIR_BuildMI, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199144 */   GIR_AddTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199151 */   GIR_AddSimpleTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/,
     /* 199156 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/32,
     /* 199160 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/31,
     /* 199164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 672(*/0xA0, 0x05/*)*/,
     /* 199167 */   GIR_MakeTempReg, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199171 */   GIR_BuildMI, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199176 */   GIR_AddTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199183 */   GIR_AddSimpleTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/,
     /* 199188 */   GIR_AddImm, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 671(*/0x9F, 0x05/*)*/,
     /* 199202 */   GIR_MakeTempReg, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199206 */   GIR_BuildMI, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199211 */   GIR_AddTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199218 */   GIR_AddSimpleTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/,
     /* 199223 */   GIR_AddImm, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 670(*/0x9E, 0x05/*)*/,
     /* 199237 */   GIR_MakeTempReg, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199241 */   GIR_BuildMI, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199246 */   GIR_AddTempRegister, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199253 */   GIR_AddImm, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 669(*/0x9D, 0x05/*)*/,
     /* 199267 */   GIR_MakeTempReg, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199271 */   GIR_BuildMI, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199276 */   GIR_AddTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199283 */   GIR_AddSimpleTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/,
     /* 199288 */   GIR_AddImm, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 668(*/0x9C, 0x05/*)*/,
     /* 199302 */   GIR_MakeTempReg, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199306 */   GIR_BuildMI, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199311 */   GIR_AddTempRegister, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 667(*/0x9B, 0x05/*)*/,
     /* 199321 */   GIR_MakeTempReg, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199325 */   GIR_BuildMI, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199330 */   GIR_AddTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199337 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/,
     /* 199342 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/,
     /* 199347 */   GIR_AddImm8, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Imm*/1,
     /* 199351 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199357 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199363 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199369 */   GIR_MakeTempReg, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199373 */   GIR_BuildMI, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199378 */   GIR_AddTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199385 */   GIR_AddSimpleTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/,
     /* 199390 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/32,
     /* 199394 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/31,
     /* 199398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 665(*/0x99, 0x05/*)*/,
     /* 199401 */   GIR_MakeTempReg, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199405 */   GIR_BuildMI, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199410 */   GIR_AddTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199417 */   GIR_AddSimpleTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/,
     /* 199422 */   GIR_AddImm, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 664(*/0x98, 0x05/*)*/,
     /* 199436 */   GIR_MakeTempReg, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199440 */   GIR_BuildMI, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199445 */   GIR_AddTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199452 */   GIR_AddSimpleTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/,
     /* 199457 */   GIR_AddImm, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 663(*/0x97, 0x05/*)*/,
     /* 199471 */   GIR_MakeTempReg, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199475 */   GIR_BuildMI, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199480 */   GIR_AddTempRegister, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199487 */   GIR_Copy, /*NewInsnID*//* 662(*/0x96, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 199492 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/1,
     /* 199496 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/62,
     /* 199500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 662(*/0x96, 0x05/*)*/,
     /* 199503 */   GIR_MakeTempReg, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199507 */   GIR_BuildMI, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199512 */   GIR_AddTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199519 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/,
     /* 199524 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/,
     /* 199529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 661(*/0x95, 0x05/*)*/,
     /* 199532 */   GIR_MakeTempReg, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199536 */   GIR_BuildMI, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199541 */   GIR_AddTempRegister, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199548 */   GIR_AddImm, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 660(*/0x94, 0x05/*)*/,
     /* 199562 */   GIR_MakeTempReg, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199566 */   GIR_BuildMI, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199571 */   GIR_AddTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199578 */   GIR_AddSimpleTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/,
     /* 199583 */   GIR_AddImm, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 659(*/0x93, 0x05/*)*/,
     /* 199597 */   GIR_MakeTempReg, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199601 */   GIR_BuildMI, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199606 */   GIR_AddTempRegister, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 658(*/0x92, 0x05/*)*/,
     /* 199616 */   GIR_MakeTempReg, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199620 */   GIR_BuildMI, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199625 */   GIR_AddTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199632 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/,
     /* 199637 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/,
     /* 199642 */   GIR_AddImm8, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Imm*/1,
     /* 199646 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199652 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199658 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199664 */   GIR_MakeTempReg, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199668 */   GIR_BuildMI, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199673 */   GIR_AddTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199680 */   GIR_AddSimpleTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/,
     /* 199685 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/32,
     /* 199689 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/31,
     /* 199693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 656(*/0x90, 0x05/*)*/,
     /* 199696 */   GIR_MakeTempReg, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199700 */   GIR_BuildMI, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199705 */   GIR_AddTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199712 */   GIR_AddSimpleTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/,
     /* 199717 */   GIR_AddImm, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 655(*/0x8F, 0x05/*)*/,
     /* 199731 */   GIR_MakeTempReg, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199735 */   GIR_BuildMI, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199740 */   GIR_AddTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199747 */   GIR_AddSimpleTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/,
     /* 199752 */   GIR_AddImm, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 654(*/0x8E, 0x05/*)*/,
     /* 199766 */   GIR_MakeTempReg, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199770 */   GIR_BuildMI, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 199775 */   GIR_AddTempRegister, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199782 */   GIR_Copy, /*NewInsnID*//* 653(*/0x8D, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 199787 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/63,
     /* 199791 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/1,
     /* 199795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 653(*/0x8D, 0x05/*)*/,
     /* 199798 */   GIR_MakeTempReg, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199802 */   GIR_BuildMI, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199807 */   GIR_AddTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199814 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/,
     /* 199819 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/,
     /* 199824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 652(*/0x8C, 0x05/*)*/,
     /* 199827 */   GIR_MakeTempReg, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199831 */   GIR_BuildMI, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 199836 */   GIR_AddTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199843 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/,
     /* 199848 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/,
     /* 199853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 651(*/0x8B, 0x05/*)*/,
     /* 199856 */   GIR_MakeTempReg, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199860 */   GIR_BuildMI, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199865 */   GIR_AddTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199872 */   GIR_AddSimpleTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/,
     /* 199877 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/2,
     /* 199881 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/61,
     /* 199885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 650(*/0x8A, 0x05/*)*/,
     /* 199888 */   GIR_MakeTempReg, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199892 */   GIR_BuildMI, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199897 */   GIR_AddTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199904 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/,
     /* 199909 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/,
     /* 199914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 649(*/0x89, 0x05/*)*/,
     /* 199917 */   GIR_MakeTempReg, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199921 */   GIR_BuildMI, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199926 */   GIR_AddTempRegister, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199933 */   GIR_AddImm, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 199944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 648(*/0x88, 0x05/*)*/,
     /* 199947 */   GIR_MakeTempReg, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199951 */   GIR_BuildMI, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199956 */   GIR_AddTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199963 */   GIR_AddSimpleTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/,
     /* 199968 */   GIR_AddImm, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 199979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 647(*/0x87, 0x05/*)*/,
     /* 199982 */   GIR_MakeTempReg, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199986 */   GIR_BuildMI, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199991 */   GIR_AddTempRegister, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 646(*/0x86, 0x05/*)*/,
     /* 200001 */   GIR_MakeTempReg, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200005 */   GIR_BuildMI, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200010 */   GIR_AddTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200017 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/,
     /* 200022 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/,
     /* 200027 */   GIR_AddImm8, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Imm*/1,
     /* 200031 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200037 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200043 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200049 */   GIR_MakeTempReg, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200053 */   GIR_BuildMI, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200058 */   GIR_AddTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200065 */   GIR_AddSimpleTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/,
     /* 200070 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/32,
     /* 200074 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/31,
     /* 200078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 644(*/0x84, 0x05/*)*/,
     /* 200081 */   GIR_MakeTempReg, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200085 */   GIR_BuildMI, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200090 */   GIR_AddTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200097 */   GIR_AddSimpleTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/,
     /* 200102 */   GIR_AddImm, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 643(*/0x83, 0x05/*)*/,
     /* 200116 */   GIR_MakeTempReg, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200120 */   GIR_BuildMI, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200125 */   GIR_AddTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200132 */   GIR_AddSimpleTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/,
     /* 200137 */   GIR_AddImm, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 642(*/0x82, 0x05/*)*/,
     /* 200151 */   GIR_MakeTempReg, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 200155 */   GIR_BuildMI, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200160 */   GIR_AddTempRegister, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200167 */   GIR_AddImm, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 641(*/0x81, 0x05/*)*/,
     /* 200181 */   GIR_MakeTempReg, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200185 */   GIR_BuildMI, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200190 */   GIR_AddTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200197 */   GIR_AddSimpleTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/,
     /* 200202 */   GIR_AddImm, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 640(*/0x80, 0x05/*)*/,
     /* 200216 */   GIR_MakeTempReg, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200220 */   GIR_BuildMI, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200225 */   GIR_AddTempRegister, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 639(*/0xFF, 0x04/*)*/,
     /* 200235 */   GIR_MakeTempReg, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200239 */   GIR_BuildMI, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200244 */   GIR_AddTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200251 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/,
     /* 200256 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/,
     /* 200261 */   GIR_AddImm8, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Imm*/1,
     /* 200265 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200271 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200277 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200283 */   GIR_MakeTempReg, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200287 */   GIR_BuildMI, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200292 */   GIR_AddTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200299 */   GIR_AddSimpleTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/,
     /* 200304 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/32,
     /* 200308 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/31,
     /* 200312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 637(*/0xFD, 0x04/*)*/,
     /* 200315 */   GIR_MakeTempReg, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200319 */   GIR_BuildMI, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200324 */   GIR_AddTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200331 */   GIR_AddSimpleTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/,
     /* 200336 */   GIR_AddImm, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 636(*/0xFC, 0x04/*)*/,
     /* 200350 */   GIR_MakeTempReg, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200354 */   GIR_BuildMI, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200359 */   GIR_AddTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200366 */   GIR_AddSimpleTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/,
     /* 200371 */   GIR_AddImm, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 635(*/0xFB, 0x04/*)*/,
     /* 200385 */   GIR_MakeTempReg, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200389 */   GIR_BuildMI, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200394 */   GIR_AddTempRegister, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200401 */   GIR_Copy, /*NewInsnID*//* 634(*/0xFA, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200406 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/1,
     /* 200410 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/62,
     /* 200414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 634(*/0xFA, 0x04/*)*/,
     /* 200417 */   GIR_MakeTempReg, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200421 */   GIR_BuildMI, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200426 */   GIR_AddTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200433 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/,
     /* 200438 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/,
     /* 200443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 633(*/0xF9, 0x04/*)*/,
     /* 200446 */   GIR_MakeTempReg, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200450 */   GIR_BuildMI, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200455 */   GIR_AddTempRegister, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200462 */   GIR_AddImm, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 632(*/0xF8, 0x04/*)*/,
     /* 200476 */   GIR_MakeTempReg, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200480 */   GIR_BuildMI, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200485 */   GIR_AddTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200492 */   GIR_AddSimpleTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/,
     /* 200497 */   GIR_AddImm, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 631(*/0xF7, 0x04/*)*/,
     /* 200511 */   GIR_MakeTempReg, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200515 */   GIR_BuildMI, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200520 */   GIR_AddTempRegister, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 630(*/0xF6, 0x04/*)*/,
     /* 200530 */   GIR_MakeTempReg, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200534 */   GIR_BuildMI, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200539 */   GIR_AddTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200546 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/,
     /* 200551 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/,
     /* 200556 */   GIR_AddImm8, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Imm*/1,
     /* 200560 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200566 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200572 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200578 */   GIR_MakeTempReg, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200582 */   GIR_BuildMI, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200587 */   GIR_AddTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200594 */   GIR_AddSimpleTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/,
     /* 200599 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/32,
     /* 200603 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/31,
     /* 200607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 628(*/0xF4, 0x04/*)*/,
     /* 200610 */   GIR_MakeTempReg, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200614 */   GIR_BuildMI, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200619 */   GIR_AddTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200626 */   GIR_AddSimpleTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/,
     /* 200631 */   GIR_AddImm, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 627(*/0xF3, 0x04/*)*/,
     /* 200645 */   GIR_MakeTempReg, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200649 */   GIR_BuildMI, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200654 */   GIR_AddTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200661 */   GIR_AddSimpleTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/,
     /* 200666 */   GIR_AddImm, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 626(*/0xF2, 0x04/*)*/,
     /* 200680 */   GIR_MakeTempReg, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200684 */   GIR_BuildMI, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200689 */   GIR_AddTempRegister, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200696 */   GIR_Copy, /*NewInsnID*//* 625(*/0xF1, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200701 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/63,
     /* 200705 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/1,
     /* 200709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 625(*/0xF1, 0x04/*)*/,
     /* 200712 */   GIR_MakeTempReg, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200716 */   GIR_BuildMI, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200721 */   GIR_AddTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200728 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/,
     /* 200733 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/,
     /* 200738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 624(*/0xF0, 0x04/*)*/,
     /* 200741 */   GIR_MakeTempReg, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200745 */   GIR_BuildMI, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 200750 */   GIR_AddTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200757 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/,
     /* 200762 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/,
     /* 200767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 623(*/0xEF, 0x04/*)*/,
     /* 200770 */   GIR_MakeTempReg, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200774 */   GIR_BuildMI, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200779 */   GIR_AddTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200786 */   GIR_AddSimpleTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/,
     /* 200791 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/62,
     /* 200795 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/2,
     /* 200799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 622(*/0xEE, 0x04/*)*/,
     /* 200802 */   GIR_MakeTempReg, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200806 */   GIR_BuildMI, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200811 */   GIR_AddTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200818 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/,
     /* 200823 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/,
     /* 200828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 621(*/0xED, 0x04/*)*/,
     /* 200831 */   GIR_MakeTempReg, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200835 */   GIR_BuildMI, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 200840 */   GIR_AddTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200847 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/,
     /* 200852 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/,
     /* 200857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 620(*/0xEC, 0x04/*)*/,
     /* 200860 */   GIR_MakeTempReg, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200864 */   GIR_BuildMI, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200869 */   GIR_AddTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200876 */   GIR_AddSimpleTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/,
     /* 200881 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/4,
     /* 200885 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/59,
     /* 200889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 619(*/0xEB, 0x04/*)*/,
     /* 200892 */   GIR_MakeTempReg, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200896 */   GIR_BuildMI, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200901 */   GIR_AddTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200908 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/,
     /* 200913 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/,
     /* 200918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 618(*/0xEA, 0x04/*)*/,
     /* 200921 */   GIR_MakeTempReg, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200925 */   GIR_BuildMI, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200930 */   GIR_AddTempRegister, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200937 */   GIR_AddImm, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 200948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 617(*/0xE9, 0x04/*)*/,
     /* 200951 */   GIR_MakeTempReg, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200955 */   GIR_BuildMI, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200960 */   GIR_AddTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200967 */   GIR_AddSimpleTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/,
     /* 200972 */   GIR_AddImm, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 200983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 616(*/0xE8, 0x04/*)*/,
     /* 200986 */   GIR_MakeTempReg, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200990 */   GIR_BuildMI, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200995 */   GIR_AddTempRegister, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 615(*/0xE7, 0x04/*)*/,
     /* 201005 */   GIR_MakeTempReg, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201009 */   GIR_BuildMI, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201014 */   GIR_AddTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201021 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/,
     /* 201026 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/,
     /* 201031 */   GIR_AddImm8, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Imm*/1,
     /* 201035 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201041 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201047 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201053 */   GIR_MakeTempReg, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201057 */   GIR_BuildMI, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201062 */   GIR_AddTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201069 */   GIR_AddSimpleTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/,
     /* 201074 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/32,
     /* 201078 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/31,
     /* 201082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 613(*/0xE5, 0x04/*)*/,
     /* 201085 */   GIR_MakeTempReg, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201089 */   GIR_BuildMI, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201094 */   GIR_AddTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201101 */   GIR_AddSimpleTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/,
     /* 201106 */   GIR_AddImm, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 612(*/0xE4, 0x04/*)*/,
     /* 201120 */   GIR_MakeTempReg, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201124 */   GIR_BuildMI, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201129 */   GIR_AddTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201136 */   GIR_AddSimpleTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/,
     /* 201141 */   GIR_AddImm, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 611(*/0xE3, 0x04/*)*/,
     /* 201155 */   GIR_MakeTempReg, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201159 */   GIR_BuildMI, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201164 */   GIR_AddTempRegister, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201171 */   GIR_AddImm, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 610(*/0xE2, 0x04/*)*/,
     /* 201185 */   GIR_MakeTempReg, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201189 */   GIR_BuildMI, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201194 */   GIR_AddTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201201 */   GIR_AddSimpleTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/,
     /* 201206 */   GIR_AddImm, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 609(*/0xE1, 0x04/*)*/,
     /* 201220 */   GIR_MakeTempReg, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201224 */   GIR_BuildMI, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201229 */   GIR_AddTempRegister, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 608(*/0xE0, 0x04/*)*/,
     /* 201239 */   GIR_MakeTempReg, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201243 */   GIR_BuildMI, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201248 */   GIR_AddTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201255 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/,
     /* 201260 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/,
     /* 201265 */   GIR_AddImm8, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Imm*/1,
     /* 201269 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201275 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201281 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201287 */   GIR_MakeTempReg, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201291 */   GIR_BuildMI, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201296 */   GIR_AddTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201303 */   GIR_AddSimpleTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/,
     /* 201308 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/32,
     /* 201312 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/31,
     /* 201316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 606(*/0xDE, 0x04/*)*/,
     /* 201319 */   GIR_MakeTempReg, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201323 */   GIR_BuildMI, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201328 */   GIR_AddTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201335 */   GIR_AddSimpleTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/,
     /* 201340 */   GIR_AddImm, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 605(*/0xDD, 0x04/*)*/,
     /* 201354 */   GIR_MakeTempReg, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201358 */   GIR_BuildMI, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201363 */   GIR_AddTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201370 */   GIR_AddSimpleTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/,
     /* 201375 */   GIR_AddImm, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 604(*/0xDC, 0x04/*)*/,
     /* 201389 */   GIR_MakeTempReg, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201393 */   GIR_BuildMI, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201398 */   GIR_AddTempRegister, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201405 */   GIR_AddImm, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 603(*/0xDB, 0x04/*)*/,
     /* 201419 */   GIR_MakeTempReg, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201423 */   GIR_BuildMI, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201428 */   GIR_AddTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201435 */   GIR_AddSimpleTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/,
     /* 201440 */   GIR_AddImm, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 602(*/0xDA, 0x04/*)*/,
     /* 201454 */   GIR_MakeTempReg, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201458 */   GIR_BuildMI, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201463 */   GIR_AddTempRegister, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 601(*/0xD9, 0x04/*)*/,
     /* 201473 */   GIR_MakeTempReg, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201477 */   GIR_BuildMI, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201482 */   GIR_AddTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201489 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/,
     /* 201494 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/,
     /* 201499 */   GIR_AddImm8, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Imm*/1,
     /* 201503 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201509 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201515 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201521 */   GIR_MakeTempReg, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201525 */   GIR_BuildMI, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201530 */   GIR_AddTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201537 */   GIR_AddSimpleTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/,
     /* 201542 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/32,
     /* 201546 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/31,
     /* 201550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 599(*/0xD7, 0x04/*)*/,
     /* 201553 */   GIR_MakeTempReg, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201557 */   GIR_BuildMI, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201562 */   GIR_AddTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201569 */   GIR_AddSimpleTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/,
     /* 201574 */   GIR_AddImm, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 598(*/0xD6, 0x04/*)*/,
     /* 201588 */   GIR_MakeTempReg, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201592 */   GIR_BuildMI, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201597 */   GIR_AddTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201604 */   GIR_AddSimpleTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/,
     /* 201609 */   GIR_AddImm, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 597(*/0xD5, 0x04/*)*/,
     /* 201623 */   GIR_MakeTempReg, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201627 */   GIR_BuildMI, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201632 */   GIR_AddTempRegister, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201639 */   GIR_Copy, /*NewInsnID*//* 596(*/0xD4, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201644 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/1,
     /* 201648 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/62,
     /* 201652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 596(*/0xD4, 0x04/*)*/,
     /* 201655 */   GIR_MakeTempReg, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201659 */   GIR_BuildMI, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201664 */   GIR_AddTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201671 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/,
     /* 201676 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/,
     /* 201681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 595(*/0xD3, 0x04/*)*/,
     /* 201684 */   GIR_MakeTempReg, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201688 */   GIR_BuildMI, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201693 */   GIR_AddTempRegister, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201700 */   GIR_AddImm, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 594(*/0xD2, 0x04/*)*/,
     /* 201714 */   GIR_MakeTempReg, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201718 */   GIR_BuildMI, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201723 */   GIR_AddTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201730 */   GIR_AddSimpleTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/,
     /* 201735 */   GIR_AddImm, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 593(*/0xD1, 0x04/*)*/,
     /* 201749 */   GIR_MakeTempReg, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201753 */   GIR_BuildMI, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201758 */   GIR_AddTempRegister, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 592(*/0xD0, 0x04/*)*/,
     /* 201768 */   GIR_MakeTempReg, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201772 */   GIR_BuildMI, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201777 */   GIR_AddTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201784 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/,
     /* 201789 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/,
     /* 201794 */   GIR_AddImm8, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Imm*/1,
     /* 201798 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201804 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201810 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201816 */   GIR_MakeTempReg, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201820 */   GIR_BuildMI, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201825 */   GIR_AddTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201832 */   GIR_AddSimpleTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/,
     /* 201837 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/32,
     /* 201841 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/31,
     /* 201845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 590(*/0xCE, 0x04/*)*/,
     /* 201848 */   GIR_MakeTempReg, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201852 */   GIR_BuildMI, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201857 */   GIR_AddTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201864 */   GIR_AddSimpleTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/,
     /* 201869 */   GIR_AddImm, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 589(*/0xCD, 0x04/*)*/,
     /* 201883 */   GIR_MakeTempReg, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201887 */   GIR_BuildMI, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201892 */   GIR_AddTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201899 */   GIR_AddSimpleTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/,
     /* 201904 */   GIR_AddImm, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 588(*/0xCC, 0x04/*)*/,
     /* 201918 */   GIR_MakeTempReg, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201922 */   GIR_BuildMI, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 201927 */   GIR_AddTempRegister, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201934 */   GIR_Copy, /*NewInsnID*//* 587(*/0xCB, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201939 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/63,
     /* 201943 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/1,
     /* 201947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 587(*/0xCB, 0x04/*)*/,
     /* 201950 */   GIR_MakeTempReg, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201954 */   GIR_BuildMI, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201959 */   GIR_AddTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201966 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/,
     /* 201971 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/,
     /* 201976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 586(*/0xCA, 0x04/*)*/,
     /* 201979 */   GIR_MakeTempReg, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201983 */   GIR_BuildMI, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 201988 */   GIR_AddTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201995 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/,
     /* 202000 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/,
     /* 202005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 585(*/0xC9, 0x04/*)*/,
     /* 202008 */   GIR_MakeTempReg, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202012 */   GIR_BuildMI, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202017 */   GIR_AddTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202024 */   GIR_AddSimpleTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/,
     /* 202029 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/2,
     /* 202033 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/61,
     /* 202037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 584(*/0xC8, 0x04/*)*/,
     /* 202040 */   GIR_MakeTempReg, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202044 */   GIR_BuildMI, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202049 */   GIR_AddTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202056 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/,
     /* 202061 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/,
     /* 202066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 583(*/0xC7, 0x04/*)*/,
     /* 202069 */   GIR_MakeTempReg, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202073 */   GIR_BuildMI, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202078 */   GIR_AddTempRegister, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202085 */   GIR_AddImm, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 582(*/0xC6, 0x04/*)*/,
     /* 202099 */   GIR_MakeTempReg, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202103 */   GIR_BuildMI, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202108 */   GIR_AddTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202115 */   GIR_AddSimpleTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/,
     /* 202120 */   GIR_AddImm, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 581(*/0xC5, 0x04/*)*/,
     /* 202134 */   GIR_MakeTempReg, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202138 */   GIR_BuildMI, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202143 */   GIR_AddTempRegister, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 580(*/0xC4, 0x04/*)*/,
     /* 202153 */   GIR_MakeTempReg, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202157 */   GIR_BuildMI, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202162 */   GIR_AddTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202169 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/,
     /* 202174 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/,
     /* 202179 */   GIR_AddImm8, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Imm*/1,
     /* 202183 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202189 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202195 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202201 */   GIR_MakeTempReg, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202205 */   GIR_BuildMI, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202210 */   GIR_AddTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202217 */   GIR_AddSimpleTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/,
     /* 202222 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/32,
     /* 202226 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/31,
     /* 202230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 578(*/0xC2, 0x04/*)*/,
     /* 202233 */   GIR_MakeTempReg, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202237 */   GIR_BuildMI, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202242 */   GIR_AddTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202249 */   GIR_AddSimpleTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/,
     /* 202254 */   GIR_AddImm, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 577(*/0xC1, 0x04/*)*/,
     /* 202268 */   GIR_MakeTempReg, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202272 */   GIR_BuildMI, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202277 */   GIR_AddTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202284 */   GIR_AddSimpleTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/,
     /* 202289 */   GIR_AddImm, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 576(*/0xC0, 0x04/*)*/,
     /* 202303 */   GIR_MakeTempReg, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202307 */   GIR_BuildMI, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202312 */   GIR_AddTempRegister, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202319 */   GIR_AddImm, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 575(*/0xBF, 0x04/*)*/,
     /* 202333 */   GIR_MakeTempReg, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202337 */   GIR_BuildMI, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202342 */   GIR_AddTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202349 */   GIR_AddSimpleTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/,
     /* 202354 */   GIR_AddImm, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 574(*/0xBE, 0x04/*)*/,
     /* 202368 */   GIR_MakeTempReg, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202372 */   GIR_BuildMI, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202377 */   GIR_AddTempRegister, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 573(*/0xBD, 0x04/*)*/,
     /* 202387 */   GIR_MakeTempReg, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202391 */   GIR_BuildMI, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202396 */   GIR_AddTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202403 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/,
     /* 202408 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/,
     /* 202413 */   GIR_AddImm8, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Imm*/1,
     /* 202417 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202423 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202429 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202435 */   GIR_MakeTempReg, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202439 */   GIR_BuildMI, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202444 */   GIR_AddTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202451 */   GIR_AddSimpleTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/,
     /* 202456 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/32,
     /* 202460 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/31,
     /* 202464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 571(*/0xBB, 0x04/*)*/,
     /* 202467 */   GIR_MakeTempReg, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202471 */   GIR_BuildMI, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202476 */   GIR_AddTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202483 */   GIR_AddSimpleTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/,
     /* 202488 */   GIR_AddImm, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 570(*/0xBA, 0x04/*)*/,
     /* 202502 */   GIR_MakeTempReg, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202506 */   GIR_BuildMI, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202511 */   GIR_AddTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202518 */   GIR_AddSimpleTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/,
     /* 202523 */   GIR_AddImm, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 569(*/0xB9, 0x04/*)*/,
     /* 202537 */   GIR_MakeTempReg, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202541 */   GIR_BuildMI, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202546 */   GIR_AddTempRegister, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202553 */   GIR_Copy, /*NewInsnID*//* 568(*/0xB8, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202558 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/1,
     /* 202562 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/62,
     /* 202566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 568(*/0xB8, 0x04/*)*/,
     /* 202569 */   GIR_MakeTempReg, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202573 */   GIR_BuildMI, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202578 */   GIR_AddTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202585 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/,
     /* 202590 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/,
     /* 202595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 567(*/0xB7, 0x04/*)*/,
     /* 202598 */   GIR_MakeTempReg, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202602 */   GIR_BuildMI, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202607 */   GIR_AddTempRegister, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202614 */   GIR_AddImm, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 566(*/0xB6, 0x04/*)*/,
     /* 202628 */   GIR_MakeTempReg, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202632 */   GIR_BuildMI, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202637 */   GIR_AddTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202644 */   GIR_AddSimpleTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/,
     /* 202649 */   GIR_AddImm, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 565(*/0xB5, 0x04/*)*/,
     /* 202663 */   GIR_MakeTempReg, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202667 */   GIR_BuildMI, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202672 */   GIR_AddTempRegister, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 564(*/0xB4, 0x04/*)*/,
     /* 202682 */   GIR_MakeTempReg, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202686 */   GIR_BuildMI, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202691 */   GIR_AddTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202698 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/,
     /* 202703 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/,
     /* 202708 */   GIR_AddImm8, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Imm*/1,
     /* 202712 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202718 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202724 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202730 */   GIR_MakeTempReg, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202734 */   GIR_BuildMI, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202739 */   GIR_AddTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202746 */   GIR_AddSimpleTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/,
     /* 202751 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/32,
     /* 202755 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/31,
     /* 202759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 562(*/0xB2, 0x04/*)*/,
     /* 202762 */   GIR_MakeTempReg, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202766 */   GIR_BuildMI, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202771 */   GIR_AddTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202778 */   GIR_AddSimpleTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/,
     /* 202783 */   GIR_AddImm, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 561(*/0xB1, 0x04/*)*/,
     /* 202797 */   GIR_MakeTempReg, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202801 */   GIR_BuildMI, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202806 */   GIR_AddTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202813 */   GIR_AddSimpleTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/,
     /* 202818 */   GIR_AddImm, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 560(*/0xB0, 0x04/*)*/,
     /* 202832 */   GIR_MakeTempReg, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202836 */   GIR_BuildMI, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 202841 */   GIR_AddTempRegister, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202848 */   GIR_Copy, /*NewInsnID*//* 559(*/0xAF, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202853 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/63,
     /* 202857 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/1,
     /* 202861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 559(*/0xAF, 0x04/*)*/,
     /* 202864 */   GIR_MakeTempReg, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202868 */   GIR_BuildMI, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202873 */   GIR_AddTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202880 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/,
     /* 202885 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/,
     /* 202890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 558(*/0xAE, 0x04/*)*/,
     /* 202893 */   GIR_MakeTempReg, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202897 */   GIR_BuildMI, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 202902 */   GIR_AddTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202909 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/,
     /* 202914 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/,
     /* 202919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 557(*/0xAD, 0x04/*)*/,
     /* 202922 */   GIR_MakeTempReg, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202926 */   GIR_BuildMI, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 202931 */   GIR_AddTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202938 */   GIR_AddSimpleTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/,
     /* 202943 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/62,
     /* 202947 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/2,
     /* 202951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 556(*/0xAC, 0x04/*)*/,
     /* 202954 */   GIR_MakeTempReg, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202958 */   GIR_BuildMI, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202963 */   GIR_AddTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202970 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/,
     /* 202975 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/,
     /* 202980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 555(*/0xAB, 0x04/*)*/,
     /* 202983 */   GIR_MakeTempReg, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202987 */   GIR_BuildMI, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 202992 */   GIR_AddTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202999 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/,
     /* 203004 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/,
     /* 203009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 554(*/0xAA, 0x04/*)*/,
     /* 203012 */   GIR_MakeTempReg, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203016 */   GIR_BuildMI, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203021 */   GIR_AddTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203028 */   GIR_AddSimpleTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/,
     /* 203033 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/60,
     /* 203037 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/4,
     /* 203041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 553(*/0xA9, 0x04/*)*/,
     /* 203044 */   GIR_MakeTempReg, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203048 */   GIR_BuildMI, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203053 */   GIR_AddTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203060 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/,
     /* 203065 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/,
     /* 203070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 552(*/0xA8, 0x04/*)*/,
     /* 203073 */   GIR_MakeTempReg, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203077 */   GIR_BuildMI, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203082 */   GIR_AddTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203089 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/,
     /* 203094 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/,
     /* 203099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 551(*/0xA7, 0x04/*)*/,
     /* 203102 */   GIR_MakeTempReg, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203106 */   GIR_BuildMI, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203111 */   GIR_AddTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203118 */   GIR_AddSimpleTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/,
     /* 203123 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 203127 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 203131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 550(*/0xA6, 0x04/*)*/,
     /* 203134 */   GIR_MakeTempReg, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203138 */   GIR_BuildMI, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203143 */   GIR_AddTempRegister, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203150 */   GIR_AddImm, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 818(*/0xB2, 0x06/*)*/,
     /* 203164 */   GIR_MakeTempReg, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203168 */   GIR_BuildMI, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203173 */   GIR_AddTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203180 */   GIR_AddSimpleTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/,
     /* 203185 */   GIR_AddImm, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 817(*/0xB1, 0x06/*)*/,
     /* 203199 */   GIR_MakeTempReg, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203203 */   GIR_BuildMI, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203208 */   GIR_AddTempRegister, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 816(*/0xB0, 0x06/*)*/,
     /* 203218 */   GIR_MakeTempReg, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203222 */   GIR_BuildMI, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203227 */   GIR_AddTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203234 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/,
     /* 203239 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/,
     /* 203244 */   GIR_AddImm8, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Imm*/1,
     /* 203248 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203254 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203260 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203266 */   GIR_MakeTempReg, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203270 */   GIR_BuildMI, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203275 */   GIR_AddTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203282 */   GIR_AddSimpleTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/,
     /* 203287 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/32,
     /* 203291 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/31,
     /* 203295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 814(*/0xAE, 0x06/*)*/,
     /* 203298 */   GIR_MakeTempReg, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203302 */   GIR_BuildMI, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203307 */   GIR_AddTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203314 */   GIR_AddSimpleTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/,
     /* 203319 */   GIR_AddImm, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 813(*/0xAD, 0x06/*)*/,
     /* 203333 */   GIR_MakeTempReg, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203337 */   GIR_BuildMI, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203342 */   GIR_AddTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203349 */   GIR_AddSimpleTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/,
     /* 203354 */   GIR_AddImm, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 812(*/0xAC, 0x06/*)*/,
     /* 203368 */   GIR_MakeTempReg, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203372 */   GIR_BuildMI, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203377 */   GIR_AddTempRegister, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203384 */   GIR_AddImm, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 811(*/0xAB, 0x06/*)*/,
     /* 203398 */   GIR_MakeTempReg, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203402 */   GIR_BuildMI, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203407 */   GIR_AddTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203414 */   GIR_AddSimpleTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/,
     /* 203419 */   GIR_AddImm, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 810(*/0xAA, 0x06/*)*/,
     /* 203433 */   GIR_MakeTempReg, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203437 */   GIR_BuildMI, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203442 */   GIR_AddTempRegister, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 809(*/0xA9, 0x06/*)*/,
     /* 203452 */   GIR_MakeTempReg, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203456 */   GIR_BuildMI, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203461 */   GIR_AddTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203468 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/,
     /* 203473 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/,
     /* 203478 */   GIR_AddImm8, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Imm*/1,
     /* 203482 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203488 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203494 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203500 */   GIR_MakeTempReg, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203504 */   GIR_BuildMI, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203509 */   GIR_AddTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203516 */   GIR_AddSimpleTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/,
     /* 203521 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/32,
     /* 203525 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/31,
     /* 203529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 807(*/0xA7, 0x06/*)*/,
     /* 203532 */   GIR_MakeTempReg, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203536 */   GIR_BuildMI, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203541 */   GIR_AddTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203548 */   GIR_AddSimpleTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/,
     /* 203553 */   GIR_AddImm, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 806(*/0xA6, 0x06/*)*/,
     /* 203567 */   GIR_MakeTempReg, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203571 */   GIR_BuildMI, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203576 */   GIR_AddTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203583 */   GIR_AddSimpleTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/,
     /* 203588 */   GIR_AddImm, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 805(*/0xA5, 0x06/*)*/,
     /* 203602 */   GIR_MakeTempReg, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203606 */   GIR_BuildMI, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203611 */   GIR_AddTempRegister, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203618 */   GIR_AddImm, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 804(*/0xA4, 0x06/*)*/,
     /* 203632 */   GIR_MakeTempReg, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203636 */   GIR_BuildMI, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203641 */   GIR_AddTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203648 */   GIR_AddSimpleTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/,
     /* 203653 */   GIR_AddImm, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 803(*/0xA3, 0x06/*)*/,
     /* 203667 */   GIR_MakeTempReg, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203671 */   GIR_BuildMI, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203676 */   GIR_AddTempRegister, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 802(*/0xA2, 0x06/*)*/,
     /* 203686 */   GIR_MakeTempReg, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203690 */   GIR_BuildMI, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203695 */   GIR_AddTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203702 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/,
     /* 203707 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/,
     /* 203712 */   GIR_AddImm8, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Imm*/1,
     /* 203716 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203722 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203728 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203734 */   GIR_MakeTempReg, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203738 */   GIR_BuildMI, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203743 */   GIR_AddTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203750 */   GIR_AddSimpleTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/,
     /* 203755 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/32,
     /* 203759 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/31,
     /* 203763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 800(*/0xA0, 0x06/*)*/,
     /* 203766 */   GIR_MakeTempReg, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203770 */   GIR_BuildMI, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203775 */   GIR_AddTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203782 */   GIR_AddSimpleTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/,
     /* 203787 */   GIR_AddImm, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 799(*/0x9F, 0x06/*)*/,
     /* 203801 */   GIR_MakeTempReg, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203805 */   GIR_BuildMI, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203810 */   GIR_AddTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203817 */   GIR_AddSimpleTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/,
     /* 203822 */   GIR_AddImm, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 798(*/0x9E, 0x06/*)*/,
     /* 203836 */   GIR_MakeTempReg, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203840 */   GIR_BuildMI, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203845 */   GIR_AddTempRegister, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203852 */   GIR_Copy, /*NewInsnID*//* 797(*/0x9D, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 203857 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/1,
     /* 203861 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/62,
     /* 203865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 797(*/0x9D, 0x06/*)*/,
     /* 203868 */   GIR_MakeTempReg, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203872 */   GIR_BuildMI, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203877 */   GIR_AddTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203884 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/,
     /* 203889 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/,
     /* 203894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 796(*/0x9C, 0x06/*)*/,
     /* 203897 */   GIR_MakeTempReg, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203901 */   GIR_BuildMI, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203906 */   GIR_AddTempRegister, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203913 */   GIR_AddImm, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 795(*/0x9B, 0x06/*)*/,
     /* 203927 */   GIR_MakeTempReg, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203931 */   GIR_BuildMI, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203936 */   GIR_AddTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203943 */   GIR_AddSimpleTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/,
     /* 203948 */   GIR_AddImm, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 794(*/0x9A, 0x06/*)*/,
     /* 203962 */   GIR_MakeTempReg, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203966 */   GIR_BuildMI, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203971 */   GIR_AddTempRegister, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 793(*/0x99, 0x06/*)*/,
     /* 203981 */   GIR_MakeTempReg, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203985 */   GIR_BuildMI, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203990 */   GIR_AddTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203997 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/,
     /* 204002 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/,
     /* 204007 */   GIR_AddImm8, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Imm*/1,
     /* 204011 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204017 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204023 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204029 */   GIR_MakeTempReg, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204033 */   GIR_BuildMI, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204038 */   GIR_AddTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204045 */   GIR_AddSimpleTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/,
     /* 204050 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/32,
     /* 204054 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/31,
     /* 204058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 791(*/0x97, 0x06/*)*/,
     /* 204061 */   GIR_MakeTempReg, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204065 */   GIR_BuildMI, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204070 */   GIR_AddTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204077 */   GIR_AddSimpleTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/,
     /* 204082 */   GIR_AddImm, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 790(*/0x96, 0x06/*)*/,
     /* 204096 */   GIR_MakeTempReg, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204100 */   GIR_BuildMI, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204105 */   GIR_AddTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204112 */   GIR_AddSimpleTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/,
     /* 204117 */   GIR_AddImm, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 789(*/0x95, 0x06/*)*/,
     /* 204131 */   GIR_MakeTempReg, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204135 */   GIR_BuildMI, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 204140 */   GIR_AddTempRegister, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204147 */   GIR_Copy, /*NewInsnID*//* 788(*/0x94, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204152 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/63,
     /* 204156 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/1,
     /* 204160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 788(*/0x94, 0x06/*)*/,
     /* 204163 */   GIR_MakeTempReg, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204167 */   GIR_BuildMI, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204172 */   GIR_AddTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204179 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/,
     /* 204184 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/,
     /* 204189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 787(*/0x93, 0x06/*)*/,
     /* 204192 */   GIR_MakeTempReg, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204196 */   GIR_BuildMI, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 204201 */   GIR_AddTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204208 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/,
     /* 204213 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/,
     /* 204218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 786(*/0x92, 0x06/*)*/,
     /* 204221 */   GIR_MakeTempReg, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204225 */   GIR_BuildMI, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204230 */   GIR_AddTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204237 */   GIR_AddSimpleTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/,
     /* 204242 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/2,
     /* 204246 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/61,
     /* 204250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 785(*/0x91, 0x06/*)*/,
     /* 204253 */   GIR_MakeTempReg, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204257 */   GIR_BuildMI, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204262 */   GIR_AddTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204269 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/,
     /* 204274 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/,
     /* 204279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 784(*/0x90, 0x06/*)*/,
     /* 204282 */   GIR_MakeTempReg, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204286 */   GIR_BuildMI, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204291 */   GIR_AddTempRegister, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204298 */   GIR_AddImm, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 783(*/0x8F, 0x06/*)*/,
     /* 204312 */   GIR_MakeTempReg, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204316 */   GIR_BuildMI, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204321 */   GIR_AddTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204328 */   GIR_AddSimpleTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/,
     /* 204333 */   GIR_AddImm, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 782(*/0x8E, 0x06/*)*/,
     /* 204347 */   GIR_MakeTempReg, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204351 */   GIR_BuildMI, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204356 */   GIR_AddTempRegister, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 781(*/0x8D, 0x06/*)*/,
     /* 204366 */   GIR_MakeTempReg, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204370 */   GIR_BuildMI, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204375 */   GIR_AddTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204382 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/,
     /* 204387 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/,
     /* 204392 */   GIR_AddImm8, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Imm*/1,
     /* 204396 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204402 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204408 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204414 */   GIR_MakeTempReg, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204418 */   GIR_BuildMI, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204423 */   GIR_AddTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204430 */   GIR_AddSimpleTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/,
     /* 204435 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/32,
     /* 204439 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/31,
     /* 204443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 779(*/0x8B, 0x06/*)*/,
     /* 204446 */   GIR_MakeTempReg, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204450 */   GIR_BuildMI, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204455 */   GIR_AddTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204462 */   GIR_AddSimpleTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/,
     /* 204467 */   GIR_AddImm, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 778(*/0x8A, 0x06/*)*/,
     /* 204481 */   GIR_MakeTempReg, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204485 */   GIR_BuildMI, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204490 */   GIR_AddTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204497 */   GIR_AddSimpleTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/,
     /* 204502 */   GIR_AddImm, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 777(*/0x89, 0x06/*)*/,
     /* 204516 */   GIR_MakeTempReg, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204520 */   GIR_BuildMI, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204525 */   GIR_AddTempRegister, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204532 */   GIR_AddImm, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 776(*/0x88, 0x06/*)*/,
     /* 204546 */   GIR_MakeTempReg, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204550 */   GIR_BuildMI, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204555 */   GIR_AddTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204562 */   GIR_AddSimpleTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/,
     /* 204567 */   GIR_AddImm, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 775(*/0x87, 0x06/*)*/,
     /* 204581 */   GIR_MakeTempReg, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204585 */   GIR_BuildMI, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204590 */   GIR_AddTempRegister, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 774(*/0x86, 0x06/*)*/,
     /* 204600 */   GIR_MakeTempReg, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204604 */   GIR_BuildMI, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204609 */   GIR_AddTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204616 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/,
     /* 204621 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/,
     /* 204626 */   GIR_AddImm8, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Imm*/1,
     /* 204630 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204636 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204642 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204648 */   GIR_MakeTempReg, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204652 */   GIR_BuildMI, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204657 */   GIR_AddTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204664 */   GIR_AddSimpleTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/,
     /* 204669 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/32,
     /* 204673 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/31,
     /* 204677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 772(*/0x84, 0x06/*)*/,
     /* 204680 */   GIR_MakeTempReg, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204684 */   GIR_BuildMI, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204689 */   GIR_AddTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204696 */   GIR_AddSimpleTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/,
     /* 204701 */   GIR_AddImm, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 771(*/0x83, 0x06/*)*/,
     /* 204715 */   GIR_MakeTempReg, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204719 */   GIR_BuildMI, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204724 */   GIR_AddTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204731 */   GIR_AddSimpleTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/,
     /* 204736 */   GIR_AddImm, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 770(*/0x82, 0x06/*)*/,
     /* 204750 */   GIR_MakeTempReg, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204754 */   GIR_BuildMI, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204759 */   GIR_AddTempRegister, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204766 */   GIR_Copy, /*NewInsnID*//* 769(*/0x81, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204771 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/1,
     /* 204775 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/62,
     /* 204779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 769(*/0x81, 0x06/*)*/,
     /* 204782 */   GIR_MakeTempReg, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204786 */   GIR_BuildMI, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204791 */   GIR_AddTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204798 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/,
     /* 204803 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/,
     /* 204808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 768(*/0x80, 0x06/*)*/,
     /* 204811 */   GIR_MakeTempReg, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204815 */   GIR_BuildMI, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204820 */   GIR_AddTempRegister, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204827 */   GIR_AddImm, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 767(*/0xFF, 0x05/*)*/,
     /* 204841 */   GIR_MakeTempReg, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204845 */   GIR_BuildMI, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204850 */   GIR_AddTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204857 */   GIR_AddSimpleTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/,
     /* 204862 */   GIR_AddImm, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 766(*/0xFE, 0x05/*)*/,
     /* 204876 */   GIR_MakeTempReg, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204880 */   GIR_BuildMI, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204885 */   GIR_AddTempRegister, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 765(*/0xFD, 0x05/*)*/,
     /* 204895 */   GIR_MakeTempReg, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204899 */   GIR_BuildMI, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204904 */   GIR_AddTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204911 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/,
     /* 204916 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/,
     /* 204921 */   GIR_AddImm8, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Imm*/1,
     /* 204925 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204931 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204937 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204943 */   GIR_MakeTempReg, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204947 */   GIR_BuildMI, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204952 */   GIR_AddTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204959 */   GIR_AddSimpleTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/,
     /* 204964 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/32,
     /* 204968 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/31,
     /* 204972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 763(*/0xFB, 0x05/*)*/,
     /* 204975 */   GIR_MakeTempReg, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204979 */   GIR_BuildMI, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204984 */   GIR_AddTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204991 */   GIR_AddSimpleTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/,
     /* 204996 */   GIR_AddImm, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 762(*/0xFA, 0x05/*)*/,
     /* 205010 */   GIR_MakeTempReg, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205014 */   GIR_BuildMI, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205019 */   GIR_AddTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205026 */   GIR_AddSimpleTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/,
     /* 205031 */   GIR_AddImm, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 761(*/0xF9, 0x05/*)*/,
     /* 205045 */   GIR_MakeTempReg, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205049 */   GIR_BuildMI, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 205054 */   GIR_AddTempRegister, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205061 */   GIR_Copy, /*NewInsnID*//* 760(*/0xF8, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 205066 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/63,
     /* 205070 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/1,
     /* 205074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 760(*/0xF8, 0x05/*)*/,
     /* 205077 */   GIR_MakeTempReg, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205081 */   GIR_BuildMI, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205086 */   GIR_AddTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205093 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/,
     /* 205098 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/,
     /* 205103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 759(*/0xF7, 0x05/*)*/,
     /* 205106 */   GIR_MakeTempReg, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205110 */   GIR_BuildMI, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205115 */   GIR_AddTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205122 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/,
     /* 205127 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/,
     /* 205132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 758(*/0xF6, 0x05/*)*/,
     /* 205135 */   GIR_MakeTempReg, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205139 */   GIR_BuildMI, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 205144 */   GIR_AddTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205151 */   GIR_AddSimpleTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/,
     /* 205156 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/62,
     /* 205160 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/2,
     /* 205164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 757(*/0xF5, 0x05/*)*/,
     /* 205167 */   GIR_MakeTempReg, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205171 */   GIR_BuildMI, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205176 */   GIR_AddTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205183 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/,
     /* 205188 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/,
     /* 205193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 756(*/0xF4, 0x05/*)*/,
     /* 205196 */   GIR_MakeTempReg, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205200 */   GIR_BuildMI, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205205 */   GIR_AddTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205212 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/,
     /* 205217 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/,
     /* 205222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 755(*/0xF3, 0x05/*)*/,
     /* 205225 */   GIR_MakeTempReg, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205229 */   GIR_BuildMI, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205234 */   GIR_AddTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205241 */   GIR_AddSimpleTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/,
     /* 205246 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/4,
     /* 205250 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/59,
     /* 205254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 754(*/0xF2, 0x05/*)*/,
     /* 205257 */   GIR_MakeTempReg, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205261 */   GIR_BuildMI, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205266 */   GIR_AddTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205273 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/,
     /* 205278 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/,
     /* 205283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 753(*/0xF1, 0x05/*)*/,
     /* 205286 */   GIR_MakeTempReg, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205290 */   GIR_BuildMI, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205295 */   GIR_AddTempRegister, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205302 */   GIR_AddImm, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 752(*/0xF0, 0x05/*)*/,
     /* 205316 */   GIR_MakeTempReg, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205320 */   GIR_BuildMI, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205325 */   GIR_AddTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205332 */   GIR_AddSimpleTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/,
     /* 205337 */   GIR_AddImm, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 751(*/0xEF, 0x05/*)*/,
     /* 205351 */   GIR_MakeTempReg, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205355 */   GIR_BuildMI, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205360 */   GIR_AddTempRegister, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 750(*/0xEE, 0x05/*)*/,
     /* 205370 */   GIR_MakeTempReg, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205374 */   GIR_BuildMI, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205379 */   GIR_AddTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205386 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/,
     /* 205391 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/,
     /* 205396 */   GIR_AddImm8, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Imm*/1,
     /* 205400 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205406 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205412 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205418 */   GIR_MakeTempReg, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205422 */   GIR_BuildMI, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205427 */   GIR_AddTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205434 */   GIR_AddSimpleTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/,
     /* 205439 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/32,
     /* 205443 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/31,
     /* 205447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 748(*/0xEC, 0x05/*)*/,
     /* 205450 */   GIR_MakeTempReg, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205454 */   GIR_BuildMI, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205459 */   GIR_AddTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205466 */   GIR_AddSimpleTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/,
     /* 205471 */   GIR_AddImm, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 747(*/0xEB, 0x05/*)*/,
     /* 205485 */   GIR_MakeTempReg, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205489 */   GIR_BuildMI, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205494 */   GIR_AddTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205501 */   GIR_AddSimpleTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/,
     /* 205506 */   GIR_AddImm, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 746(*/0xEA, 0x05/*)*/,
     /* 205520 */   GIR_MakeTempReg, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205524 */   GIR_BuildMI, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205529 */   GIR_AddTempRegister, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205536 */   GIR_AddImm, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 745(*/0xE9, 0x05/*)*/,
     /* 205550 */   GIR_MakeTempReg, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205554 */   GIR_BuildMI, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205559 */   GIR_AddTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205566 */   GIR_AddSimpleTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/,
     /* 205571 */   GIR_AddImm, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 744(*/0xE8, 0x05/*)*/,
     /* 205585 */   GIR_MakeTempReg, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205589 */   GIR_BuildMI, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205594 */   GIR_AddTempRegister, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 743(*/0xE7, 0x05/*)*/,
     /* 205604 */   GIR_MakeTempReg, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205608 */   GIR_BuildMI, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205613 */   GIR_AddTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205620 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/,
     /* 205625 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/,
     /* 205630 */   GIR_AddImm8, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Imm*/1,
     /* 205634 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205640 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205646 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205652 */   GIR_MakeTempReg, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205656 */   GIR_BuildMI, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205661 */   GIR_AddTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205668 */   GIR_AddSimpleTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/,
     /* 205673 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/32,
     /* 205677 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/31,
     /* 205681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 741(*/0xE5, 0x05/*)*/,
     /* 205684 */   GIR_MakeTempReg, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205688 */   GIR_BuildMI, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205693 */   GIR_AddTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205700 */   GIR_AddSimpleTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/,
     /* 205705 */   GIR_AddImm, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 740(*/0xE4, 0x05/*)*/,
     /* 205719 */   GIR_MakeTempReg, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205723 */   GIR_BuildMI, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205728 */   GIR_AddTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205735 */   GIR_AddSimpleTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/,
     /* 205740 */   GIR_AddImm, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 739(*/0xE3, 0x05/*)*/,
     /* 205754 */   GIR_MakeTempReg, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205758 */   GIR_BuildMI, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205763 */   GIR_AddTempRegister, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205770 */   GIR_AddImm, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 738(*/0xE2, 0x05/*)*/,
     /* 205784 */   GIR_MakeTempReg, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205788 */   GIR_BuildMI, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205793 */   GIR_AddTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205800 */   GIR_AddSimpleTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/,
     /* 205805 */   GIR_AddImm, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 737(*/0xE1, 0x05/*)*/,
     /* 205819 */   GIR_MakeTempReg, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205823 */   GIR_BuildMI, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205828 */   GIR_AddTempRegister, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 736(*/0xE0, 0x05/*)*/,
     /* 205838 */   GIR_MakeTempReg, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205842 */   GIR_BuildMI, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205847 */   GIR_AddTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205854 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/,
     /* 205859 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/,
     /* 205864 */   GIR_AddImm8, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Imm*/1,
     /* 205868 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205874 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205880 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205886 */   GIR_MakeTempReg, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205890 */   GIR_BuildMI, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205895 */   GIR_AddTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205902 */   GIR_AddSimpleTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/,
     /* 205907 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/32,
     /* 205911 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/31,
     /* 205915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 734(*/0xDE, 0x05/*)*/,
     /* 205918 */   GIR_MakeTempReg, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205922 */   GIR_BuildMI, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205927 */   GIR_AddTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205934 */   GIR_AddSimpleTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/,
     /* 205939 */   GIR_AddImm, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 733(*/0xDD, 0x05/*)*/,
     /* 205953 */   GIR_MakeTempReg, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205957 */   GIR_BuildMI, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205962 */   GIR_AddTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205969 */   GIR_AddSimpleTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/,
     /* 205974 */   GIR_AddImm, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 732(*/0xDC, 0x05/*)*/,
     /* 205988 */   GIR_MakeTempReg, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205992 */   GIR_BuildMI, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205997 */   GIR_AddTempRegister, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206004 */   GIR_Copy, /*NewInsnID*//* 731(*/0xDB, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206009 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/1,
     /* 206013 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/62,
     /* 206017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 731(*/0xDB, 0x05/*)*/,
     /* 206020 */   GIR_MakeTempReg, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206024 */   GIR_BuildMI, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206029 */   GIR_AddTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206036 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/,
     /* 206041 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/,
     /* 206046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 730(*/0xDA, 0x05/*)*/,
     /* 206049 */   GIR_MakeTempReg, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206053 */   GIR_BuildMI, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206058 */   GIR_AddTempRegister, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206065 */   GIR_AddImm, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 729(*/0xD9, 0x05/*)*/,
     /* 206079 */   GIR_MakeTempReg, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206083 */   GIR_BuildMI, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206088 */   GIR_AddTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206095 */   GIR_AddSimpleTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/,
     /* 206100 */   GIR_AddImm, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 728(*/0xD8, 0x05/*)*/,
     /* 206114 */   GIR_MakeTempReg, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206118 */   GIR_BuildMI, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206123 */   GIR_AddTempRegister, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 727(*/0xD7, 0x05/*)*/,
     /* 206133 */   GIR_MakeTempReg, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206137 */   GIR_BuildMI, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206142 */   GIR_AddTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206149 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/,
     /* 206154 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/,
     /* 206159 */   GIR_AddImm8, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Imm*/1,
     /* 206163 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206169 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206175 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206181 */   GIR_MakeTempReg, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206185 */   GIR_BuildMI, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206190 */   GIR_AddTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206197 */   GIR_AddSimpleTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/,
     /* 206202 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/32,
     /* 206206 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/31,
     /* 206210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 725(*/0xD5, 0x05/*)*/,
     /* 206213 */   GIR_MakeTempReg, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206217 */   GIR_BuildMI, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206222 */   GIR_AddTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206229 */   GIR_AddSimpleTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/,
     /* 206234 */   GIR_AddImm, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 724(*/0xD4, 0x05/*)*/,
     /* 206248 */   GIR_MakeTempReg, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206252 */   GIR_BuildMI, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206257 */   GIR_AddTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206264 */   GIR_AddSimpleTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/,
     /* 206269 */   GIR_AddImm, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 723(*/0xD3, 0x05/*)*/,
     /* 206283 */   GIR_MakeTempReg, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206287 */   GIR_BuildMI, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 206292 */   GIR_AddTempRegister, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206299 */   GIR_Copy, /*NewInsnID*//* 722(*/0xD2, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206304 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/63,
     /* 206308 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/1,
     /* 206312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 722(*/0xD2, 0x05/*)*/,
     /* 206315 */   GIR_MakeTempReg, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206319 */   GIR_BuildMI, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206324 */   GIR_AddTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206331 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/,
     /* 206336 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/,
     /* 206341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 721(*/0xD1, 0x05/*)*/,
     /* 206344 */   GIR_MakeTempReg, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206348 */   GIR_BuildMI, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 206353 */   GIR_AddTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206360 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/,
     /* 206365 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/,
     /* 206370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 720(*/0xD0, 0x05/*)*/,
     /* 206373 */   GIR_MakeTempReg, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206377 */   GIR_BuildMI, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206382 */   GIR_AddTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206389 */   GIR_AddSimpleTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/,
     /* 206394 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/2,
     /* 206398 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/61,
     /* 206402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 719(*/0xCF, 0x05/*)*/,
     /* 206405 */   GIR_MakeTempReg, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206409 */   GIR_BuildMI, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206414 */   GIR_AddTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206421 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/,
     /* 206426 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/,
     /* 206431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 718(*/0xCE, 0x05/*)*/,
     /* 206434 */   GIR_MakeTempReg, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206438 */   GIR_BuildMI, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206443 */   GIR_AddTempRegister, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206450 */   GIR_AddImm, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 717(*/0xCD, 0x05/*)*/,
     /* 206464 */   GIR_MakeTempReg, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206468 */   GIR_BuildMI, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206473 */   GIR_AddTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206480 */   GIR_AddSimpleTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/,
     /* 206485 */   GIR_AddImm, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 716(*/0xCC, 0x05/*)*/,
     /* 206499 */   GIR_MakeTempReg, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206503 */   GIR_BuildMI, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206508 */   GIR_AddTempRegister, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 715(*/0xCB, 0x05/*)*/,
     /* 206518 */   GIR_MakeTempReg, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206522 */   GIR_BuildMI, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206527 */   GIR_AddTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206534 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/,
     /* 206539 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/,
     /* 206544 */   GIR_AddImm8, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Imm*/1,
     /* 206548 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206554 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206560 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206566 */   GIR_MakeTempReg, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206570 */   GIR_BuildMI, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206575 */   GIR_AddTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206582 */   GIR_AddSimpleTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/,
     /* 206587 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/32,
     /* 206591 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/31,
     /* 206595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 713(*/0xC9, 0x05/*)*/,
     /* 206598 */   GIR_MakeTempReg, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206602 */   GIR_BuildMI, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206607 */   GIR_AddTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206614 */   GIR_AddSimpleTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/,
     /* 206619 */   GIR_AddImm, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 712(*/0xC8, 0x05/*)*/,
     /* 206633 */   GIR_MakeTempReg, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206637 */   GIR_BuildMI, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206642 */   GIR_AddTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206649 */   GIR_AddSimpleTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/,
     /* 206654 */   GIR_AddImm, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 711(*/0xC7, 0x05/*)*/,
     /* 206668 */   GIR_MakeTempReg, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206672 */   GIR_BuildMI, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206677 */   GIR_AddTempRegister, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206684 */   GIR_AddImm, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 710(*/0xC6, 0x05/*)*/,
     /* 206698 */   GIR_MakeTempReg, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206702 */   GIR_BuildMI, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206707 */   GIR_AddTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206714 */   GIR_AddSimpleTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/,
     /* 206719 */   GIR_AddImm, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 709(*/0xC5, 0x05/*)*/,
     /* 206733 */   GIR_MakeTempReg, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206737 */   GIR_BuildMI, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206742 */   GIR_AddTempRegister, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 708(*/0xC4, 0x05/*)*/,
     /* 206752 */   GIR_MakeTempReg, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206756 */   GIR_BuildMI, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206761 */   GIR_AddTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206768 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/,
     /* 206773 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/,
     /* 206778 */   GIR_AddImm8, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Imm*/1,
     /* 206782 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206788 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206794 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206800 */   GIR_MakeTempReg, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206804 */   GIR_BuildMI, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206809 */   GIR_AddTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206816 */   GIR_AddSimpleTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/,
     /* 206821 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/32,
     /* 206825 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/31,
     /* 206829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 706(*/0xC2, 0x05/*)*/,
     /* 206832 */   GIR_MakeTempReg, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206836 */   GIR_BuildMI, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206841 */   GIR_AddTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206848 */   GIR_AddSimpleTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/,
     /* 206853 */   GIR_AddImm, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 705(*/0xC1, 0x05/*)*/,
     /* 206867 */   GIR_MakeTempReg, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206871 */   GIR_BuildMI, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206876 */   GIR_AddTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206883 */   GIR_AddSimpleTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/,
     /* 206888 */   GIR_AddImm, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 704(*/0xC0, 0x05/*)*/,
     /* 206902 */   GIR_MakeTempReg, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206906 */   GIR_BuildMI, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206911 */   GIR_AddTempRegister, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206918 */   GIR_Copy, /*NewInsnID*//* 703(*/0xBF, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206923 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/1,
     /* 206927 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/62,
     /* 206931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 703(*/0xBF, 0x05/*)*/,
     /* 206934 */   GIR_MakeTempReg, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206938 */   GIR_BuildMI, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206943 */   GIR_AddTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206950 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/,
     /* 206955 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/,
     /* 206960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 702(*/0xBE, 0x05/*)*/,
     /* 206963 */   GIR_MakeTempReg, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206967 */   GIR_BuildMI, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206972 */   GIR_AddTempRegister, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206979 */   GIR_AddImm, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 701(*/0xBD, 0x05/*)*/,
     /* 206993 */   GIR_MakeTempReg, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206997 */   GIR_BuildMI, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 207002 */   GIR_AddTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207009 */   GIR_AddSimpleTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/,
     /* 207014 */   GIR_AddImm, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 700(*/0xBC, 0x05/*)*/,
     /* 207028 */   GIR_MakeTempReg, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207032 */   GIR_BuildMI, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207037 */   GIR_AddTempRegister, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 699(*/0xBB, 0x05/*)*/,
     /* 207047 */   GIR_MakeTempReg, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207051 */   GIR_BuildMI, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207056 */   GIR_AddTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207063 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/,
     /* 207068 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/,
     /* 207073 */   GIR_AddImm8, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Imm*/1,
     /* 207077 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207083 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207089 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207095 */   GIR_MakeTempReg, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207099 */   GIR_BuildMI, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 207104 */   GIR_AddTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207111 */   GIR_AddSimpleTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/,
     /* 207116 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/32,
     /* 207120 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/31,
     /* 207124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 697(*/0xB9, 0x05/*)*/,
     /* 207127 */   GIR_MakeTempReg, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207131 */   GIR_BuildMI, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 207136 */   GIR_AddTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207143 */   GIR_AddSimpleTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/,
     /* 207148 */   GIR_AddImm, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 696(*/0xB8, 0x05/*)*/,
     /* 207162 */   GIR_MakeTempReg, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207166 */   GIR_BuildMI, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 207171 */   GIR_AddTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207178 */   GIR_AddSimpleTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/,
     /* 207183 */   GIR_AddImm, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 695(*/0xB7, 0x05/*)*/,
     /* 207197 */   GIR_MakeTempReg, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207201 */   GIR_BuildMI, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207206 */   GIR_AddTempRegister, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207213 */   GIR_Copy, /*NewInsnID*//* 694(*/0xB6, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 207218 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/63,
     /* 207222 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/1,
     /* 207226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 694(*/0xB6, 0x05/*)*/,
     /* 207229 */   GIR_MakeTempReg, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207233 */   GIR_BuildMI, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207238 */   GIR_AddTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207245 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/,
     /* 207250 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/,
     /* 207255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 693(*/0xB5, 0x05/*)*/,
     /* 207258 */   GIR_MakeTempReg, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207262 */   GIR_BuildMI, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207267 */   GIR_AddTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207274 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/,
     /* 207279 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/,
     /* 207284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 692(*/0xB4, 0x05/*)*/,
     /* 207287 */   GIR_MakeTempReg, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207291 */   GIR_BuildMI, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207296 */   GIR_AddTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207303 */   GIR_AddSimpleTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/,
     /* 207308 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/62,
     /* 207312 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/2,
     /* 207316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 691(*/0xB3, 0x05/*)*/,
     /* 207319 */   GIR_MakeTempReg, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207323 */   GIR_BuildMI, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207328 */   GIR_AddTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207335 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/,
     /* 207340 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/,
     /* 207345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 690(*/0xB2, 0x05/*)*/,
     /* 207348 */   GIR_MakeTempReg, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207352 */   GIR_BuildMI, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207357 */   GIR_AddTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207364 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/,
     /* 207369 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/,
     /* 207374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 689(*/0xB1, 0x05/*)*/,
     /* 207377 */   GIR_MakeTempReg, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207381 */   GIR_BuildMI, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207386 */   GIR_AddTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207393 */   GIR_AddSimpleTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/,
     /* 207398 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/60,
     /* 207402 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/4,
     /* 207406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 688(*/0xB0, 0x05/*)*/,
     /* 207409 */   GIR_MakeTempReg, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207413 */   GIR_BuildMI, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207418 */   GIR_AddTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207425 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/,
     /* 207430 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/,
     /* 207435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 687(*/0xAF, 0x05/*)*/,
     /* 207438 */   GIR_MakeTempReg, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207442 */   GIR_BuildMI, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207447 */   GIR_AddTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207454 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/,
     /* 207459 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/,
     /* 207464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 686(*/0xAE, 0x05/*)*/,
     /* 207467 */   GIR_MakeTempReg, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207471 */   GIR_BuildMI, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207476 */   GIR_AddTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207483 */   GIR_AddSimpleTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/,
     /* 207488 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 207492 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 207496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 685(*/0xAD, 0x05/*)*/,
     /* 207499 */   GIR_MakeTempReg, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207503 */   GIR_BuildMI, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207508 */   GIR_AddTempRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207515 */   GIR_AddTempSubRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207524 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207530 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207536 */   GIR_MakeTempReg, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 207540 */   GIR_BuildMI, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207545 */   GIR_AddTempRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207552 */   GIR_AddTempSubRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207561 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207567 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207573 */   GIR_MakeTempReg, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207577 */   GIR_BuildMI, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207582 */   GIR_AddTempRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207589 */   GIR_AddTempSubRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207598 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207604 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207610 */   GIR_MakeTempReg, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207614 */   GIR_BuildMI, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 207619 */   GIR_AddTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207626 */   GIR_AddSimpleTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/,
     /* 207631 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/24,
     /* 207635 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/0,
     /* 207639 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/31,
     /* 207643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 413(*/0x9D, 0x03/*)*/,
     /* 207646 */   GIR_MakeTempReg, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207650 */   GIR_BuildMI, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207655 */   GIR_AddTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207662 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/,
     /* 207667 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/,
     /* 207672 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 207676 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 207680 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/15,
     /* 207684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 412(*/0x9C, 0x03/*)*/,
     /* 207687 */   GIR_MakeTempReg, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207691 */   GIR_BuildMI, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207696 */   GIR_AddTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207703 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/,
     /* 207708 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/,
     /* 207713 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/8,
     /* 207717 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/24,
     /* 207721 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/31,
     /* 207725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 411(*/0x9B, 0x03/*)*/,
     /* 207728 */   GIR_MakeTempReg, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 207732 */   GIR_BuildMI, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207737 */   GIR_AddTempRegister, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 410(*/0x9A, 0x03/*)*/,
     /* 207747 */   GIR_MakeTempReg, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 207751 */   GIR_BuildMI, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207756 */   GIR_AddTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207763 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/,
     /* 207768 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/,
     /* 207773 */   GIR_AddImm8, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Imm*/1,
     /* 207777 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207783 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207789 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207795 */   GIR_MakeTempReg, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 207799 */   GIR_BuildMI, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207804 */   GIR_AddTempRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207811 */   GIR_AddTempSubRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207820 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207826 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207832 */   GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 207836 */   GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207841 */   GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207848 */   GIR_AddTempSubRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207857 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207863 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207869 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 207872 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207876 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207881 */   GIR_AddTempSubRegister, /*InsnID*/7, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207888 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207893 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207898 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 207901 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 207905 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207910 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 207913 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/24,
     /* 207916 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 207919 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 207922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 207924 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 207927 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207931 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207936 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 207939 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 207943 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 207946 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 207949 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/15,
     /* 207952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 207954 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 207957 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207961 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207966 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 207969 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*//* 274(*/0x92, 0x02/*)*/,
     /* 207973 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/8,
     /* 207976 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/24,
     /* 207979 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/31,
     /* 207982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 207984 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 207987 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207991 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 207998 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208001 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 208005 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208010 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 208013 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 208016 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 208019 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208024 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208029 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 208041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208046 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208049 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 208052 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 208055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 208060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 208062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 408(*/0x98, 0x03/*)*/,
     /* 208069 */   GIR_RootConstrainSelectedInstOperands,
     /* 208070 */   // GIR_Coverage, 4883,
     /* 208070 */   GIR_EraseRootFromParent_Done,
     /* 208071 */ // Label 2763: @208071
     /* 208071 */ GIM_Reject,
     /* 208072 */ // Label 2759: @208072
     /* 208072 */ GIM_Reject,
     /* 208073 */ // Label 71: @208073
     /* 208073 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2769*/ GIMT_Encode4(208347),
     /* 208084 */ /*GILLT_s32*//*Label 2764*/ GIMT_Encode4(208104),
     /* 208088 */ /*GILLT_s64*//*Label 2765*/ GIMT_Encode4(208197),
     /* 208092 */ /*GILLT_s128*//*Label 2766*/ GIMT_Encode4(208245),
     /* 208096 */ /*GILLT_v2s64*//*Label 2767*/ GIMT_Encode4(208276),
     /* 208100 */ /*GILLT_v4s32*//*Label 2768*/ GIMT_Encode4(208299),
     /* 208104 */ // Label 2764: @208104
     /* 208104 */ GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(208196),
     /* 208109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208112 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(208176), // Rule ID 1704 //
     /* 208117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208124 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208136 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208140 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 208152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208175 */     // GIR_Coverage, 1704,
     /* 208175 */     GIR_EraseRootFromParent_Done,
     /* 208176 */   // Label 2771: @208176
     /* 208176 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(208195), // Rule ID 146 //
     /* 208181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208188 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIPS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPS),
     /* 208193 */     GIR_RootConstrainSelectedInstOperands,
     /* 208194 */     // GIR_Coverage, 146,
     /* 208194 */     GIR_Done,
     /* 208195 */   // Label 2772: @208195
     /* 208195 */   GIM_Reject,
     /* 208196 */ // Label 2770: @208196
     /* 208196 */ GIM_Reject,
     /* 208197 */ // Label 2765: @208197
     /* 208197 */ GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(208244),
     /* 208202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208205 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(208224), // Rule ID 909 //
     /* 208210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208217 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 208222 */     GIR_RootConstrainSelectedInstOperands,
     /* 208223 */     // GIR_Coverage, 909,
     /* 208223 */     GIR_Done,
     /* 208224 */   // Label 2774: @208224
     /* 208224 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(208243), // Rule ID 144 //
     /* 208229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208236 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIPD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPD),
     /* 208241 */     GIR_RootConstrainSelectedInstOperands,
     /* 208242 */     // GIR_Coverage, 144,
     /* 208242 */     GIR_Done,
     /* 208243 */   // Label 2775: @208243
     /* 208243 */   GIM_Reject,
     /* 208244 */ // Label 2773: @208244
     /* 208244 */ GIM_Reject,
     /* 208245 */ // Label 2766: @208245
     /* 208245 */ GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(208275), // Rule ID 2159 //
     /* 208250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208260 */   // (fceil:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 2:{ *:[i32] })
     /* 208260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 208263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 208265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208268 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 208270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 208273 */   GIR_RootConstrainSelectedInstOperands,
     /* 208274 */   // GIR_Coverage, 2159,
     /* 208274 */   GIR_EraseRootFromParent_Done,
     /* 208275 */ // Label 2776: @208275
     /* 208275 */ GIM_Reject,
     /* 208276 */ // Label 2767: @208276
     /* 208276 */ GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(208298), // Rule ID 917 //
     /* 208281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208291 */   // (fceil:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIP),
     /* 208296 */   GIR_RootConstrainSelectedInstOperands,
     /* 208297 */   // GIR_Coverage, 917,
     /* 208297 */   GIR_Done,
     /* 208298 */ // Label 2777: @208298
     /* 208298 */ GIM_Reject,
     /* 208299 */ // Label 2768: @208299
     /* 208299 */ GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(208346),
     /* 208304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208307 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(208326), // Rule ID 925 //
     /* 208312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208319 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIP),
     /* 208324 */     GIR_RootConstrainSelectedInstOperands,
     /* 208325 */     // GIR_Coverage, 925,
     /* 208325 */     GIR_Done,
     /* 208326 */   // Label 2779: @208326
     /* 208326 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(208345), // Rule ID 1414 //
     /* 208331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 208334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208338 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 208338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /* 208343 */     GIR_RootConstrainSelectedInstOperands,
     /* 208344 */     // GIR_Coverage, 1414,
     /* 208344 */     GIR_Done,
     /* 208345 */   // Label 2780: @208345
     /* 208345 */   GIM_Reject,
     /* 208346 */ // Label 2778: @208346
     /* 208346 */ GIM_Reject,
     /* 208347 */ // Label 2769: @208347
     /* 208347 */ GIM_Reject,
     /* 208348 */ // Label 72: @208348
     /* 208348 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2786*/ GIMT_Encode4(208564),
     /* 208359 */ /*GILLT_s32*//*Label 2781*/ GIMT_Encode4(208379),
     /* 208363 */ /*GILLT_s64*//*Label 2782*/ GIMT_Encode4(208431),
     /* 208367 */ /*GILLT_s128*//*Label 2783*/ GIMT_Encode4(208487),
     /* 208371 */ /*GILLT_v2s64*//*Label 2784*/ GIMT_Encode4(208510),
     /* 208375 */ /*GILLT_v4s32*//*Label 2785*/ GIMT_Encode4(208537),
     /* 208379 */ // Label 2781: @208379
     /* 208379 */ GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(208430),
     /* 208384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208387 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(208406), // Rule ID 960 //
     /* 208392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 208395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208399 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 208399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 208404 */     GIR_RootConstrainSelectedInstOperands,
     /* 208405 */     // GIR_Coverage, 960,
     /* 208405 */     GIR_Done,
     /* 208406 */   // Label 2788: @208406
     /* 208406 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(208429), // Rule ID 162 //
     /* 208411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208418 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 208423 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208427 */     GIR_RootConstrainSelectedInstOperands,
     /* 208428 */     // GIR_Coverage, 162,
     /* 208428 */     GIR_Done,
     /* 208429 */   // Label 2789: @208429
     /* 208429 */   GIM_Reject,
     /* 208430 */ // Label 2787: @208430
     /* 208430 */ GIM_Reject,
     /* 208431 */ // Label 2782: @208431
     /* 208431 */ GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(208486),
     /* 208436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208439 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(208462), // Rule ID 809 //
     /* 208444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208451 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 208456 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208460 */     GIR_RootConstrainSelectedInstOperands,
     /* 208461 */     // GIR_Coverage, 809,
     /* 208461 */     GIR_Done,
     /* 208462 */   // Label 2791: @208462
     /* 208462 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(208485), // Rule ID 160 //
     /* 208467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208474 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 208479 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208483 */     GIR_RootConstrainSelectedInstOperands,
     /* 208484 */     // GIR_Coverage, 160,
     /* 208484 */     GIR_Done,
     /* 208485 */   // Label 2792: @208485
     /* 208485 */   GIM_Reject,
     /* 208486 */ // Label 2790: @208486
     /* 208486 */ GIM_Reject,
     /* 208487 */ // Label 2783: @208487
     /* 208487 */ GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(208509), // Rule ID 992 //
     /* 208492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208502 */   // (fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 208502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 208507 */   GIR_RootConstrainSelectedInstOperands,
     /* 208508 */   // GIR_Coverage, 992,
     /* 208508 */   GIR_Done,
     /* 208509 */ // Label 2793: @208509
     /* 208509 */ GIM_Reject,
     /* 208510 */ // Label 2784: @208510
     /* 208510 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(208536), // Rule ID 820 //
     /* 208515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208525 */   // (fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 208530 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208534 */   GIR_RootConstrainSelectedInstOperands,
     /* 208535 */   // GIR_Coverage, 820,
     /* 208535 */   GIR_Done,
     /* 208536 */ // Label 2794: @208536
     /* 208536 */ GIM_Reject,
     /* 208537 */ // Label 2785: @208537
     /* 208537 */ GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(208563), // Rule ID 822 //
     /* 208542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208552 */   // (fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 208557 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208561 */   GIR_RootConstrainSelectedInstOperands,
     /* 208562 */   // GIR_Coverage, 822,
     /* 208562 */   GIR_Done,
     /* 208563 */ // Label 2795: @208563
     /* 208563 */ GIM_Reject,
     /* 208564 */ // Label 2786: @208564
     /* 208564 */ GIM_Reject,
     /* 208565 */ // Label 73: @208565
     /* 208565 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2801*/ GIMT_Encode4(208839),
     /* 208576 */ /*GILLT_s32*//*Label 2796*/ GIMT_Encode4(208596),
     /* 208580 */ /*GILLT_s64*//*Label 2797*/ GIMT_Encode4(208689),
     /* 208584 */ /*GILLT_s128*//*Label 2798*/ GIMT_Encode4(208737),
     /* 208588 */ /*GILLT_v2s64*//*Label 2799*/ GIMT_Encode4(208768),
     /* 208592 */ /*GILLT_v4s32*//*Label 2800*/ GIMT_Encode4(208791),
     /* 208596 */ // Label 2796: @208596
     /* 208596 */ GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(208688),
     /* 208601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208604 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(208668), // Rule ID 1702 //
     /* 208609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208616 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIM:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208616 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208619 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208623 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208628 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 208644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208667 */     // GIR_Coverage, 1702,
     /* 208667 */     GIR_EraseRootFromParent_Done,
     /* 208668 */   // Label 2803: @208668
     /* 208668 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(208687), // Rule ID 154 //
     /* 208673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208680 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIMS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMS),
     /* 208685 */     GIR_RootConstrainSelectedInstOperands,
     /* 208686 */     // GIR_Coverage, 154,
     /* 208686 */     GIR_Done,
     /* 208687 */   // Label 2804: @208687
     /* 208687 */   GIM_Reject,
     /* 208688 */ // Label 2802: @208688
     /* 208688 */ GIM_Reject,
     /* 208689 */ // Label 2797: @208689
     /* 208689 */ GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(208736),
     /* 208694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208697 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(208716), // Rule ID 907 //
     /* 208702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208709 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIM:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 208714 */     GIR_RootConstrainSelectedInstOperands,
     /* 208715 */     // GIR_Coverage, 907,
     /* 208715 */     GIR_Done,
     /* 208716 */   // Label 2806: @208716
     /* 208716 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(208735), // Rule ID 152 //
     /* 208721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208728 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIMD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMD),
     /* 208733 */     GIR_RootConstrainSelectedInstOperands,
     /* 208734 */     // GIR_Coverage, 152,
     /* 208734 */     GIR_Done,
     /* 208735 */   // Label 2807: @208735
     /* 208735 */   GIM_Reject,
     /* 208736 */ // Label 2805: @208736
     /* 208736 */ GIM_Reject,
     /* 208737 */ // Label 2798: @208737
     /* 208737 */ GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(208767), // Rule ID 2161 //
     /* 208742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208752 */   // (ffloor:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 208752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 208755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 208757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208760 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 208762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 208765 */   GIR_RootConstrainSelectedInstOperands,
     /* 208766 */   // GIR_Coverage, 2161,
     /* 208766 */   GIR_EraseRootFromParent_Done,
     /* 208767 */ // Label 2808: @208767
     /* 208767 */ GIM_Reject,
     /* 208768 */ // Label 2799: @208768
     /* 208768 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(208790), // Rule ID 915 //
     /* 208773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208783 */   // (ffloor:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIM:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIM),
     /* 208788 */   GIR_RootConstrainSelectedInstOperands,
     /* 208789 */   // GIR_Coverage, 915,
     /* 208789 */   GIR_Done,
     /* 208790 */ // Label 2809: @208790
     /* 208790 */ GIM_Reject,
     /* 208791 */ // Label 2800: @208791
     /* 208791 */ GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(208838),
     /* 208796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208799 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(208818), // Rule ID 923 //
     /* 208804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208811 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIM),
     /* 208816 */     GIR_RootConstrainSelectedInstOperands,
     /* 208817 */     // GIR_Coverage, 923,
     /* 208817 */     GIR_Done,
     /* 208818 */   // Label 2811: @208818
     /* 208818 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(208837), // Rule ID 1413 //
     /* 208823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 208826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208830 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIM:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 208830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /* 208835 */     GIR_RootConstrainSelectedInstOperands,
     /* 208836 */     // GIR_Coverage, 1413,
     /* 208836 */     GIR_Done,
     /* 208837 */   // Label 2812: @208837
     /* 208837 */   GIM_Reject,
     /* 208838 */ // Label 2810: @208838
     /* 208838 */ GIM_Reject,
     /* 208839 */ // Label 2801: @208839
     /* 208839 */ GIM_Reject,
     /* 208840 */ // Label 74: @208840
     /* 208840 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2818*/ GIMT_Encode4(209051),
     /* 208851 */ /*GILLT_s32*//*Label 2813*/ GIMT_Encode4(208871),
     /* 208855 */ /*GILLT_s64*//*Label 2814*/ GIMT_Encode4(208939),
     /* 208859 */ /*GILLT_s128*//*Label 2815*/ GIMT_Encode4(208966),
     /* 208863 */ /*GILLT_v2s64*//*Label 2816*/ GIMT_Encode4(208997),
     /* 208867 */ /*GILLT_v4s32*//*Label 2817*/ GIMT_Encode4(209024),
     /* 208871 */ // Label 2813: @208871
     /* 208871 */ GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(208938), // Rule ID 1708 //
     /* 208876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208886 */   // (frint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208886 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208889 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208893 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208898 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208902 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 208914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208919 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208932 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208937 */   // GIR_Coverage, 1708,
     /* 208937 */   GIR_EraseRootFromParent_Done,
     /* 208938 */ // Label 2819: @208938
     /* 208938 */ GIM_Reject,
     /* 208939 */ // Label 2814: @208939
     /* 208939 */ GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(208965), // Rule ID 1712 //
     /* 208944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208954 */   // (frint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 208954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 208959 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208963 */   GIR_RootConstrainSelectedInstOperands,
     /* 208964 */   // GIR_Coverage, 1712,
     /* 208964 */   GIR_Done,
     /* 208965 */ // Label 2820: @208965
     /* 208965 */ GIM_Reject,
     /* 208966 */ // Label 2815: @208966
     /* 208966 */ GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(208996), // Rule ID 2163 //
     /* 208971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208981 */   // (frint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPIX:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 208981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPIX),
     /* 208984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 208986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208989 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 208991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 208994 */   GIR_RootConstrainSelectedInstOperands,
     /* 208995 */   // GIR_Coverage, 2163,
     /* 208995 */   GIR_EraseRootFromParent_Done,
     /* 208996 */ // Label 2821: @208996
     /* 208996 */ GIM_Reject,
     /* 208997 */ // Label 2816: @208997
     /* 208997 */ GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(209023), // Rule ID 1714 //
     /* 209002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209012 */   // (frint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 209012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 209017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209021 */   GIR_RootConstrainSelectedInstOperands,
     /* 209022 */   // GIR_Coverage, 1714,
     /* 209022 */   GIR_Done,
     /* 209023 */ // Label 2822: @209023
     /* 209023 */ GIM_Reject,
     /* 209024 */ // Label 2817: @209024
     /* 209024 */ GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(209050), // Rule ID 1710 //
     /* 209029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209039 */   // (frint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 209039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 209044 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209048 */   GIR_RootConstrainSelectedInstOperands,
     /* 209049 */   // GIR_Coverage, 1710,
     /* 209049 */   GIR_Done,
     /* 209050 */ // Label 2823: @209050
     /* 209050 */ GIM_Reject,
     /* 209051 */ // Label 2818: @209051
     /* 209051 */ GIM_Reject,
     /* 209052 */ // Label 75: @209052
     /* 209052 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2829*/ GIMT_Encode4(209288),
     /* 209063 */ /*GILLT_s32*//*Label 2824*/ GIMT_Encode4(209083),
     /* 209067 */ /*GILLT_s64*//*Label 2825*/ GIMT_Encode4(209151),
     /* 209071 */ /*GILLT_s128*//*Label 2826*/ GIMT_Encode4(209178),
     /* 209075 */ /*GILLT_v2s64*//*Label 2827*/ GIMT_Encode4(209209),
     /* 209079 */ /*GILLT_v4s32*//*Label 2828*/ GIMT_Encode4(209236),
     /* 209083 */ // Label 2824: @209083
     /* 209083 */ GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(209150), // Rule ID 1715 //
     /* 209088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209098 */   // (fnearbyint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 209098 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 209101 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209105 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209110 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 209114 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 209122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209131 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 209134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209144 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209149 */   // GIR_Coverage, 1715,
     /* 209149 */   GIR_EraseRootFromParent_Done,
     /* 209150 */ // Label 2830: @209150
     /* 209150 */ GIM_Reject,
     /* 209151 */ // Label 2825: @209151
     /* 209151 */ GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(209177), // Rule ID 1716 //
     /* 209156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209166 */   // (fnearbyint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 209166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209171 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209175 */   GIR_RootConstrainSelectedInstOperands,
     /* 209176 */   // GIR_Coverage, 1716,
     /* 209176 */   GIR_Done,
     /* 209177 */ // Label 2831: @209177
     /* 209177 */ GIM_Reject,
     /* 209178 */ // Label 2826: @209178
     /* 209178 */ GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(209208), // Rule ID 2153 //
     /* 209183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209193 */   // (fnearbyint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 209193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 209196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 209198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209201 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 209203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 209206 */   GIR_RootConstrainSelectedInstOperands,
     /* 209207 */   // GIR_Coverage, 2153,
     /* 209207 */   GIR_EraseRootFromParent_Done,
     /* 209208 */ // Label 2832: @209208
     /* 209208 */ GIM_Reject,
     /* 209209 */ // Label 2827: @209209
     /* 209209 */ GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(209235), // Rule ID 1717 //
     /* 209214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209224 */   // (fnearbyint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 209224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 209229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209233 */   GIR_RootConstrainSelectedInstOperands,
     /* 209234 */   // GIR_Coverage, 1717,
     /* 209234 */   GIR_Done,
     /* 209235 */ // Label 2833: @209235
     /* 209235 */ GIM_Reject,
     /* 209236 */ // Label 2828: @209236
     /* 209236 */ GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(209287),
     /* 209241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209244 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(209267), // Rule ID 1718 //
     /* 209249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209256 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 209256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 209261 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209265 */     GIR_RootConstrainSelectedInstOperands,
     /* 209266 */     // GIR_Coverage, 1718,
     /* 209266 */     GIR_Done,
     /* 209267 */   // Label 2835: @209267
     /* 209267 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(209286), // Rule ID 1416 //
     /* 209272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 209275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209279 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIN:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 209279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /* 209284 */     GIR_RootConstrainSelectedInstOperands,
     /* 209285 */     // GIR_Coverage, 1416,
     /* 209285 */     GIR_Done,
     /* 209286 */   // Label 2836: @209286
     /* 209286 */   GIM_Reject,
     /* 209287 */ // Label 2834: @209287
     /* 209287 */ GIM_Reject,
     /* 209288 */ // Label 2829: @209288
     /* 209288 */ GIM_Reject,
     /* 209289 */ // Label 76: @209289
     /* 209289 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2842*/ GIMT_Encode4(209558),
     /* 209300 */ /*GILLT_s32*//*Label 2837*/ GIMT_Encode4(209320),
     /* 209304 */ /*GILLT_s64*//*Label 2838*/ GIMT_Encode4(209394),
     /* 209308 */ /*GILLT_s128*//*Label 2839*/ GIMT_Encode4(209472),
     /* 209312 */ /*GILLT_v2s64*//*Label 2840*/ GIMT_Encode4(209498),
     /* 209316 */ /*GILLT_v4s32*//*Label 2841*/ GIMT_Encode4(209528),
     /* 209320 */ // Label 2837: @209320
     /* 209320 */ GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(209393),
     /* 209325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209331 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(209350), // Rule ID 948 //
     /* 209336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209343 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 209348 */     GIR_RootConstrainSelectedInstOperands,
     /* 209349 */     // GIR_Coverage, 948,
     /* 209349 */     GIR_Done,
     /* 209350 */   // Label 2844: @209350
     /* 209350 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(209373), // Rule ID 238 //
     /* 209355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209362 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 209362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 209367 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209371 */     GIR_RootConstrainSelectedInstOperands,
     /* 209372 */     // GIR_Coverage, 238,
     /* 209372 */     GIR_Done,
     /* 209373 */   // Label 2845: @209373
     /* 209373 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(209392), // Rule ID 578 //
     /* 209378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209385 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 209390 */     GIR_RootConstrainSelectedInstOperands,
     /* 209391 */     // GIR_Coverage, 578,
     /* 209391 */     GIR_Done,
     /* 209392 */   // Label 2846: @209392
     /* 209392 */   GIM_Reject,
     /* 209393 */ // Label 2843: @209393
     /* 209393 */ GIM_Reject,
     /* 209394 */ // Label 2838: @209394
     /* 209394 */ GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(209471),
     /* 209399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209405 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(209428), // Rule ID 765 //
     /* 209410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209417 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 209417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 209422 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209426 */     GIR_RootConstrainSelectedInstOperands,
     /* 209427 */     // GIR_Coverage, 765,
     /* 209427 */     GIR_Done,
     /* 209428 */   // Label 2848: @209428
     /* 209428 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(209451), // Rule ID 236 //
     /* 209433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209440 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 209440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 209445 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209449 */     GIR_RootConstrainSelectedInstOperands,
     /* 209450 */     // GIR_Coverage, 236,
     /* 209450 */     GIR_Done,
     /* 209451 */   // Label 2849: @209451
     /* 209451 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(209470), // Rule ID 557 //
     /* 209456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 209463 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 209463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 209468 */     GIR_RootConstrainSelectedInstOperands,
     /* 209469 */     // GIR_Coverage, 557,
     /* 209469 */     GIR_Done,
     /* 209470 */   // Label 2850: @209470
     /* 209470 */   GIM_Reject,
     /* 209471 */ // Label 2847: @209471
     /* 209471 */ GIM_Reject,
     /* 209472 */ // Label 2839: @209472
     /* 209472 */ GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(209497), // Rule ID 983 //
     /* 209477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 209486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209490 */   // (strict_fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 209490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 209495 */   GIR_RootConstrainSelectedInstOperands,
     /* 209496 */   // GIR_Coverage, 983,
     /* 209496 */   GIR_Done,
     /* 209497 */ // Label 2851: @209497
     /* 209497 */ GIM_Reject,
     /* 209498 */ // Label 2840: @209498
     /* 209498 */ GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(209527), // Rule ID 769 //
     /* 209503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209516 */   // (strict_fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 209516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 209521 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209525 */   GIR_RootConstrainSelectedInstOperands,
     /* 209526 */   // GIR_Coverage, 769,
     /* 209526 */   GIR_Done,
     /* 209527 */ // Label 2852: @209527
     /* 209527 */ GIM_Reject,
     /* 209528 */ // Label 2841: @209528
     /* 209528 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(209557), // Rule ID 771 //
     /* 209533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209546 */   // (strict_fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 209546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 209551 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209555 */   GIR_RootConstrainSelectedInstOperands,
     /* 209556 */   // GIR_Coverage, 771,
     /* 209556 */   GIR_Done,
     /* 209557 */ // Label 2853: @209557
     /* 209557 */ GIM_Reject,
     /* 209558 */ // Label 2842: @209558
     /* 209558 */ GIM_Reject,
     /* 209559 */ // Label 77: @209559
     /* 209559 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2859*/ GIMT_Encode4(209828),
     /* 209570 */ /*GILLT_s32*//*Label 2854*/ GIMT_Encode4(209590),
     /* 209574 */ /*GILLT_s64*//*Label 2855*/ GIMT_Encode4(209664),
     /* 209578 */ /*GILLT_s128*//*Label 2856*/ GIMT_Encode4(209742),
     /* 209582 */ /*GILLT_v2s64*//*Label 2857*/ GIMT_Encode4(209768),
     /* 209586 */ /*GILLT_v4s32*//*Label 2858*/ GIMT_Encode4(209798),
     /* 209590 */ // Label 2854: @209590
     /* 209590 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(209663),
     /* 209595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209601 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(209620), // Rule ID 952 //
     /* 209606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209613 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 209618 */     GIR_RootConstrainSelectedInstOperands,
     /* 209619 */     // GIR_Coverage, 952,
     /* 209619 */     GIR_Done,
     /* 209620 */   // Label 2861: @209620
     /* 209620 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(209643), // Rule ID 250 //
     /* 209625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209632 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 209632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 209637 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209641 */     GIR_RootConstrainSelectedInstOperands,
     /* 209642 */     // GIR_Coverage, 250,
     /* 209642 */     GIR_Done,
     /* 209643 */   // Label 2862: @209643
     /* 209643 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(209662), // Rule ID 596 //
     /* 209648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209655 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 209660 */     GIR_RootConstrainSelectedInstOperands,
     /* 209661 */     // GIR_Coverage, 596,
     /* 209661 */     GIR_Done,
     /* 209662 */   // Label 2863: @209662
     /* 209662 */   GIM_Reject,
     /* 209663 */ // Label 2860: @209663
     /* 209663 */ GIM_Reject,
     /* 209664 */ // Label 2855: @209664
     /* 209664 */ GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(209741),
     /* 209669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209675 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(209698), // Rule ID 777 //
     /* 209680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209687 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 209687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 209692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209696 */     GIR_RootConstrainSelectedInstOperands,
     /* 209697 */     // GIR_Coverage, 777,
     /* 209697 */     GIR_Done,
     /* 209698 */   // Label 2865: @209698
     /* 209698 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(209721), // Rule ID 248 //
     /* 209703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209710 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 209710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 209715 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209719 */     GIR_RootConstrainSelectedInstOperands,
     /* 209720 */     // GIR_Coverage, 248,
     /* 209720 */     GIR_Done,
     /* 209721 */   // Label 2866: @209721
     /* 209721 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(209740), // Rule ID 575 //
     /* 209726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 209733 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 209733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 209738 */     GIR_RootConstrainSelectedInstOperands,
     /* 209739 */     // GIR_Coverage, 575,
     /* 209739 */     GIR_Done,
     /* 209740 */   // Label 2867: @209740
     /* 209740 */   GIM_Reject,
     /* 209741 */ // Label 2864: @209741
     /* 209741 */ GIM_Reject,
     /* 209742 */ // Label 2856: @209742
     /* 209742 */ GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(209767), // Rule ID 987 //
     /* 209747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 209756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209760 */   // (strict_fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 209760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 209765 */   GIR_RootConstrainSelectedInstOperands,
     /* 209766 */   // GIR_Coverage, 987,
     /* 209766 */   GIR_Done,
     /* 209767 */ // Label 2868: @209767
     /* 209767 */ GIM_Reject,
     /* 209768 */ // Label 2857: @209768
     /* 209768 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(209797), // Rule ID 779 //
     /* 209773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209786 */   // (strict_fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 209786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 209791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209795 */   GIR_RootConstrainSelectedInstOperands,
     /* 209796 */   // GIR_Coverage, 779,
     /* 209796 */   GIR_Done,
     /* 209797 */ // Label 2869: @209797
     /* 209797 */ GIM_Reject,
     /* 209798 */ // Label 2858: @209798
     /* 209798 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(209827), // Rule ID 781 //
     /* 209803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209816 */   // (strict_fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 209816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 209821 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209825 */   GIR_RootConstrainSelectedInstOperands,
     /* 209826 */   // GIR_Coverage, 781,
     /* 209826 */   GIR_Done,
     /* 209827 */ // Label 2870: @209827
     /* 209827 */ GIM_Reject,
     /* 209828 */ // Label 2859: @209828
     /* 209828 */ GIM_Reject,
     /* 209829 */ // Label 78: @209829
     /* 209829 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2876*/ GIMT_Encode4(210098),
     /* 209840 */ /*GILLT_s32*//*Label 2871*/ GIMT_Encode4(209860),
     /* 209844 */ /*GILLT_s64*//*Label 2872*/ GIMT_Encode4(209934),
     /* 209848 */ /*GILLT_s128*//*Label 2873*/ GIMT_Encode4(210012),
     /* 209852 */ /*GILLT_v2s64*//*Label 2874*/ GIMT_Encode4(210038),
     /* 209856 */ /*GILLT_v4s32*//*Label 2875*/ GIMT_Encode4(210068),
     /* 209860 */ // Label 2871: @209860
     /* 209860 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(209933),
     /* 209865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209871 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(209890), // Rule ID 950 //
     /* 209876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209883 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 209888 */     GIR_RootConstrainSelectedInstOperands,
     /* 209889 */     // GIR_Coverage, 950,
     /* 209889 */     GIR_Done,
     /* 209890 */   // Label 2878: @209890
     /* 209890 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(209913), // Rule ID 246 //
     /* 209895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209902 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 209902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 209907 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209911 */     GIR_RootConstrainSelectedInstOperands,
     /* 209912 */     // GIR_Coverage, 246,
     /* 209912 */     GIR_Done,
     /* 209913 */   // Label 2879: @209913
     /* 209913 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(209932), // Rule ID 592 //
     /* 209918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209925 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 209930 */     GIR_RootConstrainSelectedInstOperands,
     /* 209931 */     // GIR_Coverage, 592,
     /* 209931 */     GIR_Done,
     /* 209932 */   // Label 2880: @209932
     /* 209932 */   GIM_Reject,
     /* 209933 */ // Label 2877: @209933
     /* 209933 */ GIM_Reject,
     /* 209934 */ // Label 2872: @209934
     /* 209934 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(210011),
     /* 209939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209945 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(209968), // Rule ID 767 //
     /* 209950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209957 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 209957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 209962 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209966 */     GIR_RootConstrainSelectedInstOperands,
     /* 209967 */     // GIR_Coverage, 767,
     /* 209967 */     GIR_Done,
     /* 209968 */   // Label 2882: @209968
     /* 209968 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(209991), // Rule ID 244 //
     /* 209973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209980 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 209980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 209985 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209989 */     GIR_RootConstrainSelectedInstOperands,
     /* 209990 */     // GIR_Coverage, 244,
     /* 209990 */     GIR_Done,
     /* 209991 */   // Label 2883: @209991
     /* 209991 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(210010), // Rule ID 571 //
     /* 209996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210003 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 210008 */     GIR_RootConstrainSelectedInstOperands,
     /* 210009 */     // GIR_Coverage, 571,
     /* 210009 */     GIR_Done,
     /* 210010 */   // Label 2884: @210010
     /* 210010 */   GIM_Reject,
     /* 210011 */ // Label 2881: @210011
     /* 210011 */ GIM_Reject,
     /* 210012 */ // Label 2873: @210012
     /* 210012 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(210037), // Rule ID 985 //
     /* 210017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210030 */   // (strict_fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 210035 */   GIR_RootConstrainSelectedInstOperands,
     /* 210036 */   // GIR_Coverage, 985,
     /* 210036 */   GIR_Done,
     /* 210037 */ // Label 2885: @210037
     /* 210037 */ GIM_Reject,
     /* 210038 */ // Label 2874: @210038
     /* 210038 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(210067), // Rule ID 773 //
     /* 210043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210056 */   // (strict_fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 210061 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210065 */   GIR_RootConstrainSelectedInstOperands,
     /* 210066 */   // GIR_Coverage, 773,
     /* 210066 */   GIR_Done,
     /* 210067 */ // Label 2886: @210067
     /* 210067 */ GIM_Reject,
     /* 210068 */ // Label 2875: @210068
     /* 210068 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(210097), // Rule ID 775 //
     /* 210073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210086 */   // (strict_fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 210091 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210095 */   GIR_RootConstrainSelectedInstOperands,
     /* 210096 */   // GIR_Coverage, 775,
     /* 210096 */   GIR_Done,
     /* 210097 */ // Label 2887: @210097
     /* 210097 */ GIM_Reject,
     /* 210098 */ // Label 2876: @210098
     /* 210098 */ GIM_Reject,
     /* 210099 */ // Label 79: @210099
     /* 210099 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2893*/ GIMT_Encode4(210368),
     /* 210110 */ /*GILLT_s32*//*Label 2888*/ GIMT_Encode4(210130),
     /* 210114 */ /*GILLT_s64*//*Label 2889*/ GIMT_Encode4(210204),
     /* 210118 */ /*GILLT_s128*//*Label 2890*/ GIMT_Encode4(210282),
     /* 210122 */ /*GILLT_v2s64*//*Label 2891*/ GIMT_Encode4(210308),
     /* 210126 */ /*GILLT_v4s32*//*Label 2892*/ GIMT_Encode4(210338),
     /* 210130 */ // Label 2888: @210130
     /* 210130 */ GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(210203),
     /* 210135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210141 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(210160), // Rule ID 954 //
     /* 210146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210153 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 210158 */     GIR_RootConstrainSelectedInstOperands,
     /* 210159 */     // GIR_Coverage, 954,
     /* 210159 */     GIR_Done,
     /* 210160 */   // Label 2895: @210160
     /* 210160 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(210183), // Rule ID 242 //
     /* 210165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210172 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 210172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 210177 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210181 */     GIR_RootConstrainSelectedInstOperands,
     /* 210182 */     // GIR_Coverage, 242,
     /* 210182 */     GIR_Done,
     /* 210183 */   // Label 2896: @210183
     /* 210183 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(210202), // Rule ID 590 //
     /* 210188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 210195 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 210195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 210200 */     GIR_RootConstrainSelectedInstOperands,
     /* 210201 */     // GIR_Coverage, 590,
     /* 210201 */     GIR_Done,
     /* 210202 */   // Label 2897: @210202
     /* 210202 */   GIM_Reject,
     /* 210203 */ // Label 2894: @210203
     /* 210203 */ GIM_Reject,
     /* 210204 */ // Label 2889: @210204
     /* 210204 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(210281),
     /* 210209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210215 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(210238), // Rule ID 806 //
     /* 210220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210227 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 210232 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210236 */     GIR_RootConstrainSelectedInstOperands,
     /* 210237 */     // GIR_Coverage, 806,
     /* 210237 */     GIR_Done,
     /* 210238 */   // Label 2899: @210238
     /* 210238 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(210261), // Rule ID 240 //
     /* 210243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210250 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 210250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 210255 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210259 */     GIR_RootConstrainSelectedInstOperands,
     /* 210260 */     // GIR_Coverage, 240,
     /* 210260 */     GIR_Done,
     /* 210261 */   // Label 2900: @210261
     /* 210261 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(210280), // Rule ID 569 //
     /* 210266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210273 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 210278 */     GIR_RootConstrainSelectedInstOperands,
     /* 210279 */     // GIR_Coverage, 569,
     /* 210279 */     GIR_Done,
     /* 210280 */   // Label 2901: @210280
     /* 210280 */   GIM_Reject,
     /* 210281 */ // Label 2898: @210281
     /* 210281 */ GIM_Reject,
     /* 210282 */ // Label 2890: @210282
     /* 210282 */ GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(210307), // Rule ID 989 //
     /* 210287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210300 */   // (strict_fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 210305 */   GIR_RootConstrainSelectedInstOperands,
     /* 210306 */   // GIR_Coverage, 989,
     /* 210306 */   GIR_Done,
     /* 210307 */ // Label 2902: @210307
     /* 210307 */ GIM_Reject,
     /* 210308 */ // Label 2891: @210308
     /* 210308 */ GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(210337), // Rule ID 815 //
     /* 210313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210326 */   // (strict_fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 210331 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210335 */   GIR_RootConstrainSelectedInstOperands,
     /* 210336 */   // GIR_Coverage, 815,
     /* 210336 */   GIR_Done,
     /* 210337 */ // Label 2903: @210337
     /* 210337 */ GIM_Reject,
     /* 210338 */ // Label 2892: @210338
     /* 210338 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(210367), // Rule ID 817 //
     /* 210343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210356 */   // (strict_fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 210361 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210365 */   GIR_RootConstrainSelectedInstOperands,
     /* 210366 */   // GIR_Coverage, 817,
     /* 210366 */   GIR_Done,
     /* 210367 */ // Label 2904: @210367
     /* 210367 */ GIM_Reject,
     /* 210368 */ // Label 2893: @210368
     /* 210368 */ GIM_Reject,
     /* 210369 */ // Label 80: @210369
     /* 210369 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2910*/ GIMT_Encode4(210926),
     /* 210380 */ /*GILLT_s32*//*Label 2905*/ GIMT_Encode4(210400),
     /* 210384 */ /*GILLT_s64*//*Label 2906*/ GIMT_Encode4(210546),
     /* 210388 */ /*GILLT_s128*//*Label 2907*/ GIMT_Encode4(210692),
     /* 210392 */ /*GILLT_v2s64*//*Label 2908*/ GIMT_Encode4(210770),
     /* 210396 */ /*GILLT_v4s32*//*Label 2909*/ GIMT_Encode4(210848),
     /* 210400 */ // Label 2905: @210400
     /* 210400 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(210545),
     /* 210405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210414 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(210455), // Rule ID 964 //
     /* 210419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 210438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210440 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 210443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210449 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210451 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210453 */     GIR_RootConstrainSelectedInstOperands,
     /* 210454 */     // GIR_Coverage, 964,
     /* 210454 */     GIR_EraseRootFromParent_Done,
     /* 210455 */   // Label 2912: @210455
     /* 210455 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(210480), // Rule ID 962 //
     /* 210460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210467 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 210470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210472 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210474 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210476 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210478 */     GIR_RootConstrainSelectedInstOperands,
     /* 210479 */     // GIR_Coverage, 962,
     /* 210479 */     GIR_EraseRootFromParent_Done,
     /* 210480 */   // Label 2913: @210480
     /* 210480 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(210521), // Rule ID 224 //
     /* 210485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 210504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210506 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 210506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 210509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 210511 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 210513 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 210515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 210519 */     GIR_RootConstrainSelectedInstOperands,
     /* 210520 */     // GIR_Coverage, 224,
     /* 210520 */     GIR_EraseRootFromParent_Done,
     /* 210521 */   // Label 2914: @210521
     /* 210521 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(210544), // Rule ID 220 //
     /* 210526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210533 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 210533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 210538 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210542 */     GIR_RootConstrainSelectedInstOperands,
     /* 210543 */     // GIR_Coverage, 220,
     /* 210543 */     GIR_Done,
     /* 210544 */   // Label 2915: @210544
     /* 210544 */   GIM_Reject,
     /* 210545 */ // Label 2911: @210545
     /* 210545 */ GIM_Reject,
     /* 210546 */ // Label 2906: @210546
     /* 210546 */ GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(210691),
     /* 210551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210560 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(210601), // Rule ID 785 //
     /* 210565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 210584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210586 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 210589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210595 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210597 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210599 */     GIR_RootConstrainSelectedInstOperands,
     /* 210600 */     // GIR_Coverage, 785,
     /* 210600 */     GIR_EraseRootFromParent_Done,
     /* 210601 */   // Label 2917: @210601
     /* 210601 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(210626), // Rule ID 783 //
     /* 210606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210613 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 210616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210618 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210620 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210622 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210624 */     GIR_RootConstrainSelectedInstOperands,
     /* 210625 */     // GIR_Coverage, 783,
     /* 210625 */     GIR_EraseRootFromParent_Done,
     /* 210626 */   // Label 2918: @210626
     /* 210626 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(210667), // Rule ID 222 //
     /* 210631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 210650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210652 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 210652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 210655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 210657 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 210659 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 210661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 210665 */     GIR_RootConstrainSelectedInstOperands,
     /* 210666 */     // GIR_Coverage, 222,
     /* 210666 */     GIR_EraseRootFromParent_Done,
     /* 210667 */   // Label 2919: @210667
     /* 210667 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(210690), // Rule ID 218 //
     /* 210672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210679 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 210679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 210684 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210688 */     GIR_RootConstrainSelectedInstOperands,
     /* 210689 */     // GIR_Coverage, 218,
     /* 210689 */     GIR_Done,
     /* 210690 */   // Label 2920: @210690
     /* 210690 */   GIM_Reject,
     /* 210691 */ // Label 2916: @210691
     /* 210691 */ GIM_Reject,
     /* 210692 */ // Label 2907: @210692
     /* 210692 */ GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(210769),
     /* 210697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210703 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 210706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210710 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(210747), // Rule ID 995 //
     /* 210715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 210730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210732 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 210735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 210737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 210741 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 210743 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 210745 */     GIR_RootConstrainSelectedInstOperands,
     /* 210746 */     // GIR_Coverage, 995,
     /* 210746 */     GIR_EraseRootFromParent_Done,
     /* 210747 */   // Label 2922: @210747
     /* 210747 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(210768), // Rule ID 993 //
     /* 210752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210755 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 210758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 210760 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 210762 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 210764 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 210766 */     GIR_RootConstrainSelectedInstOperands,
     /* 210767 */     // GIR_Coverage, 993,
     /* 210767 */     GIR_EraseRootFromParent_Done,
     /* 210768 */   // Label 2923: @210768
     /* 210768 */   GIM_Reject,
     /* 210769 */ // Label 2921: @210769
     /* 210769 */ GIM_Reject,
     /* 210770 */ // Label 2908: @210770
     /* 210770 */ GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(210847),
     /* 210775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210781 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210788 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(210825), // Rule ID 795 //
     /* 210793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210810 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 210813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210819 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210821 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210823 */     GIR_RootConstrainSelectedInstOperands,
     /* 210824 */     // GIR_Coverage, 795,
     /* 210824 */     GIR_EraseRootFromParent_Done,
     /* 210825 */   // Label 2925: @210825
     /* 210825 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(210846), // Rule ID 791 //
     /* 210830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210833 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 210836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210838 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210840 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210842 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210844 */     GIR_RootConstrainSelectedInstOperands,
     /* 210845 */     // GIR_Coverage, 791,
     /* 210845 */     GIR_EraseRootFromParent_Done,
     /* 210846 */   // Label 2926: @210846
     /* 210846 */   GIM_Reject,
     /* 210847 */ // Label 2924: @210847
     /* 210847 */ GIM_Reject,
     /* 210848 */ // Label 2909: @210848
     /* 210848 */ GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(210925),
     /* 210853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210859 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210866 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(210903), // Rule ID 797 //
     /* 210871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210888 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 210891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210897 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210899 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210901 */     GIR_RootConstrainSelectedInstOperands,
     /* 210902 */     // GIR_Coverage, 797,
     /* 210902 */     GIR_EraseRootFromParent_Done,
     /* 210903 */   // Label 2928: @210903
     /* 210903 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(210924), // Rule ID 793 //
     /* 210908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210911 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 210914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210916 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210918 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210920 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210922 */     GIR_RootConstrainSelectedInstOperands,
     /* 210923 */     // GIR_Coverage, 793,
     /* 210923 */     GIR_EraseRootFromParent_Done,
     /* 210924 */   // Label 2929: @210924
     /* 210924 */   GIM_Reject,
     /* 210925 */ // Label 2927: @210925
     /* 210925 */ GIM_Reject,
     /* 210926 */ // Label 2910: @210926
     /* 210926 */ GIM_Reject,
     /* 210927 */ // Label 81: @210927
     /* 210927 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2935*/ GIMT_Encode4(211143),
     /* 210938 */ /*GILLT_s32*//*Label 2930*/ GIMT_Encode4(210958),
     /* 210942 */ /*GILLT_s64*//*Label 2931*/ GIMT_Encode4(211010),
     /* 210946 */ /*GILLT_s128*//*Label 2932*/ GIMT_Encode4(211066),
     /* 210950 */ /*GILLT_v2s64*//*Label 2933*/ GIMT_Encode4(211089),
     /* 210954 */ /*GILLT_v4s32*//*Label 2934*/ GIMT_Encode4(211116),
     /* 210958 */ // Label 2930: @210958
     /* 210958 */ GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(211009),
     /* 210963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210966 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(210985), // Rule ID 959 //
     /* 210971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210978 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 210978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 210983 */     GIR_RootConstrainSelectedInstOperands,
     /* 210984 */     // GIR_Coverage, 959,
     /* 210984 */     GIR_Done,
     /* 210985 */   // Label 2937: @210985
     /* 210985 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(211008), // Rule ID 161 //
     /* 210990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210997 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 210997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 211002 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211006 */     GIR_RootConstrainSelectedInstOperands,
     /* 211007 */     // GIR_Coverage, 161,
     /* 211007 */     GIR_Done,
     /* 211008 */   // Label 2938: @211008
     /* 211008 */   GIM_Reject,
     /* 211009 */ // Label 2936: @211009
     /* 211009 */ GIM_Reject,
     /* 211010 */ // Label 2931: @211010
     /* 211010 */ GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(211065),
     /* 211015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 211018 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(211041), // Rule ID 808 //
     /* 211023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 211030 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 211030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 211035 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211039 */     GIR_RootConstrainSelectedInstOperands,
     /* 211040 */     // GIR_Coverage, 808,
     /* 211040 */     GIR_Done,
     /* 211041 */   // Label 2940: @211041
     /* 211041 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(211064), // Rule ID 159 //
     /* 211046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 211049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 211053 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 211053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 211058 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211062 */     GIR_RootConstrainSelectedInstOperands,
     /* 211063 */     // GIR_Coverage, 159,
     /* 211063 */     GIR_Done,
     /* 211064 */   // Label 2941: @211064
     /* 211064 */   GIM_Reject,
     /* 211065 */ // Label 2939: @211065
     /* 211065 */ GIM_Reject,
     /* 211066 */ // Label 2932: @211066
     /* 211066 */ GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(211088), // Rule ID 991 //
     /* 211071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 211074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 211077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 211081 */   // (strict_fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 211081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 211086 */   GIR_RootConstrainSelectedInstOperands,
     /* 211087 */   // GIR_Coverage, 991,
     /* 211087 */   GIR_Done,
     /* 211088 */ // Label 2942: @211088
     /* 211088 */ GIM_Reject,
     /* 211089 */ // Label 2933: @211089
     /* 211089 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(211115), // Rule ID 819 //
     /* 211094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 211100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211104 */   // (strict_fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 211104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 211109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211113 */   GIR_RootConstrainSelectedInstOperands,
     /* 211114 */   // GIR_Coverage, 819,
     /* 211114 */   GIR_Done,
     /* 211115 */ // Label 2943: @211115
     /* 211115 */ GIM_Reject,
     /* 211116 */ // Label 2934: @211116
     /* 211116 */ GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(211142), // Rule ID 821 //
     /* 211121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 211127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211131 */   // (strict_fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 211131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 211136 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211140 */   GIR_RootConstrainSelectedInstOperands,
     /* 211141 */   // GIR_Coverage, 821,
     /* 211141 */   GIR_Done,
     /* 211142 */ // Label 2944: @211142
     /* 211142 */ GIM_Reject,
     /* 211143 */ // Label 2935: @211143
     /* 211143 */ GIM_Reject,
     /* 211144 */ // Label 82: @211144
     /* 211144 */ GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(211156), // Rule ID 72 //
     /* 211149 */   // (trap)  =>  (TRAP)
     /* 211149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::TRAP),
     /* 211154 */   GIR_RootConstrainSelectedInstOperands,
     /* 211155 */   // GIR_Coverage, 72,
     /* 211155 */   GIR_Done,
     /* 211156 */ // Label 2945: @211156
     /* 211156 */ GIM_Reject,
     /* 211157 */ // Label 83: @211157
     /* 211157 */ GIM_Reject,
     /* 211158 */ }; // Size: 211158 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
